\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,       SETHP=21,       GETERR=22,      CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,       POINT=41,       FLINE=42,        MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
ATTRIB=69,      SETWIND=70,     RAWTEXT=71,     HILIGHT=72,
MALLOC=73;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,	MOD=58,		LOG=59,		COS=60,
TAN=61,         ASIN=62,        ACOS=63;

real SINX,SINY,SINZ,COSX,COSY,COSZ;
int XDEG,YDEG,ZDEG,ZPLU,YPLU,XPLU,NXDEG,NYDEG,NZDEG,CH,RETMODE,CPUREG,OFFSET,TEMP,TEMP2,BOXE,BOXL,ELMNT,NELMTS,
        SCX,SCY,CBANK,HAND,CRNR1,CRNR2;
\HAND=  I/O HANDLE FOR LOADING/SAVING LANDSCAPE FILE
segment char VIDEO;
segment char PALETTE;
char BOARD;
def PNT=1,LNE=2,QT=0;
real ZOOM;
int MOUSEX,MOUSEY,SSX,SSY,LFTFST,RGTFST,BBX,BBY,LMX,LMY,SENX,SENY,SENM;
int MBLEFT,MBRIGHT,MBMIDDLE;
real XMOD,YMOD,ZMOD,X2;
real PERSPECTIVE;

proc RSTMOUSE;
begin
CPUREG(0):=$21;
SOFTINT($33);           \reset mouse driver
end;

proc SETMSENSITIVITY(NSX,NSY,NSM);           \Set Mouse Sensitivity
int NSX,NSY,NSM;
begin
CPUREG(0):=$1B;
SOFTINT($33);
SENX:=CPUREG(1);
SENY:=CPUREG(2);
SENM:=CPUREG(3);
CPUREG(0):=$1A;
CPUREG(1):=NSX;
CPUREG(2):=NSY;
CPUREG(3):=NSM;
SOFTINT($33);
end;

proc SMPOS;
begin
CPUREG(0):=4;
CPUREG(2):=MOUSEX;
CPUREG(3):=MOUSEY;
SOFTINT($33);
end;

proc MC(ON);
int ON;
begin
if ON then TEMP:=1 else TEMP:=2;
CPUREG(0):=TEMP;          \TURN ON/OFF MOUSE CURSOR;
SOFTINT($33);
end;

proc MOUSEBOUNDRY(BX,BY,EX,EY);
int BX,BY,EX,EY;
begin
CPUREG(0):=$7;     CPUREG(2):=BX;      CPUREG(3):=EX;   SOFTINT($33);
CPUREG(0):=$8;     CPUREG(2):=BY;      CPUREG(3):=EY;   SOFTINT($33);
end;

proc GETMINFO;
begin
CPUREG(0):=$3;
SOFTINT($33);
MOUSEX:=CPUREG(2);
MOUSEY:=CPUREG(3);
TEMP:=CPUREG(1);
case TEMP of
0:      [MBLEFT:=false;MBRIGHT:=false];
1:      [MBLEFT:=true;MBRIGHT:=false];
2:      [MBLEFT:=false;MBRIGHT:=true];
3:      [MBLEFT:=true;MBRIGHT:=true]
        else;
\CURSOR(0,0);
\INTOUT(0,CPUREG(1));
end;


proc SETPAL;
begin
CPUREG(0):=$1012;
CPUREG(1):=0;
CPUREG(2):=256;
CPUREG(11):=PALETTE(0);
CPUREG(3):=0;
SOFTINT($10);
end;

proc LPAL;
int I,LX,I2,RGBA,CREG;
begin
RGBA:=RESERVE(24);
HAND:=FOPEN("PALSAVE.SAV",0);FSET(HAND,^I);OPENI(3);
for I:=0,767 do PALETTE(0,I):=CHIN(3);
CLOSE(3);FCLOSE(HAND);
SETPAL;
end;


proc DPOINT(DX,DY,DC);
int DX,DY,DC;
if DX>=0 & DY>=0 & DX<SSX & DY<SSY then [MOVE(DX,DY);VIDEO(0,DY*320+DX):=DC];
\begin
\end;

proc ISITONSCREAN(INCX,INCY);
int INCX,INCY;
if INCX>=0 & INCX<320 & INCY>=0 & INCY<200 then return(true) else return(false);

proc SURFIL(PO1X,PO1Y,PO1COL,PO2X,PO2Y,PO2COL,PO3X,PO3Y,PO3COL,PO4X,PO4Y,PO4COL);
int PO1X,PO1Y;
char PO1COL;
int PO2X,PO2Y;
char PO2COL;
int PO3X,PO3Y;
char PO3COL;
int PO4X,PO4Y;
char PO4COL;
int AVFIVE;
begin
if
ISITONSCREAN(PO1X,PO1Y) !
ISITONSCREAN(PO2X,PO2Y) !
ISITONSCREAN(PO3X,PO3Y) !
ISITONSCREAN(PO4X,PO4Y) then
begin
AVFIVE:=RESERVE(20);
for TEMP2:=0,4 do AVFIVE(TEMP2):=RESERVE(12);     \AVFIVE({top-middle,left-middle,middle-middle,right-middle,bottom-middle},
                                                  \{x,y,col});
AVFIVE(0,0):=(PO1X+PO2X)/2;
AVFIVE(0,1):=(PO1Y+PO2Y)/2;
AVFIVE(0,2):=(PO1COL+PO2COL)/2;
DPOINT(AVFIVE(0,0),AVFIVE(0,1),AVFIVE(0,2));

AVFIVE(1,0):=(PO1X+PO3X)/2;
AVFIVE(1,1):=(PO1Y+PO3Y)/2;
AVFIVE(1,2):=(PO1COL+PO3COL)/2;
DPOINT(AVFIVE(1,0),AVFIVE(1,1),AVFIVE(1,2));

AVFIVE(2,0):=(PO1X+PO2X+PO3X+PO4X)/4;
AVFIVE(2,1):=(PO1Y+PO2Y+PO3Y+PO4Y)/4;
AVFIVE(2,2):=(PO1COL+PO2COL+PO3COL+PO4COL)/4;
DPOINT(AVFIVE(2,0),AVFIVE(2,1),AVFIVE(2,2));

AVFIVE(3,0):=(PO2X+PO4X)/2;
AVFIVE(3,1):=(PO2Y+PO4Y)/2;
AVFIVE(3,2):=(PO2COL+PO4COL)/2;
DPOINT(AVFIVE(3,0),AVFIVE(3,1),AVFIVE(3,2));

AVFIVE(4,0):=(PO3X+PO4X)/2;
AVFIVE(4,1):=(PO3Y+PO4Y)/2;
AVFIVE(4,2):=(PO3COL+PO4COL)/2;
DPOINT(AVFIVE(4,0),AVFIVE(4,1),AVFIVE(4,2));


if

ABS(AVFIVE(2,0)-PO1X)>1 ! ABS(AVFIVE(2,1)-PO1Y)>1
! ABS(AVFIVE(0,0)-PO1X)>1 ! ABS(AVFIVE(0,1)-PO1Y)>1 !
ABS(AVFIVE(1,0)-PO1X)>1 ! ABS(AVFIVE(1,1)-PO1Y)>1

then
        SURFIL(
        PO1X,PO1Y,PO1COL,
        AVFIVE(0,0),AVFIVE(0,1),AVFIVE(0,2),
        AVFIVE(1,0),AVFIVE(1,1),AVFIVE(1,2),
        AVFIVE(2,0),AVFIVE(2,1),AVFIVE(2,2));

if

ABS(AVFIVE(2,0)-PO2X)>1 ! ABS(AVFIVE(2,1)-PO2Y)>1
! ABS(AVFIVE(0,0)-PO2X)>1 ! ABS(AVFIVE(0,1)-PO2Y)>1 !
ABS(AVFIVE(3,0)-PO2X)>1 ! ABS(AVFIVE(3,1)-PO2Y)>1

then
        SURFIL(
        AVFIVE(0,0),AVFIVE(0,1),AVFIVE(0,2),
        PO2X,PO2Y,PO2COL,
        AVFIVE(2,0),AVFIVE(2,1),AVFIVE(2,2),
        AVFIVE(3,0),AVFIVE(3,1),AVFIVE(3,2));

if

ABS(AVFIVE(2,0)-PO3X)>1 ! ABS(AVFIVE(2,1)-PO3Y)>1
! ABS(AVFIVE(4,0)-PO3X)>1 ! ABS(AVFIVE(4,1)-PO3Y)>1 !
ABS(AVFIVE(1,0)-PO3X)>1 ! ABS(AVFIVE(1,1)-PO3Y)>1

then
        SURFIL(
        AVFIVE(1,0),AVFIVE(1,1),AVFIVE(1,2),
        AVFIVE(2,0),AVFIVE(2,1),AVFIVE(2,2),
        PO3X,PO3Y,PO3COL,
        AVFIVE(4,0),AVFIVE(4,1),AVFIVE(4,2));

if

ABS(AVFIVE(2,0)-PO4X)>1 ! ABS(AVFIVE(2,1)-PO4Y)>1
! ABS(AVFIVE(4,0)-PO4X)>1 ! ABS(AVFIVE(4,1)-PO4Y)>1 !
ABS(AVFIVE(3,0)-PO4X)>1 ! ABS(AVFIVE(3,1)-PO4Y)>1

then
        SURFIL(
        AVFIVE(2,0),AVFIVE(2,1),AVFIVE(2,2),
        AVFIVE(3,0),AVFIVE(3,1),AVFIVE(3,2),
        AVFIVE(4,0),AVFIVE(4,1),AVFIVE(4,2),
        PO4X,PO4Y,PO4COL);
end;
end;

proc LINE(LNX,LNY,LNCOL);
int LNX,LNY,LNCOL;
begin
FLINE(LNX,LNY,LNCOL);
DPOINT(LNX,LNY,LNCOL);
end;

proc GETM;
begin
CPUREG(0):=$F00;
SOFTINT($10);
RETMODE:=CPUREG(0) & $00FF;
end;

proc SETM;
begin
CPUREG(0):=RETMODE;
SOFTINT($10);
end;

proc ELINE(LINX,LINY,LINX2,LINY2,LINCOL);
int LINX,LINY,LINX2,LINY2,LINCOL,STEEP,SLINX,SLINY,DLINX,DLINY,LINET,E,I;
begin
POINT(LINX,LINY,LINCOL);LINE(LINX2,LINY2,LINCOL);
DPOINT(LINX2,LINY2,LINCOL);
end;

proc DBOX(BBX,BBY,EBX,EBY,COL);
int BBX,BBY,EBX,EBY,COL;
begin
\ELINE(BBX,BBY,EBX,BBY,COL);
\ELINE(EBX,BBY,EBX,EBY,COL);
\ELINE(EBX,EBY,BBX,EBY,COL);
\ELINE(BBX,EBY,BBX,BBY,COL);
end;

proc DIM3(XDIS,YDIS,ZDIS);
real XDIS,YDIS,ZDIS;
\real DIV;
begin
XMOD:=(XDIS*COSZ)+(SINZ*YDIS);             \ This is the
YMOD:=(YDIS*COSZ)-(SINZ*XDIS);             \ Z rotation.

ZMOD:=(ZDIS*COSX)+(SINX*YMOD);             \ This is the   (from the side, allong the 'X' axis)
YMOD:=(YMOD*COSX)-(SINX*ZDIS);             \ X rotation.

X2:=(        XMOD *COSY)+(SINY*      ZMOD );             \ This is the   (from the top,  allong the 'Y' axis)
ZMOD:=(      ZMOD *COSY)-(SINY*      XMOD );             \ Y rotation.

YMOD:=(PERSPECTIVE*YMOD)/(PERSPECTIVE-ZMOD);
X2:=(PERSPECTIVE*X2)/(PERSPECTIVE-ZMOD);

SCX:=FIX(X2*ZOOM);
SCY:=FIX(YMOD*ZOOM);
end;

                                \int DIMX,DIMY,DIMZ;
                                \real XTMP,YTMP;
                                \begin
                                \XTMP:=(FLOAT(DIMX)*COSZ)-(SINZ*FLOAT(DIMY));
                                \YTMP:=(FLOAT(DIMY)*COSZ)+(SINZ*FLOAT(DIMX));
                                \SCX:=FIX((SINY*SINX*YTMP)+(XTMP*COSY)+(SINY*COSX*FLOAT(DIMZ)));
                                \SCY:=FIX((YTMP*COSX)-(FLOAT(DIMZ)*SINX));
                                \end;

proc CORNER;    \THIS PROCEEDURE FIGURES OUT WHAT CORNER IS THE FURTHEST BACK.
\CRNR1:       THIS VALUSE WILL BE RETURNED: 0=UpperLeft 1=UpperRight 2=LowerLeft 3=LowerRight
    int
    CORNERS,CI,
    FST,      \THIS IS THE FARTHST DISTANCE FOUND YET.
    SND,
    CTMP;

        proc NOPERSPECTIVE(XDIS,YDIS,ZDIS);
        real XDIS,YDIS,ZDIS;
        begin
        XMOD:=(XDIS*COSZ)+(SINZ*YDIS);             \ This is the
        YMOD:=(YDIS*COSZ)-(SINZ*XDIS);             \ Z rotation.

        ZMOD:=(ZDIS*COSX)+(SINX*YMOD);             \ This is the   (from the side, allong the 'X' axis)
        YMOD:=(YMOD*COSX)-(SINX*ZDIS);             \ X rotation.

        X2:=(        XMOD *COSY)+(SINY*      ZMOD );             \ This is the   (from the top,  allong the 'Y' axis)
        ZMOD:=(      ZMOD *COSY)-(SINY*      XMOD );             \ Y rotation.
        \YMOD:=(PERSPECTIVE*YMOD)/(PERSPECTIVE-ZMOD);
        \X2:=(PERSPECTIVE*X2)/(PERSPECTIVE-ZMOD);

        \SCX:=FIX(X2*ZOOM);
        \SCY:=FIX(ZMOD*ZOOM);
        end;

begin
CORNERS:=RESERVE(16);
NOPERSPECTIVE(-128.0,-128.0,0.0);       CORNERS(0):=FIX(ZMOD);
NOPERSPECTIVE(128.0,-128.0,0.0);        CORNERS(1):=FIX(ZMOD);
NOPERSPECTIVE(128.0,128.0,0.0);         CORNERS(2):=FIX(ZMOD);
NOPERSPECTIVE(-128.0,128.0,0.0);        CORNERS(3):=FIX(ZMOD);

CRNR1:=0;
for CI:=1,3 do if CORNERS(CI)<CORNERS(CRNR1) then CRNR1:=CI;

if CRNR1=0 then CRNR2:=1 else CRNR2:=0;
for CI:=0,3 do if CORNERS(CI)<CORNERS(CRNR2) & CI#CRNR1 then CRNR2:=CI;
end;


proc LOAD;
int I,LX;
begin
HAND:=FOPEN("EVOSAVE.TMP",0);
FSET(HAND,^I);
OPENI(3);
for I:=0,4224 do BOARD(I):=CHIN(3);
CLOSE(3);
FCLOSE(HAND);
end;

proc BOX(ON);
int ON,COL;
begin
for TEMP:=0,NELMTS-1 do
        begin
        if ON=1 then COL:=BOXL(TEMP,3,CBANK) else COL:=0;
        SCX:=BOXL(TEMP,0,CBANK)+OFFSET(2,0);
        SCY:=BOXL(TEMP,1,CBANK)+OFFSET(2,1);
        if BOXL(TEMP,2,CBANK)=PNT then POINT(SCX,SCY,COL) else LINE(SCX,SCY,COL);
        end;
end;

proc SETNEW(BXDEGX,BXDEGY,BXDEGZ);
int BXDEGX,BXDEGY,BXDEGZ;
begin
SINX:=SIN(.017453292*FLOAT(BXDEGX));COSX:=COS(.017453292*FLOAT(BXDEGX));
SINY:=SIN(.017453292*FLOAT(BXDEGY));COSY:=COS(.017453292*FLOAT(BXDEGY));
SINZ:=SIN(.017453292*FLOAT(BXDEGZ));COSZ:=COS(.017453292*FLOAT(BXDEGZ));
ELMNT:=0;
loop
        begin
        if BOXE(ELMNT*5)=QT then quit;
        DIM3(FLOAT(BOXE(ELMNT*5+1)),FLOAT(BOXE(ELMNT*5+2)),FLOAT(BOXE(ELMNT*5+3)));
SCX:=FIX(X2*ZOOM/4.0);
SCY:=FIX(YMOD*ZOOM/4.0);
        BOXL(ELMNT,0,CBANK):=SCX;
        BOXL(ELMNT,1,CBANK):=SCY;
        BOXL(ELMNT,2,CBANK):=BOXE(ELMNT*5);
        BOXL(ELMNT,3,CBANK):=BOXE(ELMNT*5+4);
        ELMNT:=ELMNT+1;
        end;
end;


proc NBOX(NX,NY,NZ);
int NX,NY,NZ;
begin
if CBANK=0 then CBANK:=1 else CBANK:=0;
SETNEW(NX,NY,NZ);
if CBANK=0 then CBANK:=1 else CBANK:=0;
BOX(0);
if CBANK=0 then CBANK:=1 else CBANK:=0;
BOX(1);
XDEG:=NX;
YDEG:=NY;
ZDEG:=NZ;
end;

proc DRWDEG;

        proc BLANKING(AM);
        int AM;
        begin
        if AM>=0 then
                begin
                if AM<100 then CHOUT(0,^ );
                if AM<10 then CHOUT(0,^ );
                end
        else
                begin
                if AM>-100 then CHOUT(0,^ );
                if AM>-10 then CHOUT(0,^ );
                end;
        end;

begin
CURSOR(OFFSET(1,0)+7,OFFSET(1,1)+0);
INTOUT(0,XDEG);
BLANKING(XDEG);
CURSOR(OFFSET(1,0)+7,OFFSET(1,1)+1);
INTOUT(0,YDEG);
BLANKING(YDEG);
CURSOR(OFFSET(1,0)+7,OFFSET(1,1)+2);
INTOUT(0,ZDEG);
BLANKING(ZDEG);
CURSOR(OFFSET(1,0)+7,OFFSET(1,1)+3);
end;

proc CLS;
begin
\for TEMP:=0,319 do for TEMP2:=0,199 do DPOINT(TEMP,TEMP2,0);
CLEAR;
end;

proc DRWSCN;
begin
CLS;
CURSOR(OFFSET(1,0),OFFSET(1,1));
TEXT(0,"X-DEG:");
CURSOR(OFFSET(1,0),OFFSET(1,1)+1);
TEXT(0,"Y-DEG:");
CURSOR(OFFSET(1,0),OFFSET(1,1)+2);
TEXT(0,"Z-DEG:");
DRWDEG;
NBOX(XDEG,YDEG,ZDEG);
end;


proc CL0;
begin
\for TEMP:=-184,184 do [POINT(TEMP+OFFSET(0,0),OFFSET(0,1)-184,0);LINE(TEMP+OFFSET(0,0),OFFSET(0,1)+184,0)];
\for TEMP:=-184,184 do for TEMP2:=-184,184 do DPOINT(TEMP+OFFSET(0,0),TEMP2+OFFSET(0,2),0);
CLS;
end;

proc BLINE(SBX,SBY,SEX,SEY,SBLC1,SBLC2);
int SBX,SBY,SEX,SEY,SBLC1,SBLC2;

proc BSUB(BX,BY,EX,EY,BLC1,BLC2);
int BX,BY,EX,EY,BLC1,BLC2;
begin
if ABS(BX-EX)>1 ! ABS(BY-EY)>1 then
        begin
        POINT((BX+EX)/2,(BY+EY)/2,(BLC1+BLC2)/2);
        BLINE(BX,BY,(BX+EX)/2,(BY+EY)/2,BLC1,(BLC1+BLC2)/2);
        BLINE((BX+EX)/2,(BY+EY)/2,EX,EY,(BLC1+BLC2)/2,BLC2);
        end;
end;

begin
POINT(SBX,SBY,SBLC1);
POINT(SEX,SEY,SBLC2);
BSUB(SBX,SBY,SEX,SEY,SBLC1,SBLC2);
end;


proc PREVIEW;
int XSCAN,YSCAN,TOGGLE,CHAR,LAST,PCOL,WATER,YCOUNT,XCOUNT,TOGLAST,TOGCUR,SCANDIR,
LSCAN,YNOT,XNOT,LNOT;


begin
SINX:=SIN(.017453292*FLOAT(XDEG));COSX:=COS(.017453292*FLOAT(XDEG));
SINY:=SIN(.017453292*FLOAT(YDEG));COSY:=COS(.017453292*FLOAT(YDEG));
SINZ:=SIN(.017453292*FLOAT(ZDEG));COSZ:=COS(.017453292*FLOAT(ZDEG));
WATER:=0;               \IF YOU WANT TO VIEW above WATER ONLY, 50, FOR EVERYTHING: 0;

DBOX(OFFSET(0,0)-185,OFFSET(0,1)-185,OFFSET(0,0)+185,OFFSET(0,1)+185,2);
DBOX(OFFSET(2,0)-47,OFFSET(2,1)-47,OFFSET(2,0)+47,OFFSET(2,1)+47,3);

LAST:=RESERVE(4*65);
for TEMP:=0,64 do LAST(TEMP):=RESERVE(4*3);
for XSCAN:=0,64 do for YSCAN:=0,2 do LAST(XSCAN,YSCAN):=RESERVE(8);

CL0;
TOGGLE:=0;
TOGCUR:=0;
TOGLAST:=1;
CORNER;
\INTOUT(0,CRNR1);CHOUT(0,^ );
\INTOUT(0,CRNR2);CHOUT(0,^ );
if CRNR1=0 & CRNR2=1 then SCANDIR:=0;
if CRNR1=1 & CRNR2=0 then SCANDIR:=1;

if CRNR1=1 & CRNR2=2 then SCANDIR:=2;
if CRNR1=2 & CRNR2=1 then SCANDIR:=3;

if CRNR1=2 & CRNR2=3 then SCANDIR:=4;
if CRNR1=3 & CRNR2=2 then SCANDIR:=5;

if CRNR1=3 & CRNR2=0 then SCANDIR:=6;
if CRNR1=0 & CRNR2=3 then SCANDIR:=7;
\INTOUT(0,SCANDIR);
loop
        begin
        for YCOUNT:=0,64 do
                begin
                for XCOUNT:=0,64 do
                        begin
                        if SCANDIR=0 then      \BACK to FRONT, LEFT to RIGHT
                                [XSCAN:=XCOUNT;YSCAN:=YCOUNT;           YNOT:=0;  XNOT:=0;LSCAN:=XSCAN;LNOT:=-1] else
                        if SCANDIR=1 then      \BACK to FRONT, RIGHT to LEFT
                                [XSCAN:=64-XCOUNT;YSCAN:=YCOUNT;        YNOT:=0;  XNOT:=1;LSCAN:=XSCAN;LNOT:=1] else

                        if SCANDIR=2 then      \RIGHT to LEFT, BACK to FRONT
                                [XSCAN:=64-YCOUNT;YSCAN:=XCOUNT;        YNOT:=0;  XNOT:=1;LSCAN:=YSCAN;LNOT:=-1] else
                        if SCANDIR=3 then      \RIGHT to LEFT, FRONT to BACK
                                [XSCAN:=64-YCOUNT;YSCAN:=64-XCOUNT;     YNOT:=1;  XNOT:=1;LSCAN:=YSCAN;LNOT:=1] else

                        if SCANDIR=4 then      \FRONT to BACK, RIGHT to LEFT
                                [XSCAN:=64-XCOUNT;YSCAN:=64-YCOUNT;     YNOT:=1;  XNOT:=1;LSCAN:=XSCAN;LNOT:=1] else
                        if SCANDIR=5 then      \FRONT to BACK, LEFT to RIGHT
                                [XSCAN:=XCOUNT;YSCAN:=64-YCOUNT;        YNOT:=1;  XNOT:=0;LSCAN:=XSCAN;LNOT:=-1] else

                        if SCANDIR=6 then      \LEFT to RIGHT, FRONT to BACK
                        [XSCAN:=YCOUNT;YSCAN:=64-XCOUNT;                YNOT:=1;  XNOT:=0;LSCAN:=YSCAN;LNOT:=1] else
                        if SCANDIR=7 then      \LEFT to RIGHT, BACK to FRONT
                        [XSCAN:=YCOUNT;YSCAN:=XCOUNT;                   YNOT:=0;  XNOT:=0;LSCAN:=YSCAN;LNOT:=-1];


                \        if BOARD(XSCAN+65*YSCAN)>=WATER then
                                DIM3(FLOAT(XSCAN-32),FLOAT(YSCAN-32),FLOAT(BOARD(XSCAN+65*YSCAN)-50)/5.0)\\;\ else
                \                DIM3(FLOAT(XSCAN-32),FLOAT(YSCAN-32),FLOAT(WATER-50)/5.0);

                \        if BOARD(XSCAN+65*YSCAN)>=WATER then
                                PCOL:=BOARD(XSCAN+65*YSCAN)+16\\;\ else
                \                PCOL:=WATER+16;

                        LAST(LSCAN,0,TOGCUR):=SCX+OFFSET(0,0);
                        LAST(LSCAN,1,TOGCUR):=SCY+OFFSET(0,1);
                        LAST(LSCAN,2,TOGCUR):=PCOL;
                        DPOINT(SCX+OFFSET(0,0),SCY+OFFSET(0,1),PCOL);

                        if YSCAN#(YNOT*64) & XSCAN#(XNOT*64) then
                                SURFIL(
                                LAST(LSCAN+LNOT,0,TOGLAST),
                                LAST(LSCAN+LNOT,1,TOGLAST),
                                LAST(LSCAN+LNOT,2,TOGLAST),

                                LAST(LSCAN,0,TOGLAST),
                                LAST(LSCAN,1,TOGLAST),
                                LAST(LSCAN,2,TOGLAST),

                                LAST(LSCAN+LNOT,0,TOGCUR),
                                LAST(LSCAN+LNOT,1,TOGCUR),
                                LAST(LSCAN+LNOT,2,TOGCUR),

                                LAST(LSCAN,0,TOGCUR),
                                LAST(LSCAN,1,TOGCUR),
                                LAST(LSCAN,2,TOGCUR));

                        if CHKKEY then quit;
                        end;
                if TOGCUR=0 then [TOGCUR:=1;TOGLAST:=0] else [TOGCUR:=0;TOGLAST:=1];
                end;
        quit;
        end;

\DBOX(OFFSET(0,0)-185,OFFSET(0,1)-185,OFFSET(0,0)+185,OFFSET(0,1)+185,3);
\DBOX(OFFSET(2,0)-47,OFFSET(2,1)-47,OFFSET(2,0)+47,OFFSET(2,1)+47,2);
loop
        begin
        GETMINFO;
        if CHKKEY then [CH:=CHIN(1);quit];
        if MBLEFT ! MBRIGHT then
                begin
                loop [GETMINFO;if MBLEFT=false & MBRIGHT=false then quit];
                quit;
                end;
        end;
DRWSCN;
end;

proc SETMDEG;
begin
MOUSEX:=(YDEG+180)*2;MOUSEY:=180-XDEG;SMPOS;
end;

proc L;
begin
ZPLU:=0;
YPLU:=0;
XPLU:=0;
SETNEW(XDEG,YDEG,ZDEG);
BOX(1);
\MC(true);
MOUSEBOU(0,0,720,360);
DRWSCN;
DRWDEG;
loop
        begin
        TEMP2:=false;
        if CHKKEY then
                begin
                CH:=CHIN(1);
                if CH=0 then
                        begin
                        CH:=CHIN(1);
                        if CH=71 then [YPLU:=YPLU-1;XPLU:=XPLU+1];
                        if CH=72 then XPLU:=XPLU+1;
                        if CH=73 then [YPLU:=YPLU-1;XPLU:=XPLU+1];
                        if CH=75 then YPLU:=YPLU-1;
                        if CH=77 then YPLU:=YPLU+1;
                        if CH=79 then [YPLU:=YPLU-1;XPLU:=XPLU-1];
                        if CH=80 then XPLU:=XPLU-1;
                        if CH=81 then [YPLU:=YPLU-1;XPLU:=XPLU-1];
                        end
                else case CH of
                        $1B:    quit;
                        ^V:     [if PERSPECTIVE=50.0 then PERSPECTIVE:=100000000.0 else PERSPECTIVE:=50.0;TEMP2:=true];
                        ^v:     [if PERSPECTIVE=50.0 then PERSPECTIVE:=100000000.0 else PERSPECTIVE:=50.0;TEMP2:=true];
                        ^P:     PREVIEW;
                        ^p:     PREVIEW;
                        ^Q:     ZPLU:=ZPLU+1;
                        ^q:     ZPLU:=ZPLU+1;
                        ^A:     ZPLU:=ZPLU-1;
                        ^a:     ZPLU:=ZPLU-1;
                        ^R:     [NXDEG:=0;NYDEG:=0;NZDEG:=0;ZPLU:=0;YPLU:=0;XPLU:=0;NBOX(NXDEG,NYDEG,NZDEG);DRWDEG;SETMDEG];
                        ^r:     [NXDEG:=0;NYDEG:=0;NZDEG:=0;ZPLU:=0;YPLU:=0;XPLU:=0;NBOX(NXDEG,NYDEG,NZDEG);DRWDEG];
                        18:     [NXDEG:=0;NYDEG:=0;NZDEG:=0;NBOX(NXDEG,NYDEG,NZDEG);DRWDEG];
                        ^f:     [XPLU:=0;YPLU:=0;ZPLU:=0;DRWDEG];
                        ^ :     [XPLU:=0;YPLU:=0;ZPLU:=0;DRWDEG];
                        ^F:     [XPLU:=0;YPLU:=0;ZPLU:=0;DRWDEG]
                        else;
                end;
        GETMINFO;
        if MBRIGHT then PREVIEW;
        if MBLEFT then [if LMX#MOUSEX ! LMY#MOUSEY then
                begin

                if LFTFST then [SETMDEG;LMX:=MOUSEX;LMY:=MOUSEY;LFTFST:=false]
                else
                        begin
\                        INTOUT(0,MOUSEX);
\                        INTOUT(0,MOUSEY);
                        NXDEG:=360-MOUSEY-180;
                        NYDEG:=(MOUSEX)/2-180;
                        LMX:=MOUSEX;
                        LMY:=MOUSEY;
                        TEMP2:=true;
                        end;
                end]
        else LFTFST:=true;
        if XPLU#0 then
                begin
                TEMP2:=true;
                NXDEG:=XDEG+XPLU;
                if NXDEG>359 then NXDEG:=NXDEG-360;
                if NXDEG<0 then NXDEG:=NXDEG+360;
                end;
        if YPLU#0 then
                begin
                TEMP2:=true;
                NYDEG:=YDEG+YPLU;
                if NYDEG>359 then NYDEG:=NYDEG-360;
                if NYDEG<0 then NYDEG:=NYDEG+360;
                end;
        if ZPLU#0 then
                begin
                TEMP2:=true;
                NZDEG:=ZDEG+ZPLU;
                if NZDEG>359 then NZDEG:=NZDEG-360;
                if NZDEG<0 then NZDEG:=NZDEG+360;
                end;
        if TEMP2 then
                begin
                DRWDEG;
                NBOX(NXDEG,NYDEG,NZDEG);
                end;
        end;
end;

begin
CPUREG:=GETREG;
SETMSENSITIVITY(25,25,25);
LFTFST:=true;
VIDEO:=RESERVE(2);
VIDEO(0):=$A000;
PALETTE:=RESERVE(2);
PALETTE(0):=MALLOC(48);
SSX:=320;
SSY:=200;
\GETM;
OFFSET:=RESERVE(16);
for TEMP:=0,4 do OFFSET(TEMP):=RESERVE(8);
OFFSET(0,0):=160;
OFFSET(0,1):=100;
OFFSET(1,0):=0;
OFFSET(1,1):=20;
OFFSET(2,0):=\OFFSET(0,0)-233\160;
OFFSET(2,1):=\OFFSET(0,1)-138\100;
OFFSET(3,0):=0;
OFFSET(3,1):=0;

        \1:PNT or LNE (point or line), 2:X pos, 3:Y pos, 4: Z pos, Color
BOXE:=[ PNT,-5,-35,0,82, LNE,-5,-45,0,82, LNE,5,-35,0,82, LNE,5,-45,0,82,     \this is the data for the 'N' (north)

        PNT,-32,-32,-5,64,                                                    \bottom square
        LNE,32,-32,-5,64,
        LNE,32,32,-5,64,
        LNE,-32,32,-5,64,
        LNE,-32,-32,-5,64,

        LNE,-32,-32,5,64,                                               \top square, and upper-left line
        LNE,32,-32,5,15,
        LNE,32,32,5,15,
        LNE,-32,32,5,15,
        LNE,-32,-32,5,15,

        PNT,32,-32,-5,64,                                               \the other lines
        LNE,32,-32,5,64,
        PNT,32,32,-5,64,
        LNE,32,32,5,64,
        PNT,-32,32,-5,64,
        LNE,-32,32,5,64,
        QT
        ];
NELMTS:=0;
loop
        begin
        if BOXE(NELMTS*5)=QT then quit;
        NELMTS:=NELMTS+1;
        end;
BOXL:=RESERVE(4*(NELMTS));                                    \NELMTS stands for Number of Eliments IN THE BOX
for TEMP:=0,NELMTS do BOXL(TEMP):=RESERVE(18);
for TEMP:=0,NELMTS do for TEMP2:=0,3 do BOXL(TEMP,TEMP2):=RESERVE(8);
BOARD:=RESERVE(4225);
SETVID($13);
LPAL;
SETMSENSITIVITY(25,25,25);
\SETVID(99);
\LPAL;
PERSPECTIVE:=50.0;
XDEG:=60;
YDEG:=30;
ZDEG:=0;
NXDEG:=60;
NYDEG:=30;
NZDEG:=0;
CBANK:=0;
LMX:=180+YDEG;
LMY:=180+XDEG;
ZOOM:=4.0;
DBOX(OFFSET(0,0)-185,OFFSET(0,1)-185,OFFSET(0,0)+185,OFFSET(0,1)+185,3);
DBOX(OFFSET(2,0)-47,OFFSET(2,1)-47,OFFSET(2,0)+47,OFFSET(2,1)+47,2);
\DBOX(OFFSET(0,0)-91,OFFSET(0,1)-185,OFFSET(0,0)-278,OFFSET(0,1)+185,3);
LOAD;
L;
\SETM;
RSTMOUSE;
end;
