\ADCOPY.XPL
\COPY FROM APEX TO DOS

'CODE'
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;
'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;



'DEFINE'
	LF=$0A,
	RETURN=$0D,
	FF=$0C,		\FORM FEED
	EOF=$1A;	\END OF FILE



'INTEGER'
	EATLF,	\FLAGS IGNORE LINE FEEDS
	ENTRY,	\POINTER TO EMPTY DIRECTORY ENTRY
	TSPTR,	\POINTER INTO T/S LIST
	EOFLAG,	\FLAGS END OF FILE
	X,
	TSSIZE,	\NUMBER OF SECTORS IN T/S LIST
	FSIZE,	\NUMBER OF SECTORS IN THIS FILE
	TSTRCK,	\CURRENT T/S LIST TRACK
	TSSECT,	\CURRENT T/S LIST SECTOR
	DIRSEC,	\CURRENT ACTIVE DIRECTORY SECTOR
	DIRTRK,	\CURRENT ACTIVE DIRECTORY TRACK
	SECMAP,	\HOLDS SECTOR BIT MAP FOR A TRACK
	BITMASK,\ARRAY TO FIND BITS IN BYTES
	FSECT,	\FREE SECTOR ON DISK
	FTRACK,	\FRED TRACK ON DISK
	BITPTR,	\POINTS INTO BIT MAP IN VTOC
	DUNIT;	\DOS UNIT NUMBER


'ADDRESS'
	DATBUF,	\HOLD DATA BEINGING COPYIED
	TSBUF,	\HOLDS T/S SECTOR
	DIRBUF,	\BUFFERS A SECTOR OF DIRECTORY
	VTOCBUF;\BUFFERS VTOC


'PROCEDURE' OPENFIN;
'INTEGER' BLOCK,LUNIT;
'ADDRESS' FNAME;


'PROCEDURE' GETNAME(NAME);
'ADDRESS' NAME;
'INTEGER' X,Y,CHAR;

'PROCEDURE' FIRST;
'BEGIN'
OPENI(0);
X:=0;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(0);
	'IF' CHAR=^. 'THEN' 'QUIT';
	NAME(X):=CHAR;
	X:=X+1;
	'IF' X>8 ! CHAR=RETURN 'THEN'
		'BEGIN'
		TEXT(0,"BAD FILE NAME");
		CRLF(0);
		TEXT(0,"TRY AGAIN");
		CRLF(0);
		'QUIT';
		'END';
	'END';
'END';	\END FIRST

'BEGIN'	\START OF GETNAME
'REPEAT' FIRST 'UNTIL' CHAR=^.;
'FOR' Y:=X,7 'DO' NAME(Y):=$20;
X:=8;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(0);
	'IF' CHAR=RETURN 'THEN' 'QUIT';
	NAME(X):=CHAR;
	X:=X+1;
	'IF' X>10 'THEN' 'QUIT';
	'END';
'FOR' Y:=X,10 'DO' NAME(Y):=$20;
'END';	\END OF GETNAME



'BEGIN'	\OPENFIN
BLOCK:=RESERVE(4);
FNAME:=RESERVE(25);
TEXT(0,"*** INPUT FILE SPECIFICATIONS ***");
CRLF(0);
TEXT(0,"ENTER apex UNIT NUMBER ");
LUNIT:=INTIN(0);
TEXT(0,"ENTER apex FILE NAME ");
GETNAME(FNAME);
TRAP('FALSE');
SCAN(LUNIT,BLOCK,FNAME);
TRAP('TRUE');
'IF' GETERR 'THEN'
	'BEGIN'
	TEXT(0,"FILE NOT FOUND");
	CRLF(0);
	OPENFIN;
	'END';
OPENF(LUNIT,BLOCK);
'END';


'PROCEDURE' GETSTRING(STR,TERM,LEN);
'ADDRESS' STR;
'INTEGER' TERM,LEN,CHAR,X;
'BEGIN'
X:=0;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(0);
	'IF' CHAR=TERM 'THEN' 'QUIT';
	STR(X):=CHAR;
	X:=X+1;
	'IF' X=LEN 'THEN' 'QUIT';
	'END';
'IF' X=0 'THEN' STR(0):=$A0
	'ELSE' STR(X-1):=STR(X-1)!$80;
'END';



'PROCEDURE' EXOR(A,B);
'INTEGER' A,B;
'RETURN' (A & 'NOT' B) ! ('NOT' A & B);


'PROCEDURE' CBLOCK(TRACK,SEC);	\CONVERT TRACK-SECTOR TO BLOCK
'INT'	TRACK,SEC,APSEC,HOLD;
'BEGIN'
'IF' SEC=0 'THEN' APSEC:=0
'ELSE' APSEC:='IF' SEC=15 'THEN' 15 'ELSE' 15-SEC;
'RETURN' (TRACK*16)+APSEC;
'END';



'PROCEDURE' GETUNIT;
'BEGIN'
TEXT(0,"ENTER UNIT NUMBER WITH DOS DISK ");
DUNIT:=INTIN(0);
'END';



'PROCEDURE' CLEARTS;	\CLEAR TRACK SECTOR LIST
'INTEGER' X;
'FOR' X:=0,255 'DO' TSBUF(X):=0;



'PROCEDURE' WRITETS;	\WRITE TRACK SECTOR LIST
WRITE(DUNIT,CBLOCK(TSTRCK,TSSECT),TSBUF,1);



'PROCEDURE' WRITDAT;
WRITE(DUNIT,CBLOCK(FTRACK,FSECT),DATBUF,1);



'PROCEDURE' SETTSP;
'BEGIN'
TSBUF(5):=TSSIZE;
TSBUF(6):=SWAP(TSSIZE);
TSPTR:=$C;
'END';



'PROCEDURE' READVTOC;
'BEGIN'
READ(DUNIT,CBLOCK($11,0),VTOCBUF,1);
BITPTR:=$40;
FSECT:=0;
DIRBUF(1):=VTOCBUF(1);
DIRBUF(2):=VTOCBUF(2);
'END';



'PROCEDURE' WRITEVTOC;
WRITE(DUNIT,CBLOCK($11,0),VTOCBUF,1);


'PROCEDURE' GETTRK;	\FIND TRACK WITH UNUSED SECTORS

'BEGIN'
'LOOP'
	'BEGIN'
	BITPTR:=BITPTR+4;
	'IF' BITPTR>$C3 'THEN' 'QUIT';
	SECMAP:=0;
	SECMAP:=VTOCBUF(BITPTR);
	SECMAP:=SWAP(SECMAP)+VTOCBUF(BITPTR+1);
	'IF' SECMAP#0 'THEN' 'QUIT';
	'END';
'END';


'PROCEDURE' GETSECT;	\POINT TO NEXT SECTOR BIT IN MAP
'BEGIN'
FSECT:=FSECT-1;
'IF' FSECT<0 'THEN'
	'BEGIN'
	GETTRK;
	FSECT:=$F;
	'END'
'END';



'PROCEDURE' FREE;	\FIND A FREE SECTOR
'BEGIN'
'LOOP'
	'BEGIN'
	GETSECT;
	'IF' (SECMAP&BITMASK(FSECT))#0 'THEN' 'QUIT';
	'IF' BITPTR>$C3 'THEN'
		'BEGIN'
		TEXT(0,"NO MORE SPACE ON DISK");CRLF(0);
		'RETURN' 'FALSE';
		'END';
	'END';
FTRACK:=(BITPTR-$38)/4;

SECMAP:=EXOR(SECMAP,BITMASK(FSECT));
VTOCBUF(BITPTR):=SWAP(SECMAP);
VTOCBUF(BITPTR+1):=SECMAP;
'RETURN' 'TRUE';
'END';



'PROCEDURE' READIR;
'BEGIN'
DIRTRK:=DIRBUF(1);
DIRSEC:=DIRBUF(2);
'IF' DIRTRK=0 & DIRSEC=0 'THEN' 'RETURN' 'FALSE'
'ELSE'	'BEGIN'
	READ(DUNIT,CBLOCK(DIRTRK,DIRSEC),DIRBUF,1);
	'RETURN' 'TRUE';
	'END';
'END';



'PROCEDURE' WRITEDIR;
WRITE(DUNIT,CBLOCK(DIRTRK,DIRSEC),DIRBUF,1);



'PROCEDURE' EMPTY;	\FIND EMPTY FILE SLOT IN DIRECTORY
'INTEGER' X;
'BEGIN'
X:=$B;
'LOOP'
	'BEGIN'
	'IF' DIRBUF(X)=0 ! DIRBUF(X)=$FF 'THEN' 'QUIT';
	X:=X+$23;
	'IF' X>$FF 'THEN' 'QUIT';
	'END';
'RETURN' X;
'END';



'PROCEDURE' SAVETS;	\PUT DATA TRACK AND SECTOR IN T/S LIST
'INTEGER' TTEMP,STEMP;
'BEGIN'
'IF' 'NOT' FREE 'THEN' 'RETURN' 'FALSE';
TSBUF(TSPTR):=FTRACK;
TSBUF(TSPTR+1):=FSECT;
TSPTR:=TSPTR+2;
'IF' TSPTR>$FF 'THEN'
	'BEGIN'
	TTEMP:=FTRACK;
	STEMP:=FSECT;
	FREE;
	TSBUF(1):=FTRACK;
	TSBUF(2):=FSECT;
	WRITETS;
	TSTRCK:=FTRACK;
	TSSECT:=FSECT;
	TSSIZE:=TSSIZE+122;
	CLEARTS;
	SETTSP;
	FTRACK:=TTEMP;
	FSECT:=STEMP;
	'END';
'RETURN' 'TRUE';
'END';



'PROCEDURE' FINDIR;	\FIND AND ENTER FILENAME IN DIRECT
'ADDRESS' NAME;
'INTEGER'X;
'BEGIN'
'LOOP'
	'BEGIN'
	'IF' 'NOT' READIR 'THEN'
		'BEGIN'
		TEXT(0,"DIRECTORY FULL");CRLF(0);
		'RETURN' 'FALSE';
		'END';
	ENTRY:=EMPTY;
	'IF' ENTRY<$100 'THEN' 'QUIT';
	'END';

TEXT(0,"ENTER DOS FILENAME  ");
GETSTRING(NAME,$0D,28);
'IF' 'NOT' FREE 'THEN' 'RETURN' 'FALSE';
TSTRCK:=FTRACK;
TSSECT:=FSECT;
CLEARTS;
TSSIZE:=0;
SETTSP;
'IF' 'NOT' SAVETS 'THEN' 'RETURN' 'FALSE';

DIRBUF(ENTRY):=TSTRCK;
DIRBUF(ENTRY+1):=TSSECT;
DIRBUF(ENTRY+2):=0;

X:=0;
'REPEAT'
	'BEGIN'
	DIRBUF(ENTRY+3+X):=NAME(X) ! $80;
	X:=X+1;
	'END'
'UNTIL' NAME(X-1)>$7F;

'FOR' X:=X,$20-3 'DO' DIRBUF(ENTRY+3+X):=$A0;

'RETURN' 'TRUE';
'END';


'PROCEDURE' CLODOS;	\CLOSE OUT DOS FILE
'BEGIN'
DIRBUF(ENTRY+$21):=FSIZE;
DIRBUF(ENTRY+$22):=0;
WRITEDIR;
WRITEVTOC;
WRITETS;
'END';



'PROCEDURE' FILL;
'INTEGER' X,CHAR;
'BEGIN'
X:=0;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(3);
	'IF' CHAR=EOF 'THEN'
		'BEGIN'
		EOFLAG:='TRUE';
		DATBUF(X):=0;
		'QUIT';
		'END';
	'IF' EATLF & CHAR=LF 'THEN'
	'ELSE' 
		'BEGIN'
		DATBUF(X):=CHAR ! $80;
		X:=X+1;
		'END';
	'IF' X>255 'THEN' 'QUIT';
	'END';
FSIZE:=FSIZE+1;
'END';



'PROCEDURE' COPY;
'BEGIN'
CHOUT(0,FF);
CRLF(0);
TEXT(0," *** COPIES TEXT FILES FROM APEX ***");
CRLF(0);
TEXT(0,"       *** TO APPLE DOS ***");
CRLF(0);

TEXT(0,"EAT LINE FEEDS (Y-N)? ");
OPENI(0);
EATLF:=CHIN(0)=^Y;

OPENFIN;
CRLF(0);

GETUNIT;
READVTOC;
'IF' 'NOT' FINDIR 'THEN' 'RETURN';
FSIZE:=0;
OPENI(3);
EOFLAG:='FALSE';

'LOOP'
	'BEGIN'
	FILL;
	WRITDAT;
	'IF' EOFLAG 'THEN' 'QUIT';
	'IF' 'NOT' SAVETS 'THEN' 'QUIT';
	'END';
CLODOS;
'END';


'BEGIN'	\MAIN
VTOCBUF:=RESERVE(256);
DIRBUF:=RESERVE(256);
TSBUF:=RESERVE(256);
DATBUF:=RESERVE(256);
BITMASK:=[1,2,4,8,$10,$20,$40,$80,
$100,$200,$400,$800,$1000,$2000,$4000,$8000];

'LOOP' COPY;
'END';
