\ALINE2.XPL	NOV-05-92
\Gupta-Sproull algorithm for antialiased lines.

include C:\CXPL\CODESI;


proc	ALINE(X1, Y1, X2, Y2);
int	X1, Y1, X2, Y2;
int	DX, DY, E, NE, D, X, Y, TWOVDX;
int	FILTER;
real	INVDENOM, TWODXINVDENOM;


	proc	DOT(X, Y, DIST);
	int	X, Y;
	real	DIST;
	begin
	POINT(X, Y, FILTER(FIX(RLABS(DIST*3.0))));
	end;	\DOT


begin	\ALINE
FILTER:= [$1C, $1B, $1A, $19, $18, $17, $16, $15, $14, $13, $12, $11, $10];
DX:= X2 - X1;
DY:= Y2 - Y1;
D:= 2*DY - DX;
E:= 2 *DY;
NE:= 2 *(DY-DX);
TWOVDX:= 0;
INVDENOM:= 1.0 / (2.0 * SQRT(FLOAT(DX)*FLOAT(DX) + FLOAT(DY)*FLOAT(DY)));
TWODXINVDENOM:= 2.0 * FLOAT(DX) * INVDENOM;
X:= X1;
Y:= Y1;

DOT(X, Y, 0.0);
DOT(X, Y+1, TWODXINVDENOM);
DOT(X, Y-1, TWODXINVDENOM);
DOT(X, Y+2, 2.0*TWODXINVDENOM);
DOT(X, Y-2, 2.0*TWODXINVDENOM);
DOT(X, Y+3, 3.0*TWODXINVDENOM);
DOT(X, Y-3, 3.0*TWODXINVDENOM);
while X < X2 do
	begin
	if D < 0 then
		begin
		TWOVDX:= D +DX;
		D:= D + E;
		X:= X +1;
		end
	else	begin
		TWOVDX:= D -DX;
		D:= D + NE;
		X:= X +1;
		Y:= Y +1;
		end;

	DOT(X, Y, FLOAT(TWOVDX) *INVDENOM);
	DOT(X, Y+1, TWODXINVDENOM - FLOAT(TWOVDX) *INVDENOM);
	DOT(X, Y-1, TWODXINVDENOM + FLOAT(TWOVDX) *INVDENOM);
	DOT(X, Y+2, 2.0*TWODXINVDENOM - FLOAT(TWOVDX) *INVDENOM);
	DOT(X, Y-2, 2.0*TWODXINVDENOM + FLOAT(TWOVDX) *INVDENOM);
	DOT(X, Y+3, 3.0*TWODXINVDENOM - FLOAT(TWOVDX) *INVDENOM);
	DOT(X, Y-3, 3.0*TWODXINVDENOM + FLOAT(TWOVDX) *INVDENOM);
	end;
end;	\ALINE



begin	\MAIN
SETVID($13);
ALINE(10, 10, 250, 150);
ALINE(10, 20, 250, 30);
ALINE(10, 30, 250, 90);
ALINE(10, 40, 120, 150);
if CHIN(1) then;
SETVID($03);
end;	\MAIN
