\BACCARAT.XPL	FEB-18-86

\REVISION HISTORY:
\OCT-24-79, ORIGINAL VERSION, ANONYMOUS
\FEB-18-86, MODIFIED FOR 32-BIT XPL ON THE STRIDE, L.B.

code	ABS=0, RAN=1, REM=2, RESERVE=3, SWAP=4, CHIN=7, CHOUT=8, CRLF=9,
	INTIN=10, INTOUT=11, TEXT=12, CLOSE=15, CURSOR=23;

integer CARD, PLAYER, BANKER, WIN, PLAY, BANK, DRAW, TIE, BET, MONEY, I;



procedure DELAY;			\DELAY FOR A 10 MHZ STRIDE
int	I,J;
begin
for J:=1,10 do
	for I:=0,32000 do;
end;	\DELAY



procedure CLEAR(N);
integer N,I;
for I:=1,N do CHOUT(0,32);



procedure NUMBER(X);
integer X;
[INTOUT(0,X);CLEAR(32)];



procedure MESS(X);
address X;
integer I;
begin
DELAY;
CURSOR(0,14);
TEXT(0,X);
end;



procedure WON(X);
integer X;
begin
MONEY:=MONEY+X;
CURSOR(22,12);
NUMBER(MONEY);
MESS("WINNER PAID");CLEAR(32);
end;



procedure SETUP;
integer I;
begin
CHOUT(0,12);
TEXT(0,"			    BACCARAT");
CURSOR(0,1);
for I:=0,63 do TEXT(0,"*");
CURSOR(0,10);
for I:=0,63 do TEXT(0,"*");
for I:=2,9 do [CURSOR(32,I);TEXT(0,"*")];
CURSOR(13,2); TEXT(0,"PLAYER");
CURSOR(46,2); TEXT(0,"BANKER");
CURSOR(0,5); TEXT(0,"FIRST CARD:");
CURSOR(34,5); TEXT(0,"FIRST CARD:");
CURSOR(0,6); TEXT(0,"SECOND CARD:");
CURSOR(34,6); TEXT(0,"SECOND CARD:");
CURSOR(0,7); TEXT(0,"THIRD CARD:");
CURSOR(34,7); TEXT(0,"THIRD CARD:");
CURSOR(0,9); TEXT(0,"WAGER: $0");
CURSOR(34,9); TEXT(0,"WAGER: $0");
CURSOR(0,12); TEXT(0,"YOUR BANKROLL IS NOW $");
NUMBER(MONEY);
loop	begin
	CURSOR(0,14); CLEAR(32);
	MESS("BETS PLEASE ");
	BET:=INTIN(0);
	if MONEY>=ABS(BET) then quit;
	end;
if BET>0 then
	begin
	CURSOR(8,9);
	INTOUT(0,BET);
	end
else	begin
	CURSOR(42,9);
	INTOUT(0,-BET);
	end;
MONEY:=MONEY-ABS(BET);
CURSOR(22,12);
NUMBER(MONEY);
MESS("CARDS PLEASE"); CLEAR(32);
end;	\SETUP



procedure DEAL(X,Y);
integer X,Y,SUIT,I;
begin
DELAY;
CURSOR(X,Y);
CARD:=20;
while CARD>13 do CARD:=RAN(16)+1;
if CARD=1 then TEXT(0,"ACE")
else if CARD<11 then INTOUT(0,CARD)
else if CARD=11 then TEXT(0,"JACK")
else if CARD=12 then TEXT(0,"QUEEN")
else if CARD=13 then TEXT(0,"KING");
if CARD>10 then CARD:=10;
SUIT:=RAN(4);
if SUIT=0 then TEXT(0," OF DIAMONDS")
else if SUIT=1 then TEXT(0," OF SPADES")
else if SUIT=2 then TEXT(0," OF HEARTS")
else TEXT(0," OF CLUBS");
end;	\DEAL



begin	\MAIN
TIE:=0;
PLAY:=1;
BANK:=2;
MONEY:=1000;

\MAIN GAME LOOP
while MONEY>0 do begin
SETUP;
DEAL(13,5); PLAYER:=CARD;
DEAL(47,5); BANKER:=CARD;
DEAL(13,6); PLAYER:=REM((PLAYER+CARD)/10);
DEAL(47,6); BANKER:=REM((BANKER+CARD)/10);
DRAW:=(0=1);				\FALSE
if BANKER=9 then 			\BANK HAS NATURAL
	begin
	MESS("BANKER HAS A NATURAL"); CLEAR(32);
	if PLAYER=9 then
		begin
		WIN:=TIE;
		MESS("PLAYER HAS A NATURAL"); CLEAR(32);
		end
	else WIN:=BANK;
	end
else	begin				\NO BANK NATURAL
	if PLAYER>5 then
		begin			\PLAYER DOES NOT DRAW
		if PLAYER=9 then
			begin
			MESS("PLAYER HAS A NATURAL"); CLEAR(32);
			WIN:=PLAY	\PLAYER HAS NATURAL
			end
		else			\WILL BANK DRAW?
			DRAW:=BANKER<=5;
		end
	else	begin			\PLAYER DOES DRAW
		MESS("CARD TO THE PLAYER"); CLEAR(32);
		DEAL(13,7); PLAYER:=REM((PLAYER+CARD)/10);
		\WILL BANK DRAW?
		DRAW:=	(BANKER<=2)
		!	(BANKER=3 & CARD#8)
		!	(BANKER=4 & CARD>1 & CARD<8)
		!	(BANKER=5 & CARD>3 & CARD<8)
		!	(BANKER=6 & CARD>5 & CARD<8);
		end;
	\DEAL TO BANK IF HE MUST DRAW
	if DRAW then
		begin
		MESS("CARD TO THE BANKER"); CLEAR(32);
		DEAL(47,7);
		BANKER:=REM((BANKER+CARD)/10);
		end;
	if BANKER=PLAYER then WIN:=TIE
	else if BANKER>PLAYER then WIN:=BANK
	else WIN:=PLAY;
	end;

MESS("PLAYER SHOWS: "); NUMBER(PLAYER);
MESS("BANKER SHOWS: "); NUMBER(BANKER);
if WIN=TIE then
	begin
	MESS("PLAYER AND BANK PUSH"); CLEAR(32);
	MONEY:=MONEY+ABS(BET);
	end
else if WIN=BANK then
	begin
	MESS("BANKER WINS"); CLEAR(32);
	if BET<0 then WON((2*(-BET))-(-BET)/20);
	end
else	begin
	MESS("PLAYER WINS"); CLEAR(32);
	if BET>0 then WON(2*BET);
	end;
DELAY;
end;	\GAME LOOP

MESS("SORRY, SIR, BUT YOU LOSE");
I:=CHIN(0);
end;	\MAIN
