proc SAVECUR;
begin
CPUREG(0):=$0300;       CPUREG(1):=$0000;
SOFTINT($10);
ANSIY:=(CPUREG(3)&$FF00)/$100;
ANSIX:=CPUREG(3)&$00FF;
end;

proc RESCUR;
begin
CURSOR(ANSIX,ANSIY);
end;

proc CCUP(AMNT);
int AMNT;
begin
COUT($1B);
COUT(^[);
IOUT(AMNT);
COUT(^A);

CALLOTHER(1):=CALLOTHER(1)-AMNT;
\TEXT(0,"CCUP");
end;

proc CCDOWN(AMNT);
int AMNT;
begin
COUT($1B);
COUT(^[);
IOUT(AMNT);
COUT(^B);

CALLOTHER(1):=CALLOTHER(1)+AMNT;
\TEXT(0,"CCDOWN");
end;

proc CCRIGHT(AMNT);
int AMNT;
begin
COUT($1B);
COUT(^[);
IOUT(AMNT);
COUT(^C);

CALLOTHER(0):=CALLOTHER(0)+AMNT;
\DEBUG(^R);
\TEXT(0,"CCRIGHT");
end;

proc CCLEFT(AMNT);
int AMNT;
begin
\if AMNT<4 then for I:=1,AMNT do COUT(8)
\else    begin
        COUT($1B);
        COUT(^[);
        IOUT(AMNT);
        COUT(^D);
\        end;
CALLOTHER(0):=CALLOTHER(0)-AMNT;
\TEXT(0,"CCLEFT");
\DEBUG(^L);
end;

proc CCMOVETO(CCX,CCY);
int CCX,CCY;
begin
COUT($1B);
COUT(^[);
if CCY#0 ! CCX#0 then IOUT(CCY-SCRMXMN(0)+1);
if CCX#0 then [COUT(^;);IOUT(CCX+1)];
COUT(^H);

CALLOTHER(0):=CCX;
CALLOTHER(1):=CCY;
\TEXT(0,"CCMOVETO");
\DEBUG(^M);
end;

proc CCCOLOR(COLOR);
int COLOR,CTMP,CCTMP2;

        proc SETBACK;
        int CLRTMP;
        begin
        if       ( (CALLOTHER(2)&$F0) < $80 ) & ( (COLOR&$F0) > $70 )
                then [if CTMP then COUT(^;) else CTMP:=true;IOUT(5)];
\if the new color if blinking and the old is not, set blinking


        if (CALLOTHER(2)&$F0)+$80 = (COLOR&$F0) then else
                begin
                if CTMP then COUT(^;) else CTMP:=true;
                CLRTMP:=COLOR;
                CLRTMP:=(CLRTMP&$F0)/$10;
                if CLRTMP>$7 the CLRTMP:=CLRTMP-$8;
                case CLRTMP of
                0:      IOUT(40);
                1:      IOUT(44);
                2:      IOUT(42);
                3:      IOUT(46);
                4:      IOUT(41);
                5:      IOUT(45);
                6:      IOUT(43);
                7:      IOUT(47)
                else;
                end;
        end;

        proc SETFORE;
        int CLRTMP;
        begin
        if       ( (CALLOTHER(2)&$0F) < $08 ) & ( (COLOR&$0F) > $07 )
                then [if CTMP then COUT(^;) else CTMP:=true;IOUT(1)];
\if the new color is high-intensity and the old it not, set high-intensity


        if (CALLOTHER(2)&$F)+8 = (COLOR&$F) then else
                begin
                if CTMP then COUT(^;) else CTMP:=true;
                CLRTMP:=COLOR;
                CLRTMP:=(CLRTMP&$F);
                if CLRTMP>$7 the CLRTMP:=CLRTMP-$8;
                case CLRTMP of
                0:      IOUT(30);
                1:      IOUT(34);
                2:      IOUT(32);
                3:      IOUT(36);
                4:      IOUT(31);
                5:      IOUT(35);
                6:      IOUT(33);
                7:      IOUT(37)
                else;
                end;
        end;

if COLOR#CALLOTHER(2) then
begin
COUT($1B);
COUT(^[);
CTMP:=false;

\ctmp says, "is there an entry before this? "... true of false...
\      - used to tell whether to insert a ";" before the number


CCTMP2:=false;
\if either BLINKING of HIGH-INTENSITY are to be turned off, send NORMAL
if (((CALLOTHER(2)&$F0)>$70) & ((COLOR&$F0)<$80)) then
[CCTMP2:=true;CALLOTHER(2):=(CALLOTHER(2)&$F0-$80)&(CALLOTHER(2)&$F)];
if (((CALLOTHER(2)&$0F)>$07) & ((COLOR&$0F)<$08)) then
[CCTMP2:=true;CALLOTHER(2):=(CALLOTHER(2)&$F-$8)&(CALLOTHER(2)&$F0)];

if CCTMP2 then [IOUT(0);CTMP:=true;SETBACK;SETFORE]
else
        begin
        if (CALLOTHER(2)&$F0) # (COLOR&$F0) then SETBACK;
        \if background colors don't match, send new background color

        if (CALLOTHER(2)&$0F) # (COLOR&$0F) then SETFORE;
        \if foreground colors don't match, send new foreground color
        end;
COUT(^m);
CALLOTHER(2):=COLOR;
\TEXT(0,"CCCOLOR");
end;

proc CCSAVE;
begin
COUT($1B);
COUT(^[);
COUT(^s);
end;

proc GCCOL(GX,GY);
int GX,GY;
return CALLSCR(0,((GY*80)+GX)*2+1);

proc GLCOL(GX,GY);
int GX,GY;
return LCLSCR(0,((GY*80)+GX)*2+1);

proc CCRESTOR;
begin
COUT($1B);
COUT(^[);
COUT(^u);
end;

proc CUOUT(CHR);
char CHR;
begin
case CHR of
^:     COUT(^);
^:     COUT(^)\;
\^:     COUT(^);
\^:     COUT(^)
else COUT(CHR);
CALLSCR(0,(CALLOTHER(1)*80+CALLOTHER(0))*2):=CHR;
CALLSCR(0,(CALLOTHER(1)*80+CALLOTHER(0))*2+1):=CALLOTHER(2);
\DEBUG(CALLOTHER(2)+48);
CALLOTHER(0):=CALLOTHER(0)+1;
end;

proc MCUR(MCX,MCY);
char MCX,MCY;
begin
\if CALLOTHER(0)=MCX & CALLOTHER(1)=MCY then

if CALLOTHER(0)=MCX & CALLOTHER(1)#MCY then
        [\PAUSE;
        if CALLOTHER(1)>MCY then CCUP(CALLOTHER(1)-MCY)
        else CCDOWN(MCY-CALLOTHER(1))];

if CALLOTHER(0)#MCX & CALLOTHER(1)=MCY then
        [\PAUSE;
        if CALLOTHER(0)>MCX then CCLEFT(CALLOTHER(0)-MCX)
        else CCRIGHT(MCX-CALLOTHER(0))];

if CALLOTHER(0)#MCX & CALLOTHER(1)#MCY then
        CCMOVETO(MCX,MCY);
end;

