\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,        CRLF=9,         INTIN=10,       INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,       POINT=41,       LINE=42,        MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
ATTRIB=69,      SETWIND=70,     RAWTEXT=71,     HILIGHT=72,
MALLOC=73       RELEASE=74;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,        LN=54,          EXP=55,         SIN=56,
ATAN2=57,       MOD=58,         LOG=59,         COS=60,
TAN=61,         ASIN=62,        ACOS=63;

int STATLINE,LINESTAT,MDMSTAT,CPUREG,COMPORT,CH,TEXTCX,TEXTCY,LAST,I,ERRCHK,
ACOLOR,HANDLE,BAUDRATE,PSPADD,POSITION;
char TEMP,ANSISTR,CSAVE,LASTLINE,LASTMDM;
seg char PSP;

include BIT.XPL;
include CLOCK;
include SERIAL.XPL;
include SERLINE.XPL;

proc GETSTRING(SS,LIM);
char SS;
int LIM;
begin
I:=0;
loop
        begin
        CH:=CHIN(0);
        if CH=$0D then quit;
        if I=LIM-1 then quit;
        SS(I):=CH;
        I:=I+1;
        end;
SS(I-1):=SS(I-1)!$80;
end;

proc GETCURSOR;
begin
CPUREG(0):=$0300;       CPUREG(1):=$0000;
SOFTINT($10);
TEXTCY:=(CPUREG(3)&$FF00)/$100;
TEXTCX:=CPUREG(3)&$00FF;
end;

proc DRAWSCR;
begin
ATTRIB($4E);
SETWIND(0,0,79,0,$FF00,true);
\GETCURSOR;
\CURSOR(0,STATLINE);
\HILIGHT(0,STATLINE,79,STATLINE,$1F);
\RAWTEXT(0,"Stat-Line  MDM: RL RI DS CS DR TE DD DC  LINE: TO TS TH BD FE PE OE DR      ");
\CURSOR(TEXTCX,TEXTCY);
end;

proc DRAWSTAT;
begin
GETSTAT;
if (LASTMDM#MDMSTAT) ! (LASTLINE#LINESTAT) then
        begin
        GETCURSOR;
        ATTRIB($4E);
        SETWIND(0,0,79,0,$FF02,false);
        CURSOR(0,0);

        if CARRIER then TEXT(6," On-line ") else TEXT(6," Off-line ");
        LASTMDM:=MDMSTAT;
        LASTLINE:=LINESTAT;
\        BITOUT(0,MDMSTAT);CHOUT(0,^ );
\        BITOUT(0,LINESTAT);


        ATTRIB(ACOLOR);
        SETWIND(0,1,79,24,0,false);
        CURSOR(TEXTCX,TEXTCY);
        end;
end;

proc GETTIME;
begin
CPUREG(0):=$2C00;
SOFTINT($21);
end;

proc ANSIOUT(CHR);
char CHR,DRAW;

        proc RANSI;
        begin
\        ANSISTR(9):=0;
        for I:=0,9 do ANSISTR(I):=0;
        end;

        proc SETDESATTRIB;
        begin
        for I:=0,ANSISTR(9) do
                begin
\                INTOUT(6,ANSISTR(I));CHOUT(6,^ );
                case ANSISTR(I) of
                0:      [if (ACOLOR & $F)>7 then ACOLOR:=ACOLOR-8;if (ACOLOR & $F0) >$70 then ACOLOR:=ACOLOR-$80];
                1:      if (ACOLOR & $F)<8 then ACOLOR:=ACOLOR+8;
\                4:
                5:      if ACOLOR&$F<$80 then ACOLOR:=ACOLOR+$80;
\                7:
\                8:
                30:     [if (ACOLOR & $0F)>$7 then ACOLOR:=(ACOLOR & $F0)+$8 else ACOLOR:=(ACOLOR & $F0)];
                31:     [if (ACOLOR & $0F)>$7 then ACOLOR:=(ACOLOR & $F0)+$8+4 else ACOLOR:=(ACOLOR & $F0)+4];
                32:     [if (ACOLOR & $0F)>$7 then ACOLOR:=(ACOLOR & $F0)+$8+2 else ACOLOR:=(ACOLOR & $F0)+2];
                33:     [if (ACOLOR & $0F)>$7 then ACOLOR:=(ACOLOR & $F0)+$8+6 else ACOLOR:=(ACOLOR & $F0)+6];
                34:     [if (ACOLOR & $0F)>$7 then ACOLOR:=(ACOLOR & $F0)+$8+1 else ACOLOR:=(ACOLOR & $F0)+1];
                35:     [if (ACOLOR & $0F)>$7 then ACOLOR:=(ACOLOR & $F0)+$8+5 else ACOLOR:=(ACOLOR & $F0)+5];
                36:     [if (ACOLOR & $0F)>$7 then ACOLOR:=(ACOLOR & $F0)+$8+3 else ACOLOR:=(ACOLOR & $F0)+3];
                37:     [if (ACOLOR & $0F)>$7 then ACOLOR:=(ACOLOR & $F0)+$8+7 else ACOLOR:=(ACOLOR & $F0)+7];
                40:     [if (ACOLOR & $F0)>$70 then ACOLOR:=(ACOLOR & $0F)+$80 else ACOLOR:=(ACOLOR & $0F)];
                41:     [if (ACOLOR & $F0)>$70 then ACOLOR:=(ACOLOR & $0F)+$C0 else ACOLOR:=(ACOLOR & $0F)+$40];
                42:     [if (ACOLOR & $F0)>$70 then ACOLOR:=(ACOLOR & $0F)+$A0 else ACOLOR:=(ACOLOR & $0F)+$20];
                43:     [if (ACOLOR & $F0)>$70 then ACOLOR:=(ACOLOR & $0F)+$E0 else ACOLOR:=(ACOLOR & $0F)+$60];
                44:     [if (ACOLOR & $F0)>$70 then ACOLOR:=(ACOLOR & $0F)+$90 else ACOLOR:=(ACOLOR & $0F)+$10];
                45:     [if (ACOLOR & $F0)>$70 then ACOLOR:=(ACOLOR & $0F)+$D0 else ACOLOR:=(ACOLOR & $0F)+$50];
                46:     [if (ACOLOR & $F0)>$70 then ACOLOR:=(ACOLOR & $0F)+$B0 else ACOLOR:=(ACOLOR & $0F)+$30];
                47:     [if (ACOLOR & $F0)>$70 then ACOLOR:=(ACOLOR & $0F)+$F0 else ACOLOR:=(ACOLOR & $0F)+$70]
                else;
\                TEXT(6,"New color: ");
\                HEXOUT(6,ACOLOR);CRLF(6);
                end;
        ATTRIB(ACOLOR);
        end;

        proc MOVECURSOR(MCX,MCY);
        int MCX,MCY;
        begin
        GETCURSOR;
        TEXTCX:=TEXTCX+MCX;
        TEXTCY:=TEXTCY+MCY;
        if TEXTCX<0 then TEXTCX:=0;
        if TEXTCX>79 then TEXTCX:=79;
        if TEXTCY<1 then TEXTCY:=1;
        if TEXTCY>24 then TEXTCY:=24;
        CURSOR(TEXTCX,TEXTCY);
        end;

        proc MOVECTO;
        [CURSOR(ANSISTR(1)-1,ANSISTR(0))\;TEXT(6," ^MOVETO^ ")\];

        proc HOME;
        CURSOR(0,1);

        proc ACHOUT(PRT,CHR);
        char PRT,CHR;
        begin
        case CHR of
        8:      CHOUT(0,CHR);
        12:     SETWIND(0,1,79,24,0,true)
        else CHOUT(PRT,CHR);
        end;

begin
DRAW:=true;
case ANSISTR(9) of
254:    [if CHR=$1B then ANSISTR(9):=255 else ACHOUT(6,CHR)];
255:    [if CHR=^[ then RANSI else ANSISTR(9):=254]
else
        begin
        ANSISTR(8):=ANSISTR(8)+1;
        if CHR>=48 & CHR<=57 then ANSISTR(ANSISTR(9)):=ANSISTR(ANSISTR(9))*10+CHR-48
        else
        case CHR of
        ^;:     if ANSISTR(9)<9 then ANSISTR(9):=ANSISTR(9)+1;
        ^m:     [SETDESATTRIB;ANSISTR(9):=254];
        ^s:     [GETCURSOR;CSAVE(0):=TEXTCX;CSAVE(1):=TEXTCY;ANSISTR(9):=254];
        ^u:     [CURSOR(CSAVE(0),CSAVE(1));ANSISTR(9):=254];
        ^A:     [if ANSISTR(8)=1 then ANSISTR(0):=1;MOVECURSOR(0,0-ANSISTR(0));ANSISTR(9):=254];
        ^B:     [if ANSISTR(8)=1 then ANSISTR(0):=1;MOVECURSOR(0,ANSISTR(0));ANSISTR(9):=254];
        ^C:     [if ANSISTR(8)=1 then ANSISTR(0):=1;MOVECURSOR(ANSISTR(0),0);ANSISTR(9):=254];
        ^D:     [if ANSISTR(8)=1 then ANSISTR(0):=1;MOVECURSOR(0-ANSISTR(0),0);ANSISTR(9):=254];
        ^f:     [if ANSISTR(8)<4 then ANSISTR(1):=1;if ANSISTR(8)>=2 then MOVECTO else HOME;ANSISTR(9):=254];
        ^H:     [if ANSISTR(8)<4 then ANSISTR(1):=1;if ANSISTR(8)>=2 then MOVECTO else HOME;ANSISTR(9):=254];
        ^J:     [if ANSISTR(0)=2 then ACHOUT(6,12);ANSISTR(9):=254]
        else [ANSISTR(9):=254;ACHOUT(6,CHR);ANSISTR(8):=ANSISTR(8)-1];
        end;
end; \ansiOut



proc LOADANS;
seg char SSAVE;
char FILENAME;
begin
FILENAME:=RESERVE(80);
SSAVE:=RESERVE(2);
SSAVE(0):=MALLOC(((2*80*25)/16)+1);
GETCURSOR;
BLIT($B800,0,SSAVE(0),0,80*25*2);
ATTRIB($1F);
SETWIND(10,10,69,15,$FF02,true);
RAWTEXT(6,"͸
 Type in file name to UPLOAD:                             
                                                          
                                                          
                                                          
; ");
ATTRIB($07);
SETWIND(12,13,67,13,$2,true);
GETSTRING(FILENAME,55);

HANDLE:=FOPEN(FILENAME,0);
FSET(HANDLE,^I);

ATTRIB(ACOLOR);
BLIT(SSAVE(0),0,$B800,0,80*25*2);

SETWIND(0,1,79,24,0,false);
CURSOR(TEXTCX,TEXTCY);
OPENI(0);
\loop if CHKKEY then CH:=CHIN(1) else quit;
loop
        begin
        \for I:=0,700 do\ if CHKKEY then [CH:=CHIN(1);if CH=$1B then quit];
        CH:=CHIN(3);
        if CH=$1A then quit;
\        ANSIOUT(CH);
        COUT(CH);
        if CKKCOM then ANSIOUT(CIN);
        end;

CLOSE(3);
FCLOSE(HANDLE);
RELEASE(SSAVE(0));
end; \loadans

\*********************************

proc EXITPROG;
seg char SSAVE;
char XBOOL;

proc EXITFORREAL;
begin
CPUREG(0):=$05;
CPUREG(3):=COMPORT;
SOFTINT($14);
CHOUT(0,$0C);
ATTRIB($1F);
SETWIND(0,0,79,5,$FF02,true);
RAWTEXT(6,"͸
                                                                              
                    Thank-you for using Super-Duper-Comm!                     
                          by Shane Brinkman-Davis                             
                                                                              
; ");
ATTRIB($7);
exit;
end; \exitforreal

begin
XBOOL:=^N;
SSAVE:=RESERVE(2);
SSAVE(0):=MALLOC(2*80*25);
GETCURSOR;
BLIT($B800,0,SSAVE(0),0,80*25*2);
ATTRIB($1F);
SETWIND(29,11,51,15,$FF02,true);
RAWTEXT(6,"͸
   Exit Terminal?    
                     
      YES   NO       
; ");
loop
        begin
        if CHKKEY then
                begin
                CH:=CHIN(1);
                case CH of
                ^Y:     \XBOOL:=^Y;\EXITFORREAL;
                ^y:     \XBOOL:=^Y;\EXITFORREAL;
                ^N:     \XBOOL:=^N;\quit;
                ^n:     \XBOOL:=^N;\quit;
                $0D:    if XBOOL=^Y then EXITFORREAL else quit;
                $1B:    quit; 0:      [CH:=CHIN(1);case CH of 75:
                XBOOL:=^Y; 77:     XBOOL:=^N else] else; end; if
                XBOOL=^N then
                [HILIGHT(41,14,44,14,$4F);HILIGHT(35,14,39,14,$1F)] else
                [HILIGHT(41,14,44,14,$1F);HILIGHT(35,14,39,14,$4F)];
                end; BLIT(SSAVE(0),0,$B800,0,80*25*2);
                CURSOR(TEXTCX,TEXTCY); RELEASE(SSAVE(0)); end; \exitproc

proc TERM;
begin
ATTRIB(7);
SETWIND(0,1,79,24,0,true);
ACOLOR:=$07;
loop
        begin
        if CKKCOM then ANSIOUT(CIN) else
        \[HEXOUT(6,CIN);CRLF(6)];
        if CHKKEY then
                begin
                CH:=CHIN(1);
                case CH of
                0:      begin
                        CH:=CHIN(1);
                        case CH of
                        22:     LOADANS;
                        45:     EXITPROG
                        else COUT(CH);;
                        end
                else COUT(CH);
                end;
        DRAWSTAT;
        end;
end; \term


begin
CPUREG:=GETREG;
PSPADD:=CPUREG(11);
PSP:=RESERVE(2);
PSP(0):=PSPADD;
CLINE;

STATLINE:=0;
ANSISTR:=RESERVE(200);
ANSISTR(0):=0;
ANSISTR(9):=254;
CSAVE:=RESERVE(200);
DRAWSCR;
LASTMDM:=0;
LASTLINE:=0;


\COMPORT:=0;
INITCOMMPORT(BAUDRATE,0,1,8);
DRAWSTAT;
TERM;
end;
