\CALENDAR.XPL		DEC-03-99
\CALENDAR MAKER
\ BY LOREN BLANEY

\REVISION HISTORY:
\DEC-28-83, ORIGINAL
\MAR-14-86, MODIFIED FOR 32-BIT XPL
\APR-23-87, MODIFIED FOR XPL V5.7
\DEC-03-99, Y2K AND PC COMPLIANT

code	REM=2, CHIN=7, CHOUT=8, CRLF=9, INTIN=10, INTOUT=11, TEXT=12, OPENI=13,
	OPENO=14, CLOSE=15;

def	WIDE=14;	\USE 17 FOR 96 CHARACTER LINES, 14 FOR 80 CHAR LINES
def	TV=0, KB=0, PR=2;
def	SP=$20, FF=$0C, BEL=$07;
def	\MONTH\ DUMMY, JAN, FEB, MAR, APR, MAY, JUN, JUL, AUG, SEP, OCT, NOV, DEC;
int	YEAR,	\RANGE:
	MONTH;	\RANGE: JAN-DEC (I.E. 1-12)



proc	DOMONTH(MONTH, YEAR);	\PRINT A CALENDAR MONTH
int	MONTH, YEAR;
int	CH, MONAME, DAYNAME, MOMAX;
int	WEEK, ROW, WEEKDAY, I, DAYMAX, DAY, DAY0;
def	\DAY\ SUN, MON, TUE, WED, THR, FRI, SAT;
addr	NAME;
begin
MONAME:= ["DUMMY",	"JANUARY",	"FEBRUARY",	"MARCH",
	"APRIL",	"MAY",		"JUNE",		"JULY",
	"AUGUST",	"SEPTEMBER",	"OCTOBER",	"NOVEMBER",
	"DECEMBER"];

TEXT(PR, "     ");
NAME:= MONAME(MONTH);
for I:= 0, 100 do
	begin
	CH:= NAME(I);
	if CH >= $80 then
		begin
		CH:= CH & $7F;
		I:= 100;
		end;
	CHOUT(PR, CH);
	TEXT(PR, "  ");
	end;

OPENO(8);
INTOUT(8, YEAR);
OPENI(8);
TEXT(PR, "      ");
for I:= 0, 3 do
	begin
	CHOUT(PR, CHIN(8));
	TEXT(PR, "  ");
	end;
CRLF(PR);

DAYNAME:= ["SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT"];

\DETERMINE THE MAXIMUM NUMBER OF DAYS THIS MONTH CAN HAVE
MOMAX:= [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
DAYMAX:= MOMAX(MONTH);
YEAR:= YEAR - 1976;
if MONTH=FEB & REM(YEAR/4)=0 then DAYMAX:= DAYMAX+1;

\DETERMINE WHAT DAY OF THE WEEK THE FIRST OF THE MONTH IS
DAY:= 1;
if MONTH<=2 then [MONTH:= MONTH+10;   YEAR:= YEAR-1] else MONTH:= MONTH-2;
WEEKDAY:= REM(((26*MONTH -2) /10 +DAY +YEAR +YEAR/4 +61) /7);
DAY:= 1 - WEEKDAY;

DAY0:= DAY;
for WEEKDAY:= SUN, SAT do
	begin
	DAY:= DAY0;
	TEXT(PR, "   ");
	for WEEK:= 1, 5 do
		begin
		CHOUT(PR, ^+);
		for I:= 1, WIDE do CHOUT(PR, ^-);
		end;
	CHOUT(PR, ^+);
	CRLF(PR);

	TEXT(PR, "   ");
	for WEEK:= 1, 5 do
		begin
		TEXT(PR, "| ");
		if DAY>0 & DAY<=DAYMAX then
			begin
			INTOUT(PR, DAY);
			if DAY<=9 then CHOUT(PR,SP);
			end
		else TEXT(PR,"  ");
		for I:= 1, WIDE-3 do CHOUT(PR,SP);
		DAY:= DAY+7;
		end;
	CHOUT(PR, ^|);
	CRLF(PR);

	for ROW:= 1, 6 do
		begin
		NAME:= DAYNAME(WEEKDAY);
		CHOUT(PR, if ROW>=2 & ROW<=4 then NAME(ROW-2)&$7F else SP);
		TEXT(PR, "  ");
		for WEEK:= 1, 5 do
			begin
			if WEEK=5 & DAY<=DAYMAX & (ROW=3 ! ROW=4) then
				begin
				if ROW=3 then 
					[CHOUT(PR, ^+);
					for I:= 1, WIDE do CHOUT(PR, ^-)];
				if ROW=4 then
					[TEXT(PR, "| ");   INTOUT(PR, DAY);
					for I:= 1, WIDE-3 do CHOUT(PR, SP)];
				end
			else
			[CHOUT(PR, ^|);
			for I:= 1, WIDE do CHOUT(PR, ^ )];
			end;
		CHOUT(PR, if DAY<=DAYMAX & ROW=3 then ^+ else ^|);
		CRLF(PR);
		end;

	DAY0:= DAY0+1;
	end;
TEXT(PR, "   ");
for WEEK:= 1, 5 do
	begin
	CHOUT(PR, ^+);
	for I:= 1, WIDE do CHOUT(PR,^-);
	end;
CHOUT(PR, ^+);
CRLF(PR);
CHOUT(PR, FF);
end;	\DOMONTH



begin	\MAIN
TEXT(TV, "
 -- CALENDAR MAKER, VER 1.2 --
");
CRLF(TV);
TEXT(TV, "WHICH YEAR (4 DIGITS)? ");
OPENI(KB);
YEAR:= INTIN(KB);

\PRINT CALENDAR
OPENO(PR);
TEXT(TV, "WHICH MONTH (1 - 12)? ");   MONTH:= INTIN(KB);	\DEBUG
\for MONTH:= JAN, DEC do 
DOMONTH(MONTH, YEAR);
end;	\MAIN
