\CASES.XPL
\SELECTIVELY CONVERTS TEXTS TO UPPER AND LOWER CASE
\COPYRIGHT 1979 LARRY FISH


'CODE'RESERVE=3,CHIN=7,CHOUT=8,
REM=2,CRLF=9,NUMIN=10,
NUMOUT=11,TEXT=12,OPENIN=13,
OPENOUT=14,CLOSE=15,ABORT=16;

'INT' CAP,X,STATE,SWITCH,IDEV,ODEV,CASE,CHAR;

'DEF' UPPER,LOWER;
'DEF' CTZ=26;

'PROC' LOW;
'EXIT' CHAR>=(^A+32) & CHAR<=(^Z+32);

'PROC' GETC;
'BEGIN'
CHAR:=CHIN(IDEV);
'END';
'PROC' DOUPPER;
'BEGIN'
'IF' LOW 'THEN' CHAR:=CHAR-32;
'END';

'PROC' DOLOWER;
'BEGIN'
'IF' CHAR>=^A & CHAR<=^Z 'THEN' CHAR:=CHAR+32;
'END';

'PROC' UPPMAR;
'BEGIN'
TEXT(0,"MARKER CHAR?");
OPENIN(0);SWITCH:=CHIN(0);

'WHILE' CHAR#CTZ 'DO'
	'BEGIN'
	GETC;
	'IF' CHAR=SWITCH 'THEN'
		'BEGIN'
		GETC;
		DOLOWER;
		'END'
	'ELSE' DOUPPER;
	CHOUT(ODEV,CHAR);
	'END';
'END';
'PROC' CWORD;
'BEGIN'
GETC;
'WHILE' CHAR>^  'DO'
	'BEGIN'
	DOUPPER;
	CHOUT(ODEV,CHAR);
	GETC;
	'END';
'END';



'PROC' LOWMAR;

'BEGIN'
TEXT(0,"MARKER CHAR?");
OPENIN(0);SWITCH:=CHIN(0);
TEXT(0,"MARK FOR WORD CAPITALIZE?");
OPENIN(0);CAP:=CHIN(0);
'WHILE' CHAR#CTZ 'DO'
	'BEGIN'
	GETC;
	'IF' CHAR=CAP 'THEN' CWORD;
	'IF' CHAR=SWITCH 'THEN'
		'BEGIN'
		GETC;
		DOUPPER;
		'END'
	'ELSE' DOLOWER;
	CHOUT(ODEV,CHAR);
	'END';
'END';

'PROC' ENCLOSED;

'BEGIN'
STATE:='FALSE';
TEXT(0,"SWITCH CHARACTER? ");
OPENIN(0);SWITCH:=CHIN(0);
TEXT(0,"CONVERT TO UPPER OR LOWER");
OPENIN(0);
CASE:='IF' CHIN(0)=^U 'THEN' UPPER 'ELSE' LOWER;
'WHILE' CHAR#CTZ 'DO'
	'BEGIN'
	GETC;
	'IF' CHAR=SWITCH 'THEN'
		'BEGIN'
		STATE:='NOT' STATE;
		GETC;
		'END';
	'IF' CASE=UPPER & STATE='TRUE' 'THEN' DOUPPER;
	'IF' CASE=LOWER & STATE='TRUE' 'THEN' DOLOWER;
	CHOUT(ODEV,CHAR);
	'END';
'END';


'PROC' XPL;	\CONVERT LOWER TO UPPER WITH XPL0 STYLE QUOTES
'INT' FLAG;

'PROC' QUOTE;
CHOUT(ODEV,^');

'BEGIN'
FLAG:=UPPER;
'WHILE' CHAR#CTZ 'DO'
	'BEGIN'
	GETC;
	'IF' LOW 'THEN'
		'BEGIN'
		'IF' FLAG=UPPER'THEN' [QUOTE;FLAG:=LOWER;];
		DOUPPER;
		'END'
	'ELSE' 'IF' FLAG=LOWER 'THEN' [QUOTE;FLAG:=UPPER;];
	CHOUT(ODEV,CHAR);
	'END';
'END';



'BEGIN' \MAIN
TEXT(0,"INPUT DEVICE, OUTPUT DEVICE");
IDEV:=NUMIN(0);ODEV:=NUMIN(0);
OPENIN(0);
OPENIN(IDEV);OPENOUT(ODEV);
CRLF(0);
TEXT(0,"1) CONVERT TO LOWERCASE EXCEPT MARKED CHARACTERS.");
CRLF(0);
TEXT(0,"2) CONVERT TO UPPERCASE EXCEPT MARKED CHARACTERS.");
CRLF(0);
TEXT(0,"3) CONVERT TEXT BETWEEN MARKERS.");
CRLF(0);
TEXT(0,"4 CONVERT TO UPPER AND ADD QUOTE");
CRLF(0);
X:=NUMIN(0);
'IF' X=1 'THEN' LOWMAR 'ELSE'
'IF' X=2 'THEN' UPPMAR 'ELSE' 
'IF' X=3 'THEN' ENCLOSED 'ELSE' XPL;
CHOUT(ODEV,CTZ);
CLOSE(ODEV);
'END';
