\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
ATTRIB=69,	SETWIND=70,	RAWTEXT=71,	HILIGHT=72;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,       MOD=58,         LOG=59,         COS=60,
TAN=61,         ASIN=62,        ACOS=63;

int XPOS,YPOS,P1X,P4X,P4Y,P5X,POINTS,CH,P1DIV,P2DIV,P3DIV,PABS,I,COUNT,RET,DRWI,PNTS;
int MOUSEX,MOUSEY,CPUREG,SSX,SSY,TEMP,LFTFST,RGTFST,BBX,BBY,LMX,LMY;
int MBLEFT,MBRIGHT,MBMIDDLE;

proc MC(ON);
int ON;
begin
if ON then TEMP:=1 else TEMP:=2;
CPUREG(0):=TEMP;          \TURN ON/OFF MOUSE CURSOR;
SOFTINT($33);
end;

proc SETVGA;
begin
SSX:=640;
SSY:=480;
SETVID(18);
MC(true);
CPUREG(0):=$7;     CPUREG(2):=0;      CPUREG(3):=SSX-1;   SOFTINT($33);
CPUREG(0):=$8;     CPUREG(2):=0;      CPUREG(3):=SSY-1;   SOFTINT($33);
\Set Max/Min positions for Horizontal and Vertical
end;

proc GETMINFO;
begin
CPUREG(0):=$3;
SOFTINT($33);
MOUSEX:=CPUREG(2);
MOUSEY:=CPUREG(3);
TEMP:=CPUREG(1);
case TEMP of
0:      [MBLEFT:=false;MBRIGHT:=false];
1:      [MBLEFT:=true;MBRIGHT:=false];
2:      [MBLEFT:=false;MBRIGHT:=true];
3:      [MBLEFT:=true;MBRIGHT:=true]
        else;
\CURSOR(0,0);
\INTOUT(0,CPUREG(1));
end;

proc EXITP;
begin
SETVID(3);
exit;
end;

proc CPOINT(PADDX,PADDY);
int PADDX,PADDY;
begin
XPOS:=(XPOS+PADDX)/2;
YPOS:=(YPOS+PADDY)/2;
GETMINFO;
if MOUSEX-16>XPOS ! MOUSEY-16>YPOS ! MOUSEX+16<XPOS ! MOUSEY+16<YPOS then
POINT(XPOS,YPOS,3)
else
        begin
        MC(false);
        POINT(XPOS,YPOS,3);
        MC(true);
        end
end;                                                                         

proc GETPOINTS;
int GPX,GPY;

        proc GETP;
        begin
        RET:=true;
        loop [if MBLEFT then [GPX:=MOUSEX;GPY:=MOUSEY;quit];if CHKKEY then RET:=false;GETMINFO;];
        if RET then loop [GETMINFO;if MBLEFT=false then quit];
        if CHKKEY then [CH:=CHIN(0);if CH=^Q ! CH=^q then EXITP];
        end;
        
begin
GETP;PNTS(0,0):=GPX;PNTS(0,1):=GPY;
        CURSOR(0,0);TEXT(0,"POINT #1-X: ");INTOUT(0,PNTS(0,0));
        CURSOR(0,1);TEXT(0,"POINT #1-Y: ");INTOUT(0,PNTS(0,1));
MC(false);
POINT(PNTS(0,0),PNTS(0,1),15);
MC(true);
GETP;PNTS(1,0):=GPX;PNTS(1,1):=GPY;
MC(false);
LINE(PNTS(1,0),PNTS(1,1),15);
MC(true);
        CURSOR(0,2);TEXT(0,"POINT #2-X: ");INTOUT(0,PNTS(1,0));
        CURSOR(0,3);TEXT(0,"POINT #2-Y: ");INTOUT(0,PNTS(1,1));

GETP;PNTS(2,0):=GPX;PNTS(2,1):=GPY;
MC(false);
LINE(PNTS(2,0),PNTS(2,1),15);
LINE(PNTS(0,0),PNTS(0,1),15);
MC(true);
        CURSOR(0,4);TEXT(0,"POINT #3-X: ");INTOUT(0,PNTS(2,0));
        CURSOR(0,5);TEXT(0,"POINT #3-Y: ");INTOUT(0,PNTS(2,1));

\        PNTS(0,0):=RAN(640);
\        PNTS(0,1):=RAN(480);
\        PNTS(1,0):=RAN(640);
\        PNTS(1,1):=RAN(480);
\        PNTS(2,0):=RAN(640);
\        PNTS(2,1):=RAN(480);
end;

begin
CPUREG:=GETREG;
PNTS:=RESERVE(12);
for I:=0,2 do PNTS(I):=RESERVE(8);
COUNT:=true;
DRWI:=0;
XPOS:=RAN(640);
YPOS:=RAN(480);
GETMINFO;
loop
        begin
        I:=0;
        SETVGA;
        GETPOINTS;
        CURSOR(0,6);TEXT(0,"ITERATIONS: ");INTOUT(0,I);DRWI:=I;
        if COUNT=true then
        loop
                begin
                if I=1000 then [I:=0;DRWI:=DRWI+1;CURSOR(12,6);INTOUT(0,DRWI);TEXT(0,"000")];
                I:=I+1;
                POINTS:=RAN(3);
                CPOINT(PNTS(POINTS,0),PNTS(POINTS,1));
\                case POINTS of
\                0: CPOINT(PNTS(0,0),PNTS(0,1));
\                1: CPOINT(PNTS(1,0),PNTS(1,1))
\                else CPOINT(PNTS(2,0),PNTS(2,1));
                OPENI(1);
                GETMINFO;
                if MBLEFT then [\loop [GETMINFO;if MBLEFT=false then quit];\quit];
                if CHKKEY then
                        begin
                        CH:=CHIN(1);
                        if CH=^Q ! CH=^q then EXITP;
                        end;
                end;
        end;
end;
