\COLUMNS.XPL		10/2/81
\BY LOREN BLANEY
\This program converts a single column of lines into two columns.

'CODE'
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
FREE=18;

'DEF' EOL=$0A, EOF=$1A, CR=$0D, TAB=$09, FF=$0C, BEL=$07, DEV=3;

'INT' INDEX, CHAR, BUFSIZ;
'CHAR' BUFFER;


'PROC' LINEIN(INDEX);
'BEGIN'
'IF' CHAR=EOF 'THEN' 'RETURN';
'REPEAT' CHAR:=CHIN(3);
	BUFFER(INDEX):=CHAR;
	INDEX:=INDEX +1;
	'IF' INDEX>=BUFSIZ 'THEN'
		[CHOUT(0,BEL);
		TEXT(0,"COLUMN TOO BIG");
		CRLF(0);
		'EXIT'];
	'UNTIL' CHAR=EOL ! CHAR=EOF;
'END';	\LINEIN


'PROC' LINEOUT(X);
'INT' X;
'BEGIN'
'IF' BUFFER(X(0))=EOF 'THEN' 'RETURN';
'WHILE' BUFFER(X(0))#CR 'DO'
	'BEGIN'
	CHOUT(DEV,BUFFER(X(0)));
	X(0):=X(0)+1;
	'END';
X(0):=X(0)+2;		\SKIP CR & LF
'END';	\LINEOUT


'PROC' COLUMIZE(LINES);
'INT' LINES;
'INT' I,INX1,INX2;
'BEGIN'
INDEX:=0;
'FOR' I:=1,LINES 'DO' LINEIN;
INX2:=INDEX;
'FOR' I:=1,LINES 'DO' LINEIN;
INX1:=0;
'FOR' I:=1,LINES 'DO'
	'BEGIN'
	LINEOUT('ADDR'INX1);
	CHOUT(DEV,TAB);
	CHOUT(DEV,TAB);
	LINEOUT('ADDR'INX2);
	CRLF(DEV);
	'END';
CHOUT(DEV,FF);
'END';	\COLUMNIZE


'BEGIN'	\MAIN
BUFSIZ:=FREE-200;
BUFFER:=RESERVE(BUFSIZ);
TEXT(0,"-- COLUMNIZER VERSION 1.0 --
");
CHAR:=0;
OPENI(3); OPENO(DEV);
COLUMIZE(54-5);
'WHILE' CHAR#EOF 'DO' COLUMIZE(54);
CLOSE(DEV);
'END';	\MAIN
