\COMPRESS.XPLV5D		11/11/81
\ BY LOREN BLANEY.
\THIS PROGRAM FILTERS OUT THE BEGINNING LETTERS WHICH
\ DUPLICATE THOSE OF THE PREVIOUS LINE.  THIS PROGRAM IS
\ NORMALLY USED TO COMPRESS ALPHABETICAL LISTS OF WORDS.

code
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
CHIN=7, 	CHOUT=8,	CRLF=9,		INTIN=10,
INTOUT=11,	TEXT=12,	OPENI=13,	OPENO=14,
CLOSE=15;

def	TV=0, KB=0, PR=2, FILE=3, EOF=$1A, EOL=$A; \I/O STUFF
def	MAXLINE=256;	\MAXIMUM NO. OF CHARS IN A LINE

char	BUF1,BUF2;	\HOLDS TEXT LINES
int	CHAR,		\LAST CHARACTER FROM "GETLINE"
	COMMON;		\NUMBER OF FIRST LETTERS IN COMMON


proc	GETLINE(LINE);
\COPIES THE NEXT LINE FROM THE INPUT FILE INTO "LINE."
\OUTPUTS: CHAR.
char	LINE;
int	I;
begin
loop	begin
	for I:=0,MAXLINE-1 do
		[CHAR:=CHIN(FILE);
		LINE(I):=CHAR;
		if CHAR=EOL ! CHAR=EOF then return];
	repeat CHAR:=CHIN(FILE)		\SKIP THE REST OF THIS
	until CHAR=EOL ! CHAR=EOF;	\ LONG LINE
	quit;
	end;
end;	\GETLINE


proc	PUTLINE(COMMON,LINE);
\WRITES A LINE TO THE OUTPUT FILE, SKIPPING THE COMMON CHARS
int	COMMON;
char	LINE;
int	I,CH;
begin
\CHOUT(FILE,$30+COMMON);
loop for I:=COMMON,32767 do
	[CH:=LINE(I);
	CHOUT(FILE,CH);
	if CH=EOL ! CH=EOF then quit];
end;	\PUTLINE


funct	EQUAL(LINE1,LINE2);	\LINE COMPARE FUNCTION
\RETURNS THE NUMBER OF FIRST CHARACTERS WHICH ARE THE SAME.
char	LINE1,LINE2;
int	I;
begin
for I:=0,32767 do
	[if LINE1(I)#LINE2(I) then return I;
	if LINE1(I)=EOL then return I];		\DUPLICATE LINE
end;	\EQUAL


proc	COMPRESS;
\FILTERS OUT DUPLICATE ADJACENT FIRST CHARACTERS
begin
GETLINE(BUF1);
if CHAR=EOF then return;
COMMON:=0;
loop	begin
	PUTLINE(COMMON,BUF1);
	GETLINE(BUF2);
	if CHAR=EOF then return;
	COMMON:=EQUAL(BUF1,BUF2);
	PUTLINE(COMMON,BUF2);

	GETLINE(BUF1);
	if CHAR=EOF then return;
	COMMON:=EQUAL(BUF1,BUF2);
	end;
end;	\COMPRESS


begin	\MAIN
TEXT(TV,"COMPRESS   VER 1.0
");
BUF1:=RESERVE(MAXLINE); BUF2:=RESERVE(MAXLINE);
OPENI(FILE); OPENO(FILE);
COMPRESS;
CLOSE(FILE);
end;	\MAIN
