\COPY.XPL
\***COPY FOR APEX V1.0***

'CODE'
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
CHIN=7,		CHOUT=8,	CRLF=9,
INTIN=10,	INTOUT=11,	TEXT=12,	INITI=13,	INITO=14,
CLOSE=15,	FRUN=28,	FSAVE=29,	FWRITE=30,
FREAD=31,	FASAVE=27,	FGET=26,
SPACE=18,	RAN=1,		ABORT=16,
REBEGIN=6,	RERUN=19;

\THE DIRECTORY
'ADDRESS'
	TITLE,	\TITLE OF THE VOLUME
	RNAM,	\THE REMEMBERED FILE
	FNAME,	\THE FILE NAMES
	FSTAT,	\THE FILE STATUS
	FLAGS,	\FFS SPECIAL REQUEST FLAGS
	FREE1;	\UNUSED
\INTEGER ARRAYS IN THE DIRECTORY
'INTEGER'
	PMAXB,	\DISK SIZE, MAX BLOCK NUMBER
	DIRDAT,	\DIRECTORY DATE
	VOLUME,	\UNIQUE DISK ID NUMBER
	FDATE,	\DATE OF FILES
	FBLK,	\THE FIRST BLOCK
	LBLK;	\THE LAST BLOCK


\THE SYSTEM GLOBALS:
'ADDRESS'
	STAB,	\SORT POINTER ARRAY
	LOCNAM;	\LOCAL NAME OF FILE

'INTEGER'
	DONE,
	BLKSIZ,	\SIZE OF A BLOCK IN BYTES
	DIRSIZ,	\DIR SIZE
	SWAPSIZ,\SWAPPING SIZE
	DIRBLK,	\WHERE DIRECT IS
	SWAPBLK,\SWAPPING AREA
	SYSBLK,	\WHERE SYSTEM IS
	USERBLK,\FIRST USER BLOCK
	BACKBLK,\BLOCK TO PU BACKUP DIR IN
	SYSLEN,	\HOLDS LENGTH OF SYSTEM AREA ON DEVICE
	FIRBLK,	\FIRST BLOCK OF FILE
	LASBLK,	\LAST BLOCK OF FILE
	FLNO,	\NUMBER OF FILE
	DEVICE,	\HOLDS DEVICE NUMBER OF ACTIVE DEVICE
	MAXBLK,	\HIGHEST BLOCK
	MAXFL,	\HIGHEST FILE NO
	CHAR,	\INPUT CHARACTER
	ERR,	\ERR CODE IF NON ZERO
	SWAPFLG,\=0 IF SWAPPING AREA IS INVALID
	SWITCH,	\USER FILE SWITCH
	ARG1,	\USER ARGUMENT
	ARG2,	\USER ARGUMENT
	SPECIAL,\SPECIAL BITS IN PROGRAM FILE REQUEST
	SYSDAT,	\SYSTEM DATE
	INSIZE,	\SIZE OF LAST OPENED INFILE
	INDATE,	\DATE OF LAST INFILE
	MAXSTB;	\SIZE OF STAB ARRAY




\FOR MAIN
'INTEGER'FILE,TOBLK,FRBLK,SIZE,BUFSIZ,RDSIZ,I,L,
DRIVE,FRDRV,TODRV,NEXFL,MAXDRV;
'ADDRESS'BUFFER,MYNAME,OLDTRK;

\CONSTANTS

\FILE STATUS IN THE DIRECTORY
'DEFINE' NULL=0,TENTATIVE=255,REPLACE=254,VALID=1;

\FILE STATUS IN COMM AREA
'DEFINE' NOFILE=0,SETUP=1,CLOSED=255;

\SYSTEM REENTRY CONDITIONS
'DEFINE' SWAPIN=254,SAVEIN=255,BOOTIN=253;

\FAILED FLAG
'DEFINE' NONE=65535;

'DEFINE'DEFDEV=$5F;


	'PROCEDURE'NEXT;
	CHAR:=CHIN(0);



	'PROCEDURE'CR;
	CRLF(0);



	'PROCEDURE'STR(TXT);
	'ADDRESS'TXT;
	TEXT(0,TXT);



	'PROCEDURE'NUM(I);
	'INTEGER'I;
	INTOUT(0,I);



	'PROCEDURE'ALPH;

\CHECK FOR ALPHANUMERIC OR "?"
'EXIT'((CHAR>=^0)&(CHAR<=^9))!((CHAR>=^A)&(CHAR<=^Z))!(CHAR=^?);




	'PROCEDURE'NAME(DEFAULT);
'ADDRESS'DEFAULT;
'INTEGER'K;

'BEGIN'
\READ IN A FILE NAME. INTO LOCFILE. SET TO DEFAULT EXTENTION
\IF NONE WAS GIVEN.  EXPAND *'S INTO FIELDS OF ?'S.
\LEAVE CHAR SET THE TERMINATION CHARACTER - FILE OR NOT.
\LEAVE THE NAME FIELD SET TO BLANKS IF NO FILE.
\THERE IS NO FILE IF CHAR IS RETURN OR A NON ALPHA IS
\THE FIRST NON-BLANK SEEN.  ALSO SET SWITCHES IF ANY.

'IF'CHAR#13\CR\'THEN'NEXT;
'WHILE'CHAR=^ 'DO'NEXT;
K:=0;
'IF'CHAR#^*'THEN'
	'BEGIN'
	'WHILE'ALPH'DO'
		'BEGIN'
		LOCNAM(K):=CHAR;
		'IF'K<8'THEN'K:=K+1;
		NEXT;
		'END';
	'FOR'K:=K,7'DO'LOCNAM(K):=^ ;
	'END'
'ELSE'['FOR'K:=0,7'DO'LOCNAM(K):=^?;NEXT];

K:=8;
'IF'CHAR=^.'THEN'
	'BEGIN'
	NEXT;
	'IF'CHAR#^*'THEN'
		'BEGIN'
		'WHILE'ALPH'DO'
			'BEGIN'
			LOCNAM(K):=CHAR;
			'IF'K<11'THEN'K:=K+1;
			NEXT;
			'END';
		'FOR'K:=K,10'DO'LOCNAM(K):=^ ;
		'END'
	'ELSE'['FOR'K:=8,10'DO'LOCNAM(K):=^?;NEXT];
	'END'
'ELSE''BEGIN'
	LOCNAM(8):=DEFAULT(0);
	LOCNAM(9):=DEFAULT(1);
	LOCNAM(10):=DEFAULT(2)&127;
	K:=11;
	'END';
ARG1:=NONE;
ARG2:=NONE;
'END';\NAME






	'PROCEDURE'ERROR(N);
	'ADDRESS'N;

'BEGIN'
CR;STR("COPY ERROR: ");STR(N);
CR;
REBEGIN;
'END';




	'PROCEDURE'WRTDIR;

'BEGIN'
FWRITE(DRIVE,DIRBLK,FNAME,DIRSIZ);
'END';



	'PROCEDURE'LOOKUP(FILE);
	'INTEGER'FILE,L;

'BEGIN'
\LOOKUP THE FILENAME IN LOCFILE BEGINNING AT
\DIRECTORY ENTRY NUMBER FILE.
\TAKE ? AS WILD
'LOOP'	'BEGIN'
	'IF'FSTAT(FILE)=VALID'THEN'
		'BEGIN'
		L:=0;
		'LOOP'
			'BEGIN'
			'IF'(LOCNAM(L)#^?)&(FNAME(FILE*11+L)#LOCNAM(L))
			'THEN''QUIT';
			L:=L+1;
			'IF'L=11'THEN''QUIT';
			'END';
		'IF'L=11'THEN''QUIT'\WE HAVE IT\;
		'END';
	FILE:=FILE+1;
	'IF'FILE>MAXFL'THEN''QUIT';
	'END';
'EXIT''IF'FILE<=MAXFL'THEN'FILE'ELSE'NONE;
'END';\LOOKUP


	'PROCEDURE'PRINT(FILE);
	'INTEGER'FILE,MIN,MAX,K,SIZE;

'BEGIN'
NUM(DRIVE);
CHOUT(0,^:);
'FOR'K:=0,7'DO'CHOUT(0,FNAME(FILE*11+K));
CHOUT(0,^.);
'FOR'K:=8,10'DO'CHOUT(0,FNAME(FILE*11+K));
MIN:=FBLK(FILE);
MAX:=LBLK(FILE);
SIZE:=MAX-MIN+1;
STR("  ");NUM(SIZE);
'IF'SIZE<10'THEN'CHOUT(0,^ );
'IF'SIZE<100'THEN'CHOUT(0,^ );
CHOUT(0,^ );
NUM(MIN);
CHOUT(0,^-);NUM(MAX);
'END';

	'PROCEDURE'RDDIR;

'BEGIN'
FREAD(DRIVE,DIRBLK,FNAME,DIRSIZ);
MAXBLK:=PMAXB(0);
'END';


	'PROCEDURE'CLEAR(FILE);
	'INTEGER'FILE,MIN,MAX,I;

'BEGIN'
\REMOVE A ENTRY FROM THE DIRECTORY, FREE UP ITS BLOCKS
'IF'FSTAT(FILE)#VALID'THEN''EXIT';
FSTAT(FILE):=NULL;
MIN:=FBLK(FILE);
MAX:=LBLK(FILE);
STR("REMOVING ");PRINT(FILE);
CR;
'END';



	'PROCEDURE'REMOVE;
	'INTEGER'FILENO;
'BEGIN'
\REMOVE ANY COLLISIONS WITH LOCFILE
FILENO:=LOOKUP(0);
'IF'FILENO#NONE'THEN'CLEAR(FILENO);
'END';

	'PROCEDURE'GETNAM(FILE);
	'INTEGER'FILE,I;

'FOR'I:=0,10'DO'LOCNAM(I):=FNAME(FILE*11+I);


	'PROCEDURE'EMSIZ(I);
	'INTEGER'I;
'BEGIN'
FIRBLK:='IF'I<0'THEN'USERBLK'ELSE'(LBLK(STAB(I))+1);
LASBLK:='IF'(MAXSTB<0)!(MAXSTB=I)'THEN'MAXBLK'ELSE'
	(FBLK(STAB(I+1))-1);
'EXIT''IF'LASBLK>=FIRBLK'THEN'LASBLK-FIRBLK+1'ELSE'0;
'END';

	'PROCEDURE'SORT;
	'INTEGER'I,J,T;

'BEGIN'\BUBBLE SORT THE FILES INTO ACENDING FBLK
J:=0;
'FOR'I:=0,MAXFL'DO'
	'IF' FSTAT(I)=VALID'THEN'
		[STAB(J):=I;J:=J+1];
MAXSTB:=J-1;
'FOR'I:=0,MAXSTB-1'DO'
'IF'FBLK(STAB(I+1))<FBLK(STAB(I))'THEN'
	\WE ARE OUT OF ORDER SO...
	'BEGIN'
	J:=I;
	'REPEAT''BEGIN'
		T:=STAB(J);
		STAB(J):=STAB(J+1);
		STAB(J+1):=T;
		J:=J-1;
		'END'
	'UNTIL'(FBLK(STAB(J))<FBLK(STAB(J+1)))!(J<0);
	'END';
'END';

	'PROCEDURE'FIND(SIZE);
	'INTEGER'SIZE,I;

'BEGIN'
\FIND FIXED SIZE SPACE, SET FIRST AND LAST BLOCK TO IT
'IF'SIZE<=0'THEN'ERROR("BAD FILE");
SORT;
I:=-1;
'WHILE'EMSIZ(I)<SIZE & I<=MAXSTB'DO'I:=I+1;
'IF'I>MAXSTB'THEN'ERROR("NOT ENOUGH SPACE");
LASBLK:=FIRBLK+SIZE-1;
'END';

	'PROCEDURE'ENTER;
	'INTEGER'K;

'BEGIN'
\ENTER A TENTATIVE FILE AND ITS BLOCKS INTO THE DIRECTORY
\DONT RESERVE THE BLOCKS, DONT MARK IT VALID

'FOR'K:=0,10'DO'
	'IF'LOCNAM(K)=^?'THEN'ERROR("BAD FILE");
\FIND AN EMPTY DIR SLOT
FLNO:=0;
'WHILE'FSTAT(FLNO)=VALID'DO'
	'BEGIN'
	FLNO:=FLNO+1;
	'IF'FLNO>MAXFL'THEN'ERROR("DIRECTORY IS FULL");
	'END';
\NOW COPY THE NAME INTO IT
'FOR'K:=0,10'DO'FNAME(FLNO*11+K):=LOCNAM(K);
FBLK(FLNO):=FIRBLK;
LBLK(FLNO):=LASBLK;
FSTAT(FLNO):=REPLACE;
FDATE(FLNO):=INDATE;
'END';


	'PROCEDURE'CLOMARK(FILE);
	'INTEGER'FILE;

'BEGIN'
FSTAT(FILE):=VALID;
FIRBLK:=FBLK(FILE);
LASBLK:=LBLK(FILE);
STR("CLOSING: ");PRINT(FILE);
CR;
'END';


	'PROCEDURE'CLOFIL(FILE);
	'INTEGER'FILE,S;

'BEGIN'
\CLOSE THE TENTATIVE FILE BY DIRECTORY NUMBER
\ASSUME IT HAS BEEN ENTERED
\REMOVE COLLISIONS
S:=FSTAT(FILE);
'IF'(S#TENTATIVE)&(S#REPLACE)'THEN'ERROR("INTERNAL ERROR");
GETNAM(FILE);
REMOVE;
CLOMARK(FILE);
'END';

	'PROCEDURE'READBUF;

'BEGIN'
RDSIZ:='IF'SIZE>BUFSIZ'THEN'BUFSIZ'ELSE'SIZE;
FREAD(DRIVE,FRBLK,BUFFER,RDSIZ);
'END';


	'PROCEDURE'WRTBUF;
'BEGIN'
FWRITE(DRIVE,TOBLK,BUFFER,RDSIZ);
FRBLK:=FRBLK+RDSIZ;
TOBLK:=TOBLK+RDSIZ;
SIZE:=SIZE-RDSIZ;
'END';

'BEGIN'\MAIN PROC\
BLKSIZ:=256;			\SIZE OF A BLOCK IN BYTES
DIRBLK:=9;		\LOCATION OF DIRECTORY BLOCK
DIRSIZ:=4;			\SIZE OF DIRECTORY IN "BLKSIZ" BLOCKS
BACKBLK:=DIRBLK+DIRSIZ;		\LOCATION OF BACKUP DIRECTORY
USERBLK:=BACKBLK+DIRSIZ;	\START OF USER FILE SPACE
MAXFL:=47;	\SELECT SO THAT DIRSIZ IS RIGHT


\RESERVE THE ARRAYS
I:=(MAXFL+1)*2;
\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(I);
LBLK:=RESERVE(I);
\BLOCK 3
FREE1:=RESERVE(75);
PMAXB:=RESERVE(2);
RNAM:=RESERVE(11);
TITLE:=RESERVE(60);
VOLUME:=RESERVE(2);
DIRDAT:=RESERVE(2);
FDATE:=RESERVE(I);
FLAGS:=RESERVE(8);

\NON DIR ARRAYS
LOCNAM:=RESERVE(11);
STAB:=RESERVE(48);
MYNAME:=RESERVE(11);
MAXDRV:=7;
CR;STR("COPY FOR APEX V1.0");
BUFSIZ:=SPACE/256-4;
'IF'BUFSIZ<=0'THEN'BUFSIZ:=127;
BUFFER:=RESERVE(BUFSIZ*256);


'LOOP'
'BEGIN'\MAIN LOOP
SPECIAL:=0;
NEXFL:=0;
INSIZE:=0;
CR;
STR("FILE:");
CHAR:=0;
INITI(0);
NAME("@@@");
'IF'LOCNAM(0)=^ 'THEN''QUIT';
'FOR'I:=0,10'DO'MYNAME(I):=LOCNAM(I);
CR;


STR("FROM,TO UNITS?");
INITI(0);
FRDRV:=INTIN(0);
TODRV:=INTIN(0);
CR;
'IF'FRDRV<0 ! FRDRV>MAXDRV 'THEN' ERROR("BAD UNIT NUMBER");
'IF'TODRV<0 ! TODRV>MAXDRV 'THEN' ERROR("BAD UNIT NUMBER");


'LOOP'\OVER ALL FILES THAT MATCH
	'BEGIN'
	DRIVE:=FRDRV;
	RDDIR;
	'FOR'I:=0,10'DO'LOCNAM(I):=MYNAME(I);
	FILE:=LOOKUP(NEXFL);
	'IF'FILE=NONE'THEN'
		'BEGIN'
		'IF'NEXFL=0'THEN'ERROR("NO SUCH FILE");
		'QUIT';
		'END';
	NEXFL:=FILE+1;
	'FOR'I:=0,10'DO'LOCNAM(I):=FNAME(FILE*11+I);
	CR;STR("MOVING   ");PRINT(FILE);CR;
	FRBLK:=FBLK(FILE);		\ITS FIRST BLOCK
	SIZE:=LBLK(FILE)-FRBLK+1;	\ITS SIZE
	INDATE:=FDATE(FILE);		\ITS DATE
	READBUF;
	DRIVE:=TODRV;
	RDDIR;
	FIND(SIZE);
	ENTER;
	TOBLK:=FIRBLK;
	WRTBUF;
	'WHILE'SIZE>0'DO'
		'BEGIN'
		DRIVE:=FRDRV;
		READBUF;
		DRIVE:=TODRV;
		WRTBUF;
		'END';
	CLOFIL(FLNO);
	WRTDIR;		
	'END';\OF FILE LOOP
'END';\MAIN LOOP
'END';\OF ALL

