\CURTEST.XPL
\GRAPH THEMISTER CURVES


'CODE'	\COMPLETE SET, STANDARD XPLV5D INTRINSICS

ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENIN=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;

'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;


'DEF'
	FF=$0C;



'INTEGER' ODEV,X,LOGFLAG;


'REAL'
	LOW,
	CURVE,
	RES0,
	RES25,
	RES50,
	RATIO,
	TEMP,
	BETA,
	FACT,
	RES;



'PROCEDURE' OPENFIN;
'CODE' OPENF=29,INTIN=10,ERRFLG=22,
OPENIN=13,CHIN=7,TEXT=12,CRLF=9,
TRAP=17,RESERVE=3,SCAN=24;
'INTEGER' BLOCK,LUNIT;
'ADDRESS' FNAME;
'DEFINE' RETURN=$0D;


'PROCEDURE' GETNAME(NAME);
'ADDRESS' NAME;
'INTEGER' X,Y,CHAR;

'PROCEDURE' FIRST;
'BEGIN'
OPENIN(0);
X:=0;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(0);
	'IF' CHAR=^. 'THEN' 'QUIT';
	NAME(X):=CHAR;
	X:=X+1;
	'IF' X>8 ! CHAR=RETURN 'THEN'
		'BEGIN'
		TEXT(0,"BAD FILE NAME");
		CRLF(0);
		TEXT(0,"TRY AGAIN");
		CRLF(0);
		'QUIT';
		'END';
	'END';
'END';	\END FIRST

'BEGIN'	\START OF GETNAME
'REPEAT' FIRST 'UNTIL' CHAR=^.;
'FOR' Y:=X,7 'DO' NAME(Y):=$20;
X:=8;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(0);
	'IF' CHAR=RETURN 'THEN' 'QUIT';
	NAME(X):=CHAR;
	X:=X+1;
	'IF' X>10 'THEN' 'QUIT';
	'END';
'FOR' Y:=X,10 'DO' NAME(Y):=$20;
'END';	\END OF GETNAME



'BEGIN'	\OPENFILE
FNAME:=RESERVE(25);
BLOCK:=RESERVE(4);
TEXT(0,"*** INPUT FILE SPECIFICATIONS ***");
CRLF(0);
TEXT(0,"ENTER UNIT NUMBER ");
LUNIT:=INTIN(0);
TEXT(0,"ENTER FILE NAME ");
GETNAME(FNAME);
TRAP('FALSE');
SCAN(LUNIT,BLOCK,FNAME);
TRAP('TRUE');
'IF' ERRFLG 'THEN'
	'BEGIN'
	TEXT(0,"FILE NOT FOUND");
	CRLF(0);
	OPENFILE;
	'END';
OPENF(LUNIT,BLOCK);
'END';

'PROCEDURE' VALUES;
'BEGIN'
TEXT(0,"BETA? ");
BETA:=RLIN(0);
TEXT(0,"RESISTANCE AT 25 C ");
RES25:=RLIN(0);
\TEXT(0,"FACTOR? ");
\FACT:=RLIN(0);
'END';



'PROCEDURE' 'REAL' PWR(N,E);
'REAL' N,E;
'RETURN' EXP(E* LN(N));



'FUNCTION' 'REAL' FINDRES(TEMP);
'REAL' TEMP;
'DEF' E=2.7182818;
'BEGIN'
'RETURN'
RES25/EXP(BETA*(1./298.15-1./TEMP));
'END';



'PROCEDURE' VSCALE(N);
'REAL' N,SCALE,LL;
'BEGIN'
LL:=LOG(LOW);
SCALE:=191./(6.-LL);
'RETURN'
'IF' LOGFLAG 'THEN' 192-FIX((LOG(N)-LL)*SCALE)
'ELSE' 192-FIX(N*.000192);
'END';



'PROCEDURE' TCURVE;
'INTEGER' X;
'BEGIN'
SETTXT;
VALUES;
SETHI;
MOVE(0,VSCALE(FINDRES(273.15-40.)));
'FOR' X:=-40,99 'DO'
	'BEGIN'
	LINE((X+40)*2,VSCALE(FINDRES(FLOAT(X)+273.15)),$80);
	'END';
'END';



'PROCEDURE' GRAPHBASE;
'INTEGER' X;
'BEGIN'
MOVE(0,VSCALE(CURVE(0)));
'FOR' X:=0,139 'DO'
	'BEGIN'
	LINE(X*2,VSCALE(CURVE(X)),$80);
	'END';
'END';



'PROCEDURE' GRAPH;
'BEGIN'
TEXT(0,"LOG SCALE? ");
OPENIN(0);
LOGFLAL:='IF' CHIN(0)=^Y 'THEN' 'TRUE' 'ELSE' 'FALSE';
SETHI;
CLEAR;
GRAPHBASE;
'LOOP'
	'BEGIN'
	SETTXT;
	CHOUT(0,FF);
	TEXT(0,"CLEAR? ");
	OPENIN(0);
	'IF' CHIN(0)=^Y 'THEN'
		'BEGIN'
		SETHI;
		CLEAR;
		GRAPHBASE;
		'END';
	TCURVE;
	OPENIN(0);
	X:=CHIN(0);
	SETTXT;
	CHOUT(0,FF);
	TEXT(0,"MORE? ");
	OPENIN(0);
	'IF' CHIN(0)=^N 'THEN' 'QUIT';
	'END';
'END';



'PROCEDURE' COMPARE;
'INTEGER' X;
'REAL' DELTA,CHART,CAL;
'BEGIN'
VALUES;
'FOR' X:=-40,99 'DO'
	'BEGIN'
	FORMAT(3,0);
	RLOUT(0,FLOAT(X));
	FORMAT(8,0);
	CHART:=CURVE(X+40);
	RLOUT(0,CHART);
	CAL:=FINDRES(FLOAT(X)+273.15);
	RLOUT(0,CAL);
	DELTA:=CAL-CHART;
	FORMAT(8,2);
	RLOUT(0,DELTA);
	FORMAT(2,4);
	RLOUT(0,DELTA/CHART);
	CRLF(0);
	'END';
'END';



'PROCEDURE' VOLTAGE;
'REAL' DIVRES,VLTOUT,VLTIN,VLTOLD,DELTA;
'INTEGER' X;
'BEGIN'
TEXT(0,"VOLTAGE IN? ");
VLTIN:=RLIN(0);
TEXT(0,"DIVIDER RESISTOR? ");
DIVRES:=RLIN(0);
'FOR' X:=-40,99 'DO'
	'BEGIN'
	VLTOLD:=VLTOUT;
	RES:=CURVE(X+40);
	VLTOUT:=VLTIN-((RES/(RES+DIVRES))*VLTIN);
	INTOUT(ODEV,X);
	FORMAT(4,0);
	RLOUT(ODEV,FLOAT(X)*1.8+32.);
	FORMAT(7,0);
	RLOUT(ODEV,RES);
	FORMAT(4,3);
	RLOUT(ODEV,VLTOUT);
	FORMAT(3,4);
	DELTA:=VLTOUT-VLTOLD;
	RLOUT(ODEV,DELTA);
	FORMAT(3,2);
	RLOUT(ODEV,(5./256.)/(DELTA/1.8));
	CRLF(ODEV);
	'END';
'END';


'PROCEDURE' ADCERR;
'BEGIN'
TEXT(0,"OUTPUT DEVICE");
ODEV:=INTIN(0);
OPENO(ODEV);
'REPEAT'
	'BEGIN'
	VOLTAGE;
	TEXT(0,"MORE? ");
	OPENIN(0);
	'END'
'UNTIL' CHIN(0)=^N;
CHOUT(ODEV,$1A);
CLOSE(ODEV);
'END';



'PROCEDURE' MENU;
'INTEGER' STATUS,COMMAND;
'BEGIN'
STATUS:='FALSE';
CHOUT(0,FF);
TEXT(0,"***** THERMISTOR CURVES ******");CRLF(0);
CRLF(0);
TEXT(0,"0) QUIT");CRLF(0);
TEXT(0,"1) GRAPH CURVES");CRLF(0);
TEXT(0,"2) COMPARE CURVES");CRLF(0);
TEXT(0,"3) PRINT ADC ERRORS");CRLF(0);
CRLF(0);
TEXT(0,"SELECT ONE: ");
OPENIN(0);
COMMAND:=INTIN(0);
'CASE' COMMAND 'OF'
	1: GRAPH;
	2: COMPARE;
	3: ADCERR;
	0: STATUS:='TRUE'
'ELSE';
'RETURN' STATUS;
'END';


'BEGIN'	\MAIN
CURVE:=RLRES(141);
OPENFIN;
OPENIN(3);
'FOR' X:=0,140 'DO' CURVE(X):=RLIN(3);
LOW:=CURVE(139);


'REPEAT' 'UNTIL' MENU;
'END';
