\DEMON.XPL	JUL-04-92
\By Loren Blaney
\A celluar universe of debris, droplets, defects, and demons as described
\ in Scientific American's "Computer Recreations", August 1989.

include	\CXPL\CODESI;
ext	GEN, RANDOM;

def	WIDTH= 320, HEIGHT= 180;	\Dimensions of celluar universe
def	DEPTH= 16;
def	BEL= $07, ESC= $1B, SP= $20;

addr	OLD;		\Array: holds next generation patterns
int	DATASEG,
	CPUREG,
	UNISIZE,
	;



proc	SETUP;		\Set up and display the initial pattern
int	I, J, IJ;
begin
IJ:= 0;
for J:= 0, HEIGHT-1 do
    for I:= 0, WIDTH-1 do
	begin
	POINT(I, J, RANDOM(DEPTH));
	IJ:= IJ +1;
	end;
BLIT($A000, 0, DATASEG, OLD, UNISIZE);
end;	\SETUP



begin	\MAIN
CPUREG:= GETREG;
DATASEG:= CPUREG(12);

UNISIZE:= WIDTH *HEIGHT;	\Size of celluar universe in bytes

\OLD -WIDTH MUST BE ON A PARAGRAPH BOUNDARY BECAUSE OF GEN ROUTINE
OLD:= RESERVE(UNISIZE +2*WIDTH +$F);
OLD:= OLD +$F & $FFF0;
OLD:= OLD +WIDTH;

SETVID($13);
CURSOR(0, 24);
TEXT(0, "DEMON:    ESC = EXIT    SPACE = RESTART");

SETUP;
loop	begin
	GEN(DATASEG+(OLD-WIDTH)>>4, UNISIZE);
	\OLD - WIDTH = SEGMENT ADDRESS

	BLIT($A000, 0, DATASEG, OLD, UNISIZE);
	BLIT(DATASEG, OLD, DATASEG, OLD+UNISIZE, WIDTH);
	BLIT(DATASEG, OLD+UNISIZE-WIDTH, DATASEG, OLD-WIDTH, WIDTH);

	if CHKKEY then
		case CHIN(1) of
		  ESC:	quit;
		  SP:	SETUP
		other	CHOUT(0, BEL);
	end;
SETVID(3);
end;	\MAIN
