\EXCHV20.XPL
\EXCH V2.0 FOR FFS V2.0

'CODE'
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
CHIN=7,		CHOUT=8,	CRLF=9,		INTIN=10,
INTOUT=11,	TEXT=12,	INITI=13,	INITO=14,
CLOSE=15,	FRUN=28,	FSAVE=29,	FWRITE=30,
FREAD=31,	FASAVE=27,	FGET=26,	RESTORE=32,
ABORT=16,	SPACE=18;


\THE DIRECTORY
'ADDRESS'
	TITLE,	\TITLE OF THE VOLUME
	RNAM,	\THE REMEMBERED FILE
	FNAME,	\THE FILE NAMES
	FSTAT,	\THE FILE STATUS
	BLKUSE,	\BLOCK BIT MAP
	UNUSED;	\FREE DIRECTORY SPACE
\INTEGER ARRAYS IN THE DIRECTORY
'INTEGER'
	DIRDAT,	\DIRECTORY DATE
	FDATE,	\DATE OF FILES
	FBLK,	\THE FIRST BLOCK
	LBLK;	\THE LAST BLOCK

\SOME ABSOLUTE ADDRES
'ADDRESS'
	COMPAG,PARM,IOPAG,PG0;

\THE SYSTEM GLOBALS:
'ADDRESS'
	STAB,	\FOR SORT
	LOCNAM;	\LOCAL NAME OF FILE

'INTEGER'
	DIRSIZ,	\DIR SIZE
	SWAPSIZ,\SWAPPING SIZE
	DIRBLK,	\WHERE DIRECT IS
	SWAPBLK,\SWAPPING AREA
	SYSBLK,	\WHERE SYSTEM IS
	USERBLK,\FIRST USER BLOCK
	BACKBLK,\BLOCK TO PU BACKUP DIR IN
	FIRBLK,	\FIRST BLOCK OF FILE
	LASBLK,	\LAST BLOCK OF FILE
	FLNO,	\NUMBER OF FILE
	MAXBLK,	\HIGHEST BLOCK
	MAXFL,	\HIGHEST FILE NO
	CHAR,	\INPUT CHARACTER
	SWAPFLG,\=0 IF SWAPPING AREA IS INVALID
	SWITCH,	\USER FILE SWITCH
	ARG1,	\USER ARGUMENT
	ARG2,	\USER ARGUMENT
	SPECIAL,\SPECIAL BITS IN PROGRAM FILE REQUEST
	SYSDAT,	\SYSTEM DATE
	INSIZE,	\SIZE OF LAST OPENED INFILE
	INDATE,	\DATE OF LAST INFILE
	MAXSTB,	\SIZE OF STAB
	AMOUNT,	\AMOUNT MOVED
	FILENO;	\RUN FILE NUMBER

\FOR MAIN
'INTEGER'FILE,TOBLK,FRBLK,SIZE,BUFSIZ,RDSIZ,I,L;
'ADDRESS'BUFFER;

\CONSTANTS

\FILE STATUS IN THE DIRECTORY
'DEFINE' NULL=0,TENTATIVE=255,REPLACE=254,VALID=1;

\FILE STATUS IN COMM AREA
'DEFINE' NOFILE=0,SETUP=1,CLOSED=255;

\SYSTEM REENTRY CONDITIONS
'DEFINE' SWAPIN=254,SAVEIN=255,BOOTIN=253;

\FAILED FLAG
'DEFINE' NONE=65535;



	'PROCEDURE'VERIFY;

'BEGIN'
CRLF(0);
TEXT(0,"VERIFY? ");
INITI(0);
'EXIT'CHIN(0)=^Y;
'END';

	'PROCEDURE'SETDISK(I);
	'INTEGER'I;

'BEGIN'
RESTORE;
'IF'I=0'THEN'TEXT(0,"RESTORE ORIGINAL DISK")
'ELSE'TEXT(0,"INSERT COPY DISK");
'WHILE' (IOPAG(0)&128)=0 'DO';
'WHILE' (IOPAG(0)&128)#0 'DO';
'WHILE''NOT'VERIFY'DO';
'END';

	'PROCEDURE'PARENT;
'BEGIN'
TEXT(0,"INSERT FFS DISK");
'WHILE''NOT'VERIFY'DO';
'END';


	'PROCEDURE'ERROR(N);
	'INTEGER'N;

'BEGIN'
TEXT(0,"EXCHANGE ERROR #");INTOUT(0,N);
CRLF(0);
PARENT;
ABORT;
'END';


	'PROCEDURE'PRDAT(DAT);
	'INTEGER'DAT,DAY,MO;

'BEGIN'
'IF'DAT<=0'THEN'[TEXT(0,"NO DATE");'EXIT'];
DAT:=DAT/32;DAY:=REM(0);
DAT:=DAT/16;MO:=REM(0);
INTOUT(0,MO);CHOUT(0,^/);
INTOUT(0,DAY);CHOUT(0,^/);
INTOUT(0,DAT+76);
'END';


	'PROCEDURE'WRTDIR;

'BEGIN'
FWRITE(DIRBLK,FNAME,DIRSIZ);
'END';



	'PROCEDURE'LOOKUP(FILE);
	'INTEGER'FILE,L;

'BEGIN'
\LOOKUP THE FILENAME IN LOCFILE BEGINNING AT
\DIRECTORY ENTRY NUMBER FILE.
\TAKE ? AS WILD
'LOOP'	'BEGIN'
	'IF'FSTAT(FILE)=VALID'THEN'
		'BEGIN'
		L:=0;
		'LOOP'
			'BEGIN'
			'IF'(LOCNAM(L)#^?)&(FNAME(FILE*11+L)#LOCNAM(L))
			'THEN''QUIT';
			L:=L+1;
			'IF'L=11'THEN''QUIT';
			'END';
		'IF'L=11'THEN''QUIT'\WE HAVE IT\;
		'END';
	FILE:=FILE+1;
	'IF'FILE>MAXFL'THEN''QUIT';
	'END';
'EXIT''IF'FILE<=MAXFL'THEN'FILE'ELSE'NONE;
'END';\LOOKUP


	'PROCEDURE'PRINT(FILE);
	'INTEGER'FILE,MIN,MAX,K,SIZE;

'BEGIN'
'FOR'K:=0,7'DO'CHOUT(0,FNAME(FILE*11+K));
CHOUT(0,^.);
'FOR'K:=8,10'DO'CHOUT(0,FNAME(FILE*11+K));
MIN:=FBLK(FILE);
MAX:=LBLK(FILE);
SIZE:=MAX-MIN+1;
TEXT(0,"  ");INTOUT(0,SIZE);
'IF'SIZE<10'THEN'CHOUT(0,^ );
'IF'SIZE<100'THEN'CHOUT(0,^ );
CHOUT(0,^ );
INTOUT(0,MIN);
CHOUT(0,^-);INTOUT(0,MAX);
'END';

	'PROCEDURE'RDDIR;

'BEGIN'
FREAD(DIRBLK,FNAME,DIRSIZ);
'END';

	'PROCEDURE'CLEAR(FILE);
	'INTEGER'FILE,MIN,MAX,I;

'BEGIN'
\REMOVE A ENTRY FROM THE DIRECTORY, FREE UP ITS BLOCKS
'IF'FSTAT(FILE)#VALID'THEN''EXIT';
FSTAT(FILE):=NULL;
MIN:=FBLK(FILE);
MAX:=LBLK(FILE);
TEXT(0,"REMOVING ");PRINT(FILE);
CRLF(0);
'END';



	'PROCEDURE'REMOVE;
	'INTEGER'FILENO;
'BEGIN'
\REMOVE ANY COLLISIONS WITH LOCFILE
FILENO:=LOOKUP(0);
'IF'FILENO#NONE'THEN'CLEAR(FILENO);
'END';

	'PROCEDURE'GETNAM(FILE);
	'INTEGER'FILE,I;

'FOR'I:=0,10'DO'LOCNAM(I):=FNAME(FILE*11+I);


	'PROCEDURE'EMSIZ(I);
	'INTEGER'I;
'BEGIN'
FIRBLK:='IF'I<0'THEN'USERBLK'ELSE'(LBLK(STAB(I))+1);
LASBLK:='IF'(MAXSTB<0)!(MAXSTB=I)'THEN'MAXBLK'ELSE'
	(FBLK(STAB(I+1))-1);
'EXIT''IF'LASBLK>=FIRBLK'THEN'LASBLK-FIRBLK+1'ELSE'0;
'END';

	'PROCEDURE'SORT;
	'INTEGER'I,J,T;

'BEGIN'\BUBBLE SORT THE FILES INTO ACENDING FBLK
J:=0;
'FOR'I:=0,MAXFL'DO'
	'IF' FSTAT(I)=VALID'THEN'
		[STAB(J):=I;J:=J+1];
MAXSTB:=J-1;
'FOR'I:=0,MAXSTB-1'DO'
'IF'FBLK(STAB(I+1))<FBLK(STAB(I))'THEN'
	\WE ARE OUT OF ORDER SO...
	'BEGIN'
	J:=I;
	'REPEAT''BEGIN'
		T:=STAB(J);
		STAB(J):=STAB(J+1);
		STAB(J+1):=T;
		J:=J-1;
		'END'
	'UNTIL'(FBLK(STAB(J))<FBLK(STAB(J+1)))!(J<0);
	'END';
'END';

	'PROCEDURE'FIND(SIZE);
	'INTEGER'SIZE,I;

'BEGIN'
\FIND FIXED SIZE SPACE, SET FIRST AND LAST BLOCK TO IT
'IF'SIZE<=0'THEN'ERROR(5);
SORT;
I:=-1;
'WHILE'EMSIZ(I)<SIZE & I<=MAXSTB'DO'I:=I+1;
'IF'I>MAXSTB'THEN'ERROR(1);
LASBLK:=FIRBLK+SIZE-1;
'END';

	'PROCEDURE'ENTER;
	'INTEGER'K;

'BEGIN'
\ENTER A TENTATIVE FILE AND ITS BLOCKS INTO THE DIRECTORY
\DONT RESERVE THE BLOCKS, DONT MARK IT VALID

'IF'(LOCNAM(8)=^B)&(LOCNAM(9)=^A)&(LOCNAM(10)=^K)
'THEN'ERROR(3);
'FOR'K:=0,10'DO'
	'IF'LOCNAM(K)=^?'THEN'ERROR(4);
\FIND AN EMPTY DIR SLOT
FLNO:=0;
'WHILE'FSTAT(FLNO)=VALID'DO'
	'BEGIN'
	FLNO:=FLNO+1;
	'IF'FLNO>MAXFL'THEN'ERROR(5);
	'END';
\NOW COPY THE NAME INTO IT
'FOR'K:=0,10'DO'FNAME(FLNO*11+K):=LOCNAM(K);
FBLK(FLNO):=FIRBLK;
LBLK(FLNO):=LASBLK;
FSTAT(FLNO):=REPLACE;
FDATE(FLNO):=INDATE;
'END';


	'PROCEDURE'CLOMARK(FILE);
	'INTEGER'FILE;

'BEGIN'
FSTAT(FILE):=VALID;
FIRBLK:=FBLK(FILE);
LASBLK:=LBLK(FILE);
TEXT(0,"CLOSING: ");PRINT(FILE);
CRLF(0);
'END';


	'PROCEDURE'CLOFIL(FILE);
	'INTEGER'FILE,S;

'BEGIN'
\CLOSE THE TENTATIVE FILE BY DIRECTORY NUMBER
\ASSUME IT HAS BEEN ENTERED
\REMOVE COLLISIONS
S:=FSTAT(FILE);
'IF'(S#TENTATIVE)&(S#REPLACE)'THEN'ERROR(6);
GETNAM(FILE);
REMOVE;
CLOMARK(FILE);
'END';

	'PROCEDURE'READBUF;

'BEGIN'
RDSIZ:='IF'SIZE>BUFSIZ'THEN'BUFSIZ'ELSE'SIZE;
FREAD(FRBLK,BUFFER,RDSIZ);
TEXT(0,"BLOCKS MOVED: ");
AMOUNT:=AMOUNT+BUFSIZ;
INTOUT(0,AMOUNT);CRLF(0);
'END';


	'PROCEDURE'WRTBUF;
'BEGIN'
FWRITE(TOBLK,BUFFER,RDSIZ);
FRBLK:=FRBLK+RDSIZ;
TOBLK:=TOBLK+RDSIZ;
SIZE:=SIZE-RDSIZ;
'END';

'BEGIN'\MAIN PROC\

MAXBLK:=1000;
SWAPSIZ:=56;
DIRBLK:=0;
DIRSIZ:=5;
SWAPBLK:=13;
USERBLK:=130;
SYSBLK:=SWAPBLK+SWAPSIZ;
BACKBLK:=125;

MAXFL:=47;	\SELECT SO THAT DIRSIZ IS RIGHT

\SETUP ABSOLUTE ADDRES
PARM:=$B000;	\RESIDENT HANDER COMM AREA
COMPAG:=$FFC0;	\SYSTEM COMM AREA
PG0:=$0;
IOPAG:=$F000;	\DISK I-O

\RESERVE THE ARRAYS
I:=(MAXFL+1)*2;
\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(I);
LBLK:=RESERVE(I);
\BLOCK 3
BLKUSE:=RESERVE(181);
RNAM:=RESERVE(11);
TITLE:=RESERVE(62);
DIRDAT:=RESERVE(2);
\BLOCK 4
FDATE:=RESERVE(I);
UNUSED:=RESERVE(256-I);
\NON DIR ARRAYS
LOCNAM:=RESERVE(11);
STAB:=RESERVE(48);
AMOUNT:=0;

CRLF(0);TEXT(0,"EXCHANGE V2.0");CRLF(0);
SPECIAL:=0;
INSIZE:=0;
'IF'PARM(10)#SETUP'THEN'ERROR(7);

BUFSIZ:=SPACE/256-4;
'IF'BUFSIZ<=0'THEN'ERROR(8);
BUFFER:=RESERVE(BUFSIZ*256);

RDDIR;
FILE:=PARM(11); 		\FILE NUMBER INPUT
GETNAM(FILE);			\GET ITS NAME
FRBLK:=FBLK(FILE);		\ITS FIRST BLOCK
SIZE:=LBLK(FILE)-FRBLK+1;	\ITS SIZE
INDATE:=FDATE(FILE);		\ITS DATE
READBUF;
SETDISK(1);
RDDIR;
FIND(SIZE);
ENTER;
TOBLK:=FIRBLK;
WRTBUF;
'WHILE'SIZE>0'DO'
	'BEGIN'
	SETDISK(0);
	READBUF;
	SETDISK(1);
	WRTBUF;
	'END';
CLOFIL(FLNO);
WRTDIR;		
PARENT;
'END';\OF ALL
