
\XPL file shifter v6.0 for IBM

code
ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68;
code real
RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,	SQRT=53,	LN=54,
EXP=55,		SIN=56,		ATAN2=57,	MOD=58,
LOG=59,		COS=60,		TAN=61,		ASIN=62,
ACOS=63;


\%%% VARIABLES FOR IBM DISKIO %%%%

integer
	SYSINFO,
	INHAND,	\INPUT HANDLE
	OUTHAND;\OUTPUT HANDLE

address INNAME,OUTNAME;


'INTEGER'CH;

\----------------------------------------------------------

procedure IBMOPEN;
\This routine opens an input and an output file (big buffers)
\using the command tail and the default extensions provided below:
\It only handles the basic case of a single file name given.
\it has an example switch use.

integer PSEG,CSEG,SYSINF;
addres TAIL,TLEN;

	function MAKUP(C);
	\CONVERT C TO UPPERCASE
	int C;
	return if C>=^a & C<=^z then C-32 else C;


	function GETSWT;
	\FIND, REMOVE AND RETURN NEXT AVAILABLE SWITCH
	integer P,T;
	begin
	for P:=0,TLEN(0) do if TAIL(P)=^/ then
		begin
		TAIL(P):=$20;	\so we know we took it
		if P<TLEN(0) then
			begin
			T:=TAIL(P+1);	\the switch character
			TAIL(P+1):=$20;	\so we know we took it
			return MAKUP(T);\in upper case, return it
			end;
		end;
	return 0;	\if none, return zero.
	end;



	procedure PARSE;
	\PARSE COMMAND TAIL AND SET I/O HANDLES: OUTHAND AND INHAND.
	\this rather simple routine assumes only one file name was given, 
	\optionally with an input extension. The name part is also used to 
	\unconditionally open the output file.

	address EXT1,EXT2;
	integer P,EFLG,I;
	begin
	EXT1:=".XPL";EXT2:=".TMP";	\default extensions
	P:=0;
	EFLG:=false;
	\PARSE COMMAND TAIL FOR EXTENTION

	loop
		begin
		if TAIL(P)=^. then
			begin
			EFLG:=true;
			quit;
			end;
		P:=P+1;
		if P>=TLEN(0) then
			begin
			EFLG:=false;
			quit;
			end;
		end;

	\SET EXTENTION AND INPUT HANDLE
	if not EFLG then
		for I:=0,3 do TAIL(P+I):=EXT1(I);
	for I:=0,79 do INNAME(I):=0;
	for I:=1,P+3 do INNAME(I-1):=TAIL(I);
	INNAME(P+2):=INNAME(P+2)&$7F;
	INHAND:=FOPEN(TAIL,0);

	\SET EXTENTION AND OUTPUT HANDLE
	for I:=0,3 do TAIL(P+I):=EXT2(I);
	for I:=0,79 do OUTNAME(I):=0;
	for I:=1,P+3 do OUTNAME(I-1):=TAIL(I);
	OUTNAME(P+2):=OUTNAME(P+2)&$7F;
	OUTHAND:=FOPEN(TAIL,1);
	end;



begin	\OF IBMOPEN

\GET COMMAND TAIL FROM PSP
TLEN:=RESERVE(80);
TAIL:=TLEN+1;
SYSINF:=GETREG;			\FETCH CPU REGISTERS
PSEG:=SYSINF(11);		\get the segment register contents
CSEG:=SYSINF(12);
BLIT(PSEG,$80,CSEG,TLEN,79);	\copy over the command tail
if TLEN(0)>79 then TLEN(0):=79; \correct the limit

if GETSWT=^L then [];	\do something if switch is given

\PARSE COMMAND LINE AND SET HANDLES
PARSE;

\OPEN FILES
FSET(INHAND,^I);
FSET(OUTHAND,^O);
end;



procedure IBMCLOSE;
begin 
SYSINFO:=GETREG;
SYSINFO(0):=$4100;	\DELETE ORIGINAL FILE
SYSINFO(3):=INNAME;
SYSINFO(9):=SYSINFO(12);
SOFTINT($21);
if SYSINFO(7) then 
	begin 
	TEXT(0,"FILE DELETE FAILED");
	CRLF(0);
	exit ;
	end ;

SYSINFO(0):=$5600;	\RENAME TEMP FILE TO ORGINAL FILE
SYSINFO(3):=OUTNAME;
SYSINFO(4):=INNAME;
SYSINFO(9):=SYSINFO(12);
SYSINFO(11):=SYSINFO(12);
SOFTINT($21);
if SYSINFO(7) then 
	begin 
	TEXT(0,"FILE RENAME FAILED");
	CRLF(0);
	exit ;
	end ;
end ;

\==================================================

begin	\MAIN
INNAME:=RESERVE(80);
OUTNAME:=RESERVE(80);

TEXT(0,"FILTER TO REMOVE HIGH BIT SETS IN WORDSTAR FILES");
CRLF(0);

IBMOPEN;
OPENO(3);
OPENI(3);
TRAP(0);
\PROCESS INPUT TO OUTPUT HERE
'LOOP''BEGIN'
	CH:=CHIN(3);
	'IF'GETERR#0'THEN''QUIT';	

	'IF'(CH>127)'THEN'CH:=CH-128;
	'IF'CH<^ 'THEN'
	'CASE'CH'OF'
	$D,$A,$9:[]
	'ELSE'CH:=^ ;

	CHOUT(3,CH);
	'END';

CLOSE(3);
FCLOSE(OUTHAND);
FCLOSE(INHAND);
end;	\MAIN
