\FORMAT.XPL
\FORMAT V0.1 -5:12:78
\REQURIRES THE I2L FUNCTIONS IN FORMAT.P65

'CODE'
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
CHIN=7,		CHOUT=8,	CRLF=9,		INTIN=10,
INTOUT=11,	TEXT=12,	INITI=13,	INITO=14,
CLOSE=15,	FRUN=28,	FSAVE=29,	FWRITE=30,
FREAD=31,	FASAVE=27,	FGET=26,	FREST=32,
FSTEP=33,	FTRKW=34;

\GLOBALS
'INTEGER'GAPS1,GAPS2,GAPS3,GAPS4,SECSIZ,NUMSEC,NUMTRK,SKEW,K;
'ADDRESS'BLOCK,DUMMY,PG0;

\LOCALS FOR MAIN
'INTEGER'I;


'PROCEDURE'DAT(I);	\INSERT ONE BYTE
'INTEGER'I;
'BEGIN'
BLOCK(K):=I;
K:=K+1;
'END';

'PROCEDURE'GAP(I);
'INTEGER'I,J;
'FOR'J:=1,I'DO'DAT(0);

'PROCEDURE'IDFIELD(SECID,SECMARK);
'INTEGER'SECID,SECMARK;
'BEGIN'
DAT(254);	\ID MARK
DAT(0);		\TRACK NUMBER
DAT(0);
DAT(SECID);	\SECTOR NUMBER
DAT(SECMARK);	\SECTOR TYPE MARK
DAT(247);	\CRC
'END';

'PROCEDURE'DATAFLD(SECLEN);
'INTEGER'SECLEN,I;
'BEGIN'
DAT(251);	\DATA MARK
'FOR'I:=1,SECLEN'DO'DAT(229);
DAT(247);	\CRC
'END';



'PROCEDURE'MAKESEC(SECID,SECMARK,SECLEN);
'INTEGER'SECID,SECMARK,SECLEN;
'BEGIN'
GAP(GAPS2);
IDFIELD(SECID,SECMARK);
GAP(GAPS3);
DATAFLD(SECLEN);
'END';



'PROCEDURE'MAKEIT;	\MAKE THE TRACK DATA ARRAY
'INTEGER'I;
'BEGIN'
K:=0;
GAP(GAPS1);		\INDEX GAP
DAT(252);		\INDEX MARK
'FOR'I:=1,NUMSEC'DO'MAKESEC(I,0,SECSIZ);
GAP(GAPS4);
'END';\MAKEIT


'PROCEDURE'SETTRACK(TRK);		\INSERT TRACK NUMBERS
'INTEGER'TRK,SEC,L,M,K,N;
'BEGIN'
L:=GAPS2+GAPS3+SECSIZ+8;	\# OF BYTES PER SECTOR
K:=GAPS1+GAPS2+2;		\OFFSET TO FIRST TRACK #
'FOR'M:=0,NUMSEC-1'DO'
	'BEGIN'
	N:=K+M*L;
	SEC:=REM((TRK*(NUMSEC-SKEW)+M)/NUMSEC)+1;
	BLOCK(N):=TRK;		\INSERT TRACK NUMBER
	BLOCK(N+2):=SEC;	\INSERT SECTOR NUMBER
	'END';
'END';



'BEGIN'\MAIN ROUTINE

CRLF(0);
TEXT(0,"FORMAT V0.1");
CRLF(0);
TEXT(0,"IBM SKEWED");

PG0:=0;

\SETUP PARAMETERS OF DISK ORGANIZATION
GAPS1:=46;	\NUMBER OF 0 BYTES AFTER THE INDEX PULSE
GAPS2:=33;	\# OF 0 BYTES BETWEEN SECTORS
GAPS3:=17;	\# OF 0 BYTES BETWEEN ID AND DATA
GAPS4:=512;	\0 FILL FOR THE END OF THE TRACK
SECSIZ:=128;	\# OF DATA BYTES PER SECTOR
NUMSEC:=26;	\# OF SECTORS PER TRACK
NUMTRK:=77;	\# OF TRACKS
SKEW:=4;	\# OF SECTORS OF SKEW PER TRACK

BLOCK:=RESERVE(GAPS1+GAPS4+NUMSEC*(GAPS2+GAPS3+SECSIZ+8));
I:=13*256;
DUMMY:=RESERVE(I);
'FOR'K:=0,I-1'DO'DUMMY(K):=229;

MAKEIT;

'LOOP''BEGIN'
	CRLF(0);
	TEXT(0,"INSERT DISK TO BE FORMATTED ");
	PG0(116):=255;
	I:=CHIN(0);
	'IF'I#^Y'THEN''QUIT';
	FREST;
	'FOR'I:=0,NUMTRK-1'DO'
		'BEGIN'
		SETTRACK(I);
		CRLF(0);
		TEXT(0,"TRACK ");
		INTOUT(0,I);
		FTRKW(BLOCK);
		FWRITE(I*13,DUMMY,13);
		FREAD(I*13,DUMMY,13);
		TEXT(0," VERIFIED");
		FSTEP;
		'END';
	CRLF(0);
	TEXT(0,"FORMATTING DONE");
	'END';
CRLF(0);
TEXT(0,"INSERT ORIGINAL DISK ");
PG0(116):=255;
I:=0;'WHILE'I#^Y'DO'I:=CHIN(0);
'END';\OF ALL

