
include \CXPL\CODESI.XPL;


real 

	MATRIX;		\DETERMINATE MATRIX

integer
	X,	\TEMPORARY
	DVZFLG,	\FLAGS DIVIDE BY ZERO
	EQUAS;	\NUMBER OF EQUATIONS

define
	MAXEQU=40;	\MAXIMUM NUMBER OF EQUATIONS




procedure PAUSE;
integer C;
begin
TEXT(0,"HIT ANY KEY ");
C:=CHIN(1);
end;




procedure GETMATRIX;
\BUILD DETERMINATE MATRIX
integer E,T,S;
begin
\ZERO MATRIX
for E:=0,MAXEQU-1 do
for T:=0,MAXEQU-1 do
	MATRIX(E,T):=0.0;

TEXT(0,"ENTER NUMBER OF EQUATIONS: ");
EQUAS:=INTIN(0);


for E:=0,EQUAS-1 do
	begin
	TEXT(0,"EQUATION # ");
	INTOUT(0,E);CRLF(0);
	for T:=0,EQUAS-1 do
		begin
		TEXT(0,"ENTER TERM # ");
		INTOUT(0,T);
		TEXT(0," : ");
		MATRIX(E,T):=RLIN(0);
		end;
	TEXT(0,"ENTER THE EQUATION VALUE: ");
	MATRIX(E,EQUAS):=RLIN(0);
	end;
end;



procedure DISMATRIX;
integer E,T;
begin
CRLF(0);
CRLF(0);

for E:=0,EQUAS-1 do
	begin
	for T:=0,EQUAS-1 do
		begin
		RLOUT(0,MATRIX(E,T));
		TEXT(0,"  ");
		end;
	TEXT(0," = ");
	RLOUT(0,MATRIX(E,EQUAS));
	CRLF(0);
	end;
PAUSE;
end;



procedure GAUSS;
\DO GAUSS JORDAN ELEMINATION
integer I,K,J;
real S;
begin
K:=0;
DVZFLG:=false;
loop
	begin
	S:=MATRIX(K,K);
	if S=0.0 then [DVZFLG:=true;S:=4.19E-307;];
	for J:=K,EQUAS do MATRIX(K,J):=MATRIX(K,J)/S;
	if K>=EQUAS-1 then quit;
	for I:=K+1,EQUAS-1 do
		begin
		S:=MATRIX(I,K);
		for J:=K,EQUAS do
			MATRIX(I,J):=MATRIX(I,J)-S*MATRIX(K,J);
		end;
	K:=K+1;
	end;

while K>0 do
	begin
	I:=K-1;
	repeat
		begin
		S:=MATRIX(I,K);
		for J:=K,EQUAS do
			MATRIX(I,J):=MATRIX(I,J)-S*MATRIX(K,J);
		I:=I-1;
		end
	until I<0;
	K:=K-1;
	end;
end;




begin

MATRIX:=RLRES(MAXEQU);
for X:=0,MAXEQU-1 do MATRIX(X):=RLRES(MAXEQU);

GETMATRIX;
DISMATRIX;
GAUSS;
DISMATRIX;

end;
