\GEARS.XPL

\CALCULATE BICYCLE GEAR RATIOS

'CODE'	\COMPLETE SET, STANDARD XPLV5D INTRINSICS
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;
'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;


'DEF'
	CTZ=26,	\END OF FILE
	FF=$C;	\FORM FEED




'REAL'
	WIDTH,	\WIDTH OF OUTPUT DEVICE
	CWHEEL,	\NUMBER OF CHAIN WHEEL TEETH
	FWHEEL;	\NUMBER OF FREE WHEEL TEETH



'INTEGER'
	NUMCWH,	\NUMBER OF CHAIN WHEELS IN THE SET
	NUMFWH,	\NUMBER OF FREE WHEELS IN THE SET
	CHAR,	\GLOBAL CHARACTER
	ODEV;	\OUTPUT DEVICE



'PROCEDURE' DASH(DEV,NUMBER);
'INTEGER' DEV,NUMBER,X;
'FOR' X:=1,NUMBER 'DO' CHOUT(DEV,^=);



'PROCEDURE' TAB(DEV,NUMBER);
'INTEGER' DEV,NUMBER,X;
'FOR' X:=1,NUMBER 'DO' CHOUT(DEV,^ );



'PROCEDURE' MORE;
'INTEGER' X;
'BEGIN'
TEXT(0,"MORE SETS?");
OPENI(0);
X:=CHIN(0);
OPENI(0);
'RETURN' X;
'END';



'PROCEDURE' SORT(ARRAY);
'REAL' ARRAY,TEMP;
'INTEGER' ORDERED,X;


'PROCEDURE' PASS;
'BEGIN'
X:=0;
'REPEAT'
	'BEGIN'
	'IF' ARRAY(X)>ARRAY(X+1) 'THEN'
		'BEGIN'
		ORDERED:='FALSE';
		TEMP:=ARRAY(X);
		ARRAY(X):=ARRAY(X+1);
		ARRAY(X+1):=TEMP;
		'END';
	X:=X+1;
	'END'
'UNTIL' ARRAY(X+1)=0.0;
'END';


'BEGIN'
'IF' ARRAY(1)=0.0 'THEN' 'RETURN';
'REPEAT'
	'BEGIN'
	ORDERED:='TRUE';
	PASS;
	'END'
'UNTIL' ORDERED;
'END';



'PROCEDURE REAL' INCHES(C,F);	\RATIO TO INCHES
'REAL' C,F;
'RETURN' (C/F)*27.0;



'PROCEDURE' DOSET(C,F);	\DO A COMPLETE GEAR SET
'REAL' C,F;
'INTEGER' X,Y;
'BEGIN'
X:=0;
FORMAT(2,0);
CHOUT(0,FF);
TAB(ODEV,3);
'REPEAT'
	'BEGIN'
	TAB(ODEV,3);
	RLOUT(ODEV,F(X));
	X:=X+1;
	'END'
'UNTIL' F(X)=0.0;
CRLF(ODEV);
DASH(ODEV,FIX(WIDTH-1.0));
CRLF(ODEV);
CRLF(ODEV);
X:=0;
'REPEAT'
	'BEGIN'
	Y:=0;
	FORMAT(2,0);
	RLOUT(ODEV,C(X));
	TEXT(ODEV,"-");
	'REPEAT'
		'BEGIN'
		TAB(ODEV,2);
		FORMAT(3,0);
		RLOUT(ODEV,INCHES(C(X),F(Y)));
		Y:=Y+1;
		'END'
	'UNTIL' F(Y)=0.0;
	X:=X+1;
	CRLF(ODEV);
	'END'
'UNTIL' C(X)=0.0;
CRLF(ODEV);
DASH(ODEV,FIX(WIDTH-1.0));
CRLF(ODEV);
'END';



'PROCEDURE' GETCHAIN;
'INTEGER' X;
'BEGIN'
CHOUT(0,FF);
TEXT(0,"==== CHAIN WHEEL SET ====");CRLF(0);
CRLF(0);
TEXT(0,"ENTER NUMBER OF CHAIN TEETH FOR");CRLF(0);
TEXT(0,"FOR EACH WHEEL IN THE SET");CRLF(0);
TEXT(0,"ZERO TO QUIT");CRLF(0);
CRLF(0);
X:=0;
'REPEAT'
	'BEGIN'
	TEXT(0,"NUMBER OF TEETH? ");
	CWHEEL(X):=RLIN(0);
	X:=X+1;
	'END'
'UNTIL' CWHEEL(X-1)=0.0 ! X=10;
CWHEEL(X-1):=0.0;
NUMCWH:=X;
SORT(CWHEEL);
'END';



'PROCEDURE' GETSET;	\READ A GEAR SET FROM USER
'INTEGER' X;
'BEGIN'
GETCHAIN;

CHOUT(0,FF);
TEXT(0,"==== FREE WHEEL SET ====");CRLF(0);
TEXT(0,"ENTER FOR EACH COG IN THE SET");CRLF(0);
TEXT(0,"ENTER ZERO TO QUIT");CRLF(0);
CRLF(0);
CRLF(0);
X:=0;
'REPEAT'
	'BEGIN'
	TEXT(0,"NUMBER OF TEETH? ");
	FWHEEL(X):=RLIN(0);
	X:=X+1;
	'END'
'UNTIL' FWHEEL(X-1)=0.0 ! X=10;
FWHEEL(X-1):=0.0;
NUMFWH:=X-1;
SORT(FWHEEL);
'END';




'PROCEDURE' GRAPH(C,F);
'REAL' C,F,HIGH,LOW;
'INTEGER' CPTR;


'PROCEDURE' HILOW;
'REAL' CHI,CLOW,FHI,FLOW,CDIF;
'INTEGER' X,CRS;
'BEGIN'
X:=0;
CHI:=C(X);
CLOW:=C(X);
'REPEAT'
	'BEGIN'
	'IF' CHI<C(X) 'THEN' CHI:=C(X);
	'IF' C(X)<CLOW 'THEN' CLOW:=C(X);
	X:=X+1;
	'END'
'UNTIL' C(X)=0.0;
X:=0;
FHI:=F(X);
FLOW:=F(X);
'REPEAT'
	'BEGIN'
	'IF' FHI<F(X) 'THEN' FHI:=F(X);
	'IF' F(X)<FLOW 'THEN' FLOW:=F(X);
	X:=X+1;
	'END'
'UNTIL' F(X)=0.0;
LOW:=INCHES(CLOW,FHI);
HIGH:=INCHES(CHI,FLOW);
TEXT(ODEV,"LOW= ");
RLOUT(ODEV,LOW);

TEXT(ODEV," CROSS OVER ");
CRS:=NUMFWH/2;
INTOUT(ODEV,CRS+1);
TEXT(ODEV,"  DIFFERENCE= ");
'IF' NUMCWH<2 'THEN' TEXT(0,"NO CROSS OVER")
	'ELSE'
	'BEGIN'
	CDIF:=INCHES(CWHEEL(1),FWHEEL(CRS))-INCHES(CWHEEL(0),FWHEEL(CRS));
	RLOUT(0,CDIF);
	'END';
CRLF(ODEV);

TEXT(ODEV,"HIGH= ");
RLOUT(ODEV,HIGH);
CRLF(ODEV);

HIGH:=HIGH+1.0;
LOW:=LOW-1.0;
'END';


'PROCEDURE REAL' SCALE(VAL);
'REAL' VAL,DIF;
'BEGIN'
DIF:=LOG(HIGH)-LOG(LOW);
'RETURN' (LOG(VAL)-LOG(LOW))*WIDTH/DIF;
'END';


'PROCEDURE REAL' HIGHER(VAL);
'REAL' VAL,HI;
'INTEGER' X;
'BEGIN'
X:=0;
HI:=0.0;
'REPEAT'
	'BEGIN'
	 'IF' F(X)<VAL & F(X)>HI 'THEN' HI:=F(X);
	X:=X+1;
	'END'
'UNTIL' F(X)=0.0;
'RETURN' HI;
'END';



'PROCEDURE' RANGE;
'INTEGER' DELTA,CCOL;
'REAL' ACOL,HI;
'BEGIN'
CCOL:=0;
HI:=500.0;
FORMAT(3,0);
'LOOP'
	'BEGIN'
	HI:=HIGHER(HI);
	'IF' HI=0.0 'THEN''QUIT';
	ACOL:=SCALE(INCHES(C(CPTR),HI));
	DELTA:=FIX(ACOL)-CCOL;
	CCOL:=FIX(ACOL);
	TAB(ODEV,DELTA-1);
	TEXT(ODEV,"*");
	'END';
CRLF(ODEV);
CRLF(ODEV);
'END';



'PROCEDURE' RULE;
'BEGIN'
FORMAT(2,0);
RLOUT(ODEV,LOW);
TAB(ODEV,FIX(WIDTH/2.0-3.0));
RLOUT(ODEV,SQRT(HIGH*LOW));
TAB(ODEV,FIX(WIDTH/2.0-5.0));
RLOUT(ODEV,HIGH);
CRLF(ODEV);
'END';


'BEGIN'
HILOW;
DASH(ODEV,FIX(WIDTH-1.0));
CRLF(ODEV);
RULE;
CPTR:=0;
CRLF(ODEV);
'REPEAT'
	'BEGIN'
	RANGE;
	CPTR:=CPTR+1;
	'END'
'UNTIL' C(CPTR)=0.0;
'END';



'PROCEDURE' MANUAL;
'BEGIN'
'LOOP'
	'BEGIN'
	GETSET;
	DOSET(CWHEEL,FWHEEL);
	GRAPH(CWHEEL,FWHEEL);
	'IF' MORE=^N 'THEN' 'QUIT';
	'END';
CHOUT(ODEV,CTZ);
CLOSE(ODEV);
'END';



'PROCEDURE' AUTO;
'INTEGER'
	WH0,WH1,WH2,WH3,WH4,
	X,C;

'PROCEDURE' TEST;
'INTEGER' D0,D1,D2,D3;
'BEGIN'
D0:=WH1-WH0;
D1:=WH2-WH1;
D2:=WH3-WH2;
D3:=WH4-WH3;
'RETURN'
	D0<=D1 &
	D1<=D2 &
	D2<=D3;
'END';


'BEGIN'
C:=0;
GETCHAIN;
NUMFWH:=5;
'FOR' WH0:=13,15 'DO'
'FOR' WH1:=WH0+1,17 'DO'
'FOR' WH2:=WH1+1,20 'DO'
'FOR' WH3:=WH2+1,24 'DO'
'FOR' WH4:=WH3+1,28 'DO'
	'BEGIN'
	'IF' TEST 'THEN'
		'BEGIN'
		C:=C+1;
		FWHEEL(0):=FLOAT(WH0);
		FWHEEL(1):=FLOAT(WH1);
		FWHEEL(2):=FLOAT(WH2);
		FWHEEL(3):=FLOAT(WH3);
		FWHEEL(4):=FLOAT(WH4);
		FWHEEL(5):=0.0;
		DOSET(CWHEEL,FWHEEL);
		GRAPH(CWHEEL,FWHEEL);
		CRLF(0);
		TEXT(0,"COUNT= ");
		INTOUT(0,C);CRLF(0);
		TEXT(0,"NEXT? ");
		OPENI(0);
		CHAR:=CHIN(0);
		'END';
	'END';
'END';



'BEGIN'	\MAIN
CWHEEL:=RLRES(10);
FWHEEL:=RLRES(10);
CHOUT(0,FF);
TEXT(0,"OUTPUT DEVICE? ");
ODEV:=INTIN(0);
TEXT(0,"OUTPUT DEVICE WIDTH (COLUMNS)? ");
OPENO(ODEV);
WIDTH:=RLIN(0);
'REPEAT'
	'BEGIN'
	TEXT(0,"MANUAL OR AUTOMATIC MODE");CRLF(0);
	TEXT(0,"ENTER m OR a -- ");
	OPENI(0);
	CHAR:=CHIN(0);
	'END'
'UNTIL' CHAR=^A ! CHAR=^M;
'IF' CHAR=^A 'THEN' AUTO 'ELSE' MANUAL;
'END';
