code RESERVE=3, CHIN=7, CHOUT=8,
CRLF=9, INTIN=10, INTOUT=11,
TEXT=12, ABORT=16, CURSOR=23;

integer NUMBER, LEVEL, MOVE;
integer DSKCH, NEEDLCH;
address TOP, CENTER;

procedure SHOW(SIZE, CHAR);
integer SIZE, CHAR, I;
begin
for I:=1,SIZE do CHOUT(0,CHAR);
CHOUT(0,NEEDLCH);
for I:=1,SIZE do CHOUT(0,CHAR);
end;

procedure SETUP;
integer I, J, T;
integer WIDTH, LINES, SIZE, ROW;
begin
WIDTH:=40; LINES:=24;
DSKCH:=^=; NEEDLCH:=^I;

LEVEL:=0; MOVE:=0;
CURSOR(0,1);
TEXT(0,"                                ");
CHOUT(0,13\CR\); TEXT(0,"NUMBER OF DISKS? ");
NUMBER:=INTIN(0);
'IF' NUMBER < 0 'THEN' [CHOUT(0,12);ABORT];
TOP(1):=(LINES-1)-NUMBER;
TOP(2):=LINES-1; TOP(3):=LINES-1;
T:=WIDTH/6;
for I:=0,2 do CENTER(I+1):=T+2*I*T;
CHOUT(0,12); \CLEAR SCREEN
CURSOR(0,0); TEXT(0,"MOVE # ");
CURSOR(0,1);TEXT(0,"A..Z CONTROL SPEED");

for I:=0,NUMBER-1 do
    begin SIZE:=NUMBER-I;
    ROW:=(LINES-1)-I;
    CURSOR(CENTER(1)-SIZE, ROW);
    SHOW(SIZE,DSKCH);
    CURSOR(CENTER(2),ROW);
    CHOUT(0,NEEDLCH);
    CURSOR(CENTER(3),ROW);
    CHOUT(0,NEEDLCH);
    end;
end;

procedure DELAY; \GROSS MACHINE DEPENDANT KLUDGE
address KYADDR;
integer I, N;
begin KYADDR:=$C000; N:=(KYADDR(0)&127)-^A;
      KYADDR($16):=0; \CLEAR STROBE
if N<0 ! N>25 then N:=25;
for I:=1, 100*N do ;
end; 

procedure MOVETOWER( HEIGHT, FROM, TO, USING);
integer HEIGHT, FROM, TO, USING;

procedure MOVEDISK( TAKEOFF, PUTON );
integer TAKEOFF, PUTON, I, SIZE, NOP;
begin MOVE:=MOVE+1;
SIZE:=NUMBER-(LEVEL-1);
TOP(TAKEOFF):=TOP(TAKEOFF)+1;
CURSOR(CENTER(TAKEOFF)-SIZE, TOP(TAKEOFF));
SHOW(SIZE,^ );
CURSOR( CENTER(PUTON)-SIZE, TOP(PUTON));
TOP(PUTON):=TOP(PUTON)-1; SHOW(SIZE,DSKCH);
CURSOR(8,0); INTOUT(0,MOVE); CHOUT(0,9\TAB\);
INTOUT(0,TAKEOFF);
TEXT(0,"==>"); INTOUT(0,PUTON);
DELAY;
end;

begin \MOVETOWER
LEVEL:=LEVEL+1;
if HEIGHT>0 then
    begin
    MOVETOWER( HEIGHT-1, FROM, USING, TO );
    MOVEDISK( FROM, TO );
    MOVETOWER( HEIGHT-1, USING, TO, FROM);    
    end;
LEVEL:=LEVEL-1;
end;

begin \MAIN PROGRAM
TOP:=RESERVE(4); CENTER:=RESERVE(4);
CHOUT(0,12);	\CLEAR SCREEN
loop
    begin
    SETUP;
    MOVETOWER( NUMBER, 1, 3, 2 );
    end;
end;

\gross machine dependancies are limited to
\first few lines of proc. SETUP and proc. DELAY
