\Times square message display

int	Key,
	BytesPerChar,
	FontSeg,
	FontOff,
	;
char	Message;
def	DotXSize =10;
def	DotYSize =15;

inc \LIB\LIB.XPL;



proc	Dot(X, Y, C);
int	X, Y, C;
int	I, J;
begin
for J:= 0, DotYSize-3 do
	for I:= 0, DotXSize-3 do
		Point(X+I, Y+J, C);

C:= (C+8) & $f;
for J:= 1, DotYSize-1 do Point(X+DotXSize-2, Y+J, C);
for J:= 2, DotYSize-1 do Point(X+DotXSize-1, Y+J, C);
for I:= 1, DotXSize-1 do Point(X+I, Y+DotYSize-2, C);
for I:= 2, DotXSize-1 do Point(X+I, Y+DotYSize-1, C);
end;	\Dot



proc	DisplayChar(X, Y, CH);
int	X, Y, CH;
int	I, J, Byte;
begin
for J:= 0, BytesPerChar-1 do
	begin
	Byte:= Peek(FontSeg, FontOff + CH*BytesPerChar + J);
	for I:= 0, 7 do
		begin
		if Byte & $80 then Dot(X+I*(DotXSize+2), Y+J*(DotYSize+4), $e);
		Byte:= Byte << 1;
		end;
	end;
end;	\DisplayChar



proc	DisplayMsg;
int	Ch, I;
char	Str;
begin
Str:= "Howdy ! ";
for I:= 0, 6 do DisplayChar(\150+\I*(DotXSize+2)*8, 100, Str(I));
end;	\DisplayMsg



begin
Cpureg:= Getreg;

Setvid($12);

Cpureg(AX):= $1130;	\Get font info
Cpureg(BX):= $0100;
Softint($10);
BytesPerChar:= Cpureg(CX);
FontSeg:= Cpureg(ES);
FontOff:= Cpureg(BP);

\loop	begin
\	GetMsg;
\	if Key = Esc then quit;
	DisplayMsg;
\	end;

WaitKey;
Setvid($03);
end;	\Main
