\INTEREST.XPLV5D		4/15/81
\COMPOUND INTEREST CALCULATOR
\ BY LOREN BLANEY
\A HARDCOPY MAY BE MADE BY CHANGING "DEV" TO YOUR PRINTER
\ DEVICE NUMBER (2).

'CODE'	\COMPLETE SET, STANDARD XPLV5D INTRINSICS
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5		RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31	RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;
'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;

def	TV=0, KB=0, DEV=0;

int	TIME, SAMPLES;
real	PRINCIPAL, RATE, COMPOUNDING, YEARS, AMOUNT;


funct real POWER; real	X,Y;
begin	\RAISE X TO THE Y POWER
return EXP(Y*LN(X));
end;


loop begin	\MAIN PROC
OPENI(KB);
TEXT(TV, "
  -- COMPOUND INTEREST CALCULATOR --
ENTER PRINCIPAL:  "); PRINCIPAL:=RLIN(KB);
RLOUT(DEV,PRINCIPAL); CRLF(DEV);

TEXT(TV, "ENTER RATE (%):  "); RATE:=RLIN(KB) /100.0;
RLOUT(DEV,RATE *100.0); CRLF(DEV);

TEXT(TV, "ENTER COMPOUNDING
(I.E. NO. OF TIMES COMPOUNDED PER YEAR):  ");
COMPOUNDING:=RLIN(KB);
RLOUT(DEV,COMPOUNDING); CRLF(DEV);

TEXT(TV, "ENTER YEARS:  "); YEARS:=RLIN(KB);
RLOUT(DEV,YEARS); CRLF(DEV);

TEXT(TV, "ENTER SAMPLES PER YEAR:  "); SAMPLES:=INTIN(KB);
INTOUT(DEV,SAMPLES); CRLF(DEV);
TEXT(DEV, "
SAMPLE	AMOUNT		YEAR
");
for TIME:=0,SAMPLES*FIX(YEARS) do
	[INTOUT(DEV,TIME); TEXT(DEV,"	");
	AMOUNT:=PRINCIPAL *POWER(1.0 +RATE/COMPOUNDING,
		FLOAT(TIME) /FLOAT(SAMPLES) *COMPOUNDING);
	RLOUT(DEV,AMOUNT); TEXT(DEV,"	");
	INTOUT(DEV,TIME/SAMPLES); CRLF(DEV)];
end;
