\NOT TRIED LATELY - NOR ON APPLE



code ABS=0,RAN=1,REM=2,RESERVE=3,SWAP=4,ABORT=16;
code EXTEN=5,SHORT=6,CHIN=7,CHOUT=8,CRLF=9,INTIN=10;
code INTOUT=11,TEXT=12,INITI=13,INITO=14,CLOSE=15;
code CALL=17,SPACE=18,SETSP=21,ADC=22;
code CURSOR=23,SPEAK=24;


integer I,T,MIDV,MIDH,VTHRST,HTHRST,BASE,SAFE,LEV;
integer ALT,HPOS,VEL,FUEL,SCALE,NOP,OLDALT,OLDH;

procedure LEVEL;

begin
INITO(0);
TEXT(0,"Welcome to LUNAR LANDER, or as it is often called, SPLAT.
The object of the game is to land your ship inside the moonbase
(shown in the short range display as :___: ).
Which scenario would you like to play ?
 (1) STUDENT-Start from a stable position,in the sturdy TX-4 
             trainer, and lots of fuel to play with.
 (2) PILOT-A standard freigter approach, with enough fuel for
           the job, but you had better watch your landing speed.
 (3) EXPERT-A damaged ship, coming in fast. Landing gear is shot
           so you must land very gently, but you have barely
           enough fuel to make it.

Number ? ");
LEV:=INTIN(0);
CRLF(0);
end;


procedure MOVE;
integer I,TEMP;
begin
VTHRST:=(MIDV-ADC(1))/SCALE+78;
TEMP:=(ADC(0)-MIDH);
if TEMP>10 then HTHRST:=HTHRST+1
 else if TEMP<-10 then HTHRST:=HTHRST-1;
HPOS:=HPOS+HTHRST;
if FUEL<VTHRST then VTHRST:=FUEL;
FUEL:=FUEL-VTHRST;
VEL:=VEL+80-VTHRST;
ALT:=ALT-VEL;
if ALT<0 then ALT:=0;
T:=REM((T+1)/2);SPEAK(T,30,100);
for I:=1,1000 do ;
end;

procedure DIS;
begin
CURSOR(0,1);
TEXT(0,"MAXIMUM LANDING SPEED ");INTOUT(0,SAFE/10);
CURSOR(0,2);
TEXT(0,"THR.=    ");CURSOR(5,2);INTOUT(0,VTHRST);
CURSOR(0,3);
TEXT(0,"VEL.=        ");CURSOR(5,3);INTOUT(0,VEL/10);
CURSOR(0,4);
TEXT(0,"ALT.=    ");CURSOR(5,4);INTOUT(0,ALT/10);
CURSOR(0,5);
if FUEL>0 
  then 
   [TEXT(0,"FUEL=       ");CURSOR(5,5);INTOUT(0,FUEL)]
  else
  begin
  TEXT(0,"  OUT OF FUEL!!   ");
  SPEAK(1,40,200);SPEAK(1,20,400)
  end;
end;

procedure LRDIS;
integer NEWALT;
begin
DIS;
NEWALT:=15-ALT/1000;
CURSOR(32,OLDALT);TEXT(0," ");
CURSOR(32,NEWALT);TEXT(0,"^");
OLDALT:=NEWALT;
end;

procedure SRDIS;
integer NEWALT;
begin
DIS;
NEWALT:=15-ALT/100;
if ALT<0 then NEWALT:=15;
CURSOR(OLDH,OLDALT);TEXT(0," ");
CURSOR(HPOS,NEWALT);TEXT(0,"");
OLDH:=HPOS;OLDALT:=NEWALT;
end;

procedure LRSET;
integer I;
begin
INITO(0);
TEXT(0,"  LONG RANGE DISPLAY ");
CURSOR(0,14);for I:=1,8 do TEXT(0," _ _ _ _");
CURSOR(0,15);for I:=1,8 do TEXT(0,"________");
end;

procedure SRSET;
integer I;
begin
INITO(0);
TEXT(0,"  SHORT RANGE DISPLAY ");
CURSOR(0,15);
TEXT(0,"_____/\/\/^--^\/^\/\____/\__/\__");
TEXT(0,"____\\^-------------/\/\_____");
BASE:=RAN(56)+3;
CURSOR(BASE-2,15);TEXT(0,":___:");
end;

procedure BOOM;
integer I;
begin
CURSOR(HPOS-1,14);TEXT(0,"\l/");
CURSOR(HPOS-1,15);TEXT(0,"-*-");
for I:=1,50 do SPEAK(1,6,RAN(200)+100-(I+I));
end;

procedure LOST;
integer I;
begin
for I:=1,16 do SPEAK(1,30,140+I*10);
CURSOR(0,8);TEXT(0,"WELL, IT WAS A PRETTY GOOD LANDING ");
CRLF(0);TEXT(0,"BUT YOU DID MISS THE BASE.");
end;

procedure WON;
integer I;
begin
CURSOR(25,7); TEXT(0,"*************");
CURSOR(24,8);TEXT(0,"* YOU MADE IT *");
CURSOR(25, 9);TEXT(0,"*************");
for I:=1,16 do SPEAK(1,30,300-10*I);
end;


begin\MAIN\
LEVEL;
TEXT(0,"Center joystick and hit return ");NOP:=CHIN(0);
MIDV:=ADC(1);MIDH:=ADC(0);
loop 
begin
 if LEV=1 then 
 [ALT:=10000;VEL:=0;FUEL:=20000;SAFE:=100];
 if LEV=2 then 
 [ALT:=16000;VEL:=300;FUEL:=15000;SAFE:=50];
 if LEV=3 then 
 [ALT:=16000;VEL:=500;FUEL:=10000;SAFE:=20];
 SCALE:=1;
 HPOS:=32;HTHRST:=0;OLDALT:=ALT;OLDH:=HPOS;
 LRSET;
 while ALT>1600 do
  begin
  MOVE;
  LRDIS;
  end;
 SRSET;OLDALT:=0;HPOS:=32;SCALE:=2;
 while ALT>10 do
  begin
  MOVE;
  SRDIS;
  end;
 if VEL>SAFE then BOOM else 
  if ABS(BASE-HPOS)<2 then WON else LOST;
 DIS;
 CURSOR(0,6);
 TEXT(0," VELOCITY AT TOUCHDOWN ");INTOUT(0,VEL/10);
 TEXT(0,".");INTOUT(0,REM(VEL/10));
 for I:=1,30000 do ;
 end;
end;
 
 