code
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	HEXOUT=27
FSET=24,	FOPEN=29,
FCLOSE=32,	GETREG=35,	BLIT=36,
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SOUND=39	CLEAR=40
DOTAPP=41	LINE=42		MOVE=43		FIX=50;

code real	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;

'INT'CH,PC,BASE,SIZE,K,COUNT,I,ROWS,ROW;
'ADDR'DATA;
integerINHAND,OUTHAND;
'CHAR'NAME,CHAR;
'DEF'NAMMAX=80;

def EOF=$1A, BEL=$07, EOL=$0A;


'FUNCTION' GETNAME(DEFEXT);
'CHAR'DEFEXT;
\get a file name from the user
integer EXTFLG,I,K;
char CHAR;
begin
EXTFLG:=false;

'FOR'I:=0,NAMMAX'DO'NAME(I):=0;
CHAR:=CHIN(0);	\GET STARTING CHAR

\EAT LEADING SPACES AND CONTROL CHARS
while CHAR<=$20 do CHAR:=CHIN(0);

\COPY FILE NAME INTO 'NAME'
K:=0;
	
loop	begin
	case CHAR of
	^. : EXTFLG:=true;
	$D : quit 
	else;

	NAME(K):=CHAR;
	K:=K+1;
	if K>=NAMMAX  then return false;
	CHAR:=CHIN(0);
	end;

\DEAL WITH EMPTY FILENAME
if K=0 then return false;

\DEAL WITH DEFAULT EXTENTIONS
if EXTFLG then NAME(K-1):=NAME(K-1) ! $80
else	begin
	if (K+4)>=NAMMAX then return false;
	NAME(K):=^.;
	K:=K+1;
	for I:=0,2 do NAME(K+I):=DEFEXT(I);
	end;
\'FOR'I:=0,NAMMAX'DO'CHOUT(0,NAME(I)&$7F);
\CRLF(0);
return true;
end;



'PROCEDURE'OPENIN;
\OPEN A FILE FOR INPUT
'INTEGER'I;
'BEGIN'
TEXT(0,"INPUT FILE:  ");
'IF''NOT'GETNAME("XPL")'THEN'[TEXT(0,"NAME ERROR");'EXIT'];
TRAP($FFFB);
INHAND:=FOPEN(NAME,0);
TRAP($FFFF);
if GETERR=3 then [TEXT(0,"FILE NOT FOUND");'EXIT'];
FSET(INHAND,^I);
OPENI(3);
end;


'PROCEDURE'OPENOUT;
\OPEN A FILE FOR OUTPUT
'INTEGER'I;
'BEGIN'
TEXT(0,"OUTPUT FILE: ");
'IF''NOT'GETNAME("LST")'THEN'[TEXT(0,"NAME ERROR");'EXIT'];
TRAP($FFFB);
OUTHAND:=FOPEN(NAME,1);
TRAP($FFFF);
if GETERR=3 then [TEXT(0,"FILE NOT OPENED");'EXIT'];
FSET(OUTHAND,^O);
OPENO(3);
end;

\ ----------------------------------------------------------

'PROC'INONE;
'BEGIN'
CH:=CHIN(3);
CHOUT(0,CH);
'END';

'PROC'INCH;
'BEGIN'
'REPEAT'INONE'UNTIL'(CH#$A)&(CH#$D);
'END';


'FUNC'ISHEX;
'RETURN'((CH>=^0)&(CH<=^9))!((CH>=^A)&(CH<=^F));

'FUNC'HEXDIG;
'INT'DIG;
'BEGIN'
'IF''NOT'ISHEX'THEN'
	'BEGIN'
	CRLF(0);
	TEXT(0,"BAD INPUT DATA");CRLF(0);
	'EXIT';
	'END';
'IF'CH<=^9'THEN'DIG:=CH-^0
'ELSE'DIG:=CH-^A+10;
INCH;
'RETURN'DIG;
'END';


'FUNC'HEXBYTE;
'RETURN'HEXDIG*16+HEXDIG;



'PROC'NEWPC;
'BEGIN'
INCH;
PC:=HEXBYTE*256+HEXBYTE;
PC:=PC+BASE+1;
'END';

'PROC'ADDBYT(X);
'INT'X,ADR;
'BEGIN'
ADR:=PC-BASE;
K:=(SWAP(ADR)&$FF)/4;
'IF'(K>=0)&(K<SIZE)'THEN'
	'BEGIN'
	DATA(ADR):=X;
	COUNT:=COUNT+1;
	'END';
PC:=PC+1;
'END';


'PROC'RELAD;
'INT'ADR;
'BEGIN'
INCH;
ADR:=BASE+(HEXBYTE*256+HEXBYTE)+1;
ADDBYT(ADR);
ADDBYT(SWAP(ADR));
'END';

'PROC'FIXUP;
'INT'LOC;
'BEGIN'
INCH;
LOC:=(HEXBYTE*256+HEXBYTE)+1;
K:=(SWAP(LOC)&$FF)/4;
'IF'(K<0)!(K>=SIZE)'THEN''RETURN';
DATA(LOC):=PC;
DATA(LOC+1):=SWAP(PC);
'END';

\-------------------------------------------------------

'PROC'PUTBYTE;		\SEND BYTE TO OUTPUT FILE
'INT'BYTE;

'PROC'ONEHEX(I);
'INT'I;
'BEGIN'
I:=I&$F;
'IF'I>=10'THEN'CHOUT(3,I-10+^A)
'ELSE'CHOUT(3,I+^0);
'END';

'BEGIN'
BYTE:=DATA(PC);
ONEHEX(BYTE/16);
ONEHEX(BYTE);
PC:=PC+1;
'END';


\==============


'BEGIN'
SIZE:=80;
BASE:=$8000;
TEXT(0,"LOADER FOR ROM I2L FILES");CRLF(0);
TEXT(0,"SIZE=");INTOUT(0,SIZE/4);
TEXT(0,"K, BASE=");INTOUT(0,BASE/1024);
CHOUT(0,^K);
CRLF(0);

DATA:=RESERVE(SIZE*256);
'FOR'K:=0,SIZE-1'DO'
	'BEGIN'
	CHOUT(0,^.);
	'FOR'I:=0,255'DO'DATA(K*256+I):=$FF;
	'END';
PC:=BASE;
COUNT:=0;
ADDBYT(0);

NAME:=RESERVE(NAMMAX+1);
CRLF(0);
OPENIN;
OPENOUT;

OPENI(3);
INCH;
'LOOP'	'BEGIN'
	'IF'(CH=^$)!(CH=26)'THEN''QUIT';
	'IF'CH=^;'THEN'NEWPC
	'ELSE''IF'CH=^*'THEN'RELAD
	'ELSE''IF'CH=^^'THEN'FIXUP
	'ELSE'ADDBYT(HEXBYTE);
	'END';
CRLF(0);
TEXT(0,"...DONE...");
CRLF(0);
INTOUT(0,COUNT);
TEXT(0," BYTES LOADED");

PC:=0;
OPENO(3);
ROWS:=SIZE*16;
'FOR'ROW:=0,ROWS-1'DO'
	'BEGIN'
	'FOR'I:=0,15'DO'PUTBYTE;
	CRLF(3);
	CHOUT(0,^.);
	'END';
CRLF(0);
TEXT(0,"BYTES OUTPUT: ");
INTOUT(0,PC);
CRLF(0);
CLOSE(3);
FCLOSE(INHAND);
FCLOSE(OUTHAND);
TEXT(0,"THE DEED IS DONE");
CRLF(0);
'END';
