\LOWCASE.XPL    APR-07-98
\This copies a file, shifting all characters to lowercase.

code    RESERVE=3,      CHIN=7,         CHOUT=8,        OPENI=13,
	OPENO=14,       CLOSE=15,       FSET=24,        FOPEN=29,
	FCLOSE=32,      GETREG=35,      BLIT=36		TEXT=12;

int     CPUREG,         \Register array from GETREG
	HANDIN,HANDOUT, \File handles
	I;              \Scratch
char    CMDTAIL;        \Copy of command tail

begin
Text(0, "
This copies a file, shifting all characters to lowercase.

WARNING: This is a simple-minded program. Two, complete and different
file names must be given on the command line and they must be separated
by a comma. For example:

	LOWCASE FILE1.TXT, FILE2.TXT

Thinking...");

CPUREG:= GETREG;                \Get DOS PSP and data segment
CMDTAIL:= RESERVE($80);         \Get copy of command tail
BLIT(CPUREG(11), $81, CPUREG(12), CMDTAIL, $7F);

HANDIN:= FOPEN(CMDTAIL, 0);     \Open first file name for input
FSET(HANDIN, ^I);
OPENI(3);

loop for I:= 1, $7F do          \Scan to second file name
	if CMDTAIL(I) = ^, then quit;

HANDOUT:= FOPEN(CMDTAIL+I+1, 1); \Open second file name for output
FSET(HANDOUT, ^O);
OPENO(3);

repeat  I:= CHIN(3);            \Copy and shift to lowercase
	if I>=^A & I<=^Z then I:= I !$20;
	CHOUT(3, I);
until I = \EOF\ $1A;

CLOSE(3);
FCLOSE(HANDIN);
FCLOSE(HANDOUT);
end;
