\MERGE.XPL
\PROGRAM TO MERGE AN FILE OF ADDRESS 
\WITH A LETTER



'CODE'
ABS=0,         RAN=1,        REM=2,
RESERVE=3,     SWAP=4,       EXTEND=5,
REBEGIN=6,     CHIN=7,       CHOUT=8,
CRLF=9,        NUMIN=10,     NUMOUT=11,
TEXT=12,       OPENIN=13,     OPENOUT=14,
CLOSE=15,      ABORT=16,     TRAP=17,
SPACE=18,      RERUN=19,     GETSP=20,
SETSP=21,      ERRFLG=22,    CURSOR=23,
SCAN=24,       SETRUN=25,
CHAIN=28,       OPENF=29,     FWRITE=30,
FREAD=31,      FRESTOR=32;


'DEFINE'
	FEED=$0A,
	CTZ=$1A,
	CTB=2,
	FF=$C,
	RETURN=$0D;

'ADDRESS'
	ABUFFER,	\BUFFER FOR DISK READS
	FNAME;		\GLOBAL FILE NAME

'INTEGER'
	ODEV,	\WORKING OUTPUT DEVICE
	LUNIT,	\UNIT FOR LETTER FILE
	BYTE,	\CURRENT CHAR FROM DISK
	OCHAR,	\ONE CHARACTER BACK
	LPNTER,	\CURRENT LINE COUNT
	APNTER,	\CURRENT BUFFER POINTER
	ALINE,	\ARRAY OF ADDRESS LINES
	AEOF,	\FLAGS END OF ADDRESS FILE
	ENDADD,	\FLAGS END OF SINGLE ADDRESS
	ABLOCK,	\CURRENT BLOCK OF ADDRESS FILE
	ASTART,	\STARTING BLOCK OF ADDRESS FILE
	AEND,	\ENDING BLOCK OF ADDRESS FILE
	AUNIT,	\UNIT OF ADDRESS FILE	
	TEMP;	\GLOBAL TEMPORARY



'PROCEDURE' GETNAME(NAME);
'ADDRESS' NAME;
'INTEGER' X,Y,CHAR;

'PROCEDURE' FIRST;
'BEGIN'
OPENIN(0);
X:=0;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(0);
	'IF' CHAR=^. 'THEN' 'QUIT';
	NAME(X):=CHAR;
	X:=X+1;
	'IF' X>8 ! CHAR=RETURN 'THEN'
		'BEGIN'
		TEXT(0,"BAD FILE NAME");
		CRLF(0);
		TEXT(0,"TRY AGAIN");
		CRLF(0);
		'QUIT';
		'END';
	'END';
'END';	\END FIRST

'BEGIN'	\START OF GETNAME
'REPEAT' FIRST 'UNTIL' CHAR=^.;
'FOR' Y:=X,7 'DO' NAME(Y):=$20;
X:=8;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(0);
	'IF' CHAR=RETURN 'THEN' 'QUIT';
	NAME(X):=CHAR;
	X:=X+1;
	'IF' X>10 'THEN' 'QUIT';
	'END';
'FOR' Y:=X,10 'DO' NAME(Y):=$20;
'END';



'PROCEDURE' SETADDRESS;
'INTEGER' BLOCK;
'BEGIN'
BLOCK:=RESERVE(4);
TEXT(0,"*** ADDRESS FILE SPECIFICATIONS ***");
CRLF(0);
TEXT(0,"ENTER UNIT NUMBER ");
AUNIT:=NUMIN(0);
TEXT(0,"ENTER FILE NAME ");
GETNAME(FNAME);
TRAP('FALSE');
SCAN(AUNIT,BLOCK,FNAME);
TRAP('TRUE');
'IF' ERRFLG 'THEN'
	'BEGIN'
	TEXT(0,"FILE NOT FOUND");
	CRLF(0);
	SETADDRESS;
	'END';
ASTART:=BLOCK(0);
AEND:=BLOCK(1);
APNTER:=256;
'END';



'PROCEDURE' SETLETTER;
'INTEGER' BLOCK;
'BEGIN'
BLOCK:=RESERVE(4);
TEXT(0,"*** LETTER FILE SPECIFICATIONS ***");
CRLF(0);
TEXT(0,"ENTER UNIT NUMBER ");
LUNIT:=NUMIN(0);
TEXT(0,"ENTER FILE NAME ");
GETNAME(FNAME);
TRAP('FALSE');
SCAN(LUNIT,BLOCK,FNAME);
TRAP('TRUE');
'IF' ERRFLG 'THEN'
	'BEGIN'
	TEXT(0,"FILE NOT FOUND");
	CRLF(0);
	SETLETTER;
	'END';
OPENF(LUNIT,BLOCK);
'END';




'PROCEDURE' GETBYTE;
'INTEGER' DUM;
'BEGIN'
OCHAR:=BYTE;
'REPEAT'
	'BEGIN'
	'IF' APNTER>255 'THEN'
		'BEGIN'
		FREAD(AUNIT,ABLOCK,ABUFFER,1);
		ABLOCK:=ABLOCK+1;
		APNTER:=0;
		'END';
	BYTE:=ABUFFER(APNTER);
	APNTER:=APNTER+1;
	'END'
'UNTIL' BYTE#FEED;
'IF' BYTE=CTZ 'THEN' AEOF:='TRUE';
'RETURN' BYTE;
'END';



'PROCEDURE' EATCHAR;
'BEGIN'
'REPEAT' GETBYTE 'UNTIL' BYTE=RETURN;
'END';


'PROCEDURE' RLINE(LINE);
'INTEGER' LINE,X,CHAR;
'ADDRESS' STR;
'BEGIN'
X:=0;
STR:=ALINE(LINE);
'LOOP'
	'BEGIN'
	CHAR:=GETBYTE;
	STR(X):=CHAR;
	'IF' OCHAR=RETURN & CHAR=RETURN 'THEN'
		'BEGIN'
		ENDADD:='TRUE';
		'QUIT';
		'END';
	'IF' CHAR=RETURN 'THEN' 'QUIT';
	'IF' AEOF 'THEN' 'QUIT';
	X:=X+1;
	'IF' X=64 'THEN'
		'BEGIN'
		EATCHAR;
		'QUIT';
		'END';
	'END';
'IF' X#0 'THEN' STR(X-1):=STR(X-1)+$80;
'RETURN' X#0;
'END';



'PROCEDURE' EATLINE;
'BEGIN'
'REPEAT' GETBYTE
'UNTIL'
(OCHAR=RETURN & BYTE=RETURN) !
AEOF;
'END';



'PROCEDURE' AREAD;
'INTEGER' FLAG;
'BEGIN'
ENDADD:='FALSE';
LPNTER:=0;
'LOOP'
	'BEGIN'
	'IF' RLINE(LPNTER) 'THEN'
		'BEGIN'
		LPNTER:=LPNTER+1;
		'IF' LPNTER=10 'THEN'
			'BEGIN'
			EATLINE;
			'QUIT';
			'END';
		'END';
	'IF' AEOF ! ENDADD 'THEN' 'QUIT';
	'END';
'RETURN' LPNTER#0;
'END';



'PROCEDURE' ERROR(C);
'INTEGER' C;
'BEGIN'
CRLF(0);
TEXT(0,"---->");
CHOUT(0,C);
TEXT(0,"<----");
CRLF(0);
TEXT(0,"!!! ILLEGAL COMMAND !!!");
CRLF(0);
ABORT;
'END';



'PROCEDURE' COMMAND;
'INTEGER' CCHAR,COM1,COM2,DUAL,X;
'BEGIN'
DUAL:='FALSE';
CCHAR:=CHIN(3);
'IF' CCHAR#^( 'THEN' ERROR(CCHAR);
CCHAR:=CHIN(3);
'IF' (CCHAR<^0 ! CCHAR>^9) &
(CCHAR#^A & CCHAR#^a) 'THEN' ERROR(CCHAR);
COM1:=CCHAR;
CCHAR:=CHIN(3);
'IF' CCHAR=^, 'THEN'
	'BEGIN'
	CCHAR:=CHIN(3);
	'IF' CCHAR<^0 ! CCHAR>^9 'THEN' ERROR(CCHAR);
	COM2:=CCHAR;
	CCHAR:=CHIN(3);
	DUAL:='TRUE';
	'END';
'IF' CCHAR#^) 'THEN' ERROR(CCHAR);
'IF' DUAL 'THEN'
	'BEGIN'
	COM1:=COM1-^0;COM2:=COM2-^0;
	'IF' COM2>=LPNTER-1 'THEN' COM2:=LPNTER-1;
	'FOR' X:=COM1,COM2 'DO'
		'BEGIN'
		TEXT(ODEV,ALINE(X));
		CRLF(ODEV);
		'END';
	'END'
'ELSE'
	'BEGIN'
	'IF' COM1=^A ! COM1=^a 'THEN'
		'BEGIN'
		'FOR' X:=0,LPNTER-1 'DO'
			'BEGIN'
			TEXT(ODEV,ALINE(X));
			CRLF(ODEV);
			'END';
		'END'
	'ELSE'
		'BEGIN'
		COM1:=COM1-^0;
		'IF' COM1<LPNTER 'THEN'
			TEXT(ODEV,ALINE(COM1));
		'END';
	'END';
'END';



'PROCEDURE' DOLETTER;
'INTEGER' LCHAR;
'BEGIN'
OPENIN(3);
'LOOP'
	'BEGIN'
	LCHAR:=CHIN(3);
	'WHILE' LCHAR=CTB 'DO'
		'BEGIN'
		COMMAND;
		LCHAR:=CHIN(3);
		'END';
	'IF' LCHAR=CTZ 'THEN' 'QUIT';
	CHOUT(ODEV,LCHAR);
	'END';
CHOUT(ODEV,FF);
'END';




'BEGIN'	\MAIN
FNAME:=RESERVE(25);
ABUFFER:=RESERVE(256);
ALINE:=RESERVE(20);
'FOR' TEMP:=0,10 'DO' ALINE(TEMP):=RESERVE(64);
ODEV:=3;


CHOUT(0,FF);
SETADDRESS;
ABLOCK:=ASTART;
AEOF:='FALSE';
OCHAR:=0;

CHOUT(0,FF);
SETLETTER;

OPENOUT(ODEV);
'WHILE' AREAD 'DO' DOLETTER;
CHOUT(ODEV,CTZ);
CLOSE(ODEV);
'END';
