\NEWTON.XPL	5-11-84
\BY LOREN BLANEY
\FIND ROOT OF EQUATION USING NEWTON METHOD

code	\COMPLETE SET, STANDARD XPLV5D INTRINSICS
ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
SCAN=24,	SETRUN=25,	CHAIN=28,	OPENF=29,
WRITE=30,	READ=31,	SETTXT=33,	SETHI=34,
SETMIX=35,	SETLO=36,	BUTTON=37,	PADDLE=38,
SOUND=39,	CLEAR=40,	POINT=41,	LINE=42,
MOVE=43,	SCREEN=44,	BLOCK=45,	FIX=50;
code real	RLRES=46,	RLIN=47,	RLOUT=48,
FLOAT=49,	RLABS=51,	FORMAT=52,	SQRT=53,
LN=54,		EXP=55,		SIN=56,		ATAN2=57,
MOD=58,		LOG=59,		COS=60,		TAN=61,
ASIN=62,	ACOS=63;

real	X0,Y0,X1,Y1,X;
int	I;


func real F(X);	\EQUATION TO FIND ROOT OF
real	X;
begin
return SIN(2.0*X);
end;



begin	\MAIN
FORMAT(12,12);
TRAP(0);
X0:=0.123456789;	\PICK 2 INITIAL POINTS ON THE EQUATION CURVE
Y0:=F(X0);
X1:=1.0;
I:=1;
loop	begin
	Y1:=F(X1);
	INTOUT(0,I); CHOUT(0,9); RLOUT(0,X1); CHOUT(0,9); RLOUT(0,Y1); CRLF(0);
		\FIND STRAIGHT-LINE INTERCEPT (X) GIVEN 2 POINTS:
	X:=X0 - Y0*(X1-X0)/(Y1-Y0);
	if X=X1 then quit;
	X0:=X1; Y0:=Y1;
	X1:=X;
	I:=I+1;
	end;
TEXT(0,"ANSWER="); CHOUT(0,9); RLOUT(0,X1); CRLF(0);
end;	\MAIN
