\OCT.XPL	NOV-06-90
\TUMBLING OCTAHEDRON
\ORIGINALLY BY RICHARD WILLMORE
\MAY-21-87, MODIFIED FOR AMIGA.
\NOV-06-90, MODIFIED FOR PC.

include	C:\CXPL\CODESI;

def	WIDTH= 640, HEIGHT= 480, DEPTH= 1;
def	INTSIZE= 2;
def	TV= 0, KB= 0;
def	POINTS= 14;

int	C1, C2,
	SCALE,
	X, Y, Z,
	;


proc	WAITVB;		\Wait for the beginning of the next vertical blank
begin
while PIN($3DA, 0) & $08 do;	\Wait for no vertical blank
repeat until PIN($3DA, 0) & $08;	\Wait for vertical blank
end;	\WAITVB;



proc	DELAY;
int	I;
begin
for I:= 1, 1000 do;
end;	\DELAY



proc	SHOW(COLOR);
int	COLOR;
int	I;
def	SIZ=20;
begin
\for I:= 0, POINTS-1 do
\	[INTOUT(0, X(I)/SIZ+320);   CHOUT(0,9);
\	INTOUT(0, 239-Y(I)/SIZ);   CRLF(0);
\	];
\return;


MOVE(X(0)/SIZ+320, 239-Y(0)/SIZ);
for I:= 1, POINTS-1 do
	LINE(X(I)/SIZ+320, 239-Y(I)/SIZ, COLOR);
end;	\SHOW



proc	ROTATE;
int	I;
begin
for I:= 0, POINTS-1 do
	begin
	X(I):= X(I) + Y(I) /C1;
	Y(I):= Y(I) - X(I) /C1;
	Y(I):= Y(I) + Z(I) /C2;
	Z(I):= Z(I) - Y(I) /C2;
	end;
end;	\ROTATE



begin	\MAIN
X:= RESERVE(POINTS *INTSIZE);
Y:= RESERVE(POINTS *INTSIZE);
Z:= RESERVE(POINTS *INTSIZE);

C1:= 100; C2:= 70;

X(0):= 0; Y(0):= 4242; Z(0):= 0;
X(1):= 3000; Y(1):= 0; Z(1):= 3000;
X(2):= 3000; Y(2):= 0; Z(2):= -3000;
X(3):= 0; Y(3):= 4242; Z(3):= 0;
X(4):= -3000; Y(4):= 0; Z(4):= 3000;
X(5):= -3000; Y(5):= 0; Z(5):= -3000;
X(6):= 0; Y(6):= -4242; Z(6):= 0;
X(7):= -3000; Y(7):= 0; Z(7):= 3000;
X(8):= 3000; Y(8):= 0; Z(8):= 3000;
X(9):= 0; Y(9):= -4242; Z(9):= 0;
X(10):= 3000; Y(10):= 0; Z(10):= -3000;
X(11):= -3000; Y(11):= 0; Z(11):= -3000;
X(12):= 0; Y(12):= 4242; Z(12):= 0;
X(13):= 0; Y(13):= 0; Z(13):= 0;

SETVID($12);

CLEAR;
loop	begin
	SHOW($01);
\	DELAY;
	if CHKKEY then quit;
	WAITVB;
	WAITVB;
	WAITVB;
	WAITVB;
\	SHOW($00);
	ROTATE;
	CLEAR;
	end;

SETVID(3);
CURSOR(0,21);
end;	\MAIN
