\OCTFLICK.XPL	FEB-04-93
\Hi-res Animated Octahedron (with Flicker)
\by Richard Willmore and Loren Blaney

include	C:\CXPL\CODESI;

def	POINTS= 14;	\Number of points or vertices
def	C1=130, C2=80;	\Determine speed of rotation (larger nos are slower)
int	X, Y, Z;	\Arrays: coordinates of a point



proc	WAITVB;		\Wait for the beginning of the next vertical blank
begin
while PIN($3DA, 0) & $08 do;		\Wait for no vertical blank
repeat until PIN($3DA, 0) & $08;	\Wait for vertical blank
end;	\WAITVB;



proc	DRAW(COLOR);	\Draw the octahedron with specified color
int	COLOR;
int	I;
def	SIZ=20;		\Scale factor
begin
MOVE(X(0)/SIZ+320, 239-Y(0)/SIZ);
for I:= 1, POINTS-1 do
	LINE(X(I)/SIZ+320, 239-Y(I)/SIZ, COLOR);
end;	\DRAW



proc	ROTATE;		\Rotate the octahedron
int	I;
begin
for I:= 0, POINTS-1 do
	begin
	X(I):= X(I) + Y(I) /C1;
	Y(I):= Y(I) - X(I) /C1;
	Y(I):= Y(I) + Z(I) /C2;
	Z(I):= Z(I) - Y(I) /C2;
	end;
end;	\ROTATE



begin	\MAIN
\Coordinates defining the starting position of the octahedron:
X:= [    0, 3000, 3000,    0,-3000,-3000,    0,-3000, 3000,    0, 3000,
     -3000,    0,    0];
Y:= [ 4242,    0,    0, 4242,    0,    0,-4242,    0,    0,-4242,    0,
         0, 4242,    0];
Z:= [    0, 3000,-3000,    0, 3000,-3000,    0, 3000, 3000,    0,-3000,
     -3000,    0,    0];

SETVID($12);	\Select 640x480x16 graphics

loop	begin
	CLEAR;			\Erase page
	DRAW($9);		\Draw the octahedron in light blue
	ROTATE;			\Rotate the octahedron for next frame
	if CHKKEY then quit;	\Quit if keystroke
	WAITVB;			\Wait for vertical blank
	WAITVB;
	end;

OPENI(0);	\Eat keystroke
SETVID($03);	\Return to text mode
end;	\MAIN
