\OPTEST.XPL
\PROGRAM TO TEST TWO-OPERAND OPTIMIZATIONS
\REQUIRES THE EXTERNAL XTEST.ASM
\BUILD USING OPTEST.MAK

include C:\CXPL\CODESI.XPL;

external XTEST;

int A,B,C;
int 
	X0,	\S - R
	X1,	\A - R
	X2,	\I - R

	X3,	\S - S
	X4,	\A - S
	X5,	\I - S

	X6,	\R - A
	X7,	\S - A
	X8,	\A - A
	X9,	\I - A

	X10,	\R - I
	X11,	\S - I
	X12,	\A - I
	X13;	\I - I




proc ADDTEST;
begin
A:=2;B:=3;
X0:=(A+B) + (A+B);
X1:=A + (A +B);
X2:=7 + (A+B);
X3:=XTEST + XTEST;
X4:=A + XTEST;
X5:=6 + XTEST;
X6:=(A+B) + A;
X7:=XTEST + A;
X8:=A + B;
X9:=6 + B;
X10:=(A+B) + 6;
X11:=XTEST + 6;
X12:=A + 6;
X13:=7 + 8;
TEXT(0,"ADD RESULT (118) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc SUBTEST;
begin
A:=2;B:=3;C:=4;
X0:=(A+B) - (A+C);
X1:=A - (A+B);
X2:=7 - (A+B);
X3:=XTEST - XTEST;
X4:=A - XTEST;
X5:=6 - XTEST;
X6:=(A+B) - A;
X7:=XTEST - A;
X8:=A - B;
X9:=6 - B;
X10:=(A+B) - 6;
X11:=XTEST - 6;
X12:=A - 6;
X13:=7 - 8;
TEXT(0,"SUB RESULT (-3) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc MULTEST;
begin
A:=2;B:=3;C:=4;
X0:=(A+B) * (A+C);
X1:=A * (A+B);
X2:=7 * (A+B);
X3:=XTEST * XTEST;
X4:=A * XTEST;
X5:=6 * XTEST;
X6:=(A+B) * A;
X7:=XTEST * A;
X8:=A * B;
X9:=6 * B;
X10:=(A+B) * 6;
X11:=XTEST * 6;
X12:=A * 6;
X13:=7 * 8;
TEXT(0,"MULT RESULT (264) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc DIVTEST;
begin
A:=2;B:=3;C:=4;
X0:=(A+B) / (A+C);
X1:=A / (A+B);
X2:=7 / (A+B);
X3:=XTEST / XTEST;
X4:=A / XTEST;
X5:=6 / XTEST;
X6:=(A+B) / A;
X7:=XTEST / A;
X8:=A / B;
X9:=6 / B;
X10:=(A+B) / 6;
X11:=XTEST / 6;
X12:=A / 6;
X13:=7 / 8;
TEXT(0,"DIVIDE RESULT (9) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc EQUTEST;
begin
A:=2;B:=3;C:=4;
X0:=(A+B) = (A+C);
X1:=A = (A+B);
X2:=7 = (A+B);
X3:=XTEST = XTEST;
X4:=A = XTEST;
X5:=6 = XTEST;
X6:=(A+B) = A;
X7:=XTEST = A;
X8:=A = B;
X9:=6 = B;
X10:=(A+B) = 6;
X11:=XTEST = 6;
X12:=A = 6;
X13:=7 = 8;
TEXT(0,"EQUAL RESULT (-1) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc NOTEQUTEST;
begin
A:=2;B:=3;C:=4;
X0:=(A+B) # (A+C);
X1:=A # (A+B);
X2:=7 # (A+B);
X3:=XTEST # XTEST;
X4:=A # XTEST;
X5:=6 # XTEST;
X6:=(A+B) # A;
X7:=XTEST # A;
X8:=A # B;
X9:=6 # B;
X10:=(A+B) # 6;
X11:=XTEST # 6;
X12:=A # 6;
X13:=7 # 8;
TEXT(0,"NOTEQUAL RESULT (-13) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc GREATTEST;
begin
A:=2;B:=3;C:=4;
X0:=(A+B) > (A+C);
X1:=A > (A+B);
X2:=7 > (A+B);
X3:=XTEST > XTEST;
X4:=A > XTEST;
X5:=6 > XTEST;
X6:=(A+B) > A;
X7:=XTEST > A;
X8:=A > B;
X9:=6 > B;
X10:=(A+B) > 6;
X11:=XTEST > 6;
X12:=A > 6;
X13:=7 > 8;
TEXT(0,"> RESULT (-5) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc LESSTEST;
begin
A:=2;B:=3;C:=4;
X0:=(A+B) < (A+C);
X1:=A < (A+B);
X2:=7 < (A+B);
X3:=XTEST < XTEST;
X4:=A < XTEST;
X5:=6 < XTEST;
X6:=(A+B) < A;
X7:=XTEST < A;
X8:=A < B;
X9:=6 < B;
X10:=(A+B) < 6;
X11:=XTEST < 6;
X12:=A < 6;
X13:=7 < 8;
TEXT(0,"LESS THAN RESULT (-8) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc GRTEQUTEST;
begin
A:=2;B:=3;C:=4;
X0:=(A+B)>= (A+C);
X1:=A>= (A+B);
X2:=7>= (A+B);
X3:=XTEST>= XTEST;
X4:=A>= XTEST;
X5:=6>= XTEST;
X6:=(A+B)>= A;
X7:=XTEST>= A;
X8:=A>= B;
X9:=6>= B;
X10:=(A+B)>= 6;
X11:=XTEST>= 6;
X12:=A>= 6;
X13:=7>= 8;
TEXT(0,"GREATER OR EQUAL RESULT (-6)=");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc LESSEQUTEST;
begin
A:=2;B:=3;C:=4;
X0:=(A+B) <= (A+C);
X1:=A <= (A+B);
X2:=7 <= (A+B);
X3:=XTEST <= XTEST;
X4:=A <= XTEST;
X5:=6 <= XTEST;
X6:=(A+B) <= A;
X7:=XTEST <= A;
X8:=A <= B;
X9:=6 <= B;
X10:=(A+B) <= 6;
X11:=XTEST <= 6;
X12:=A <= 6;
X13:=7 <= 8;
TEXT(0,"LESS OR EQUAL RESULT (-9) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc INTARRY1;
int S1,S2,P,I,J;
def SIZE=100;
begin
S1:=RESERVE(SIZE*2); S2:=RESERVE(SIZE*2);
for P:=0,SIZE-1 do [S1(P):=RESERVE(SIZE*2); S2(P):=RESERVE(SIZE*2);];
for I:=0,SIZE-1 do for J:=0,SIZE-1 do [S1(I,J):=I*J; S2(I,J):=I+J;];
A:=2;B:=3;C:=4;

S1(7,8):=(A+B);
S1(A,6):=A;
S1(XTEST,6):=7;
S1((A+B),6):=XTEST;

S2(7,8):=S1((A+B),(A+C));
S2(A,6):=S1(A,(A+B));
S2(XTEST,6):=S1(7,(A+B));
S2((A+B),6):=S1(XTEST,XTEST);
S2(6,B):=S1(A,XTEST);
S2(A,B):=S1(6,XTEST);
S2(XTEST,A):=S1((A+B),A);
S2((A+B),A):=S1(XTEST,A);
S2(6,XTEST):=S1(A,B);
S2(A,XTEST):=S1(6,B);
S2(XTEST,XTEST):=S1((A+B),6);
S2(7,(A+B)):=S1(XTEST,6);
S2(A,(A+B)):=S1(A,6);
S2((A+B),(A+C)):=S1(7,8);

X0:=S2((A+B),(A+C));
X1:=S2(A,(A+B));
X2:=S2(7,(A+B));
X3:=S2(XTEST,XTEST);
X4:=S2(A,XTEST);
X5:=S2(6,XTEST);
X6:=S2((A+B),A);
X7:=S2(XTEST,A);
X8:=S2(A,B);
X9:=S2(6,B);
X10:=S2((A+B),6);
X11:=S2(XTEST,6);
X12:=S2(A,6);
X13:=S2(7,8);

TEXT(0,"INTEGER ARRAY 1 RESULT (134) =");INTOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc INTARRY2;
int S1,S2,P,I,J;
def SIZE=100;
begin
S1:=RESERVE(SIZE*2); S2:=RESERVE(SIZE*2);

for I:=0,SIZE-1 do [S1(I):=I; S2(I):=SIZE-I;];
A:=2;B:=3;C:=4;

S1(8):=(A+B);
S1(A):=A;
S1(XTEST):=7;
S1((A+B)):=XTEST;

S2(7):=S1((A+B));
S2(A):=S1(A);
S2(XTEST):=S1(7);
S2((A+B)):=S1(XTEST);

X0:=S2((A+B));
X1:=S2(A);
X2:=S2(7);
X3:=S2(XTEST);

TEXT(0,"INTEGER ARRAY 2 RESULT (19) =");INTOUT(0,X0+X1+X2+X3);CRLF(0);
end;



proc RLARRY1;
real S1,S2;
real A1,B1,C1;
int P,I,J;
def SIZE=30;
real X0,X1,X2,X3,X4,X5,X6,X7,X8,X9,X10,X11,X12,X13;
begin
S1:=RLRES(SIZE); S2:=RLRES(SIZE);
for P:=0,SIZE-1 do [S1(P):=RLRES(SIZE*2); S2(P):=RLRES(SIZE*2);];
for I:=0,SIZE-1 do for J:=0,SIZE-1 do [S1(I,J):=FLOAT(I*J); S2(I,J):=FLOAT(I+J);];
A:=2;B:=3;C:=4;
A1:=2.0;B1:=3.0;C1:=4.0;
S1(7,8):=(A1+B1);
S1(A,6):=A1;
S1(XTEST,6):=7.0;
S1((A+B),6):=FLOAT(XTEST);

S2(7,8):=S1((A+B),(A+C));
S2(A,6):=S1(A,(A+B));
S2(XTEST,6):=S1(7,(A+B));
S2((A+B),6):=S1(XTEST,XTEST);
S2(6,B):=S1(A,XTEST);
S2(A,B):=S1(6,XTEST);
S2(XTEST,A):=S1((A+B),A);
S2((A+B),A):=S1(XTEST,A);
S2(6,XTEST):=S1(A,B);
S2(A,XTEST):=S1(6,B);
S2(XTEST,XTEST):=S1((A+B),6);
S2(7,(A+B)):=S1(XTEST,6);
S2(A,(A+B)):=S1(A,6);
S2((A+B),(A+C)):=S1(7,8);

X0:=S2((A+B),(A+C));
X1:=S2(A,(A+B));
X2:=S2(7,(A+B));
X3:=S2(XTEST,XTEST);
X4:=S2(A,XTEST);
X5:=S2(6,XTEST);
X6:=S2((A+B),A);
X7:=S2(XTEST,A);
X8:=S2(A,B);
X9:=S2(6,B);
X10:=S2((A+B),6);
X11:=S2(XTEST,6);
X12:=S2(A,6);
X13:=S2(7,8);

TEXT(0,"REAL ARRAY 1 RESULT (134) =");RLOUT(0,X0+X1+X2+X3+X4+X5+X6+X7+X8+X9+X10+X11+X12+X13);CRLF(0);
end;



proc RLARRY2;
real S1,S2;
int P,I,J;
real A1,B1,C1;
real X0,X1,X2,X3,X4,X5,X6,X7,X8,X9,X10,X11,X12,X13;
def SIZE=100;
begin
S1:=RLRES(SIZE); S2:=RLRES(SIZE);

for I:=0,SIZE-1 do [S1(I):=FLOAT(I); S2(I):=FLOAT(SIZE-I);];
A:=2;B:=3;C:=4;
A1:=2.0;B1:=3.0;C1:=4.0;
S1(8):=A1+B1;
S1(A):=A1;
S1(XTEST):=7.0;
S1((A+B)):=FLOAT(XTEST);

S2(7):=S1((A+B));
S2(A):=S1(A);
S2(XTEST):=S1(7);
S2((A+B)):=S1(XTEST);

X0:=S2((A+B));
X1:=S2(A);
X2:=S2(7);
X3:=S2(XTEST);

TEXT(0,"REAL ARRAY 2 RESULT (19) =");RLOUT(0,X0+X1+X2+X3);CRLF(0);
end;


begin
ADDTEST;
SUBTEST;
MULTEST;
DIVTEST;
EQUTEST;
NOTEQUTEST;
GREATTEST;
LESSTEST;
GRTEQUTEST;
LESSEQUTEST;
INTARRY1;
INTARRY2;
RLARRY1;
RLARRY2;
end;
