\PDIR.XPL
\	P D I R
\
\ PDIR WILL PRODUCE DIRECTORY LISTINGS
\ ON THE DEVICE IN OUTPUT UNIT 2.  THE
\ DIRECTORIES MAY BE  NORMAL  OR  LONG
\ IN FORM.  THE FOLLOWING ARE EXAMPLES
\ OF PDIR'S USE:
\
\  APX>	PDIR	  (A NORMAL DIRECTORY
\		  OF UNIT 0)
\  APX>	PDIR 3/L  (A LONG DIRECTORY OF
\		  UNIT 3)
\  APX> PDIR 4	  (A NORMAL DIRECTORY
\		  OF UNIT 4)
\  APX>	PDIR /L	  (A LONG DIRECTORY OF
\		  UNIT 0 - NOTE THAT
\		  THERE MUST BE A SPACE
\		  BETWEEN THE "PDIR" &
\		  THE SWITCH)
\
\ THIS WILL COMPILE WITH V4B OF XPL0.
\ THE 'RETURN' STATEMENTS MUST BE
\ CHANGED TO 'EXIT' TO USE V4D.
\
\ NOTE!!! IF THIS IS SAVED, THE FILE
\ EXTENTION DEFAULTS MUST!!! BE SET
\ TO BLANKS.
\
\
\ CONSTRUCTED BY ROGER NACE, DEC  1980
\
\ MOST OF THIS CODE HAS BEEN
\ BORROWED FROM APEX.XPL



'CODE'	\XPL0 V4B
REM=2		RESERVE=3	CHIN=7
CRLF=9		NUMOUT=11	TEXT=12
OPENO=14	CLOSE=15	CHOUT=8
FREAD=31;


\DIRECTORY
'ADDR'	PRDEV,	TITLE,	PRNAME,	FNAME,
	FSTAT,	FLAGS,	FREE1;

'INT'	PMAXB,	DIRDAT,	VOLUME,	FDATE,
	FBLK,	LBLK;

\NON-DIRECTORY
'ADDR'	STAB;

'INT'	OUT,	I,	LFORM,	LINIDX,
	MAXFL,	DIRDEV,	FIRBLK,	LASBLK,
	MAXSTB,	USERBLK,SYSDAT	MAXBLK;


'DEFINE'
	VALID=1;




	'PROC' PRNAM(FILE);	\PRINT A FILE NAME

	'ADDR' 	FILE;
	'INT'	K;

'BEGIN'
'FOR' K:=0,7 'DO' CHOUT(OUT,FILE(K));
CHOUT(OUT,^.);
'FOR' K:=8,10'DO' CHOUT(OUT,FILE(K));
'END';	\OF PRNAM




	'PROC'	SORT;		\SORT THE DIRECTORY IN BLOCK SEQUENCE

	'INT'	I,	J,	T;

'BEGIN'
J:=0;
'FOR' I:=0,MAXFL 'DO'
	'IF' FSTAT(I)=VALID 'THEN'
		[STAB(J):=I;J:=J+1];

MAXSTB:=J-1;
'FOR' I:=0,MAXSTB-1 'DO'
'IF' FBLK(STAB(I+1))<FBLK(STAB(I)) 'THEN'
	'BEGIN'
	J:=I;
	'REPEAT''BEGIN'
		T:=STAB(J);
		STAB(J):=STAB(J+1);
		STAB(J+1):=T;
		J:=J-1;
		'END'
	'UNTIL'
	(FBLK(STAB(J))<FBLK(STAB(J+1)))!
		(J<0);
	'END';
'END';	\OF SORT




	'PROC'	EMSIZ(I);

	'INT'	I;

'BEGIN'
FIRBLK:='IF'I<0'THEN'USERBLK'ELSE'
	(LBLK(STAB(I))+1);
LASBLK:='IF'(MAXSTB<0)!(MAXSTB=I) 'THEN'
	MAXBLK 'ELSE'
	(FBLK(STAB(I+1))-1);
'EXIT''IF' LASBLK>=FIRBLK 'THEN'
	LASBLK-FIRBLK+1 'ELSE' 0;
'END';	\OF EMSIZ




	'PROC'	BIGBLK;	\FIND THE LARGEST HOLE

	'INT'	LMAX,	FMAX,	I,	SIZE;

'BEGIN'
LMAX:=EMSIZ(-1);
FMAX:=-1;
'FOR' I:=0,MAXSTB 'DO'
	'BEGIN'
	SIZE:=EMSIZ(I);
	'IF' SIZE>LMAX 'THEN'
		[LMAX:=SIZE;FMAX:=I];
	'END';
'IF' LMAX=0 'THEN' 'EXIT' 0;
'EXIT' EMSIZ(FMAX);
'END';	\OF BIGBLK




	'PROC'	PRDAT(DAT);	\PRINT A DATE

	'INT'	DAT,	DAY,	MO;

'BEGIN'
'IF'DAT<=0'THEN'[TEXT(OUT,"NO DATE");
'EXIT'];
DAT:=DAT/32;DAY:=REM(0);
DAT:=DAT/16;MO:=REM(0);
'IF'MO <10'THEN'CHOUT(OUT,^0);
NUMOUT(OUT,MO);CHOUT(OUT,^-);
'IF'DAY<10'THEN'CHOUT(OUT,^0);
NUMOUT(OUT,DAY);CHOUT(OUT,^-);
NUMOUT(OUT,DAT+76);
'END';	\OF PRDAT




	'PROC'	PRINT(FILE);	\PRINT THE FILE DATA

	'INT'	FILE,	MIN,	MAX,	K,
		SIZE;

'BEGIN'
PRNAM(FNAME+FILE*11);
MIN:=FBLK(FILE);
MAX:=LBLK(FILE);
SIZE:=MAX-MIN+1;
TEXT(OUT,"  ");
'IF' SIZE<10  'THEN' CHOUT(OUT,^ );
'IF' SIZE<100 'THEN' CHOUT(OUT,^ );
NUMOUT(OUT,SIZE);
CHOUT(OUT,^ );
PRDAT(FDATE(FILE));
CHOUT(OUT,^ );
'IF' MIN<100 'THEN' CHOUT(OUT,^ );
NUMOUT(OUT,MIN);
CHOUT(OUT,^-);
NUMOUT(OUT,MAX);
'END';	\OF PRINT




	'PROC'	DODAT;	\PRINT A DATE

	'INT'	DAY,	MO,	YR,	DAYWRD,
		X;

'BEGIN'
DAYWRD:=RESERVE(14);
DAYWRD(0):="MON";
DAYWRD(1):="TUE";
DAYWRD(2):="WED";
DAYWRD(3):="THR";
DAYWRD(4):="FRI";
DAYWRD(5):="SAT";
DAYWRD(6):="SUN";
'IF' SYSDAT<=0 'THEN''EXIT';
YR:=SYSDAT/32;DAY:=REM(0);
YR:=YR/16;MO:=REM(0);
'IF'MO<=2'THEN'[MO:=MO+10;YR:=YR-1]
'ELSE'MO:=MO-2;
X:=REM(((26*MO-2)/10+DAY+YR+YR/4+60)/7);
TEXT(OUT,DAYWRD(X));CHOUT(OUT,^ );
PRDAT(SYSDAT);
'END';	\OF DODAT




	'PROC' DIR;	\PRINT THE DIRECTORY

	'INT'	I,	SUM,	END,	START,
		K,	FILENO,	A;

'BEGIN'

K:=0;
SYSDAT:=DIRDAT(0);
MAXBLK:=PMAXB(0);
DODAT;
TEXT(OUT,"  V:");NUMOUT(OUT,VOLUME(0));
TEXT(OUT,"  UNIT:");NUMOUT(OUT,DIRDEV);
CRLF(OUT);TEXT(OUT,TITLE);CRLF(OUT);

SORT;

'FOR' I:=0,MAXSTB 'DO'
	'BEGIN'
	'IF' LFORM#^L 'THEN'
		'BEGIN'
		'IF' REM(K/2)=0 'THEN' CRLF(OUT)
		'ELSE' TEXT(OUT,"    ");
		PRNAM(FNAME+STAB(I)*11);
		'END'
	'ELSE'
		'BEGIN'
		CRLF(OUT);
		PRINT(STAB(I));
		'END';
	K:=K+1;
	'END';

SUM:=MAXBLK-USERBLK+1;
'FOR' I:=0,MAXFL 'DO'
	'IF' FSTAT(I)=VALID 'THEN'
		'BEGIN'
		END:=LBLK(I);
		START:=FBLK(I);
		SUM:=SUM-(END-START+1);
		'END';
	
'IF' SUM<0 'THEN' SUM:=0;
CRLF(OUT);TEXT(OUT,"FREE: ");
NUMOUT(OUT,SUM);
TEXT(OUT,"   MAX: ");
NUMOUT(OUT,BIGBLK); CRLF(OUT); CRLF(OUT);

'END';	\OF DIR



'BEGIN'	\MAINLINE

MAXFL:=47;

\SETUP THE ARRAYS
I:=(MAXFL+1)*2;

\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:= RESERVE(I);
LBLK:= RESERVE(I);
\BLOCK 3
FREE1:=RESERVE(74);
PRDEV:=RESERVE(1);
PMAXB:=RESERVE(2);
PRNAME:=RESERVE(11);
TITLE:=RESERVE(60);
VOLUME:=RESERVE(2);
DIRDAT:=RESERVE(2);
FDATE:=RESERVE(I);
FLAGS:=RESERVE(8);

\NON DIR STUFF

USERBLK:=17;

LINIDX:=$BF5A;	\INPUT LINE POINTER (767 IS NO INPUT)

STAB:=RESERVE(48);

DIRDEV:=0; LFORM:=0;

'IF' LINIDX(0)#767 'THEN'
	'BEGIN'
	I:=CHIN(0);
	'IF' I#^/ 'THEN'
		[ DIRDEV:=I&7;
		I:=CHIN(0); ];
	'IF' I=^/ 'THEN'
		LFORM:=CHIN(0);
	'END';

FREAD(DIRDEV,9,FNAME,4);

OUT:=2;

OPENO(OUT);
CRLF(OUT);

DIR;

CRLF(OUT);
CLOSE(OUT);

'END'; \OF MAINLINE
