\PETALS.XPLV5D			11/3/81
\A PUZZLE BY RICHARD WILLMORE.
\APPLEFICATION BY ROGER NACE.
\XPLV5DIZED BY LOREN BLANEY.
\NOTE: THIS PROGRAM CONTAINS A SPECIAL KEYBOARD HANDLER FOR
\ A MEMORY-MAPPED KEYBOARD DEVICE, AND IS NOT PORTABLE
\ WITHOUT SOME MODIFICATION.


code
RAN=1,		RESERVE=3,	Cʹ7,		CHOUT=8,
TEXT=12,	OPENI=13,	OPENO=14,	CURSOR=23
SOUND=39;

def CR=$0D, FF=$0C, BS=8, TV=0, KB=0;	\I/O STUFF

int SOLVED;
int	PETALS,	\THE ANSWER--THE NUMBER OF PETALS
	GUESS, MUL, INAROW, ODDCOUNT;
int NOCOUNT, NUMUSED;

char DICE, USED, APPLEIO;


proc PR(STRING);
char STRING;
begin
TEXT(TV,STRING);
end;


proc PRT(STRING);
char STRING;
int I;
begin
I:=0;
while STRING(I)<128 do
	begin
	if STRING(I)=^+ then
		begin
		SOUND(1,10,50+RAN(100));
		I:=I+1;
		CHOUT(TV,STRING(I));
		end
	else CHOUT(TV,STRING(I));
	I:=I+1;
	end;
end;


proc SPELL(N);
int N;
begin
if N<14 ! N=20 then
	case N of
		0: PR("ZERO");
		2: PR("TWO");
		4: PR("FOUR");
		6: PR("SIX");
		8: PR("EIGHT");
		10: PR("TEN");
		12: PR("TWELVE")
	else PR("TWENTY")
else [SPELL(N-10); PR("TEEN")];
end;


proc CLRTWO(YCURS);	\BLANK TWO LINES STARTING AT "YCURS"
int YCURS, I;
begin
CURSOR(0,YCURS);
for I:=1,4 do TEXT(TV,"          ");
CURSOR(0,YCURS+1);
for I:=1,4 do TEXT(TV,"          ");
end;


proc SAYWHAT;
begin
CLRTWO(17); CURSOR(0,17);
if RAN(2) then PRT("+KINDLY ESCHEW OBFUSCATION. ")
else PRT("+YOU ARE KIDDING AREN'T YOU? ");
end;


proc REPROMPT;
begin
CLRTWO(17); CURSOR(0,17);
if RAN(2) then PRT("+HELLO!  +HELLO!  +IS ANYBODY OUT THERE? ")
else if RAN(2) then PRT("+WAKE UP!! +SAY SOMETHING! ");
if MUL#1 then
	[CURSOR(16,14);
	if RAN(2) then PRT("+FORGET THE RETURN KEY? ")
	else if RAN(2) then PRT("+IS THAT IT?   +HUH? +HUH? ")];
end;


proc CLEARUSED;
int I;
begin
for I:=0,4 do USED(I):=false; 
NUMUSED:=0;
end;


proc HARASS;
int PICK;
begin
PICK:=RAN(5);
while USED(PICK) do PICK:=RAN(5);
USED(PICK):=true; NUMUSED:=NUMUSED+1;
if NUMUSED=5 then CLEARUSED;
CURSOR(0,17);
case PICK of
	0: PRT("+YOU'RE NOT DOING VERY WELL AT THIS. ");
	1: PRT("+COME ON NOW, IT'S NOT THAT TRICKY. ");
	2: PRT("+I WONDER IF YOU'RE PAYING ATTENTION. ");
	3: PRT("+LOOK ON THE BRIGHT SIDE...+THE AVERAGE
CHIMPANZEE DOES EVEN WORSE THAN THIS. ")
else PRT("+BY THE WAY, DID +I MENTION
THAT WE ARE PLAYING FOR MONEY? ");
end;


proc GETGUESS;
int I, XC, CH, DONE;
begin
GUESS:=0; I:=0; XC:=13; MUL:=1; DONE:=false;
while not DONE do
	begin
	CH:=APPLEIO(0);
	I:=I+1;
	SOUND(0,1000,1);	\DELAY
	if I>100 then [I:=0; REPROMPT]
	else if CH>128 then
		begin
		CH:=CH & 127;
		APPLEIO(16):=0;
		DONE:=(CH=CR);
		if not DONE then
			begin
			if CH=BS & MUL>1 then	\BACK SPACE
				[XC:=XC-1;
				CURSOR(XC,14); TEXT(TV," ");
				GUESS:=GUESS/10; MUL:=MUL/10]
			else if (CH<^0) ! (CH>^9) then SAYWHAT
			else [GUESS:=GUESS*MUL+(CH-^0);
				CURSOR(XC,14); CHOUT(TV,CH);
				MUL:=MUL*10; XC:=XC+1];
			end;
		end;
	end;
end;


proc QUERY;
int I;
begin
CLRTWO(13);
CURSOR(0,14); PRT("+YOUR GUESS ? ");
CLRTWO(15); CLRTWO(17); CLRTWO(19);
GETGUESS; CLRTWO(17);
if GUESS & 1 then ODDCOUNT:=ODDCOUNT+1;
if ODDCOUNT=3 then
	[CURSOR(0,8); PRT("+ANOTHER HINT... ");
	CURSOR(2,9);PRT("+THE ANSWER IS ALWAYS EVEN! ")];
end;


proc YES;	\HE GUESSED RIGHT
int I;
begin
CURSOR(0,15); PRT("+CORRECT!  ");
INAROW:=INAROW+1;
if INAROW=3 then
	[PRT("+I THINK YOU MAY HAVE SOMETHING! ");
	SOUND(0,1000,70)]	\DELAY
else if INAROW>4 then
	begin
	SOLVED:=true;
	CURSOR(0,16);
	PRT("+CONGRATULATIONS, YOU KNOW THE SECRET! ");
	CURSOR(8,17); PRT("(+DON'T TELL ANYONE.) ");
	CURSOR(8,19);
	PRT("+NEXT!! ");
	SOUND(0,1000,700);	\DELAY
	end;
end;


proc NO;
int I;
begin
CLRTWO(14); CURSOR(0,15);
if INAROW>2 then PRT("+YOU BLEW IT KID. ")
else PRT("+NO, THAT'S NOT RIGHT. ");
CURSOR(0,16); PRT("+THE ANSWER IS  ");
SPELL(PETALS); PR(".");
INAROW:=0;
NOCOUNT:=NOCOUNT+1;
if NOCOUNT>5 & RAN(3)=2 then HARASS else PRT("  +TRY AGAIN. ");
CURSOR(0,19); PRT("+TYPE RETURN TO CONTINUE. ");
OPENI(KB); I:=CHIN(KB);
end;


proc ROLL;
int I,B;
char BOUNCES;


proc TICK;	\MAKE TICK NOISE
int I;
begin
SOUND(1,1,1000);
\APPLEIO(48):=0;
\I:=APPLEIO(48);
end;


proc SHOW (WHICH, WHAT);
int WHICH, WHAT, X, EVENS, ODDS;
begin
EVENS:=WHAT/2; ODDS:=WHAT-2*EVENS;
X:=WHICH*8+1;
TICK;

CURSOR(X,10);
case EVENS of
	1: PR("O    ");
	2: PR("O   O");
	3: PR("O O O")
else PR("     ");

CURSOR(X,11);
if ODDS=1 then PR("  O  ") else PR("     ");

CURSOR(X,12);
case EVENS of
	1: PR("    O");
	2: PR("O   O");
	3: PR("O O O")
else PR("     ");
end;	\SHOW


begin	\ROLL
BOUNCES:=RESERVE(5);
for I:=0,4 do DICE(I):=RAN(6)+1;
for I:=0,4 do BOUNCES(I):=RAN(10)+5;
for B:=0,15 do for I:=0,4 do
	[if BOUNCES(I)>B then SHOW(I,RAN(6)+1);
	if BOUNCES(I)=B then SHOW(I,DICE(I))];
CURSOR(0,14);
end;	\ROLL


proc COUNT;
int I;
begin
PETALS:=0;
for I:=0,4 do
	if (DICE(I) & 1)=1 then PETALS:=PETALS+DICE(I)-1;
end;


begin	\MAIN
DICE:=RESERVE(5); USED:=RESERVE(5);
APPLEIO:=$C000;		\BASE ADDRESS OF KEYBOARD INPUT
OPENO(TV);
loop	begin
	SOLVED:=false; CLEARUSED;
	NOCOUNT:=0; ODDCOUNT:=0; INAROW:=0;
	CHOUT(TV,FF);
	PRT("  +THIS IS THE GAME CALLED +PETALS +AROUND
THE +ROSE.  +I WILL  ROLL 5 DICE AND  YOU
TRY  TO  GUESS  THE  NUMBER   WHICH  IS
DERIVED  FROM THE FACES OF THE  DICE BY
A  SECRET  ALGORITHM.  +WHEN  YOU  GUESS
CORRECTLY 5 TIMES IN A ROW, YOU'VE WON.
+HINT...
  +THE NAME OF THE GAME IS SIGNIFICANT! ");

	CLRTWO(8);
	while not SOLVED do
		begin
		ROLL; COUNT; QUERY;
		if GUESS=PETALS then YES
		else NO;
		end;
	end;
end;	\MAIN
