\SIEVE2.XPL	JUL-27-92
\Eratosthenes Sieve Prime Number Program

code RESERVE=3, CRLF=9, INTOUT=11, TEXT=12;
define SIZE = 8190;


proc	SIEVE;
integer	PRIME, COUNT, ITER, I, K;
addr	FLAGS;
begin
FLAGS:=RESERVE(SIZE+1);				\allocate array space
TEXT(0,"100 iterations
");
for ITER:= 1, 100 do				\do program 10 times
	begin
	COUNT:= 0;				\prime counter
	for I:= 0, SIZE do
		FLAGS(I):= true;		\set flags all true
	for I:= 0, SIZE do
	    if FLAGS(I) then			\found a prime
		begin
		PRIME:= I+I+3;			\twice the index + 3
		\INTOUT(0,PRIME); CRLF(0);
		K:= I + PRIME;			\first multiple to kill
		while K <= SIZE do
			begin
			FLAGS(K):= false;	\zero a non-prime
			K:= K + PRIME		\next multiple
			end;
		COUNT:= COUNT + 1		\primes found
		end;
	end;
INTOUT(0,COUNT); TEXT(0," primes
");						\primes found in 10th pass
end;


begin
SIEVE;
end;
