code	\THE REQUIRED INTRINSICS:
ABS=0		REM=2		RESERVE=3	SWAP=4
CHIN=7		CHOUT=8		CRLF=9		INTIN=10
INTOUT=11	TEXT=12		OPENI=13	OPENO=14
CLOSE=15	HEXOUT=27
TRAP=17,	GETERR=22,	FSET=24,	FOPEN=29,
FCLOSE=32,	SOFTINT=34,	GETREG=35,	BLIT=36;
code real	FLOAT=49,	RLRES=46;


integer	INHAND,OUTHAND,DIHAND;	\INPUT HANDLE
integer CH,CHU,CHAR,WDCNT,WRDLST,WRDPNT,WORDS,I,K,A;
integer ENDOFFILE,WRDIDX,FOUND,WRDSTA,STP,WDLN,WRDREP,NXTREP,LAST,DATEND;
integer SRCMOD,APPEND,IGNORE,DICMOD,DICCNT;
address WORD,PNT,NPNT,FILNAM,TEMPNAME,STRING,DATA;

def	EOF=$1A,LF=$A,CR=$D,TAB=$9,ESC=$1B,BSP=$8;
def 	MAXCHAR=19,MAXWRD=2999,MAXREP=99,MAXDAT=28000;
def 	MARK=^|;


\----------------------------------------------------------------

procedure ERROR(K);
integer K;

begin 
CRLF(0);
TEXT(0,"Out of memory =");INTOUT(0,K);CRLF(0);
exit ;
end ;


\----------------------------------------------------------

procedure IBMOPEN;
integer PSEG,CSEG,SYSINF;
addres TAIL,TLEN;

	function MAKUP(C);
	\CONVERT C TO UPPERCASE
	int C;
	return if C>=^a & C<=^z then C-32 else C;


	function GETSWT;
	\FIND, REMOVE AND RETURN NEXT AVAILABLE SWITCH
	integer P,T;
	begin
	for P:=0,TLEN(0) do if TAIL(P)=^/ then
		begin
		TAIL(P):=$20;	\so we know we took it
		if P<TLEN(0) then
			begin
			T:=TAIL(P+1);	\the switch character
			TAIL(P+1):=$20;	\so we know we took it
			return MAKUP(T);\in upper case, return it
			end;
		end;
	return 0;	\if none, return zero.
	end;



	procedure PARSE;
	address EXT1,EXT2;
	integer P,EFLG,I;
	begin
	EXT1:=".TXT";
	EXT2:=".MOD";
	P:=0;
	EFLG:=false;
	\PARSE COMMAND TAIL FOR EXTENTION

	loop
		begin
		if TAIL(P)=^. then
			begin
			EFLG:=true;
			quit;
			end;
		P:=P+1;
		if P>=TLEN(0) then
			begin
			EFLG:=false;
			quit;
			end;
		end;

	\SET EXTENTION AND INPUT HANDLE
	if not EFLG then
		for I:=0,3 do TAIL(P+I):=EXT1(I);
	for I:=0,79 do FILNAM(I):=0;
	for I:=1,P+3 do FILNAM(I-1):=TAIL(I);
	FILNAM(P+2):=FILNAM(P+2)&$7F;

	INHAND:=FOPEN(FILNAM,0);
	end;

begin	\OF IBMOPEN

\GET COMMAND TAIL FROM PSP
TLEN:=RESERVE(80);
TAIL:=TLEN+1;
SYSINF:=GETREG;			\FETCH CPU REGISTERS
PSEG:=SYSINF(11);		\get the segment register contents
CSEG:=SYSINF(12);
BLIT(PSEG,$80,CSEG,TLEN,79);	\copy over the command tail
if TLEN(0)>79 then TLEN(0):=79; \correct the limit

if GETSWT=^A then APPEND:= true ;
if APPEND then [TEXT(0,"APPEND TO DICT...");CRLF(0)];

\TEXT(0,"SWITCH=");CHOUT(0,GETSWT);CRLF(0);


\PARSE COMMAND LINE AND SET HANDLES
PARSE;

\OPEN FILES
FSET(INHAND,^I);
end;



procedure IBMCLOSE;
integer SYSINFO;
begin 
FCLOSE(OUTHAND);
FCLOSE(INHAND);
SYSINFO:=GETREG;
SYSINFO(0):=$4100;	\DELETE ORIGINAL FILE
SYSINFO(3):=FILNAM;
SYSINFO(9):=SYSINFO(12);
SOFTINT($21);
if SYSINFO(7) then 
	begin 
	TEXT(0,"FILE DELETE FAILED");
	CRLF(0);
	exit ;
	end ;

SYSINFO(0):=$5600;	\RENAME TEMP FILE TO ORGINAL FILE
SYSINFO(3):=TEMPNAME;	\FROM THIS NAME
SYSINFO(4):=FILNAM;	\TO THIS NAME
SYSINFO(9):=SYSINFO(12);
SYSINFO(11):=SYSINFO(12);
SOFTINT($21);
if SYSINFO(7) then 
	begin 
	TEXT(0,"FILE RENAME FAILED");
	CRLF(0);
	exit ;
	end ;
end ;



procedure DICTCLOSE;
integer SYSINFO;
addr OLDNAME,NEWNAME;
begin 
OLDNAME:="DICT.@@@ ";
NEWNAME:="DICT.WDS ";
OLDNAME(8):=0;
NEWNAME(8):=0;

if DICMOD then 
	begin 
	SYSINFO:=GETREG;
	SYSINFO(0):=$4100;	\DELETE ORIGINAL FILE
	SYSINFO(3):=NEWNAME;
	SYSINFO(9):=SYSINFO(12);
	SOFTINT($21);
	if SYSINFO(7) then 
		begin 
		TEXT(0,"FILE DELETE FAILED");
		CRLF(0);
		exit ;
		end ;

	SYSINFO(0):=$5600;	\RENAME TEMP FILE TO ORGINAL FILE
	SYSINFO(3):=OLDNAME;	\FROM THIS NAME
	SYSINFO(4):=NEWNAME;	\TO THIS NAME
	SYSINFO(9):=SYSINFO(12);
	SYSINFO(11):=SYSINFO(12);
	SOFTINT($21);
	if SYSINFO(7) then 
		begin 
		TEXT(0,"FILE RENAME FAILED");
		CRLF(0);
		exit ;
		end ;
	TEXT(0,"DICT.WDS is updated ");
	end 
else 	begin 
	SYSINFO:=GETREG;
	SYSINFO(0):=$4100;	\DELETE NEW FILE
	SYSINFO(3):=OLDNAME;
	SYSINFO(9):=SYSINFO(12);
	SOFTINT($21);
	if SYSINFO(7) then 
		begin 
		TEXT(0,"FILE DELETE FAILED");
		CRLF(0);
		exit ;
		end ;
	TEXT(0,"DICT.WDS is unchanged ");
	end ;
INTOUT(0,DICCNT);
TEXT(0," words.");
CRLF(0);
end ;

\-----------------------------------------------------------------


procedure LOOKUP;	
\SEARCH EXISTING LIST FOR THE WORD
\IF FOUND, LEAVE WRDIDX POINTING TO THE WORD
\OTHERWISE, LEAVE WRDIDX POINTING TO THE FIRST LATER WORD
\THAT IS, TO THE NEXT WORD IN THE SORT ORDER.
int MIN,MAX;
addr PNT;
begin 
if WORDS=0 then 
	begin 
	FOUND:= false ;
	WRDIDX:=0;
	return ;
	end ;

FOUND:= true ;
MIN:=0;
MAX:=WORDS-1;
loop 	begin 
	WRDIDX:=(MIN+MAX)/2;
	PNT:=WRDLST(WRDPNT(WRDIDX));

	WDLN:=0;
	loop 	begin 
		if PNT(WDLN)=0 then 
		if WORD(WDLN)=0 then return ;
		if WORD(WDLN)#PNT(WDLN) then quit ;
		WDLN:=WDLN+1;
		end ;
	if WORD(WDLN)>PNT(WDLN) then 
		begin 
		if (WRDIDX+1)=MIN then quit ;
		MIN:=WRDIDX+1;
		end 
	else 	begin 
		if (WRDIDX-1)=MAX then quit ;
		MAX:=WRDIDX-1;
		end ;
	end ;

if WORD(WDLN)>PNT(WDLN) then WRDIDX:=WRDIDX+1;
WDLN:=0;
FOUND:= false ;		\SHOULD USE WDLN TO TELL!
end ;



procedure INSERT;
int I,A;
addr PNT;
begin 
LOOKUP;				\SEARCH FOR IT IS EXISTING LIST
if FOUND then return ;	\ALREADY IN THE LIST - IGNORE IT

if (WRDIDX<0)!(DATEND>(MAXDAT-MAXCHAR)) then ERROR(1);
CHOUT(0,^.);

\PUT ACTUAL WORD IN THE WRDLST
PNT:=DATA+DATEND;
WRDLST(WORDS):=PNT;
I:=0;
repeat begin 
	CH:=WORD(I);
	PNT(I):=CH;
	I:=I+1;
	end 
until CH=0;
DATEND:=DATEND+I;

\NOW PUT THE POINTER TO IT INTO WRDPNT:
\FIRST PUSH DOWN THE POINTERS TO MAKE ROOM FOR A NEW ONE:
I:=WORDS-1;
repeat begin 
	WRDPNT(I+1):=WRDPNT(I);
	I:=I-1;
	end 
until I<WRDIDX;

WRDPNT(WRDIDX):=WORDS;
WORDS:=WORDS+1;
if WORDS>=MAXWRD then ERROR(2);
end ;





function  GETWORD;
\READ NEXT WORD FROM SOURCE TEXT
int K,I;


procedure GETCH;	\READ & PREPROCESS THE NEXT CHAR FROM SOURCE
begin 
if ENDOFFILE then return ;
repeat begin 
	CHAR:=CHIN(3);
	STRING(STP):=CHAR;
	if STP<79 then STP:=STP+1;
	end 
until (CHAR#LF);
if CHAR=EOF then ENDOFFILE:= true ;
if (CHAR>=^a)&(CHAR<=^z) then CHAR:=CHAR-32;
end ;


begin 
STP:=0;
repeat GETCH until ENDOFFILE!((CHAR>=^A)&(CHAR<=^Z));
if ENDOFFILE then return 0;
K:=0;
repeat begin 
	WORD(K):=CHAR;
	if K<MAXCHAR then K:=K+1;
	GETCH;
	end 
until not (  (CHAR=^')!((CHAR>=^A)&(CHAR<=^Z)) );
if WORD(K-1)=^' then K:=K-1;	\KILL POST APOSTROPHY
if WORD(K-2)=^' then 
if (WORD(K-1)=^s)!(WORD(K-1)=^S) then K:=K-2;	\KILL POSESSIVE "'S"
for I:=K,MAXCHAR do WORD(I):=0;
WDCNT:=WDCNT+1;
return K;	\RETURN WORD LENGTH
end ;




procedure GETDICT;
\READ NEXT WORD FROM DICTIONARY
int K;
begin 
K:=0;
CHAR:=CHIN(3);
if CHAR=EOF then [ENDOFFILE:= true ; return ];
loop 	begin 
	if CHAR=CR then quit ;
	WORD(K):=CHAR;
	if K<MAXCHAR then K:=K+1;
	CHAR:=CHIN(3);
	end ;
CHAR:=CHIN(3);	\EAT THE LF
WORD(K):=0;
DICCNT:=DICCNT+1;
end ;



begin	\MAIN
FILNAM:=RESERVE(80);
STRING:=RESERVE(80);
WORD:=RESERVE(MAXCHAR+1);
WRDLST:=RESERVE((MAXWRD+1)*2);
WRDPNT:=RESERVE((MAXWRD+1)*2);
WRDSTA:=RESERVE((MAXWRD+1)*2);
DATA:=RESERVE(MAXDAT);
WRDREP:=RESERVE((MAXREP+1)*2);
for I:=0,MAXREP do WRDREP(I):=-1;
for I:=0,MAXWRD do 
	begin 
	WRDLST(I):=-1;
	WRDPNT(I):=-1;
	WRDSTA(I):=0;
	end ;
DATEND:=0;


APPEND:= false ;
IGNORE:= false ;

TEXT(0,"SPELL CHECKER V1.0");CRLF(0);
TEXT(0,"Scanning source text....");CRLF(0);
IBMOPEN;
OPENI(3);
ENDOFFILE:= false ;


WORDS:=0;
WDCNT:=0;
repeat 
	begin 
	I:=GETWORD;
	if I>1 then INSERT;
	end 
 until ENDOFFILE;

CRLF(0);
INTOUT(0,WDCNT);TEXT(0," WORDS, ");
INTOUT(0,WORDS);TEXT(0," DIFFERENT");CRLF(0);

\NOW CHECK AGAIST DICTIONARY
TEXT(0,"Check against dictionary....");CRLF(0);
SRCMOD:= false ;

DIHAND:=FOPEN("DICT.WDS",0);
FSET(DIHAND,^I);
OPENI(3);
ENDOFFILE:= false ;


OUTHAND:=FOPEN("DICT.@@@",1);
FSET(OUTHAND,^O);
OPENO(3);
DICMOD:= false ;
DICCNT:=0;

A:=0;
NXTREP:=0;
GETDICT;
loop 	begin 
	if A=WORDS then quit ;	\DONE ALL WORDS
	PNT:=WRDLST(WRDPNT(A));

\	TEXT(0,"LOOKING FOR=");
\	'FOR'I:=0,MAXCHAR'DO'CHOUT(0,PNT(I));
\	CRLF(0);

	loop 	begin 		\CHECK FOR THIS WORD IN THE DICT
		I:=0;
		loop 	begin 
			if WORD(I)=0 then 
			if PNT(I)=0 then quit ;
			if WORD(I)#PNT(I) then quit ;
			I:=I+1;
			end ;
		if WORD(I)<PNT(I) then 
			begin 
			if ENDOFFILE then quit ;
			K:=0;
			loop 	begin 	\ADD IT TO DICT
				CHAR:=WORD(K);K:=K+1;
				if CHAR=0 then quit ;
				CHOUT(3,CHAR);
				end ;
			CRLF(3);
			GETDICT;
			end 
		else quit ;
		end ;


	if ENDOFFILE!(WORD(I)>PNT(I)) then 
		begin 
		TEXT(0,"WORD NOT IN DICT: ");

		K:=0;
		loop 	begin 
			CHAR:=PNT(K);K:=K+1;
			if CHAR=0 then quit ;
			CHOUT(0,CHAR);
			end ;
		CHOUT(0,^ );

		CHAR:=0;
		if IGNORE then CHAR:=^ ;
		if APPEND then CHAR:=TAB;
		if CHAR=0 then CHAR:=CHIN(1);
		if CHAR=ESC then [IGNORE:= true ;CHAR:=^ ];

		if (CHAR>=^a) then CHAR:=CHAR-32;
		if CHAR=TAB then 
			begin	\ADD IT TO THE DICT 
			K:=0;
			loop 	begin
				CHAR:=PNT(K);K:=K+1;
				if CHAR=0 then quit ;
				CHOUT(3,CHAR);
				end ;
			CRLF(3);
			TEXT(0,"ADD TO DICT");
			DICMOD:= true ;
			DICCNT:=DICCNT+1;
			end \END OF ADD TO DICT
		else if CHAR=CR then 
			begin 
			WRDSTA(A):=1; \MARK IT REQUESTED
			TEXT(0,"MARK IT");
			SRCMOD:= true ;
			end 
		else if (CHAR>=^A)&(CHAR<=^Z) then 
			begin \REPLACE IT
			TEXT(0,"REPLACE WITH: ");

			\PUT NEW  WORD IN THE DATA ARRAY
			if (DATEND>(MAXDAT-MAXCHAR)) then ERROR(3);
			NPNT:=DATA+DATEND;
			if NXTREP<MAXREP then NXTREP:=NXTREP+1;
			WRDSTA(A):=NPNT;

			K:=0;
			loop 	begin 
				if CHAR=CR then quit ;
				if (CHAR>=^a)&(CHAR<=^z) then CHAR:=CHAR-32;

				if CHAR#BSP then 
					begin 
					NPNT(K):=CHAR;
					CHOUT(0,CHAR);
					K:=K+1;
					end 
				else 	begin 
					CHOUT(0,BSP);
					CHOUT(0,^ );
					CHOUT(0,BSP);
					if K>0 then K:=K-1;
					end ;

				CHAR:=CHIN(1);
				end ;
			NPNT(K):=0;
			DATEND:=DATEND+K+1;
			SRCMOD:= true ;
			end \END OF REPLACE IT
		else TEXT(0," IGNORE");
		CRLF(0);
		end 
	else if PNT(I)=0 then 
		begin 
\		TEXT(0,"WORD FOUND");CRLF(0);
		end ;

	A:=A+1;
\	CRLF(0);
	end ;

loop 	begin 		\FINISH DICT SCAN AND OUTPUT
	if ENDOFFILE then quit ;
	K:=0;
	loop 	begin 	\ADD IT TO DICT
		CHAR:=WORD(K);K:=K+1;
		if CHAR=0 then quit ;
		CHOUT(3,CHAR);
		end ;
	CRLF(3);
	GETDICT;
	end ;

CLOSE(3);
FCLOSE(OUTHAND);
FCLOSE(DIHAND);
DICTCLOSE;

\DICT IS NOW UPDATED

if not SRCMOD then 
	begin 
	TEXT(0,"THE DEED IS DONE");
	CRLF(0);
	exit ;
	end ;

\PREPARE TO UPDATE SOURCE FILE:
TEXT(0,"Updating source file...");CRLF(0);
FSET(INHAND,^I);
OPENI(3);
ENDOFFILE:= false ;

TEMPNAME:="temp.@@@ ";
TEMPNAME(8):=0;

OUTHAND:=FOPEN(TEMPNAME,1);
FSET(OUTHAND,^O);
OPENO(3);

repeat begin 

	loop 	begin 
		if GETWORD#1 then quit ;
		for I:=0,STP-1 do CHOUT(3,STRING(I));
		end ;

	LOOKUP;
	if not FOUND then TEXT(0,"WHAT?");

	if WRDSTA(WRDIDX)#0 then \REPLACEMENT REQUESTED 
		begin 
		\first, output from STRING up to the word: 
		PNT:=WRDLST(WRDPNT(WRDIDX));
		CHAR:=PNT(0);	\THE FIRST CHAR OF THE WORD
		I:=0;
		loop 	begin 
			CH:=STRING(I);
			if CH>=^a then CHU:=CH-32 else CHU:=CH;
			if CHU=CHAR then quit ; \found first char
			CHOUT(3,CH);
			I:=I+1;
			end ;
		LAST:=I+WDLN-1;
		K:=0;
		PNT:=WRDSTA(WRDIDX);	\pointer to replacement word

	if PNT>1 then 
		begin 
		\insert replacement word, using case of original word
		loop 	begin 
			CH:=PNT(K);
			if (STRING(I)>=^a)!(STRING(I)=^') then 
 			if (CH>=^A)&(CH<=^Z) then CH:=CH+32;
			K:=K+1;
			if CH=0 then quit ;
			if I<LAST then I:=I+1;
			CHOUT(3,CH);
			end ;
		end 
	else 	begin 
		CHOUT(3,MARK);
		for I:=I,LAST do CHOUT(3,STRING(I));
		CHOUT(3,MARK);
		end ;

		for I:=LAST+1,STP-1 do CHOUT(3,STRING(I));
		end  \MODIFY REQUESTED
	else 
		for I:=0,STP-1 do CHOUT(3,STRING(I)); \LEAVE AS IS

	end 
until ENDOFFILE;

CLOSE(3);
IBMCLOSE;
TEXT(0,"THE DEED IS DONE");
CRLF(0);

end;	\MAIN
