\SQUASH.XPL
\SQUASH FOR APEX V1.0

'CODE'
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
CHIN=7,		CHOUT=8,	CRLF=9,		INTIN=10,
INTOUT=11,	TEXT=12,	INITI=13,	INITO=14,
CLOSE=15,	FWRITE=30,	FREAD=31,
ABORT=16,	SPACE=18;


\THE DIRECTORY
'ADDRESS'
	TITLE,	\TITLE OF THE VOLUME
	VOLUME,
	FLAGS,
	RNAM,	\THE REMEMBERED FILE
	FNAME,	\THE FILE NAMES
	FSTAT,	\THE FILE STATUS
	BLKUSE,	\BLOCK BIT MAP
	UNUSED;	\FREE DIRECTORY SPACE
\INTEGER ARRAYS IN THE DIRECTORY
'INTEGER'
	PMAXB,	\DRIVE SIZE
	DIRDAT,	\DIRECTORY DATE
	FDATE,	\DATE OF FILES
	FBLK,	\THE FIRST BLOCK
	LBLK;	\THE LAST BLOCK


\THE SYSTEM GLOBALS:
'ADDRESS'
	STAB;	\FOR SORT

'INTEGER'
	DEVICE,
	DIRSIZ,	\DIR SIZE
	DIRBLK,	\WHERE DIRECT IS
	USERBLK,\FIRST USER BLOCK
	FIRBLK,	\FIRST BLOCK OF FILE
	LASBLK,	\LAST BLOCK OF FILE
	FLNO,	\NUMBER OF FILE
	MAXBLK,	\HIGHEST BLOCK
	MAXFL,	\HIGHEST FILE NO
	CHAR,	\INPUT CHARACTER
	SWITCH,	\USER FILE SWITCH
	ARG1,	\USER ARGUMENT
	ARG2,	\USER ARGUMENT
	SPECIAL,\SPECIAL BITS IN PROGRAM FILE REQUEST
	SYSDAT,	\SYSTEM DATE
	INSIZE,	\SIZE OF LAST OPENED INFILE
	INDATE,	\DATE OF LAST INFILE
	MAXSTB,	\SIZE OF STAB
	FILENO;	\RUN FILE NUMBER

\FOR MAIN
'INTEGER'I,UBL;

\CONSTANTS

\FILE STATUS IN THE DIRECTORY
'DEFINE' NULL=0,TENTATIVE=255,REPLACE=254,VALID=1;

'DEFINE'DEFDEV=$5F;



	'PROCEDURE'WRTDIR;

'BEGIN'
FWRITE(DEVICE,DIRBLK,FNAME,DIRSIZ);
'END';



	'PROCEDURE'PRINT(FILE);
	'INTEGER'FILE,MIN,MAX,K,SIZE;

'BEGIN'
'FOR'K:=0,7'DO'CHOUT(0,FNAME(FILE*11+K));
CHOUT(0,^.);
'FOR'K:=8,10'DO'CHOUT(0,FNAME(FILE*11+K));
MIN:=FBLK(FILE);
MAX:=LBLK(FILE);
SIZE:=MAX-MIN+1;
TEXT(0,"  ");INTOUT(0,SIZE);
'IF'SIZE<10'THEN'CHOUT(0,^ );
'IF'SIZE<100'THEN'CHOUT(0,^ );
CHOUT(0,^ );
INTOUT(0,MIN);
'END';

	'PROCEDURE'RDDIR;

'BEGIN'
FREAD(DEVICE,DIRBLK,FNAME,DIRSIZ);
MAXBLK:=PMAXB(0);
'END';


	'PROCEDURE'SORT;
	'INTEGER'I,J,T;

'BEGIN'\BUBBLE SORT THE FILES INTO ACENDING FBLK
J:=0;
'FOR'I:=0,MAXFL'DO'
	'IF' FSTAT(I)=VALID'THEN'
		[STAB(J):=I;J:=J+1];
MAXSTB:=J-1;
'FOR'I:=0,MAXSTB-1'DO'
'IF'FBLK(STAB(I+1))<FBLK(STAB(I))'THEN'
	\WE ARE OUT OF ORDER SO...
	'BEGIN'
	J:=I;
	'REPEAT''BEGIN'
		T:=STAB(J);
		STAB(J):=STAB(J+1);
		STAB(J+1):=T;
		J:=J-1;
		'END'
	'UNTIL'(FBLK(STAB(J))<FBLK(STAB(J+1)))!(J<0);
	'END';
'END';

	'PROC'COPY(FROM,TO,SIZE);
	'INT'FROM,TO,SIZE,BUFSIZ;
	'ADR'BUFFER;

'BEGIN'
BUFSIZ:=SPACE/256-4;
'IF'BUFSIZ<=0'THEN'BUFSIZ:=127;
BUFFER:=RESERVE(BUFSIZ*256);
'WHILE'SIZE>BUFSIZ'DO'
	'BEGIN'
	FREAD(DEVICE,FROM,BUFFER,BUFSIZ);
	FWRITE(DEVICE,TO,BUFFER,BUFSIZ);
	FROM:=FROM+BUFSIZ;
	TO:=TO+BUFSIZ;
	SIZE:=SIZE-BUFSIZ;
	'END';
FREAD(DEVICE,FROM,BUFFER,SIZE);
FWRITE(DEVICE,TO,BUFFER,SIZE);
'END';


	'PROCEDURE'MOVE(I);
	'INTEGER'I,FBL,LBL,SIZ,FL;

'BEGIN'
FL:=STAB(I);
FBL:=FBLK(FL);
LBL:=LBLK(FL);
SIZ:=LBL-FBL+1;
'IF'UBL<FBL'THEN'
	'BEGIN'
	TEXT(0,"MOVING: ");PRINT(FL);
	TEXT(0,"  TO  ");INTOUT(0,UBL);
	CRLF(0);
	COPY(FBL,UBL,SIZ);
	FBLK(FL):=UBL;
	LBLK(FL):=UBL+SIZ-1;
	WRTDIR;
	'END';
UBL:=LBLK(FL)+1;
'END';




'BEGIN'\MAIN PROC\

DIRBLK:=9;
DIRSIZ:=4;
USERBLK:=17;

MAXFL:=47;	\SELECT SO THAT DIRSIZ IS RIGHT


\RESERVE THE ARRAYS
I:=(MAXFL+1)*2;
\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(I);
LBLK:=RESERVE(I);
\BLOCK 3
UNUSED:=RESERVE(75);
PMAXB:=RESERVE(2);
RNAM:=RESERVE(11);
TITLE:=RESERVE(62);
VOLUME:=RESERVE(2);
DIRDAT:=RESERVE(2);
FDATE:=RESERVE(I);
\NON DIR ARRAYS
STAB:=RESERVE(48);


CRLF(0);TEXT(0,"SQUASH FOR APEX V1.0");CRLF(0);
TEXT(0,"WHAT UNIT?");INITI(0);
DEVICE:=INTIN(0);


RDDIR;
SORT;
UBL:=USERBLK;
'FOR'I:=0,MAXSTB'DO'MOVE(I);
WRTDIR;
TEXT(0,"SQUASH DONE");CRLF(0);
'END';\OF ALL
