\UNPRINT.XPL
\PRINTER HANDLER

'CODE'RESERVE=3,CHIN=7,CHOUT=8,
REM=2,CRLF=9,NUMIN=10,
NUMOUT=11,TEXT=12,OPENIN=13,
OPENOUT=14,CLOSE=15,ABORT=16;


'INT'
	TEMP,	\TEMPORARY STORAGE
	CHAR,	\GLOBAL CHARACTER
	NCHAR,	\ONE CHARACTER LOOK AHEAD
	OCHAR,	\ONE CHARACTER LOOK BACK
	LINECOUNT,	\HOLDS CURRENT LINE POSITION
	TABCOUNT,	\HOLDS CURRENT LINE POSITION
	PGCTR,	\HOLDS PAGE NUMBER
	EXTRA,	\FLAGS EXTRA FORM FEED
	LMAR,	\LEFT MARGIN
	TABSIZ,	\NUMBER OF SPACES IN A TAB
	ODEV,	\OUTPUT DEVICE
	IDEV,	\INPUT DEVICE
	GAP,	\LINES BETWEEN FORMS
	PLENGTH,	\LENGTH OF PAGE
	COPCTR,	\COUNTS NUMBER OF COPIES
	COPIES,	\NUMBER OF COPIES TO PRINT
	PGFLG;	\FLAGS PAGE NUMBERS


'DEF'	\DEFINE SOME ASCII CHARACTERS 
	SPACE=$20,
	RETURN=13,
	ESC=27,
	CTZ=26,
	FORM=12,
	TAB=9,
	FEED=10;


'DEF'	\PAGE CONSTANTS

	FLENGTH=66,	\LENGTH OF FORM
	WIDTH=65;	\PAGE WIDTH

'ADDR'
	DATE;	\HOLDS DATE STRING



'PROCEDURE' EOL(CHAR);	\TEST FOR END OF LINE
'INTEGER' CHAR;
'RETURN' CHAR=RETURN ! CHAR=FEED;



'PROC' YESNO;
'INTEGER' X;
'BEGIN'
OPENIN(0);
'RETURN' CHIN(0)=^Y;
'END';


'PROCEDURE' DELAY(MILSEC);
'INTEGER' MILSEC;
'INTEGER' I,J;
'DEF' K=3;
'BEGIN'
'FOR' I:=1,MILSEC 'DO' 'FOR' J:=1,K 'DO';
'END';



'PROCEDURE' SKIP;
'BEGIN'
CRLF(ODEV);
OCHAR:=RETURN;
CHAR:=FEED;
LINECOUNT:=LINECOUNT-1;
'END';


'PROC' MARGIN;
'INT' X;
'FOR' X:=1,LMAR 'DO' CHOUT(ODEV,SPACE);

'PROC' PAGE;
'INT' X;
'BEGIN'
PGCTR:=PGCTR+1;
MARGIN;
'FOR' X:=1,WIDTH-10 'DO' CHOUT(ODEV,SPACE);
TEXT(ODEV,"PAGE ");NUMOUT(ODEV,PGCTR);
SKIP;
SKIP;
'END';

'PROC' TOPFORM;
'BEGIN'
SKIP;
CHOUT(ODEV,FORM);
\USE THIS IF PRINTER DOESN'T UNDERSTAND
\FORM FEED
\'FOR' TEMP:=1,LINECOUNT 'DO'
\	'BEGIN'
\	CHOUT(ODEV,FEED);
\	'END';
LINECOUNT:=FLENGTH;
'END';



'PROC' ZETAB;
TABCOUNT:=TABSIZ;



'PROC' DOFORM;
'BEGIN'
TOPFORM;
'IF' PGFLG 'THEN' PAGE;
ZETAB;
'END';


'PROC' GETC;
'BEGIN'
OCHAR:=CHAR;
CHAR:=NCHAR;
NCHAR:=CHIN(IDEV);
'IF' CHAR=FORM & LINECOUNT>=FLENGTH 'THEN' GETC;
'END';



'PROCEDURE' WAIT;
'BEGIN'
TEXT(0,"ALIGN FORMS, THEN TYPE RETURN ");
OPENIN(0);
TEMP:=CHIN(0);
'END';



'PROC' GETDATE;
'INT' X;
'BEGIN'
X:=0;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(0);
	'IF' CHAR=13 ! X=20 'THEN' 'QUIT';
	DATE(X):=CHAR;
	X:=X+1;
	'END';
DATE(X-1):=DATE(X-1) ! 128;
'END';

'PROC' DOTAB;
'INT' X;
'BEGIN'
'FOR' X:=1,TABCOUNT 'DO' CHOUT(ODEV,SPACE);
ZETAB;
'END';

'PROC' SETPARM;
'INT' X;
'BEGIN'
TEXT(0,"NUMBER OF COPIES");COPIES:=NUMIN(0);
TEXT(0,"TAB SIZE? ");TABSIZE:=NUMIN(0);
TEXT(0,"INPUT DEVICE? ");IDEV:=NUMIN(0);
TEXT(0,"EXTRA FORM FEED? "); EXTRA:= YESNO;
TEXT(0,"GAP BETWEEN FORMS?");X:=NUMIN(0);
PLENGTH:=FLENGTH-X;
TEXT(0,"PAGE NUMBERS? ");PGFLG:=YESNO;

'END';

'PROC' DEFAULT;
'BEGIN'
COPIES:=1;
TABSIZE:=8;
IDEV:=3;
EXTRA:='TRUE';
PLENGTH:=64;
PGFLG:='TRUE';

'END';



'PROCEDURE' ENDLINE;
'BEGIN'
CHOUT(ODEV,CHAR);
LINECOUNT:=LINECOUNT-1;
'IF' LINECOUNT<=GAP 'THEN' DOFORM;
'IF' 'NOT' EOL(NCHAR) 'THEN' MARGIN;
ZETAB;
'END';


'PROCEDURE' STARTUP;	\DO ANY PRINTER INITIALIZATION
'BEGIN'
OPENOUT(ODEV);
\SPIN WRITER CODES
CHOUT(ODEV,ESC);	\SIGNAL COMMAND
TEXT(ODEV,"QF");	\TAB TO 39
CHOUT(ODEV,ESC);
CHOUT(ODEV,^M);		\SET LEFT MAR
\CHOUT(ODEV,ESC);
\TEXT(ODEV,"]L");\	\SET 10 PITCH
CRLF(ODEV);
WAIT;
'END';



'PROC' PRINT;
'BEGIN'
ZETAB;
PGCTR:=1;
NCHAR:=0;
CHAR:=0;
OPENIN(IDEV);
GETC;
SKIP;
TEXT(0,"                               ");TEXT(ODEV,DATE);
SKIP;
MARGIN;
'REPEAT'
	'BEGIN'
	GETC;
	'IF' CHAR#TAB 'THEN'
		'CASE''OF'
		CHAR=FEED: ENDLINE;
		CHAR=FORM:
			'BEGIN'
			DOFORM;
			'IF' 'NOT' EOL(NCHAR) 'THEN' MARGIN;
			'END'
		'ELSE' 
			'BEGIN'
			CHOUT(ODEV,CHAR);
			TABCOUNT:=TABCOUT-1;
			'IF' TABCOUT<=0 'THEN' ZETAB;
			'END'
	'ELSE' DOTAB;
	'END'
'UNTIL' CHAR=CTZ;
TOPFORM;
'END';


'BEGIN'	\MAIN
TEXT(0,"ENTER OUTPUT DEVICE");
ODEV:=NUMIN(0);

DATE:=RESERVE(20);
LINECOUNT:=FLENGTH;
TEXT(0,"LEFT MARGIN?");LMAR:=NUMIN(0);
TEXT(0,"DATE ");
GETDATE;
TEXT(0,"1. DEFAULTS, 2. NORMAL");
TEMP:=NUMIN(0);
'IF' TEMP=1 'THEN' DEFAULT 'ELSE' SETPARM;
ZETAB;
GAP:=FLENGTH-PLENGTH;	\GAP BETWEEN PAGES
STARTUP;
'FOR' COPCTR:=1,COPIES 'DO' PRINT;
'IF' EXTRA='TRUE' 'THEN' TOPFORM;
'END';
