
include \CXPL\CODESI.XPL;

char BBUFFER;
int WBUFFER;
seg char BPOINTER;
seg int WPOINTER;
integer DSEG,P,SEG,OFF,CPUREG,COL,MODE,LEN;


procedure PAUSE;
int C;
begin
TEXT(0,"HIT ANY KEY ");
C:=CHIN(1);
CRLF(0);
end;


procedure BLANK;
CHOUT(0,$0C);


procedure BAR;
TEXT(0,"============================================================
");


procedure DOFUNC12;
begin
CRLF(0);
BAR;
TEXT(0,"BIOS Int $10, Function $12, Sub $10");CRLF(0);
BAR;
CRLF(0);CRLF(0);
CPUREG(1):=$10;
CPUREG(0):=$1200;
SOFTINT($10);
TEXT(0,"AX = ");HEXOUT(0,CPUREG(0));CRLF(0);
TEXT(0,"BX = ");HEXOUT(0,CPUREG(1));CRLF(0);
TEXT(0,"CX = ");HEXOUT(0,CPUREG(2));CRLF(0);
CRLF(0);
end;




procedure DOFUNC1B;
begin
CRLF(0);
BAR;
TEXT(0,"BIOS Int $10, Function $1B");CRLF(0);
BAR;
CRLF(0);CRLF(0);
CPUREG(11):=DSEG;
CPUREG(4):=BBUFFER;
CPUREG(1):=0;
CPUREG(0):=$1B00;
SOFTINT($10);

if CPUREG(0)=$1B1B then
	begin
	TEXT(0,"Functionality/State Table ");
	CRLF(0);
	for P:=0,$32 do
		begin
		HEXOUT(0,P);TEXT(0," - ");HEXOUT(0,BBUFFER(P));
		if REM((P+1)/4)=0 then CRLF(0) else TEXT(0,"     ");
		end;
	CRLF(0);
	PAUSE;
	OFF:=WBUFFER(0);
	SEG:=WBUFFER(1);		
	TEXT(0,"Static Functionality Tables");
	CRLF(0);
	for P:=0,$0F do
		begin
		HEXOUT(0,P);TEXT(0," - ");HEXOUT(0,PEEK(SEG,OFF+P));
		if REM((P+1)/4)=0 then CRLF(0) else TEXT(0,"     ");
		end;
	CRLF(0);
	end
else TEXT(0,"Function Not Supported");
CRLF(0);
end;




procedure WPEEK(S,O);
int S,O;
return PEEK(S,O) ! SWAP(PEEK(S,O+1));




begin
CPUREG:=GETREG;
BPOINTER:=RESERVE(2);
WPOINTER:=RESERVE(2);

DSEG:=CPUREG(12);

BBUFFER:=RESERVE(40);
WBUFFER:=BBUFFER;


CPUREG(0):=$0F00;
SOFTINT($10);

MODE:=CPUREG(0) & $FF;
TEXT(0,"MODE= ");HEXOUT(0,MODE);CRLF(0);

COL:=SWAP(CPUREG(0)) & $FF;
TEXT(0,"COLLUMNS= ");INTOUT(0,COL);CRLF(0);

LEN:=WPEEK(0,$44C);
TEXT(0,"REGENERATION LENGTH= ");INTOUT(0,LEN);CRLF(0);

TEXT(0,"CALCULATED HEIGHT= ");INTOUT(0,(LEN/COL)/2);CRLF(0);
TEXT(0,"HEIGHT= ");INTOUT(0,PEEK(0,$484));CRLF(0);

TEXT(0,"SCREEN OFFSET= ");HEXOUT(0,WPEEK(0,$44E));CRLF(0);
TEXT(0," CURSOR LOCATIONS");CRLF(0);
for P:=0,7 do 
	begin
	TEXT(0,"  ");
	INTOUT(0,P);
	TEXT(0," - ");
	HEXOUT(0,WPEEK(0,$450+(2*P)));
	CRLF(0);
	end;
CRLF(0);
TEXT(0,"CURSOR SIZE= ");HEXOUT(0,WPEEK(0,$460));CRLF(0);
TEXT(0,"DISPLAY PAGE= ");HEXOUT(0,PEEK(0,$462));CRLF(0);
TEXT(0,"PORT ADDRESS= ");HEXOUT(0,WPEEK(0,$463));CRLF(0);

PAUSE;
BLANK;
DOFUNC12;
PAUSE;
BLANK;
DOFUNC1B;
end;
