	PAGE	59,130
;ZOOMEXT.ASM	JUL-05-92
;ZOOMEXT(X, IMAGE(0), ZOOM);
;"IMAGE(0)" is the segment address of the image to be displayed.
; It must be 320 pixels wide.
;"ZOOM" is the scalled zoom factor. $0100 is one to one.

;Register usage:
;	zoom	bx	cx
;	source	ds:si	dx
;	dest	es:di

cseg	segment DWORD public 'code'
	assume	cs:cseg

yl	dw	0			;
yh	dw	0

	public	zoomext
zoomext:
	mov	bp,sp			;get args:
	mov	ch,[bp]+4		;zoom factor, low byte
	mov	cl,0
	mov	bl,[bp]+5		;high byte
	mov	bh,0

	mov	ax,[bp]+6		;image segment address

	push	ds			;save segment registers
	push	es

	mov	ds,ax			;point data segment to image

	mov	ax,0a000h		;point extra seg to video ram
	mov	es,ax

	mov	ax,100			;compute top edge of image
	mul	word ptr [bp]+4		;zoom
	add	ax,080h
	adc	dx,0
	mov	al,ah
	mov	ah,dl
	mov	dx,100
	sub	dx,ax

	mov	cs:yl,0
	mov	cs:yh,dx

z05:
	mov	ax,160			;compute left edge of image
	mul	word ptr [bp]+4		;zoom
	add	ax,080h
	adc	dx,0
	mov	al,ah
	mov	ah,dl
	mov	si,160
	sub	si,ax
	add	si,[bp]+8

	mov	di,0			;start a left edge
	mov	dx,0
	align	4
z10:
	add	dx,cx			;add zoom factor
	adc	si,bx
	mov	al,[si]			;get pixel of image

	add	dx,cx			;add zoom factor
	adc	si,bx
	mov	ah,[si]			;get pixel of image
	mov	es:[di],ax		;plot it

	add	di,2			;next screen pixels
	cmp	di,320
	jne	z10

	add	cs:yl,cx		;y:= y +zoom
	adc	cs:yh,bx
	mov	ax,cs:yh

	mov	dx,20
	mul	dx
	add	ax,[bp]+6		;zoom
	mov	ds,ax

	mov	ax,es
	add	ax,320/16
	mov	es,ax
	cmp	ax,320/16*200 + 0a000h
	jne	z05

	pop	es			;restore segment registers
	pop	ds
	retf	6			;drop two args

cseg	ends
	end
