\ALLDIR.XPL

'CODE'
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
CHIN=7,		CHOUT=8,	CRLF=9,		NUMIN=10,
INTOUT=11,	TEXT=12,	INITI=13,	INITO=14,
CLOSE=15,	FRUN=28,	FSAVE=29,	FWRITE=30,
FREAD=31,	FASAVE=27,	FGET=26,	RESTORE=32,
SPACE=18,	RAN=1,		ABORT=16;


\THE DIRECTORY
'ADDRESS'
	TITLE,	\TITLE OF THE VOLUME
	RNAM,	\THE REMEMBERED FILE
	FNAME,	\THE FILE NAMES
	FSTAT,	\THE FILE STATUS
	FLAGS,	\FFS SPECIAL REQUEST FLAGS
	FREE1,	\UNUSED
	UNUSED;	\FREE DIRECTORY SPACE
\INTEGER ARRAYS IN THE DIRECTORY
'INTEGER'
	DIRDAT,	\DIRECTORY DATE
	VOLUME,	\UNIQUE DISK ID NUMBER
	FDATE,	\DATE OF FILES
	FBLK,	\THE FIRST BLOCK
	LBLK;	\THE LAST BLOCK

\SOME ABSOLUTE ADDRESES
'ADDRESS'
	COMPAG,PARM,IOPAG,PG0,DRVLOC;

\THE SYSTEM GLOBALS:
'ADDRESS'
	STAB,	\SORT POINTER ARRAY
	LOCNAM;	\LOCAL NAME OF FILE

'INTEGER'
	DIRSIZ,	\DIR SIZE
	SWAPSIZ,\SWAPPING SIZE
	DIRBLK,	\WHERE DIRECT IS
	SWAPBLK,\SWAPPING AREA
	SYSBLK,	\WHERE SYSTEM IS
	USERBLK,\FIRST USER BLOCK
	BACKBLK,\BLOCK TO PU BACKUP DIR IN
	FIRBLK,	\FIRST BLOCK OF FILE
	LASBLK,	\LAST BLOCK OF FILE
	FLNO,	\NUMBER OF FILE
	MAXBLK,	\HIGHEST BLOCK
	MAXFL,	\HIGHEST FILE NO
	CHAR,	\INPUT CHARACTER
	ERR,	\ERR CODE IF NON ZERO
	SWAPFLG,\=0 IF SWAPPING AREA IS INVALID
	SWITCH,	\USER FILE SWITCH
	ARG1,	\USER ARGUMENT
	ARG2,	\USER ARGUMENT
	SPECIAL,\SPECIAL BITS IN PROGRAM FILE REQUEST
	SYSDAT,	\SYSTEM DATE
	INSIZE,	\SIZE OF LAST OPENED INFILE
	INDATE,	\DATE OF LAST INFILE
	MAXSTB,	\SIZE OF STAB ARRAY
	FILENO;	\RUN FILE NUMBER

\CONSTANTS

\ASCII
'DEFINE'EOF=26,FF=12,TAB=9;

\FILE STATUS IN THE DIRECTORY
'DEFINE' NULL=0,TENTATIVE=255,REPLACE=254,VALID=1;

\FILE STATUS IN COMM AREA
'DEFINE' NOFILE=0,SETUP=1,CLOSED=255;

\SYSTEM REENTRY CONDITIONS
'DEFINE' SWAPIN=254,SAVEIN=255,BOOTIN=253;

\FAILED FLAG
'DEFINE' NONE=65535;

\FOR MAIN
'INTEGER'ODEV,IDEV,I,J,TOPFL,NUMFL;
'INTEGER'FILES;
'INTEGER'TITMAX,TITLST,VOLLST,TITNO;
'ADRESS'TITSTR;
'DEFINE'RECSIZ=16;

	'PROCEDURE'NEXT;
	CHAR:=CHIN(IDEV);


	'PROCEDURE'CR;
	CRLF(ODEV);


	'PROCEDURE'STR(TXT);
	'ADDRESS'TXT;
	TEXT(ODEV,TXT);


	'PROCEDURE'NUM(I);
	'INTEGER'I;
	INTOUT(ODEV,I);

	'PROCEDURE'TABIT;
	'INTEGER'I;
CHOUT(ODEV,TAB);

	'PROCEDURE'ERROR(I);

'ADDRESS'I;
'BEGIN'
ODEV:=0;
CR;
STR("ERROR!! ");
STR(I);
CR;
ABORT;
'END';



\	'PROCEDURE'ALPH;
\
\CHECK FOR ALPHANUMERIC OR "?"
\'EXIT'((CHAR>=^0)&(CHAR<=^9))!((CHAR>=^A)&(CHAR<=^Z))!(CHAR=^?);


	'PROCEDURE'PRDAT(DAT);
	'INTEGER'DAT,DAY,MO;

'BEGIN'
'IF'DAT<=0'THEN'[STR("NO DATE");'EXIT'];
DAT:=DAT/32;DAY:=REM(0);
DAT:=DAT/16;MO:=REM(0);
NUM(MO);CHOUT(ODEV,^/);
NUM(DAY);CHOUT(ODEV,^/);
NUM(DAT+76);
'END';



	'PROCEDURE'RDDIR;

'BEGIN'
FREAD(DIRBLK,FNAME,DIRSIZ);
'END';



	'PROCEDURE'ADDIT(FILE);
	'INTEGER'FILE,MIN,MAX,K,SIZE,ADRS;
	'ADDRESS'STRING,FILEST;

'BEGIN'
'IF'NUMFL>TOPFL'THEN'ERROR("TOO MANY FILES");
FILEST:=FNAME+FILE*11;
STRING:=FILES(NUMFL);
'FOR'K:=0,10'DO'STRING(K):=FILEST(K);
STRING(11):=0;
ADRS:=STRING;
ADRS(6):=SWAP(FDATE(FILE));
ADRS(7):=SWAP(VOLUME(0));
NUMFL:=NUMFL+1;
'END';

'PROCEDURE'ADDIR;
'INTEGER'I;


	'PROCEDURE'SORT;
	'INTEGER'I,J,T;

'BEGIN'\FAKE IN THIS USEAGE - NO NEED FOR IT
J:=0;
'FOR'I:=0,MAXFL'DO'
	'IF' FSTAT(I)=VALID'THEN'
		[STAB(J):=I;J:=J+1];
MAXSTB:=J-1;
'END';


'BEGIN'\ADDIR
SORT;
'FOR'I:=0,MAXSTB'DO'
	'BEGIN'
	ADDIT(STAB(I));
	'END';
'END';


	'PROCEDURE'VERIFY(STR);
	'ADDRESS'STR;
'BEGIN'
CRLF(IDEV);TEXT(0,STR);
INITI(IDEV);
'EXIT'CHIN(IDEV)=^Y;
'END';


'PROCEDURE'SORTFILES;
'INTEGER'RIGHT,LEFT;
'INTEGER'NEXT,I;
'DEFINE'EMPTY=$FFFF;

'PROCEDURE'THREAD(NODE);
'INTEGER'NODE;

'PROCEDURE'CMPSTR(S1,S2);
'ADDRESS'S1,S2;
'INTEGER'I;
'BEGIN'
I:=0;
'LOOP'	'BEGIN'
	'IF'S1(I)#S2(I)'THEN''QUIT';
	'IF'I=RECSIZ+1'THEN''QUIT';
	I:=I+1;
	'END';
'EXIT'S1(I)>=S2(I);
'END';\CMPSTR


'BEGIN'\THREAD
'IF'CMPSTR(FILES(NEXT),FILES(NODE))
'THEN'
	'IF'RIGHT(NODE)=EMPTY'THEN'RIGHT(NODE):=NEXT
	'ELSE'THREAD(RIGHT(NODE))
'ELSE'
	'IF'LEFT(NODE)=EMPTY'THEN'LEFT(NODE):=NEXT
	'ELSE'THREAD(LEFT(NODE));
'END';\THREAD

'PROCEDURE'TRACE(NODE);
'INTEGER'NODE;

'PROCEDURE'PRNAM(I);
'INTEGER'I;
'ADDRESS'STRING;
'INTEGER'J,ADRS;

'BEGIN'\PRNAM
CR;
STRING:=FILES(I);
ADRS:=STRING;
'FOR'J:=0,7'DO'CHOUT(ODEV,STRING(J));
CHOUT(ODEV,^.);
'FOR'J:=8,10'DO'CHOUT(ODEV,STRING(J));
TABIT;
PRDAT(SWAP(ADRS(6)));
CHOUT(ODEV,^ );CHOUT(ODEV,^ );
TABIT;
NUM(SWAP(ADRS(7)));
'END';\PRNAM

'BEGIN'\TRACE
'IF'LEFT(NODE)#EMPTY'THEN'TRACE(LEFT(NODE));
PRNAM(NODE);
'IF'RIGHT(NODE)#EMPTY'THEN'TRACE(RIGHT(NODE));
'END';

'BEGIN'\SORTFILES
RIGHT:=RESERVE(NUMFL*2);
LEFT:=RESERVE(NUMFL*2);
'FOR'I:=0,NUMFL-1'DO'
	'BEGIN'
	RIGHT(I):=EMPTY;
	LEFT(I):=EMPTY;
	'END';
'FOR'NEXT:=1,NUMFL-1'DO'THREAD(0);
TRACE(0);
'END';\SORTFILES

'PROCEDURE'ADDTITLE;
'INTEGER'I;
'ADDRESS'TITSTR;
'BEGIN'
TITSTR:=TITLST(TITNO);
'FOR'I:=0,31'DO'TITSTR(I):=TITLE(I);
VOLLST(TITNO):=VOLUME(0);
TITNO:=TITNO+1;
'IF'TITNO>TITMAX'THEN'ERROR("TOO MANY VOLUMES");
'END';

'PROCEDURE'DOTITLES;
'INTEGER'RIGHT,LEFT;
'INTEGER'NEXT,I;
'DEFINE'EMPTY=$FFFF;

'PROCEDURE'THREAD(NODE);
'INTEGER'NODE;

'BEGIN'\THREAD
'IF'VOLLST(NEXT)>=VOLLST(NODE)
'THEN'
	'IF'RIGHT(NODE)=EMPTY'THEN'RIGHT(NODE):=NEXT
	'ELSE'THREAD(RIGHT(NODE))
'ELSE'
	'IF'LEFT(NODE)=EMPTY'THEN'LEFT(NODE):=NEXT
	'ELSE'THREAD(LEFT(NODE));
'END';\THREAD

'PROCEDURE'TRACE(NODE);
'INTEGER'NODE;

'PROCEDURE'PRNAM(I);
'INTEGER'I;
'BEGIN'\PRNAM
CR;
NUM(VOLLST(I));
TABIT;
STR(TITLST(I));
'END';\PRNAM

'BEGIN'\TRACE
'IF'LEFT(NODE)#EMPTY'THEN'TRACE(LEFT(NODE));
PRNAM(NODE);
'IF'RIGHT(NODE)#EMPTY'THEN'TRACE(RIGHT(NODE));
'END';

'BEGIN'\DOTITLES
RIGHT:=RESERVE(TITNO*2);
LEFT:=RESERVE(TITNO*2);
'FOR'I:=0,TITNO-1'DO'
	'BEGIN'
	RIGHT(I):=EMPTY;
	LEFT(I):=EMPTY;
	'END';
'FOR'NEXT:=1,TITNO-1'DO'THREAD(0);
TRACE(0);
'END';\DOTITLES



'BEGIN'\MAIN PROC\

MAXBLK:=1000;
SWAPSIZ:=56;
DIRBLK:=0;
DIRSIZ:=5;
SWAPBLK:=13;
USERBLK:=130;
SYSBLK:=SWAPBLK+SWAPSIZ;
BACKBLK:=125;

MAXFL:=47;	\SELECT SO THAT DIRSIZ IS RIGHT

\SETUP ABSOLUTE ADDRES
PARM:=$C080;	\RESIDENT HANDER COMM AREA
COMPAG:=$C000;	\SYSTEM COMM AREA
PG0:=$0;
DRVLOC:=$FEEA;
IOPAG:=$FE00;	\$FE00

\RESERVE THE ARRAYS
I:=(MAXFL+1)*2;
\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(I);
LBLK:=RESERVE(I);
\BLOCK 3
FREE1:=RESERVE(181);
RNAM:=RESERVE(11);
TITLE:=RESERVE(60);
VOLUME:=RESERVE(2);
DIRDAT:=RESERVE(2);
\BLOCK 4
FDATE:=RESERVE(I);
FLAGS:=RESERVE(8);
UNUSED:=RESERVE(248-I);

\NON DIR ARRAYS
LOCNAM:=RESERVE(11);
STAB:=RESERVE(48);
SYSDAT:=PARM(32)+SWAP(PARM(33));




\SETUP FOR FILES ARRAYS
TOPFL:=1000;
FILES:=RESERVE((TOPFL+1)*2);
'FOR'I:=0,TOPFL'DO'FILES(I):=RESERVE(RECSIZ);
NUMFL:=0;

\SETUP FOR TILES ARRAYS
TITMAX:=40;
TITLST:=RESERVE((TITMAX+1)*2);
'FOR'I:=0,TITMAX-1'DO'TITLST(I):=RESERVE(32);
VOLLST:=RESERVE((TITMAX+1)*2);
TITNO:=0;

IDEV:=0;
ODEV:=0;
CR;STR("PRINT DIR V1.0");CR;
'WHILE'VERIFY("MORE ?")'DO'
	'BEGIN'
	RDDIR;
	ADDTITLE;
	ADDIR;
	'END';

CR;STR("*** INSERT ORIGINAL DISK !! ***");
'WHILE''NOT'VERIFY("VERIFY ?")'DO';
ODEV:=3;
INITO(ODEV);
TABIT;TABIT;STR("****** VOLUME INDEX ******");CR;CR;
DOTITLES;
CHOUT(ODEV,FF);
TABIT;TABIT;STR("****** FILE INDEX ******");CR;CR;
SORTFILES;
CR;
CHOUT(ODEV,EOF);
CLOSE(ODEV);
'END';\OF ALL
