\ATTRIBS.XPL	MAR-26-94
\Shows all possible attributes for a specified video mode.

include	C:\CXPL\CODESI;
def	FF=$0C, SP=$20;
int	I, J, K, MODE, MODE0, COL80;
addr	HEXTBL;

int	Cpureg;			\Address of CPU register array (from Getreg)
def	AX, BX, CX, DX, DI, SI, BP, CF, CS, DS, SS, ES;		\Getreg registers



func	GetVid;			\Returns the current video mode
begin
Cpureg(AX):= $0f00;		\Function $0f
Softint($10);			\Call BIOS routine
return Cpureg(AX) & $ff;
end;	\GetVid




proc	KeyToGo;
int	I;
begin
Text(0, "Any key to continue...");
OPENI(1);
I:= CHIN(1);
end;	\KEYTOGO



proc	BLINKOFF;	\Blink/intensity for EGA and VGA
int	II, JJ;
begin
JJ:= PEEK(0, $463) +$304;	\port address of mode set register
II:= PEEK(0, $465) & $DF;	\clear blink enable bit
POUT(II, JJ, 0);
POKE(0, $465, II);		\save updated value in BIOS data area
end;	\BLINKOFF



begin	\MAIN
HEXTBL:= "0123456789ABCDEF ";

CPUREG:= GETREG;
MODE0:= GETVID;

TEXT(0, "MODE: $");
MODE:= HEXIN(0);
CHOUT(0, FF);
SETVID(MODE);
\BLINKOFF;

case MODE of
  0, 1, 4, 5, 8, 9, $D, $13: COL80:= false
other COL80:= true;

case MODE of
  4, 5, $D, $13:	\320x200
	for J:= 0, 200-1 do
		[MOVE(0, J);  LINE(320-1, J, 1)];
  6, $E:		\640x200
	for J:= 0, 200-1 do
		[MOVE(0, J);  LINE(640-1, J, 1)];
  $F, $10, $11, $12:	\640x350 or 640x480
	for J:= 0, 350-1 do
		[MOVE(0, J);  LINE(640-1, J, 1)]
other;


for J:= 0, 15 do
	begin
	for I:= 0, 15 do
		begin
		ATTRIB(J<<4+I);
		if COL80 then CHOUT(6, SP);
		CHOUT(6, HEXTBL(J));
		CHOUT(6, HEXTBL(I));
		if COL80 then CHOUT(6, SP);
		end;
	CRLF(6);
	end;

CURSOR(0, 20);
KeyToGo;


CHOUT(0, $0C);
for J:= 0, 15 do
	begin
	for I:= 0, 15 do
		begin
		if COL80 then CHOUT(0, SP);
		CHOUT(0, HEXTBL(J));
		CHOUT(0, HEXTBL(I));
		if COL80 then CHOUT(0, SP);
		end;
	CRLF(0);
	end;

K:= if COL80 then 4 else 2;
for J:= 0, 15 do
	begin
	for I:= 0, 15 do
		begin
		HILIGHT(I*K, J, (I+1)*K-1, J, J<<4+I);
		end;
	end;

CURSOR(0, 20);
KEYTOGO;

SETVID(MODE0);
end;	\MAIN
