\BANNER.XPL			2/7/81
\BY RICHARD OTTOSEN & LOREN BLANEY

\THIS PROGRAM REQUIRES A SEPARATE FILE
\ (BANNER.FIL) WHICH CONTAINS THE
\ CHARACTER FONT.
\CHARACTER FONT FROM MOTOROLA MCM6571
\U =CHARACTER IS NOT SHIFTED
\D =CHARACTER IS SHIFTED DOWN THREE DOTS
\VALUES ARE FOR COLUMNS WITH THE MSB AT
\ THE TOP OF THE CHAR.
\THE RIGHT COLUMN IS GIVEN FIRST
\EVERYTHING AFTER THE Up OR Down IS A
\ COMMENT:
\	1. DECIMAL ASCII OF CHARACTER
\	2. THE CHARACTER

code	ABS=0, RAN=1, REM=2, RES=3, SWAP=4, EXTEN=5,
	CHIN=7, CHOUT=8, CRLF=9, INTIN=10, INTOUT=11,
	TEXT=12, OPENI=13, OPENO=14, CLOSE=15, ABORT=16;

def	TV=0, KB=0, PR=2, FILE=$3, EOF=$1A, CR=$0D;
int	I,J,K, DEVIN, DEVOUT, HEX, CH, X;
int	SHAPE, HEIGHT, WIDTH;
addr	CHARGEN;	\CHAR GENERATOR ARRAY


proc	HEXIN;		\CONVERT ASCII TO HEX
int	CHAR;
begin
repeat CHAR:= CHIN(FILE) until CHAR >=^0;
HEX:= 0;
loop	[if CHAR>=^0 & CHAR<=^9 then HEX:=HEX*16 +CHAR -^0
	else if CHAR>=^A & CHAR<=^F then HEX:=HEX*16+CHAR-^A+10
	else quit;
	CHAR:= CHIN(FILE)];
end;


proc	BIGLINE (DOTS);		\OUTPUT A SINGLE LINE IN A CHAR
int	DOTS, D, S, H, W, I;
begin
for W:=1,WIDTH do
	[D:= DOTS;
	for I:= 0,11 do
		[if (D & 1)#0 then
			if SHAPE#^  then S:= SHAPE else S:= CH
		else S:= ^ ;
		for H:= 1,HEIGHT do CHOUT(DEVOUT,S);
	D:= D /2];
	CRLF(DEVOUT)];
end;


proc	BIGCHAR;	\OUTPUT A BANNER CHARACTER
int	I;
begin
I:= 12;
while I >=0 do
	[BIGLINE(CHARGEN(CH*14+I) +SWAP(CHARGEN(CH*14+I+1)));
	I:= I -2];
BIGLINE(0);
end;


begin		\MAIN PROC
TEXT(TV,"BANNER VER 1.0");CRLF(TV);
TEXT(TV," PLEASE WAIT FOR ME TO BE READY...");
CRLF(TV); CRLF(TV);
CHARGEN:= RES(128 *7 *2);	\SAVE SPACE FOR CHAR. GEN. "ROM"
OPENI(FILE);
CH:= CHIN(FILE);		\SYNC TO CR'S
while CH# CR do CH:= CHIN(FILE);

X:= 0;	\READ IN THE FILE & BUILD THE CHARGEN ARRAY (ROM)
for J:= 0,127 do
	[for I:= 0,13 do
		[HEXIN;
		CHARGEN(X +I):= HEX;
		CHARGEN(X +I +1):= SWAP(HEX);
		I:= I +1];
	if CHIN(FILE) =^U then for I:= 0,13 do
		[K:=CHARGEN(X+I) +SWAP(CHARGEN(X+I+1));
		K:= K *8;
		CHARGEN(X +I):= K;
		CHARGEN(X +I +1):= SWAP(K);
		I:= I +1];
	CH:= CHIN(FILE);		\SYNC TO CR'S
	while CH# CR do CH:= CHIN(FILE);
	X:= X +14];

loop	[CRLF(TV); CRLF(TV);
	TEXT(TV,"ENTER OUTPUT DEVICE NUMBER"); CRLF(TV);
	TEXT(TV," (CONSOLE=0, PRINTER=2): ");
	OPENI(KB); DEVIN:= KB;
	DEVOUT:= INTIN(KB); OPENO(DEVOUT);
	TEXT(TV,"ENTER HEIGHT AND WIDTH (HINT: 3,2): ");
	HEIGHT:= INTIN(KB); WIDTH:= INTIN(KB);
	TEXT(TV,"ENTER DOT CHARACTER (IF SPACE THEN"); CRLF(TV);
	TEXT(TV," DOT CHAR = BANNER CHAR): ");
	SHAPE:= CHIN(KB);
	TEXT(TV,"ENTER BANNER:"); CRLF(TV);
	OPENI(DEVIN); CH:= CHIN(DEVIN);
	while CH# CR do [BIGCHAR; CH:= CHIN(DEVIN)]];
end;	\OF ALL

