\BASICS.XPL
\Incorporates Shane's libraries as of 1/16/94:
\  LIB
\  BIT
\  CLOCK
\  (XPL)STRING
\  ZSTRING

\Requires these globals
\int  TEXTCX, TEXTCY;       BASICS: GETCURSOR
\int  TICK;                 BASICS: CLOCK stuff
\int TEMP,TTMP,TEMP2,I;     BASICS: misc LIB
\int CPUREG,DATASEG;        BASICS: CPU
\int SCRSNUM;               BASICS: SCRSAVE
\char CH;                   BASICS
\seg char SSAVE,PSP,LCLSCR; BASICS: SCRSAVE & CPU

\Requires these initiailizations
\TICK:=RESERVE(4);
\CPUREG:=GETREG;
\PSP:=RESERVE(2);
\PSP(0):=CPUREG(11);
\DATASEG:=CPUREG(12);

\SCRSNUM:=0;
\SSAVE:=RESERVE(10);

\LCLSCR:=RESERVE(2);
\LCLSCR(0):=$B800;


\***************************************
\Shane's LIB    1/16/94

public func GETFREE;
 \displays available space for MALLOC
begin
CPUREG(0):=$4800;
CPUREG(1):=$FFFF;
SOFTINT($21);
if CPUREG(7) then return(CPUREG(1))
   else [CRLF(0); TEXT(0,"Wooooow! There is NO WAY you have this much memory! (64K*16) Space allocated. About to release it.");CH:=CHIN(1);RELEASE(CPUREG(0));TEXT(0," done.");CH:=CHIN(1)];
end;


public proc CTYPE(SSCAN,ESCAN);
int SSCAN,ESCAN;
begin
CPUREG(0):=$100;
CPUREG(2):=SSCAN*$100+ESCAN;
SOFTINT($10);
end;

public func CHKKEY;
begin
CPUREG(0):=$0B00;
SOFTINT($21);
return(CPUREG(0)&$FF);
end;

public func GETKEYFLAGS;
begin
CPUREG(0):=$0200;
SOFTINT($16);
return(CPUREG(0)&$FF);
end;

public proc OUTCHAR(CHR);    \sends character to keyboard buffer
char CHR;
begin
CPUREG(0):=$0500;
\CPUREG(2):=CHR;
if CHR<256 then CPUREG(2):=CHR
    else CPUREG(2):=(CHR-256)*256;
SOFTINT($16);
end;

public func RETMAX(INT1,INT2);
int INT1,INT2;
if INT2>INT1 then return(INT2) else return(INT1);

public func RETMIN(INT1,INT2);
int INT1,INT2;
if INT2<INT1 then return(INT2) else return(INT1);

public func real RETMINREAL(RL1,RL2);
real RL1,RL2;
if RL1<RL2 then return(RL1) else return(RL2);

public func UPPER(CHR);
char CHR;
if CHR>=^a & CHR<=^z then return(CHR-32)
else return(CHR);

public func LOWER(CHR);
char CHR;
if CHR>=^A & CHR <=^Z then return(CHR+32)
else return(CHR);

public func ISLETTER(CHR);
char CHR;
begin
if CHR>=^A & CHR<=^Z then return(1) else        \UPPER CASE
if CHR>=^a & CHR<=^z then return(2) else return(false); \LOWER CASE
end;

public func ISHEX(CHR);   \Is it 0-9 or A-F?
char CHR;
begin
if CHR>=^0 & CHR<=^9 then return(1) else
if CHR>=^A & CHR<=^F then return(2) else return(false);
end;

public func ISNUMBER(CHR);
int CHR;
if CHR>=^0 & CHR <=^9 then return(true) else return(false);

public proc GETCURSOR;
begin
CPUREG(0):=$0300;       CPUREG(1):=$0000;
SOFTINT($10);
TEXTCY:=(CPUREG(3)&$FF00)/$100;
TEXTCX:=CPUREG(3)&$00FF;
end;

public proc GETVIDINFO(TYPE);   \TYPE: ^X for the x-size (columns), ^Y for the y-size (rows), ^M for the mode
char TYPE;
char INFOBUF;
int INFOINT;
begin
INFOBUF:=RESERVE(55);
CPUREG(0):=$1B00;
CPUREG(1):=0;
CPUREG(4):=INFOBUF;
CPUREG(11):=DATASEG;
SOFTINT($10);

case TYPE of
^X:     return(INFOBUF(5));
^Y:     return(INFOBUF(34));
^M:     return(INFOBUF(4))
other return(-1);
end;

\public proc SCRSAVE;
\begin
\if SCRSNUM<NUMSAVES then
\        begin
\        SSAVE(SCRSNUM):=MALLOC((80*25*2)/16);
\        BLIT($B800,0,SSAVE(SCRSNUM),0,80*25*2);
\        end;
\SCRSNUM:=SCRSNUM+1;
\end;
\
\public proc SCRRESTOR;
\if SCRSNUM>0 then
\begin
\SCRSNUM:=SCRSNUM-1;
\if SCRSNUM<NUMSAVES then
\        begin
\        BLIT(SSAVE(SCRSNUM),0,$B800,0,80*25*2);
\        RELEASE(SSAVE(SCRSNUM));
\        end;
\end;
\
\public proc WINSAVE;
\begin
\if WINSNUM<NUMSAVES then
\        begin
\        GETCURSOR;
\        LASTWIN(6):=TEXTCX;
\        LASTWIN(7):=TEXTCY;
\        WSAVE(WINSNUM):=MALLOC(1);
\        BLIT(DATASEG,LASTWIN,WSAVE(WINSNUM),0,16);
\        end;
\WINSNUM:=WINSNUM+1;
\end;
\
\public proc WINRESTORE;
\if WINSNUM>0 then
\begin
\WINSNUM:=WINSNUM-1;
\if WINSNUM<NUMSAVES then
\        begin
\        BLIT(WSAVE(WINSNUM),0,DATASEG,LASTWIN,16);
\        RELEASE(WSAVE(WINSNUM));
\        SETW(LASTWIN(0),LASTWIN(1),LASTWIN(2),LASTWIN(3),LASTWIN(4),false);
\        ATRB(LASTWIN(5));
\        CURSOR(LASTWIN(6),LASTWIN(7));
\        end;
\end;

public proc ATTRIB(CLR);
char CLR;
begin
LASTWIN(5):=CLR;
ATRB(CLR);
end;

public proc SETWIND(X1,Y1,X2,Y2,MODE,FILL);
int X1,Y1,X2,Y2,MODE,FILL;
begin
LASTWIN(0):=X1;
LASTWIN(1):=Y1;
LASTWIN(2):=X2;
LASTWIN(3):=Y2;
LASTWIN(4):=MODE;
SETW(X1,Y1,X2,Y2,MODE,FILL);
end;


\*****************************************************************************
\       Generic String Routines
\*****************************************************************************

public func STRNCMP(A, B, N);       \Compare string A to string B up to N bytes long
\This returns:
\	>0 if A > B
\	=0 if A = B
\	<0 if A < B
\This provides a general string compare, for example:
\ if StrNCmp(A, B, N) >= 0 then...	(if A >= B then...)
char	A, B;	\Strings to be compared (must be right justified)
int	N;	\Number of bytes to compare
int	I;
begin
for I:= 0, N-1 do
	if A(I) # B(I) then
		return A(I) - B(I);
return 0;			\They're equal
end;	\StrNCmp

public proc	STRCOPY(A, B, N);       \Copy string that is N bytes long: A --> B
char	A, B;                   \Strings, B must already have enough space "Reserved"
int	N;                      \Number of bytes to copy
BLIT(DATASEG,A,DATASEG,B,N);
\for I:=0,N-1 do B(I):=A(I);

\*****************************************************************************
\       XPL String Rutines
\*****************************************************************************
\Shane's (XPL) STRING   1/16/94

public func    XPLLEN(STR);            \Retuns the number of characters in a string
char	STR;                    \Str must be <= 32766 characters long
int	I3;
for I3:= 0, $7FFE do
	if STR(I3) >= $80 then return I3+1;

public proc    ADDXPL(S1, S2);         \Append (concatenate) string S1 onto S2
char	S1, S2;	                \S1 must have space already reserved for S2
int	L1, L2;	                \Lengths of strings (bytes)
begin
L1:= XPLLEN(S1);
L2:= XPLLEN(S2);
S2(L2-1):=S2(L2-1)&$7F;
STRCOPY(S1, S2+L2, L1);
end;	\StrCat

public proc COPYXPL(ST1,ST2);          \COPYs an XPL string to another XPL string (hi bit terminated)
char ST1,ST2;
int I3;
begin
I3:=0;
loop
        begin
        ST2(I3):=ST1(I3);
        if ST2(I3)>127 then quit;
        I3:=I3+1;
        end;
end;

public proc TEXTCENTER(PORT,STR,LEN);
int PORT;
char STR;
int LEN;
begin
\LEN:=XPLLEN(STR);
GETCURSOR;
CURSOR(TEXTCX+LEN/2-XPLLEN(STR)/2,TEXTCY);
TEXT(6,STR);
end;

\*****************************************************************************
\       ASCII-Z to XPL string conversion rutines
\*****************************************************************************

public proc Z2XPL(STR);             \Converts an ASCIIZ (0 terminated) string to an XPL string (Hi bit terminated)
char STR;
int I3;
for I3:=0,$7FFE do
        if STR(I3)=0 then [STR(I3-1):=STR(I3-1)!$80;return];


public proc XPL2Z(STR);             \Converts an XPL string (Hi bit terminated) string to an ASCIIZ (0 terminated)
char STR;
int I3;
for I3:=0,$7FF0 do
        if STR(I3)>$80 then [STR(I3):=STR(I3)&$7F;STR(I3+1):=0;return];

\*****************************************************************************
\       ASCII-Z string rutines
\*****************************************************************************
\Shane's ZSTRING  1/16/94

public func	ZLEN(STR);              \Retuns the number of characters in a string
char	STR;                    \Str must be <= 32766 characters long
int	I3;
for I3:= 0, $7FFE do if STR(I3)=0 then return I3;

public proc COPYZ(ST1,ST2);            \COPYs an ASCIIZ string to another ASCIIZ string (0 terminated)
char ST1,ST2;
int I3;
begin
I3:=0;
loop
        begin
        ST2(I3):=ST1(I3);
        if ST2(I3)=0 then quit;
        I3:=I3+1;
        end;
end;

public proc TEXTZ(PORT,STR);   \same as XPL TEXT intrinsic but for ASCIIZ strings, not XPL strings
char PORT,STR;
int I3;
begin
I3:=0;
loop
        begin
        if STR(I3)=0 then quit;
        CHOUT(PORT,STR(I3));
        I3:=I3+1;
        if I3>=10000 then quit;
        end;
end;

public func WWZ(S1,S2,LEN);         \Wordwrap ASCIIZ (s1), put the results in S2
char S1,S2;                             \returns number of lines
int LEN,S1POS,S2POS,COL,LASTSPACE,LINES;
begin
S1POS:=0;
S2POS:=0;
LINES:=1;
LASTSPACE:=-1;
COL:=0;
loop
        begin
        case S1(S1POS) of
        ^ :     LASTSPACE:=S1POS;
        0:      [S2(S2POS):=0;quit]
        other;
        if COL>=LEN then
                begin
                if LASTSPACE>0 then
                        begin
                        S2POS:=S2POS-(S1POS-LASTSPACE);
                        S1POS:=LASTSPACE+1;
                        end;
                S2(S2POS):=$D;
                S2(S2POS+1):=$A;
                S2POS:=S2POS+2;
                LINES:=LINES+1;
                COL:=0;
                LASTSPACE:=-1;
                end;
        S2(S2POS):=S1(S1POS);
        COL:=COL+1;
        S1POS:=S1POS+1;
        S2POS:=S2POS+1;
        end;
return(LINES);
end;

public proc    ADDZ(S1, S2);           \Append (concatenate) string S1 onto S2
char	S1, S2;	                \S2 must have space already reserved for S1
int	L1, L2;	                \Lengths of strings (bytes)
begin
L1:=ZLEN(S1);
L2:=ZLEN(S2);
STRCOPY(S1,S2+L2,L1);
S2(L1+L2):=0;
end;	\StrCat


public proc ZFORMAT(STR,LEN);         \Truncates ZASCII, putting last BYTE=0,
                               \ or padding out the length with 0s
char STR;
int LEN,I2,ZYET;
begin
ZYET:=false;
for I2:=0,LEN-1 do
        begin
        if STR(I2)=0 then ZYET:=true;
        if ZYET then STR(I2):=^ ;
        end;
STR(LEN):=0;
end;

public proc ZTERM(STR,NUM);    \finds end of CHAR and pads rest of string with 0
char STR; \address
int NUM;      \length to be checked
int END,A;
begin
\TEXT(0,"ZTERM(");INTOUT(0,STR);TEXT(0,",");INTOUT(0,NUM);TEXT(0,");");CH:=CHIN(1);
END:=ZLEN(STR);                                 \finds the end of the string based on 0 terminator
while STR(END-1)=^  & END>=1 do END:=END-1;     \finds end of string base on spaces
while END<NUM do [STR(END):=0;END:=END+1];      \pad 0s to NUM length
end;

public proc SPLITZ(STR,CHR,STR2,STR3);\Splits an AsciiZ string at the first
char STR,CHR,STR2,STR3;               \occurance of the CHR and returns the left
int I2;                               \half of the split in STR2 and the
                                      \right half in STR3 (both 0 terminated)
                                      \NOTE: if no match was found, STR2=STR, STR3 is blank
begin
I2:=0;
loop
        begin
        if STR(I2)=CHR then
                begin
                STRCOPY(STR,STR2,I2);
                STR2(I2):=0;
                COPYZ(STR+I2+1,STR3);
                return;
                end;
        if STR(I2)=0 then quit;
        I2:=I2+1;
        if I2>$7FFF then quit;
        end;
COPYZ(STR,STR2);
STR3(0):=0;
end;

public proc SPLITZ2(STR,CHR,STR2,STR3);\Splits an AsciiZ string at the last
char STR,CHR,STR2,STR3;                \occurance of the CHR and returns the left
int I2;                                \half of the split in STR2 and the
                                       \right half in STR3 (both 0 terminated)
                                       \NOTE: if no match was found, STR2=STR, STR3 is blank
begin
I2:=ZLEN(STR)-1;
loop
        begin
        if STR(I2)=CHR then
                begin
                STRCOPY(STR,STR2,I2);
                STR2(I2):=0;
                COPYZ(STR+I2+1,STR3);
                return;
                end;
        I2:=I2-1;
        if I2<0 then quit;
        end;
STR2(0):=0;
COPYZ(STR,STR3);
end;


public proc SWhiteZ(STR);       \Strip "White" charaters from beginning/end of string (Space, CR, LF, TB)
char STR;
int CSTART,CEND,SLEN;
begin
CEND:=ZLEN(STR)-1;
loop
        begin
        if CEND<0 then quit;
        case STR(CEND) of
        $D,$A,$9,^ ,255:    STR(CEND):=^&
        other quit;
        CEND:=CEND-1;                                   \strip end;
        end;
CSTART:=0;
loop
        begin
        case STR(CSTART) of
        $D,$A,$9,^ ,255:    STR(CSTART):=^&
        other quit;
        if CSTART=CEND then quit;
        CSTART:=CSTART+1;
        end;
BLIT(DATASEG,STR+CSTART,DATASEG,STR,CEND-CSTART+1);     \strip beginning
STR(CEND-CSTART+1):=0;
end;

\*****************************************************************************
\       Real and 2 byte-signed-integer stuff
\*****************************************************************************
\Shane's reals    1/16/94

public func real FRAC(X);		\Get fractional part of real number
real	X;			\e.g: Frac(12.9) =  0.9
return MOD(X, 1.0);		\     Frac(-3.7) = -0.7

public func real INTPART(X);		\Get integer part of real number
real	X;			\e.g: Int(12.9) = 12.0
return X -MOD(X, 1.0);		\     Int(-3.7) = -3.0

public proc IEXP(BASE,EXP);    \Raise BASE to an EXPonant (both 2 byte ints)
int BASE,EXP,ANS,ITTMP;
begin
ANS:=1;
ITTMP:=0;
loop
        begin
        if ITTMP>=EXP then quit;
        ANS:=ANS*BASE;
        ITTMP:=ITTMP+1;
        end;
return(ANS);
end;

\*****************************************************************************
\       Large Integer Rutines
\*****************************************************************************
\Shane's LARGEINT    1/16/94

public proc REAL2INT(X,LINT);
  \converted to public proc by kent  1/16/94
real X;         \real to be converted
int LINT;       \INT TO BE RETURNED
real Y,Z;
int A,B;
                \converts a real to two two-byte unsigned integers.
                \** need overflow re reals >4 bytes
                \Fills REALHI and REALLO (integers)
begin
X:=X/32768./2.;
Y:=MOD(X,1.);
Z:=X-Y;
Y:=Y*32768.*2.;

case of
Z>(65535.0+1.):         LINT(0):=0;                      \error
Z<0.:                   LINT(0):=0;                      \error
Z>32767.:               LINT(0):=FIX(Z-65535.-1.)
other                   LINT(0):=FIX(Z);

case of
Y<0.:                   LINT(1):=0;                      \error
Y>(65535.0+1.):         LINT(1):=0;                      \error
Y>32767.:               LINT(1):=FIX(Y-65535.-1.)
other                   LINT(1):=FIX(Y);
\return(LINT);  deleted by kent 1/16/94
end;


public func real INT2REAL(LINT);
int LINT;
real X;
        \converts two two-byte unsigned integers to a real
        \A is the Hi integer
begin
X:=0.0;
case of
LINT(0)>-1 & LINT(1)>-1:        X:=(FLOAT(LINT(0))*32768.0*2.0) + FLOAT(LINT(1));
LINT(0)>-1 & LINT(1)<0:         X:=(FLOAT(LINT(0))*32768.0*2.0) + (FLOAT(LINT(1))+65535.0+1.0);
LINT(0)<0 & LINT(1)>-1:         X:=((FLOAT(LINT(0))+65535.0+1.0)*32768.0*2.0) + FLOAT(LINT(1));
LINT(0)<0 & LINT(1)<0:          X:=((FLOAT(LINT(0))+65535.0+1.0) *32768.0*2.0) + (FLOAT(LINT(1))+65535.0+1.0)
other;
return(X);
end;

\public proc INTINC(LINT);
\int LINT;
\REAL2INT(INT2REAL(LINT)+1.0,LINT);
\
\public proc INTADD(LINT1,LINT2,LINT3);
\int LINT1,LINT2,LINT3;
\real X;
\begin
\X:=INT2REAL(LINT1)+INT2REAL(LINT2);
\REAL2INT(X,LINT3);
\end;
\
\public proc INTSUB(LINT1,LINT2,LINT3);
\int LINT1,LINT2,LINT3;
\real X;
\begin
\X:=INT2REAL(LINT1)-INT2REAL(LINT2);
\REAL2INT(X,LINT3);
\end;
\
\public proc INTMULT(LINT1,LINT2,LINT3);
\int LINT1,LINT2,LINT3;
\real X;
\begin
\X:=INT2REAL(LINT1)*INT2REAL(LINT2);
\REAL2INT(X,LINT3);
\end;
\
\public proc INTDIV(LINT1,LINT2,LINT3);
\int LINT1,LINT2,LINT3;
\real X;
\begin
\X:=INT2REAL(LINT1)/INT2REAL(LINT2);
\REAL2INT(X,LINT3);
\end;

\****************************************
\kent 1/16/94
\public proc TIMEOUT(S);         \\Timeout in Seconds
\int S;                          \\approximate timeout seconds
\int A,B,C;
\begin
\  for A:=1,S do for B:=1,32766 do for C:=1,3 do;
\end;


\kent 1/16/94
\public proc BYTEDISPLAY(PORT,START,NUM);
\CHOUTs "Num" bytes (special char) at "Start"
\** Currently only works for local variables
\int PORT;
\char START;
\of character string to display
\int NUM;
\of bytes
\int A;

\begin
\INTOUT(0,NUM); TEXT(0," bytes:");
\for A:=0,NUM-1 do
\ begin
\  case START(A) of
\   0:  TEXT(PORT,"[0]");
\   7:  TEXT(PORT,"[7]");
\   8:  TEXT(PORT,"[8]");
\   9:  TEXT(PORT,"[9]");
\   10:  TEXT(PORT,"[10]");
\   12:  TEXT(PORT,"[12]");
\   13:  TEXT(PORT,"[13]");
\   255:  TEXT(PORT,"[255]")
\   other CHOUT(PORT,START(A));
\ end;
\end;


\*****************************************************************************
\       Character BIT manipulation
\*****************************************************************************
\Shane's BIT  1/16/94

public proc BINOUT(PORT,CHR);
char PORT,CHR;
int BIT;
for BIT:=0,7 do if CHR&IEXP(2,7-BIT) then INTOUT(PORT,1) else INTOUT(PORT,0);

public func RETBIT(CHR,BIT);
char CHR,BIT;
return(CHR&IEXP(2,BIT));

public func TOGLBIT(CHR,BIT);
char CHR,BIT;
return(CHR|IEXP(2,BIT));

public func BITON(CHR,BIT);
char CHR,BIT;
return(CHR!IEXP(2,BIT));

public func BITOFF(CHR,BIT);
char CHR,BIT;
return(CHR&~IEXP(2,BIT));



public proc SETIDLEMODE(KEY,ASC,MMOVE,MBUTTON,MSPECIAL);
int KEY,ASC,MMOVE,MBUTTON,MSPECIAL;
begin
IDLEMODE:=0;
if KEY          then IDLEMODE:=BITON(IDLEMODE,0);
if ASC          then IDLEMODE:=BITON(IDLEMODE,1);
if MMOVE        then IDLEMODE:=BITON(IDLEMODE,2);
if MBUTTON      then
        begin
        IDLEMODE:=BITON(IDLEMODE,3);
        case MSPECIAL of
        0:      ;
        1:      IDLEMODE:=BITON(IDLEMODE,4);    \If any button is down, return
        2:      IDLEMODE:=BITON(IDLEMODE,5)     \If all buttons are up, return
        other;
        end;
end;

\*****************************************************************************
\       CPU clock utility public proceedures (18.5 ticks per second)
\*****************************************************************************
\Shanes CLOCK stuff  1/16/94
\**Note - needs Shane's BIGINT stuff

\public proc GETCPUTICK(LINT);
\int LINT;
\begin
\CPUREG(0):=$0000;
\SOFTINT($1A);
\LINT(0):=CPUREG(3);
\LINT(1):=CPUREG(2);
\end;

\public proc GETTICK;
\int LINT;
\begin
\LINT:=RESERVE(4);
\GETCPUTICK(LINT);
\
\REAL2INT(INT2REAL(LINT)-INT2REAL(TICK),LINT);
\return(LINT(0));
\end;
\
\public proc SETTICK(INTEGER);
\int INTEGER, LINT;
\begin
\LINT:=RESERVE(4);
\LINT(0):=INTEGER;
\LINT(1):=0;
\GETCPUTICK(TICK);
\REAL2INT(INT2REAL(TICK)-INT2REAL(LINT),TICK);
\end;
\
\public proc TIMEDWAIT(INTEGER);
\int INTEGER,W1,W2;
\begin
\SETTICK(0);
\loop if GETTICK>INTEGER then quit;
\end;

\************************************************
\more KENT   1/16/94

\kent 1/16/94
\public proc MESSAGE(MSG);
       \Generic message flasher
\int MSG;
\int A;
\begin
\GETCURSOR;
\CURSOR(2,0);
\HILIGHT(2,0,40,0,$67);
\case MSG of
                        \Always use this size text string
\  1:        TEXT(0,"Number Outside Range - Try Again       ")
\  other;
\TIMEOUT(2);
\CURSOR(2,0); for A:=2,40 do CHOUT(0,^ );
\CURSOR(TEXTCX,TEXTCY);
             \put cursor back where it was
\end;


\*****************************************************************************
\       Simple keyboard input
\*****************************************************************************
\from keyb-p.xpl

public func ALT2CTRL(KEY);
int KEY;
case KEY-256 of
\ALT-A\ 30:     return(01);
\ALT-B\ 48:     return(02);
\ALT-C\ 46:     return(03);
\ALT-D\ 32:     return(04);
\ALT-E\ 18:     return(05);
\ALT-F\ 33:     return(06);
\ALT-G\ 34:     return(07);
\ALT-H\ 35:     return(08);
\ALT-I\ 23:     return(09);
\ALT-J\ 36:     return(10);
\ALT-K\ 37:     return(11);
\ALT-L\ 38:     return(12);
\ALT-M\ 50:     return(13);
\ALT-N\ 49:     return(14);
\ALT-O\ 24:     return(15);
\ALT-P\ 25:     return(16);
\ALT-Q\ 16:     return(17);
\ALT-R\ 19:     return(18);
\ALT-S\ 31:     return(19);
\ALT-T\ 20:     return(20);
\ALT-U\ 22:     return(21);
\ALT-V\ 47:     return(22);
\ALT-W\ 17:     return(23);
\ALT-X\ 45:     return(24);
\ALT-Y\ 21:     return(25);
\ALT-Z\ 44:     return(26)
else return(KEY);

public proc GETKEY;    \used to be GETIN. is pin compatible with older version, I think. SBD 1-21-94
begin
EXTENDED:=CHIN(1);
if EXTENDED=0 then EXTENDED:=CHIN(1)+256;
EXTENDED:=ALT2CTRL(EXTENDED);
end;


\****************************************************************************
\       Conversion rutines
\****************************************************************************

\********
\ XPL STRINGS (HI-BIT TERMINATED)
\********

public func    XPL2INT(STR);    \Convert a string of ascii digits to an integer
char	STR;                    \Must be terminated with MSB set on last digit
begin                           \WARNING: This uses device 8
                                \** Does this handle negatives?? -RKD  I think so. - SBD
OPENO(8);
TEXT(8, STR);
TEXT(8, " 0");			\Return 0 if Str does not contain a number
OPENI(8);
return INTIN(8);		\Leading garbage is ignored
end;	\AtoI

public proc REAL2XPL(R,STR);    \Convert a real R to a string of ascii digits
real	R;                      \WARNING: This uses device 8
char	STR;                    \Creats a XPL string... (hi-bit)
int     I2;
begin
OPENO(8);
RLOUT(8,R);
CRLF(8);
I2:=0;
loop
        begin
        CH:=CHIN(8);
        if CH=$0D then quit;
        STR(I2):=CH;
        I2:=I2+1;
        end;
STR(I2-1):=STR(I2-1)!$80;
end;

public func real       XPL2REAL(STR);
char STR;
\real R;
int I2;
begin
OPENO(8);
I2:=0;
loop
        begin
        CHOUT(8,STR(I2)&$7F);
        if STR(I2)>$7F then quit;
        I2:=I2+1;
        end;
CRLF(8);
return(RLIN(8));
end;

\********
\ ASCII-Z
\********

public proc UPPERZ(STR);
char STR;
int I;
begin
I:=0;
while STR(I)#0 do
        [if STR(I)>=^a & STR(I)<=^z then STR(I):=STR(I)-32;
        I:=I+1];
end;

public proc LOWERZ(STR);
char STR;
int I;
begin
I:=0;
while STR(I)#0 do
        [if STR(I)>=^A & STR(I)<=^Z then STR(I):=STR(I)+32;
        I:=I+1];
end;

public func    Z2INT(STR);      \Convert a string of ascii digits to an integer
char	STR;
begin                           \WARNING: This uses device 8
OPENO(8);
TEXTZ(8,STR);
TEXT(8," 0");                   \Return 0 if Str does not contain a number
OPENI(8);
return INTIN(8);                \Leading garbage is ignored
end;


\added by Kent 1/25/94
public proc   	INT2Z(I, STR);  \Convert an integer to ASCII-Z
int  I;
char STR;
int I2;
begin
OPENO(8);
INTOUT(8,I);
CRLF(8);
I2:=0;
loop
        begin
        CH:=CHIN(8);
        if CH=$0D then quit;
        STR(I2):=CH;
        I2:=I2+1;
        end;
STR(I2):=0;
end;


\added by Kent 1/25/94
public proc    REAL2Z(R, STR);  \Convert a real R to a string of ascii digits
real R;                         \WARNING: This uses device 8
char STR;
int I2;
begin
OPENO(8);
RLOUT(8,R);
CRLF(8);
I2:=0;
loop
        begin
        CH:=CHIN(8);
        if CH=$0D then quit;
        STR(I2):=CH;
        I2:=I2+1;
        end;
STR(I2):=0;
end;


\added by Kent  1/25/94
public func real       Z2REAL(STR);
char STR;
\real R;
int I2;
begin
OPENO(8);
I2:=0;
loop
        begin
        if STR(I2)=0 then quit
                     else CHOUT(8,STR(I2));
        I2:=I2+1;
        end;
CRLF(8);
return(RLIN(8));
end;

\********
\ DATE CONVERSIONS
\********

public func real DATE2R(DATE);          \Converts DATE to a REAL
int DATE;
real R;
int I2,DTEMP;
begin
R:=FLOAT(DATE(0))*365.25+365.0;
R:=R+BOC;                               \2147483634=DAY 0 (BIRTH OF CHRIST)
R:=R+.0001-MOD(R+.0001,1.0);
for I2:=0,DATE(1)-2 do
        begin
        DTEMP:=MONTHS(I2);
        if I2=1 then if REM(DATE(0)/4)=0 then DTEMP:=29;
        R:=R+FLOAT(DTEMP);
        end;
R:=R+FLOAT(DATE(2));
return(R);
end;

public proc R2DATE(R,DATE);             \Converts R (a real) to a DATE
real R;
int DATE;
real YEAR,DAY;
int I2,DTEMP;
if R=0.0 then
        begin
        DATE(0):=0;
        DATE(1):=0;
        DATE(2):=0;
        end
else
begin
FORMAT(1,5);
R:=R-BOC;   \R=0=1/1/0001
YEAR:=R/365.25;

YEAR:=YEAR+.0001-MOD(YEAR+.0001,1.0);

DAY:=R-YEAR*365.25+1.0;
DAY:=DAY+.0001-MOD(DAY+.0001,1.0);

YEAR:=YEAR-1.0;

I2:=0;
loop
        begin
        if I2=1 & MOD(YEAR,4.0)=0.0 then DTEMP:=29 else DTEMP:=MONTHS(I2);
        if DAY<=FLOAT(DTEMP) then quit;
        DAY:=DAY-FLOAT(DTEMP);
        I2:=I2+1;
        end;

if YEAR>32000. then YEAR:=0.;
if YEAR<-32000. then YEAR:=0.;
if DAY>31. then DAY:=31.;
if DAY<0. then YEAR:=0.;
DATE(0):=FIX(YEAR);
DATE(1):=I2+1;
DATE(2):=FIX(DAY);
end;

public proc DATE2Z(DATE,STR);      \Converts DATE to an ASCIIZ string
int DATE;
char STR;
int I2,DTEMP;
begin
OPENO(8);
OPENI(8);
I2:=0;
if DATE(1)<10 then CHOUT(8,^ );
INTOUT(8,DATE(1));
CHOUT(8,^/);

if DATE(2)<10 then CHOUT(8,^0);
INTOUT(8,DATE(2));
CHOUT(8,^/);

DTEMP:=DATE(0);
if DTEMP>=1900 & DTEMP<2000 then DTEMP:=DTEMP-1900;
if DTEMP<10 then CHOUT(8,^0);
INTOUT(8,DTEMP);
CHOUT(8,$0D);
I2:=0;
loop
        begin
        STR(I2):=CHIN(8);
        if STR(I2)=$0D then quit;
        I2:=I2+1;
        end;
STR(I2):=0;
end;

public proc Z2DATE(STR,DATE);      \Converts ASCIIZ to a date
char STR;
int DATE,I2;
begin
OPENO(8);
OPENI(8);
I2:=0;
if STR(0)=^  then I2:=1;
CHOUT(8,^0);
loop
        begin
        if ISNUMBER(STR(I2)) then CHOUT(8,STR(I2)) else quit;
        I2:=I2+1;
        end;
CRLF(8);
DATE(1):=INTIN(8);

I2:=I2+1;
OPENO(8);
OPENI(8);
CHOUT(8,^0);
loop
        begin
        if ISNUMBER(STR(I2)) then CHOUT(8,STR(I2)) else quit;
        I2:=I2+1;
        end;
CRLF(8);
DATE(2):=INTIN(8);

I2:=I2+1;
OPENO(8);
OPENI(8);
CHOUT(8,^0);
loop
        begin
        if ISNUMBER(STR(I2)) then CHOUT(8,STR(I2)) else quit;
        I2:=I2+1;
        end;
CRLF(8);
DATE(0):=INTIN(8);

if DATE(0)<100 then DATE(0):=DATE(0)+1900;
end;

public proc GetSysDate(DATE);   \Get the system date
int DATE;
begin
CPUREG(0):=$2A00;
SOFTINT($21);
DATE(0):=CPUREG(2);
DATE(1):=CPUREG(3)>>8;
DATE(2):=CPUREG(3)&$FF;
end;

\********
\ TIME CONVERSIONS
\********

public proc GetSysTime(TIME);
int TIME;
begin
CPUREG(0):=$2C00;
SOFTINT($21);
TIME(0):=CPUREG(2)>>8;          \hours
TIME(1):=CPUREG(2)&$FF;         \minutes
TIME(2):=CPUREG(3)>>8;          \seconds
TIME(3):=(CPUREG(3)&$FF)*100;   \1/10000 sec (ms)
end;

public proc INT2TIME(INT,TIME);
int INT,TIME;
real THOURS;
begin
THOURS:=FLOAT(INT)/60.0;
THOURS:=THOURS-MOD(THOURS,1.0);
TIME(0):=FIX(THOURS);           \hours
TIME(1):=INT-TIME(0)*60;        \minutes
TIME(2):=0;                     \seconds
TIME(3):=0;                     \1/10000 sec (ms)
end;

public proc REAL2TIME(TREAL,TIME);
real TREAL;
int TIME;
real THOUR,TMIN,TSEC;
begin
TSEC:=INTPART(TREAL/10000.0);
TIME(3):=FIX(TREAL-TSEC*10000.0);  \1/10000 sec

TMIN:=INTPART(TSEC/60.0);
TIME(2):=FIX(TSEC-TMIN*60.0);      \Seconds

THOUR:=INTPART(TMIN/60.0);
TIME(1):=FIX(TMIN-THOUR*60.0);    \minutes
TIME(0):=FIX(THOUR);              \hours
end;

public func real TIME2REAL(TIME);
int TIME;
real TREAL;
begin
TREAL:=FLOAT(TIME(0));                  \set hours
TREAL:=TREAL*60.0+FLOAT(TIME(1));       \set minutes
TREAL:=TREAL*60.0+FLOAT(TIME(2));       \set seconds
TREAL:=TREAL*10000.0+FLOAT(TIME(3));    \set 1/10000 second
return(TREAL);
end;

public func TIME2INT(TIME);
int TIME,INT;
real TREAL;
begin
INT:=TIME(0);                   \set hours
INT:=INT*60+TIME(1);          \set minutes
return(INT);
end;

public proc TIME2Z(TIME,STR,FORMAT);    \FORMAT=0 for SHORT (HH:MM) format
int TIME;                               \1 for LONG (HH:MM:SS.SSS) format
char STR;
int FORMAT,TMP,I2;
begin
OPENO(8);
OPENI(8);
I2:=0;
TMP:=TIME(0);
if TIMEMODE=false then          \12 hour clock
        begin
        if TMP>=12 then TMP:=TMP-12;
        if TMP=0 then TMP:=12;
        end;
if TMP<10 then CHOUT(8,^ );
INTOUT(8,TMP);
CHOUT(8,^:);

if TIME(1)<10 then CHOUT(8,^0);
INTOUT(8,TIME(1));

if FORMAT then
        begin
        CHOUT(8,^:);
        if TIME(2)<10 then CHOUT(8,^0);
        INTOUT(8,TIME(2));

        CHOUT(8,^.);

        if TIME(3)<1000 then CHOUT(8,^0);
        if TIME(3)<100 then CHOUT(8,^0);
        if TIME(3)<10 then CHOUT(8,^0);
        INTOUT(8,TIME(3));
        end;

if TIMEMODE=false then
        if TIME(0)>=12 then TEXT(8,"p") else TEXT(8,"a");

CHOUT(8,$0D);
I2:=0;
loop
        begin
        STR(I2):=CHIN(8);
        if STR(I2)=$0D then quit;
        I2:=I2+1;
        end;
STR(I2):=0;
end;

public proc Z2TIME(STR,TIME);
char STR;
int TIME,I2;
begin
OPENO(8);
OPENI(8);
I2:=0;
if STR(0)=^  then I2:=1;
CHOUT(8,^0);
loop
        begin
        if ISNUMBER(STR(I2)) then CHOUT(8,STR(I2)) else quit;
        I2:=I2+1;
        end;
CRLF(8);
TIME(0):=INTIN(8);      \hours

I2:=I2+1;
OPENO(8);
OPENI(8);
CHOUT(8,^0);
loop
        begin
        if ISNUMBER(STR(I2)) then CHOUT(8,STR(I2)) else quit;
        I2:=I2+1;
        end;
CRLF(8);
TIME(1):=INTIN(8);      \minutes

if STR(I2)=^: then      \Seconds & 1/10000 secs
        begin
        I2:=I2+1;
        OPENO(8);
        OPENI(8);
        CHOUT(8,^0);
        loop
                begin
                if ISNUMBER(STR(I2)) then CHOUT(8,STR(I2)) else quit;
                I2:=I2+1;
                end;
        CRLF(8);
        TIME(2):=INTIN(8);      \seconds

        if STR(I2)=^. then      \1/10000 secs
                begin
                I2:=I2+1;
                OPENO(8);
                OPENI(8);
                CHOUT(8,^0);
                loop
                        begin
                        if ISNUMBER(STR(I2)) then CHOUT(8,STR(I2)) else quit;
                        I2:=I2+1;
                        end;
                CRLF(8);
                TIME(3):=INTIN(8);      \1/10000 seconds
                end;
        end;
case LOWER(STR(I2)) of
^p:     [TIME(0):=TIME(0)+12;if TIME(0)>23 then TIME(0):=12];
^a:     [if TIME(0)=12 then TIME(0):=0]
other;
end;

\********
\ BIT FLAG CONVERSIONS
\********

public proc BITF2Z(CHR,STR);
char CHR,STR;
int I;
begin
for I:=0,7 do if RETBIT(CHR,7-I) then STR(I):=^X
                else STR(I):=^.;
STR(8):=0;
end;

public func Z2BITF(STR);
char STR,CHR;
int I;
begin
CHR:=0;
for I:=0,7 do if STR(I)=^X then CHR:=BITON(CHR,7-I) else CHR:=BITOFF(CHR,7-I);
return(CHR);
end;

\********
\ Hex String CONVERSIONS
\********

public proc HEX2Z(HEXSTR,ZSTR,NUM);
char HEXSTR,ZSTR;
int NUM,CNT,ZPOS,T;
begin
if HEXSTR=ZSTR then [CRLF(0);TEXT(0,"HEX2Z: Error! HEXSTR and ZSTR are the same!");CH:=CHIN(1)];
ZPOS:=0;
for CNT:=0,NUM-1 do
        begin
        OPENI(8);
        OPENO(8);
        HEXOUT(8,HEXSTR(CNT));
        T:=CHIN(8);
        T:=CHIN(8);
        ZSTR(ZPOS):=CHIN(8);ZPOS:=ZPOS+1;
        ZSTR(ZPOS):=CHIN(8);ZPOS:=ZPOS+1;
        if CNT=NUM-1 then       ZSTR(ZPOS):=0
                else            ZSTR(ZPOS):=^ ;
        ZPOS:=ZPOS+1;
        end;
\CRLF(0);TEXT(0,"HEX2Z: ");TEXTZ(0,ZSTR);CH:=CHIN(1);
end;

public proc Z2HEX(ZSTR,HEXSTR);
char ZSTR,HEXSTR;
int ZPOS,HEXPOS,CNT,I;
begin
ZPOS:=0;
HEXPOS:=0;
loop
        begin
        OPENO(8);
        OPENI(8);
\        CHOUT(8,$FF);
\        CHOUT(8,$FF);
        for I:=0,1 do
                begin
                loop
                        begin
                        if ZSTR(ZPOS)=0 then quit;
                        if ISHEX(UPPER(ZSTR(ZPOS))) then [CHOUT(8,UPPER(ZSTR(ZPOS)));ZPOS:=ZPOS+1;quit]
                        else ZPOS:=ZPOS+1;
                        end;
                end;
        if ZSTR(ZPOS)=0 then quit;
        CRLF(8);
        HEXSTR(HEXPOS):=HEXIN(8);
        HEXPOS:=HEXPOS+1;
        end;
end;


\********************************************************************
\       Getting the directory that BBS/BBSEDIT was run from (for saving private files $CALLSCR.SAV and $RETVARS.SAV)
\********************************************************************

public func RINT(SEG,OFF);
int SEG,OFF;
int TI;
begin
BLIT(SEG,OFF,DATASEG,address TI,2);
return(TI);
end;

public proc GETRUNDIR;
seg char ENV;
int I;
begin
ENV:=RESERVE(2);
ENV(0):=RINT(PSP(0),44);
I:=0;
loop
        begin
        if ENV(0,I)=0 & ENV(0,I+1)=0 then [BLIT(ENV(0),I+4,DATASEG,RUNDIR,100);quit];
        I:=I+1;
        end;

SPLITZ2(RUNDIR,^\,RUNDIR,STRING);

if ZLEN(RUNDIR)>0 then
        begin
        Z2XPL(RUNDIR);
        ADDXPL("\",RUNDIR);
        end
else COPYXPL("\",RUNDIR);
end;

public proc GetCline(STR);   \Get the command line in ASCII-Z format
char STR;
int LENGTH;
begin
LENGTH:=PSP(0,$6C+20);
BLIT(PSP(0),$6C+21,DATASEG,STR,LENGTH);
STR(LENGTH):=0;
end;

public proc SetCline(STR);   \Get the command line in ASCII-Z format
char STR;
int LEN;
begin
LEN:=ZLEN(STR);
BLIT(DATASEG,STR,PSP(0),$6C+21,LEN);
PSP(0,$6C+20):=LEN;
POKE(PSP(0),$6C+21+LEN,$D);
end;

\**********************************************************************
\ New Time Procs
\**********************************************************************
public func real GetCompleteTime;
                                \returns a REAL that indicates the current
                                \DATE+TIME accurate to 1/100 second
real RET;
int TIMEINT;
begin
TIMEINT:=RESERVE(4*INTSIZE);
GetSysDate(TIMEINT);
RET:=8640000.0*(Date2R(TIMEINT)-BOC);     \Current Date
GetSysTime(TIMEINT);
RET:=RET+TIME2REAL(TIMEINT)/100.0;
return(RET);
end;


