efunc GETFREE;
eproc CTYPE;
efunc CHKKEY;
efunc GETKEYFLAGS;
eproc OUTCHAR;
efunc RETMAX;
efunc RETMIN;
efunc real RETMINREAL;
efunc UPPER;
efunc LOWER;
efunc ISLETTER;
efunc ISHEX;
efunc ISNUMBER;
eproc GETCURSOR;
eproc GETVIDINFO;
\eproc SCRSAVE;
\eproc SCRRESTOR;
\eproc WINSAVE;
\eproc WINRESTOR;
eproc ATTRIB;
eproc SETWIND;

\*****************************************************************************
\       Generic String Routines
\*****************************************************************************
efunc STRNCMP;
eproc STRCOPY;

\*****************************************************************************
\       XPL String Rutines
\*****************************************************************************
eproc XPLLEN;
eproc ADDXPL;
eproc COPYXPL;
eproc TEXTCENTER;

\*****************************************************************************
\       ASCII-Z to XPL string conversion rutines
\*****************************************************************************
eproc Z2XPL;
eproc XPL2Z;

\*****************************************************************************
\       ASCII-Z string rutines
\*****************************************************************************
efunc ZLEN;
eproc COPYZ;
eproc TEXTZ;
efunc WWZ;
eproc ADDZ;
eproc ZFORMAT;
eproc ZTERM;
eproc SPLITZ;
eproc SPLITZ2;
eproc SWhiteZ;
\*****************************************************************************
\       Real and 2 byte-signed-integer stuff
\*****************************************************************************
efunc real FRAC;
efunc real INTPART;
eproc IEXP;

\*****************************************************************************
\       Large Integer Rutines
\*****************************************************************************
eproc REAL2INT;
efunc real INT2REAL;
\eproc INTINC;
\eproc INTADD;
\eproc INTSUB;
\eproc INTMULT;
\eproc INTDIV;
\eproc BYTEDISPLAY;

\*****************************************************************************
\       Character BIT manipulation
\*****************************************************************************
eproc BINOUT;
efunc RETBIT;
efunc TOGLBIT;
efunc BITON;
efunc BITOFF;
eproc SETIDLEMODE;
\*****************************************************************************
\       CPU clock utility public proceedures (18.5 ticks per second)
\*****************************************************************************
\eproc GETCPUTICK;
\eproc GETTICK;
\eproc SETTICK;
\eproc TIMEDWAIT;

\*****************************************************************************
\       Simple keyboard input
\*****************************************************************************
efunc ALT2CTRL;
eproc GETKEY;

\****************************************************************************
\       Conversion rutines
\****************************************************************************

\********
\ XPL STRINGS (HI-BIT TERMINATED)
\********
efunc XPL2INT;
eproc REAL2XPL;
efunc real XPL2REAL;

\********
\ ASCII-Z
\********
eproc UPPERZ;
eproc LOWERZ;
efunc Z2INT;
eproc INT2Z;
eproc REAL2Z;
efunc real Z2REAL;

\********
\ DATE CONVERSIONS
\********
efunc real DATE2R;
eproc R2DATE;
eproc DATE2Z;
eproc Z2DATE;
eproc GETSYSDATE;

\********
\ TIME CONVERSIONS
\********

eproc GETSYSTIME;
eproc INT2TIME;
eproc REAL2TIME;
efunc real TIME2REAL;
efunc TIME2INT;
eproc TIME2Z;  \FORMAT=0 for SHORT  format, 1 for long
eproc Z2TIME;

\********
\ BIT FLAG CONVERSIONS
\********

eproc BITF2Z;
efunc Z2BITF;

\********
\ Hex String CONVERSIONS
\********

eproc HEX2Z;
eproc Z2HEX;

\********************************************************************
\       Getting the directory that BBS/BBSEDIT was run from (for saving private files $CALLSCR.SAV and $RETVARS.SAV)
\********************************************************************
efunc RINT;
eproc GETRUNDIR;
eproc GetCline;
eproc SetCline;


\**********************************************************************
\ New Time Procs
\**********************************************************************
efunc real GetCompleteTime;     \returns a REAL that indicates the current
                                \DATE+TIME accurate to 1/100 second


