\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,        CRLF=9,         INTIN=10,       INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,       POINT=41,       LINE=42,        MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
ATTRIB=69,      SETWIND=70,     RAWTEXT=71,     HILIGHT=72,
MALLOC=73       RELEASE=74;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
LABS=51,       FORMAT=52,

SQRT=53,        LN=54,          EXP=55,         SIN=56,
ATAN2=57,       MOD=58,         LOG=59,         COS=60,
TAN=61,         ASIN=62,        ACOS=63;

int CH,I,HANDLE,EXTENDED,TEXTCX,TEXTCY,CPUREG,ACOLOR,TEMP,TTMP,BAUD,COLOR;
char STRING,STRPOS,SCRMXMN,CALLOTHER,LCLOTHER,QUITB,CALLER,INTERUPT,SINGLEKEY;
int TX,TY,PSPADD;
\STRING is used for the input/editing/and output string for types: VANILLA
\STRPOS if an array that holds inportant information on the on-screan
\       starting point of the string...
\SCRMXMN if an array contianing the range that the CALLER will see on screan
\SCRMXMN(0) if where the callers screan startes compared to the local screan
\SCRMXMN(1) if where the callers screan ends compared to the local screan
seg char
CALLSCR,
LCLSCR,
SSAVE,
DIRSCR,
PSP;


\VARIABLES THAT ARE INITIALIZED IN "GETPARAMS"
int LENGTH, POSITION, COMMAND;

\VARIABLES THAT ARE PRIMARILY USED IN "USERINPT"
char INSERT;

\ANSI VARIABLES:
char ANSIX,ANSIY;

def
\----------------LEGITIMATE VALUES FOR "COMMAND"
ICOMM=0,                \INIT COMMPORT AND MODEM
HANGUP=1,               \HANG UP
CREF=2,                 \refresh remote screan
WAITFORCALL=3,          \wait for caller
TOTALREFRESH=4,         \completely refresh the remote screen
SYSOPCHAT=5,            \CHAT WITH SYSOP
ONEKEY=10,              \ONE KEY (mainly for menus)
VSTRINGINPUT=11,        \"VANILLA STRING INPUT"
PSTRINGINPUT=12,        \"PASSWORD STRING INPUT" (NOT ECHO)
ICSTRINGINPUT=13,       \INITIAL CAPS...
DATEINPUT=14,           \DATE INPUT (LENGTH:=6)
PHNUMINPUT=15,          \PHONE NUMBER INPUT (LENGTH:=10)
CSCROLL=16,             \Cursor scroll

CLOCAL=0,
CREMOTE=1;

\VARIABLES NEEDED FOR "SERIAL.XPL"
int COMPORT;
int LINESTAT,MDMSTAT;
char ERRCHK;
\int REFX,REFY;

proc DESSTNG;
begin
loop
        begin
        for I:=0,LENGTH do
                begin
                if STRING(I)=0 then quit;
                CHOUT(0,STRING(I));
                end;
        quit;
        end;
CH:=CHIN(1);
end;



\proc PAUSE;
\int YY;
\begin
\TEXT(0,"--PAUSED--");
\loop if CHKKEY then quit;
\YY:=CHIN(I);
\end;

proc NEXTCHAR(CHR);
char CHR;
loop    [CH:=CHIN(3);if CH=CHR then quit];

proc GETCURSOR;
begin
CPUREG(0):=$0300;       CPUREG(1):=$0000;
SOFTINT($10);
TEXTCY:=(CPUREG(3)&$FF00)/$100;
TEXTCX:=CPUREG(3)&$00FF;
end;

\proc DEBUG(CHR);
\char CHR;
\begin
\GETCURSOR;
\CURSOR(78,0);
\CHOUT(0,CHR);
\CURSOR(TEXTCX,TEXTCY);
\end;


proc DRWINS;
begin
GETCURSOR;
CURSOR(74,0);
if INSERT then TEXT(0,"(INS)") else TEXT(0,"(   )");
CURSOR(TEXTCX,TEXTCY);
end;

proc REMOTE;
begin
\TEXT(0,"REMOTE: (COM) ");INTOUT(0,COMPORT);TEXT(0,", (REMOTE?) ");INTOUT(0,CALLER);TEXT(0,", (CREMOTE)");INTOUT(0,CREMOTE);CH:=CHIN(1);
if COMPORT<8 & CALLER=CREMOTE then return(true) else return(false);
end;


proc UCASE(CHARR);
char CHARR;
if CHARR>=97 & CHARR<=122 then return(CHARR-32)
else return(CHARR);

proc SYSMESSAGE;
begin
HILIGHT(12,6,72,16,$08);
ATTRIB($1A);
SETWIND(10,5,70,15,$FF02,true);
RAWTEXT(6,"͸
                                                           
                                                           
                                                           
                                                           
                                                           
                                                           
                                                           
                                                           
                                                           
                                                           
; ");
ATTRIB($08);
SETWIND(11,6,69,14,$FF00,true);
end;

include CLINE;
\include LOADCNFG;
include CLOCK;
include BIT;
include SERIAL;

proc INITCALL;
\initializes CALLSCR & CALLOTHER
begin
for I:=0,80*25 do for TEMP:=0,1 do
        if TEMP=1 then CALLSCR(0,I*2+1):=$7
        else CALLSCR(0,I*2):=^ ;
CALLOTHER(0):=0;
CALLOTHER(1):=0;
CALLOTHER(2):=$07;
CALLOTHER(3):=100;
CALLOTHER(4):=100;
if REMOTE then
        begin
        COUT($1B);
        COMTEXT("[0;37;40m");
        COUT($0C);
        end;
end;

\        proc CKCOM;
\        if REMOTE then return(CKKCOM)
\        else return(false);

include ANSI;
include CALLREF;
\include GETPARAM;
include USERINPT;


proc RETPARAMS;
begin
HANDLE:=FOPEN("RETVARS.SC",1);
FSET(HANDLE,^O);


\------------------------------STRING RETURN
TEXT(3,"STRING =");
if COMMAND#CSCROLL then
        begin
        I:=0;
        loop
                begin
                if STRING(I)=0 then quit;
                if COMMAND=PHNUMINPUT & I=0 then CHOUT(3,^();
                CHOUT(3,STRING(I));
                if COMMAND=DATEINPUT & (I=1 ! I=3) then CHOUT(3,^/);
                if COMMAND=PHNUMINPUT & I=2 then CHOUT(3,^));
                if COMMAND=PHNUMINPUT & I=5 then CHOUT(3,^-);
                I:=I+1;
                end;
        end
else    INTOUT(3,POSITION);
CHOUT(3,^=);CRLF(3);



\------------------------------SINGLE_KEY RETURN
TEXT(3,"SINGLE_KEY =");
TEXT(3,SINGLEKEY);CHOUT(3,^=);
\if NUMBER#0 then
\        begin
\        CRLF(3);
\        TEXT(3,"NUMBER =");INTOUT(3,NUMBER);
\        CHOUT(3,^=);
\        end;
CHOUT(3,$1A);
CLOSE(3);
FCLOSE(HANDLE);
end;

proc STITLEBAR;
begin
GETCURSOR;
ATTRIB($A);
CURSOR(59,0);TEXT(6," XBBSv1.3           ");
CURSOR(70,0);INTOUT(6,COMMAND);
CURSOR(TEXTCX,TEXTCY);
DRWINS;
ATTRIB(COLOR);
end;

\proc TITLEBAR;
\begin
\GETCURSOR;
\ATTRIB($4E);
\SETWIND(0,0,79,0,$FF02,true);
\CURSOR(0,0);
\
\RAWTEXT(6,"XBBSv1.3  Modem:  ");
\if REMOTE then [if CARRIER then TEXT(6,"on-line") else TEXT(6,"off-line")]
\else TEXT(6,"local");
\RAWTEXT(6,"  Status:  ");
\case COMMAND of
\ICOMM:          [TEXT(6,"Initializing comm port ");if COMPORT=8 then TEXT(6,"(none)") else INTOUT(6,COMPORT)];
\HANGUP:         [TEXT(6,"Hanging up")];
\CREF:           [TEXT(6,"Refreshing remote scream")];
\WAITFORCALL:    [TEXT(6,"Waiting for a caller (L to logon locally)")];
\ONEKEY:         [TEXT(6,"Waiting for a single key")];
\VSTRINGINPUT:   [TEXT(6,"Inputting a 'Vanilla' string")];
\PSTRINGINPUT:   [TEXT(6,"Inputting a 'Password' string (no echo)")];
\ICSTRINGINPUT:  [TEXT(6,"Inputting an 'Initial Caps' string")];
\DATEINPUT:      [TEXT(6,"Inputting a date")];
\PHNUMINPUT:     [TEXT(6,"Inputting a phone number")]
\else            [TEXT(6,"I'm confused!!! (COMMAND not legit)")];
\
\
\
\CURSOR(TEXTCX,TEXTCY);
\DRWINS;
\ATTRIB(COLOR);
\end;


proc VARINIT;
begin
SSAVE:=RESERVE(2);
SSAVE(0):=MALLOC((80*25*2)/16+1);
\RETURN VARIABLES:
SINGLEKEY:=RESERVE(100);
STRING:=RESERVE(2000);

INSERT:=true;
CALLSCR:=RESERVE(2);
CALLSCR(0):=MALLOC((80*25*2)/16+1);

CALLOTHER:=RESERVE(5);

\CALLOTHER(0) is the callers current X cursor position
\CALLOTHER(1) is the callers current Y cursor position
\CALLOTHER(2) is the callers current color
\CALLOTHER(3) is the callers saved X cursor position
\CALLOTHER(4) is the callers saved Y cursor position

\CALLSCR(0,I) is the callers current screan


LCLSCR:=RESERVE(2);
LCLSCR(0):=$B800;
\MALLOC((80*25*2)/16+1);

LCLOTHER:=RESERVE(5);
\LCL* is set up exactly like "CALL*"

STRPOS:=RESERVE(2);

DIRSCR:=RESERVE(2);
DIRSCR(0):=$B800;

SCRMXMN:=RESERVE(2);
SCRMXMN(0):=1;
SCRMXMN(1):=24;
end;

begin
CPUREG:=GETREG;
PSPADD:=CPUREG(11);
PSP:=RESERVE(2);
PSP(0):=PSPADD;
\ATTRIB($1F);
SETWIND(0,0,79,24,$FF00,false);

VARINIT;
\LOADCNFG;
\GETPARAMS;
LOADSCR;
CLINE;
STITLEBAR;

GETLOCAL;
\COMMAND:=10;
\loop if CHKKEY then CH:=CHIN(1) else quit;
\if REMOTE then [loop if CKKCOM then CH:=CIN else quit];
USERINPUT;

RETPARAMS;
SAVESCR;

RELEASE(SSAVE(0));
RELEASE(CALLSCR(0));
\RELEASE(LCLSCR(0));
\BLIT(CALLSCR(0),0,$B800,0,80*25*2);
end;
