\BLACKJ.XPL
\BLACK JACK GAME

'CODE'
RAN=1,RESERVE=3,CHIN=7,CHOUT=8,
REM=2,CRLF=9,NUMIN=10,
NUMOUT=11,TEXT=12,OPENIN=13,
OPENOUT=14,CLOSE=15,ABORT=16;



'DEF'
	MAXPLAY=10,	\MAXIMUM NUMBER OF PLAYERS IN THE GAME
	MAXHAND=11;	\MAXIMUM NUMBER OF CARDS IN A HAND



'INTEGER'
	X,		\GLOBAL TEMPORARY
	UP,		\SHOW DEALERS HOLE CARD
	DOWN,	\DON'T SHOW HOLE CARD
	NEXTCARD,	\POINT TO NEXT CARD IN DECK
	PLAYERS,	\PLAYER'S HANDS
	DEALER,	\DEALER'S HAND
	NUMDECKS,	\NUMBER OF DECKS
	NUMPLAY,	\NUMBER OF PLAYERS
	NDEALC,	\NUMBER OF CARDS IN DEALERS HAND
	DECKSIZE;	\TOTAL CARDS



'ADDRESS'
	NPLAYC,	\NUMBER OF CARDS IN A PLAYERS HAND
	DECK;	\THE WORKING DECK



'PROCEDURE' CVALUE(C);
'INTEGER' C;
'BEGIN'
C:=REM(C/13)+1;
'RETURN' 'IF' C>10 'THEN' 10 'ELSE' C;
'END';



'PROCEDURE' DISPLAY(VAL);
'INTEGER' VAL,SUIT,CARD;
'BEGIN'
SUIT:=VAL/13;
CARD:=REM(0);
'CASE' CARD 'OF'
	0: CHOUT(0,^A);
	10: CHOUT(0,^J);
	11: CHOUT(0,^Q);
	12: CHOUT(0,^K)
'ELSE' NUMOUT(0,CARD+1);
TEXT(0,"  ");
'CASE' SUIT 'OF'
	0: TEXT(0,"DIAMONDS");
	1: TEXT(0,"HEARTS");
	2: TEXT(0,"CLUBS");
	3: TEXT(0,"SPADES")
'ELSE';
'END';



'PROCEDURE' TOTAL(CARDS,NUMBER);
'INTEGER' CARDS,NUMBER,ACES,SUM,V;
'BEGIN'
SUM:=0;
ACES:=0;
'FOR' X:=0,NUMBER-1 'DO'
	'BEGIN'
	V:=CVALUE(CARDS(X));
	SUM:=SUM+V;
	'IF' V=1 'THEN' ACES:=ACES+1;
	'END';
'IF' SUM<12 & ACES>0 'THEN' SUM:=SUM+10;
TEXT(0,"<");
NUMOUT(0,SUM);
TEXT(0,">");
'RETURN' SUM;
'END';



'PROCEDURE' TABLE(SHOW);
'INTEGER' SHOW,X,Y;
'BEGIN'
TEXT(0,"THE DEALER HAS");
CRLF(0);
CRLF(0);
'FOR' X:=0,NDEALC-1 'DO'
	'BEGIN'
	'IF' SHOW ! X#0 'THEN' DISPLAY(DEALER(X));
	CRLF(0);
	'END';
'IF' SHOW 'THEN'
	'BEGIN'
	TEXT(0,"DEALERS TOTAL ");
	X:=TOTAL(DEALER,NDEALC);
	NUMOUT(0,X);
	CRLF(0);
	'END';
CRLF(0);
'FOR' X:=0,NUMPLAY-1 'DO'
	'BEGIN'
	TEXT(0,"PLAYER NUMBER ");
	NUMOUT(0,X+1);
	TEXT(0," HOLDS:");
	CRLF(0);CRLF(0);
	'FOR' Y:=0,NPLAYC(X)-1 'DO'
		'BEGIN'
		DISPLAY(PLAYERS(X,Y));
		CRLF(0);
		'END';
	TEXT(0,"PLAYERS TOTAL: ");
	NUMOUT(0,TOTAL(PLAYERS(X)),NPLAYC(X));
	CRLF(0);
	'END';
'END';



'PROCEDURE' NEWDECK;
'INTEGER' X,Y;
'BEGIN'
'FOR' X:=0,NUMDECK-1 'DO'
	'BEGIN'
	'FOR' Y:=0,51 'DO' DECK((X*52)+Y):=Y;
	'END';
'END';



'PROCEDURE' SHUFFLE;
'INTEGER' A,B,TEMP,X;
'BEGIN'
NEXTCARD:=0;
TEXT(0,"SHUFFLING....");
CRLF(0);
'FOR' X:=0,DECKSIZE*2 'DO'
	'BEGIN'
	A:=RAN(DECKSIZE);
	B:=RAN(DECKSIZE);
	TEMP:=DECK(A);
	DECK(A):=DECK(B);
	DECK(B):=TEMP;
	'END';
'END';



'PROCEDURE' GETCARD;
'INTEGER' C;
'BEGIN'
'IF' NEXTCARD>=DECKSIZE 'THEN' SHUFFLE;
C:=DECK(NEXTCARD);
NEXTCARD:=NEXTCARD+1;
'RETURN' C;
'END';



'PROCEDURE' CLEAR;
'INTEGER' X;
'BEGIN'
NDEALC:=0;
'FOR' X:=0,MAXPLAY-1 'DO' NPLAYC(X):=0;
'END';



'PROCEDURE' DEAL;
'INTEGER' X;
'BEGIN'
DEALER(0):=GETCARD;
DEALER(1):=GETCARD;
NDEALC:=2;

'FOR' X:=0,NUMPLAY-1 'DO'
	'BEGIN'
	PLAYERS(X,0):=GETCARD;
	PLAYERS(X,1):=GETCARD;
	NPLAYC(X):=2;
	'END';
'END';



'PROCEDURE' HIT;
'INTEGER' BUST,SOFT;
'BEGIN'
BUST:='FALSE';
TEXT(0,"HIT? ");
OPENIN(0);
'IF' CHIN(0)=^Y 'THEN'
	'REPEAT'
	'BEGIN'
	PLAYERS(0,NPLAYC(0)):=GETCARD;
	NPLAYC(0):=NPLAYC(0)+1;
	TABLE(DOWN);
	TEXT(0,"AGAIN? ");
	OPENIN(0);
	'END'
'UNTIL' CHIN(0)#^Y;
'END';



'PROCEDURE' DODEALER;
'BEGIN'
TABLE(UP);
'LOOP'
	'BEGIN'
	'IF' TOTAL(DEALER,NDEALC)>16 'THEN' 'QUIT';
	TEXT(0,"DEALER TAKES A CARD");
	CRLF(0);
	DEALER(NDEALC):=GETCARD;
	NDEALC:=NDEALC+1;
	TABLE(UP);
	'END';
'END';



'PROCEDURE' PAYOFF;
'BEGIN'
'END';




'PROCEDURE' GAME;
'BEGIN'
CLEAR;
NUMPLAY:=1;
DEAL;
TABLE(DOWN);
HIT;
DODEALER;
PAYOFF;
'END';



'BEGIN'	\MAIN
'REPEAT'
	'BEGIN'
	TEXT(0,"NUMBER OF DECKS? ");
	CRLF(0);
	TEXT(0,"(1 TO 9) ");
	NUMDECKS:=NUMIN(0);
	'END'
'UNTIL' NUMDECKS>0 & NUMDECKS<11;
DECKSIZE:=(52*NUMDECKS);
DECK:=RESERVE(DECKSIZE);
DEALER:=RESERVE(2*MAXHAND);
PLAYERS:=RESERVE(2*MAXPLAYERS);
'FOR' X:=0,MAXPLAYERS-1 'DO' PLAYERS(X):=RESERVE(2*MAXHAND);
NPLAYC:=RESERVE(MAXPLAYER);
UP:='TRUE';
DOWN:='FALSE';

NEWDECK;
SHUFFLE;
'REPEAT'
	'BEGIN'
	GAME;
	TEXT(0,"ANOTHER GAME? ");
	OPENIN(0);
	'END'
'UNTIL' CHIN(0)=^N;
'END';
