\CAL.XPL
\PROGRAMMERS CALCULATOR


'CODE'

ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;
'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;



'DEFINE'	\DEFINE NUMBER BASE FLAGS

	BIN,	\BINARY MODE FLAG
	OCT,	\OCTAL MODE FLAG
	DEC,	\DECIMAL MODE FLAG
	HEX;	\HEXADECIMAL MODE FLAG



'DEFINE'
	LOW=0,	\POINTER TO LOW INTEGER
	HI=1;	\POINTER TO HIGH INTEGER


'DEFINE'
	BLANK=$20,	\BLANK CHARACTER
	DEL=$7F	\DELETE
	CR=$0D,	\CARRIAGE RETURN
	BELL=7,	\BELL
	FF=$0C;	\FORM FEED

'DEFINE'
	OFF=5,		\OFFSET
	BASLIN=21,	\LINE TO DISPLAY BASE OF NUMBER
	MAINLINE=23,	\LINE TO DISPLAY ARGUMENTS
	INLINE=19;	\NUMBER INPUT LINE



'ADDRESS'
	NSTRING;	\HOLDS INPUT NUMBER STRING
	



'INTEGER'
	BEFORE,		\DIGIT BEFORE DECIMAL
	AFTER,		\DIGITS AFTER DECIMAL

	ARGBAS,		\BASE OF ARGUMENTS

	CHAR,	\GLOBAL CHAR

	ARG,	\WHICH ARGUMENT ACTIVE
	INTAC1,	\INTEGER ACCUMULATOR NUMBER ONE
	INTAC2,	\INTEGER ACCUMULATOR NUMBER TWO

	SPTR,	\POINTER FOR NUMBER STRING

	OPER,	\OPERATOR
	MODLEN,	\DIGITS IN A NUMBER
	MODE;	\FLAGS DECIMAL, HEX OR OCTAL MODE



'REAL'
	FLPAC;	\FLOATING POINT ACCUMULATORS



'FUNCTION' 'REAL' TRUNK(R);
'REAL' R;
'RETURN' R-MOD(R,1.);



'PROCEDURE' SIZE(R);
'REAL' R,T,CF,RF;
'INTEGER' X;
'BEGIN'
'IF' R=0. 'THEN'
	'BEGIN'
	BEFORE:=3;
	AFTER:=0;
	'RETURN';
	'END';
R:=RLABS(R);
T:=LOG(R);
BEFORE:=FIX(T-MOD(T,1.))+1;
'IF' BEFORE<=2 'THEN' BEFORE:=3;

CF:=EXP(FLOAT(BEFORE-9)*2.30258509);
RF:=CF/2.;

'FOR' AFTER:=0,8-BEFORE 'DO'
	'BEGIN'
	'IF' MOD(R+RF,1.)<CF 'THEN' 'RETURN';
	R:=R*10.;
	CF:=CF*10.;
	RF:=RF*10.;
	'END';
'END';



'PROCEDURE' EXOR(A,B);
'INTEGER' A,B;
'RETURN' (A & 'NOT' B) ! ('NOT' A & B);



'PROCEDURE' CLRLIN(L);
'INTEGER' L;
'BEGIN'
CURSOR(0,L);
TEXT(0,"                                       ");
'END';



'PROCEDURE' GETC;
CHAR:=CHIN(0);



'PROCEDURE'NUMERIC;
'INTEGER'DUMMY;
'RETURN'CHAR>=^0 & CHAR<=^9;



'PROCEDURE'ISHEX;
'INTEGER'DUMMY;
'RETURN'NUMERIC ! (CHAR>=^A & CHAR<=^F);



'PROCEDURE' ISNUM;
'BEGIN'
'CASE' MODE 'OF'
	BIN: 'RETURN' CHAR=^0 ! CHAR=^1;
	OCT: 'RETURN' CHAR>=^0 & CHAR<=^7;
	DEC: 'RETURN' NUMERIC ! CHAR=^.;
	HEX: 'RETURN' ISHEX
'ELSE';
'END';



'PROCEDURE' HEXCHAR(C);
'INTEGER' C;
'IF' C<10 'THEN' CHOUT(0,^0+C)
	'ELSE' CHOUT(0,^A+C-10);


'PROCEDURE' BYTEOUT(B);
'INTEGER' B,R;
'BEGIN'
B:=B&$FF;
B:=B/16;
R:=REM(0);
HEXCHAR(B);
HEXCHAR(R);
'END';


'PROCEDURE' HEXWORD(W);
'INTEGER' W;
'BEGIN'
BYTEOUT(SWAP(W));
BYTEOUT(W);
'END';


'PROCEDURE' HEXO32(I);
'INTEGER' I;
'BEGIN'
HEXWORD(I(HI));
HEXWORD(I(LOW));
'END';



'PROCEDURE' OCTO32(I);
'INTEGER' I;
'ADDRESS' A;
'BEGIN'
A:=I;
INTOUT(0,A(3)/64);
INTOUT(0,(A(3) & $38)/8);
INTOUT(0,A(3) & $7);

INTOUT(0,A(2)/32);
INTOUT(0,(A(2) & $1C)/4);
INTOUT(0,(A(2) & $3)*2 ! A(1)/128);

INTOUT(0,(A(1) & $70)/16);
INTOUT(0,(A(1) & $E)/2);


INTOUT(0,A(0)/64 ! (A(1) & $1)*4);
INTOUT(0,(A(0) & $38)/8);
INTOUT(0,A(0) & $7);
'END';



'PROCEDURE' 'REAL' CONDEC(I);
'INTEGER' I;
'REAL' R;
'BEGIN'
R:=FLOAT(I(LOW) & $7FFF);
'IF' (I(LOW) & $8000)#0 'THEN' R:=R+3.2768E4;
R:=R+FLOAT(I(HI))*6.5536E4;
'RETURN' R;
'END';



'PROCEDURE' CONINT(R,I);
'REAL' R;
'INTEGER' I,A;
'REAL' T,TRNK;
'BEGIN'
T:=RLABS(R);
TRNK:=TRUNK(T/6.5536E4);

'IF' TRNK>3.2767E4 'THEN'
	'BEGIN'
	CURSOR(0,16);TEXT(0,"TRNK=");RLOUT(0,TRNK-3.2768E4);

	I(HI):=FIX(TRNK-3.2768E4);
	I(HI):=I(HI)!$8000;
	'END'
'ELSE' I(HI):=FIX(TRNK);

T:=T-(TRNK*6.5536E4);
I(LOW):=FIX(T);

'IF' R<0.'THEN'
	'BEGIN'
	I(LOW):='NOT' I(LOW);
	I(HI):='NOT' I(HI);
	'IF' I(LOW)=$FFFF 'THEN'
		'BEGIN'
		I(HI):=I(HI)+1;
		I(LOW):=0;
		'END'
	'ELSE' I(LOW):=I(LOW)+1;
	'END';
'END';



'PROCEDURE' HEXI32(I);
'INTEGER' I,X;
'ADDRESS' A;
'BEGIN'
A:=I;
I(LOW):=0;
I(HI):=0;
'FOR' X:=0,SPTR-1 'DO'
	'BEGIN'
	I(HI):=I(HI)*16;
	I(HI):=I(HI) ! A(1)/16;
	'IF'NSTRING(X)<^A'THEN'I(LOW):=(I(LOW)*16) ! NSTRING(X)-^0
	'ELSE'I(LOW):=(I(LOW)*16) ! NSTRING(X)-^A+10;
	'END';
'END';



'PROCEDURE' OCTI32(I);
'INTEGER' I,X;
'ADDRESS' A;
'BEGIN'
A:=I;
I(LOW):=0;
I(HI):=0;
'FOR' X:=0,SPTR-1 'DO'
	'BEGIN'
	I(HI):=I(HI)*8;
	I(HI):=I(HI) ! A(1)/32;
	I(LOW):=(I(LOW)*8) ! NSTRING(X)-^0
	'END';
'END';



'PROCEDURE' 'REAL' DECIMAL;
'REAL' R,P;
'INTEGER' X;
'BEGIN'
R:=0.;
X:=0;
'LOOP'
	'BEGIN'
	'IF' SPTR=X 'THEN' 'RETURN' R;
	'IF' NSTRING(X)=^. 'THEN' 'QUIT';
	R:=(R*10.)+FLOAT(NSTRING(X)-^0);
	X:=X+1;
	'END';
X:=X+1;
P:=10.;
'LOOP'
	'BEGIN'
	'IF' SPTR=X ! NSTRING(X)=^. 'THEN' 'QUIT';
	R:=R+FLOAT(NSTRING(X)-^0)/P;
	P:=P*10.;
	X:=X+1;
	'END';
'RETURN' R;
'END';



'PROCEDURE' ARGPOS(A);
'INTEGER' A,P;
'BEGIN'
'CASE' ARGBAS(A) 'OF'
	OCT: P:=11;
	DEC:	'BEGIN'
		SIZE(FLPAC(A));
		P:=BEFORE+AFTER;
		'IF' AFTER#0 'THEN' P:=P+1;
		'IF'  FLPAC(A)<0. 'THEN' P:=P+1;
		'END';
	HEX: P:=8
'ELSE';
'RETURN' P;
'END';



'PROCEDURE' POSITION;
'INTEGER' T;
'BEGIN'
'IF' ARG=0 'THEN' 'RETURN' 0;
T:=ARGPOS(0);
'IF' ARG=2 'THEN' T:=T+ARGPOS(1);
'RETURN' T+3;
'END';



'PROCEDURE' COMLIN(S);
'ADDRESS' S;
'BEGIN'
CLRLIN(15);
CURSOR(0,15);
TEXT(0,S);
'END';



'PROCEDURE' BASOUT;
'INTEGER' B;
'BEGIN'
'CASE' B 'OF'
	BIN: TEXT(0,"BIN");
	OCT: TEXT(0,"OCT");
	DEC: TEXT(0,"DEC");
	HEX: TEXT(0,"HEX")
'ELSE';
'END';



'PROCEDURE' DISBASE;
'BEGIN'
CURSOR(15,14);
BASOUT(MODE);
TEXT(0," ARG=");INTOUT(0,ARG);
TEXT(0," OPER=");CHOUT(0,OPER);
CURSOR(0,15);
TEXT(0,"ARGPOS(0)= ");INTOUT(0,ARGPOS(0));
TEXT(0,"  ARGPOS(1)= ");INTOUT(0,ARGPOS(1));
'END';




'PROCEDURE' MAKNUM;
'BEGIN'
'IF' SPTR=0 'THEN' 'RETURN';
'IF' ARG=0 'THEN'
	'BEGIN'
	ARGBAS(0):=MODE;
	'CASE' MODE 'OF'
		BIN: ;
		OCT: OCTI32(INTAC1);
		DEC: FLPAC(0):=DECIMAL;
		HEX: HEXI32(INTAC1)
	'ELSE';
	ARGBAS(1):=MODE;
	'END'
'ELSE'
	'BEGIN'
	'CASE' MODE 'OF'
		BIN: ;
		OCT: OCTI32(INTAC2);
		DEC: FLPAC(1):=DECIMAL;
		HEX: HEXI32(INTAC2)
	'ELSE';
	'END';
ARG:=ARG+1;
'IF' ARG>2 'THEN' ARG:=2;
SPTR:=0;
'END';



'PROCEDURE' DISPLAY;
'BEGIN'
CHOUT(0,FF);
CURSOR(0,0);TEXT(0,"BASES:");CRLF(0);
CURSOR(0,2);TEXT(0," Ten (decimal)");
CURSOR(0,3);TEXT(0," Hexadecimal");
CURSOR(0,4);TEXT(0," Octal");
CURSOR(0,5);TEXT(0," Binary");

CURSOR(15,0);TEXT(0,"ARITHMETIC OPERATIONS:");
CURSOR(15,2);TEXT(0," (+) add");
CURSOR(15,3);TEXT(0," (-) subtract");
CURSOR(15,4);TEXT(0," (*) multiply");
CURSOR(15,5);TEXT(0," (/) divide");

CURSOR(0,7);TEXT(0,"LOGICAL OPERATIONS:");
 CURSOR(0,9);TEXT(0," (&) and          Invert        Shift");
CURSOR(0,10);TEXT(0," (!) or           Negate");
CURSOR(0,11);TEXT(0," (^^) xor          Xtend");

CURSOR(0,12);
TEXT(0,"========================================");

CURSOR(0,14);TEXT(0," CURRENT BASE:");
'END';



'PROCEDURE' DISNUM(ARG);
'INTEGER' ARG;
'BEGIN'
'CASE' ARGBAS(ARG) 'OF'
	BIN: ;
	OCT: OCTO32(INTAC1+(ARG*4));
	DEC:	'BEGIN'
		SIZE(FLPAC(ARG));
		FORMAT(BEFORE,AFTER);
		RLOUT(0,FLPAC(ARG));
		'END';
	HEX: HEXO32(INTAC1+(ARG*4))
'ELSE';
'END';



'PROCEDURE' UPDATE;
'BEGIN'
DISBASE;

CLRLIN(MAINLINE);
CLRLIN(BASLIN);

\FIRST BASE INDICATOR
CURSOR(OFF+ARGPOS(0)/2-1,BASLIN);
BASOUT(ARGBAS(0));

'IF' ARG=0 'THEN' 'RETURN';

\SECOND BASE INDICATOR
'IF' OPER#BLANK 'THEN'
	'BEGIN'
	CURSOR(OFF+ARGPOS(0)+3+ARGPOS(1)/2-1,BASLIN);
	BASOUT(ARGBAS(1));
	'END';

\FIRST ARGUMENT
CURSOR(OFF,MAINLINE);
DISNUM(0);

\OPERATOR
CURSOR(OFF+ARGPOS(0)+1,MAINLINE);
CHOUT(0,OPER);

\SECOND ARGUEMNT
'IF' ARG=2 'THEN'
	'BEGIN'
	CURSOR(OFF+ARGPOS+3,MAINLINE);
	DISNUM(1);
	'END';
'END';



'PROCEDURE' CONA1;
'BEGIN'
 'IF' MODE=DEC & ARGBAS(0)#DEC 'THEN'
	FLPAC(0):=CONDEC(INTAC1);
'IF' MODE#DEC & ARGBAS(0)=DEC 'THEN'
	CONINT(FLPAC(0),INTAC1);
ARGBAS(0):=MODE;
'END';



'PROCEDURE' CONA2;
'BEGIN'
'IF' MODE=DEC & ARGBAS(1)#DEC 'THEN'
	FLPAC(1):=CONDEC(INTAC2);
'IF' MODE#DEC & ARGBAS(1)=DEC 'THEN'
	CONINT(FLPAC(1),INTAC2);
ARGBAS(1):=MODE;
'END';



'PROCEDURE' CONVERT;
'BEGIN'
'CASE' ARG 'OF'
	0: [ARGBAS(0):=MODE;'RETURN';];
	1: 'IF' OPER=BLANK 'THEN' CONA1
		'ELSE' ARGBAS(1):=MODE;
	2: CONA2
'ELSE';
'END';



'PROCEDURE' ACLEAR;
'BEGIN'
'IF' SPTR#0 'THEN' SPTR:=0
'ELSE' 'CASE' ARG 'OF'
	1: 'IF' OPER#BLANK 'THEN' OPER:=BLANK
	'ELSE' 'BEGIN'
		ARG:=0;
		INTAC1(LOW):=0;
		INTAC1(HI):=0;
		FLPAC(0):=0.;
		MODE:=ARGBAS(0);
		'END';
	2: 	'BEGIN'
		ARG:=1;
		INTAC2(LOW):=0;
		INTAC2(HI):=0;
		FLPAC(1):=0.;
		'END'
'ELSE';
'END';



'PROCEDURE' LOGICAL;
'BEGIN'
'IF' ARGBAS(0)=DEC 'THEN' CONINT(FLPAC(0),INTAC1);
'IF' ARGBAS(1)=DEC 'THEN' CONINT(FLPAC(1),INTAC2);
'END';



'PROCEDURE' MATH;
'BEGIN'
'IF' ARGBAS(0)#DEC 'THEN' FLPAC(0):=CONDEC(INTAC1);
'IF' ARGBAS(1)#DEC 'THEN' FLPAC(1):=CONDEC(INTAC2);
'END';



'PROCEDURE' AND;
'BEGIN'
'IF' ARG#2 'THEN' 'RETURN';
LOGICAL;
INTAC1(LOW):=INTAC1(LOW)&INTAC2(LOW);
INTAC1(HI):=INTAC1(HI)&INTAC2(HI);
FLPAC(0):=CONDEC(INTAC1);
ACLEAR;
'END';



'PROCEDURE' OR;
'BEGIN'
'IF' ARG#2 'THEN' 'RETURN';
LOGICAL;
INTAC1(LOW):=INTAC1(LOW)!INTAC2(LOW);
INTAC1(HI):=INTAC1(HI)!INTAC2(HI);
FLPAC(0):=CONDEC(INTAC1);
ACLEAR;
'END';



'PROCEDURE' EXOR32;
'BEGIN'
'IF' ARG#2 'THEN' 'RETURN';
LOGICAL;
INTAC1(LOW):=EXOR(INTAC1(LOW),INTAC2(LOW));
INTAC1(HI):=EXOR(INTAC1(HI),INTAC2(HI));
FLPAC(0):=CONDEC(INTAC1);
ACLEAR;
'END';



'PROCEDURE' NOT;
'BEGIN'
'IF' ARG=0 'THEN' 'RETURN';
'IF' ARG=1 'THEN'
	'BEGIN'
	'IF' ARGBAS(0)=DEC 'THEN' CONINT(FLPAC(0),INTAC1);
	INTAC1(LOW):='NOT' INTAC1(LOW);
	INTAC1(HI):='NOT' INTAC1(HI);
	FLPAC(0):=CONDEC(INTAC1);
	'END'
'ELSE'
	'BEGIN'
	'IF' ARGBAS(1)=DEC 'THEN' CONINT(FLPAC(1),INTAC2);
	INTAC2(LOW):='NOT' INTAC2(LOW);
	INTAC2(HI):='NOT' INTAC2(HI);
	FLPAC(1):=CONDEC(INTAC2);
	'END';
'END';



'PROCEDURE' XTEND;
'BEGIN'
'IF' ARG=0 'THEN' 'RETURN';
'IF' ARG=1 'THEN'
	'BEGIN'
	'IF' ARGBAS(0)=DEC 'THEN' CONINT(FLPAC(0),INTAC1);
	'IF' (INTAC1(LOW)&$8000)#0 'THEN' INTAC1(HI):=$FFFF
	'ELSE' INTAC1(HI):=0;
	FLPAC(0):=CONDEC(INTAC1);
	'END'
'ELSE'
	'BEGIN'
	'IF' ARGBAS(1)=DEC 'THEN' CONINT(FLPAC(1),INTAC2);
	'IF' (INTAC2(LOW)&$8000)#0 'THEN' INTAC2(HI):=$FFFF
	'ELSE' INTAC2(HI):=0;
	FLPAC(1):=CONDEC(INTAC2);
	'END';
'END';



'PROCEDURE' TWOAR1;
'BEGIN'
'IF' ARGBAS(0)=DEC 'THEN' FLPAC(0):=FLPAC(0)*-1.
'ELSE'
	'BEGIN'
	INTAC1(LOW):='NOT' INTAC1(LOW);
	INTAC1(HI):='NOT' INTAC1(HI);
	'IF' INTAC1(LOW)=$FFFF 'THEN'
		'BEGIN'
		INTAC1(HI):=INTAC1(HI)+1;
		INTAC1(LOW):=0;
		'END'
	'ELSE' INTAC1(LOW):=INTAC1(LOW)+1;
	FLPAC(0):=CONDEC(INTAC1);
	'END';
'END';



'PROCEDURE' TWOAR2;
'BEGIN'
'IF' ARGBAS(1)=DEC 'THEN' FLPAC(1):=FLPAC(1)*-1.
'ELSE'	'BEGIN'
	INTAC2(LOW):='NOT' INTAC2(LOW);
	INTAC2(HI):='NOT' INTAC2(HI);
	'IF' INTAC2(LOW)=$FFFF 'THEN'
		'BEGIN'
		INTAC2(HI):=INTAC2(HI)+1;
		INTAC2(LOW):=0;
		'END'
	'ELSE' INTAC2(LOW):=INTAC2(LOW)+1;
	FLPAC(1):=CONDEC(INTAC2);
	'END';
'END';



'PROCEDURE' TWOCOMP;
'BEGIN'
'IF' ARG=0 'THEN' 'RETURN';
'IF' ARG=1 'THEN' TWOAR1
'ELSE' TWOAR2;
'END';



'PROCEDURE' RIGHT16(I);
'INTEGER' I;
'BEGIN'
'IF' I<0 'THEN' 'RETURN' ((I&$7FFF)/2)!$4000
'ELSE' 'RETURN' I/2;
'END';



'PROCEDURE' DIRECT(I,N);
'INTEGER' I,N,X;
'BEGIN'
'IF' N<0 'THEN'
	'BEGIN'
	'FOR' X:=1,ABS(N) 'DO'
		'BEGIN'
		I(LOW):=RIGHT16(I(LOW));
		'IF' (I(HI)&1)#0 'THEN' I(LOW):=$8000!I(LOW);
		I(HI):=RIGHT16(I(HI));
		'END';
	'END'
'ELSE'
	'BEGIN'
	'FOR' X:=1,ABS(N) 'DO'
		'BEGIN'
		I(HI):=I(HI)*2;
		'IF' (I(LOW)&$8000)#0 'THEN' I(HI):=I(HI)!1;
		I(LOW):=I(LOW)*2;
		'END';
	'END';
'END';



'PROCEDURE' GETSHIFT;
'INTEGER' PTR,SIGN,X,T;
'ADDRESS' STRING;
'BEGIN'
STRING:=RESERVE(3);
COMLIN("ENTER NUMBER OF PLACES TO SHIFT");
CURSOR(0,INLINE);
PTR:=0;
T:=0;
SIGN:=1;
'LOOP'
	'BEGIN'
	CHAR:=CHIN(1);
	'IF' (NUMERIC ! CHAR=^-) & PTR#3 'THEN'
		'BEGIN'
		CURSOR(PTR,INLINE);
		CHOUT(0,CHAR);
		STRING(PTR):=CHAR;
		PTR:=PTR+1;
		'END'
	'ELSE'
	'IF' CHAR=DEL & PTR#0 'THEN'
		'BEGIN'
		PTR:=PTR-1;
		CURSOR(PTR,INLINE);
		CHOUT(0,^ );
		CURSOR(PTR,INLINE);
		'END'
	'ELSE' 'IF' CHAR=CR 'THEN' 'QUIT';
	'END';
'FOR' X:=0,PTR-1 'DO'
	'BEGIN'
	'IF' STRING(X)=^- 'THEN' SIGN:=-1
	'ELSE' T:=(T*10)+STRING(X)-^0;
	'END';
'RETURN' T*SIGN;
'END';



'PROCEDURE' SHIFT;
'INTEGER' N;
'BEGIN'
'IF' ARG=0 'THEN' 'RETURN';
N:=GETSHIFT;
'IF' ARG=1 'THEN'
	'BEGIN'
	'IF' ARGBAS(0)=DEC 'THEN' CONINT(FLPAC(0),INTAC1);
	DIRECT(INTAC1,N);
	FLPAC(0):=CONDEC(INTAC1);
	'END'
'ELSE'
	'BEGIN'
	'IF' ARGBAS(1)=DEC 'THEN' CONINT(FLPAC(1),INTAC2);
	DIRECT(INTAC2,N);
	FLPAC(1):=CONDEC(INTAC2);
	'END';
'END';



'PROCEDURE' PLUS;
'BEGIN'
MATH;
FLPAC(0):=FLPAC(0)+FLPAC(1);
CONINT(FLPAC(0),INTAC1);
ACLEAR;
'END';



'PROCEDURE' MINUS;
'BEGIN'
MATH;
FLPAC(0):=FLPAC(0)-FLPAC(1);
CONINT(FLPAC(0),INTAC1);
ACLEAR;
'END';



'PROCEDURE' MULT;
'BEGIN'
MATH;
FLPAC(0):=FLPAC(0)*FLPAC(1);
CONINT(FLPAC(0),INTAC1);
ACLEAR;
'END';



'PROCEDURE' DIVIDE;
'BEGIN'
MATH;
FLPAC(0):=FLPAC(0)/FLPAC(1);
CONINT(FLPAC(0),INTAC1);
ACLEAR;
'END';



'PROCEDURE' EXECUTE;
'BEGIN'
'IF' ARG=2 'THEN'
	'BEGIN'
	'CASE' OPER 'OF'
	^&: AND;
	^^: EXOR32;
	^!: OR;

	^+: PLUS;
	^-: MINUS;
	^*: MULT;
	^/: DIVIDE
	'ELSE';
	'END';
'END';



'PROCEDURE' STORE;
'BEGIN'
'IF' (ARG=1) & (OPER=BLANK) 'THEN'
	'BEGIN'
	MODE:=ARGBAS(0);
	ARG:=0;
	CLRLIN(MAINLINE);
	CURSOR(OFF,MAINLINE);
	'END';
'IF' ARG=2 'THEN'
	'BEGIN'
	ARG:=1;
	CURSOR(OFF+ARGPOS(0)+3,MAINLINE);
	TEXT(0,"           ");
	CURSOR(OFF+ARGPOS(0)+3,MAINLINE);
	'END';
'IF' SPTR<MODLEN 'THEN'
	'BEGIN'
	NSTRING(SPTR):=CHAR;
	SPTR:=SPTR+1;
	CHOUT(0,CHAR);
	'END';
'END';



'PROCEDURE' DELETE;
'BEGIN'
'IF' SPTR#0 'THEN'
	'BEGIN'
	SPTR:=SPTR-1;
	CURSOR(OFF+SPTR+POSITION,MAINLINE);
	CHOUT(0,^ );
	'END';
'END';



'PROCEDURE' DOUBLE;
'BEGIN'
MAKNUM;
OPER:=CHAR;
ARGBAS(1):=MODE;
EXECUTE;
UPDATE;
'END';



'PROCEDURE' CYCLE;
'BEGIN'
SPTR:=0;
'LOOP'
	'BEGIN'
	CURSOR(OFF+SPTR+POSITION,MAINLINE);
	CHAR:=CHIN(1);
	'CASE' 'OF'
	ISNUM:    STORE;
	CHAR=DEL: DELETE
	'ELSE' 
		'BEGIN'
		'CASE' CHAR 'OF'
		\SINGLE ARGUMENT
		^B: ;
		^O: [MAKNUM;MODE:=OCT;MODLEN:=11;CONVERT;UPDATE;];
		^T: [MAKNUM;MODE:=DEC;MODLEN:=12;CONVERT;UPDATE;];
		^H: [MAKNUM;MODE:=HEX;MODLEN:=8;CONVERT;UPDATE;];

		^I: [MAKNUM;NOT;UPDATE;];
		^S: [MAKNUM;SHIFT;UPDATE;];
		^N: [MAKNUM;TWOCOMP;UPDATE;];
		^Z: [ACLEAR;UPDATE;];
		^X: [MAKNUM;XTEND;UPDATE;];

		\DOUBLE ARGUMENT
		^&: DOUBLE;
		^^: DOUBLE;
		^!: DOUBLE;

		^+: DOUBLE;
		^-: DOUBLE;
		^*: DOUBLE;
		^/: DOUBLE;

		CR: [MAKNUM;EXECUTE;UPDATE;]
		'ELSE';
		'END';
	'END';
'END';



'BEGIN'	\MAIN
INTAC1:=RESERVE(8);
INTAC2:=INTAC1+4;

FLPAC:=RLRES(2);
NSTRING:=RESERVE(20);
ARGBAS:=RESERVE(4);

FLPAC(0):=0.;
FLPAC(1):=0.;
INTAC1(LOW):=0;
INTAC1(HI):=0;
INTAC2(LOW):=0;
INTAC2(HI):=0;

MODE:=DEC;
MODLEN:=12;
ARGBAS(0):=MODE;
ARGBAS(1):=MODE;
ARG:=0;
OPER:=BLANK;

DISPLAY;
DISBASE;
UPDATE;
CYCLE;
'END';
