\CELLS.XPL	9/1/84

'CODE'	\COMPLETE SET, STANDARD XPL V5.6 INTRINSICS
ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
SCAN=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	OPENF=29,	WRITE=30,	READ=31,
TESTPT=32,	SETTXT=33,	SETHI=34,	SETMIX=35,
SETLO=36,	BUTTON=37,	PADDLE=38,	SOUND=39,
CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
SCREEN=44,	BLOCK=45,	FIX=50;
'CODE''REAL'	RLRES=46,	RLIN=47,	RLOUT=48,
FLOAT=49,	RLABS=51,	FORMAT=52,	SQRT=53,
LN=54,		EXP=55,		SIN=56,		ATAN2=57,
MOD=58,		LOG=59,		COS=60,		TAN=61,
ASIN=62,	ACOS=63;


'DEF' MAX=280,LASTGEN=191;

'INT' SR, JR;

'INT'	GEN, STATES, DUMMY;

'INT'\ARRAY\ CELLS, RULE, MAP;

'PROC' SETRULES;
'INT' TEMP, I;

'BEGIN'
TEXT(0,"HOW MANY STATES PER CELL? ");
STATES:= INTIN(0);
TEXT(0,"SUM TABLE HAS ");
INTOUT(0,(STATES -1) *3 +1);
TEXT(0," ENTRIES."); CRLF(0);
'FOR' I:= 0,(STATES -1)*3 'DO'
    ['REPEAT'
    TEXT(0,"NEXT STATE FOR SUM= "); INTOUT(0,I); TEXT(0," ");
    TEMP:= INTIN(0);
    'UNTIL' TEMP <=(STATES -1);
    RULE(I):= TEMP;
    ];
\FILL UP MAP TABLE
TEXT(0,"MAP STATES TO COLOR. "); CRLF(0);
'FOR' I:= 0,(STATES -1) 'DO'
    [TEXT(0,"PICK CELL COLOR FOR STATE "); INTOUT(0,I);
    TEXT(0,": ");
    'CASE' INTIN(0) 'OF'
	0:MAP(I):= 0;
	1:MAP(I):= 128;
	3:MAP(I):= 64
	'ELSE';

    ];
'END';


'PROC' ENTER;
'INT' I, N;

['FOR' I:= 0,MAX *2 'DO'
    CELLS(I):= 0;
TEXT(0,"RANDOM IN PLACE OF POINTS? ");
'IF' CHIN(0) = ^Y 'THEN'
    ['FOR' I:= 0,MAX/10 'DO'
	CELLS(SR +RAN(MAX *2)):= RAN(STATES);
    ]
    'ELSE' 
    [TEXT(0,"INITIAL VALUE(S). (- VALUE TO QUIT.): ");
    N:=0;
    'REPEAT'
    CELLS(MAX +SR +(2 *N)):= INTIN(0);
    N:= N +1;
    'UNTIL' CELLS(MAX +SR +(2 *(N -1))) <0;
    ];
];


'PROC' NEXTGEN;
'INT' LEFT, RIGHT, CELL;

\MAGIC!!!
'FOR' CELL:=0, (MAX-1)*2 'DO'
    [LEFT:= CELL -2;
    'IF' LEFT <0 'THEN' LEFT :=(MAX -1) *2;
    RIGHT:= CELL +2;
    'IF' RIGHT >(MAX -1) *2 'THEN' RIGHT :=0;;
    CELLS(CELL +JR):= RULE(CELLS(SR +LEFT) +CELLS(SR +CELL) +CELLS(SR +RIGHT));
    CELL:= CELL +1;
    ];


'PROC' OUTPUT;
'INT' CELL;
'FOR' CELL:= 0,(MAX-1) 'DO'
    POINT(CELL,GEN, MAP(CELLS(SR +CELL*2)));


\MAIN
'BEGIN'
CELLS:= RESERVE(4*MAX);
RULE:= RESERVE (50);
MAP:= RESERVE (40);
'LOOP BEGIN'
    SR:= 1; JR:= 0;
    SETRULES;
    ENTER;
    GEN:=0;
    SETHI; CLEAR;
    'WHILE' GEN <LASTGEN
	'DO'
	'BEGIN'
	OUTPUT;
	NEXTGEN;
	'IF' SR= 1 'THEN' SR:=0 'ELSE' SR:=1;
	'IF' JR= 1 'THEN' JR:=0 'ELSE' JR:=1;
	GEN:= GEN +1;
	'END';
    DUMMY:= CHIN(1);
    SETTXT;
    'END';
'END';
