\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
ATTRIB=69,	SETWIND=70,	RAWTEXT=71,	HILIGHT=72;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,       MOD=58,         LOG=59,         COS=60,
TAN=61,         ASIN=62,        ACOS=63;

real UMAIN,X,STEP,YMUL,PERIOD,LEAN,      \STEP=ICREMENT TO COUNT BY FOR UMAIN
FIRST,LAST,TOP,BOTTOM;
int I,XOS,AWAY,DRAW,CH,DRAWX,DRAWY,RET,REDRAW,ZMBX,ZMBY,ZMEX,ZMEY,XPOS,YPOS,
CPUREG,PCOUNT,CHAOS,PER,HASCHAOS;
\LEANEANCY
\DRAWX/Y: X/Y COORDINATES FOR AN ON-SCREAN PLOT
\XOS= X OffSet, AWAY=HOW MANY ITTERATIONS TO "THROUGH AWAY"
\DRAW=# OF ITTERATIONS TO DRAW.
\PERIOD is a real array that tracks the perios numercally
\PCOUNT is an integer that counts the periods
real SSX,SSY;
\SSX/SSY:       Screan Size X/Y
int MOUSEX,MOUSEY,TEMP,LFTFST,RGTFST,BBX,BBY,LMX,LMY;
int MBLEFT,MBRIGHT,MBMIDDLE;

def
HOME=71,
UPA=72,
PGUP=73,
LEFTA=75,
RIGHTA=77,
END=78,
DOWNA=80,
PGDN=81;

proc PAUSE(PY);
int PY;
begin
CURSOR(0,PY);TEXT(0,"-pause-");
OPENI(1);
loop if CHKKEY then quit;
CURSOR(0,PY);TEXT(0,"       ");
CH:=CHIN(1);
end;

proc MC(ON);
int ON;
begin
if ON then TEMP:=1 else TEMP:=2;
CPUREG(0):=TEMP;          \TURN ON/OFF MOUSE CURSOR;
SOFTINT($33);
end;

proc GETMINFO;
begin
CPUREG(0):=$3;
SOFTINT($33);
MOUSEX:=CPUREG(2);
MOUSEY:=CPUREG(3);
TEMP:=CPUREG(1);
case TEMP of
0:      [MBLEFT:=false;MBRIGHT:=false];
1:      [MBLEFT:=true;MBRIGHT:=false];
2:      [MBLEFT:=false;MBRIGHT:=true];
3:      [MBLEFT:=true;MBRIGHT:=true]
        else;
\CURSOR(0,0);
\INTOUT(0,CPUREG(1));
end;

proc INVPNT(INVX,INVY);
int INVX,INVY;
begin
\RETCLR:=READPIX(XPOS,YPOS);
POINT(INVX,INVY,15-READPIX(INVX,INVY));
end;

proc INVLNE(IX,BY,EY);
int IX,BY,EY;
begin
MC(false);
if BY>EY then [TEMP:=EY;EY:=BY;BY:=TEMP];
for TEMP:=BY,EY do INVPNT(IX,TEMP);
MC(true);
end;

proc INVBOX(BX,BY,EX,EY);
int BX,BY,EX,EY;
begin
MC(false);
if BX>EX then [TEMP:=EX;EX:=BX;BX:=TEMP];
if BY>EY then [TEMP:=EY;EY:=BY;BY:=TEMP];
for TEMP:=BX,EX do [INVPNT(TEMP,BY);INVPNT(TEMP,EY)];
for TEMP:=BY,EY do [INVPNT(BX,TEMP);INVPNT(EX,TEMP)];
MC(true);
end;

proc WORKSPACE(WSBX,WSBY,WSEX,WSEY);
int WSBX,WSBY,WSEX,WSEY;
real NF,NL,NT,NB;       \NEW(FIRST,LAST,TOP,BOTTOM)
begin
WSEY:=(FIX(SSY)-1)-WSEY;
WSBY:=(FIX(SSY)-1)-WSBY;
if REDRAW then
        begin
        NF:=((LAST-FIRST)/SSX)*FLOAT(WSBX)+FIRST;
        NL:=((LAST-FIRST)/SSX)*FLOAT(WSEX)+FIRST;
        if NL>NF then [LAST:=NL;FIRST:=NF] else [LAST:=NF;FIRST:=NL];
        STEP:=((LAST-FIRST)/(SSX-1.0));
        NT:=((TOP-BOTTOM)/SSY)*FLOAT(WSBY)+BOTTOM;
        NB:=((TOP-BOTTOM)/SSY)*FLOAT(WSEY)+BOTTOM;
        if NT>NB then [TOP:=NT;BOTTOM:=NB] else [TOP:=NB;BOTTOM:=NT];
        YMUL:=1.0/(TOP-BOTTOM);
\        return(false);
        end
else [REDRAW:=true\;return(true)\];
end;

proc SELECT;
def MINX=2,MINY=2;
begin
GETMINFO;
\LFTFST:=false;
BBX:=MOUSEX;
BBY:=MOUSEY;
LMX:=MOUSEX;
LMY:=MOUSEY;
INVPNT(BBX,BBY);
loop
        begin
        GETMINFO;
        if LMX#MOUSEX ! LMY#MOUSEY then
                begin               \if the coordinates have changes, redraw...
                INVBOX(BBX,BBY,LMX,LMY);
                INVBOX(BBX,BBY,MOUSEX,MOUSEY);
                LMX:=MOUSEX;
                LMY:=MOUSEY;
                end;
        [CURSOR(0,4);TEXT(0,"X: ");RLOUT(0,((LAST-FIRST)/SSX)*FLOAT(MOUSEX)+FIRST)];
        [CURSOR(0,5);TEXT(0,"Y: ");RLOUT(0,((TOP-BOTTOM)/SSY)*(SSY-1.0-FLOAT(MOUSEY))+BOTTOM)];
        if MBLEFT=false then [INVBOX(BBX,BBY,LMX,LMY);REDRAW:=true;quit];
        end;
if ABS(BBX-MOUSEX)>MINX & ABS(BBY-MOUSEY)>MINY then WORKSPACE(BBX,BBY,MOUSEX,MOUSEY) else REDRAW:=false;
end;

proc SETVGA;
begin
SSX:=640.0;
SSY:=480.0;
SETVID(18);
CPUREG(0):=$1;          \TURN ON MOUSE CURSOR;
SOFTINT($33);
CPUREG(0):=$7;     CPUREG(2):=0;      CPUREG(3):=FIX(SSX)-1;   SOFTINT($33);
CPUREG(0):=$8;     CPUREG(2):=0;      CPUREG(3):=FIX(SSY)-1;   SOFTINT($33);
\Set Max/Min positions for Horizontal and Vertical
end;

proc APOINT(APX,APY);
int APX,APY,APC;
begin
APC:=READPIX(APX,APY);
if APC<15 then APC:=APC+1;
POINT(APX,APY,APC);
end;

\proc RECTANGLE(BX,BY,EX,EY,CLR);
\int BX,BY,EX,EY,CLR;
\begin
\POINT(BX,BY,CLR);
\LINE(EX,BY,CLR);
\LINE(EX,EY,CLR);
\LINE(BX,EY,CLR);
\LINE(BX,BY,CLR);
\end;

proc CALC1;
begin
X:=UMAIN*X*(1.0-X);
end;

proc FRNG;              \FINDWS THE LARGEST RANGE FOR Y AND SETS THE Y
real YLOW,YHIGH;        \MULTIPLYER TO A VALUE WHERE, WHEN MULTIPLEID BY
                        \ANY NUMBER IN THAT RANGE, WILL BE OF THE INTERVAL:
                        \[0,1]
begin
UMAIN:=LAST;
X:=0.2;
for I:=0,AWAY do CALC1;
YLOW:=X;
YHIGH:=X;
for I:=0,AWAY do
        begin
        CALC1;
        if X<YLOW then YLOW:=X;
        if X>YHIGH then YHIGH:=X;
        end;
TOP:=YHIGH;BOTTOM:=YLOW;
YMUL:=1.0/(TOP-BOTTOM);
end;

proc ACCURACY;
begin
SETVGA;
CURSOR(0,0);
TEXT(0,"Bifurcation diagram of the logistic map. v1.0");CRLF(0);
TEXT(0,"Number of itterations to through away (speed vs. acuracy).");CRLF(0);
TEXT(0,"An additional 10% of those itterations will be drawn.");CRLF(0);
TEXT(0,"0-32000 ( > #'s for acuracy, < #'s for speed. Sugested 100): ");
AWAY:=INTIN(0);CRLF(0);DRAW:=AWAY/10;
\INTOUT(0,AWAY);TEXT(0," ITTERATIONS WILL BE THROUGHEN AWAY. ");
\INTOUT(0,DRAW);TEXT(0," ITTERATIONS WILL BE DRAWEN ON SCREAN.");CRLF(0);
\PAUSE(5);
REDRAW:=true;
end;

proc QUESTIONS;
begin
ACCURACY;
FIRST:=2.9;
LAST:=3.9;
STEP:=((LAST-FIRST)/(SSX-1.0));
FRNG;
end;

proc GETPERIOD;
begin
PCOUNT:=0;
CHAOS:=true;
X:=0.2;
I:=0;
loop
        begin
        GETMINFO;
        if LMX#MOUSEX ! LMY#MOUSEY then [CHAOS:=false;quit];
        CALC1;
        if I>=AWAY then quit;
        I:=I+1;
        end;                      \through away 'AWAY' itterations
I:=0;
loop                \scan 'DRAW' itterations for a period cycle
        begin
        CALC1;
        PERIOD(PCOUNT):=X;
        GETMINFO;
        if LMX#MOUSEX ! LMY#MOUSEY then [CHAOS:=false;quit];
        if PCOUNT>0 & (X-LEAN)<PERIOD(0) & (X+LEAN)>PERIOD(0) then
                begin
                if CHAOS=true then [CURSOR(0,7);TEXT(0,"      ")];
                CURSOR(8,6);INTOUT(0,PCOUNT);TEXT(0," ");
                CHAOS:=false;
\                if PCOUNT#PER then [POINT(DRAWX,0,COLOR);LINE(DRAWX,FIX(SSY)-1,COLOR);LEAN:=LEAN/2.0];
                PER:=PCOUNT;
                PCOUNT:=-1;
                end;
        PCOUNT:=PCOUNT+1;
        if PCOUNT>=64 then [CURSOR(0,7);TEXT(0,"CHAOS!");PCOUNT:=0];
        if I>=DRAW then quit;
        I:=I+1;
        end;
if CHAOS then [CURSOR(0,7);TEXT(0,"Chaos!");HASCHAOS:=true];
end;

proc MAINCALC;
int COLOR;

        proc KEY1;
        begin
        CH:=CHIN(1);
        case CH of
                ^Q:     exit;
                ^q:     exit;
\                0:      [CH:=CHIN(1);if CH=71 ! 72 ! 73 ! 75 ! 77 ! 78 ! 79 then
\                                [TEMP:=ZOOM;return(true)]];
                $1B:    return(true)
                else [PAUSE(1);return(false)];
                \true=QUIT LOOP!
        end;

begin
X:=0.2;
UMAIN:=FIRST;
MC(false);
CURSOR(0,6);
TEXT(0,"Period: ");
LEAN:=.002;
HASCHAOS:=false;
COLOR:=14;
PER:=1;
RET:=false;
loop
        begin
        GETMINFO;
        if MBRIGHT ! MBLEFT then quit;
        DRAWX:=FIX(((UMAIN-FIRST)/(LAST-FIRST))*SSX);
        X:=0.2;
        for I:=1,AWAY do CALC1;         \through away 'AWAY' itterations
        PCOUNT:=0;
        CHAOS:=true;
        I:=0;
        loop                            \draw 'DRAW' itterations
                begin
                CALC1;
                PERIOD(PCOUNT):=X;

                if PCOUNT>0 & (X-LEAN)<PERIOD(0) & (X+LEAN)>PERIOD(0) then
                        begin
                        if CHAOS=true then [CURSOR(0,7);TEXT(0,"      ")];
                        CURSOR(8,6);INTOUT(0,PCOUNT);TEXT(0," ");
                        CHAOS:=false;
                        if PCOUNT#PER then [POINT(DRAWX,0,COLOR);LINE(DRAWX,FIX(SSY)-1,COLOR);LEAN:=LEAN*.75;if PCOUNT>PER then RET:=true];
                        PER:=PCOUNT;
                        PCOUNT:=-1;
                        end;
                PCOUNT:=PCOUNT+1;
                if PCOUNT>=64 then [CURSOR(0,7);TEXT(0,"CHAOS!");PCOUNT:=0];
                if I>=DRAW then [if RET then [\AWAY:=AWAY*2;DRAW:=DRAW*2;\RET:=false;quit] else quit];
                if X>=BOTTOM & X<=TOP then
                DRAWY:=FIX( (SSY-1.0) - ((X-BOTTOM)*YMUL) *(SSY) );
                if DRAWX>=0 & DRAWX<FIX(SSX) & DRAWY>=0 & DRAWY<FIX(SSY) then
                        APOINT(DRAWX,DRAWY,15);
                if CHKKEY then if KEY1 then [RET:=true;quit];
                I:=I+1;
                end;
        if RET then quit;
        if CHAOS then [CURSOR(0,7);TEXT(0,"Chaos!");HASCHAOS:=true;COLOR:=12];
        UMAIN:=UMAIN+STEP;
        if UMAIN>=LAST then quit
        end;
MC(true);
end;

proc KEY2;
begin
loop [GETMINFO;if MBLEFT=false then quit];
CH:=CHIN(1);
if MBLEFT then SELECT;
case CH of
\        0:      [CH:=CHIN(1);if CH=71 ! 72 ! 73 ! 75 ! 77 ! 78 ! 79 then [if ZOOM then return(true) else return(false)]];
        ^Q:     exit;
        ^q:     exit;
        $1B:    exit
        else RET:=true;
        \true=QUIT LOOP!
end;

begin
PERIOD:=RLRES(1024);
CPUREG:=GETREG;
FORMAT(1,10);
CRLF(0);
RET:=0;
\SETVGA;
LFTFST:=true;
loop
        begin
        QUESTIONS;
        REDRAW:=false;
        loop
                begin
                SETVGA;
FORMAT(15,0);CURSOR(0,2);RLOUT(0,-1.0/((TOP-BOTTOM)*(FIRST-LAST)));TEXT(0,"x ZOOM");FORMAT(1,10);
                REDRAW:=false;
                CURSOR(0,0);
                TEXT(0,"Q quits, ESC stops, P pauses.");
                MAINCALC;               \Main Calculation/plotting
                if MBLEFT then loop [GETMINFO;if MBLEFT then else quit];
                if REDRAW then REDRAW:=false else
                        begin
                        OPENI(0);
                       CURSOR(0,0);
                        TEXT(0,"Q & ESC quit, any other key to restart.");CRLF(0);
                        TEXT(0,"Stopped.");
                        RET:=false;
                        loop
                                begin
                                GETMINFO;
                                LMX:=MOUSEX;
                                LMY:=MOUSEY;
                                UMAIN:=((LAST-FIRST)/SSX)*FLOAT(MOUSEX)+FIRST;
                                GETPERIOD;
                                if MBLEFT then SELECT;
                                if MBRIGHT then ACCURACY;
[CURSOR(0,3);TEXT(0,"X: ");RLOUT(0,((LAST-FIRST)/SSX)*FLOAT(MOUSEX)+FIRST)];
[CURSOR(0,4);TEXT(0,"Y: ");RLOUT(0,((TOP-BOTTOM)/SSY)*(SSY-1.0-FLOAT(MOUSEY))+BOTTOM)];
                                if CHKKEY then KEY2;
\                                if RET then quit;
                                if RET then [CURSOR(0,0);QUESTIONS;RET:=false\\;quit];
                                if REDRAW then quit;
                                end;
                        end;
                end;
        end;
end;
