
include \CXPL\CODESI.XPL;

\MS-DOS I-O STUFF

integer
	SYSINF,		\REGISTER SET FOR DOS CALLS
	INHAND,		\INPUT HANDLE
	OUTHAND;	\OUTPUT HANDLE

define WHITE=1,NPOINTS=512;
define DISK=3,EOF=$1A;
define WIDTH=640;

real SINTAB,X,Y,MAGNITUDE,PHASE;

integer I,CH;


proc LIST;
integer I;
begin
for I:=0,NPOINTS-1 do
	begin
	RLOUT(0,X(I));CHOUT(0,^,);
	RLOUT(0,Y(I));CRLF(0)
	end;
end;


proc PLOT(PNTS,N,S);
real PNTS;
int N,S,I;
real MAX;
begin
MAX:=0.0;
for I:=0,N-1 do if MAX<RLABS(PNTS(I)) then MAX:=RLABS(PNTS(I));

if MAX=0.0 then MAX:=1.0E-300;

SETVID(6);CLEAR;
MOVE(0,96);
for I:=0,N-1 do LINE(I*(WIDTH/N),96-FIX(PNTS(I)*90.0/MAX+0.5),WHITE);
CURSOR(0,24);
TEXT(0,S);TEXT(0,"  (MAG IS ");RLOUT(0,MAX);TEXT(0,")");
CH:=CHIN(1);
SETVID(3);
end;




procedure CORR(REAL);
\CALCULATE CORRELATION TRANSFORM
real REAL,SUM;
int I,J;
begin
for I:=0,NPOINTS-1 do
	begin
	SUM:=0.0;
	for J:=0,NPOINTS-1 do SUM:=REAL(J)*REAL(REM((J+I)/NPOINTS))+SUM;
	MAGNITUDE(I):=SUM/(FLOAT(NPOINTS)*16384.0);
	INTOUT(0,I);RLOUT(0,MAGNITUDE(I));CRLF(0);
	end;
end;




procedure IBMOPEN;
integer PSEG,CSEG;
addres TAIL,TLEN;


	procedure PARSE;
	\PARSE COMMAND TAIL AND SET I/O HANDLES
	address EXT1,EXT2;
	integer P,EFLG,I;
	begin
	EXT1:=".XPL";EXT2:=".CAS";

	P:=0;
	EFLG:=false;
	\PARSE COMMAND TAIL FOR EXTENTION

	loop
		begin
		if TAIL(P)=^. then
			begin
			EFLG:=true;
			quit;
			end;
		P:=P+1;
		if P>=TLEN(0) then
			begin
			EFLG:=false;
			quit;
			end;
		end;

	\SET EXTENTION AND INPUT HANDLE
	if not EFLG then
		for I:=0,3 do TAIL(P+I):=EXT1(I);
	INHAND:=FOPEN(TAIL,0);
	end;


begin	\OF IBMOPEN

\GET COMMAND TAIL FROM PSP
TLEN:=RESERVE(80);
TAIL:=TLEN+1;
SYSINF:=GETREG;
PSEG:=SYSINF(11);
CSEG:=SYSINF(12);
BLIT(PSEG,$80,CSEG,TLEN,79);
if TLEN(0)>79 then TLEN(0):=79;

\PARSE COMMAND LINE AND SET HANDLES
PARSE;

\OPEN FILES
FSET(INHAND,^I);
end;




begin
IBMOPEN;
OPENI(DISK);
SINTAB:=RLRES(NPOINTS+1);
MAGNITUDE:=RLRES((NPOINTS/2)+1);
PHASE:=RLRES((NPOINTS/2)+1);

X:=RLRES(NPOINTS);
Y:=RLRES(NPOINTS);

OPENI(3);
for I:=0,NPOINTS-1 do X(I):=RLIN(3);
for I:=0,NPOINTS-1 do Y(I):=0.0;


PLOT(X,NPOINTS,"INPUT WAVE FORM");
CORR(X);
CHOUT(0,7);
PLOT(MAGNITUDE,NPOINTS,"SPECTRUM");
FCLOSE(INHAND);
end;
