\CPMOVE.XPL
\READ A CPM DISK

code
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT	=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;

code real

RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;



address
	SEC1,
	SEC2,
	SECTOR,
	DIRECT;



integer
	UNIT,
	SPTR,
	BPTR,
	ODEV,
	DSTART;


integer ITLTAB;


define
	FF=$0C,
	CR=$0D,
	EOF=$1A;



procedure PAUSE;
integer T;
begin
TEXT(0,"HIT ANY KEY ");
T:=CHIN(1);
end;




procedure GETSEC(N);
\GET 128 BYTE SECTOR
integer N,B,S;
begin
B:=N/2;
S:=REM(N/2);

if S=0 then READ(UNIT,B,SEC2,1)
else READ(UNIT,B,SEC1,1);
end;




procedure LOGSEC(N);
\GET LOGICAL SECTOR USING INTERLEAVE
integer N,T,S;
begin
T:=N/26;
S:=REM(N/26);
N:=(T*26)+ITLTAB(S);
GETSEC(N);
end;




procedure GETBYT;
integer C;
\READ BYTES FROM SECTORS
begin
if BPTR>=128 then
	begin
	LOGSEC(SPTR);
	SPTR:=SPTR+1;
	BPTR:=0;
	end;
C:=SECTOR(BPTR);
BPTR:=BPTR+1;
return C;
end;



procedure SETSEC(N);
integer N;
\SET NEW STARTING SECTOR
begin
SPTR:=N;
BPTR:=128;
end;



procedure GETDIR;
\READ THE DIRECTORY
integer P;
begin
SETSEC(DSTART);
for P:=0,2047 do DIRECT(P):=GETBYT;
end;



procedure DISNAME(E);
\DISPLAY FILENAME FOR AN ENTRY
integer E,P;
begin
E:=E*32;
for P:=1,8 do CHOUT(0,DIRECT(P+E));
CHOUT(0,^.);
for P:=9,11 do CHOUT(0,DIRECT(P+E));
end;



procedure DISDIR;
\DISPLAY THE DIRECTORY
integer D,L;
begin
CHOUT(0,FF);
L:=0;
for D:=0,63 do
if (DIRECT(D*32)#$E5) &
   (DIRECT(D*32+12)=0) then
	begin
	INTOUT(0,D);
	TEXT(0,") ");
	DISNAME(D);
	CRLF(0);
	L:=L+1;
	if REM(L/20)=0 then PAUSE;
	end;
end;



procedure GROUPOUT(G);
\OUTPUT 8 SECTOR GROUP
integer G,B;
begin
SETSEC(G*8+DSTART);
for B:=0,1023 do CHOUT(ODEV,GETBYT);
end;




procedure FOLLOW(ENT);
\FOLLOW EXTENTS THROUGH FILE
integer ENT,APTR,GRP;
begin
APTR:=0;
loop
	begin
	GRP:=DIRECT(ENT*32+16+APTR);
	if GRP=0 then quit;
	GROUPOUT(GRP);
	APTR:=APTR+1;
	if APTR=16 then
		begin
		ENT:=ENT+1;
		APTR:=0;
		end;
	end;
end;




procedure COPY;
integer ENTRY;
begin
GETDIR;
DISDIR;
CRLF(0);
TEXT(0,"SELECT ENTRY NUMBER ");
ENTRY:=INTIN(0);
if (DIRECT(ENTRY*32)=$E5) !
   (DIRECT(ENTRY*32+12)#0) then
	begin
	TEXT(0,"BAD FILE NUMBER");
	return;
	end;

FOLLOW(ENTRY);
end;




begin	\MAIN

SEC1:=RESERVE(384);
SEC2:=SEC1+128;
SECTOR:=SEC2;
DIRECT:=RESERVE(2048);

\INTERLEAVE TABLE
ITLTAB:=[
 0, 6,12,18,24,
 4,10,16,22,
 2, 8,14,20,
 1, 7,13,19,25,
 5,11,17,23,
 3, 9,15,21];

DSTART:=52;

CHOUT(0,FF);
TEXT(0,"

** COPY CP/M TO APEX **

NOTE: THIS MAY NOT A COPY A DISK WITH A
      FRAGMENTED DIRECTORY

");


TEXT(0,"ODEV= ");
ODEV:=INTIN(0);

OPENO(ODEV);

loop
	begin
	TEXT(0,"CP/M UNIT ");
	UNIT:=INTIN(0);
	COPY;
	CRLF(0);
	TEXT(0,"MORE? ");
	OPENI(0);
	if CHIN(0)#^Y then quit;
	end;
CLOSE(ODEV);
end;
