
include C:\CXPL\CODESI.XPL;

int
	DATASEG,	\CURRENT DATA SEGMENT
	CPUREG;		\SYSTEM INFO

integer P,X,COLOR;

integer LX1,LY1,LX2,LY2,LX3,LY3,LX4,LY4;


define SaveMax=100;
define EOFFSET=50;

int SavePTR,ErasePTR;

integer SaveX1,SaveY1,SaveX2,SaveY2,SaveX3,SaveY3,SaveX4,SaveY4;




define XBORDER=150,YBORDER=100;



procedure SETALL(PAL);
\Set EGA and VGA palete
int PAL,P;
char B;
begin
B:=RESERVE(17);
for P:=0,15 do	B(P):=PAL(P);
B(16):=0;
CPUREG(0):=$1002;
CPUREG(11):=DATASEG;
CPUREG(3):=B;
SOFTINT($10);
end;



procedure GRAPHICS;
\Enable graphics mode and set paletes
int PALETE;
begin
SETVID($12);
PALETE:=[0,$2C,$24,$34,$14,$26,$3E,$16,$02,$1B,$0B,$19,$01,$21,$0D,$2D];
SETALL(PALETE);
end;



procedure DOSPLINE(X0,Y0,X1,Y1,X2,Y2,X3,Y3,Color);
int X0,Y0,X1,Y1,X2,Y2,X3,Y3;
int Color;
int X,Y,P;
real T,A,B,C,D,E,F,G,H;
define INCREMENT=150;
begin
A:=FLOAT(X3 - (3 * X2) + (3 * X1) - X0);
B:=FLOAT((3 * X2) - (6 * X1) + (3 * X0));
C:=FLOAT((3 * X1) - (3 * X0));
D:=FLOAT(X0);

E:=FLOAT(Y3 - (3 * Y2) + (3 * Y1) - Y0);
F:=FLOAT((3 * Y2) - (6 * Y1) + (3 * Y0));
G:=FLOAT((3 * Y1) - (3 * Y0));
H:=FLOAT(Y0);

MOVE(X0,Y0);
for P:=0,INCREMENT do
	begin
	T:=FLOAT(P)/FLOAT(INCREMENT);
	X:=FIX( (((A * T) + B) * T + C) * T + D);
	Y:=FIX( (((E * T) + F) * T + G) * T + H);
	LINE(X,Y,Color);
	end;
end;
	

procedure LINKSPLINE(X1,Y1,X2,Y2,X3,Y3,X4,Y4);
integer X1,Y1,X2,Y2,X3,Y3,X4,Y4;
begin
end;


procedure FLIP;
int DX,DY;
begin
LX1:=LX4;LY1:=LY4;
LX2:=LX3;LY2:=LY3;
DX:=LX2-LX1; DY:=LY2-LY1;
LX2:=LX1-DX; LY2:=LY1-DY;
end;


procedure SaveSpline(X1,Y1,X2,Y2,X3,Y3,X4,Y4);
integer X1,Y1,X2,Y2,X3,Y3,X4,Y4;
begin
if SavePTR>=SaveMAX then return;
SaveX1(SavePTR):=X1; SaveY1(SavePTR):=Y1;
SaveX2(SavePTR):=X2; SaveY2(SavePTR):=Y2;
SaveX3(SavePTR):=X3; SaveY3(SavePTR):=Y3;
SaveX4(SavePTR):=X4; SaveY4(SavePTR):=Y4;
SavePTR:=SavePTR+1;
DOSPLINE(X1,Y1,X2,Y2,X3,Y3,X4,Y4,COLOR);
end;


procedure EraseSpline;
define EOFFSET=10;
begin
if SavePTR<EOFFSET then return;
if ErasePTR>=SaveMAX then [ErasePTR:=0;SavePTR:=0;];
DOSPLINE(SaveX1(ErasePTR),SaveY1(ErasePTR),SaveX2(ErasePTR),SaveY2(ErasePTR),SaveX3(ErasePTR),SaveY3(ErasePTR),SaveX4(ErasePTR),SaveY4(ErasePTR),0);
ErasePTR:=ErasePTR+1;
end;





procedure XRANDOM;
begin
return RAN(640-(2*XBORDER))+XBORDER;
end;



procedure YRANDOM;
begin
return RAN(480-(2*YBORDER))+YBORDER;
end;




procedure CONTINUOUS;
begin

GRAPHICS;
COLOR:=2;
LX1:=XRANDOM; LY1:=YRANDOM;
LX2:=XRANDOM; LY2:=YRANDOM;
loop
	begin
	LX3:=XRANDOM; LY3:=YRANDOM;
	LX4:=XRANDOM; LY4:=YRANDOM;

	DOSPLINE(LX1,LY1,LX2,LY2,LX3,LY3,LX4,LY4,COLOR);

	FLIP;

	if RAN(20)=0 then [COLOR:=COLOR+1;if COLOR=0 then COLOR:=1;];
	if CHKKEY then case CHIN(1) of
	$1B: quit;
	^c,^C: GRAPHICS
	other;
	end;

SETVID(3);
end;



procedure TRACE;
begin
SavePTR:=0;
ErasePTR:=0;
GRAPHICS;
COLOR:=2;
LX1:=XRANDOM; LY1:=YRANDOM;
LX2:=XRANDOM; LY2:=YRANDOM;
loop
	begin
	LX3:=XRANDOM; LY3:=YRANDOM;
	LX4:=XRANDOM; LY4:=YRANDOM;

	SaveSpline(LX1,LY1,LX2,LY2,LX3,LY3,LX4,LY4);
	EraseSpline;
	FLIP;

	if RAN(20)=0 then [COLOR:=COLOR+1;if COLOR=0 then COLOR:=1;];
	if CHKKEY then case CHIN(1) of
	$1B: quit;
	^c,^C: GRAPHICS
	other;
	end;

X:=CHIN(1);
SETVID(3);
end;



begin
CPUREG:=GETREG;
DATASEG:=CPUREG(12);

SaveX1:=RESERVE(SaveMAX*2);
SaveY1:=RESERVE(SaveMAX*2);
SaveX2:=RESERVE(SaveMAX*2);
SaveY2:=RESERVE(SaveMAX*2);
SaveX3:=RESERVE(SaveMAX*2);
SaveY3:=RESERVE(SaveMAX*2);
SaveX4:=RESERVE(SaveMAX*2);
SaveY4:=RESERVE(SaveMAX*2);

loop
	begin
	CHOUT(0,$0C);
	TEXT(0,"Select Trace or Continuous T/C: ");
	case CHIN(1) of
	^t,^T: Trace;
	^c,^C: Continuous
	other; 
	end;
end;
