
\DISK REPAIR UTILITIES

include C:\CXPL\CODESI.XPL;

address NAME,BUFFER;

define MEG=1.048576E6;

integer
	X,
	DSEG,
	BITTAB,
	R,
	DRIVE,
	SC1,
	SC2,
	HANDLE,
	CPUREG;

integer
	DTYPE,		\SPECIFIES FLOPPY VS HARD DRIVE
	HDRIVE,		\WORKING HARD DRIVE
	MAXCYL,		\MAXIMUM CYLINER NUMBER
	MAXHEAD,	\MAXIMUM HEAD NUMBER
	MAXSEC;		\MAXIMUM SECTOR NUMBER

real	DSIZE;		\CURRENT HARD DISK SIZE


procedure WAIT;
\WAIT FOR KEYSTROKE
int X;
begin
TEXT(0,"HIT ANY KEY ");
X:=CHIN(1);
CRLF(0);
end;


procedure BLANK;
\CLEAR SCREEN
CHOUT(0,$0C);



procedure GETSTR(S);
\INPUT STRING FROM KEYBOARD
address S;
integer P;
begin
for P:=0,32000 do
	begin
	S(P):=CHIN(0);
	if S(P)=$0D then
		[if P#0 then S(P-1):=S(P-1) ! $80 else P(0):=$20;return;];
	if  P>=79 then [S(P):=S(P) ! $80;return;];
	end;
end;




procedure NIBOUT(I);
\ DISPLAY HEX CHAR 
int I;
begin
I:=I & $0F;
if I>9 then CHOUT(0,I+55) else CHOUT(0,I+48);
end;


procedure BYTOUT(I);
\ DISPLAY hEX BYTE 
int I;
begin
I:=I&$FF;
NIBOUT(I/16);
NIBOUT(I);
end;


procedure ASCOUT(C);
\DISPLAY NORMAL ASCII CHARACTER
integer C;
if (C<^ ) ! (C>$7F) then CHOUT(0,^.) else CHOUT(0,C);


procedure DISDRIVE(D);
\CONVERT DRIVE TO LETTER AND DISPLAY
integer D;
begin
CHOUT(0,D+^A);
CHOUT(0,^:);
end;



procedure GETDRIVE;
\READ A DRIVE LETTER AND CONVERT TO NUMBER
int D;
begin
loop
	begin
	TEXT(0,"ENTER DRIVE SPEC (A,B,C..) ");
	OPENI(0);
	D:=CHIN(0);
	if D>=^a & D<=^z then [D:=D-^a;quit;];
	if D>=^A & D<=^Z then [D:=D-^A;quit;];
	TEXT(0,"ILLEGAL SPEC. ");CRLF(0);
	end;
DRIVE:=D;
end;



procedure GETSC1;
\GET STARTING SECTOR
begin
TEXT(0,"ENTER STARTING SECTOR ");
SC1:=INTIN(0);
end;



procedure GETSC2;
\GET ENDING SECTOR
begin
GETSC1;
TEXT(0,"ENTER ENDING SECTOR ");
SC2:=INTIN(0);
end;



procedure DISERROR(E);
\DISPLAY FIXED DRIVE ERROR CODES
int E;
begin
case E of
0: TEXT(0,"NO ERROR");
$01: TEXT(0,"INVALID FUNCTION REQUEST");
$02: TEXT(0,"ADDRESS MARK NOT FOUND");
$03: TEXT(0,"WRITE PROTECT ERROR");
$04: TEXT(0,"SECTOR NOT FOUND");
$05: TEXT(0,"RESET FAILED");
$07: TEXT(0,"DRIVE PARAMETER ACTIVITY FAILED");
$08: TEXT(0,"DMA OVERRUN ON OPERATION");
$09: TEXT(0,"DATA BOUNDRY ERROR");
$0A: TEXT(0,"BAD SECTOR FLAG DETECTED");
$0B: TEXT(0,"BAD TRACK DETECTED");
$0D: TEXT(0,"INVALID NUMBER OF SECTORS ON FORMAT");
$0E: TEXT(0,"CONTROL DATA ADDRESS MARK DETECTED");
$0F: TEXT(0,"DMA ARBITRATION LEVEL OUT OF RANGE");
$10: TEXT(0,"UNCORRECTABLE ECC OR CRC ERROR");
$11: TEXT(0,"ECC CORRECTED DATA ERROR");
$20: TEXT(0,"GENERAL CONTROLLER FAILURE");
$40: TEXT(0,"SEEK OPERATION FAILURE");
$80: TEXT(0,"TIMEOUT");
$AA: TEXT(0,"DRIVE NOT READY");
$BB: TEXT(0,"UNDEFINED ERROR OCCURED");
$CC: TEXT(0,"WRITE FAULT ON SELECTED DRIVE");
$E0: TEXT(0,"STATUS ERROR/ERROR REGISTER IS 0");
$FF: TEXT(0,"SENSE OPERATION FAILED")
else TEXT(0,"UNKNOWN ERROR");
CRLF(0);
end;




procedure FILLBUF(D,S);
\FILL BUFFER FROM SPECIFIED DRIVE AND SECTOR
int D,S;
begin
TRAP($FFFB);
X:=CHIN(1);
READ(D,S,BUFFER,1);
TRAP($FFFF);
if GETERR=3 then
	begin
	TEXT(0,"UNABLE TO READ SECTOR ");
	INTOUT(0,S);CRLF(0);
	return false;
	end
else return true;
end;



procedure LOWWRITE(DRV,CYL,HD,SEC);
\LOW LEVEL BUFFER BUFFER
\TO SPECIFIED CYLINDER,DRIVE,HEAD,SECTOR
int DRV,CYL,HD,SEC,EFLAG;
int COM,ERR;
begin
BLANK;
CHOUT(0,7);
TEXT(0,"!!!!!!! VERY DANGEROUS OPERATION !!!!!!!!");CRLF(0);
TEXT(0,"ABOUT TO WRITE A SECTOR TO THE HARD DISK ");CRLF(0);
TEXT(0,"THIS OPERATION COULD DAMAGE YOUR PARTITION");CRLF(0);
TEXT(0,"TABLE AND CAUSE ALL INFORMATION ON THE HARD");CRLF(0);
TEXT(0,"          DISK TO BE LOST ");CRLF(0);
TEXT(0," --------------------------------------- ");CRLF(0);CRLF(0);
TEXT(0," DRIVE:    ");INTOUT(0,HDRIVE);CRLF(0);
TEXT(0," CYLINDER: ");INTOUT(0,CYL);CRLF(0);
TEXT(0," HEAD:     ");INTOUT(0,HD);CRLF(0);
TEXT(0," SECTOR:   ");INTOUT(0,SEC);CRLF(0);CRLF(0);
TEXT(0," TO VERIFY TYPE Y");
OPENI(0);COM:=CHIN(0);if COM#^Y & COM#^y then return;
TEXT(0," ONE LAST CHANCE, TO VERIFY TYPE V");
OPENI(0);COM:=CHIN(0);if COM#^V & COM#^v then return;

CPUREG(0):=$0301;
CPUREG(2):=SWAP (CYL & $FF);
CPUREG(2):=CPUREG(2) ! (SEC & $3F);
CPUREG(2):=CPUREG(2) ! ((CYL & $0300) >> 2);
CPUREG(3):=SWAP(HD & $FF);
CPUREG(3):=CPUREG(3) ! (DRV & $FF);
CPUREG(1):=BUFFER;
CPUREG(11):=DSEG;
SOFTINT($13);

ERR:=SWAP (CPUREG(0) & $FF00);

if ERR # 0 then
	begin
	DISERROR(ERR);
	return false;
	end
else return true;
end;



procedure LOWFILL(DRV,CYL,HD,SEC,EFLAG);
\LOW LEVEL BUFFER FILL
\FROM SPECIFIED CYLINDER,DRIVE,HEAD,SECTOR
int DRV,CYL,HD,SEC,EFLAG;
int ERR;
begin
CPUREG(0):=$0201;
CPUREG(2):=SWAP (CYL & $FF);
CPUREG(2):=CPUREG(2) ! (SEC & $3F);
CPUREG(2):=CPUREG(2) ! ((CYL & $0300) >> 2);
CPUREG(3):=SWAP(HD & $FF);
CPUREG(3):=CPUREG(3) ! (DRV & $FF);
CPUREG(1):=BUFFER;
CPUREG(11):=DSEG;

SOFTINT($13);
ERR:=SWAP (CPUREG(0) & $FF00);
if ERR # 0 then
	begin
	if EFLAG then DISERROR(ERR);
	return false;
	end
else return true;
end;



procedure DUMP1;
\DUMP FIRST HALF OF BUFFER TO SCREEN
integer P,I,C;
begin
P:=0;
repeat
	begin
	HEXOUT(0,P);TEXT(0," ");
	for I:=0,15 do [BYTOUT(BUFFER(P+I));TEXT(0," ");];
	TEXT(0," -- ");
	for I:=0,15 do ASCOUT(BUFFER(P+I));
	CRLF(0);
	P:=P+16;
	end
until P>=256;
end;



procedure DUMP2;
\DUMP SECOND HALF OF BUFFER TO SCREEN
integer P,I,C;
begin
P:=256;
repeat
	begin
	HEXOUT(0,P);TEXT(0," ");
	for I:=0,15 do [BYTOUT(BUFFER(P+I));TEXT(0," ");];
	TEXT(0," -- ");
	for I:=0,15 do ASCOUT(BUFFER(P+I));
	CRLF(0);
	P:=P+16;
	end
until P>=512;
end;



procedure DUMP;
\DUMP WHOLE BUFFER TO SCREEN
int C;
begin
DUMP1;
TEXT(0,"HIT ANY KEY FOR SECOND HALF OF SECTOR");C:=CHIN(1);CRLF(0);
DUMP2;
end;



procedure BEDIT;
\EDIT BUFFER
int P,C;
begin
BLANK;
P:=0;
loop
	begin
	HEXOUT(0,P);TEXT(0," - ");
	BYTOUT(BUFFER(P));
	C:=CHIN(1);
	case C of
	^-: if P>0 then P:=P-1;
	$0D,^+: if P<511 then P:=P+1;
	^M,^m: [TEXT(0," ENTER> ");BUFFER(P):=HEXIN(0); if P<511 then P:=P+1;];
	$1B: quit
	other;
	CRLF(0);
	end;
BLANK;
end;


procedure ERRHAND;
\DISPLAY DISK ERROR
int E;
begin
E:=CPUREG(15) >> 8;
TEXT(0," - ");HEXOUT(0,E);TEXT(0," ! BAD ! ");

case E of
	$80: TEXT(0,"Response failure");
	$40: TEXT(0,"Seek failure");
	$20: TEXT(0,"Controller failure");
	$10: TEXT(0,"Bad CRC");
	$08: TEXT(0,"DMA Failure");
	$04: TEXT(0,"Sector Not Found");
	$03: TEXT(0,"Write Protect Failure");
	$02: TEXT(0,"Bad Address Mark");
	$01: TEXT(0,"Bad Command") 
other;			
end;



procedure STATUS;
\DISPLAY DRIVE STATUS INFO
int D,E,P;
begin
BLANK;
TEXT(0,"

  $80 - $81             = FIXED DISK
    0,1,2,3             = FLOPPY DISK

ENTER DRIVE NUMBER: ");
D:=HEXIN(0) & $FF;


E:=CPUREG(0) & $FF;
CRLF(0);HEXOUT(0,E);CRLF(0);
for P:=$41,$48 do [HEXOUT(0,PEEK($40,P));TEXT(0,",");];CRLF(0);
HEXOUT(0,PEEK($40,$74));TEXT(0,",");HEXOUT(0,PEEK($40,$75));CRLF(0);

CPUREG(0):=$0100;
CPUREG(3):=D;

P:=CHIN(1);
SOFTINT($13);  

if D>8 then 
	begin
	TEXT(0,"FIXED DRIVE STATUS:");CRLF(0);
	DISERROR(E)
	end
else
	begin
	TEXT(0,"FLOPPY DRIVE STATUS:");CRLF(0);
	if E & $80 then TEXT(0,"DRIVER NOT READY, ");
	if E & $40 then TEXT(0,"SEEK ERROR OCCURED, ");
	if E & $20 then TEXT(0,"DISK CONTROLLER FAILED, ");
	case E & $1F of
	$01: TEXT(0,"ILLEGAL FUNCTION REQUESTED");
	$02: TEXT(0,"ADDRES MARK NOT FOUND");
	$03: TEXT(0,"WRITE PROTECT ERROR");
	$04: TEXT(0,"SECTOR NOT FOUND");
	$06: TEXT(0,"DRIVE  DOOR WAS OPENED");
	$08: TEXT(0,"DMA OVERRUN ERROR");
	$09: TEXT(0,"DMA BOUNDRY ERROR");
	$0C: TEXT(0,"MEDIA TYPE UNKNOWN");
	$10: TEXT(0,"CRC FAILED ON DISKETTE READ") 
	else;
	end;
end;



procedure STATUS1;
\DISPLAY CONTINUOUS INFO
int P;

	procedure DISPORT(P);
	int P;
	[HEXOUT(0,P);TEXT(0," - ");BYTOUT(PIN(P,0));CRLF(0);];

begin
BLANK;
loop
	begin
	CURSOR(0,0);
	DISPORT($374);
	DISPORT($377);
	DISPORT($3F0);
	DISPORT($3F1);
	DISPORT($3F2);
	DISPORT($3F4);
	DISPORT($3F5);
	DISPORT($3F7);
	if CHKKEY then quit;
	end;
end;




procedure HDEXAMINE;
\DO LOW LEVEL HARD DISK EXAMINE AND MODIFY
int CYL,HD,SEC,FIRST;


	procedure STATUS;
	begin
	CURSOR(0,0);
	TEXT(0,"C/c = CYLINDER        H/h = HEAD               S/s = SECTOR");CRLF(0);
	TEXT(0,"R   = READ            T   = TOGGLE HALVES      E   = EDIT BUFFER");CRLF(0);
	TEXT(0,"                      W   = WRITE BUFFER");CRLF(0);

	CURSOR(0,4);
	TEXT(0,"DRIVE: ");INTOUT(0,HDRIVE & 1);
	TEXT(0,"  CYLINDER: ");INTOUT(0,CYL);
	TEXT(0," HEAD: ");INTOUT(0,HD);
	TEXT(0," SECTOR: ");INTOUT(0,SEC);
	TEXT(0," SECTOR OFFSET: ");
	RLOUT(0,FLOAT(SEC) + (FLOAT(HD) * FLOAT(MAXSEC)) + (FLOAT(CYL) * FLOAT(MAXHEAD)));
	TEXT(0,"   ");
	end;


	procedure DODUMP;
	begin
	CURSOR(0,8);
	if FIRST then DUMP1 else DUMP2;
	end;


begin
FORMAT(10,0);
CYL:=0;HD:=0;SEC:=1;
FIRST:=true;
BLANK;
STATUS;
loop
	begin
	case CHIN(1) of
	$1B: [CURSOR(0,24);quit;];
	^R,^r: 	begin
		CURSOR(0,6);
		TEXT(6,"                                              ");
		CURSOR(0,6);
		LOWFILL(HDRIVE,CYL,HD,SEC,true);
		CURSOR(0,8);
		FIRST:=true;
		DODUMP;
		end;
	^E,^e: [BEDIT;DODUMP;];
	^T,^t: [FIRST:=not FIRST;DODUMP;];
	^W,^w: [LOWWRITE(HDRIVE,CYL,HD,SEC);BLANK;];
	^S: SEC:=if SEC<63 then SEC+1 else 63;
	^H: HD:=if HD<255 then HD+1 else 255;
	^C: CYL:=if CYL < 1023 then CYL+1 else 1023;
	^s: SEC:=if SEC>1 then  SEC-1 else 1;
	^h: HD:=if HD>0 then HD-1 else 0;
	^c: [CYL:=if CYL>0 then CYL-1 else 0;]
	other;
	STATUS;
	end;
end;




procedure FINDPART;
\FIND ALL PARTITION TABLES
int CYL,HD,SEC,C;
begin
BLANK;
CYL:=0;HD:=0;SEC:=1;
loop
	begin
	CURSOR(0,10);
	INTOUT(0,CYL);
	TEXT(0," ");
	INTOUT(0,HD);
	TEXT(0," ");
	INTOUT(0,SEC);
	TEXT(0,"   ");

	LOWFILL(HDRIVE,CYL,HD,SEC,false);
	if BUFFER($1FE)=$55 then if BUFFER($1FF)=$AA then
	if BUFFER($1FC)#$55 then if BUFFER($1FD)#$AA then
		begin
		TEXT(0,"TABLE SIGNATURE FOUND");
		C:=CHIN(1);		
		BLANK;
		end;

	SEC:=SEC+1;
	if SEC>MAXSEC then
		begin		
		SEC:=1;
		HD:=HD+1;
		if HD>=MAXHEAD then
			begin
			HD:=0;
			CYL:=CYL+1;
			if CYL>=MAXCYL then quit;
			end;
		end;

	end;
end;


procedure READSIZE;
\READ DISK SIZE FROM BIOS
begin
CPUREG(0):=$0800;
CPUREG(3):=HDRIVE;
SOFTINT($13);
MAXCYL:=SWAP(CPUREG(2) & $FF00) ! ((CPUREG(2) & $C0) << 2) +2;
MAXHEAD:=SWAP(CPUREG(3) & $FF00)+1;
MAXSEC:=CPUREG(2) & $3F;
DSIZE:=(FLOAT(MAXCYL) * FLOAT(MAXHEAD) * FLOAT(MAXSEC)*512.)/MEG;
end;




procedure FINDSIZE;
\Find Hard disk size by testing
int CYL,HD,SEC,B;
real SIZE;
begin
FORMAT(10,0);
BLANK;
HD:=0;SEC:=1;

CYL:=512;
B:=512;
loop
	begin
	if B=1 then quit;
	B:=B/2;
	CYL:=if LOWFILL(HDRIVE,CYL,HD,SEC,false) then CYL+B else CYL-B;
	CURSOR(0,3);
	TEXT(6,"CYLINDER: ");
	INTOUT(6,CYL);
	end;
CYL:=CYL-1;
while LOWFILL(HDRIVE,CYL,HD,SEC,false) do
	begin
	HD:=HD+1;
	CURSOR(0,4);
	TEXT(6,"HEAD: ");
	INTOUT(6,HD);
	end;
HD:=HD-1;
while LOWFILL(HDRIVE,CYL,HD,SEC,false) do
	begin
	 SEC:=SEC+1;
	CURSOR(0,5);
	TEXT(6,"SECTOR ");
	INTOUT(6,SEC);
	end;
SEC:=SEC-1;
CRLF(0);
TEXT(0,"CYLINDERS= ");INTOUT(0,CYL+1);
TEXT(0," HEADS= ");INTOUT(0,HD+1);
TEXT(0," SECTORS= ");INTOUT(0,SEC);

SIZE:=(FLOAT(CYL+1) * FLOAT(HD+1) * FLOAT(SEC)*512.)/MEG;
FORMAT(4,3);
CRLF(0);
TEXT(0,"TOTAL DISK SPACE= ");RLOUT(0,SIZE);
CRLF(0);
end;




procedure real PARTITION(CYL,HD,SEC,LEV);
\DISPLAY PARTITION INFORMATION
int CYL,HD,SEC,LEV;
int OFF,P;
int SYSTEM;
real SECOFF,NUMSECT,EXTEND;
char BYTEPTR;


	procedure real DBW2REAL(P);
	\CONVERT DOUBLE WORD TO REAL
	char P;
	begin
	return FLOAT(P(0))
	+ (256. * FLOAT(P(1)))
	+ ( 65.536E3 * FLOAT(P(2)))
	+ (16.777216E6 *FLOAT(P(3)));
	end;


	procedure INDENT(L);
	\INDENT TO ILLUSTRATE NESTING
	int L,P;
	for P:=1,L do CHOUT(0,^*);
	



	procedure GETPART(P,L);
	\DISPLAY PARTITION
	char P;int I;
	begin
	FORMAT(9,0);
	SYSTEM:=P(4);
	INDENT(LEV);TEXT(0,"BOOT INDICATOR:    ");BYTOUT(P(0));CRLF(0);
	INDENT(LEV);TEXT(0,"BEGINING HEAD:     ");INTOUT(0,P(1));CRLF(0);
	INDENT(LEV);TEXT(0,"BEGINING SECTOR:   ");INTOUT(0,P(2));CRLF(0);
	INDENT(LEV);TEXT(0,"BEGINING CYLINDER: ");INTOUT(0,P(3));CRLF(0);
	INDENT(LEV);TEXT(0,"SYSTEM:            ");BYTOUT(P(4));CRLF(0);
	INDENT(LEV);TEXT(0,"ENDING HEAD:       ");INTOUT(0,P(5));CRLF(0);
	INDENT(LEV);TEXT(0,"ENDING SECTOR:     ");INTOUT(0,P(6));CRLF(0);
	INDENT(LEV);TEXT(0,"ENDING CYLINDER:   ");INTOUT(0,P(7));CRLF(0);
	SECOFF:=DBW2REAL(P+8);
	INDENT(LEV);TEXT(0,"SECTOR OFFSET: ");RLOUT(0,SECOFF);
	TEXT(0,"  $");
	BYTOUT(P(11));BYTOUT(P(10));
	BYTOUT(P(9));BYTOUT(P(8));
	CRLF(0);
	NUMSECT:=DBW2REAL(P+$0C);
	INDENT(LEV);TEXT(0,"NUMBER SECTORS: ");RLOUT(0,NUMSECT);
	TEXT(0,"  $");
	BYTOUT(P(15));BYTOUT(P(14));
	BYTOUT(P(13));BYTOUT(P(12));
	TEXT(0,"  ");
	FORMAT(9,3);
	RLOUT(0,(NUMSECT * 512.)/MEG);
	TEXT(0,"MEG");
	CRLF(0);
	CRLF(0);
	end;



begin
TEXT(0,"PARTITION INFO FOR: ");
INTOUT(0,CYL);
TEXT(0,"  ");
INTOUT(0,HD);
TEXT(0,"  ");
INTOUT(0,SEC);
CRLF(0);

LOWFILL(HDRIVE,CYL,HD,SEC,true);
EXTEND:=0.0;
for P:=0,3 do 
	begin
	OFF:=$1BE+(P*16);
	GETPART(BUFFER+OFF);
	if SYSTEM=5 then EXTEND:=SECOFF;
	WAIT;CRLF(0);
	end;

TEXT(0,"SIGNATURE: ");
BYTOUT(BUFFER($1FE));
TEXT(0," ");
BYTOUT(BUFFER($1FF));
CRLF(0);
return EXTEND;
end;



procedure DOPART;
\DISPLAY AND FOLLOW PARTIONS
int C,H,S,L;
real EXT,CEXT;
begin
C:=0; H:=0; S:=1; L:=0;
EXT:=0.0;
loop
	begin
	CEXT:=PARTITION(C,H,S,L);
	if CEXT=0.0 then quit;
	L:=L+1;
	EXT:=EXT+CEXT;
	C:=FIX(EXT/(FLOAT(MAXSEC)*FLOAT(MAXHEAD)));
	end;
end;



procedure LOWMENU;
\DISPLAY MENU
begin
TEXT(0,"CURRENTLY WORKING WITH: ");
TEXT(0,if DTYPE=0 then "Floppy" else "Hard");
CRLF(0);

TEXT(0,"
		******* HARD/FLOPPY DISK ROUTINES ********

P = EXAMINE PARTITIONS		S = SCAN FOR LOST PARTITIONS
E = EXAMINE SECTORS		T = DRIVE SIZE");
end;



procedure LOWLEVEL;
\LOW LEVEL HARD/FLOPPY DISK FUNCTIONS
begin
BLANK;
TEXT(0,"DRIVE TYPE FLOPPY OR HARD [F/H]");
OPENI(0);
case CHIN(0) of
 ^F,^f: DTYPE:=0;
 ^H,^h: DTYPE:=$80
other DTYPE:=0;
TEXT(0,"DRIVE 0 OR 1: ");
HDRIVE:=(INTIN(0) & 1) ! DTYPE;
READSIZE;
loop
	begin
	BLANK;
	TEXT(0,"CYLINDERS: ");INTOUT(0,MAXCYL);
	TEXT(0,"  HEADS: ");INTOUT(0,MAXHEAD);
	TEXT(0,"  SECTORS: ");INTOUT(0,MAXSEC);
	FORMAT(4,3);
	TEXT(0,"  DISK SIZE: ");RLOUT(0,DSIZE);TEXT(0," MEG.");
	CRLF(0);CRLF(0);
	LOWMENU;
	CURSOR(0,20);
	case CHIN(1) of
		^t,^T: FINDSIZE;
		^s,^S: FINDPART;
		^p,^P: DOPART;
		^e,^E: HDEXAMINE;
		^q,^Q: quit
	other;
	WAIT;
	end;
end;



\-----------------------------------------------------------------------



proc VERIFY;
\VERIFY DISK SECTORS
int S;
begin
GETSC2;
TEXT(0,"Hit ESC to abort");CRLF(0);CRLF(0);
for S:=SC1,SC2 do
	begin
	TEXT(0,"SECTOR ");
	INTOUT(0,S);
	TRAP($FFFB);
	READ(DRIVE,S,BUFFER,1);
	TRAP($FFFF);
	if GETERR=3 then ERRHAND
	else TEXT(0," OK");
	CRLF(0);
	if CHKKEY then if CHIN(1)=$1B then return;
	end;
end;




proc FIXSECTOR;
\FIX A DISK SECTOR
int S,C;
begin
BLANK;
TEXT(0,"
================================================================
The program will retry the sector until there is no error, or
until you hit escape. If it is able to read the data from disk,
you can choose to write it back and repair the sector.
================================================================

ENTER SECTOR NUMBER: ");
S:=INTIN(0);

C:=0;
loop
	begin
	if CHKKEY then if CHIN(1)=$1B then return;
	INTOUT(0,C);TEXT(0," - ");
	TEXT(0,"SECTOR: ");INTOUT(0,S);
	TRAP($FFFB);
	READ(DRIVE,S,BUFFER,1);
	TRAP($FFFF);
	if GETERR=3 then ERRHAND
	else quit;
	CRLF(0);
	C:=C+1;
	end;
TEXT(0,"

SECTOR WAS SUCESSFULLY READ

DO YOU WISH TO WRITE IT BACK? y/[N] : ");
C:=CHIN(1);
if C#^Y & C#^y then return;

TEXT(0,"
DO YOU WISH TO WRITE TO DIFFERENT SECTOR? y/[N] : ");
C:=CHIN(1);
if C=^Y ! C=^y then
	begin
	CRLF(0);
	TEXT(0,"OLD SECTOR IS: ");INTOUT(0,S);CRLF(0);
	TEXT(0,"ENTER NEW SECTOR NUMBER: ");
	S:=INTIN(0);
	end;
CRLF(0);
TEXT(0,"!!! ABOUT TO WRITE TO SECTOR: ");
INTOUT(0,S);CRLF(0);
TEXT(0,"VERIFY Y/N: ");
OPENI(0);
C:=CHIN(1);
if C#^Y & C#^y then return;
CRLF(0);
TRAP($FFFB);
WRITE(DRIVE,S,BUFFER,1);
TRAP($FFFF);
if GETERR=3 then ERRHAND
else [TEXT(0,"SUCCESSFULLY WRITTEN");CRLF(0);];
CRLF(0);
C:=CHIN(1);
end;



procedure HEXDUMP;
\HEX DUMP SECTORS
int C;
begin
GETSC1;
loop
	begin
	TEXT(0," SECTOR = ");INTOUT(0,SC1);CRLF(0);
	if FILLBUF(DRIVE,SC1) then DUMP;

	TEXT(0,"MORE Y/N ");
	C:=CHIN(1);
	if C=^N ! C=^n then quit;
	SC1:=SC1 + 1;
	end;

end;



procedure SEARCH;
\SEARCH FOR A STRING
integer I,P;
char STRING;


procedure SCOMP;
begin
for P:=1,511 do
	if BUFFER(I+P)#STRING(P) then
	if BUFFER(I+P)=(STRING(P)&$7F) then return true else return false;
end;


procedure BCOMP;
\LOOK FOR FIRST MATCH
begin
for I:=0,511 do
	if BUFFER(I)=STRING(0) then
	if SCOMP then [DUMP;WAIT;return];
end;



begin
STRING:=RESERVE(80);
OPENI(0);
TEXT(0,"ENTER STRING = ");GETSTR(STRING);
GETSC2;

loop
	begin
	TEXT(0," SECTOR = ");INTOUT(0,SC1);CRLF(0);
	if FILLBUF(DRIVE,SC1) then BCOMP;
	SC1:=SC1 + 1;
	if SC1>SC2 then quit;
	end;
end;



procedure ASCIIDUMP;
\ASCII DUMP SECTORS
integer I;
begin
GETSC2;
repeat 
	begin
	CRLF(0);
	TEXT(0,"---------------------------------------- ");
	INTOUT(0,SC1);CRLF(0);CRLF(0);
	if FILLBUF(DRIVE,SC1) then for I:=0,511 do CHOUT(0,BUFFER(I));
	SC1:=SC1 + 1;
	if CHKKEY then if CHIN(1)=$1B then return;
	end
until SC1>SC2;
CRLF(0);CRLF(0);
end;



procedure  FINDEOF;
\FIND END OF FILE CHARACTERS
integer I;
begin
GETSC2;
repeat 
	begin
	if FILLBUF(DRIVE,SC1) then
	for I:=0,511 do if BUFFER(I)=$1A then 
		begin
		TEXT(0,"SECTOR=");INTOUT(0,SC1);
		TEXT(0," BYTE= ");INTOUT(0,I);CRLF(0);
		end;
	SC1:=SC1 + 1;
	end
until SC1>SC2;
CRLF(0);CRLF(0);
end;





procedure  OFILE;
\OPEN OUTPUT FILE
char NAME;
begin
NAME:=RESERVE(80);
GETSTR(NAME);
HANDLE:=FOPEN(NAME,1);
FSET(HANDLE,^O);
end;



procedure  CFILE;
\CLOSE FILE
begin
CHOUT(3,$1A);
CLOSE(3);
FCLOSE(HANDLE);
end;



procedure  WFILE;
\WRITE TO FILE
integer I;
begin
GETSC2;
repeat 
	begin
	if FILLBUF(DRIVE,SC1) then
	for I:=0,511 do CHOUT(3,BUFFER(I)); 
	SC1:=SC1 + 1;
	end
until SC1>SC2;
CRLF(0);CRLF(0);
end;





procedure MENU;
\MAIN MENU
int X;
begin
BLANK;
TEXT(0,"

CURRENT DRIVE: ");
DISDRIVE(DRIVE);

TEXT(0,"

                        ===== MENU =====

Q - QUIT                 H - HEX DUMP SECTOR      S - STRING SEARCH
A - ASCII DUMP SECTOR    F - FIND NEXT EOF        O - OPEN FILE
C - CLOSE FILE           W - WRITE FILE           V - VERIFY SECTORS
D - ChANGE DRIVES        R - REPAIR SECTOR        I - DISK INFO
L - LOW LEVEL HARD/FLOPPY DISK
");
case CHIN(1) of
	^l,^L: LOWLEVEL;
	^h,^H: HEXDUMP;
	^s,^S: SEARCH;
	^a,^A: ASCIIDUMP;
	^F,^f: FINDEOF;
	^o,^O: OFILE;
	^c,^C: CFILE;
	^W,^w: WFILE;
	^v,^V: VERIFY;
	^d,^D: GETDRIVE;
	^r,^R: FIXSECTOR;
	^I,^i: [STATUS;WAIT;STATUS1;];
	^Q,^q: return false
else;
return true;
end;



begin	\MAIN
CPUREG:=GETREG;
DSEG:=CPUREG(12);
NAME:=RESERVE(80);

BITTAB:=[$01,$02,$04,$08,$10,$20,$40,$80,$0100,$0200,$0400,$0800,$1000,$2000,$4000,$8000];
BUFFER:=RESERVE(512);
DRIVE:=0;
loop
	begin
	if not MENU then quit;
	WAIT;
	end;
end;
