proc CONVSTRING;
begin
I:=0;
loop
        begin
        if DIRSTRING(I)>127 then
                begin
                FILETEXT(0,I):=DIRSTRING(I)&$7F;
                FILETEXT(0,I+1):=0;
                quit;
                end
        else    [FILETEXT(0,I):=DIRSTRING(I)];
        I:=I+1;
        end;
end;

proc GETATTRIB(SEGMENT,OFFSET);
int SEGMENT,OFFSET;
begin
TEMP:=PEEK(SEGMENT,OFFSET);
READONLY:=TEMP&1;
HIDDEN:=TEMP&2;
SYSTEM:=TEMP&4;
DIRECTORY:=TEMP&16;
end;

proc GETSIZE(SEGMENT,OFFSET);
int SEGMENT,OFFSET;
begin
\for right off the FINDFIRST or FINDNEXT dos interupt: SEGMENT:PSP(0) OFFSET:$80+$1A
SIZE:=          FLOAT(PEEK(SEGMENT,OFFSET))+
256.0*          FLOAT(PEEK(SEGMENT,OFFSET+1))+
65535.0*        FLOAT(PEEK(SEGMENT,OFFSET+2))+
16777215.0*     FLOAT(PEEK(SEGMENT,OFFSET+3));
end;

proc GETTIME(SEGMENT,OFFSET);
int SEGMENT,OFFSET;
begin
\for dos FINDFIRST and FINDNEXT: seg:PSP(0) offset:$80+$16
HOUR:=(PEEK(SEGMENT,OFFSET+1)&248)/8;
SECOND:=(PEEK(SEGMENT,OFFSET)&31)*2;
MINUTE:=(PEEK(SEGMENT,OFFSET+1)&7)*8+(PEEK(SEGMENT,OFFSET)&224)/32;
\
\0123456701234567
\[M][SEC][HR ][M]
\LOW          HI
end;

proc GETDATE(SEGMENT,OFFSET);
int SEGMENT,OFFSET;
begin
\for dos FINDFIRST and FINDNEXT: seg:PSP(0) offset:$80+$18
MONTH:=(PEEK(SEGMENT,OFFSET)&224)/32 + (PEEK(SEGMENT,OFFSET+1)&1)*8;
DAY:=PEEK(SEGMENT,OFFSET)&31;
YEAR:=(PEEK(SEGMENT,OFFSET+1)&254)/2+80;
\
\0123456701234567
\[M][DAY][YEAR ]M
\LOW            HI
end;

proc DIRSIZE;
real BYTES,K,M;
def VARCOLOR=$1E,TEXTCOLOR=$17;

        proc DESBYTES;
        begin
        SETFORMAT(BYTES,0);
        ATTRIB(VARCOLOR);
        RLOUT(6,BYTES);
        ATTRIB(TEXTCOLOR);
        TEXT(6," bytes");
        end;

        proc DESK;
        begin
        SETFORMAT(K,2);
        ATTRIB(VARCOLOR);
        RLOUT(6,K);
        ATTRIB(TEXTCOLOR);
        TEXT(6,"k");
        end;

        proc DESM;
        begin
        SETFORMAT(M,2);
        ATTRIB(VARCOLOR);
        RLOUT(6,M);
        ATTRIB(TEXTCOLOR);
        TEXT(6,"m");
        end;

begin
BYTES:=TOTAL;
K:=BYTES/1024.0;
M:=K/1024.0;

SETWWPAUSE(3\6,23,73,23\,$0F02,false);
ATTRIB($1B);
if M<1.0 then
        begin
        if K<10.0 then
                [DESBYTES;TEXT(6," (");DESK;TEXT(6," or ");DESM;TEXT(6,")")]
                        \EXAMPLE:  "262 bytes (0.26k or 0.00m)"
        else
                [DESK;TEXT(6," (");DESBYTES;TEXT(6," or ");DESM;TEXT(6,")")];
                        \EXAMPLE:  "13.56k (13885 bytes or 0.01m)"
        end
else
        [DESM;TEXT(6," (");DESK;TEXT(6," or ");DESBYTES;TEXT(6,")")];
                        \EXAMPLE:  "1.56m (1597.44k or 1635778 bytes)"

TEXT(6," in ");
ATTRIB(VARCOLOR);
INTOUT(6,FILECOUNT);
ATTRIB(TEXTCOLOR);
TEXT(6," file");if FILECOUNT#1 then TEXT(6,"s");

TEXT(6," (");
ATTRIB(VARCOLOR);
TEMP:=DIRCOUNT;
if SUBDIR then TEMP:=TEMP-2;
INTOUT(6,TEMP);
ATTRIB(TEXTCOLOR);
TEXT(6," sub-director");
if TEMP=1 then TEXT(6,"y") else TEXT(6,"ies");
TEXT(6,")");
end;

proc DESATTRIB;
begin
ATTRIB($1A);
if READONLY then CHOUT(6,^R) else CHOUT(6,^ );
if HIDDEN then CHOUT(6,^H) else CHOUT(6,^ );
if SYSTEM then CHOUT(6,^S) else CHOUT(6,^ );
ATTRIB($17);
end;


proc DESSIZE;
begin
FORMAT(11,0);
RLOUT(6,SIZE);
end;

\proc DESFNAME(SEGMENT,OFFSET);
\int SEGMENT,OFFSET,DESC;
\begin
\I:=0;
\DESC:=0;
\loop
\        begin
\        CH:=PEEK(SEGMENT,OFFSET+I);
\        if CH=0 then quit;
\        if CH=^. then
\                begin
\                DESC:=I;
\                loop
\                        begin
\                        if DESC>7 then quit;
\                        DESC:=DESC+1;
\                        CHOUT(6,^ );
\                        end;
\                end;
\        CHOUT(6,CH);
\        I:=I+1;
\        if I>=12 then quit;
\        end;
\I:=I+DESC;
\if I <12 then for I:=I,11 do CHOUT(6,^ );     \\pad spaces
\end;

proc DESDNAME(SEGMENT,OFFSET);
int SEGMENT,OFFSET;
begin
I:=0;
loop
        begin
        CH:=PEEK(SEGMENT,OFFSET+I);
        if CH=0 then quit;
        CHOUT(6,CH);
        I:=I+1;
        if I>=12 then quit;
        end;
if I <12 then for I:=I,11 do CHOUT(6,^ );     \pad spaces
end;

proc DESTIME;
begin
TEMP:=HOUR;
if TEMP>12 then TEMP:=TEMP-12;
if TEMP<10 then CHOUT(6,^ );
INTOUT(6,TEMP);TEXT(6,":");                     \HOURS!
if MINUTE<10 then CHOUT(6,^0);
INTOUT(6,MINUTE);TEXT(6,".");                     \MINUTES!
if SECOND<10 then CHOUT(6,^0);
INTOUT(6,SECOND);                               \SECCONDS!
if HOUR>12 then TEXT(6,"p") else TEXT(6,"a");   \ am/pm
end;

proc DESDATE;
begin
if MONTH<10 then CHOUT(6,^ );
INTOUT(6,MONTH);CHOUT(6,^/);
if DAY<10 then CHOUT(6,^ );
INTOUT(6,DAY);CHOUT(6,^/);
INTOUT(6,YEAR);
end;


proc GETFINFO(FNO);
int FNO;
begin
GETATTRIB(FILES(0),FNO*21+20);
GETSIZE(FILES(0),FNO*21+16);
GETTIME(FILES(0),FNO*21+12);
GETDATE(FILES(0),FNO*21+14);
end;

proc GETDINFO(FNO);
int FNO;
begin
GETTIME(DIRS(0),FNO*16+12);
GETDATE(DIRS(0),FNO*16+14);
end;

proc DESFILES(FILENO);
int FILENO;
begin
GETFINFO(FILENO);
ATTRIB($17);
DESDNAME(FILES(0),FILENO*21);CHOUT(6,^ );
DESSIZE;CHOUT(6,^ );
DESATTRIB;CHOUT(6,^ );
DESTIME;CHOUT(6,^ );
DESDATE;
end;

proc DESDIRS(FILENO);
int FILENO;
begin
GETDINFO(FILENO);
ATTRIB($1E);
DESDNAME(DIRS(0),FILENO*16);
\CHOUT(0,^ );
\TEXT(6,"<DIRECTORY>     ");
\DESTIME;CHOUT(0,^ );
\DESDATE;
end;

proc FSCRN(FRSTFLE);
int FRSTFLE,FTEMP;
begin
ATTRIB($17);
\SETWWPAUSE(6,1,47,20,$FF00,true);
CURSOR(6,1);
if FRSTFLE>FILECOUNT then TEXT(0,"error IN FSCRN") else
[if FRSTFLE+FWINH>FILECOUNT-1 then FTEMP:=FILECOUNT-1 else FTEMP:=FRSTFLE+FWINH];
for I2:=FRSTFLE,FTEMP do [DESFILES(I2);\if I2<FTEMP then \CRLF(6)];
HILIGHT(6,1+CURFFW,53,1+CURFFW,$5B);
end;

proc DESDIR(AT);
char AT;      \AT=types of files to desplay (by attribute)
                        \bit #:0=normal, 1=headonly, 2=hidden, 3=system file
                        \#=$8 then VOLUME ID, #=$10 then DIRECTORY;

        proc DIRERROR;
        begin
        TEXT(6,"!!! ERROR READING DIRECTORY !!!");
        CRLFPAUSE(6);
        TEXT(6,"Error Code #");
        INTOUT(6,CPUREG(0));
        RET:=false
        end;

        proc FINDFIRST;
        begin
        CPUREG(0):=$4E00;
        CPUREG(2):=AT;
        CPUREG(3):=0;
        CPUREG(9):=FILETEXT(0);
        SOFTINT($21);
        if CPUREG(7) then
                begin
                if CPUREG(0)=18 then [TEXT(6,"No Files Found");RET:=false]
                        else DIRERROR;
                end;
        end;

        proc FINDNEXT;
        begin
        CPUREG(0):=$4F00;
        SOFTINT($21);
        if CPUREG(7) then [if CPUREG(0)=18 then [RET:=false] else DIRERROR];
        end;


        proc FCOUNT;
        begin
        if DIRECTORY then [if PSP(0,$80+$1E)=^. then SUBDIR:=true;DIRCOUNT:=DIRCOUNT+1]
        else FILECOUNT:=FILECOUNT+1;
        end;

        proc LOADDIR;

                proc LOADFILE;
                begin
                GETATTRIB(PSP(0),$80+$15);
                if DIRECTORY then
                        begin
                        for I:=0,11 do DIRS(0,DIRCOUNT*16+I):=PSP(0,$80+$1E+I);
                        for I:=0,1 do DIRS(0,DIRCOUNT*16+I+12):=PSP(0,$80+$16+I);
                        for I:=0,1 do DIRS(0,DIRCOUNT*16+I+14):=PSP(0,$80+$18+I);
                        end
                else
                        begin
                        for I:=0,11 do FILES(0,FILECOUNT*21+I):=PSP(0,$80+$1E+I);
                        for I:=0,1 do FILES(0,FILECOUNT*21+I+12):=PSP(0,$80+$16+I);
                        for I:=0,1 do FILES(0,FILECOUNT*21+I+14):=PSP(0,$80+$18+I);
                        for I:=0,3 do FILES(0,FILECOUNT*21+I+16):=PSP(0,$80+$1A+I);
                        FILES(0,FILECOUNT*21+20):=PSP(0,$80+$15);
                        GETSIZE(FILES(0),FILECOUNT*21+16);
                        TOTAL:=TOTAL+SIZE;\RLOUT(6,TOTAL);
                        end;
                end;

        begin
        DIRCOUNT:=0;
        FILECOUNT:=0;
        FINDFIRST;
        if RET then
                begin
                LOADFILE;
                FCOUNT;
                loop
                        begin
                        FINDNEXT;
                        if RET=false then quit;
                        LOADFILE;
\                        for I:=0,20 do CHOUT(6,FILES(FILECOUNT*21+I));
                        FCOUNT;
                        end;
                end;
        end;

proc SFILES(N);    \SCROLL FILE LIST BY "N" ENTRIES;
int N;
begin
TEMP:=TOPFFW;
if CURFFW+N<0 then
        begin
        if TOPFFW=0 then CURFFW:=0;
        if TOPFFW+N<0 then TOPFFW:=0 else TOPFFW:=TOPFFW+N;
        end                             \ALL ABOVE CHECKS
else if CURFFW+N>FWINH ! TOPFFW+CURFFW+N>=FILECOUNT then
        begin
        if TOPFFW=FILECOUNT-FWINH-1 then CURFFW:=FWINH;
        if FILECOUNT<=FWINH then [TOPFFW:=0;CURFFW:=FILECOUNT-1]
        else
        if TOPFFW+N+FWINH+1>FILECOUNT then TOPFFW:=FILECOUNT-FWINH-1
        else TOPFFW:=TOPFFW+N;
        end
else if N>0 & CURFFW+TOPFFW+1<FILECOUNT then CURFFW:=CURFFW+N
else if CURFFW>0 then CURFFW:=CURFFW+N;
end;

begin
SETWWPAUSE(1\6,1,47,20\,$FF00,false);
\TEXT(6,DIRSTRING);CRLFPAUSE(6);
RET:=true;
I:=0;
\CONVSTRING;
LOADDIR;
DIRSIZE;
SETWWPAUSE(2\55,1,13,20\,$FF00,false);
for I2:=0,DIRCOUNT-1 do [DESDIRS(I2);if I2<DIRCOUNT-1 then CRLFPAUSE(6)];

SETWWPAUSE(1\6,1,47,20\,$0101,false);
\for I2:=0,FILECOUNT-1 do [DESFILES(I2);if I2<FILECOUNT-1 then CRLFPAUSE(6)];
TOPFFW:=0;
CURFFW:=0;
FSCRN(TOPFFW);
HILIGHT(6,1+CURFFW,53,1+CURFFW,$5B);
CURSOR(6,1);
\EXITB:=false;
loop
        begin
        if CHKKEY then
                begin
                RET:=false;
                CH:=CHIN(1);
                if CH=0 then [TEMP2:=CURFFW;TEMP:=TOPFFW;CH:=CHIN(1);case CH of
                        71:     if TOPFFW>0 then [RET:=true;TOPFFW:=0];                     \HOME
                        79:     begin
                                TEMP:=TOPFFW;
                                if FILECOUNT<FWINH
                                then TOPFFW:=0
                                else TOPFFW:=FILECOUNT-FWINH-1;    \END
                                if TEMP#TOPFFW then RET:=true;
                                end;
                        72:     SFILES(-1);
                        80:     SFILES(1);
                        73:     SFILES(-FWINH-1);
                        81:     SFILES(FWINH+1)
                        else]
                else quit;
        if TEMP#TOPFFW then FSCRN(TOPFFW);
        if TEMP2#CURFFW\ ! TEMP#TOPFFW\ then
                begin
                HILIGHT(6,1+TEMP2,53,1+TEMP2,$17);
                \if TEMP2#CURFFW then \DESFILES(TOPFFW+TEMP2);
                HILIGHT(6,1+CURFFW,53,1+CURFFW,$5B);
                end;
        CURSOR(6,1+CURFFW);
               \ quit;
                end;

        end;
HILIGHT(6,1+CURFFW,53,1+CURFFW,$17);
\DESFILES(TOPFFW+CURFFW);
end;
