\DEPTCHG.XPL

code	ABS=0, RAN=1, REM=2, RES=3, SWAP=4, EXTEN=5,
	SHORT=6, CHIN=7, CHOUT=8, CRLF=9, INTIN=10, INTOUT=11,
	TEXT=12, OPENI=13, OPENO=14, CLOSED=15, ABORT=16,
	CURSOR=23, SOUND=39;
def TV=0, KB=0, FILE=2;
addr	PORT;
int	DOTTBL,	
	SCORE,
	HISCORE,
	HITS,	
	MISSES,	
	PASS,	
	LASTPASS,	
	SHIPX,		
	X, Y,	
	H, V,	
	CHARGE,	
	XPASS,	
	OLDBUT,	
	SONAR;	

'PROC'	POINT(X,Y,C);
'INT'	X,Y,C,XR,YR;
'BEGIN'
X:=X/2; XR:=REM(0);
Y:=Y/3; YR:=REM(0);
CURSOR(X,Y);
CHOUT(TV,if C=0 then $80 else DOTTBL(XR,YR));
'END';

proc	SUB;
int	I,J;
begin
for I:=1,3 do X(I):=X(I)+1;
for I:=0,3 do
	begin		
	if X(I)>54 then [CURSOR(X(I),Y(I));
		TEXT(TV,"        ");
		X(I):=0];
	CURSOR(X(I),Y(I));
	CHOUT(TV,$20);
	CHOUT(TV,$8C); CHOUT(TV,$8C); CHOUT(TV,$8C);
	CHOUT(TV,$BC); CHOUT(TV,$BE); CHOUT(TV,$BC);
	CHOUT(TV,$8C);
	end;
end;

proc	SHIP;	
int	I;
begin
SHIPX:=SHIPX-1;
if SHIPX=0 then	
	[CURSOR(0,0); for I:=1,9 do CHOUT(TV,$B0);
	SHIPX:=54;
	PASS:=PASS+1;
	CURSOR(18,15); INTOUT(TV,PASS+1)];
CURSOR(SHIPX,0);
CHOUT(TV,$9C); CHOUT(TV,$BC); CHOUT(TV,$BF);CHOUT(TV,$BC);
CHOUT(TV,$BF); CHOUT(TV,$BC); CHOUT(TV,$AC); CHOUT(TV,$B0); 
end;


proc	HITSUB;
int	I, J;
begin	
for J:=0,3 do if (V(CHARGE)-2)/3 = Y(J) then
	if H(CHARGE)/2 >= X(J)+1 & H(CHARGE)/2 <= X(J)+8 then
	[POINT(H(CHARGE),V(CHARGE),0);
	HITS:=HITS+1;
	CURSOR(29,15); INTOUT(TV,HITS);
	SCORE:=SCORE+Y(J)*7;
	CURSOR(7,15); INTOUT(TV,SCORE);
	V(CHARGE):=0;
	CURSOR(X(J)+1,Y(J)-1);	
	CHOUT(TV,$20); for I:=$92,$98 do CHOUT(TV,I);
	CURSOR(X(J)+1,Y(J));
	for I:=$99,$A0 do CHOUT(TV,I);
	CURSOR(X(J)+1,Y(J)+1);
	for I:=$A1,$A8 do CHOUT(TV,I);
	for I:=0,70 do SOUND(127-I/2,1,RAN(450-I));
	CURSOR(X(J)+1,Y(J)-1); TEXT(TV,"        ");
	CURSOR(X(J)+1,Y(J)); TEXT(TV,"        ");
	CURSOR(X(J)+1,Y(J)+1); TEXT(TV,"        ");
	X(J):=RAN(54); Y(J):=RAN(11)+2];

if SCORE>=600 & XPASS=1 then
	[XPASS:=2;
	LASTPASS:=LASTPASS+1;
	CURSOR(24,14); TEXT(TV," ONE EXTRA PASS ")];
if SCORE>=900 & XPASS=2 then
	[XPASS:=3;
	LASTPASS:=LASTPASS+1;
	CURSOR(24,14); TEXT(TV," TWO EXTRA PASSES ")];
end;


proc	DCHARGE;	
int	I,BUT;
begin
for CHARGE:=0,3 do if V(CHARGE)#0 then
	begin
	POINT(H(CHARGE),V(CHARGE),0);
	V(CHARGE):=V(CHARGE)+2;
	POINT(H(CHARGE),V(CHARGE),1);
	HITSUB;
	if V(CHARGE)>=41 then	
		[POINT(H(CHARGE),V(CHARGE),0);
		V(CHARGE):=0;
		MISSES:=MISSES+1;
		CURSOR(43,15); INTOUT(TV,MISSES)];
	end;
BUT:=(PORT(0) & $04);
if BUT & (not OLDBUT) then
	for I:=0,3 do if V(I)=0 then
	[H(I):=(SHIPX+3)*2; V(I):=5; I:=9999];
OLDBUT:=BUT;
end;


proc	ANIMATION;
int	I;
loop begin
SHIP;
if PASS>=LASTPASS then quit;
SUB;
DCHARGE;
if SONAR =6 then SOUND(32,70,94);
if SONAR =15 then
	[for I:=1,8 do SOUND (RAN(5)*5,30,94);
	SONAR:=0]
else	[for I:=1,8 do SOUND(RAN(5)*0,30,94);	
	SONAR:=SONAR+1];
end;


proc	SETUP;
int	I;
begin
PASS:=0; MISSES:=0; HITS:=0; SCORE:=0;
LASTPASS:=3; XPASS:=1; SHIPX:=54; SONAR:=0;
OLDBUT:=0;
CHOUT(TV,$0C);		
for I:=0,63 do CHOUT(TV,$B0);
CURSOR(0,14);
for I:=0,63 do CHOUT(TV,$A0);
TEXT(TV,
"SCORE:      PASS:      HITS:       MISSES:     HIGH SCORE:");


CURSOR(59,15); INTOUT(TV,HISCORE);
CURSOR(18,15); INTOUT(TV,PASS+1);

for I:=0,3 do [X(I):=RAN(54); Y(I):=RAN(11)+2];
for I:=0,3 do V(I):=0;		
end;


pro	INSTRUCTIONS;
int	CH;
begin
CURSOR(0,0);
for CH:=0,7 do CHOUT(TV,$0D);
CURSOR(0,3);
TEXT(TV,"               >>>  DEPTH CHARGE  <<<"); CRLF(TV);
CRLF(TV); CRLF(TV);
TEXT(TV,"               Do you want instructions ? ");
OPENI(KB);
if (CHIN(KB)! $20) #^y then return;
CRLF(TV); CRLF(TV);
TEXT(TV,
"Drop depth charges from your ship at the top of the screen by"
); CRLF(TV);
TEXT(TV,
"pressing a button on bit one of port FE03. Three passes of your");
CRLF(TV);
TEXT(TV,
"ship per game. Score over 600 and get one extra pass. Score");
 CRLF(TV);
TEXT(TV,
"over 900 and get another extra pass. The deeper the sub the");
 CRLF(TV);
TEXT(TV,"more it scores."); CRLF(TV);
 CRLF(TV); CRLF(TV);
TEXT(TV,"Hit return to start.                                  ");
OPENI(KB); CH:=CHIN(KB);
end;
proc	GAME;
begin
INSTRUCTIONS;
SETUP;
ANIMATION;
if SCORE>HISCORE then
	[HISCORE:=SCORE;
	CURSOR(24,14);
TEXT(TV," NEW HIGH SCORE  ")];
end;


begin	
PORT:=$FE03;

X:=RES(8); Y:=RES(8); H:=RES(8); V:=RES(8);
DOTTBL:=RES(2); for X:=0,1 do DOTTBL(X):=RES(3);
DOTTBL(0,0):=$82; DOTTBL(1,0):=$81;
DOTTBL(0,1):=$88; DOTTBL(1,1):=$84;
DOTTBL(0,2):=$A0; DOTTBL(1,2):=$90;

HISCORE:=0;
CHOUT(TV,$0C);	
loop GAME;
end;
