\DSCREEN.XPL
\PROGRAM TO DUMP HIRES SCREEN TO OKIDATA PRINTER

code
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;

code real	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;



address	\SOFT SWITCHES

	TXTOFF,TXTON,MIXOFF,MIXON,
	PG2OFF,PG2ON,HIROFF,HIRON;

address
	BASE;


integer
	ROW,
	SUBROW;


define
	LF=$0A,
	CR=$0D,
	FF=$0C,
	ESC=$1B;


integer
	LINLEN,
	GMODE,
	X;




procedure PRIOUT(B);
integer B;
begin
CHOUT(2,B);
end;




procedure SELPAG;
integer C;
begin

TXTOFF(0):=0;MIXOFF(0):=0;
HIRON(0):=0;PG2OFF(0):=0;

BASE:=$2000;
loop
	begin

	C:=CHIN(1);if C=ESC then quit;
	PG2ON(0):=0;
	BASE:=$4000;

	C:=CHIN(1);if C=ESC then quit;
	PG2OFF(0):=0;
	BASE:=$2000;
	end;

SETTXT;
CHOUT(0,FF);
TEXT(0,"PAGE ");
INTOUT(0,if BASE=$2000 then 1 else 2);
TEXT(0," SELECTED");CRLF(0);

TEXT(0,"

*** MODES

1) SINGLE DENSITY
2) DOUBLE DENSITY, HALF SPEED
3) DOUBLE DENSITY
4) QUAD DENSITY

SELECT ONE: ");

C:=INTIN(0);
case C of
	1: GMODE:=^K;
	2: GMODE:=^L;
	3: GMODE:=^Y;
	4: GMODE:=^Z
else;

LINLEN:=280;
end;



procedure BYTDMP(BASE);
address BASE;
integer B0,B1,B2,B3,B4,B5,B6,B7;
integer BIT,MASK,BYTE;
begin

B0:=BASE(SUBROW(7));B1:=BASE(SUBROW(6));
B2:=BASE(SUBROW(5));B3:=BASE(SUBROW(4));
B4:=BASE(SUBROW(3));B5:=BASE(SUBROW(2));
B6:=BASE(SUBROW(1));B7:=BASE(SUBROW(0));


MASK:=[$1,$2,$4,$8,$10,$20,$40,$80];

for BIT:=0,6 do
	begin
	BYTE:=0;
	if (B0 & MASK(BIT))#0 then BYTE:=BYTE ! $1;
	if (B1 & MASK(BIT))#0 then BYTE:=BYTE ! $2;
	if (B2 & MASK(BIT))#0 then BYTE:=BYTE ! $4;
	if (B3 & MASK(BIT))#0 then BYTE:=BYTE ! $8;
	if (B4 & MASK(BIT))#0 then BYTE:=BYTE ! $10;
	if (B5 & MASK(BIT))#0 then BYTE:=BYTE ! $20;
	if (B6 & MASK(BIT))#0 then BYTE:=BYTE ! $40;
	if (B7 & MASK(BIT))#0 then BYTE:=BYTE ! $80;
	PRIOUT(BYTE);
	end;
end;




procedure DUMP;
integer C,R;
begin
\SELECT RIGHT LINE SPACING
PRIOUT(ESC);PRIOUT(^A);PRIOUT(8);
PRIOUT(ESC);PRIOUT(^2);

for R:=0,23 do
	begin
	\SELECT MODE
	PRIOUT(ESC);
	PRIOUT(GMODE);

	\SET LINE LENGTH
	PRIOUT($FF&LINLEN);
	PRIOUT($FF&SWAP(LINLEN));
	for C:=0,39 do
	BYTDMP(BASE+ROW(R)+C);

	PRIOUT(CR);PRIOUT(LF);
	end;
 PRIOUT(FF);
end;
	


begin
TXTOFF:=$C050;TXTON:=$C051;
MIXOFF:=$C052;MIXON:=$C053;
PG2OFF:=$C054;PG2ON:=$C055;
HIROFF:=$C056;HIRON:=$C057;

ROW:=[
$000,$080,$100,$180,$200,$280,$300,$380,
$028,$0A8,$128,$1A8,$228,$2A8,$328,$3A8,
$050,$0D0,$150,$1D0,$250,$2D0,$350,$3D0];

SUBROW:=[0,$400,$800,$C00,$1000,$1400,$1800,$1C00];


OPENO(2);

loop
	begin
	SELPAG;
	DUMP;
	end;

end;
