\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,       POINT=41,       LINE=42,        MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
ATTRIB=69,      SETWIND=70,     RAWTEXT=71,     HILIGHT=72,
MALLOC=73;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,	MOD=58,		LOG=59,		COS=60,
TAN=61,         ASIN=62,        ACOS=63;

int GRAPHIX             \GRAPHIX WILL EQUAL EITHER: 1(CGA) 2(EGA) OR 3(VGA)
X,Y,                    \x and y coordinates on the board
                                \will always be used as accual
                                \coordinates, no floteing coord.
\RX,RY,                 used for passing the x and y variabls between
                                \procs.
EDITLVL,                \DETRMINS THE EDITING LEVEL;
TEMP,TEMP1,TEMP2;       \temporary variables.
char HCOL,BOARD,RAIN;    \COLOR FOR HIGTH(CGA,EGA,VGA);the main playing board
int MY,MX;              \MOVEMENT Y,MOVEMENT X
int OFFSET,ACTV,INACTV,CH,AVTRUE,DCOUNT,CSVWT,CPUREG,RETMODE,WHI;               \WHI=# 'O DROPS PER 200M (for rain)
int COUNT;              \global variable for counting 'FOR' 'DO' loops
int HAND;               \FILE HANDLE FOR LOADING AND SAVING THE LANDSCAPE
char CRSR;
segment char VIDEO;
segment char PALETTE;
segment char VID2;
int MOUSEX,MOUSEY,SSX,SSY,LFTFST,RGTFST,BBX,BBY,LMX,LMY,SENX,SENY,SENM;
int MBLEFT,MBRIGHT,MBMIDDLE;

proc SETPAL;
begin
CPUREG(0):=$1012;
CPUREG(1):=0;
CPUREG(2):=256;
CPUREG(11):=PALETTE(0);
CPUREG(3):=0;
SOFTINT($10);
end;

proc LPAL;
int I,LX,I2,RGBA,CREG;
begin
RGBA:=RESERVE(24);
HAND:=FOPEN("PALSAVE.SAV",0);FSET(HAND,^I);OPENI(3);
for I:=0,767 do PALETTE(0,I):=CHIN(3);
CLOSE(3);FCLOSE(HAND);
SETPAL;
end;

proc DPOINT(DX,DY,DC);
int DX,DY,DC;
if DX>=0 & DY>=0 & DX<SSX & DY<SSY then [MOVE(DX,DY);VIDEO(0,DY*320+DX):=DC];

proc DRWBOX(BX,BY,EX,EY,COL);
int BX,BY,EX,EY,COL,DCX,DCY;
begin
for DCX:=BX,EX do for DCY:=BY,EY do DPOINT(DCX,DCY,COL);
end;

proc REFRESH(ON);
int ON;
if ON=^Y ! ON=^R then [SETPAL;BLIT(VID2(0),0,$A000,0,64*1000)]
else BLIT($A000,0,VID2(0),0,64*1000);

\MOUSE STUFF

proc MC(ON);                    \MOUSE CURSOR ON OFF
int ON;
begin
if ON then TEMP:=1 else TEMP:=2;
CPUREG(0):=TEMP;          \TURN ON/OFF MOUSE CURSOR;
SOFTINT($33);
end;

proc SETMSENSITIVITY(NSX,NSY,NSM);           \Set Mouse Sensitivity
int NSX,NSY,NSM;
begin
CPUREG(0):=$1A;
CPUREG(1):=NSX;
CPUREG(2):=NSY;
CPUREG(3):=NSM;
SOFTINT($33);
end;

proc RESMSENSITIVITY;           \Restor Mouse Sensitivity
begin
CPUREG(0):=$1A;
CPUREG(1):=SENX;
CPUREG(2):=SENY;
CPUREG(3):=SENM;
SOFTINT($33);
\CPUREG(0):=$21;
\SOFTINT($33);
end;

proc MOUSEBOUNDRY(BX,BY,EX,EY);
int BX,BY,EX,EY;
begin
CPUREG(0):=$7;     CPUREG(2):=BX;      CPUREG(3):=EX;   SOFTINT($33);
CPUREG(0):=$8;     CPUREG(2):=BY;      CPUREG(3):=EY;   SOFTINT($33);
end;

proc SMPOS;
begin
CPUREG(0):=4;
CPUREG(2):=MOUSEX;
CPUREG(3):=MOUSEY;
SOFTINT($33);
end;

proc SETVGA;
begin
SSX:=320;
SSY:=200;
SETVID($13);
\MC(true);
\MOUSEBOUNDRY(0,0,
\Set Max/Min positions for Horizontal and Vertical
end;

proc GETMINFO;
begin
CPUREG(0):=$3;
SOFTINT($33);
MOUSEX:=CPUREG(2);
MOUSEY:=CPUREG(3);
TEMP:=CPUREG(1);
case TEMP of
0:      [MBLEFT:=false;MBRIGHT:=false];
1:      [MBLEFT:=true;MBRIGHT:=false];
2:      [MBLEFT:=false;MBRIGHT:=true];
3:      [MBLEFT:=true;MBRIGHT:=true]
        else;
\CURSOR(0,0);
\INTOUT(0,CPUREG(1));
end;

proc WAITMOUSE;
loop
        begin
        GETMINFO;
        if MBLEFT=false & MBRIGHT=false then quit;
        end;

proc EDITMOUSESETUP;
int MTEMP;
begin
MTEMP:=64/EDITLVL;
MOUSEBOUNDRY(0,0,64*2,64);
\2*MTEMP,MTEMP);
MOUSEX:=(MX\/EDITLVL\)*2;
MOUSEY:=MY\/EDITLVL\;
SMPOS;
GETMINFO;
LMX:=MOUSEX;
LMY:=MOUSEY;
MTEMP:=25;
\if EDITLVL<8 then MTEMP:=MTEMP/2;
\if EDITLVL>16 then MTEMP:=MTEMP+2;
SETMSENSITIVITY(MTEMP,MTEMP,MTEMP);
end;


proc GETDEFAULTS;
begin
\----------------------------------Get Mouse Sensitivity...
CPUREG(0):=$1B;
SOFTINT($33);
SENX:=CPUREG(1);
SENY:=CPUREG(2);
SENM:=CPUREG(3);
\TEXT(0,"MOUSE SENSITIVITY: ");
\INTOUT(0,SENX);TEXT(0,", ");
\INTOUT(0,SENY);TEXT(0,", ");
\INTOUT(0,SENM);TEXT(0,".");
\CH:=CHIN(1);

\----------------------------Get Video Mode
CPUREG(0):=$F00;
SOFTINT($10);
RETMODE:=CPUREG(0)&$FF;
end;

proc SETDEFAULTS;
begin
\----------------------------Set Video Mode
SETVID(RETMODE);

\----------------------------Reset Mouse Sensitivity
CPUREG(0):=$1A;
CPUREG(1):=SENX;
CPUREG(2):=SENY;
CPUREG(3):=SENM;
SOFTINT($33);
end;


\       *** GRAPHIX PROCEEDURES

proc ELINE(LINX,LINY,LINX2,LINY2,LINCOL);       \draws a line without having the first draw a dot (it actually just takes care of that part for you)
int LINX,LINY,LINX2,LINY2,LINCOL;
begin
POINT(LINX,LINY,LINCOL);LINE(LINX2,LINY2,LINCOL);
POINT(LINX2,LINY2,LINCOL);
end;

proc DRWBLK(DRWX,DRWY);
int DRWX,DRWY,DRWCOLOR;
begin
if RAIN(DRWX+65*DRWY)-\/\WHI*2>0 then if 47-RAIN(DRWX+65*DRWY)/WHI<0 then DRWCOLOR:=HCOL(GRAPHIX) else
        DRWCOLOR:=HCOL((47-RAIN(DRWX+65*DRWY)/WHI)+GRAPHIX) else

DRWCOLOR:=HCOL(BOARD(DRWX+65*DRWY)+GRAPHIX);
if DRWX>=0 & DRWX<=64 & DRWY>=0 & DRWY<=64 then
        begin
        DRWX:=DRWX*4;DRWY:=DRWY*3;
        DRWBOX(DRWX+OFFSET(0,0)+2,DRWY+OFFSET(0,1)+2,DRWX+OFFSET(0,0)+5,DRWY+OFFSET(0,1)+4,DRWCOLOR);
\        for COUNT:=0,2 do
\        ELINE(DRWX+OFFSET(0,0)+2,DRWY+COUNT+OFFSET(0,1)+2, DRWX+OFFSET(0,0)+5, DRWY+COUNT+OFFSET(0,1)+2, DRWCOLOR);
        end;
end;

proc DRWRAIN(DRWX,DRWY);
int DRWX,DRWY,DRWCOLOR;
begin
DRWCOLOR:=HCOL((50-RAIN(DRWX+65*DRWY)/WHI)*GRAPHIX);
DRWX:=DRWX*4;DRWY:=DRWY*4;
if DRWX>=0 & DRWX<=256 & DRWY>=0 & DRWY<=256 then
for COUNT:=0,3 do
ELINE(DRWX+OFFSET(0,0)+2,DRWY+COUNT+OFFSET(0,1)+2, DRWX+OFFSET(0,0)+5, DRWY+COUNT+OFFSET(0,1)+2, DRWCOLOR);
end;

proc DBOX(BBX,BBY,EBX,EBY,COL);
int BBX,BBY,EBX,EBY,COL;
begin
ELINE(BBX,BBY,EBX,BBY,COL);
ELINE(EBX,BBY,EBX,EBY,COL);
ELINE(EBX,EBY,BBX,EBY,COL);
ELINE(BBX,EBY,BBX,BBY,COL);
end;

proc ABOX(WINDOW,ACOL);
int WINDOW,ACOL;
begin
if WINDOW=0 then DBOX(OFFSET(0,0),OFFSET(0,1),OFFSET(0,0)+263,OFFSET(0,1)+198,ACOL);
if WINDOW=1 then DBOX(OFFSET(1,0),OFFSET(1,1),OFFSET(1,0)+40,OFFSET(1,1)+103,ACOL);
if WINDOW=2 then DBOX(OFFSET(2,0),OFFSET(2,1),OFFSET(2,0)+132,OFFSET(2,1)+152,ACOL);
if WINDOW=3 then DBOX(OFFSET(3,0),OFFSET(3,1),OFFSET(3,0)+263,OFFSET(3,1)+103,ACOL);
end;

\       *** END GRAPHIX PROCEEDURES

proc DRAWBOARD;
for X:=0,64 do for Y:=0,64 do DRWBLK(X,Y);

proc ASSIGN;
begin
for X:=0,64 do for Y:=0,64 do BOARD(X+65*(Y)):=32;
\for TEMP2:=0,259 do ELINE(OFFSET(0,0)+2+TEMP2,
\OFFSET(0,1)+2,OFFSET(0,0)+2+TEMP2,OFFSET(0,1)+261,HCOL(32+GRAPHIX));
DRAWBOARD;
end;














proc UPDATE;
int UX,UY,LMX,LMY;
char AVQ,LCLBOARD;

proc AVRG(AVX,AVY,AVEDLV);
int AVX,AVY,AVEDLV,AVCX,AVCY,MASTER,
AVT1,AVT2,AVT3;      \local temps

        proc AV2(NUM1,NUM2);
        int NUM1,NUM2,RET;
        begin
        if NUM1>NUM2 then RET:=RAN(NUM1-NUM2)+NUM2
                else if NUM2>NUM1 then RET:=RAN(NUM2-NUM1)+NUM1
        else
        if NUM1=NUM2 then RET:=NUM1;
\        RET:=(NUM1+NUM2)/2;
        return(RET);
        end;

        proc BAV4(P1X,P1Y,P2X,P2Y,P3X,P3Y,P4X,P4Y);
        int P1X,P1Y,P2X,P2Y,P3X,P3Y,P4X,P4Y,FPX,FPY;
        int P1TMP,P2TMP,P3TMP,P4TMP;
        begin
\        if P1X>=0 & P1X<=64 & P1Y>=0 & P1Y<=64 then P1TMP:=true else P1TMP:=false;
\        if P2X>=0 & P2X<=64 & P2Y>=0 & P2Y<=64 then P2TMP:=true else P2TMP:=false;
\        if P3X>=0 & P3X<=64 & P3Y>=0 & P3Y<=64 then P3TMP:=true else P3TMP:=false;
\        if P4X>=0 & P4X<=64 & P4Y>=0 & P4Y<=64 then P4TMP:=true else P4TMP:=false;
\        if P1TMP=false & P2TMP=false & P3TMP=false & P4TMP=false then
\        else
\                begin
                FPX:=(P1X+P2X+P3X+P4X)/4;
\                if FPX<0 then FPX:=0;if FPX>64 then FPX:=64;
                FPY:=(P1Y+P2Y+P3Y+P4Y)/4;
\                if FPY<0 then FPY:=0;if FPY>64 then FPY:=64;

\                if P1X<0 then P1X:=0;if P1X>64 then P1X:=64;
\                if P1Y<0 then P1Y:=0;if P1Y>64 then P1Y:=64;
\                if P2X<0 then P2X:=0;if P2X>64 then P2X:=64;
\                if P2Y<0 then P2Y:=0;if P2Y>64 then P2Y:=64;
\                if P3X<0 then P3X:=0;if P3X>64 then P3X:=64;
\                if P3Y<0 then P3Y:=0;if P3Y>64 then P3Y:=64;
\                if P4X<0 then P4X:=0;if P2X>64 then P4X:=64;
\                if P4Y<0 then P4Y:=0;if P2Y>64 then P4Y:=64;

\                if FPX>=0 & FPY>=0 & FPX<=64 & FPY<=64 then
                        if AVQ(FPX+(EDITLVL*2+1)*FPY)=false then
                        [LCLBOARD(FPX+(EDITLVL*2+1)*FPY):=
(LCLBOARD(P1X+(EDITLVL*2+1)*P1Y)+LCLBOARD(P2X+(EDITLVL*2+1)*P2Y)+LCLBOARD(P3X+(EDITLVL*2+1)*P3Y)+LCLBOARD(P4X+(EDITLVL*2+1)*P4Y))/4;
                AVQ(FPX+(EDITLVL*2+1)*FPY):=true];
\                end;
        end;

        proc BAV(P1X,P1Y,P2X,P2Y);
        int P1X,P1Y,P2X,P2Y,FPX,FPY,P1TMP,P2TMP;
        begin
\        if P1X>=0 & P1X<=64 & P1Y>=0 & P1Y<=64 then P1TMP:=true else P1TMP:=false;
\        if P2X>=0 & P2X<=64 & P2Y>=0 & P2Y<=64 then P2TMP:=true else P2TMP:=false;
\        if P1TMP=false & P2TMP=false then
\        else
\                begin
                FPX:=(P1X+P2X)/2;
\                if FPX<0 then FPX:=0;if FPX>64 then FPX:=64;
                FPY:=(P1Y+P2Y)/2;
\                if FPY<0 then FPY:=0;if FPY>64 then FPY:=64;

\                if P1X<0 then P1X:=0;if P1X>64 then P1X:=64;
\                if P1Y<0 then P1Y:=0;if P1Y>64 then P1Y:=64;
\                if P2X<0 then P2X:=0;if P2X>64 then P2X:=64;
\                if P2Y<0 then P2Y:=0;if P2Y>64 then P2Y:=64;
\                if FPX>=0 & FPY>=0 & FPX<=64 & FPY<=64 then
                        [if AVQ(FPX+(EDITLVL*2+1)*FPY)=false then
                        [LCLBOARD(FPX+(EDITLVL*2+1)*FPY):=AV2(LCLBOARD(P1X+(EDITLVL*2+1)*P1Y),LCLBOARD(P2X+(EDITLVL*2+1)*P2Y));
                        AVQ(FPX+(EDITLVL*2+1)*FPY):=true]];
\                end;
        end;

        proc HVAV;
\        int HX,HY;
        begin
        BAV(AVX-AVT2,AVY-AVT2,AVX-AVT2,AVY+AVT2);
        BAV(AVX+AVT2,AVY-AVT2,AVX+AVT2,AVY+AVT2);
        BAV(AVX-AVT2,AVY-AVT2,AVX+AVT2,AVY-AVT2);
        BAV(AVX-AVT2,AVY+AVT2,AVX+AVT2,AVY+AVT2);
\        if AVQ(AVT3-AVT2)=false    then [LCLBOARD(AVT3-AVT2):=AV2(LCLBOARD(AVT3-AVT2-AVT2*(EDITLVL+1)),LCLBOARD(AVT3-AVT2+AVT2*(EDITLVL+1)));    AVQ(AVT3-AVT2):=true];
\        if AVQ(AVT3-AVT2*(EDITLVL+1))=false then [LCLBOARD(AVT3-AVT2*(EDITLVL+1)):=AV2(LCLBOARD(AVT3-AVT2-AVT2*(EDITLVL+1)),LCLBOARD(AVT3+AVT2-AVT2*(EDITLVL+1))); AVQ(AVT3-AVT2*(EDITLVL+1)):=true];
\        if AVQ(AVT3+AVT2)=false    then [LCLBOARD(AVT3+AVT2):=AV2(LCLBOARD(AVT3+AVT2-AVT2*(EDITLVL+1)),LCLBOARD(AVT3+AVT2+AVT2*(EDITLVL+1)));    AVQ(AVT3+AVT2):=true];
\        if AVQ(AVT3+AVT2*(EDITLVL+1))=false then [LCLBOARD(AVT3+AVT2*(EDITLVL+1)):=AV2(LCLBOARD(AVT3-AVT2+AVT2*(EDITLVL+1)),LCLBOARD(AVT3+AVT2+AVT2*(EDITLVL+1))); AVQ(AVT3+AVT2*(EDITLVL+1)):=true];
        end;

        proc PREAV(INPUT,INPUT2);
        char INPUT,INPUT2;
        begin
        AVT1:=AVT3+INPUT2*AVT2;
        if AVQ(AVT1)=false then
                begin
                LCLBOARD(AVT1):=AV2(LCLBOARD(AVT1-AVT2*INPUT),LCLBOARD(AVT1+AVT2*INPUT));
                AVQ(AVT1):=true;
                end;
        end;

begin
MASTER:=false;
AVT2:=AVEDLV/2;
MASTER:=true;
\if AVTRUE then if AVX-AVT2>=0 & AVX+AVT2<=64 & AVY-AVT2>=0 & AVY+AVT2<=64 then
\        MASTER:=true else MASTER:=false;
                                \AVTRUE is an optimizing feature.

if MASTER then
        begin
        AVT3:=AVX+(EDITLVL*2+1)*AVY;
        HVAV;
        BAV4(AVX,AVY+AVT2,AVX,AVY-AVT2,AVX+AVT2,AVY,AVX-AVT2,AVY);
        AVTRUE:=false;

        if AVEDLV>2 then for AVCY:=0,1 do for AVCX:=0,1 do AVRG(AVX-(AVEDLV/4)+(AVCX*AVT2),AVY-(AVEDLV/4)+(AVCY*AVT2),AVT2);
        end;
end;

        proc CLRAVQ;
        int QTMP,QTMP2;

                proc INSIDE\(TF)\;
\                int TF;
                begin
                if QTMP=0 ! QTMP=EDITLVL*2 ! QTMP2=0 ! QTMP2=EDITLVL*2 then return(true)
                else return(false);
\                if QTMP2>=0 & QTMP2<=64 then AVQ(QTMP+(65*QTMP2)):=TF;
                end;

        begin
        for QTMP:=0,EDITLVL*2 do
        for QTMP2:=0,EDITLVL*2 do
                begin
                AVQ(QTMP+QTMP2*(EDITLVL*2+1)):=INSIDE;
                end;

\        for QTMP:=MX-EDITLVL,MX+EDITLVL do for QTMP2:=MY-EDITLVL,MY+EDITLVL do
\                begin
\                if QTMP=MX-EDITLVL ! QTMP2=MY-EDITLVL ! QTMP=MX+EDITLVL ! QTMP2=MY+EDITLVL then INSIDE(true) else
\                INSIDE(false);
\                end;
        end;

        proc COPYBOARD;
        int CTEMP,BX,BY;
        begin
        for LMY:=0,EDITLVL*2 do
        for LMX:=0,EDITLVL*2 do
                begin
                BX:=MX+LMX-EDITLVL;
                BY:=MY+LMY-EDITLVL;
                if BX<0 then BX:=0;if BX>64 then BX:=64;
                if BY<0 then BY:=0;if BY>64 then BY:=64;
                LCLBOARD(LMX+LMY*(EDITLVL*2+1)):=BOARD(BX+BY*65);
                end;
        end;

proc COPYBACK;
begin
for LMY:=0,EDITLVL*2 do
for LMX:=0,EDITLVL*2 do
        begin
        if
        MX+LMX-EDITLVL>=0 & MX+LMX-EDITLVL<=64 &
        MY+LMY-EDITLVL>=0 & MY+LMY-EDITLVL<=64 then
        BOARD(MX+LMX-EDITLVL+(MY+LMY-EDITLVL)*65):=LCLBOARD(LMX+LMY*(EDITLVL*2+1));
        end;
end;

begin
CURSOR(OFFSET(4,0),OFFSET(4,1));TEXT(0,"Avrg'n ");
AVQ:=RESERVE((EDITLVL*2+1)*(EDITLVL*2+1));
LCLBOARD:=RESERVE((EDITLVL*2+1)*(EDITLVL*2+1));
CURSOR(0,0);
\TEXT(0,"PREP: COPYBOARD");
COPYBOARD;

CURSOR(0,0);
\TEXT(0,"DONE: COPYBOARD, PREP: CLRAVQ");
CLRAVQ;

CURSOR(0,0);
\TEXT(0,"DONE: CLRAVQ, PREP: AVERAGING!!!!!!!!!!!!!!!!!!");
LMX:=EDITLVL;
LMY:=EDITLVL;
for UY:=0,1 do for UX:=0,1 do
        begin
        AVTRUE:=true;
        AVRG(LMY-(EDITLVL/2)+(UX*EDITLVL),LMY-(EDITLVL/2)+(UY*EDITLVL),EDITLVL);
        end;
COPYBACK;
for UX:=MX-EDITLVL,MX+EDITLVL do for UY:=MY-EDITLVL,MY+EDITLVL do
        DRWBLK(UX,UY);

CURSOR(OFFSET(4,0),OFFSET(4,1));TEXT(0,"Editing");
end;















proc AH(AMT);                           \AH=Adjust Highth
int AMT;
begin                                           \AH main
if BOARD(MX+65*(MY))+AMT>99 then BOARD(MX+65*(MY)):=99
        else if BOARD(MX+65*(MY))+AMT<0 then BOARD(MX+65*(MY)):=0
        else BOARD(MX+65*(MY)):=BOARD(MX+65*(MY))+AMT;
UPDATE;
end;

proc C(ON);
int ON;

        proc DRWC;
        int BCX,BCY,ECX,ECY;
        begin
        if MX=0 then BCX:=OFFSET(0,0)+4 else BCX:=MX*4+OFFSET(0,0)-1;
        if MX=64 then ECX:=OFFSET(0,0)+260 else ECX:=MX*4+OFFSET(0,0)+7;
        BCY:=OFFSET(0,1)+3+MY*3;
        ELINE(BCX,BCY,ECX,BCY,CRSR);
\        ELINE(BCX,BCY+1,ECX,BCY+1,CRSR);
        if MY=0 then BCY:=OFFSET(0,1)+4 else BCY:=MY*3+OFFSET(0,1)-1;
        if MY=64 then ECY:=OFFSET(0,1)+196 else ECY:=MY*3+OFFSET(0,1)+7;
        BCX:=OFFSET(0,0)+3+MX*4;
        ELINE(BCX,BCY,BCX,ECY,CRSR);
\        ELINE(BCX+1,BCY,BCX+1,ECY,CRSR);
        end;

begin
if ON=^N then
        begin
        DRWBLK(MX,MY);
        DRWBLK(MX-1,MY);
        DRWBLK(MX,MY-1);
        DRWBLK(MX,MY+1);
        DRWBLK(MX+1,MY);
        DRWBLK(MX-2,MY);
        DRWBLK(MX,MY-2);
        DRWBLK(MX,MY+2);
        DRWBLK(MX+2,MY);
ELINE(OFFSET(1,0)+8,OFFSET(1,1)+101-BOARD(MX+65*(MY)),OFFSET(1,0)+32,OFFSET(1,1)+101-BOARD(MX+65*(MY)),0);
ELINE(OFFSET(1,0)+8,OFFSET(1,1)+100-BOARD(MX+65*(MY)),OFFSET(1,0)+32,OFFSET(1,1)+100-BOARD(MX+65*(MY)),0);
ELINE(OFFSET(1,0)+8,OFFSET(1,1)+102-BOARD(MX+65*(MY)),OFFSET(1,0)+32,OFFSET(1,1)+102-BOARD(MX+65*(MY)),0);
        end
else
        begin
        DRWC;
if GRAPHIX=0 then ELINE(OFFSET(1,0)+5,OFFSET(1,1)+101-BOARD(MX+65*(MY)),OFFSET(1,0)+15,OFFSET(1,1)+101-BOARD(MX+65*(MY)),3)
        else
ELINE(OFFSET(1,0)+8,OFFSET(1,1)+101-BOARD(MX+65*(MY)),OFFSET(1,0)+32,OFFSET(1,1)+101-BOARD(MX+65*(MY)),HCOL(BOARD(MX+65*(MY))+GRAPHIX));
ELINE(OFFSET(1,0)+8,OFFSET(1,1)+100-BOARD(MX+65*(MY)),OFFSET(1,0)+32,OFFSET(1,1)+100-BOARD(MX+65*(MY)),HCOL(BOARD(MX+65*(MY))+GRAPHIX));
ELINE(OFFSET(1,0)+8,OFFSET(1,1)+102-BOARD(MX+65*(MY)),OFFSET(1,0)+32,OFFSET(1,1)+102-BOARD(MX+65*(MY)),HCOL(BOARD(MX+65*(MY))+GRAPHIX));
        end;
CURSOR(33,15);
if 100+((BOARD(MX+65*(MY))-50)*200)>-1000 then TEXT(0," ");
if 100+((BOARD(MX+65*(MY))-50)*200)<=-1000 then TEXT(0," ");
if 100+((BOARD(MX+65*(MY))-50)*200)>-1000 & 100+((BOARD(MX+65*(MY))-50)*200)<0 then TEXT(0," ")
else if 100+((BOARD(MX+65*(MY))-50)*200)>=100 & 100+((BOARD(MX+65*(MY))-50)*200)<1000 then TEXT(0,"  ")
else if 100+((BOARD(MX+65*(MY))-50)*200)>=1000 then TEXT(0," ");
INTOUT(0,100+((BOARD(MX+65*(MY))-50)*200));
TEXT(0,"m");
CURSOR(38,17);
if EDITLVL<16 then TEXT(0," ");
INTOUT(0,EDITLVL);
end;

proc GNH;
begin
ABOX(0,INACTV);
ABOX(1,ACTV);
CURSOR(0,20);TEMP:=true;CURSOR(OFFSET(4,0),OFFSET(4,1));TEXT(0,"LvlCtrl");
TEMP1:=BOARD(MX+65*(MY));
TEMP2:=true;
if MBLEFT then
        begin
        C(^Y);
        MOUSEBOUNDRY(0,0,0,99);
        MOUSEX:=0;
        MOUSEY:=99-BOARD(MX+65*MY);
        SMPOS;
        LMX:=MOUSEX;
        LMY:=MOUSEY;
        SETMSENSITIVITY(5,32,50);
        loop
                begin
                GETMINFO;
                if MOUSEX#LMX ! MOUSEY#LMY then
                        begin
                        C(^N);
                        BOARD(MX+65*MY):=99-MOUSEY;
                        C(^Y);
                        LMX:=MOUSEX;
                        LMY:=MOUSEY;
                        end;
                if MBLEFT=false then [C(^N);if MBRIGHT then [BOARD(MX+65*MY):=TEMP1;TEMP2:=false] else BOARD(MX+65*MY):=99-MOUSEY;C(^N);quit];
                end;
        EDITMOUSESETUP;
\        C(^Y);
        end
else
        begin
        C(^Y);
        loop
                begin
                if CHKKEY then
                        begin
                        C(^N);
                        CH:=CHIN(1);
                        if CH=0 then
                                begin
                                CH:=CHIN(1);
if CH=71 then BOARD(MX+65*(MY)):=99;;
if CH=72 then if BOARD(MX+65*(MY))<99 then BOARD(MX+65*(MY)):=BOARD(MX+65*(MY))+1;
if CH=73 then if BOARD(MX+65*(MY))<74 then BOARD(MX+65*(MY)):=BOARD(MX+65*(MY))+25 else BOARD(MX+65*(MY)):=99;
if CH=79 then BOARD(MX+65*(MY)):=0;
if CH=80 then if BOARD(MX+65*(MY))>0 then BOARD(MX+65*(MY)):=BOARD(MX+65*(MY))-1;
if CH=81 then if BOARD(MX+65*(MY))>24 then BOARD(MX+65*(MY)):=BOARD(MX+65*(MY))-25 else BOARD(MX+65*(MY)):=0;
if CH=82 then TEMP:=false;
                                end
                        else if CH=$1B then [BOARD(MX+65*MY):=TEMP1;TEMP2:=false;quit];
                        if TEMP=false then quit;
                        C(^Y);
                        end;
                end;
        end;
ABOX(1,INACTV);
ABOX(0,ACTV);
if TEMP2 then UPDATE;
CURSOR(OFFSET(4,0),OFFSET(4,1));TEXT(0,"Editing");
C(^Y);
end;

\proc PLINE(PLY1,PLY2,PLX);
\int PLY1,PLY2,PLX,PLTMP;
\for PLTMP:=0,PLY1-PLY2 do POINT(PLX,PLY1-PLTMP,HCOL(PLTMP*5+(GRAPHIX)));
\
\proc BLINE(SBX,SBY,SEX,SEY,SBLC1,SBLC2);
\int SBX,SBY,SEX,SEY,SBLC1,SBLC2;
\
\        proc BSUB(BX,BY,EX,EY,BLC1,BLC2);
\        int BX,BY,EX,EY,BLC1,BLC2;
\        begin
\        if ABS(BX-EX)>1 ! ABS(BY-EY)>1 then
\                begin
\                POINT((BX+EX)/2,(BY+EY)/2,(BLC1+BLC2)/2);
\                BLINE((BX+EX)/2,(BY+EY)/2,EX,EY,(BLC1+BLC2)/2,BLC2);
\                end;
\        end;
\
\begin
\POINT(SBX,SBY,SBLC1);
\POINT(SEX,SEY,SBLC2);
\BSUB(SBX,SBY,SEX,SEY,SBLC1,SBLC2);
\end;


proc CSVW;
int CS1,CS2;
loop
        begin
        for TEMP:=0,64 do
                begin
                if CSVWT=1 then [CS1:=MX;CS2:=TEMP]
                        else [CS1:=TEMP;CS2:=MY];
                for TEMP1:=0,3 do
                        begin
                        if CHKKEY then quit;
        ELINE(OFFSET(3,0)+(TEMP*4)+TEMP1+2,OFFSET(3,1)+101,OFFSET(3,0)+(TEMP*4)+TEMP1+2,OFFSET(3,1)+101-BOARD(CS1+65*(CS2))\/2\,
        \16,\HCOL(BOARD(CS1+65*(CS2))+(GRAPHIX)));
        ELINE(OFFSET(3,0)+2+(TEMP*4)+TEMP1,OFFSET(3,1)+100-BOARD(CS1+65*(CS2))\/2\,OFFSET(3,0)+2+(TEMP*4)+TEMP1,OFFSET(3,1)+1,0);
                        end;
                end;
        quit;
        end;

proc PREVIEW;
int OFX,OFY,CLR,CH,PRET1,PRET2,PRET3;
begin
OPENI(0);
OFX:=OFFSET(2,0)+2;OFY:=OFFSET(2,1)+21;
        for TEMP:=0,19 do ELINE(OFX,OFFSET(2,1)+1+TEMP,OFX+128,OFFSET(2,1)+1+TEMP,0);
loop
        begin
        for TEMP1:=0,64 do
                begin;
                for TEMP:=0,2 do ELINE(OFX,OFY+(TEMP1*2)+TEMP,OFX+128,OFY+(TEMP1*2)+TEMP,0);
                        for TEMP:=0,64 do
                                begin
                                PRET1:=TEMP+65*TEMP1;
                                if RAIN(PRET1)-\/\WHI*2 > 0 then
                                        begin
                                        PRET2:=OFY+TEMP1*2-(BOARD(PRET1)+RAIN(PRET1)/WHI)/5;
                                        PRET3:=47-RAIN(PRET1)/WHI+GRAPHIX;
                                        POINT(OFX+TEMP*2,   PRET2, HCOL(PRET3));
                                        if TEMP<64 then 
                                                POINT(OFX+TEMP*2+1, PRET2, HCOL(PRET3));
                                        end
                                else
                                        begin
                                        PRET2:=OFY+TEMP1*2-BOARD(PRET1)/5;
                                        PRET3:=BOARD(PRET1)+GRAPHIX;
                                        POINT(OFX+TEMP*2, PRET2, HCOL(PRET3));
                                        if TEMP<64 then
                                                POINT(OFX+TEMP*2+1, PRET2, HCOL(PRET3));
                                        end;
                                if CHKKEY then quit;
\                                if TEMP<64 then
\                                        begin
\                                        POINT(OFX+(TEMP*2)+1,
\                                        OFY+(TEMP1*2)-(((BOARD(PRET1)+BOARD(PRET1+1))/2)/5),
\                                        HCOL((BOARD(PRET1)+BOARD(PRET1+1))/2+(GRAPHIX)));
\                                        end;
                                end;
                end;
        quit;
        end;
loop if CHKKEY then quit;
CURSOR(OFFSET(4,0),OFFSET(4,1));TEXT(0,"Editing");
end;

proc CLEARB;
begin
CURSOR(OFFSET(4,0),OFFSET(4,1));
TEXT(0,"OK?    ");
loop if CHKKEY then quit;
CH:=CHIN(1);
if CH=^Y ! CH=^y then
        begin
        CURSOR(OFFSET(4,0),OFFSET(4,1));
        TEXT(0,"Working");
        ASSIGN;
        end;
CURSOR(OFFSET(4,0),OFFSET(4,1));
TEXT(0,"Editing");
end;

proc BACKSPACE(OUTDEV);
int OUTDEV;
begin
CHOUT(0,$8);
CHOUT(OUTDEV,^ );
CHOUT(0,$8);
end;

proc LEGFNAME(CHAR);    \IS CHAR a legitamate file name char?
char CHAR;
begin
if CHAR>32 & CHAR<127 then
[if CHAR#^" & CHAR#^, & CHAR#^/ & CHAR#^< & CHAR#^> & CHAR#^? & CHAR#^* &
CHAR#^. &
CHAR#^= & CHAR#^| & CHAR#^[ & CHAR#^] & CHAR#^\ then return(true)]
else return(false);
end;

proc GETSTRING(SS,LIM,OUTDEV);
char SS;
int LIM,OUTDEV,I,CH;
seg char STRNG;
begin
STRNG:=RESERVE(2);
STRNG(0):=SS;
I:=0;
loop
        begin
        CH:=CHIN(1);
        if CH=$0D then quit;
        if CH=$1B then [for CH:=0,I-1 do BACKSPACE(OUTDEV);I:=0]
        else if CH=$8 then [I:=I-1;if I<0 then I:=0 else BACKSPACE(OUTDEV)] else
        if I=LIM-1 then else if LEGFNAME(CH) then [STRNG(0,I):=CH;I:=I+1;CHOUT(OUTDEV,CH)];
        end;
STRNG(0,I-1):=STRNG(0,I-1)!$80;
end;

proc SAVE;
int I;
seg char STRING;
char ST2;
begin
\STRING:=RESERVE(2);
\STRING(0):=MALLOC(2);
\ST2:=RESERVE(12);
REFRESH(^S);
\SETVID(3);
\ATTRIB($1A);
\SETWIND(10,5,70,20,$00,true);
\CRLF(6);
\TEXT(6,"Type in your save name: ");
\GETSTRING(STRING(0),8,6);
\I:=0;
\loop
\        begin
\        if STRING(0,I)>127 then [STRING(0,I):=STRING(0,I)&$7F;quit];
\        I:=I+1;
\        if I>=8 then quit;
\        end;
\STRING(0,I+1):=^.;
\STRING(0,I+2):=^E;
\STRING(0,I+3):=^V;
\STRING(0,I+4):=^O;
\STRING(0,I+4):=STRING(0,I+4)!$80;

\CRLF(0);
\for I:=0,11 do ST2(I):=STRING(0,I);
\TEXT(6,ST2);
\loop if CHKKEY then quit;
\HAND:=FOPEN(ST2,1);
FSET(HAND,^O);
OPENO(3);
for I:=0,4224 do CHOUT(3,BOARD(I));
CLOSE(3);
FCLOSE(HAND);
SETVID($13);
REFRESH(^R);
end;

proc LOAD;
int I,LX;
begin
HAND:=FOPEN("EVOSAVE.SAV",0);
FSET(HAND,^I);
OPENI(3);
for I:=0,4224 do BOARD(I):=CHIN(3);
CLOSE(3);
FCLOSE(HAND);
DRAWBOARD;
end;

proc RUN3DPREVIEW;
begin
REFRESH(^S);
HAND:=FOPEN("EVOSAVE.TMP",1);
SAVE;
CHAIN("3B.EXE");
SETPAL;
REFRESH(^Y);
EDITMOUSESETUP;
end;

proc SRAIN;
int XMOD,YMOD,XLOW,YLOW,LOWEST,XS,YS;
begin
CURSOR(0,35);
TEXT(0,"RAINING!");
for Y:=0,64 do for X:=0,64 do RAIN(X+65*Y):=0;
for Y:=0,64 do
        begin
        CURSOR(30,37);
        INTOUT(0,FIX(FLOAT(Y)*(100.0/64.0)));CHOUT(0,^%);
for X:=0,64 do
        begin
        XMOD:=X;
        YMOD:=Y;
        loop
                begin
                if BOARD(XMOD+65*YMOD)>49 then RAIN(XMOD+65*YMOD):=RAIN(XMOD+65*YMOD)+1;\DRWBLK(XMOD,YMOD);
                LOWEST:=BOARD(XMOD+65*YMOD) + RAIN(XMOD+65*YMOD)/WHI;
                for YS:=YMOD-1,YMOD+1 do for XS:=XMOD-1,XMOD+1 do
                        if BOARD(XS+65*(YS))+RAIN(XS+65*(YS))/WHI < LOWEST then [XLOW:=XS;YLOW:=YS;LOWEST:=BOARD(XS+65*(YS))+RAIN(XS+65*(YS))/WHI];
                if LOWEST=BOARD(XMOD+65*YMOD) + RAIN(XMOD+65*YMOD)/WHI then quit;
                XMOD:=XLOW;
                YMOD:=YLOW;
                if XMOD<1 & XMOD>63 & YMOD<1 & YMOD>63 then quit;
                if BOARD(XLOW+65*YLOW)<=48 then quit;
                end;
        end;
        end;
CURSOR(0,35);
TEXT(0,"DONE    ");
DRAWBOARD;
PREVIEW;
CURSOR(0,35);
TEXT(0,"WAITING!");
loop if CHKKEY then quit;
for Y:=0,64 do for X:=0,64 do RAIN(X+65*Y):=0;
DRAWBOARD;
end;

proc HELP;
begin
REFRESH(^S);
SETVID(3);
CURSOR(0,0);
\ATTRIB($17);
TEXT(0,"Evolution v1.0: Editing Screan

There are two main modes that Evolution runs in. The first is the
editing mode (which you are currently in). The seccond is the 3-D
preview mode. To enter 3-D preview mode, type 'P'.

Editing
-------
The mode difficult concept of this mode it the 'Editing Level'. For now,
think of it as the size of the area you are editing (the bigger the #,
the bigger the area). You can change the editing level with the
keyboard. The '+' key doubles it (limit 32) and the '-' halves it (limit
2).

Mouse:  Move the mouse to move the cursor. When you are at the location
        you wish to edit, hold the LEFT mouse button down. While holding
        the button down, drag it up and down to the desired altitude.
        When done, LEFT up the mouse button. (if you don't want to keep
        the changes you just made, hold down the RIGHT mouse button
        while you lift up the LEFT mouse button).
Keys:   The cursor pad can be used to move to cursor (corner keys, e.g.
        HOME, PGUP..., move diagonally in that direction). By pressing
        INSERT, you can then use the up and down arrow keys to adjust
        the new altitude. Press INSERT again then done, or ESC to abort.
                (press any key or mouse button to continue)");
loop [GETMINFO;if CHKKEY then [CH:=CHIN(1);quit];if MBLEFT ! MBRIGHT
then quit];
WAITMOUSE;
CLEAR;
TEXT(0,"
Other Keys:

Thease keys effect the altitude at the current cursors position:
Q: +1           W: +10          E: +25
A: -1           S: -10          D: -25

Alt-L:  Load a previously save landscap from file EVOSAVE.SAV
Alt-S:  Save a file to EVOSAVE.SAV
C:      Clear board (start over)
Cntrl-Q: Quit!

                (press any key or mouse button to continue)");
loop [GETMINFO;if CHKKEY then [CH:=CHIN(1);quit];if MBLEFT ! MBRIGHT
then quit];
WAITMOUSE;
CLEAR;
TEXT(0,"Evolution v1.0: 3-D Preview Screan

This mode allows you to see your work from and angle...

First pick an angle using the preview box and the methods described
below, and then hit 'P' or the RIGHT mouse BUTTON. Magic! There is you
landscape in 3-D.

Mouse:  To orient the box to the correct angle, click and hold down the
        LEFT mouse button. Expiriment with how the angle control works.

Keys:   Pressing an arrow key once will start the box rotating in that
        direction, to stop, press the oppisit direction key or SPACE
        BAR. The more times you press an arrow key, the faster it will
        rotate. (NOTE: you must press the arrow key in the oppisite
        direction the same # of times as you pressed the origonal arrow
        key, but SPACE BAR will freeze the box at any time with one
        press). 'Q' & 'A' (not Question and Answer) rotate the box on
        it's Z axis. They work similar to the arrows keys. (NOTE: the
        mouse CANNOT rotate the box allong this axis. You can, however,
        use the keys and the mouse in combonation with one another). 'R'
        is used to reset the box to all angles equaling 0.

                                END of HELP
                     (press any key or mouse button to continue)");
loop [GETMINFO;if CHKKEY then [CH:=CHIN(1);quit];if MBLEFT ! MBRIGHT
then quit];
WAITMOUSE;
SETVID($13);
LPAL;
REFRESH(^Y);
EDITMOUSESETUP;
end;

proc CMAIN;
begin
MX:=32;
MY:=32;
EDITMOUSESETUP;
C(^Y);
        loop
                begin
                GETMINFO;
                if MBLEFT then GNH;
                if MOUSEX#LMX ! MOUSEY#LMY then
                        begin
                        C(^N);
                        MX:=(MOUSEX/2);
                        MY:=MOUSEY;
                        C(^Y);
                        LMX:=MOUSEX;
                        LMY:=MOUSEY;
                        end;
                if CHKKEY then
                        begin
                        C(^N);
                        CH:=CHIN(1);
                        if CH=0 then
                                begin
                                CH:=CHIN(1);
                                case CH of
                                        59:     [HELP];
                                        71:     [if MX>0 then MX:=MX-1;if MY>0 then MY:=MY-1];
                                        72:     if MY>0 then MY:=MY-1;
                                        73:     [if MX<64 then MX:=MX+1;if MY>0 then MY:=MY-1];
                                        75:     if MX>0 then MX:=MX-1;
                                        77:     if MX<64 then MX:=MX+1;
                                        79:     [if MX>0 then MX:=MX-1;if MY<64 then MY:=MY+1];
                                        80:     if MY<64 then MY:=MY+1;
                                        81:     [if MX<64 then MX:=MX+1;if MY<64 then MY:=MY+1];
                                        119:    [MX:=0;MY:=0];
                                        117:    [MX:=64;MY:=64];
                                        118:    MY:=64;
                                        132:    MY:=0;
                                        82:     GNH;
                                        18:     [REFRESH(^S);CHAIN("PALEDIT.EXE");REFRESH(^Y)];
                                        31:     [HAND:=FOPEN("EVOSAVE.SAV",1);SAVE];
                                        38:     [LOAD]
                                        else;
                                end
                        else
                                begin
                                if CH=17 then quit;
                                if CH=^A ! CH=^a then AH(-1);
                                if CH=^Q ! CH=^q then AH(1);
                                if CH=^W ! CH=^w then AH(10);
                                if CH=^S ! CH=^s then AH(-10);
                                if CH=^E ! CH=^e then AH(25);
                                if CH=^D ! CH=^d then AH(-25);
                                if CH=^C ! CH=^c then CLEARB;
                                if CH=^T ! CH=^t then if CSVWT=0 then CSVWT:=1 else CSVWT:=0;
                                if CH=^P ! CH=^p then RUN3DPREVIEW;
                                if CH=^R ! CH=^r then SRAIN;
                                if CH=^1 then WHI:=1;
                                if CH=^2 then WHI:=2;
                                if CH=^3 then WHI:=3;
                                if CH=^4 then WHI:=4;
                                if CH=^5 then WHI:=5;
                                if CH=^6 then WHI:=6;
                                if CH=^7 then WHI:=7;
                                if CH=^8 then WHI:=8;
                                if CH=^9 then WHI:=9;
                                if CH=^0 then WHI:=10;
                                if CH=^+ then
                                        begin
                                        if EDITLVL<32 then EDITLVL:=EDITLVL*2;
                                        TEMP1:=false;TEMP2:=false;
                                        loop
                                                begin
                                                for TEMP:=0,(64/EDITLVL) do
                                                        begin
                                                        if TEMP1=false then if MX=(EDITLVL*TEMP) then TEMP1:=true;
                                                        if TEMP2=false then if MY=(EDITLVL*TEMP) then TEMP2:=true;
                                                        if TEMP1=true & TEMP2=true then quit;
                                                        end;
                                                quit;
                                                end;
\                                        if TEMP1=false then MX:=(MX+EDITLVL/2);
\                                        if TEMP2=false then MY:=(MY+EDITLVL/2);
                                        EDITMOUSESETUP;
                                        end;
                                if CH=^- then [if EDITLVL>2 then EDITLVL:=EDITLVL/2;EDITMOUSESETUP];
                                end;
                        C(^Y);
                        EDITMOUSESETUP;
                        end
                else
                        begin
\                        CSVW;
\                        if CHKKEY=false then
\                        PREVIEW;
                        end;
                end;
end;

proc SETUP;
begin

VIDEO:=RESERVE(2);
VIDEO(0):=$A000;
PALETTE:=RESERVE(2);
PALETTE(0):=MALLOC(48);
VID2:=RESERVE(2);
VID2(0):=MALLOC(4096);
\DECLARES THE ARRAY OF 'BOARD'. USED AS THE PLAYING BOARD, PRETTY SIMPLE EH?
BOARD:=RESERVE(4225);
RAIN:=RESERVE(4225);    for Y:=0,64 do for X:=0,64 do RAIN(X+65*Y):=0;
WHI:=9;
OFFSET:=RESERVE(20);
for TEMP:=0,4 do OFFSET(TEMP):=RESERVE(8);
\ OFFSET contains the x and y offsets for the three windows on the screan.
\ the first number selects the window:0=edit window,1=highth window,2=preview
\ window. The seccond number selcts x or y: 0=x,1=y/ hope this helps...
OFFSET(0,0):=0;OFFSET(0,1):=0;                  \EDITING WINDOW
OFFSET(1,0):=265;OFFSET(1,1):=0;                \HIGTH WINDOW
OFFSET(2,0):=265;OFFSET(2,1):=216;              \PREVIEW WINDOW
OFFSET(3,0):=0;OFFSET(3,1):=265;                \CROSS-VIEW WONDOW
OFFSET(4,0):=33;OFFSET(4,1):=19;                 \MESSAGE-TEXT
EDITLVL:=16;
CSVWT:=0;
HCOL:=RESERVE(300);                                 \CGA=*0 EGA=*1 VGA=

\
\       *** DON'T DELETE THE NEXT FEW COMMENTED LINES ***
\
\       THEY CONTAIN INFORMATION ON WHAT COLORS ARE BEST TO USE
\       ON A DESPLAY WITH LESS THAN 256 COLORS (EGA AND VGA)

\for TEMP:=0,99 do if TEMP<25 then HCOL(TEMP):=0
\        else if TEMP<51 then HCOL(TEMP):=1
\        else if TEMP<68 then HCOL(TEMP):=2
\        else HCOL(TEMP):=3;
\for TEMP:=0,99 do
\        if TEMP<12 then HCOL(TEMP+100):=1
\        else if TEMP<25 then HCOL(TEMP+100):=9
\        else if TEMP<37 then HCOL(TEMP+100):=3
\        else if TEMP<50 then HCOL(TEMP+100):=11
\        else if TEMP=50 then HCOL(TEMP+100):=14
\        else if TEMP<59 then HCOL(TEMP+100):=10
\        else if TEMP<68 then HCOL(TEMP+100):=2
\        else if TEMP<80 then HCOL(TEMP+100):=8
\        else if TEMP<90 then HCOL(TEMP+100):=7
\        else HCOL(TEMP+100):=15;
for TEMP:=0,99 do HCOL(TEMP+200):=TEMP+16;


GRAPHIX:=200;
SETVGA;
\SETVID($13); \\94 for Trident, 99 for ATI VGA Wounder
CHOUT(0,$0C);
LPAL;
CRSR:=1;
ACTV:=2;
INACTV:=3;


ABOX(0,ACTV);
ABOX(1,INACTV);
\ABOX(2,INACTV);
\ABOX(3,INACTV);

                                \This PROC draws a comprehensible view of differnt land hights in the highth box
for TEMP:=0,99 do
        begin
        ELINE(OFFSET(1,0)+2,OFFSET(1,1)+2+TEMP,OFFSET(1,0)+6,OFFSET(1,1)+2+TEMP,HCOL((99-TEMP)+GRAPHIX));
        ELINE(OFFSET(1,0)+34,OFFSET(1,1)+2+TEMP,OFFSET(1,0)+38,OFFSET(1,1)+2+TEMP,HCOL((99-TEMP)+GRAPHIX));
        end;
HAND:=FOPEN("EVOSAVE.SAV",0);
LOAD;
\ASSIGN;
CURSOR(33,14);TEXT(0,"Alt.");
CURSOR(OFFSET(4,0),OFFSET(4,1));TEXT(0,"Editing");
CURSOR(33,16);
TEXT(0,"EdLvl:");
CURSOR(33,24);
TEXT(0," F1: ?");
end;

begin
CPUREG:=GETREG;
GETDEFAULTS;
SETUP;
CMAIN;
SETDEFAULTS;
end;
