\FILCOM.XPL	JAN-81
\ FILE COMPARISON UTILITY
\ EVERY THING IS BETTER THE
\ THIRD TIME AROUND, SO THIS
\ IS VERSION 3.1.

\ COPYRIGHT 1980 BY TED DUNNING
\ PLEASE RESPECT AND ENCOURAGE AUTHORS
\ BY NOT RIPPING OFF EVERYTHING IN SIGHT

\ I CAN BE LIKELY REACHED IN ONE OF
\ SEVERAL WAYS


\  AT 	240 SOUTH BROADWAY
\	SUITE #102
\	DENVER, CO 80209
\	(303) 778-7165

\	    - OR -

\  AT	3925 UMATILLA
\	DENVER, CO 80211
\	(303) 455-3762

\	    - OR -

\ VIA	WAYNE WALL AT THE
\	COLORADO SCHOOL OF MINES

\ PLEASE DO COMMENT/SUGGEST

'CODE'	\COMPLETE SET, STANDARD XPLV4D INTRINSICS
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEN=5		RESTRT=6	CHIN=7
CHOUT=8		CRLF=9		NUMIN=10	NUMOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETSP=20	SETSP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
FWRITE=30	FREAD=31	RESTOR=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	SWITCH=37
PADDLE=38	NOISE=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44;

'DEFINE'
CR=13		\CARRIAGE RETURN
LF=10		\LINE FEED
SP=32		\SPACE
TAB=9		\TAB
BELL=7		\BELL
EOF=26		\END OF FILE CHAR
BUFSIZ=4	\BUFFER SIZE (IN PAGES)
BUFMSK=1023	\BUFSIZ*256-1

STARTER=32	\INITIAL FOR DELTA
;

'INTEGER' 
DIFFNO		\TOTAL NUMBER OF DIFS

DELTA		\PRESENT SIZE FOR DIFF.

MARKA,MARKB	\MARK END OF DIFF.

LINNO		\LINE NUMBERS IN FILES

CHNO		\CHAR NUMBER VS. START
		\OF DIFFERENCE

INFO		\FILE INFO FROM SCAN
BLOCK		\PRESENT BLOCK

BUFPOS		\WHERE CURRENT CHAR IS

FENCE		\WHAT NOT TO CROSS W/O
		\GETTING ANOTHER BUFFER

BUFFER		\FILE BUFFERS
;

'OWN'
TXTFLG		\USE SPECIAL TEXT MODE
LSTFLG		\OUTPUT TO CONSOLE
DSKFLG		\OUTPUT TO DISK
DEFAULT		\DEFAULT INPUT DEVICE
MATCHSIZE	\SIZE TO REALIGN
DEVICE(2)	\ACTUAL DEVICES
;

'ADDRESS'

CH		\UNFILTERED CHARS
CHAR		\FILTERD CHARS
;

'PROC' WAIT;
'INTEGER' CH;
CH:=CHIN(1);

\'PROC' FREAD(DEV,BLK,BUF,N);
\'INTEGER' DEV,BLK,BUF,N;
\'BEGIN'
\  NUMOUT(0,N);CRLF(0);
\  'IF'N>0 'THEN' 'BEGIN'
\    FREAD1(DEV,BLK,BUF,N)
\  'END'
\'END';

'PROC' GETBUF(DEV);
'INTEGER' DEV,I;
'BEGIN'
  'CASE' 'OF'
    BLOCK(DEV)>INFO(DEV,1):'BEGIN'
      CRLF(0);
      TEXT(0,"CANNOT READ PAST EOF");
      ABORT;
    'END';
    (BLOCK(DEV)+BUFSIZ)>INFO(DEV,1):
      I:=INFO(DEV,1)-BLOCK(DEV)+1
  'ELSE'I:=BUFSIZ;
    
  'IF'I>(BUFSIZ-FENCE(DEV)/256)'THEN'
    I:=BUFSIZ-FENCE(DEV)/256;
    
  'IF' I>0 'THEN''BEGIN'
    FREAD(DEVICE(DEV),BLOCK(DEV),
      BUFFER(DEV)+FENCE(DEV),I);
    
  'END'
  
  'ELSE' I:=0;
  
  \ BLOCK ONLY MOVES A BIT
  BLOCK(DEV):=BLOCK(DEV)+I;
  
  \ FENCE MAY MOVE, TOO
  FENCE(DEV):=BUFMSK&(FENCE(DEV)+I*256)
'END';

'PROC' GETC(DEV);
'INTEGER' DEV;
'ADDRESS' BUFF;
'BEGIN'
  BUFF:=BUFFER(DEV);
  CH(DEV):=BUFF(BUFPOS(DEV));
  'IF'CH(DEV)=CR 'THEN' 
    LINNO(DEV):=LINNO(DEV)+1;
  'IF' CH(DEV)#EOF 'THEN''BEGIN'
    BUFPOS(DEV):=(BUFPOS(DEV)+1)&BUFMSK;
    
    'IF' BUFPOS(DEV)=FENCE(DEV) 'THEN'
      GETBUF(DEV);
  'END';
'END';

'PROC' BACKBUF(DEV);
'INTEGER' DEV,I;
'ADDRESS' BUFF;
'BEGIN'
  FENCE(DEV):=BUFMSK&(FENCE(DEV)-256);
  BLOCK(DEV):=BLOCK(DEV)-1;
  'IF'BLOCK(DEV)<=INFO(DEV,0)+BUFSIZ'THEN'
    'BEGIN'
      BUFF:=BUFFER(DEV);
      'FOR'I:=FENCE(DEV),FENCE(DEV)+255'DO'
        BUFF(I):=CR;
    'END'
  'ELSE''BEGIN'
    FREAD(DEVICE(DEV),BLOCK(DEV)-BUFSIZ,
      BUFFER(DEV)+FENCE(DEV),1);
  'END'

'END';

'PROC' BACKC(DEV);
'INTEGER' DEV;
'ADDRESS' BUFF;
'BEGIN'
  
  'IF' BUFPOS(DEV)=FENCE(DEV) 'THEN'
    BACKBUF(DEV);
    
  BUFPOS(DEV):=(BUFPOS(DEV)-1)&BUFMSK;
  BUFF:=BUFFER(DEV);
  CH(DEV):=BUFF(BUFPOS(DEV));
  'IF' CH(DEV)=CR 'THEN' 
    LINNO(DEV):=LINNO(DEV)-1;
'END';

'PROC' GETCH(DEV);
'INTEGER' DEV;
'OWN' SPFLG(2);
'BEGIN'
  GETC(DEV);
  CHAR(DEV):=CH(DEV);
  'IF' TXTFLG 'THEN''BEGIN'
    'CASE' 'OF'
      CHAR(DEV)=EOF:SPFLG(DEV):='FALSE';
      
      (CHAR(DEV)<=SP):'IF'SPFLG(DEV)
      'THEN''BEGIN'
        'WHILE'(CH(DEV)<=SP)&
	(CH(DEV)#EOF) 'DO'GETC(DEV);
	
	SPFLG(DEV):='FALSE';
	CHAR(DEV):=CH(DEV)
      'END'
      'ELSE''BEGIN'
        CHAR(DEV):=SP;
	SPFLG(DEV):='TRUE'
      'END'
    'ELSE'SPFLG(DEV):='FALSE';
      
  'END';
  CHNO(DEV):=CHNO(DEV)+1;
'END';

'PROC' BACKCH(DEV);
'INTEGER' DEV;
'OWN'SPFLG(2);
'BEGIN'
  BACKC(DEV);
  CHAR(DEV):=CH(DEV);
  'IF' TXTFLG 'THEN''BEGIN'
    'CASE' 'OF'
      CHAR(DEV)=EOF:SPFLG(DEV):='FALSE';
      
      (CHAR(DEV)<=SP):'IF' SPFLG(DEV) 
      'THEN''BEGIN'
        'WHILE'(CH(DEV)<=SP)&
	(CH(DEV)#EOF) 'DO'BACKC(DEV);
	
	CHAR(DEV):=CH(DEV);
	SPFLG(DEV):='FALSE'
      'END'
      'ELSE''BEGIN'
        CHAR(DEV):=SP;
	SPFLG(DEV):='TRUE'
      'END'
    'ELSE'SPFLG(DEV):='FALSE';
      
  'END';
  CHNO(DEV):=CHNO(DEV)-1;
  
'END';

'PROC' PUTIT(D,C);
'INTEGER' D,C;
'BEGIN'
  'CASE' C 'OF'
    CR:CRLF(D);
    LF:;
    EOF:[]
  'ELSE'CHOUT(D,C)
'END';

'PROC' PUTCH(CHR);
'INTEGER' CHR;

'BEGIN'
  'IF'LSTFLG 'THEN'PUTIT(0,CHR);
  'IF'DSKFLG 'THEN'PUTIT(3,CHR)
'END';

'PROC' PUTLIN(DEV);
'INTEGER' DEV,TMPFLG;
'ADDRESS' LET;
'BEGIN'
  TMPFLG:=TXTFLG;TXTFLG:='FALSE';

  'WHILE'(CH(DEV)#CR)&(CH(DEV)#EOF)'DO'
    BACKCH(DEV);

  GETCH(DEV);
  LET:="AB ";

  'IF' LSTFLG'THEN''BEGIN'
    CHOUT(0,LET(DEV));
    NUMOUT(0,LINNO(DEV));
    CHOUT(0,TAB)
  'END';

  'IF' DSKFLG'THEN''BEGIN'
    CHOUT(3,LET(DEV));
    NUMOUT(3,LINNO(DEV));
    CHOUT(3,TAB)
  'END';

  'REPEAT' 
    GETCH(DEV);PUTCH(CHAR(DEV))
  'UNTIL' (CHAR(DEV)=CR)!(CHAR(DEV)=EOF);
  
  TXTFLG:=TMPFLG
'END';

'PROC' GETDEFAULTS;
'INTEGER' I;

'PROC' PUT(S,F,TYPE);
'ADDRESS' S;
'INTEGER' F,TYPE;
'BEGIN'
  TEXT(0,S);
  'CASE' TYPE 'OF'
    0:'IF' F 'THEN' TEXT(0,"YES")
    'ELSE' TEXT(0,"NO");
    1:NUMOUT(0,F)
  'ELSE';

  CRLF(0)
'END';

'PROC' GET(S,F,TYPE);
'ADDRESS' S;
'INTEGER' F,TYPE,CH;
'BEGIN'
  TEXT(0,S);
  'CASE' TYPE 'OF'
    0:'BEGIN'
      CH:=CHIN(1);
      'CASE' CH 'OF'
      ^Y:'BEGIN'
        F(0):='TRUE';
	TEXT(0,"YES")
      'END';
      ^N:'BEGIN'
        F(0):='FALSE';
	TEXT(0,"NO")
      'END'
      'ELSE''IF'F(0)'THEN'TEXT(0,"YES")
        'ELSE'TEXT(0,"NO");
    'END';
    
    1:'BEGIN'
      OPENI(0);
      F(0):=NUMIN(0)
    'END'
  'ELSE';

  CRLF(0)
'END';

'LOOP''BEGIN' \DEFAULTS
  CHOUT(0,12);
  TEXT(0," -- FILE COMPARISON V3.1 --");
  CRLF(0);
  TEXT(0,"         JAN 1981");
  'FOR'I:=1,7'DO'CRLF(0);

  PUT("TEXT MODE - ",TXTFLG,0);
  PUT("LISTING - ",LSTFLG,0);
  PUT("OUTPUT TO DISK - ",DSKFLG,0);
  PUT("DEFAULT DEVICE - ",DEFAULT,1);
  PUT("MINIMUM MATCH SIZE - ",MATCHSIZE,1);
  CRLF(0);TEXT(0,"OK?");
  'IF' CHIN(1)#^N 'THEN''BEGIN'
    TEXT(0,"YES");CRLF(0);
    'QUIT'
  'END'
  'ELSE''BEGIN'
    TEXT(0,"NO");CRLF(0);
    GET("TEXT MODE - ",'ADDR'TXTFLG,0);
    GET("LISTING - ",'ADDR'LSTFLG,0);
    GET("OUTPUT TO DISK - ",'ADDR'DSKFLG,0);
    GET("DEFAULT DEVICE - ",'ADDR'DEFAULT,1);
    GET("MINIMUM MATCH SIZE - ",'ADDR'MATCHSIZE,1);
  'END';
  
  'IF'DSKFLG'THEN''BEGIN'
    TRAP('FALSE');
    OPENO(3);
    'IF'GETERR'THEN''BEGIN'
      CRLF(0);
      TEXT(0,"ERROR ON OPENING OUTPUT FILE");
      CRLF(0);
      TEXT(0,"- HIT ANY KEY -");
      I:=CHIN(1);
      DSKFLG:='FALSE'
    'END';
    TRAP('TRUE')
  'END';

'END';
  
'PROC' OPENFILES;
'INTEGER' CH,I,ERROR;
'ADDRESS' FILENAME;

'PROC' GETCH;
'BEGIN'
  'LOOP''BEGIN'
    CH:=CHIN(0);
    'IF'CH=CR 'THEN' CH:=SP;
    'IF'CH#LF 'THEN' 'QUIT';
  'END';
'END';

'PROC' ALPHA;
'INTEGER' DUMMY;
'RETURN' (CH>=^A)&(CH<=^Z)!((CH>=^0)&(CH<=^9));

'PROC' DIGIT;
'INTEGER' DUMMY;
'RETURN' (CH>=^0)&(CH<=^9);

'PROC' SKIPSP;
'WHILE' CH=SP 'DO' GETCH;

'PROC' GETNUM;
'INTEGER' SUM;
'BEGIN'
  SUM:=0;
  'WHILE' DIGIT 'DO''BEGIN'
    SUM:=SUM*10+CH-^0;
    GETCH
  'END';
  'RETURN' SUM;
'END';

'PROC' GETFILE(DEV);
'INTEGER' DEV,LEN;

'PROC' NAMOUT(UNIT);
'INTEGER' UNIT;
'BEGIN'
  CRLF(UNIT);
  NUMOUT(UNIT,DEVICE(DEV));
  CHOUT(UNIT,^:);
  LEN:=0;
  'LOOP''BEGIN'
    CH:=FILENAME(LEN);
    'IF''NOT' ALPHA 'THEN''QUIT';
    
    CHOUT(UNIT,CH);
    LEN:=LEN+1;
    'IF' LEN>7 'THEN''QUIT'
  'END';
  
  CHOUT(UNIT,^.);LEN:=8;
  'LOOP''BEGIN'
    CH:=FILENAME(LEN);
    'IF''NOT' ALPHA 'THEN''QUIT';
    
    CHOUT(UNIT,CH);
    LEN:=LEN+1;
    'IF' LEN>10 'THEN''QUIT'
  'END';
'END';
  
'BEGIN'
  FILENAME:=RESERVE(11);
  'REPEAT'
    'REPEAT'
      ERROR:='FALSE';
      'LOOP''BEGIN'
        OPENI(0);CH:=^ ;SKIPSP;
	'IF' DIGIT 'THEN''BEGIN'
	  DEVICE(DEV):=GETNUM;
	  SKIPSP;
	  GETCH; \PAST ":"
	  SKIPSP
	'END'
	'ELSE' DEVICE(DEV):=DEFAULT;
	
	'FOR' LEN:=0,10 'DO'
	  FILENAME(LEN):=^ ;
	  
	LEN:=0;
	'WHILE' ALPHA 'DO''BEGIN'
	  FILENAME(LEN):=CH;
	  LEN:=LEN+1;
	  GETCH
	'END';
	
	GETCH; \TOSS THE "."
	
	LEN:=8;
	'WHILE' ALPHA&(LEN<11) 'DO''BEGIN'
	  FILENAME(LEN):=CH;
	  LEN:=LEN+1;
	  GETCH
	'END';
	'QUIT'
      'END';
      'IF' ERROR 'THEN' 'BEGIN'
        CRLF(0);
	TEXT(0,"BAD FILE NAME");
	CRLF(0);
	OPENI(0)
      'END';
    'UNTIL' 'NOT' ERROR;
    
    TRAP('FALSE');
      SCAN(DEVICE(DEV),INFO(DEV),FILENAME);
      ERROR:=GETERR;
    TRAP('TRUE');
    
    'IF' ERROR 'THEN''BEGIN'
      
     NAMOUT(0);
     TEXT(0," - FILE NOT FOUND");
      CRLF(0);
      TEXT(0,"RE-ENTER FILE NAME -")
    'END'
    
  'UNTIL' 'NOT' ERROR;
  
  'IF'DSKFLG'THEN'NAMOUT(3);
    
  
'END';

'BEGIN' \ OPENFILES
  CRLF(0);TEXT(0,"FILE A -");
  GETFILE(0);
  'IF' DSKFLG 'THEN''BEGIN'
    TEXT(3," IS FILE A");CRLF(3)
  'END';

  CRLF(0);TEXT(0,"FILE B -");
  GETFILE(1);CRLF(0);

  'IF' DSKFLG 'THEN''BEGIN'
    TEXT(3," IS FILE B");CRLF(3);
    CRLF(3)
  'END';

'END'; \OPENFILES

'PROC' GOTO(DEV,PLACE);
'INTEGER' DEV,PLACE;
'IF' CHNO(DEV)>PLACE 'THEN''BEGIN'
  'REPEAT'
    BACKCH(DEV)
  'UNTIL' (CHNO(DEV)<=PLACE);
  BACKCH(DEV);GETCH(DEV)
'END'
'ELSE'
  'WHILE'(CHAR(DEV)#EOF)&
  	(CHNO(DEV)<PLACE)'DO'GETCH(DEV);

'PROC' SEARCH;
'INTEGER' CH,MATCH,LIMIT,MARK;

'PROC' CHECK(SIZE);
'INTEGER' SIZE;
'BEGIN'
  'LOOP''BEGIN'

    'CASE''OF'

    SIZE=0:'BEGIN'
      MATCH:='TRUE';'QUIT'
    'END';

    CHAR(0)#CHAR(1):'BEGIN'
      MATCH:='FALSE';'QUIT'
    'END'
    
    'ELSE''BEGIN'
      GETCH(0);GETCH(1);SIZE:=SIZE-1
    'END';
  'END'

'END';

'BEGIN'
  MATCH:='FALSE';
  GOTO(0,DELTA);CH:=CHAR(0);
  LIMIT:=DELTA+DELTA;

  'REPEAT'
    'IF'CH=CHAR(1)'THEN''BEGIN'
      MARK:=CHNO(1);
      GOTO(0,DELTA);

      CHECK(MATCHSIZE);
      'IF''NOT'MATCH'THEN'
        GOTO(1,MARK+1);
    'END'
    'ELSE' GETCH(1)
  'UNTIL'(CHNO(1)>=LIMIT)!MATCH;

  'IF'MATCH'THEN'CHOUT(0,^T)
  'ELSE'CHOUT(0,^F);CRLF(0);
  'RETURN' MATCH
'END';


'BEGIN'
  GETDEFAULTS;
  LINNO:=	RESERVE(4);
  LINNO(0):=0;
  LINNO(1):=0;

  CHNO:=	RESERVE(4);
  CHNO(0):=0;
  CHNO(1):=0;

  INFO:=	RESERVE(4);
  INFO(0):=	RESERVE(4);
  INFO(1):=	RESERVE(4);
  OPENFILES;
  
  CH:=		RESERVE(2);
  CHAR:=	RESERVE(2);
  CH(0):=CR;
  CH(1):=CR;
  CHAR(0):=CR;
  CHAR(1):=CR;

  FENCE:=	RESERVE(4);
  BUFFER:=	RESERVE(4);
  BUFPOS:=	RESERVE(4);

  BUFFER(0):=	RESERVE(256*BUFSIZ);
  BUFFER(1):=	RESERVE(256*BUFSIZ);

  BLOCK:=RESERVE(4);
  BLOCK(0):=INFO(0,0);
  BLOCK(1):=INFO(1,0);

  FENCE(0):=0;
  FENCE(1):=0;
  BUFPOS(0):=0;
  BUFPOS(1):=0;

  
  DIFFNO:=0;
  TEXT(0,"GETTING");
  GETBUF(0);
  TEXT(0,"...");
  GETBUF(1);
  
  TEXT(0,"GOING");
  
  'LOOP''BEGIN'
    'REPEAT'
      GETCH(0);GETCH(1)
    'UNTIL'(CHAR(0)#CHAR(1))!
		(CHAR(0)=EOF);
    
    'IF' CHAR(0)=EOF 'THEN''QUIT';
    DIFFNO:=DIFFNO+1;

    CRLF(0);TEXT(0,"..AHAA!!..");
    CRLF(0);CHNO(0):=0;CHNO(1):=0;

    CHOUT(0,CHAR(0));CHOUT(0,^-);
    CHOUT(0,CHAR(1));CRLF(0);

    DELTA:=STARTER;
    
    'LOOP''BEGIN'
      GOTO(0,DELTA);
      GOTO(1,0);
      'IF' SEARCH'THEN''BEGIN'
      
        'WHILE'CHAR(0)=CHAR(1)'DO''BEGIN'
	  BACKCH(0);BACKCH(1)
	'END';

	GETCH(0);GETCH(1);
	
	MARKA:=CHNO(0);
	MARKB:=CHNO(1);
	
	GOTO(0,-20);
	'WHILE'LINNO(0)<0'DO'GETCH(0);
	'REPEAT'
	  PUTLIN(0)
	'UNTIL'CHNO(0)>=MARKA;
	PUTLIN(0);
	
	PUTCH(CR);PUTCH(CR);PUTCH(CR);
	
	GOTO(1,-20);
	'WHILE'LINNO(1)<0'DO'GETCH(1);
	'REPEAT'
	  PUTLIN(1)
	'UNTIL'CHNO(1)>=MARKB;
	PUTLIN(1);

	PUTCH(CR);PUTCH(CR);PUTCH(CR);
	
	'QUIT'
      'END';
      
      DELTA:=DELTA+DELTA;
    'END';
    
    GOTO(0,MARKA);GOTO(1,MARKB);
    'IF' CHAR(0)=EOF 'THEN''QUIT'
  'END';
  
  PUTCH(CR);
  PUTCH(CR);
  'IF'LSTFLG'THEN''BEGIN'
    NUMOUT(0,DIFFNO);
    TEXT(0," DIFFERENCES FOUND");
  'END';

  'IF'DSKFLG'THEN''BEGIN'
    NUMOUT(3,DIFFNO);
    TEXT(3," DIFFERENCES FOUND");
  'END';
  
  PUTCH(CR);

  'IF'DSKFLG'THEN''BEGIN'
    CHOUT(3,EOF);
    CLOSE(3)
  'END';
    
'END'; 
