'CODE'	\COMPLETE SET, STANDARD XPLV5D INTRINSICS

ABS=0 RAN=1 REM=2 RESERVE=3 SWAP=4
EXTEN=5 RESTRT=6 CHIN=7 CHOUT=8 CRLF=9
NUMIN=10 NUMOUT=11 TEXT=12 OPENI=13
OPENO=14 CLOSE=15 ABORT=16 TRAP=17
SPACE=18 RERUN=19 GETSP=20 SETSP=21
GETERR=22 CURSOR=23 SCAN=24 SETRUN=25
CHAIN=28 OPENF=29 FWRITE=30 FREAD=31
RESTOR=32 SETTXT=33 SETHI=34 SETMIX=35
SETLO=36 SWITCH=37 PADDLE=38 NOISE=39
CLEAR=40 DOT=41 LINE=42 MOVE=43
SCREEN=44 BLOCK=45 FIX=50; 'CODE''REAL'
RLRES=46 RLIN=47 RLOUT=48 FLOAT=49
RLABS=51 FORMAT=52 SQRT=53 LN=54 EXP=55
SIN=56 ATAN2=57 MOD=58;

'REAL'SINTAB,X,Y,K;
'INTEGER'I,CH;
'DEFINE'WHITE=255,NPOINTS=256;

'PROC'LIST;
'INTEGER'I;
'BEGIN'
  'FOR'I:=0,NPOINTS-1'DO''BEGIN'
    RLOUT(0,X(I));CHOUT(0,^,);
    RLOUT(0,Y(I));CRLF(0)
  'END';
'END';

'PROC'PLOT(PNTS);
'REAL'PNTS,MAX;
'INTEGER'I;

'BEGIN'
  MAX:=0.0;
  'FOR'I:=0,NPOINTS'DO''IF'MAX<RLABS(PNTS(I))
    'THEN'MAX:=RLABS(PNTS(I));
    
  TEXT(0,"MAG IS ");RLOUT(0,MAX);
  'IF'MAX=0.0'THEN''RETURN';

  SETHI;CLEAR;

  MOVE(0,96);
  'FOR'I:=0,255'DO'
DOT(I,96-FIX(PNTS(I)*90.0/MAX+0.5),WHITE);
  CH:=CHIN(1);SETTXT
'END';

'PROC' SETSIN;
'INTEGER'I;
'FOR'I:=0,NPOINTS'DO'
  SINTAB(I):=SIN(6.283185308*FLOAT(I)/FLOAT(NPOINTS));

'PROC''REAL' SINT(I);
'INTEGER'I;
'BEGIN'
  'IF'I<0'THEN''RETURN'SINT(I+NPOINTS)
  'ELSE''IF'I>NPOINTS'THEN''RETURN'SINT(I-NPOINTS)
  'ELSE''RETURN'SINTAB(I)
'END';

'PROC''REAL' COST(I);
'INTEGER'I;
'RETURN'SINT(I-NPOINTS/4);

'PROC'  FFT(REAL,IMAG);
'REAL'  REAL,IMAG,TR,TI,WR,WI;
'INTEGER' MR,M,L,NN,CHAR,STEP,A;
'INTEGER'  I,J;

'BEGIN'
  MR:=0;
  NN:=NPOINTS-1;
  'FOR' M:=1,NN 'DO' 'BEGIN'
    L:=NPOINTS;
    'REPEAT' L:=L/2 'UNTIL' MR+L<=NN;
    MR:=REM(MR/L)+L;
    'IF' MR>M 'THEN' 'BEGIN'
      TR:=REAL(M);
      REAL(M):=REAL(MR);
      REAL(MR):=TR;
      TI:=IMAG(M);
      IMAG(M):=IMAG(MR);
      IMAG(MR):=TI;
    'END';
  'END';
  OPENO(0);CRLF(0);
  TEXT(0,"FIRST HALF OF FFT");
  OPENI(0);CH:=CHIN(1);
  
  L:=1;
  'WHILE' L<NPOINTS 'DO' 'BEGIN'
    CRLF(0);NUMOUT(0,L);
    STEP:=2*L;
    'FOR' M:=0,L-1 'DO' 'BEGIN'
      A:=(NPOINTS/STEP)*(-M);
      WR:=-COST(A);
      WI:=SINT(A);
      I:=M;
      'REPEAT'
        J:=I+L;
	TR:=(WR*REAL(J)-WI*IMAG(J));
	TI:=(WR*IMAG(J)+WI*REAL(J));
	REAL(J):=REAL(I)-TR;
	IMAG(J):=IMAG(I)-TI;
	REAL(I):=REAL(I)+TR;
	IMAG(I):=IMAG(I)+TI;
	I:=I+STEP
      'UNTIL' I>=NPOINTS-1;
    'END';
    L:=STEP;
  'END'
'END';

'PROC'MAG(X,Y,S);
'REAL'X,Y,S;
'INTEGER'I;
'FOR'I:=0,NPOINTS-1'DO''BEGIN'
  X(I):=S*SQRT(X(I)*X(I)+Y(I)*Y(I));
  Y(I):=0.0
'END';

'BEGIN'
  SETHI;CLEAR;SETTXT;
  SINTAB:=RLRES(NPOINTS+1);
  X:=RLRES(NPOINTS);
  Y:=RLRES(NPOINTS);
  SETSIN;
  OPENI(3);
  'FOR'I:=0,NPOINTS-1'DO'X(I):=RLIN(3);
  'FOR'I:=0,NPOINTS-1'DO'Y(I):=0.0;
  PLOT(X);

  FFT(X,Y);CHOUT(0,7);
  'IF'CH=^Y'THEN'MAG(X,Y,1.0)
  'ELSE'PLOT(Y);
  PLOT(X);
  'IF'CH=^Y'THEN'
  'FOR'I:=0,NPOINTS-1'DO''BEGIN'
    K:=RLIN(3);
    X(I):=K*X(I);
    Y(I):=K*Y(I)
  'END';
  FFT(X,Y);
  PLOT(X)
'END';
