\FRACTAL.XPL

code
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENI=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;
'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;


define XCENTER=140,YCENTER=96;

real
	SCALE,
	LAMX,LAMY,
	WX,WY;


char KEY,KEYCLR;



procedure ROOT;
real TMP,OLDY;
begin
OLDY:=WY;
TMP:=SQRT(WX*WX+WY*WY);
WY:=SQRT((-WX+TMP)/2.);
WX:=SQRT((WX+TMP)/2.);
if OLDY<0. then WX:=-WX;
end;



procedure FOUROVER;
real TMP;
begin
TMP:=LAMX*LAMX + LAMY*LAMY;
LAMX:=4.*LAMX/TMP;
LAMY:=-4.*LAMY/TMP;
end;


procedure TIMESLAM;
real TMPX,TMPY;
begin
TMPX:=WX;TMPY:=WY;
WX:=TMPX * LAMX - TMPY * LAMY;
WY:=TMPX * LAMY + TMPY * LAMX;
end;


procedure FUNCTION;
begin
TIMESLAM;
WX:=1.-WX;
ROOT;
if RAN(2)=0 then [WX:=-WX;WY:=-WY;];
WX:=1.-WX;
WX:=WX/2.;WY:=WY/2.;
end;






procedure FRACTAL;
integer X;
begin
WX:=.50001;WY:=0.;
SETHI;
CLEAR;
for X:=1,10 do FUNCTION;
loop
	begin
	DOT(FIX(SCALE*(WX-.5))+XCENTER,
	    YCENTER-FIX(SCALE*WY),$80);
	FUNCTION;
	if KEY(0)>$7F then quit;
	end;
SETTXT;
end;



procedure GETVALUE;
integer X;
begin
TEXT(0,"WHAT IS LAMBDA? (X,Y) ");
LAMX:=RLIN(0);
LAMY:=RLIN(0);
FOUROVER;
TEXT(0,"WHAT IS SCALE? ");
SCALE:=FLOAT(2*XCENTER)/RLIN(0);
KEYCLR(0):=0;
end;



begin	\MAIN
KEY:=$C000;
KEYCLR:=$C010;

loop
	begin
	GETVAL;
	FRACTAL;
	end;
end;

