\GRAPH SPECTRUM FUNCTIONS


'CODE'	\COMPLETE SET, STANDARD XPLV5D INTRINSICS
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENIN=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;
'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;


'DEF'
	TWOPI=6.2831853,
	HTOTAL=15;


'REAL'
	COSFAC,
	INC,
	FREQ,
	XPOINT,
	YPOINT,
	HARM,	\MARKS HARMONICS
	ATTEN;	\ATTENUATION FACTOR


'INTEGER'
	ODEV,
	SAMPLES,
	X,
	SINFLG,
	CHAR;


'PROCEDURE' DECIMAL;
'INTEGER' TOTAL;
'BEGIN'
TOTAL:=0;
'WHILE' CHAR>=^0 & CHAR<=^9 'DO'
	'BEGIN'
	TOTAL:=10*TOTAL+(CHAR-^0);
	CHAR:=CHIN(0);
	'END';
'RETURN' TOTAL;
'END';



'PROCEDURE' SPECTRUM;
'INTEGER' X,NUM;
'BEGIN'
'FOR' X:=1,HTOTAL 'DO'
	'BEGIN'
	ATTEN(X):=1.0;
	HARM(X):=0.0;
	'END';
CHOUT(0,$0C);
TEXT(0,"INCLUDE WHICH HARMONICS?");
CRLF(0);
TEXT(0,"ENTER ALL, SEPARATE WITH COMMAS");
CRLF(0);
TEXT(0,"END WITH RETURN");
CRLF(0);
OPENIN(0);
CHAR:=CHIN(0);
'WHILE' CHAR#$0D 'DO'
	'BEGIN'
	NUM:=DECIMAL;
	'IF' NUM>0 & NUM<=HTOTAL 'THEN' HARM(NUM):=1.0;
	CHAR:=CHIN(0);
	'END';

'FOR' X:=1,HTOTAL 'DO' 'IF' HARM(X)#0.0 'THEN'
	'BEGIN'
	TEXT(0,"ATTENUATION FOR # ");
	INTOUT(0,X);
	TEXT(0," (DEFAULT=");
	INTOUT(0,X);TEXT(0,") ");
	OPENIN(0);
	CHAR:=CHIN(0);
	'IF' CHAR=$0D 'THEN' ATTEN(X):=FLOAT(X)
		'ELSE' ATTEN(X):=FLOAT(DECIMAL);
	'END';

CHOUT(0,$0C);
'FOR' X:=1,HTOTAL 'DO'
	'BEGIN'
	'IF' HARM(X)>0.0 'THEN'
		'BEGIN'
		TEXT(0,"HARMONIC # ");
		INTOUT(0,X);
		TEXT(0," ATTENUATION ");
		INTOUT(0,FIX(ATTEN(X)));
		CRLF(0);
		'END';
	'END';
OPENIN(0);
X:=CHIN(0);
'END';



'PROCEDURE' FORMULA;
'BEGIN'
YPOINT:=SIN(XPOINT*HARM(1))/ATTEN(1)+
	SIN(XPOINT*2.0*HARM(2))/ATTEN(2)+
	SIN(XPOINT*3.0*HARM(3))/ATTEN(3)+
	SIN(XPOINT*4.0*HARM(4))/ATTEN(4)+
	SIN(XPOINT*5.0*HARM(5))/ATTEN(5)+
	SIN(XPOINT*6.0*HARM(6))/ATTEN(6)+
	SIN(XPOINT*7.0*HARM(7))/ATTEN(7)+
	SIN(XPOINT*8.0*HARM(8))/ATTEN(8)+
	SIN(XPOINT*9.0*HARM(9))/ATTEN(9)+
	SIN(XPOINT*10.0*HARM(10))/ATTEN(10)+
	SIN(XPOINT*11.0*HARM(11))/ATTEN(11)+
	SIN(XPOINT*12.0*HARM(12))/ATTEN(12)+
	SIN(XPOINT*13.0*HARM(13))/ATTEN(13)+
	SIN(XPOINT*14.0*HARM(14))/ATTEN(14)+
	SIN(XPOINT*15.0*HARM(15))/ATTEN(15);
'END';



'PROCEDURE' DATA;
'BEGIN'
TEXT(0,"OUTPUT DEVICE?");
ODEV:=INTIN(0);
OPENO(ODEV);
SPECTRUM;
TEXT(0,"FREQUENCY? ");
FREQ:=RLIN(0);
TEXT(0,"NUMBER OF SAMPLES? ");
SAMPLES:=INTIN(0);
INC:=FREQ/FLOAT(SAMPLES);
TEXT(0,"SINE OR COSINE? ");
COSFAC:='IF' CHIN(0)=^S 'THEN' 0. 'ELSE' 1.5707963;

'FOR' X:=1,SAMPLES 'DO'
	'BEGIN'
	XPOINT:=(FLOAT(X)*INC*TWOPI)+COSFAC;
	FORMULA;
	RLOUT(ODEV,YPOINT);
	CRLF(ODEV);
	'END';
'END';





'BEGIN'	\MAIN
HARM:=RLRES(HTOTAL+1);
ATTEN:=RLRES(HTOTAL+1);
'REPEAT'
	'BEGIN'
	DATA;
	TEXT(0,"MORE? ");
	OPENIN(0);
	'END'
'UNTIL' CHIN(0)=^N;
CHOUT(ODEV,$1A);
CLOSE(ODEV);
'END';
