\GRAD.XPL	AUG-05-90
\DRAW A CONTINUOUS GRADIENT OF GRAY SHADES ON THE PC

code
ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	KEYHIT=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68;
code real
RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,
SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,	MOD=58,		LOG=59,		COS=60,
TAN=61,		ASIN=62,	ACOS=63;

int	II;


func	F(I,J);
int	I,J;
real	RI, RJ;
begin
RI:= FLOAT(I -320);
RJ:= FLOAT(J -240);
return FIX( SQRT(RI*RI + RJ*RJ) );
end;	\F



proc	DRAWBOX(X, Y, C);
int	X, Y, C;
int	I;
def	H=40, W=40;
begin
for I:= X+0, X+W-1 do
	begin
	MOVE(I, Y);
	LINE(I, Y+H, C+16);
	end;
end;	\DRAWBOX



proc	DRAWBOX2(X, Y, C);
int	X, Y, C;
int	I, J, F;
def	H=40, W=20;
begin
C:= C /2 +16;
F:= REM(0)#0;
for J:= Y+0, Y+H-1 do
    for I:= X+0, X+W-1 do
	begin
	POINT(I, J, if F then C+RAN(2) else C);
	end;
end;	\DRAWBOX2



proc	DRAWBOX3(X, Y, C);
int	X, Y, C;
int	I, J, R, C1;
def	H=40, W=10;
begin
C:= C /4 +16;
R:= REM(0);
C1:= C +1;
for J:= Y+0, Y+H-1 do
    for I:= X+0, X+W-1 do
	begin
	case R of
	  0:	POINT(I, J, C);
	  1:	POINT(I, J, if RAN(4) > 0 then C else C1);
	  2:	POINT(I, J, if RAN(4) > 1 then C else C1);
	  3:	POINT(I, J, if RAN(4) > 2 then C else C1)
	other;
	end;
end;	\DRAWBOX3



proc	DRAWBOX4(X, Y, C);
int	X, Y, C;
int	J, R, C1;
def	H=40, W=1;
begin
C:= C /40 +16;
R:= REM(0);
C1:= C +1;
for J:= Y+0, Y+H-1 do
	POINT(X, J, if R > RAN(40) then C1 else C);
end;	\DRAWBOX4



proc	DRAWPOINT(X, Y, C);
int	X, Y, C;
begin
C:= C/40 +16;
POINT(X, Y, if REM(0) > RAN(40) then C+1 else C);
end;	\DRAWPOINT



proc	DRAWGRAD;
int	I,J;
real	RI, RJ, RJ2;
begin
for I:= 0, 15 do
	DRAWBOX(I*640/16, 0, I);

\for I:= 0, 32-1 do
\	DRAWBOX2(I*640/32, 100, I);

\for I:= 0, 64-1 do
\	DRAWBOX3(I*10, 200, I);

\for I:= 0, 640-1 do
\	DRAWBOX4(I, 300, I);

\for I:= 0, 640-1 do
\	DRAWBOX4(I, 400, F(I));

for J:= 0, 480-1 do
	begin
	RJ:= FLOAT(J -240);
	RJ2:= RJ *RJ;
	for I:= 0, 640-1 do
		begin
		RI:= FLOAT(I -320);
		DRAWPOINT(I, J, 599 - FIX( SQRT(RI*RI + RJ2) ) <<1 );
		end;
	end;
end;	\DRAWGRAD



begin	\MAIN
SETVID($62);
CLEAR;
\for II:= 0, 15 do			\\SET UP 16 SHADES OF GRAY
\	PALETTE(II, II<<8 ! II<<4 ! II);

DRAWGRAD;
repeat until KEYHIT;
SETVID($02);
end;	\MAIN
