\INSTALL.XPL	JAN-07-87
\PROGRAM TO INSTALL HANDLERS
\BY P.J.R. BOYLE

\SYSI2L CANNOT BE USED BECAUSE IT DOES NOT HAVE THE SCAN INTRINSIC

\REVISION HISTORY:
\DEC-21-82, ORIGINAL
\JAN-07-87, CHANGED COMMENTS ONLY, L.B.

code
RAN=1		REM=2		RESERVE=3	SWAP=4
EXTEN=5		RESTRT=6	CHIN=7		CHOUT=8
CRLF=9		NUMIN=10	NUMOUT=11	TEXT=12
OPENI=13	OPENO=14	CLOSE=15	ABORT=16
TRAP=17		SPACE=18	RERUN=19	GETSP=20
SETSP=21	GETERR=22	CURSOR=23	SCAN=24
SETRUN=25	CHAIN=28	FWRITE=30	FREAD=31;

integer I,CH,TARGAD,LOMEM,HIMEM,UNIT,BLOCK;
address BUFFER,SYSPAG;
define RESSIZ=48;



proc ERROR(STRING);
address STRING;
begin
CRLF(0);
TEXT(0,"INSTALL ERROR - ");
TEXT(0,STRING);
ABORT;
end;	\ERROR



proc HXOUT(DEV,VAL);
\ OUTPUT A HEX BYTE
integer DEV,VAL;

	proc HOUT(DIGIT);
	integer DIGIT;
	begin
	if DIGIT<=9 then CHOUT(DEV,DIGIT+^0)
	else CHOUT(DEV,DIGIT-10+^A)
	end;

begin
HOUT((VAL&$F0)/16);HOUT(VAL&$F)
end;



proc HWDOUT(DEV,VAL);
\ OUTPUT A HEX WORD (16 BITS)
integer DEV,VAL;
begin
HXOUT(DEV,SWAP(VAL));
HXOUT(DEV,VAL)
end;



proc GETCH(DEV);
integer DEV;
repeat
  CH:= CHIN(DEV);
until (CH>$20)!(CH=26);



proc ISHEX;
return ((CH>=^0)&(CH<=^9))!((CH>=^A)&(CH<=^F));



proc WTHEX(DEV);
integer DEV;
while not ISHEX do GETCH(DEV);



proc GETHEX(DEV);
integer DEV,SUM;

	proc GETNYB;
	integer DUMMY;
	begin
	if not ISHEX then ERROR("INVALID INPUT");
	return if CH<=^9 then CH-^0
	else CH-^A+10;
	end;	\GETNYB

begin	\GETHEX
SUM:= GETNYB;
GETCH(DEV);
SUM:= 16*SUM+GETNYB;
return SUM
end;	\GETHEX



proc HEXWRD(DEV);
integer DEV,A;
begin
A:= SWAP(GETHEX(DEV));
GETCH(DEV);
A:= A+GETHEX(DEV);
return A;
end;



proc GETADD;
begin
CRLF(0);CHOUT(0,^*);
GETCH(3);
TARGAD:= HEXWRD(3);
HWDOUT(0,TARGAD);
end;	\GETADD



proc MOVBYTE;
integer X;
begin
X:= GETHEX(3);
if (TARGAD<LOMEM)!(TARGAD>HIMEM) then return;
if TARGAD>=$D000 then [BUFFER(TARGAD-$D000):= X;CHOUT(0,^.)]
else [BUFFER(TARGAD-$B000):= X;CHOUT(0,^-)];
TARGAD:= TARGAD+1;
end;	\MOVBYTE



begin	\MAIN
SYSPAG:= $BF00;
UNIT:= SYSPAG($52);
BUFFER:= RESERVE(256*RESSIZ);
BLOCK:= RESERVE(4);
OPENI(0);OPENO(0);
TEXT(0,"
RESIDENT CODE INSTALLER V2.1
WHAT UNIT: ");
UNIT:= NUMIN(0);
SCAN(UNIT, BLOCK, "RESCOD  SYS ");
if BLOCK(0)#17 then ERROR("RESCOD.SYS MUST BE IN FIRST FILE ON DISK");
if (BLOCK(1)-BLOCK(0)+1)#RESSIZ then ERROR("RESCOD.SYS MUST BE 48 BLOCKS LONG");
FREAD(UNIT,17,BUFFER,RESSIZ);

\RANGES WE ARE ALLOWED TO AFFECT:
LOMEM:= $B000;
HIMEM:= $FFFF;


\NOW LOAD IT
TARGAD:= 0;
OPENI(3);
GETCH(3);
loop case CH of
    ^*:[GETADD;GETCH(3)];
    26: quit
    else [MOVBYTE;GETCH(3)];

CRLF(0);
TEXT(0,"WE ARE ABOUT TO MODIFY
THE FILE RESCOD.SYS ON UNIT ");NUMOUT(0,UNIT);
CRLF(0);
TEXT(0,"IS THIS WHAT YOU WANT TO DO? (Y OR N):");
OPENI(0);
if CHIN(0)#^Y then
	begin
	TEXT(0,"OK, WE FORGET IT..");
	exit;
	end;
FWRITE(UNIT,17,BUFFER,RESSIZ);
TEXT(0,"THE DEED IS DONE");
CRLF(0);
end;	\MAIN
