
include C:\CXPL\CODESI.XPL;

int P,X,CPUREG,DHANDLE,DSEG;

int VOC_DRIVER,AUX_DRIVER;
int CTV_STATUS,CTV_FADE,CTV_PAN;

char SBUFFER;

int VOLUMES;

procedure BLANK;
CHOUT(0,$0C);


procedure LOADRIVER(HANDLE);
\Load device driver specified by HANDLE
\Return segment where driver loaded
int HANDLE,SEGMENT; int SIZEL,SIZEH;
begin
\Get driver file size
CPUREG(0):=$4202; CPUREG(1):=HANDLE;
CPUREG(2):=0; CPUREG(3):=0;
SOFTINT($21);
SIZEH:=CPUREG(4); SIZEL:=CPUREG(0);

\Rewind pointer
CPUREG(0):=$4200; CPUREG(1):=HANDLE;
CPUREG(2):=0; CPUREG(3):=0;
SOFTINT($21);

\Allocate memory for driver
SEGMENT:=MALLOC(SIZEL>>4 +1);

\Move driver into memory
CPUREG(0):=$3F00; CPUREG(1):=HANDLE;
CPUREG(2):=$FFFF; CPUREG(9):=SEGMENT;
CPUREG(3):=0; SOFTINT($21);
return SEGMENT;
end;



procedure SETDRIVER;
begin
\INSTALL VOC DRIVER
DHANDLE:=FOPEN("CT-VOICE.DRV",0);
VOC_DRIVER:=LOADRIVER(DHANDLE);

\INSTALL AUX DRIVER
DHANDLE:=FOPEN("AUXDRV.DRV",0);
AUX_DRIVER:=LOADRIVER(DHANDLE);
end;



procedure VOCSETUP;
begin
\GET VERSION NUMBER
CPUREG(1):=0;
EXTCAL(VOC_DRIVER,0);
TEXT(0,"VOC VERSION = ");INTOUT(0,SWAP(CPUREG(0)) & $FF);
TEXT(0,".");INTOUT(0,CPUREG(0) & $FF); CRLF(0);

\INITIALIZE DRIVER
CPUREG(1):=3;
EXTCAL(VOC_DRIVER,0);
TEXT(0,"VOC INIT CODE = ");HEXOUT(0,CPUREG(0)); CRLF(0);

\SETUP STATUS WORD
CPUREG(1):=5;
CPUREG(11):=DSEG;
CPUREG(4):=add CTV_STATUS;
EXTCAL(VOC_DRIVER,0);

\GET CARD TYPE
CPUREG(1):=20;
EXTCAL(VOC_DRIVER,0);
TEXT(0,"CARD TYPE = ");HEXOUT(0,CPUREG(0)); CRLF(0);

\SET SOUND SOURCE
CPUREG(1):=17;
CPUREG(0):=3;
EXTCAL(VOC_DRIVER,0);
TEXT(0,"OLD SOURCE = ");HEXOUT(0,CPUREG(0)); CRLF(0);
end;



procedure MIXSETUP;
begin
\GET VERSION NUMBER
CPUREG(1):=0;
EXTCAL(AUX_DRIVER,0);
TEXT(0,"AUX VERSION = ");INTOUT(0,SWAP(CPUREG(0)) & $FF);
TEXT(0,".");INTOUT(0,CPUREG(0) & $FF); CRLF(0);

\INITIALIZE DRIVER
CPUREG(1):=4;
EXTCAL(AUX_DRIVER,0);
TEXT(0,"AUX INIT CODE = ");HEXOUT(0,CPUREG(0)); CRLF(0);

\SETUP STATUS WORDS
CPUREG(1):=2;
CPUREG(11):=DSEG;
CPUREG(4):=add CTV_FADE;
EXTCAL(AUX_DRIVER,0);

CPUREG(1):=3;
CPUREG(11):=DSEG;
CPUREG(4):=add CTV_PAN;
EXTCAL(AUX_DRIVER,0);
end;



procedure GETVOLUME(C);
\Return volume of channel C
int C;
begin
CPUREG(0):=C;
CPUREG(1):=7;
EXTCAL(AUX_DRIVER,0);
return CPUREG(0);
end;



procedure SETVOLUME(C,V);
\Set volume of channel C to V
int C,V;
begin
CPUREG(0):=C;
CPUREG(1):=6;
CPUREG(3):=V;
EXTCAL(AUX_DRIVER,0);
end;


procedure PREVOLUMES;
\Preset the volume values
int P;
begin
for P:=0,4 do SETVOLUME(P,$C8C8);
SETVOLUME(5,200);
end;



procedure DISVOLUME;
int P;

	procedure LEFTRIGHT(V);
	\Display left and right halves of volume
	int V;
	[INTOUT(0,SWAP(V) & $FF); TEXT(0,","); INTOUT(0,V & $FF);];

begin
BLANK;
for P:=0,5 do VOLUMES(P):=GETVOLUME(P);

TEXT(0,"[M]ASTER= "); LEFTRIGHT(VOLUMES(0)); CRLF(0);
TEXT(0,"[V]OICE= "); LEFTRIGHT(VOLUMES(1)); CRLF(0);
TEXT(0,"[F]M= "); LEFTRIGHT(VOLUMES(2)); CRLF(0);
TEXT(0,"[C]D= "); LEFTRIGHT(VOLUMES(3)); CRLF(0);
TEXT(0,"[L]INE-IN= "); LEFTRIGHT(VOLUMES(4)); CRLF(0);
TEXT(0,"MI[K]E= "); INTOUT(0,VOLUMES(5)); CRLF(0);
end;




procedure RECORD;
begin
TEXT(0,"HIT A KEY TO RECORD");X:=CHIN(1);
CPUREG(1):=7;
CPUREG(0):=4000;
CPUREG(2):=32000;
CPUREG(3):=0;
CPUREG(11):=DSEG;
CPUREG(4):=SBUFFER;
EXTCAL(VOC_DRIVER,0);

while CTV_STATUS do;
end;




procedure SAMPLE;
char BUFFER;
int P,S;
def SIZE=100;
begin
BUFFER:=RESERVE(SIZE);
CPUREG(1):=7;
CPUREG(0):=4000;
CPUREG(2):=SIZE;
CPUREG(3):=0;
CPUREG(11):=DSEG;
CPUREG(4):=BUFFER;
EXTCAL(VOC_DRIVER,0);
while CTV_STATUS do;
S:=0;
for P:=16,SIZE-1 do S:=S+ABS(BUFFER(P)-127);
return S/SIZE;
end;




procedure PLAY;
begin
TEXT(0,"HIT A KEY TO PLAY");X:=CHIN(1);
CPUREG(1):=6;
CPUREG(0):=4000;
CPUREG(2):=32000;
CPUREG(3):=0;
CPUREG(11):=DSEG;
CPUREG(4):=SBUFFER;
EXTCAL(VOC_DRIVER,0);

while CTV_STATUS do;
end;



procedure EXAMINE;
int P;
begin
P:=0;
loop
	begin
	HEXOUT(0,P);
	TEXT(0," - ");
	HEXOUT(0,SBUFFER(P));
	TEXT(0," - ");
	CHOUT(0,SBUFFER(P) & $7F);
	CRLF(0);
	OPENI(0);
	case CHIN(1) of
	^-: P:=P-1;
	^+,$0D: P:=P+1;
	$1B: quit
	else;
	end;
end;



procedure GRAPH;
int BASE;
begin
BASE:=16;
loop
	begin
	SETVID(6);
	MOVE(0,100);
	for P:=0,639 do LINE(P,100+EXTEND(SBUFFER(P+BASE)-128),1);
	CURSOR(0,24);INTOUT(0,BASE);
	OPENI(0);
	case CHIN(1) of
	^+,$0D: BASE:=BASE+640;
	^-: BASE:=BASE-640;
	$1B: quit
	else;	
	end;
SETVID(3);
end;



procedure MENU;
int T,P;

	procedure DECODE;
	begin
	case CHIN(1) of
	^M: SETVOLUME(0,VOLUMES(0)+$0101);
	^m: SETVOLUME(0,VOLUMES(0)-$0101);
	^V: SETVOLUME(1,VOLUMES(1)+$0101);
	^v: SETVOLUME(1,VOLUMES(1)-$0101);
	^F: SETVOLUME(2,VOLUMES(2)+$0101);
	^f: SETVOLUME(2,VOLUMES(2)-$0101);
	^C: SETVOLUME(3,VOLUMES(3)+$0101);
	^c: SETVOLUME(3,VOLUMES(3)-$0101);
	^L: SETVOLUME(4,VOLUMES(4)+$0101);
	^l: SETVOLUME(4,VOLUMES(4)-$0101);
	^K: SETVOLUME(5,VOLUMES(5)+1);
	^k: SETVOLUME(5,VOLUMES(5)-1);

	^G,^g: GRAPH;
	^e,^E: EXAMINE;
	^p,^P: PLAY;
	^r,^R: RECORD;
	$1B: return false
	else;
	DISVOLUME;
	return true;
	end;

begin
DISVOLUME;
OPENI(0);
loop
	begin
	if CHKKEY then
	if not DECODE then quit;
	T:=SAMPLE;
	CURSOR(0,22);
	TEXT(0,"LEVEL=");
	CURSOR(0,23);
	for P:=0,78 do if P<T then CHOUT(0,$DB) else CHOUT(0,$20);
	end;
end;


begin
CPUREG:=GETREG;
DSEG:=CPUREG(12);
SBUFFER:=RESERVE(32000);

VOLUMES:=RESERVE(6*2);


SETDRIVERS;
VOCSETUP;
X:=CHIN(1);

PREVOLUME;
MENU;
end;
