include C:\CXPL\CODESI.XPL;


\KEY BOARD SCAN CODE DEFINITIONS

define
	FUNC1=59,	\FUNCTION 1
	FUNC2=60,	\FUCNTION 2
	DELETE=83,	\DELETE KEY
	PAGEDN=81,	\PAGE DOWN KEY
	PAGEUP=73,	\PAGE UP KEY
	HOME=71,	\HOME KEY
	END=79,		\END KEY
	LFARROW=75,	\LEFT ARROW KEY
	RTARROW=77,	\RIGHT ARROW KEY
	UPARROW=72,	\UP ARROW KEY
	DNARROW=80;	\DOWN ARROW KEY

define		\SOME ASCII CHARACTERS
	BEL=7,		\BELL CHARACTER
	TAB=$09,	\TAB
	EOF=$1A,	\END OF FILE
	BS=8,		\BACKSPACE
	DEL=8,		\DELETE CHARACTER
	SP=$20,		\SPACE
	ESC=$1B,	\ESCAPE
	CR=13,		\CARRIAGE RETURN
	LF=10,		\LINE FEED
	FF=12;		\FORM FEED


char STR;




procedure SCOPY(S1,S2);
\COPY STRINGS S2 INTO S1
char S1,S2;
int I;
for I:=0,32767 do
[S1(I):=S2(I);if S1(I)>$7F then return];



procedure STRLEN(S);
\FIND STRING LENGTH
char S;
int I;
for I:=0,32767 do
if S(I)>$7F then return I+1;


\------------------- USER INTERFACE ROUTINES ---------------------------


procedure LINEDIT(STR,BX,BY,LEN,LIM,ATT);
\Procedure to edit single line string
\ String in STR, Window location in BX,BY,LEN
\ String limit in LIM, Window attribute in ATT
char STR; int BX,BY,LEN,LIM,ATT;
int LCURSOR,SEND,COM,FLAG;char STEMP;

	procedure UPDATE;
	\UPDATE DISPLAY
	int P,S,X;
	begin
	ATTRIB(ATT);
	SETWIND(BX,BY,BX+LEN,BY,$FF02,true);
	if LCURSOR>LEN then [S:=LCURSOR-LEN; X:=BX+LEN;]
	else [S:=0;X:=BX+LCURSOR;];
	for P:=S,SEND-1 do CHOUT(6,STEMP(P));
	HILIGHT(X,BY,X,BY,$70);
	end;

	procedure DELCHAR(L);
	\DELETE CHARACTER AT L
	int L,P;
	begin
	for P:=L,SEND-1 do STEMP(P):=STEMP(P+1);
	SEND:=SEND-1;
	if LCURSOR>SEND then LCURSOR:=SEND;
	end;

	procedure PUTCHAR(C,L);
	\INSERT CHARACTER AT L
	int C,L,P;
	begin
	if SEND>=LIM then return true;
	if C<$20 ! C>$7F then return false;
	for P:=-(SEND-1),-L do STEMP((-P)+1):=STEMP(-P);
	STEMP(L):=C;
	SEND:=SEND+1;
	LCURSOR:=LCURSOR+1;
	return true;
	end;

begin
STEMP:=RESERVE(LIM);
SCOPY(STEMP,STR);
SEND:=if STEMP(0)=$A0 then 0 else STRLEN(STEMP);
LCURSOR:=SEND;
if SEND#0 then STEMP(SEND-1):=STEMP(SEND-1) & $7F;

loop
	begin
	UPDATE;
	CURSOR(0,25);
	COM:=CHIN(1);if COM=0 then COM:=-CHIN(1);
	case COM of
	ESC: [CURSOR(0,24); return;];
	CR: quit;
	^H-$40: if LCURSOR>0 then
			begin
			FLAG:=LCURSOR<SEND;
			DELCHAR(LCURSOR-1);
			if FLAG then LCURSOR:=LCURSOR-1;
			end;
	-DELETE: if LCURSOR<SEND then DELCHAR(LCURSOR);
	-LFARROW: if LCURSOR>0 then LCURSOR:=LCURSOR-1;
	-RTARROW: if LCURSOR<SEND then LCURSOR:=LCURSOR+1
	other if not PUTCHAR(COM,LCURSOR) then quit;
	end;
CURSOR(0,24);
if SEND=0 then STEMP(0):=$A0 else STEMP(SEND-1):=STEMP(SEND-1) ! $80;
SCOPY(STR,STEMP);
end;






begin
STR:=RESERVE(80);
SCOPY(STR,"NOW IS THE TIME");

CHOUT(0,$0C);
LINEDIT(STR,10,10,20,40,$17);
end;
