\LODBX.XPL	FEB-08-95
\.BIN FILE LOADER FOR DFM

code	ABS=0		RAN=1		REM=2		RESERVE=3
	SWAP=4		EXTEND=5	RESTART=6	CHIN=7
	CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
	TEXT=12		OPENI=13	OPENO=14	CLOSE=15
	ABORT=16	TRAP=17 	GETERR=22 	HEXOUT=27
	FSET=24,	FOPEN=29,	FCLOSE=32;

int	CH, PC, BASE, SIZE, COUNT, II, ROWS, ROW;
char	DATA;
int	INHAND, OUTHAND;
char	NAME, CHAR;
def	NAMMAX=80;



func	GETNAME(DEFEXT);	\Get a file name from the user
char	DEFEXT;
int	EXTFLG, I, K;
char	CHAR;
begin
EXTFLG:= false;

for I:= 0, NAMMAX do NAME(I):= 0;
CHAR:= CHIN(0);			\GET STARTING CHAR

\EAT LEADING SPACES AND CONTROL CHARS
while CHAR<=$20 do CHAR:= CHIN(0);

\COPY FILE NAME INTO 'NAME'
K:= 0;
	
loop	begin
	case CHAR of
	^. : EXTFLG:= true;
	$D : quit 
	else;

	NAME(K):= CHAR;
	K:= K+1;
	if K>=NAMMAX  then return false;
	CHAR:= CHIN(0);
	end;

\DEAL WITH EMPTY FILENAME
if K=0 then return false;

\DEAL WITH DEFAULT EXTENTIONS
if EXTFLG then NAME(K-1):= NAME(K-1) ! $80
else	begin
	if (K+4)>=NAMMAX then return false;
	NAME(K):= ^.;
	K:= K+1;
	for I:= 0, 2 do NAME(K+I):= DEFEXT(I);
	end;
\for I:= 0, NAMMAX do CHOUT(0, NAME(I)&$7F);
\CRLF(0);
return true;
end;	\GETNAME



proc	OPENIN;		\OPEN A FILE FOR INPUT
int	I;
begin
TEXT(0, "INPUT FILE:  ");
if not GETNAME("XPL") then [TEXT(0, "NAME ERROR"); exit];
TRAP($FFFB);
INHAND:= FOPEN(NAME, 0);
TRAP($FFFF);
if GETERR=3 then [TEXT(0, "FILE NOT FOUND"); exit];
FSET(INHAND, ^I);
OPENI(3);
end;	\OPENIN



proc	OPENOUT;	\OPEN A FILE FOR OUTPUT
int	I;
begin
TEXT(0, "OUTPUT FILE: ");
if not GETNAME("LST") then [TEXT(0, "NAME ERROR"); exit];
TRAP($FFFB);
OUTHAND:= FOPEN(NAME, 1);
TRAP($FFFF);
if GETERR=3 then [TEXT(0, "FILE NOT OPENED"); exit];
FSET(OUTHAND, ^O);
OPENO(3);
end;	\OPENOUT

\ ----------------------------------------------------------

proc	INONE;
begin
CH:= CHIN(3);
\CHOUT(0, CH);
end;	\INONE



proc	INCH;
begin
repeat INONE until (CH#$A)&(CH#$D);
end;	\INCH



func	ISHEX;
return ((CH>=^0)&(CH<=^9))!((CH>=^A)&(CH<=^F));



func	HEXDIG;
int	DIG;
begin
if not ISHEX then
	begin
	TEXT(0, "BAD INPUT DATA"); CRLF(0);
	exit;
	end;
if CH <= ^9 then DIG:= CH -^0
else DIG:= CH -^A +10;
INCH;
return DIG;
end;	\HEXDIG



func	HEXBYTE;
return HEXDIG*16 +HEXDIG;



proc	NEWPC;
begin
INCH;
PC:= HEXBYTE*256 +HEXBYTE;
end;	\NEWPC



proc	DOHEX;
int	BYTE, ADR;
begin
BYTE:= HEXBYTE;
ADR:= PC-BASE;
if ADR>=0 & ADR<SIZE then
	begin
	DATA(ADR):= BYTE;
	COUNT:= COUNT +1;
	end;
PC:= PC +1;
end;	\DOHEX



begin	\MAIN
TEXT(0, "LOADER FOR 8K ROM BIN FILES
");
SIZE:= 1024*8;
DATA:= RESERVE(SIZE);
for II:= 0, SIZE-1 do DATA(II):= $FF;
PC:= 0;
BASE:= $E000;
COUNT:= 0;

NAME:= RESERVE(NAMMAX+1);
CRLF(0);
OPENIN;
OPENOUT;
INCH;
loop	begin
	if CH=$1A\EOF\ then quit;
	if CH=^* then NEWPC
	else if ISHEX then DOHEX
	else	begin
		TEXT(0, "BAD BIN FILE");
		exit;
		end;
	end;
CRLF(0);
INTOUT(0, COUNT);
TEXT(0, " BYTES LOADED
");

PC:= 0;
OPENO(3);
for II:= 0, SIZE-1 do CHOUT(3, DATA(II));
CLOSE(3);
end;	\MAIN
