\MAKER.XPL
\MINI-DISK MAKER FOR APEX V1.0
'CODE'
ABS=0,         RAN=1,        REM=2,
RESERVE=3,     SWAP=4,       EXTEND=5,
REBEGIN=6,     CHIN=7,       CHOUT=8,
SKIP=9,        NUMIN=10,     NUMOUT=11,
TEXT=12,       OPENI=13,     OPENO=14,
CLOSE=15,      ABORT=16,     TRAP=17,
SPACE=18,      RERUN=19,     GETSP=20,
SETSP=21,      ERRFLG=22,    CURSOR=23,
SETRUN=25,     FGET=26,      FASAVE=27,
FRUN=28,       FSAVE=29,     FWRITE=30,
FREAD=31,      FRESTOR=32;



\THE DIRECTORY
'ADDRESS'
	PRDEV,	\DEVICE ASSOSIATED WITH PRNAM
	TITLE,	\TITLE OF THE VOLUME
	PRNAME,	\THE REMEMBERED FILE
	FNAME,	\THE FILE NAMES
	FSTAT,	\THE FILE STATUS
	FLAGS,	\SPECIAL REQUEST FLAGS
	FREE1;	\UNUSED
\INTEGER ARRAYS IN THE DIRECTORY
'INTEGER'
	PMAXB,	\DISK SIZE, MAX BLOCK NUMBER
	DIRDAT,	\DIRECTORY DATE
	VOLUME,	\UNIQUE DISK ID NUMBER
	FDATE,	\DATE OF FILES
	FBLK,	\THE FIRST BLOCK
	LBLK;	\THE LAST BLOCK

\SOME ABSOLUTE ADDRES
'ADDRESS'
	COMPAG,PARM,IOPAG;

\THE SYSTEM GLOBALS:
'ADDRESS'
	RNAM,	\DEFAULT FILE NAME
	STAB,	\SORT POINTER ARRAY
	LOCNAM;	\LOCAL NAME OF FILE

'INTEGER'
	DRVSET,	\DRIVE SPECIFIED FLAG
	PAKFLG,	\PACKING WANTED?
	BAKFLG,	\BACKUPS WANTED?
	CHKFLG,	\CHECKS WANTED?
	RDEV,	\DEFAULT FILE DEVICE
	LOCDEV,	\DEVICE USER ASKED FOR
	DIRDEV,	\DEVICE WE HAVE THE DIRECTORY OF
	SYSDEV,	\THE SYSTEM DEVICE CURRENTLY
	DONE,	\KLUGE
	BLKSIZ,	\SIZE OF A BLOCK IN BYTES
	DIRSIZ,	\DIR SIZE
	SWAPSIZ,\SWAPPING SIZE
	DIRBLK,	\WHERE DIRECT IS
	SWAPBLK,\SWAPPING AREA
	SYSBLK,	\WHERE SYSTEM IS
	USERBLK,\FIRST USER BLOCK
	BACKBLK,\BLOCK TO PU BACKUP DIR IN
	SYSLEN,	\HOLDS LENGTH OF SYSTEM AREA ON DEVICE
	FIRBLK,	\FIRST BLOCK OF FILE
	LASBLK,	\LAST BLOCK OF FILE
	FLNO,	\NUMBER OF FILE
	ACTDEV,	\HOLDS DEVICE NUMBER OF ACTIVE DEVICE
	MAXBLK,	\HIGHEST BLOCK
	MAXFL,	\HIGHEST FILE NO
	CHAR,	\INPUT CHARACTER
	SWAPFLG,\=0 IF SWAPPING AREA IS INVALID
	SWITCH,	\USER FILE SWITCH
	ARG1,	\USER ARGUMENT
	ARG2,	\USER ARGUMENT
	SPECIAL,\SPECIAL BITS IN PROGRAM FILE REQUEST
	SYSDAT,	\SYSTEM DATE
	INSIZE,	\SIZE OF LAST OPENED INFILE
	INDATE,	\DATE OF LAST INFILE
	MAXSTB,	\SIZE OF STAB ARRAY
	FILENO;	\RUN FILE NUMBER

\FOR MAIN
'ADDRESS'BOOT,START;
'INTEGER'I,DEV1,DEV2,BLK;



\ASCII CONSTANTS
'DEFINE'CR=13,EOF=26,TAB=9,BEL=7,FORM=12;

\FILE STATUS IN THE DIRECTORY
'DEFINE' NULL=0,TENTATIVE=255,REPLACE=254,VALID=1;

\FILE STATUS IN COMM AREA
'DEFINE' NOFILE=0,SETUP=1,CLOSED=255;

\SYSTEM REENTRY CONDITIONS
'DEFINE' SWAPIN=254,SAVEIN=255,BOOTIN=253,RELOAD=252;

\FAILED FLAG
'DEFINE' NONE=65535;

\DEFINE SOME OFFSETS INTO COMM PAGE

'DEFINE'
	SIZEOFF=$17,		\PROGRAM SIZE IN PAGES
	DFOOFF=$21,		\DEFAULT EXT FOR OUTPUT FILE
	DFIOFF=$24,		\DEFAULT EXT FOR INPUT FILE
	DFSOFF=$27;		\SPECIAL DEFAULT FLAG BYTE

\DEFINE SOME OFFSETS INTO SYSTEM PAGE

'DEFINE'
	OTLBKL=$70,		\LOW BLOCK NUMBER
	OTLBKH=$71,
	OTHBKL=$72,		\HIGH BLOCK NUMBER
	OTHBKH=$73,
	OTFLG=$74,		\OUTPUT FILE STATUS FLAGS
	OTNO=$75,		\OUTPUT FILE NUMBER IN DIRECTORY
	OTDEV=$76,		\DEVICE NUMBER OUTPUT FILE IS ON

	INLBKL=$78,		\LOW BLOCK NUMBER
	INLBKH=$79,
	INHBKL=$7A,		\HIGH BLOCK NUMBER
	INHBKH=$7B,
	INFLG=$7C,		\INPUT FILE STATUS FLAG
	INNO=$7D,		\INPUT FILE NUMBER IN DIRECTORY
	INDEV=$7E,		\DEVICE NUMBER INPUT FILE IS ON

	SYSENT=$50,		\HOW WE REENTER THE SYSTEM
	OKDRVS=$51,		\TO GET UNIT PERMIT MASK
	DEFDEV=$52,		\THE SYSTEM UNIT NUMBER
	SYBLKX=$53		\THE SYSTEM BLOCK
	SWBLKX=$55		\THE SWAP BLOCK
	DATOFF=$57,		\OFFSETS TO SYSTEM DATE
	DATOF1=$58,
	DATOF2=$59;




	'PROCEDURE'NEXT;
	'BEGIN'
	CHAR:=CHIN(0);
	'IF' CHAR=^/ 'THEN' [SWITCH:=CHIN(0);NEXT];
	'IF'CHAR>=^a & CHAR<=^z'THEN'CHAR:=CHAR-32;
	'END';






	'PROCEDURE'CRLF;
	SKIP(0);






	'PROCEDURE'STR(TXT);
	'ADDRESS'TXT;
	TEXT(0,TXT);




	'PROCEDURE'NUM(I);
	'INTEGER'I;
	NUMOUT(0,I);


	'PROCEDURE'NUMERIC;
	'EXIT'CHAR>=^0 & CHAR<=^9;


	'PROCEDURE'NUMBER;
	'INTEGER'I;
'BEGIN'
'WHILE''NOT'NUMERIC'DO'NEXT;
I:=0;
'WHILE'NUMERIC'DO'[I:=I*10+CHAR-^0;NEXT];
'EXIT'I;
'END';


	'PROCEDURE'ALPH;

\CHECK FOR ALPHANUMERIC OR "?"
'EXIT'NUMERIC!(CHAR>=^A&CHAR<=^Z)!CHAR=^?;


	'PROCEDURE'ERROR(LINE);
'ADDRESS'LINE;
'BEGIN'
CHOUT(0,BEL);
STR("NOPE-");STR(LINE);
PARM(SYSENT):=BOOTIN;
REBEGIN;
'END';






	'PROCEDURE'VALDRV(DRV);
'INTEGER'DRV,MASK,I;
'BEGIN'
'IF'DRV<0 ! DRV>7'THEN'ERROR("BAD UNIT NUMBER")
'ELSE'	'BEGIN'
	MASK:=1;
	'FOR'I:=1,DRV'DO'MASK:=MASK+MASK;
	'IF'(MASK&PARM(OKDRVS))=0'THEN'
		ERROR("YOU DONT HAVE THAT UNIT");
	'END';
'END';




	'PROCEDURE'VERIFY;

'BEGIN'
STR(" - VERIFY? ");
OPENI(0);
'EXIT'CHIN(0)=^Y;
'END';



'PROCEDURE'MAKEFILE(FILENO,FIRBLK,SIZE,NAME);
'INTEGER'FILENO,FIRBLK,SIZE;
'ADDRESS'NAME;
'INTEGER'I;

'BEGIN'
FBLK(FILENO):=FIRBLK;
LBLK(FILENO):=FIRBLK+SIZE-1;
FSTAT(FILENO):=VALID;
FDATE(FILENO):=SYSDAT;
'FOR'I:=0,10'DO'
	FNAME(FILENO*11+I):=NAME(I)&$7F;
'END';






'BEGIN'\MAIN PROC\
\SETUP ABSOLUTE ADDRESSES
PARM:=$BF00;	\LOCATION OF RESIDENT SYSTEM PAGE
COMPAG:=$BF00;	\LOCATION OF PROGRAM DEPENDENT COMMUNICATIONS PAGE

BLKSIZ:=256;			\SIZE OF A BLOCK IN BYTES

SWAPBLK:=COMPAG(SWBLKX)+SWAP(COMPAG(SWBLKX+1));
SYSBLK:=COMPAG(SYBLKX)+SWAP(COMPAG(SYBLKX+1));
DIRBLK:=9;			\LOCATION OF DIRECTORY BLOCK
DIRSIZ:=4;			\SIZE OF DIRECTORY IN "BLKSIZ" BLOCKS
BACKBLK:=DIRBLK+DIRSIZ;		\LOCATION OF BACKUP DIRECTORY
USERBLK:=BACKBLK+DIRSIZ;	\START OF USER FILE SPACE

MAXFL:=47;	\SELECT SO THAT DIRSIZ IS RIGHT


\RESERVE THE ARRAYS
I:=(MAXFL+1)*2;

\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(I);
LBLK:=RESERVE(I);
\BLOCK 3
FREE1:=RESERVE(74);
PRDEV:=RESERVE(1);
PMAXB:=RESERVE(2);
PRNAME:=RESERVE(11);
TITLE:=RESERVE(60);
VOLUME:=RESERVE(2);
DIRDAT:=RESERVE(2);
FDATE:=RESERVE(I);
FLAGS:=RESERVE(8);

\NON DIR ARRAYS
LOCNAM:=RESERVE(11);
STAB:=RESERVE(48);
RNAM:=RESERVE(11);


BOOT:=RESERVE(256*9);
START:=RESERVE(256);
OPENI(0);
OPENO(0);


SYSDEV:=PARM(DEFDEV);
FREAD(SYSDEV,DIRBLK,FNAME,DIRSIZ);
SYSDAT:=PARM(DATOFF)+SWAP(PARM(DATOF1));


CRLF;
STR("MINI DISK MAKER FOR APEX V1.0");

CRLF;
STR("UNIT WITH VALID BOOTSTRAP?");
DEV1:=NUMBER;
VALDRV(DEV1);
FREAD(DEV1,0,BOOT,9);
FREAD(DEV1,17,START,1);

CRLF;
STR("*** UNIT TO ERASE? *** ");
ACTDEV:=NUMBER;
VALDRV(ACTDEV);
BLK:=0;
'FOR'I:=0,34'DO'
	'BEGIN'
	FWRITE(ACTDEV,BLK,0,13);
	BLK:=BLK+13;
	'END';

'FOR'I:=0,MAXFL'DO'FSTAT(I):=NULL;

TITLE(0):=$D+128;
VOLUME(0):=ABS(SYSDAT*256+RAN(256));
DIRDAT(0):=SYSDAT;
PRDEV(0):=SYSDEV;
'FOR'I:=0,10'DO'PRNAME(I):=^ ;
PMAXB(0):=454;
FLAGS(0):=0;
FLAGS(1):=0;
FLAGS(2):=0;

MAKEFILE(0,17,9,"RESCOD  SYS");
MAKEFILE(1,26,65,"SCRATCH SYS");
MAKEFILE(2,91,65,"SYSTEM  SYS");

FWRITE(ACTDEV,DIRBLK,FNAME,DIRSIZ);


FWRITE(ACTDEV,0,BOOT,9);
FWRITE(ACTDEV,17,START,1);

PARM(DEFDEV):=0;
FWRITE(ACTDEV,18,PARM,1);
PARM(DEFDEV):=SYSDEV;

FWRITE(ACTDEV,19,$B000,7);

PARM($15):=$00;
PARM($16):=$70;
PARM($17):=$40;
PARM($28):=$55;
PARM($30):=$00;
PARM($31):=$70;
PARM($32):=$00;
PARM($33):=$64;

STR("THE DEED IS DONE");

FASAVE(ACTDEV,91);

'END';
