\MASTER.XPL
\CREATES MASTER DIRECTORY OF
\DIRECTORIES FROM SEVERAL DIFFERNT DISKS
\COPYRIGHT 1979 LARRY FISH


 
 
'CODE'
ABS=0,		REM=2,		RESERVE=3,
SWAP=4,		CHIN=7,
CHOUT=8,	CRLF=9,		NUMIN=10,	NUMOUT=11,
TEXT=12,	OPENIN=13,	OPENOUT=14,	CLOSE=15,
ABORT=16,	SPACE=18,	FREAD=31;
 
 
\THE DIRECTORY
'ADDR'
	TITLE,	\TITLE OF THE VOLUME
	RNAM,		\THE REMEMBERED FILE
	FNAME,	\THE FILE NAMES
	FSTAT,	\THE FILE STATUS
	FLAGS,	\FFS SPECIAL REQUEST FLAGS
	FREE1,	\UNUSED
	UNUSED,	\FREE DIRECTORY SPACE
	MASTER;	\MASTER DIRECTORY
 
\THE SYSTEM GLOBALS:
'INT'
	DIRDAT,	\DIRECTORY DATE
	VOLUME,	\UNIQUE DISK ID NUMBER
	FDATE,	\DATE OF FILES
	FBLK,	\THE FIRST BLOCK
	LBLK,	\THE LAST BLOCK
	PG0,	\PAGE ZERO
	MEND,		\END OF SPACE
	DATMAR,	\MARKS DATA
	TIMAR,	\MARKS THE TITLE
	CHAR,		\CHARACTER CARRIER
	X,			\TEMP
	DIRSIZ,	\DIR SIZE
	DIRBLK,	\WHERE DIRECT IS
	USERBLK,	\FIRST USER BLOCK
	MAXBLK,	\HIGHT BLOCK
	MAXFL,	\HIGHEST FILE NO
	I,	\LOCAL FOR MAIN
	PTR;		\POINTER TO MASTER ARRAY

'PROC' VERIFY;
'BEGIN'
TEXT(0,"VERIFY? ");
OPENIN(0);
PG0(116):=255;
CHAR:=CHIN(0);
'END';

'PROC' ADVANCE;
'BEGIN'
PTR:=PTR+1;
'IF' PTR>=MEND 'THEN'
	'BEGIN'
	TEXT(0,"BUFFER OVERFLOW!!");
	ABORT;
	'END';
'END';


'PROC' STORE(CH);
'INT' CH;
'BEGIN'
MASTER(PTR):=CH;
ADVANCE;
'END';

'PROC' STORNUM(NUM);

'INT' NUM;
'BEGIN'
STORE(DATMAR);
MASTER(PTR):=NUM;
ADVANCE;
MASTER(PTR):=SWAP(NUM);
ADVANCE;
'END';
 

'PROC' STORSTR(STRING,SIZE);
'ADDR' STRING;

'INT' SIZE,X;

'BEGIN'
'FOR' X:=0,SIZE-1 'DO' STORE(STRING(X));
'END';


'PROC' PRDAT(DAT);
'INT' DAT,DAY,MO;

'BEGIN'
'IF' DAT<=0'THEN'[STORSTR("NO DATE",7);'EXIT'];
DAT:=DAT/32;DAY:=REM(0);
DAT:=DAT/16;MO:=REM(0);
STORNUM(MO);STORE(^/);
STORNUM(DAY);STORE(^/);
STORNUM(DAT+76);
'END';



'PROC'PRINT(FILE);
'INT'FILE,MIN,MAX,K,SIZE;
'BEGIN'
'FOR'K:=0,7'DO'STORE(FNAME(FILE*11+K));
STORE(^.);
'FOR'K:=8,10'DO'STORE(FNAME(FILE*11+K));
MIN:=FBLK(FILE);
MAX:=LBLK(FILE);
SIZE:=MAX-MIN+1;
STORE(^ );STORE(^ );
;STORNUM(SIZE);
'IF'SIZE<10'THEN'STORE(^ );
'IF'SIZE<100'THEN'STORE(^ );
STORE(^ );;STORNUM(MIN);
STORE(^-);;STORNUM(MAX);
STORE(^ );STORE(^ );
PRDAT(FDATE(FILE));
'END';
 
 
'PROC'DIR;
'INT'I,SUM,END,START,K,A;
'BEGIN'
K:=0;
STORE(TIMAR);
'WHILE' CHAR#(128+11) 'DO'
	'BEGIN'
	CHAR:=TITLE(K);
	STORE(CHAR);
	K:=K+1;
	'END';
'FOR'I:=0,MAXFL'DO'
	'IF'FSTAT(I)=1'THEN'
		'BEGIN'
		STORE(13);STORE(10);
		PRINT(I);
		'END';
SUM:=MAXBLK-USERBLK+1;
'FOR'I:=0,MAXFL'DO'
	'IF'FSTAT(I)=1'THEN'
		'BEGIN'
 		END:=LBLK(I);
		START:=FBLK(I);
		SUM:=SUM-(END-START+1);
		'END';
STORE(13);STORE(10);
STORSTR("FREE: ",6);
;STORNUM(SUM);
STORE(13);STORE(10);
STORE(13);STORE(10);
'END';
 
'BEGIN'\MAIN PROC\
USERBLK:=130;
DATMAR:=4;
TIMAR:=20;
PTR:=0;
PG0:=0;
 
MAXBLK:=1000;
DIRBLK:=0;
DIRSIZ:=5;
 
MAXFL:=47;	\SELECT SO THAT DIRSIZ IS RIGHT
 
\RESERVE THE ARRAYS
I:=(MAXFL+1)*2;
\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(I);
LBLK:=RESERVE(I);
\BLOCK 3
FREE1:=RESERVE(181);
RNAM:=RESERVE(11);
TITLE:=RESERVE(60);
VOLUME:=RESERVE(2);
DIRDAT:=RESERVE(2);
\BLOCK 4
FDATE:=RESERVE(I);
FLAGS:=RESERVE(8);
UNUSED:=RESERVE(248-I);
MEND:=SPACE-500;
MASTER:=RESERVE(SPACE-500);
'LOOP'
	'BEGIN'
	TEXT(0,"INSERT DISK");
	CRLF(0);
	VERIFY;
	'IF' CHAR#^Y 'THEN' 'QUIT';
	FREAD(DIRBLK,FNAME,DIRSIZ);
	DIR;
	TEXT(0,"MORE DISKS? ");
	VERIFY;
	'IF' CHAR#^Y 'THEN' 'QUIT';
	'END';
TEXT(0,"RESTORE FILE DISK!!!");
CRLF(0);VERIFY;
'IF' CHAR#^Y 'THEN' ABORT;
OPENOUT(3);
X:=0;
'WHILE' X<PTR 'DO'
	'BEGIN'
	'IF' MASTER(X)=DATMAR 'THEN'
		'BEGIN'
		X:=X+1;
		NUMOUT(3,MASTER(X)+(SWAP(MASTER(X+1))));
		X:=X+1;
		'END'
	'ELSE'
		'BEGIN'
		CHOUT(3,MASTER(X));
		X:=X+1;
		'END';
	'END';
 
 
CHOUT(3,26);
CLOSE(3);

'END';\OF ALL
 
 

