\NEWFCNS.XPL

code	ABS=0,		RANDOM=1,	REMAIN=2,	RESERVE=3,
	SWAP=4,		EXTEND=5,	SHORT=6,	CHARIN=7,
	CHAROUT=8,	CRLF=9,		NUMIN=10,	NUMOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	PROCALL=17,	SPACE=18,	RERUN=19,
	GETHEAP=20,	SETHEAP=21,

				 	MAKEFCB=58,	HEXIN=59,
	HEXOUT=60,	MLCALL=61,	PORTOUT=62,	PORTIN=63;

integer VALUE;

procedure FCBTEST;  \--------------------------------------------

define	CPMIO=5;

integer	CHAR,
	REGPAIR,
	FILENOTFOUND,
	I;

address	STRING,
	REGIMAG,
	REGRTN,
	READFCB,
	WRITEFCB;

begin
READFCB:=1430;			\location of the read file control block
WRITEFCB:=1470;			\location of the write file control block
REGRTN:=624;			\location of reg image return area
REGIMAG:=RESERVE(8);		\set aside 8 bytes for reg image
REGPAIR:=REGIMAG;	\REGPAIR lets us access a register pair at a time
STRING:=RESERVE(20);

FILENOTFOUND:=true;
repeat
begin
	CRLF(0);
	TEXT(0,"The read FCB presently contains the string: ");
	HEXOUT(0,READFCB(0));
	TEXT(0,"H ");
	for I:=1,11 do CHAROUT(0,READFCB(I));

	CRLF(0);
	TEXT(0,"Enter file name");
	I:=0;
	repeat
	 	begin
	 	CHAR:=CHARIN(0);
	 	STRING(I):=CHAR;
	 	I:=I+1;
	 	end
	until CHAR=^. ! CHAR=13\carriage return\;
	OPENI(0);			\empty input buffer
	STRING(I-1):=^.;		\make read file extension .XPL
	STRING(I):=^X;
	STRING(I+1):=^P;
	STRING(I+2):=^L;
	STRING(I+3):=0;			\terminate the string with a null
	MAKEFCB(READFCB,STRING);
	STRING(I):=^I;			\make write file extension .I2L
	STRING(I+1):=^2;
	MAKEFCB(WRITEFCB,STRING);
	REGIMAG(3):=17;			\search for filename
	REGPAIR(2):=SWAP(READFCB);
	MLCALL(CPMIO,REGIMAG);
	CRLF(0);
	TEXT(0,"Returned value = ");
	NUMOUT(0,REGRTN(1));
	CRLF(0);
	if REGRTN(1)#255 then FILENOTFOUND:=false
	 	else
	 	begin
	 	TEXT(0,"File not on disk: try again");
	 	CRLF(0);
	 	end;
end
until FILENOTFOUND=false;
OPENI(7);				\open read file

VALUE:=255;
end;

procedure PRINTHEX;  \--------------------------------------------

begin
	TEXT(0,"Enter decimal number to be converted to Hex");
	VALUE:=NUMIN(0);
	NUMOUT(0,VALUE);TEXT(0,"(decimal) = ");
	HEXOUT(0,VALUE);TEXT(0,"(hex)");CRLF(0);
end;

procedure GETHEX;  \----------------------------------------------

begin
	TEXT(0,"Enter Hex number to be converted to decimal");
	VALUE:=HEXIN(0);
	HEXOUT(0,VALUE);TEXT(0,"(hex) = ");
	NUMOUT(0,VALUE);TEXT(0,"(decimal)");CRLF(0);
end;

procedure GETPORT; \----------------------------------------------

integer PORT;

begin
	CRLF(0);
	TEXT(0,"Enter port number (decimal)");
	PORT:=NUMIN(0);
	VALUE:=PORTIN(PORT);
	TEXT(0,"Read ");NUMOUT(0,VALUE);TEXT(0,"(decimal) at Port ");
	NUMOUT(0,PORT);CRLF(0);
end;

procedure PUTPORT; \-----------------------------------------------

integer PORT;

begin
	CRLF(0);
	TEXT(0,"Enter port number (decimal)");
	PORT:=NUMIN(0);
	TEXT(0,"Enter decimal value to be sent to port ");
	NUMOUT(0,PORT);
	VALUE:=NUMIN(0);
	PORTOUT(PORT,VALUE);
end;

procedure CALL; \-------------------------------------------------

integer I,RADDR;

address RIMAG,RRIMAG;

begin
	RRIMAG:=RESERVE(8);
	RIMAG:=624;
	CRLF(0);
	TEXT(0,"Enter Flags,A,B,C,D,E,H,L as decimal values");CRLF(0);
	for I:=0,7 do RRIMAG(I):=SHORT(NUMIN(0));
	TEXT(0,"Enter decimal address of routine to be called");
	RADDR:=NUMIN(0);
	MLCALL(RADDR,RRIMAG);
	TEXT(0,"Flags=");
	NUMOUT(0,RIMAG(0));
	TEXT(0," A=");
	NUMOUT(0,RIMAG(1));
	TEXT(0," B=");
	NUMOUT(0,RIMAG(2));
	TEXT(0," C=");
	NUMOUT(0,RIMAG(3));
	TEXT(0," D=");
	NUMOUT(0,RIMAG(4));
	TEXT(0," E=");
	NUMOUT(0,RIMAG(5));
	TEXT(0," H=");
	NUMOUT(0,RIMAG(6));
	TEXT(0," L=");
	NUMOUT(0,RIMAG(7));
	CRLF(0);
end;

begin \Main program ***********************************************

repeat FCBTEST until VALUE=255;
repeat PRINTHEX until VALUE=255;
repeat GETHEX until VALUE=255;
repeat GETPORT until VALUE=255;
repeat PUTPORT until VALUE=255;

repeat
	begin
	CALL;
	TEXT(0,"Enter 255 to quit");
	VALUE:=NUMIN(0);
	end
until VALUE=255;

end;

