\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,       POINT=41,       ELINE=42,       MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
ATTRIB=69,	SETWIND=70,	RAWTEXT=71,	HILIGHT=72;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,	MOD=58,		LOG=59,		COS=60,
TAN=61,         ASIN=62,        ACOS=63;

int CPUREG,CREG,RGBA,XPM,YPM,RGB,CH,OFFSET,TEMP;

def     LFARROW=75,     \LEFT ARROW KEY
	RTARROW=77,	\RIGHT ARROW KEY
	UPARROW=72,	\UP ARROW KEY
        DNARROW=80,     \DOWN ARROW KEY
        PGUP=73,
        PGDN=81,
        HOMEKEY=71,     \HOME KEY
        ENDKEY=79;      \END KEY

proc LINE(LINX,LINY,COL);
int LINX,LINY,COL;
begin
ELINE(LINX,LINY,COL);
POINT(LINX,LINY,COL);
end;

procedure EXTKEY;
\READ KEY BOARD, EXTENDED CODES ARE NEGATED
integer C;
[C:=CHIN(1);return if C=0 then -CHIN(1) else C;];

proc SETPAL;
begin
CPUREG(0):=$1010;
CPUREG(1):=CREG;
CPUREG(2):=RGBA(1)*$100+RGBA(2);
CPUREG(3):=RGBA(0)*$100;
SOFTINT($10);
end;

proc GETPAL;
begin
CPUREG(0):=$1015;
CPUREG(1):=CREG;
SOFTINT($10);
RGBA(1):=(CPUREG(2)&$FF00)/$100;
RGBA(2):=CPUREG(2)&$FF;
RGBA(0):=(CPUREG(3)&$FF00)/$100;
end;


proc FILBOX(BX,BY,EX,EY,COL);
int BX,BY,EX,EY,COL,FILTMP;
begin
for FILTMP:=BX,EX do
        begin
        POINT(FILTMP,BY,COL);
        LINE(FILTMP,EY,COL);
        end;
end;

proc SAVE;
int HAND,I;
begin
HAND:=FOPEN("PALSAVE.SAV",1);
FSET(HAND,^O);
OPENO(3);
for I:=0,255 do
        begin
        CREG:=I;
        GETPAL;
        CHOUT(3,RGBA(0));
        CHOUT(3,RGBA(1));
        CHOUT(3,RGBA(2));
        end;
CLOSE(3);
FCLOSE(HAND);
end;

proc LOAD;
int HAND,I,LX,I2;
begin
HAND:=FOPEN("PALSAVE.SAV",0);
FSET(HAND,^I);
OPENI(3);
for I:=0,255 do
        begin
        for I2:=0,2 do
                begin
                LX:=CHIN(3);
                RGBA(I2):=LX;
                end;
        CREG:=I;
        SETPAL;
        end;
CLOSE(3);
FCLOSE(HAND);
end;


proc DBOX(DBX,DBY,DEX,DEY,DCOL);
int DBX,DBY,DEX,DEY,DCOL;
begin
POINT(DBX,DBY,DCOL);
LINE(DEX,DBY,DCOL);
LINE(DEX,DEY,DCOL);
LINE(DBX,DEY,DCOL);
LINE(DBX,DBY,DCOL);
end;

proc DRWPAL;
int OX,OY;
begin
OX:=OFFSET(0,0);
OY:=OFFSET(0,1);
DBOX(OX,OY,OX+164,OY+164,14);
for YPM:=0,15 do for XPM:=0,15 do FILBOX(OX+3+(10*XPM),OY+3+(10*YPM),OX+11+(10*XPM),OY+11+(10*YPM),YPM*16+XPM);
YPM:=0;
XPM:=0;
end;

proc DRWSCN;
int X,Y;
begin
DRWPAL;
CURSOR(50,0);
TEXT(0,"Red:");
CURSOR(50,1);
TEXT(0,"Green:");
CURSOR(50,2);
TEXT(0,"Blue:");
end;

proc RIGHT;
begin
if XPM=15 then [XPM:=0;if YPM<15 then
        YPM:=YPM+1 else YPM:=0] else XPM:=XPM+1;
end;

proc DOWN;
begin
if YPM=15 then [YPM:=0;if XPM<15 then
        XPM:=XPM+1 else XPM:=0] else YPM:=YPM+1;
end;


proc LEFT;
begin
if XPM=0 then [XPM:=15;if YPM>0 then
        YPM:=YPM-1 else YPM:=15] else XPM:=XPM-1;
end;

proc UP;
begin
if YPM=0 then [YPM:=15;if XPM>0 then
        XPM:=XPM-1 else XPM:=15] else YPM:=YPM-1;
end;

proc DRWCOL(ON);
int ON;
begin
if RGBA(3)#RGBA(0) then
        begin
        if RGBA(3)>RGBA(0) then
        FILBOX(OFFSET(1,0)+RGBA(0)+1,OFFSET(1,1),OFFSET(1,0)+RGBA(3),OFFSET(1,1)+11,0)
        else
        FILBOX(OFFSET(1,0)+RGBA(3)+1,OFFSET(1,1),OFFSET(1,0)+RGBA(0),OFFSET(1,1)+11,14);
        end;
if RGBA(4)#RGBA(1) then
        begin
        if RGBA(4)>RGBA(1) then
        FILBOX(OFFSET(1,0)+RGBA(1)+1,OFFSET(1,1)+14,OFFSET(1,0)+RGBA(4),OFFSET(1,1)+25,0)
        else
        FILBOX(OFFSET(1,0)+RGBA(4)+1,OFFSET(1,1)+14,OFFSET(1,0)+RGBA(1),OFFSET(1,1)+25,14);
        end;
if RGBA(5)#RGBA(2) then
        begin
        if RGBA(5)>RGBA(2) then
        FILBOX(OFFSET(1,0)+RGBA(2)+1,OFFSET(1,1)+28,OFFSET(1,0)+RGBA(5),OFFSET(1,1)+39,0)
        else
        FILBOX(OFFSET(1,0)+RGBA(5)+1,OFFSET(1,1)+28,OFFSET(1,0)+RGBA(2),OFFSET(1,1)+39,14);
        end;
RGBA(3):=RGBA(0);RGBA(4):=RGBA(1);RGBA(5):=RGBA(2);
CURSOR(68,RGB);if ON=1 then CHOUT(0,$1B) else CHOUT(0,^ );CURSOR(57,0);if RGBA(0)<10 then CHOUT(0,^ );
INTOUT(0,RGBA(0));CURSOR(57,1);if RGBA(1)<10 then CHOUT(0,^ );
INTOUT(0,RGBA(1));CURSOR(57,2);if RGBA(2)<10 then CHOUT(0,^ );INTOUT(0,RGBA(2));
end;

proc C(ON);
int ON,COL;
begin
CREG:=YPM*16+XPM;
GETPAL;
if ON=1 then COL:=14 else COL:=0;
DBOX(OFFSET(0,0)+2+10*XPM,OFFSET(0,1)+2+10*YPM,OFFSET(0,0)+12+10*XPM,OFFSET(0,1)+12+10*YPM,COL);
DRWCOL(ON);
end;

proc BLEND;
int FX,FY,SX,SY,ENDQ;

proc BLND(V1,V2);
int V1,V2,MID,RGBTMP,RGBFIN;
begin
if V1+1#V2 & V1-1#V2 & V1#V2 then
        begin
        RGBTMP:=RESERVE(12);
        MID:=(V1+V2)/2;
        CREG:=V1;
        GETPAL;
        for TEMP:=0,2 do RGBTMP(TEMP):=RGBA(TEMP);
        CREG:=V2;
        GETPAL;
        for TEMP:=0,2 do RGBA(TEMP):=(RGBA(TEMP)+RGBTMP(TEMP))/2;
        CREG:=MID;
        SETPAL;
        BLND(V1,MID);
        BLND(MID,V2);
        end;
end;

proc BLDC(M,ON);
int M,ON,COL;
begin
if ON=1 then COL:=14 else COL:=0;
if M=0 then
        begin
        POINT(OFFSET(0,0)+12+10*FX,OFFSET(0,1)+2+10*FY,COL);
        LINE(OFFSET(0,0)+2+10*FX,OFFSET(0,1)+2+10*FY,COL);
        LINE(OFFSET(0,0)+2+10*FX,OFFSET(0,1)+12+10*FY,COL);
        LINE(OFFSET(0,0)+12+10*FX,OFFSET(0,1)+12+10*FY,COL);
        end
else
        begin
        if FX=SX & FY=SY then DBOX(OFFSET(0,0)+2+10*FX,OFFSET(0,1)+2+10*FY,OFFSET(0,0)+12+10*FX,OFFSET(0,1)+12+10*FY,COL)
        else
                begin

                POINT(OFFSET(0,0)+12+10*FX,OFFSET(0,1)+2+10*FY,COL);
                LINE(OFFSET(0,0)+2+10*FX,OFFSET(0,1)+2+10*FY,COL);

                POINT(OFFSET(0,0)+12+10*FX,OFFSET(0,1)+12+10*FY,COL);
                LINE(OFFSET(0,0)+2+10*FX,OFFSET(0,1)+12+10*FY,COL);

                POINT(OFFSET(0,0)+12+10*SX,OFFSET(0,1)+2+10*SY,COL);
                LINE(OFFSET(0,0)+2+10*SX,OFFSET(0,1)+2+10*SY,COL);

                POINT(OFFSET(0,0)+12+10*SX,OFFSET(0,1)+12+10*SY,COL);
                LINE(OFFSET(0,0)+2+10*SX,OFFSET(0,1)+12+10*SY,COL);

                if FY*16+FX<SY*16+SX then
                        begin
                        POINT(OFFSET(0,0)+2+10*FX,OFFSET(0,1)+2+10*FY,COL);
                        LINE(OFFSET(0,0)+2+10*FX,OFFSET(0,1)+12+10*FY,COL);
                        POINT(OFFSET(0,0)+12+10*SX,OFFSET(0,1)+2+10*SY,COL);
                        LINE(OFFSET(0,0)+12+10*SX,OFFSET(0,1)+12+10*SY,COL);
                        end
                else
                        begin
                        POINT(OFFSET(0,0)+12+10*FX,OFFSET(0,1)+2+10*FY,COL);
                        LINE(OFFSET(0,0)+12+10*FX,OFFSET(0,1)+12+10*FY,COL);
                        POINT(OFFSET(0,0)+2+10*SX,OFFSET(0,1)+2+10*SY,COL);
                        LINE(OFFSET(0,0)+2+10*SX,OFFSET(0,1)+12+10*SY,COL);
                        end;

                end;

        end;
end;

begin
ENDQ:=false;
loop
        begin
                FX:=XPM;
                FY:=YPM;
        BLDC(0,1);
        loop
        if CHKKEY then
                begin
                BLDC(0,0);
                CH:=EXTKEY;
                case CH of
                -LFARROW:       LEFT;
                -RTARROW:       RIGHT;
                -UPARROW:       UP;
                -DNARROW:       DOWN;
                -HOMEKEY:       [XPM:=0;YPM:=0];
                -ENDKEY:        [XPM:=15;YPM:=15];
                $1B:            [ENDQ:=true;quit];
                $0D:            quit
                else;
                FX:=XPM;
                FY:=YPM;
                BLDC(0,1);
                end;
        if ENDQ then quit
        else
                begin
                SX:=XPM;
                SY:=YPM;
        BLDC(1,1);
        loop
        if CHKKEY then
                begin
                BLDC(1,0);
                CH:=EXTKEY;
                case CH of
                -LFARROW:       LEFT;
                -RTARROW:       RIGHT;
                -UPARROW:       UP;
                -DNARROW:       DOWN;
                -HOMEKEY:       [XPM:=0;YPM:=0];
                -ENDKEY:        [XPM:=15;YPM:=15];
                $1B:            quit;
                $0D:            [BLND(FY*16+FX,SY*16+SX);ENDQ:=true;quit]
                else;
                SX:=XPM;
                SY:=YPM;
                BLDC(1,1);
                end;
                end;
        if ENDQ then quit;
        end;
end;

proc EDITCOL;
int RGBT;
begin
RGBT:=RESERVE(12);
for TEMP:=0,2 do RGBT(TEMP):=RGBA(TEMP);
CREG:=YPM*16+XPM;
GETPAL;
C(1);
loop
        begin
        if CHKKEY then
                begin
                C(0);
                CH:=EXTKEY;
                case CH of
                -UPARROW:       if RGB=0 then RGB:=2 else RGB:=RGB-1;
                -DNARROW:       if RGB=2 then RGB:=0 else RGB:=RGB+1;
                -RTARROW:       [if RGBA(RGB)<63 then RGBA(RGB):=RGBA(RGB)+1 else RGBA(RGB):=63;SETPAL];
                -LFARROW:       [if RGBA(RGB)>0 then RGBA(RGB):=RGBA(RGB)-1 else RGBA(RGB):=0;SETPAL];
                -PGUP:          [if RGBA(RGB)<55 then RGBA(RGB):=RGBA(RGB)+8 else RGBA(RGB):=63;SETPAL];
                -PGDN:          [if RGBA(RGB)>7 then RGBA(RGB):=RGBA(RGB)-8 else RGBA(RGB):=0;SETPAL];
                -ENDKEY:        [RGBA(RGB):=63;SETPAL];
                -HOMEKEY:       [RGBA(RGB):=0;SETPAL];
                $1B:            [for TEMP:=0,2 do RGBA(TEMP):=RGBT(TEMP);SETPAL;quit];
                $0D:            quit
                else;
                C(1);
                end;
        end;
end;

proc PICKCOL;
begin
C(1);
loop
        begin
        if CHKKEY then
                begin
                C(0);
                CH:=EXTKEY;
                case CH of
                -LFARROW:       LEFT;
                -RTARROW:       RIGHT;
                -UPARROW:       UP;
                -DNARROW:       DOWN;
                -HOMEKEY:       XPM:=0;
                -ENDKEY:        XPM:=15;
                -PGUP:          YPM:=0;
                -PGDN:          YPM:=15;
                ^B:             BLEND;
                ^b:             BLEND;
                -31:            SAVE;
                -38:            LOAD;
                $1B:            exit;
                $0D:            EDITCOL
                else ;
                C(1);
                end;
        end;
end;

begin
OFFSET:=RESERVE(8);
for TEMP:=0,1 do OFFSET(TEMP):=RESERVE(8);
OFFSET(0,0):=400;
OFFSET(0,1):=50;
OFFSET(1,0):=473;
OFFSET(1,1):=1;
RGBA:=RESERVE(4*6);
RGB:=0;
RGBA(3):=0;
RGBA(4):=0;
RGBA(5):=0;
\SETVID(99);
CPUREG:=GETREG;
YPM:=0;
XPM:=0;
DRWSCN;
PICKCOL;
end;
