\PIE.XPL		OCT-13-99
\Test to see how easy it is to make a pie chart.

inc	\cxpl\codesi;

def	DataSize = 4;
def	R = 200.0,
	X0 = 320,
	Y0 = 240,
	;
real	Data,
	Old,
	X, Y,
	;
int	I,
	Color,
	Angle,
	;



func real Deg(X);	\Convert radians to degrees
real	X;
return 57.2957795130823 *X;



func real Rad(X);	\Convert degrees to radians
real	X;
return X /57.2957795130823;



begin	\Main
Data:= [23., 16., 54., 100.];	\3 data points + sentenal
SetVid($12);

\Convert percentages to accumulated degrees
Old:= 0.0;
for I:= 0, DataSize-1 do
	begin
	Old:= 360.0/100.0*Data(I) + Old;
	Data(I):= Old;
	end;

\Draw circle radially
\Take small steps around periphery (speed is not a concern)

I:= 0;
Color:= 1;
for Angle:= 0, 360*80 do
	begin
	X:= R*Cos(Rad(Float(Angle)/80.0));
	Y:= R*Sin(Rad(Float(Angle)/80.0)) * .707;
	if Float(Angle)/80.0 >= Data(I) then
		begin
		Color:= Color + 1;
		I:= I + 1;
		end;
	Move(X0, Y0);
	Line(Fix(X)+X0, Fix(Y)+Y0, Color);
	Line(Fix(X)+X0, Fix(Y)+Y0+30, Color);
	end;


I:= 0;
Color:= 1;
for Angle:= 0, 360*80 do
	begin
	X:= R*Cos(Rad(Float(Angle)/80.0));
	Y:= R*Sin(Rad(Float(Angle)/80.0)) * .707;
	if Float(Angle)/80.0 >= Data(I) then
		begin
		Color:= Color + 1;
		I:= I + 1;
		end;
	Move(X0, Y0);
	Line(Fix(X)+X0, Fix(Y)+Y0, Color);
	Point(Fix(X)+X0, Fix(Y)+Y0, 0);
	end;

I:= Chin(1);
SetVid($03);
end;	\Main
