\3-D PLOT.XPL	NOV-06-90
\BY LOREN BLANEY
\TRANSLATED FROM A BASIC PROGRAM BY MARK BRAMHALL OF DEC.
\REVISION HISTORY
\NOV-26-80, ORIGINAL.
\MAY-06-88, MODIFIED FOR MAC II.
\APR-26-90, MODIFIED FOR AMIGA WITH 68020 BOARD.
\NOV-06-90, MODIFIED FOR PC.

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
	ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
	GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
	FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
	CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
	FCLOSE=32,	KEYHIT=33,	SOFTINT=34,	GETREG=35,
	BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
	CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
	READPIX=44,	SETVID=45	FIX=50,		POUT=64,
	PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68,
	ATTRIB=69,	SETWIND=70,	RAWTEXT=71,	HILIGHT=72;
code real
	RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
	RLABS=51,	FORMAT=52,
	SQRT=53,	LN=54,		EXP=55,		SIN=56,
	ATAN2=57,	MOD=58,		LOG=59,		COS=60,
	TAN=61,		ASIN=62,	ACOS=63;

def	TV=0, KB=0;
def	TVW=640, TVH=480, TVD=1;
real	X, Y, Y1, Z, L, RDUM, GAIN;
int	I, F, D1, D2;



proc	PLOT;
real	XGAIN, YGAIN;
begin
CLEAR;
X:= -45.0;
XGAIN:= 1.0 /GAIN;
YGAIN:= 9.0 /GAIN;

while X <= 45.0 do
	begin
	L:= -150.0;
	Y1:= SQRT(2025.1 - X *X);
	Y:= Y1;
	while Y >= -Y1 do
		begin
		Z:= X + 0.3 *Y;
		Z:= SQRT(Z*Z +Y*Y);

		case F of
		  1:	Z:= 45.0 *EXP(-Z *Z /250.0);
		  2:	Z:= -45.0 *EXP(-Z *Z /250.0);
		  3:	Z:= 30.0 -30.0 *SIN(Z /18.0);
		  4:	Z:= 45.0 *SIN(Z /20.0) -15.0
		other	[Z:= -15.0 *EXP(-COS(Z /9.0)) +30.0];

		Z:= Z -0.7 *Y;
		if Z > L then
			begin
			L:= Z;

			\XPL BUG: FIX CANNOT HAVE A COMPLEX ARGUEMNT
			RDUM:= X *GAIN;   D1:= FIX(RDUM);
			RDUM:= Z *GAIN;   D2:= FIX(RDUM);
			POINT(D1+320, 300-D2, $01);
			end;

		Y:= Y -YGAIN;
		end;
	X:= X +XGAIN;
	if KEYHIT then return;
	end;
for I:= 1, 48 do	\DELAY
	[if KEYHIT then return;
	SOUND(0, 1, 1)];
end;	\PLOT



begin	\MAIN
SETVID(18);

GAIN:= 5.0;		\(CAUSES WEIRD ALISING IF NOT AN INTEGER VALUE)
loop	begin
	for F:= 1, 5 do [PLOT;   if KEYHIT then quit];
	end;
SETVID(2);
OPENO(0);
CURSOR(0, 23);
end;	\MAIN
