
\
\		***** P  O  N  G  *****
\
\	THE GRANDADDY OF VIDEO GAMES.  THIS PROGRAM IS A
\SIMPLE ILLUSTRATION OF LORES GRAPHICS FROM AN XPL0 PROGRAM.
\

	\ DEFINE MACHINE DEPENDENT FUNCTION VALUES \

'CODE'
RAN=1,		REM=2,		RESERVE=3,
EXTEN=5,	CHOUT=8,	ADVANCE=9,
INTIN=10,	INTOUT=11,	TEXT=12,
INITI=13,	INITO=14,	ABORT=16,
PDL=38,		CURSOR=23,	NOISE=39,
SETLO=36,	BLOCK=45,	SCREEN=44,
SWITCH=37,	SETMIX=35,	SETTXT=33;


	\ GLOBAL VARIABLES \

'INTEGER'	TRUE, FALSE;		\HOLDS "TRUE" AND "FALSE" BOOLEANS
'INTEGER'	I;			\VERY TEMPORARY

'INTEGER'	IDEV, ODEV;		\I-O DEVICE NUMBERS
'INTEGER'	MAXX, MAXY;		\HOLD SCREEN DIMENSIONS
'INTEGER'	X, Y;			\TEMP POSITION HOLDERS
'INTEGER'	ONBOARD;		\INDICATES WHETHER BALL IS ON PLAYING AREA
'INTEGER'	XBALL, YBALL;		\HOLDS CURRENT POSITION OF BALL
'INTEGER'	XDIR, YDIR;		\HOLDS CURRENT BALL DIRECTION INDICATORS
'INTEGER'	SLOPE, XCOUNT;		\THESE DETERMINE SLOPE OF BALL MOVEMENT

'INTEGER'	NUMBALL, TOTBALLS;	\KEEPS TRACK OF BALLS REMAINING
'INTEGER'	SCORE1, SCORE2;		\HOLDS SCORES OF THE PLAYERS
'INTEGER'	DEGREE, CURDEGREE;	\CONTROLS DEGREE OF DIFFICULTY
'INTEGER'	WARMUP;			\DETERMINES WHEN TO SWITCH DIFFICULTY FACTOR
'INTEGER'	SWNUM;			\DETERMINES WHICH BUTTON CONTROLS GAME
'INTEGER'	TXTLIN;			\HOLDS WHERE FIRST LINE OF TEXT BEGINS

'INTEGER'	PAD1Y, PAD2Y;		\HOLDS POSITIONS OF GAME PADDLES

	\ THESE VARIABLES DETERMINE COLORS \

'INTEGER'	BORDER, COLBALL, PAD1, PAD2, OBSTACLE;
'INTEGER'	BLACK, WHITE, PURPLE, BROWN, MAGENTA;



'PROCEDURE' DELAY(COUNT);
'INTEGER' COUNT, I;
'BEGIN'
'FOR' I:=1,COUNT 'DO';
'END'; \DELAY

'PROCEDURE' HLINE(BEGCOL,ENDCOL,ROW,COLOR); \PLOT HORIZ LINE
'INTEGER' BEGCOL, ENDCOL, ROW, COLOR;
'INTEGER' X;
'BEGIN'

'FOR' X:=BEGCOL,ENDCOL 'DO' [ BLOCK(X,ROW,COLOR) ];

'END'; \HLINE

'PROCEDURE' VLINE(BEGROW,ENDROW,COLUMN,COLOR); \PLOT VERT LINE
'INTEGER' BEGROW, ENDROW, COLUMN, COLOR;
'INTEGER' Y;
'BEGIN'

'FOR' Y:=BEGROW,ENDROW 'DO' [ BLOCK(COLUMN,Y,COLOR) ];

'END'; \VLINE

'PROCEDURE' MOVPD1;
'INTEGER' Y;
'BEGIN'

Y:=PDL(0)/7+1;
'IF' Y > (MAXY-7) 'THEN' Y:=MAXY-7;
'IF' Y # PAD1Y 'THEN'
	[ VLINE(PAD1Y,PAD1Y+6,0,BLACK); PAD1Y:=Y;
	  VLINE(PAD1Y,PAD1Y+6,0,PAD1) ]
    'ELSE' DELAY(60); \EQUALISE TIME

'END'; \MOVPD1

'PROCEDURE' MOVPD2;
'INTEGER' Y;
'BEGIN'

Y:=PDL(1)/7+1;
'IF' Y > (MAXY-7) 'THEN' Y:=MAXY-7;
'IF' Y # PAD2Y 'THEN'
	[ VLINE(PAD2Y,PAD2Y+6,MAXX,BLACK); PAD2Y:=Y;
	  VLINE(PAD2Y,PAD2Y+6,MAXX,PAD2) ]
    'ELSE' DELAY(60); \EQUALISE TIME

'END'; \MOVPD2



'FPROC' SAMESLOPE, SHALLOWER;

'PROCEDURE' STEEPER;
'BEGIN'

\REBOUND WITH STEEPER SLOPE 3/4 TIME

'IF' RAN(4)=0 'THEN' SHALLOWER
    'ELSE' [ SLOPE:=SLOPE/2;
	     'IF' SLOPE < 1 'THEN' SLOPE:=1 ];

'END'; \STEEPER

'PROCEDURE' SHALLOWER;
'BEGIN'

\REBOUND WITH SHALLOWER SLOPE 3/4 TIME

'IF' RAN(4)=0 'THEN' STEEPER
    'ELSE' [ SLOPE:=SLOPE*2;
	     'IF' SLOPE > MAXX/8 'THEN' SLOPE:=MAXX/8 ];

'END'; \SHALLOWER

'PROCEDURE' SAMESLOPE;
'INTEGER' RANNUM;
'BEGIN'

\REBOUND WITH SAME SLOPE 2/3 OF THE TIME

RANNUM:=RAN(6);
'IF' RANNUM=0 'THEN' STEEPER
    'ELSE' 'IF' RANNUM=5 'THEN' SHALLOWER;

'END'; \SAMESLOPE

'PROCEDURE' PUTOBS(X,Y); \PUT OBSTACLE ON BOARD
'INTEGER' X, Y;
'BEGIN'

VLINE(Y-3,Y+3,X,OBSTACLE);

'END'; \PUTOBS

'PROCEDURE' NEWBALL; \SETUP INITIAL POSITION OF BALL
'BEGIN'


CURSOR(0,TXTLIN);
TEXT(ODEV,"BALLS LEFT= ");
INTOUT(ODEV,NUMBALL);
CURSOR(0,TXTLIN+1);
TEXT(ODEV,"PUSH BUTTON #");
INTOUT(ODEV,SWNUM);
TEXT(ODEV," FOR NEW BALL");

'REPEAT' [ MOVPD1; MOVPD2 ]
'UNTIL' SWITCH(SWNUM);

CURSOR(0,TXTLIN+1);
TEXT(ODEV,"                           ");

XBALL:=(MAXX+1)/2-1; YBALL:=MAXY/2;
XDIR:=-1; YDIR:=1;
'IF' RAN(2)=0 'THEN'
	[ XDIR:=-XDIR; XBALL:=XBALL+2 ];
SLOPE:=MAXX/4;
XCOUNT:=0;
ONBOARD:=TRUE;

CURDEGREE:=1;
WARMUP:=15;

'END'; \NEWBALL

'PROCEDURE' SCOREIT; \UPDATE SCORE
'BEGIN'

'IF' XBALL= MAXX 'THEN' SCORE1:=SCORE1+1;

'IF' XBALL= 0 'THEN' SCORE2:=SCORE2+1;

CURSOR(15,TXTLIN);
TEXT(ODEV,"PLAYER1= ");
INTOUT(ODEV,SCORE1);
CURSOR(28,TXTLIN);
TEXT(ODEV,"PLAYER2= ");
INTOUT(ODEV,SCORE2);

'END'; \SCOREIT


'PROCEDURE' SETUP; \SETUP THE PLAYING AREA
'INTEGER' X, Y;
'INTEGER' I,J;
'BEGIN'

SETTXT;

CHOUT(ODEV,12); \HOME AND ERASE SCREEN

TEXT(ODEV,"	***** P  O  N  G *****");
ADVANCE(ODEV); ADVANCE(ODEV);
TEXT(ODEV,"ENTER DEGREE OF DIFFICULTY (1-5) ");
DEGREE:=INTIN(IDEV);

SETLO;
SETMIX;

BORDER:=WHITE;
COLBALL:=WHITE;
OBSTACLE:=BROWN;
PAD1:=PURPLE;
PAD2:=MAGENTA;

SCORE1:=0; SCORE2:=0;

\FILL SCREEN WITH GRAPHICS BLANKS

'FOR' Y:=0,MAXY 'DO'
	[ HLINE(0,MAXX,Y,BLACK) ];

\FORM BOUNDARIES

HLINE(0,MAXX,0,BORDER);
HLINE(0,MAXX,MAXY,BORDER);

\PLACE OBSTACLES

PUTOBS((MAXX+1)/4,(MAXY+1)/4);
PUTOBS((MAXX+1)/4,3*((MAXY+1)/4));
PUTOBS(3*((MAXX+1)/4),(MAXY+1)/4);
PUTOBS(3*((MAXX+1)/4),3*((MAXY+1)/4));
PUTOBS((MAXX+1)/2,(MAXY+1)/2);

\PLACE PADDLES

PAD1Y:=1; PAD2Y:=1;  \ASSUME A POSITION

'END'; \SETUP

'PROCEDURE' MOVEBALL; \MOVE THE BALL ONE CELL
'INTEGER' X, Y, CELL;
'BEGIN'

BLOCK(XBALL,YBALL,BLACK);
X:=XBALL+XDIR; Y:=YBALL;
XCOUNT:=XCOUNT+1;

'IF' XCOUNT >= SLOPE 'THEN'
	[ XCOUNT:=0; Y:=Y+YDIR ];

CELL:=SCREEN(X,Y);
'WHILE' CELL # BLACK 'DO'
	'BEGIN'

	'IF' WARMUP > 0 'THEN' WARMUP:=WARMUP-1
		'ELSE' CURDEGREE:=DEGREE;
	NOISE(1,5,1000);
	XCOUNT:=0;
	'IF' CELL = BORDER 'THEN'
		'IF' (Y=0) ! (Y=MAXY) 'THEN'
			[ YDIR:=-YDIR; Y:=Y+YDIR ];

	'IF' CELL = PAD1 'THEN'
		'BEGIN'

		'IF' (Y=PAD1Y+0) ! (Y=PAD1Y+1) 'THEN' [ YDIR:=-1; STEEPER ]
		    'ELSE' 'IF' (Y=PAD1Y+5) ! (Y=PAD1Y+6) 'THEN' [ YDIR:=1; STEEPER ]
			'ELSE' SHALLOWER;

		XDIR:=-XDIR; X:=X+XDIR;

		'END';

	'IF' CELL = PAD2 'THEN'
		'BEGIN'

		'IF' (Y=PAD2Y+0) ! (Y=PAD2Y+1) 'THEN' [ YDIR:=-1; STEEPER ]
		    'ELSE' 'IF' (Y=PAD2Y+5) ! (Y=PAD2Y+6) 'THEN' [ YDIR:=1; STEEPER ]
			'ELSE' SHALLOWER;

		XDIR:=-XDIR; X:=X+XDIR;

		'END';

	'IF' CELL = OBSTACLE 'THEN'
		'BEGIN'

		NOISE(1,10,(RAN(15)+1)*Y);
		XDIR:=-XDIR;
		X:=X+XDIR;

		'END';

	CELL:=SCREEN(X,Y); \READ NEW SCREEN CELL

	'END'; \WHILE

XBALL:=X; YBALL:=Y;
BLOCK(XBALL,YBALL,COLBALL);
'IF' (XBALL=0) ! (XBALL=MAXX) 'THEN' ONBOARD:=FALSE; \SLIPPED PAST PADDLE?

'END'; \MOVEBALL

'BEGIN'	\MAIN PROGRAM

IDEV:=0; ODEV:=0;
INITI(IDEV); INITO(ODEV);
TRUE:=(1=1); FALSE:=(1=0);

BLACK:=0; WHITE:=15; PURPLE:=3; BROWN:=8; MAGENTA:=1;

SWNUM:=1;

TXTLIN:=22;

TOTBALLS:=5;

MAXX:=39;
MAXY:=39;

'LOOP'
'BEGIN'

SETUP;

NUMBALL:=TOTBALLS;

'REPEAT'

	'BEGIN'
	NEWBALL;
	'WHILE' ONBOARD 'DO'
		'BEGIN'
		MOVPD1;
		MOVPD2;
		MOVEBALL;
		DELAY(126-25*CURDEGREE);
		'END';

	NOISE(1,100,1000);
	BLOCK(XBALL,YBALL,BLACK);
	SCOREIT;
	NUMBALL:=NUMBALL-1;
	'END'

'UNTIL' NUMBALL = 0;

CURSOR(0,TXTLIN);
TEXT(ODEV,"NO BALLS LEFT");
CURSOR(0,TXTLIN+1);
TEXT(ODEV,"THANKS FOR PLAYING THE GAME...");
'FOR' I:=0,20000 'DO';
CURSOR(0,TXTLIN+1);
TEXT(ODEV,"PRESS BUTTON #");
INTOUT(ODEV,SWNUM);
TEXT(ODEV," TO START A NEW GAME");
'REPEAT' [ MOVPD1; MOVPD2 ]
'UNTIL'  SWITCH(SWNUM);

'END'; \LOOP

'END'; \MAIN
