code	\THE REQUIRED INTRINSICS:
ABS=0		REM=2		RESERVE=3	SWAP=4
CHIN=7		CHOUT=8		CRLF=9		INTIN=10
INTOUT=11	TEXT=12		OPENI=13	OPENO=14
CLOSE=15	HEXOUT=27
TRAP=17,	GETERR=22,	FSET=24,	FOPEN=29,
FCLOSE=32,	SOFTINT=34,	GETREG=35,	BLIT=36
FORMAT=52,	RLOUT=48;
code real	FLOAT=49,	RLRES=46;


integer	INHAND,OUTHAND,DIHAND;	\INPUT HANDLE
integer CH,CHU,CHAR,WDCNT,WRDLST,WRDPNT,WORDS,I,K,A;
integer ENDOFFILE,WRDIDX,FOUND,WRDSTA,STP,WDLN,WRDREP,NXTREP,LAST,DATEND;
'INTEGER'SRCMOD,APPEND,IGNORE;
address WORD,PNT,NPNT,FILNAM,TEMPNAME,STRING,DATA;
'real'DICCNT;
	
def	EOF=$1A,LF=$A,CR=$D,TAB=$9,ESC=$1B;
def 	MAXCHAR=19,MAXWRD=2999,MAXREP=99,MAXDAT=28000;

\----------------------------------------------------------------

procedure ERROR(K);
'INTEGER'K;

begin 
CRLF(0);
TEXT(0,"CRASH=");INTOUT(0,K);CRLF(0);
exit ;
end ;


\----------------------------------------------------------

procedure IBMOPEN;
integer PSEG,CSEG,SYSINF;
addres TAIL,TLEN;

	function MAKUP(C);
	\CONVERT C TO UPPERCASE
	int C;
	return if C>=^a & C<=^z then C-32 else C;


	function GETSWT;
	\FIND, REMOVE AND RETURN NEXT AVAILABLE SWITCH
	integer P,T;
	begin
	for P:=0,TLEN(0) do if TAIL(P)=^/ then
		begin
		TAIL(P):=$20;	\so we know we took it
		if P<TLEN(0) then
			begin
			T:=TAIL(P+1);	\the switch character
			TAIL(P+1):=$20;	\so we know we took it
			return MAKUP(T);\in upper case, return it
			end;
		end;
	return 0;	\if none, return zero.
	end;



	procedure PARSE;
	address EXT1,EXT2;
	integer P,EFLG,I;
	begin
	EXT1:=".TXT";
	EXT2:=".MOD";
	P:=0;
	EFLG:=false;
	\PARSE COMMAND TAIL FOR EXTENTION

	loop
		begin
		if TAIL(P)=^. then
			begin
			EFLG:=true;
			quit;
			end;
		P:=P+1;
		if P>=TLEN(0) then
			begin
			EFLG:=false;
			quit;
			end;
		end;

	\SET EXTENTION AND INPUT HANDLE
	if not EFLG then
		for I:=0,3 do TAIL(P+I):=EXT1(I);
	for I:=0,79 do FILNAM(I):=0;
	for I:=1,P+3 do FILNAM(I-1):=TAIL(I);
	FILNAM(P+2):=FILNAM(P+2)&$7F;

	INHAND:=FOPEN(FILNAM,0);
	end;

begin	\OF IBMOPEN

\GET COMMAND TAIL FROM PSP
TLEN:=RESERVE(80);
TAIL:=TLEN+1;
SYSINF:=GETREG;			\FETCH CPU REGISTERS
PSEG:=SYSINF(11);		\get the segment register contents
CSEG:=SYSINF(12);
BLIT(PSEG,$80,CSEG,TLEN,79);	\copy over the command tail
if TLEN(0)>79 then TLEN(0):=79; \correct the limit

if GETSWT=^A then APPEND:='TRUE';
'IF'APPEND'THEN'[TEXT(0,"APPEND TO DICT...");CRLF(0)];

\TEXT(0,"SWITCH=");CHOUT(0,GETSWT);CRLF(0);


\PARSE COMMAND LINE AND SET HANDLES
PARSE;

\OPEN FILES
FSET(INHAND,^I);
end;



procedure IBMCLOSE;
integer SYSINFO;
begin 
FCLOSE(OUTHAND);
FCLOSE(INHAND);
SYSINFO:=GETREG;
SYSINFO(0):=$4100;	\DELETE ORIGINAL FILE
SYSINFO(3):=FILNAM;
SYSINFO(9):=SYSINFO(12);
SOFTINT($21);
if SYSINFO(7) then 
	begin 
	TEXT(0,"FILE DELETE FAILED");
	CRLF(0);
	exit ;
	end ;

SYSINFO(0):=$5600;	\RENAME TEMP FILE TO ORGINAL FILE
SYSINFO(3):=TEMPNAME;	\FROM THIS NAME
SYSINFO(4):=FILNAM;	\TO THIS NAME
SYSINFO(9):=SYSINFO(12);
SYSINFO(11):=SYSINFO(12);
SOFTINT($21);
if SYSINFO(7) then 
	begin 
	TEXT(0,"FILE RENAME FAILED");
	CRLF(0);
	exit ;
	end ;
end ;



procedure DICTCLOSE;
integer SYSINFO;
'ADDR'OLDNAME,NEWNAME;
begin 
TEXT(0,"DICT.TXT is updated");CRLF(0);
OLDNAME:="DICT.NEW ";
NEWNAME:="DICT.TXT ";
OLDNAME(8):=0;
NEWNAME(8):=0;

SYSINFO:=GETREG;
SYSINFO(0):=$4100;	\DELETE ORIGINAL FILE
SYSINFO(3):=NEWNAME;
SYSINFO(9):=SYSINFO(12);
SOFTINT($21);
if SYSINFO(7) then 
	begin 
	TEXT(0,"FILE DELETE FAILED");
	CRLF(0);
	exit ;
	end ;

SYSINFO(0):=$5600;	\RENAME TEMP FILE TO ORGINAL FILE
SYSINFO(3):=OLDNAME;	\FROM THIS NAME
SYSINFO(4):=NEWNAME;	\TO THIS NAME
SYSINFO(9):=SYSINFO(12);
SYSINFO(11):=SYSINFO(12);
SOFTINT($21);
if SYSINFO(7) then 
	begin 
	TEXT(0,"FILE RENAME FAILED");
	CRLF(0);
	exit ;
	end ;
end ;

\-----------------------------------------------------------------


procedure LOOKUP;	
\SEARCH EXISTING LIST FOR THE WORD
\IF FOUND, LEAVE WRDIDX POINTING TO THE WORD
\OTHERWISE, LEAVE WRDIDX POINTING TO THE FIRST LATER WORD
\THAT IS, TO THE NEXT WORD IN THE SORT ORDER.
int MIN,MAX;
addr PNT;
begin 
if WORDS=0 then 
	begin 
	FOUND:= false ;
	WRDIDX:=0;
	return ;
	end ;

FOUND:= true ;
MIN:=0;
MAX:=WORDS-1;
loop 	begin 
	WRDIDX:=(MIN+MAX)/2;
	PNT:=WRDLST(WRDPNT(WRDIDX));

	WDLN:=0;
	loop 	begin 
		if PNT(WDLN)=0 then 
		if WORD(WDLN)=0 then return ;
		if WORD(WDLN)#PNT(WDLN) then quit ;
		WDLN:=WDLN+1;
		end ;
	if WORD(WDLN)>PNT(WDLN) then 
		begin 
		if (WRDIDX+1)=MIN then quit ;
		MIN:=WRDIDX+1;
		end 
	else 	begin 
		if (WRDIDX-1)=MAX then quit ;
		MAX:=WRDIDX-1;
		end ;
	end ;

if WORD(WDLN)>PNT(WDLN) then WRDIDX:=WRDIDX+1;
WDLN:=0;
FOUND:= false ;		\SHOULD USE WDLN TO TELL!
end ;



procedure INSERT;
int I,A;
addr PNT;
begin 
LOOKUP;				\SEARCH FOR IT IS EXISTING LIST
if FOUND then return ;	\ALREADY IN THE LIST - IGNORE IT

if (WRDIDX<0)!(DATEND>(MAXDAT-MAXCHAR)) then ERROR(1);
CHOUT(0,^.);

\PUT ACTUAL WORD IN THE WRDLST
PNT:=DATA+DATEND;
WRDLST(WORDS):=PNT;
I:=0;
'REPEAT''BEGIN'
	CH:=WORD(I);
	PNT(I):=CH;
	I:=I+1;
	'END'
'UNTIL'CH=0;
DATEND:=DATEND+I;

\NOW PUT THE POINTER TO IT INTO WRDPNT:
\FIRST PUSH DOWN THE POINTERS TO MAKE ROOM FOR A NEW ONE:
I:=WORDS-1;
repeat begin 
	WRDPNT(I+1):=WRDPNT(I);
	I:=I-1;
	end 
until I<WRDIDX;

WRDPNT(WRDIDX):=WORDS;
WORDS:=WORDS+1;
if WORDS>=MAXWRD then ERROR(2);
end ;





procedure GETWORD;
\READ NEXT WORD FROM SOURCE TEXT
int K,I;


procedure GETCH;	\READ & PREPROCESS THE NEXT CHAR FROM SOURCE
begin 
if ENDOFFILE then return ;
repeat begin 
	CHAR:=CHIN(3);
	STRING(STP):=CHAR;
	if STP<79 then STP:=STP+1;
	end 
until (CHAR#LF);
if CHAR=EOF then ENDOFFILE:= true ;
if (CHAR>=^a)&(CHAR<=^z) then CHAR:=CHAR-32;
end ;


begin 
STP:=0;
repeat GETCH until ENDOFFILE!((CHAR>=^A)&(CHAR<=^Z));
if ENDOFFILE then return ;
K:=0;
repeat begin 
	WORD(K):=CHAR;
	if K<MAXCHAR then K:=K+1;
	GETCH;
	end 
until 'NOT'(  (CHAR=^')!((CHAR>=^A)&(CHAR<=^Z)) );
'IF'WORD(K-1)=^''THEN'K:=K-1;
for I:=K,MAXCHAR do WORD(I):=0;
WDCNT:=WDCNT+1;
'IF'K=1'THEN'GETWORD;
end ;




procedure GETDICT;
\READ NEXT WORD FROM DICTIONARY
int K;
begin 
K:=0;
CHAR:=CHIN(3);
if CHAR=EOF then [ENDOFFILE:= true ; return ];
loop 	begin 
	if CHAR=CR then quit ;
	WORD(K):=CHAR;
	if K<MAXCHAR then K:=K+1;
	CHAR:=CHIN(3);
	end ;
CHAR:=CHIN(3);	\EAT THE LF
WORD(K):=0;
DICCNT:=DICCNT+1.0;
end ;



begin	\MAIN
FILNAM:=RESERVE(80);
STRING:=RESERVE(80);
WORD:=RESERVE(MAXCHAR+1);
WRDLST:=RESERVE((MAXWRD+1)*2);
WRDPNT:=RESERVE((MAXWRD+1)*2);
WRDSTA:=RESERVE((MAXWRD+1)*2);
DATA:=RESERVE(MAXDAT);
WRDREP:=RESERVE((MAXREP+1)*2);
for I:=0,MAXREP do WRDREP(I):=-1;
for I:=0,MAXWRD do 
	begin 
	WRDLST(I):=-1;
	WRDPNT(I):=-1;
	WRDSTA(I):=0;
	end ;
DATEND:=0;


APPEND:='FALSE';
IGNORE:='FALSE';

TEXT(0,"DICT LISTER V0.0");CRLF(0);


DICCNT:=0.0;

DIHAND:=FOPEN("DICT.TXT",0);
FSET(DIHAND,^I);
OPENI(3);
ENDOFFILE:= false ;


OUTHAND:=FOPEN("DICT.LST",1);
FSET(OUTHAND,^O);
OPENO(3);

GETDICT;
A:=1;
loop 	begin 		\FINISH DICT SCAN AND OUTPUT
	if ENDOFFILE then quit ;
	K:=0;
	loop 	begin 	\ADD IT TO DICT
		CHAR:=WORD(K);K:=K+1;
		if CHAR=0 then quit ;
		CHOUT(3,CHAR);
		end ;
	'IF'A<4'THEN'
		'FOR'K:=K,19'DO'CHOUT(3,^ )
	'ELSE'[CRLF(3);A:=0];
	A:=A+1;
	GETDICT;
	end ;

CLOSE(3);
FCLOSE(OUTHAND);
FCLOSE(DIHAND);
FORMAT(1,0);
TEXT(0,"THE DEED IS DONE, COUNT=");RLOUT(0,DICCNT);
CRLF(0);

end;	\MAIN

