\PRINTHD.XPL
\		HPRINT.XPL  V0.1  JUN 21, 1984
\PRINT ROUTINE WITH DIRECTORY HEADING 
\TAKEN FROM ALLDIR.XPL, MASTER DIRECTORY MAKER BY P.J.R. BOYLE. (BRINKMAN)

code	REM=2,		RESERVE=3,	SWAP=4,		CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	INITI=13,	INITO=14,	CLOSE=15,
	TRAP=17,	SPACE=18,	GETERR=22,	WRITE=30,
	READ=31;

define	SP=$20, BEL=$07,EOF=$1A;	\ASCII CHARACTER CODES
define	TV=0, KB=0, PR=2, DISK=3;	\I/O DEVICES
define	DIRSIZ=4,	\DIRECTORY SIZE IN BLOCKS
	DIRBLK=9,	\BLOCK NUMBER OF THE DIRECTORY
	MAXFL=47;	\HIGHEST FILE NUMBER IN DIRECTORY

integer	UNIT,	\INPUT FILE UNIT
	DIRNUM,	\DIRECTORY NUMBER OF THE INPUT FILE
	ODEV,	\OUTPUT DEVICE NUMBER
	IDEV,	\INPUT DEVICE NUMBER
	TODAY,	\SYSTEM DATE
	CH,I,Z;	\SCRATCH

\THE DIRECTORY
address	PRDEV,	\DEVICE ASSOSIATED WITH PRNAM
	TITLE,	\TITLE OF THE VOLUME
	PRNAME,	\THE REMEMBERED FILE
	FNAME,	\THE FILE NAMES
	FSTAT,	\THE FILE STATUS
	FLAGS,	\SPECIAL REQUEST FLAGS
	NUMVAL,	\LENGTH OF STAB ARRAY.
	DIRCHG,	\FLAG TO INDICATE DIR NEEDS FIXUP
	STAB;	\SORT POINTER ARRAY

\INTEGER ARRAYS IN THE DIRECTORY
integer	PMAXB,	\UNIT SIZE, MAX BLOCK NUMBER
	FEMBLK,	\ST BLKS OF EMPTY FILE LIST
	LEMBLK,	\END BLKS OF EMPTY FILE LIST
	DIRDAT,	\DIRECTORY DATE
	VOLUME,	\UNIQUE UNIT ID NUMBER
	FDATE,	\DATE OF FILES
	FBLK,	\THE FIRST BLOCK
	LBLK;	\THE LAST BLOCK

char	SYSPAG;	\BASE ADDRESS OF SYSTEM PAGE

\----------------------------------------------------------------------\

proc	CR;
CRLF(ODEV);


proc	STR(TXT);
char	TXT;
TEXT(ODEV,TXT);


proc	NUM(I);
int	I;
INTOUT(ODEV,I);


proc	ERROR(MSG);
char	MSG;
begin
CHOUT(TV,BEL);
STR("ERROR - "); STR(MSG); CR;
end;

\----------------------------------------------------------------------\

proc	PRDAT(DAT);	\OUTPUT THE DATE
int	DAT,DAY,MO;
begin
if DAT<=0 then [STR("NO DATE"); return];
DAT:=DAT/32; DAY:=REM(0);
DAT:=DAT/16; MO:=REM(0);
NUM(MO); CHOUT(ODEV,^-);
NUM(DAY); CHOUT(ODEV,^-);
NUM(DAT+76);
if MO<10 then CHOUT(ODEV,^ );
if DAY<10 then CHOUT(ODEV,^ );
end;	\PRDAT



proc	RDDIR;	\READ A DIRECTORY
int	I;
begin
TRAP(false);		\WE'LL HANDLE THE ERRORS, THANK YOU
loop	begin
	READ(UNIT,DIRBLK,FNAME,DIRSIZ);
	if not GETERR then quit;
	ERROR("DISK, HIT RETURN TO RETRY");
	INITI(KB); I:=CHIN(KB);
	end;
TRAP(true);
end;	\RDDIR

\----------------------------------------------------------------------\


proc	PRNAM(I);	\OUTPUT THE FILE NAME, SIZE, DATE, ETC
int	I;
char	STRING,S1;
int	J;
begin
STRING:=FNAME+I*11;
for J:=0,7 do if STRING(J)#SP then CHOUT(ODEV,STRING(J));
CHOUT(ODEV,^.);
for J:=8,10 do if STRING(J)#SP then CHOUT(ODEV,STRING(J));
STR(",  "); 
J:=LBLK(I)-FBLK(I)+1; NUM(J);		\OUTPUT THE FILE SIZE
STR(" blocks,  ");PRDAT(FDATE(I));		\OUTPUT THE DATE
\STR("  ");NUM(VOLUME(O));		\\OUTPUT THE VOLUME
STR("    System date: "); PRDAT(TODAY);	\OUTPUT TODAY'S DATE
CR; CR;
end;	\PRNAM

\----------------------------------------------------------------------\

begin	\MAIN
\RESERVE THE ARRAYS IN THE DIRECTORY
I:=(MAXFL+1)*2;
		\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(I);
LBLK:=RESERVE(I);
		\BLOCK 3
FEMBLK:=RESERVE(12);
LEMBLK:=RESERVE(12);
STAB:=RESERVE(48);
NUMVAL:=RESERVE(1);
DIRCHG:=RESERVE(1);
PRDEV:=RESERVE(1);
PMAXB:=RESERVE(2);
PRNAME:=RESERVE(11);
TITLE:=RESERVE(60);
VOLUME:=RESERVE(2);
DIRDAT:=RESERVE(2);
FDATE:=RESERVE(I);
FLAGS:=RESERVE(8);

SYSPAG:=$BF00;		\SET UP POINTER TO SYSTEM PAGE
I:=SYSPAG+$57; TODAY:=I(0);

ODEV:=TV;
STR("
-- PRINT WITH HEADING OPTION, V1.0 --
");

DIRNUM:=SYSPAGE($7D);
UNIT:=SYSPAG($7E);
RDDIR; 

CR; PRNAM(DIRNUM);

ODEV:=PR;
IDEV:=DISK;
INITO(ODEV);
INITI(IDEV);

TEXT(0,"PRINT HEADING? (Y)");
\INITI(0); 
Z:=CHIN(0);
if (Z#^N & Z#^n) then PRNAM(DIRNUM);

'LOOP'	'BEGIN'
	CH:=CHIN(IDEV);
	'IF'CH=EOF'THEN''QUIT';
\	CHOUT(0,CH);
	CHOUT(ODEV,CH);
	'END';
CRLF(TV);
TEXT(0,"DO YOU WANT A FORMFEED? (Y)");
INITI(0); 
Z:=CHIN(0);
if (Z#^N & Z#^n) then CLOSE(ODEV) else CRLF(ODEV);
end;	\MAIN
