\PROSENO.XPL	SEP-02-87

code	ABS=0,		RAN=1,		REM=2,		RESERVE=3,
	SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
	CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
	TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15;


int	NUM, ONETBL;



proc	PROSENO(DEV, NUM);
\OUTPUT THE POSITIVE INTEGER "NUM" IN PROSE TO DEVICE "DEV"
int	DEV, NUM;
int	THO, I, M, ONETBL, TENTBL, THOTBL;



proc	OUT999(N);	\OUTPUT NUMBERS UP TO 999 (ZERO DOES NOTHING)
int	N;
int	HUNS, TENS, ONES;
begin
HUNS:= N /100;			\0..9
N:= REM(0);			\0..99
TENS:= N /10;			\0..9
ONES:= REM(0);			\0..9

if HUNS # 0 then
	[TEXT(DEV, ONETBL(HUNS));		\1..9
	TEXT(DEV, " HUNDRED ")];

if TENS >= 2 then
	begin
	TEXT(DEV, TENTBL(TENS));
	if ONES # 0 then
		[CHOUT(DEV, ^-); TEXT(DEV, ONETBL(ONES))];
	end
else	if N # 0 then TEXT(DEV, ONETBL(N));	\N = 1..19
end;	\OUT999



begin	\PROSENO
if NUM = 0 then [TEXT(DEV, "ZERO"); return];

ONETBL:=[0, "ONE", "TWO", "THREE", "FOUR",
	"FIVE", "SIX", "SEVEN", "EIGHT", "NINE",
	"TEN", "ELEVEN", "TWELVE", "THIRTEEN", "FOURTEEN",
	"FIFTEEN", "SIXTEEN", "SEVENTEEN", "EIGHTEEN", "NINETEEN" ];

TENTBL:=[0, 0, "TWENTY", "THIRTY", "FORTY",
	"FIFTY", "SIXTY", "SEVENTY", "EIGHTY", "NINETY" ];

THOTBL:=[" THOUSAND ", " MILLION ", " BILLION "];

THO:= 1000;		\USE 1000000000 IF 32 BITS.
for I:= 0, 0 do		\I:= -2, 0 IF 32 BITS
	begin
	M:= NUM /THO;
	NUM:= REM(0);
	if M > 0 then
		[OUT999(M);
		TEXT(DEV, THOTBL(-I))];
	THO:= THO /1000;
	end;
OUT999(NUM);
end;	\PROSENO



begin	\MAIN
loop	begin
	NUM:= INTIN(0);
	PROSENO(0, NUM);
	CRLF(0);
	end;
end;	\MAIN
