
include C:\CXPL\CODESI.XPL;

define
	EOF=$1A,	\END OF FILE
	ESC=$1B,	\ESCAPE
	CR=$0D,		\CARRIAGE RETURN
	LF=$0A,		\LINE FEED
	SP=$20,		\SPACE
	TAB=$09,	\TAB CHARACTER
	FF=$0C,		\FORM FEED
	LFARROW=75,	\LEFT ARROW KEY
	RTARROW=77,	\RIGHT ARROW KEY
	UPARROW=72,	\UP ARROW KEY
	DNARROW=80;	\DOWN ARROW KEY



int X0,Y0,X1,Y1,X2,Y2,X3,Y3;

int CURPNT,COM,POINTS,INC;

real A,B,C,D,E,F,G,H;


procedure GETKEY;
int C;
begin
C:=CHIN(1);
if C=0 then C:=-CHIN(1);
return C;
end;


procedure DOY(I);
int I;
begin
case CURPNT of
	0: Y0:=Y0+I;
	1: Y1:=Y1+I;
	2: Y2:=Y2+I;
	3: Y3:=Y3+I 
other;
end;


procedure DOX(I);
int I;
begin
case CURPNT of
	0: X0:=X0+I;
	1: X1:=X1+I;
	2: X2:=X2+I;
	3: X3:=X3+I 
other;
end;



procedure MARK(X,Y,S);
int X,Y,S;
begin
MOVE(X+S,Y+S);
LINE(X+S,Y-S,$81);
LINE(X-S,Y-S,$81);
LINE(X-S,Y+S,$81);
LINE(X+S,Y+S,$81);
end;



procedure UPDATE;
int X,Y;
begin
MARK(X0,Y0,2);
MOVE(X0,Y0);LINE(X1,Y1,$81);
MOVE(X2,Y2);LINE(X3,Y3,$81);
MARK(X3,Y3,2);
case CURPNT of
	0: [X:=X0;Y:=Y0;];
	1: [X:=X1;Y:=Y1;];
	2: [X:=X2;Y:=Y2;];
	3: [X:=X3;Y:=Y3;]
other;
MARK(X,Y,5);
CURSOR(0,24);
TEXT(0,"Point = ");INTOUT(0,CURPNT);
TEXT(0,"  INC = ");INTOUT(0,INC);
end;






procedure DOSPLINE(Points,X0,Y0,X1,Y1,X2,Y2,X3,Y3);
int Points,X0,Y0,X1,Y1,X2,Y2,X3,Y3;
int X,Y,P;
int K1,K2;
real T;
begin
K1:=3; K2:=6;

A:=FLOAT(X3 - (K1 * X2) + (K1 * X1) - X0);
B:=FLOAT((K1 * X2) - (K2 * X1) + (K1 * X0));
C:=FLOAT((K1 * X1) - (K1 * X0));
D:=FLOAT(X0);

E:=FLOAT(Y3 - (K1 * Y2) + (K1 * Y1) - Y0);
F:=FLOAT((K1 * Y2) - (K2 * Y1) + (K1 * Y0));
G:=FLOAT((K1 * Y1) - (K1 * Y0));
H:=FLOAT(Y0);

MOVE(X0,Y0);
for P:=0,Points-1 do
	begin
	T:=FLOAT(P)/FLOAT(Points-1);
	X:=FIX( (((A * T) + B) * T + C) * T + D);
	Y:=FIX( (((E * T) + F) * T + G) * T + H);
	LINE(X,Y,$81);
	end;
end;



begin
X0:=10;Y0:=10;
X1:=200;Y1:=100;
X2:=400;Y2:=100;
X3:=300;Y3:=20;

CURPNT:=0;
INC:=1;

TEXT(0,"NUMBER OF SEGMENTS: ");
POINTS:=INTIN(0);

SETVID(6);
UPDATE;
loop
	begin
	COM:=GETKEY;
	UPDATE;
	case COM of
	ESC: quit;
	^P,^p: CURPNT:=if CURPNT>=3 then 0 else CURPNT+1;
	^S,^s: DOSPLINE(POINTS,X0,Y0,X1,Y1,X2,Y2,X3,Y3);
	^I,^i: INC:=if INC=1 then 10 else 1;
	^C,^c: CLEAR;
	-UPARROW: DOY(-INC);
	-DNARROW: DOY(INC);
	-RTARROW: DOX(INC);
	-LFARROW: DOX(-INC)
	other;
	UPDATE;
	end;

SETVID(3);
end;
