	PAGE	59,130
;RANDOM.ASM	AUG-07-92
;A GOOD RANDOM NUMBER GENERATOR

DSEG	SEGMENT BYTE PUBLIC 'DATA'
RANK	DW	2537
RANL	DW	5149
RANM	DW	7026
DSEG	ENDS

MODK	EQU	33049		;CLOSE
MODL	EQU	32909
MODM	EQU	32771

;----------------------------------------------------------------------
;THIS RETURNS A RANDOM NUMBER BETWEEN 0 AND THE ARGUMENT -1.
; N:= RANDOM(N);
;
CSEG	SEGMENT DWORD PUBLIC 'CODE'
	ASSUME CS:CSEG, DS:DSEG
	PUBLIC	RANDOM

RANDOM:	MOV	AX,RANK		;RANK:= REM((RANK+RANK) /MODK);
	ADD	AX,AX
	CMP	AX,MODK
	JB	RAN10
	SUB	AX,MODK
RAN10:	MOV	RANK,AX

	MOV	AX,RANL		;RANL:= REM((RANL+RANL) /MODL);
	ADD	AX,AX
	CMP	AX,MODL
	JB	RAN20
	SUB	AX,MODL
RAN20:	MOV	RANL,AX

	ADD	AX,RANK		;RANM:= REM((RANK+RANL+RANM) /MODM);
	ADD	AX,RANM
RAN30:	CMP	AX,MODM
	JB	RAN35
	SUB	AX,MODM
	JMP	SHORT RAN30
RAN35:	MOV	RANM,AX

	MOV	DH,AL		;MAKE BIT 15 IN AX RANDOM (IT'S USUALLY 0)
	AND	DH,80H		;ESSENTIALLY COPY BIT 7 INTO BIT 15
	XOR	AH,DH

	MOV	DL,AL		;AVOID BIAS ERRORS FOR LARGE RANDOM NUMBERS
	SUB	DH,DH		; BY USING A LARGE DIVIDEND

	MOV	BP,SP		;GET ARGUMENT
	MOV	BX,[BP]+4
	TEST	BH,BH		;AVOID DIVIDE OVERFLOW ERROR
	JNZ	RAN40
	SUB	DL,DL
RAN40:	DIV	BX		;UNSIGNED DIVIDE BX INTO DX:AX
	MOV	[BP]+4,DX	;RETURN REMAINDER
	RETF

CSEG	ENDS
	END
