\RMAZE.XPL
\NOTE*** THIS WAS WRITTEN FOR V3A NOT V3C

\CONVERTED TO V4D AND CONVERTED TO 
\LORES GRAPHICS  -  R. NACE FEB 1981



'CODE'						\AVAILABLE FUNCTIONS
RAN=1,		REM=2,		RESERVE=3,
EXTEN=5,
SETLO=36,	SETMIX=35,	BLOCK=45,
SCAN=24,	CHAIN=28;


'INTEGER'	\BOOLIAN VARIABLES
	FULL
	EMPTY
	CLOSED
	OPEN
	NOMORE;

'INTEGER'					\WORKING VARIABLES
	MAXC	\NUMBER OF CELLS IN THE MAZE
	MAXV	\NUMBER OF VERTICAL WALLS
	MAXH	\NUMBER OF HORIZONTAL WALLS
	R	\NUMBER OF ROWS
	C	\NUMBER OF COLUMNS
	BLOCKR	\BLOCK ROW
	BLOCKC	\BLOCK COLUMN
	DBLOCK;	\BUFFER FOR SCAN

'ADDRESS'					\WORKING "ARRAYS"
	VWALL	\VERTICAL WALLS
	HWALL	\HORIZONTAL WALLS
	CELL	\CELLS OF THE MAZE
	SEED	\PAGE 0'S RANDOM SEED
	LOSEED	\CELL FOR BUFFER
	HISEED;	\CELL FOR BUFFER




'PROC'	SOW;	\PUT THE SEED BACK
'BEGIN'

SEED:=$82;
LOSEED:=$678;	HISEED:=$6F8;

SEED(0):=LOSEED(0);
SEED(1):=HISEED(0);

'END';

'PROC'	HARVEST; \STORE THE SEED
'BEGIN'

LOSEED(0):=SEED(0);
HISEED(0):=SEED(1);

'END';


'PROCEDURE'CLEAR;				\TO SETUP THE INITIAL MATRIX
\***************
'INTEGER'J;
'BEGIN'
'FOR'J:=0,MAXC-1'DO'CELL(J):=EMPTY;		\SET ALL CELLS TO EMPTY
'FOR'J:=0,MAXV-1'DO'VWALL(J):=CLOSED;		\SET ALL WALLS TO CLOSED
'FOR'J:=0,MAXH-1'DO'HWALL(J):=CLOSED;		
'END'\CLEAR\;


'PROC'	CRLFP;
'BEGIN'
BLOCKR:=BLOCKR+1;
BLOCKC:=0
'END';



'PROC'	BL(C);
'INT'	C;
'BEGIN'
BLOCK(BLOCKC,BLOCKR,C);
BLOCKC:=BLOCKC+1;
'END';



'PROC'	TEXTP(T);
'INT'	T;

'BEGIN'
'CASE' T 'OF'
	1:[BL(15); BL(15)];
	2:[BL(15); BL(0)];
	3:[BL(15)];
	4:[BL(15); BL(0)];
	5:[BL(0); BL(0)]
'ELSE';
'END';



'PROCEDURE'PRINT;				\PRINT THE MAZE
\****************
'INTEGER'I,J;
'BEGIN'

'FOR' BLOCKR:=0,47 'DO'
	'FOR' BLOCKC:=0,39 'DO'
		BLOCK(BLOCKC,BLOCKR,0);
BLOCKR:=0;
BLOCKC:=0;


'FOR'J:=0,R'DO'					\FOR ALL ROWS..
	'BEGIN'
	CRLFP;
	'FOR'I:=0,C-1'DO'			\ONE LINE OF HORIZONTAL WALLS
		'IF'EXTEN(HWALL(C*J+I))=CLOSED
		'THEN'TEXTP(1\"+-"\)		\IF BLOCKED
		'ELSE'TEXTP(2\"+ "\);	\IF OPEN
	TEXTP(3\"+"\);
	CRLFP;
	'IF'J#R'THEN'
	'FOR'I:=0,C'DO'				\ONE LINE OF VERTICAL WALLS
		'IF'EXTEN(VWALL(R*I+J))=CLOSED
		'THEN'TEXTP(4\"I "\)		\IF BLOCKED
		'ELSE'TEXTP(5\"  "\);	\IF OPEN
	'END';
'END';


'PROCEDURE'FILL;				\TO FILL THE MAZE WITH PATHS
\***************
'INTEGER'NOFILLED,I,J,SI,SJ;


'PROCEDURE'TRACE;				\TO TRACE ONE PATH
\****************
'INTEGER'STUCK,UPOK,DNOK,LFOK,RTOK,K;


'PROCEDURE'MOVCHK;				\TO FIND THE VALID DIRECTIONS
\*****************
'BEGIN'
'IF'J-1>=0'THEN'UPOK:=EXTEN(CELL((J-1)*C+I))	\CAN GO UP?
'ELSE'UPOK:='FALSE';

'IF'J+1<R'THEN'DNOK:=EXTEN(CELL((J+1)*C+I))	\CAN GO DOWN?
'ELSE'DNOK:='FALSE';

'IF'I-1>=0'THEN'LFOK:=EXTEN(CELL(J*C+I-1))	\CAN GO LEFT?
'ELSE'LFOK:='FALSE';

'IF'I+1<C'THEN'RTOK:=EXTEN(CELL(J*C+I+1))	\CAN GO RIGHT?
'ELSE'RTOK:='FALSE';

STUCK:='NOT'(UPOK ! DNOK ! LFOK ! RTOK);	\ARE WE STUCK?

'END';




'BEGIN'\TRACE\
\*************
 MOVCHK;					\FIND THE VALID DIRECTIONS
'WHILE''NOT'STUCK'DO'
	'BEGIN'
	K:=RAN(4);				\CHOOSE A RANDOM DIRECTION
	'LOOP'					\TRY TO GO THAT WAY
		'BEGIN'
		'IF'K=0'THEN''IF'RTOK'THEN'
			'BEGIN'
			VWALL(R*(I+1)+J):=OPEN;
			I:=I+1;
			'QUIT';
			'END';
		'IF'K=1'THEN''IF'LFOK'THEN'
			'BEGIN'
			VWALL(R*I+J):=OPEN;
			I:=I-1;
			'QUIT';
			'END';
		'IF'K=2'THEN''IF'UPOK'THEN'
			'BEGIN'
			HWALL(C*J+I):=OPEN;
			J:=J-1;
			'QUIT';
			'END';
		'IF'K=3'THEN''IF'DNOK'THEN'
			'BEGIN'
			HWALL(C*(J+1)+I):=OPEN;
			J:=J+1;
			'QUIT';
			'END';
		 K:=REM((K+1)/4);		\NO GOOD SO TRY NEXT DIRECTION
		'END';
	CELL(J*C+I):=FULL;			\FOUND ONE, SO MARK IT
	NOFILLED:=NOFILLED+1;			\ONE MORE FULL
	MOVCHK;					\SETUP FOR NEXT MOVE
	'END';
'END';\TRACE\



'PROCEDURE'NEWCELL;				\STEP TO NEXT CELL
\******************
'BEGIN'
'IF'SJ+1<R'THEN'SJ:=SJ+1			\GO DOWN IF POSSIBLE
'ELSE'
	'BEGIN'
	SJ:=0;					\ELSE GO TO TOP
	'IF'SI+1<C'THEN'SI:=SI+1		\AND RIGHT ONE IF POSSIBLE
	'ELSE'SI:=0;				\RESET IF WE CANNOT
	'END';
I:=SI;
J:=SJ;
'END';




'BEGIN'\FILL\
\************
I:=RAN(C);					\START AT A RANDOM CELL
J:=RAN(R);
CELL(J*C+I):=FULL;				\MARK IT FULL
NOFILLED:=1;					\WE HAVE ONE FULL
SI:=I;
SJ:=J;
'WHILE'NOFILLED<MAXC'DO'			\FILL ALL CELLS
	'BEGIN'					\FIND A FULL CELL
	'WHILE'EXTEN(CELL(J*C+I))=EMPTY
	'DO'NEWCELL;
	TRACE;					\AND TRACE FROM THERE
	NEWCELL;				\THEN GO TO NEXT CELL
	'END';
'END';\FILL\



'PROCEDURE'OPENENDS;				\MAKE A START AND AN END
\******************
'INTEGER'J;
'BEGIN'
J:=RAN(R);					\A RANDOM ROW
VWALL(J):=OPEN;					\ON THE LEFT
J:=RAN(R);					\AND ANOTHER
VWALL(R*C+J):=OPEN;				\ON THE RIGHT
'END';



'PROCEDURE'DOMAZE;				\MAKE ONE MAZE
\****************
'BEGIN'
MAXC:=R*C;					\FORM ARRAY SIZES
MAXV:=R*(C+1);
MAXH:=(R+1)*C;

VWALL:=RESERVE(MAXV);				\FORM ARRAYS
HWALL:=RESERVE(MAXH);
CELL:=RESERVE(MAXC);

CLEAR;						\CLEAR THE MAZE
FILL;						\TRACE ALL PATHS
OPENENDS;					\OPEN UP THE ENDS
PRINT;						\AND PRINT IT
'END';



'BEGIN'\MAIN\
\************
	\THE MATRICES ARE SEEN AS I BY J, I BEING THE X DIRECTION.
	\CELL IS (J*C+I), WITH I:=0,C-1 AND J:=0,R-1
	\VWALL IS (R*I+J), WITH I:=0,C AND J:=0,R-1
	\HWALL IS (C*J+I), WITH I:=0,C-1 AND J:=0,R

FULL:='FALSE';	EMPTY:='TRUE';			\SOME USEFUL BOOLEANS
CLOSED:='TRUE';	OPEN:='FALSE';


R:=23;	\ROWS AT 23
C:=19;	\COLS AT 19

SETLO;

SOW;

DOMAZE;					\GO$DO A MAZE

HARVEST;

DBLOCK:=RESERVE(4);
SCAN(0,DBLOCK,"SOLVE   SAV ");
CHAIN(0,DBLOCK(0));



'END';
