\SERIO.XPL	JAN-02-93
\Serial I/O routines

inc	C:\CXPL\CODESI;

int	SERDATA,	\SERIAL PORT DATA REGISTER
	SERSTAT;	\SERIAL PORT STATUS REGISTER

int	CHAR;		\FOR MAIN



proc	SEROPEN(COMM, BAUD);	\Initialize communications port
int	COMM,		\Comm port (1, 2, 3, 4)
	BAUD;		\Baud rate (unsigned)
int	N, BASE;
begin
if COMM<1 ! COMM>4 then 
	[TEXT(0, " ILLEGAL COMM PORT NUMBER ");   OPENI(1);   repeat until CHKKEY];
COMM:= (COMM -1) *2;
BASE:= PEEK($40, COMM) + SWAP(PEEK($40, COMM+1));
if BASE = 0 then 
	[TEXT(0, " COMM PORT IS NOT INSTALLED ");   OPENI(1);   repeat until CHKKEY];

SERDATA:= BASE;
SERSTAT:= BASE+5;

POUT($80, BASE+3, 0);		\Set up baud rate generator
N:= 1152 / (BAUD>>1/50);	\First divide unsigned baud rate by 100
POUT(SWAP(N), BASE+1, 0);
POUT(N, BASE, 0);

\   BITS:	765		43		2		10
\		NOT USED	PARITY		STOP BITS	WORD LENGTH
\		XXX		X0 = none	0 = 1 bit	10 = 7 bits
\				01 = odd	1 = 2 bits	11 = 8 bits
\				11 = even
POUT($03, BASE+3, 0);		\No parity, 1 stop, 8 bits

POUT($00, BASE+1, 0);		\No interrupts
POUT($03, BASE+4, 0);		\Turn on RTS and DTR

N:= PIN(BASE, 0);		\"Kick some life into it"
N:= PIN(BASE, 0);
end;	\SEROPEN



proc	SEROUT(CH);		\Send a character out the serial port
int	CH;
begin
repeat until (PIN(SERSTAT,0) & $20) \#0\;	\Transmitter holding reg empty
POUT(CH, SERDATA, 0);
end;	\SEROUT



func	SERIN;			\Receive a character from serial port
begin
repeat until (PIN(SERSTAT,0) & $01) \#0\;	\Data ready
return PIN(SERDATA, 0);
end;	\SERIN



func	SERCHK;			\Check for input character waiting
return (PIN(SERSTAT,0) & $01) # 0;

\----------------------------------------------------------------------

begin	\MAIN
TEXT(0, "SEND AND RECEIVE FROM SERIAL PORT
   ESC TO QUIT

");

SEROPEN(1, 9600);

loop	begin
	if SERCHK then
		begin
		CHAR:= SERIN;
		CHOUT(0, CHAR);
		end;
	if CHKKEY then 
		begin
		CHAR:= CHIN(1);
		if CHAR = $1B \ESC\ then quit;
		SEROUT(CHAR);
		end;
	end;
end;	\MAIN
