\SET.XPL
\SET FOR APEX V1.0
'CODE'
ABS=0,		REM=2,		RESERVE=3,
SWAP=4,		CHIN=7,		CHOUT=8,
CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	INITI=13,	INITO=14,
CLOSE=15,	FREAD=31,	FWRITE=30,
ABORT=16,	SPACE=18;


\THE DIRECTORY
'ADDRESS'
	PRDEV,
	TITLE,	\TITLE OF THE VOLUME
	VOLUME,
	RNAM,	\THE REMEMBERED FILE
	FNAME,	\THE FILE NAMES
	FSTAT,
	FLAGS,	\SPECIAL REQUEST FLAGS
	UNUSED;	\FREE DIRECTORY SPACE
\INTEGER ARRAYS IN THE DIRECTORY
'INTEGER'
	PMAXB,
	DIRDAT,	\DIRECTORY DATE
	FDATE,	\DATE OF FILES
	FBLK,	\THE FIRST BLOCK
	LBLK;	\THE LAST BLOCK

\SOME ABSOLUTE ADDRES
'ADDRESS'PARM;

\THE SYSTEM GLOBALS:
'ADDRESS'
	STAB,	\FOR SORT
	LOCNAM;	\LOCAL NAME OF FILE

'INTEGER'
	DEVICE,
	DIRSIZ,	\DIR SIZE
	SWAPSIZ,\SWAPPING SIZE
	DIRBLK,	\WHERE DIRECT IS
	SWAPBLK,\SWAPPING AREA
	SYSBLK,	\WHERE SYSTEM IS
	USERBLK,\FIRST USER BLOCK
	BACKBLK,\BLOCK TO PU BACKUP DIR IN
	FIRBLK,	\FIRST BLOCK OF FILE
	LASBLK,	\LAST BLOCK OF FILE
	FLNO,	\NUMBER OF FILE
	MAXBLK,	\HIGHEST BLOCK
	MAXFL,	\HIGHEST FILE NO
	CHAR,	\INPUT CHARACTER
	SWAPFLG,\=0 IF SWAPPING AREA IS INVALID
	SWITCH,	\USER FILE SWITCH
	ARG1,	\USER ARGUMENT
	ARG2,	\USER ARGUMENT
	SPECIAL,\SPECIAL BITS IN PROGRAM FILE REQUEST
	SYSDAT,	\SYSTEM DATE
	INSIZE,	\SIZE OF LAST OPENED INFILE
	INDATE,	\DATE OF LAST INFILE
	MAXSTB,
	FILENO;	\RUN FILE NUMBER

\FOR MAIN
'INTEGER'FILE,I,NEWSPEC;
'ADDRESS'BLOCK;




\CONSTANTS

\ASCII CONSTANTS
'DEFINE'CR=13,EOF=26,TAB=9,BEL=7,FORM=12;

\FILE STATUS IN THE DIRECTORY
'DEFINE' NULL=0,TENTATIVE=255,REPLACE=254,VALID=1;

\FILE STATUS IN COMM AREA
'DEFINE' NOFILE=0,SETUP=1,CLOSED=255;

\SYSTEM REENTRY CONDITIONS
'DEFINE' SWAPIN=254,SAVEIN=255,BOOTIN=253,RELOAD=252;

\FAILED FLAG
'DEFINE' NONE=65535;

\DEFINE SOME OFFSETS INTO COMM PAGE

'DEFINE'
	STRTOFF=$15,		\USER BASE ADDRESS
	SIZEOFF=$17,		\PROGRAM SIZE IN PAGES
	DFOOFF=$21,		\DEFAULT EXT FOR OUTPUT FILE
	DFIOFF=$24,		\DEFAULT EXT FOR INPUT FILE
	DFSOFF=$27,		\SPECIAL DEFAULT FLAG BYTE
	OTBUFD=$36,
	OTBUFE=$38,
	INBUFD=$3A,
	INBUFE=$3C,
	SYBOMB=$28,
	USRTOP=$29,
	START=$1,
	RESTART=$4,
	VEXIT=$7,
	VERROR=$A,
	VABORT=$D;






\DEFINE SOME OFFSETS INTO SYSTEM PAGE

'DEFINE'
	OTLBKL=$70,		\LOW BLOCK NUMBER
	OTLBKH=$71,
	OTHBKL=$72,		\HIGH BLOCK NUMBER
	OTHBKH=$73,
	OTFLG=$74,		\OUTPUT FILE STATUS FLAGS
	OTNO=$75,		\OUTPUT FILE NUMBER IN DIRECTORY
	OTDEV=$76,		\DEVICE NUMBER OUTPUT FILE IS ON

	INLBKL=$78,		\LOW BLOCK NUMBER
	INLBKH=$79,
	INHBKL=$7A,		\HIGH BLOCK NUMBER
	INHBKH=$7B,
	INFLG=$7C,		\INPUT FILE STATUS FLAG
	INNO=$7D,		\INPUT FILE NUMBER IN DIRECTORY
	INDEV=$7E,		\DEVICE NUMBER INPUT FILE IS ON

	SYSENT=$50,		\HOW WE REENTER THE SYSTEM
	OKDRVS=$51,		\TO GET UNIT PERMIT MASK
	DEFDEV=$52,		\THE SYSTEM UNIT NUMBER
	SYBLKX=$53		\THE SYSTEM BLOCK
	SWBLKX=$55		\THE SWAP BLOCK
	DATOFF=$57,		\OFFSETS TO SYSTEM DATE
	DATOF1=$58,
	DATOF2=$59;



'PROCEDURE'SIX(I);
'INTEGER'I;
'RETURN'BLOCK(I)+SWAP(BLOCK(I+1));


'PROCEDURE'PUT(I,J);
'INTEGER'I,J;
'BEGIN'
BLOCK(I):=J;
BLOCK(I+1):=SWAP(J);
'END';



'PROCEDURE'NEXT;
CHAR:=CHIN(0);






	'PROCEDURE'NUMBER;
	'INTEGER'I,ADD;



'PROCEDURE'NUMERIC;
'INTEGER'DUMMY;
'RETURN'CHAR>=^0 & CHAR<=^9;



'PROCEDURE'HEX;
'INTEGER'DUMMY;
'RETURN'NUMERIC ! (CHAR>=^A & CHAR<=^Z);



'BEGIN'
'WHILE'('NOT'NUMERIC)&(CHAR#^$)'DO'NEXT;
I:=0;
'IF'CHAR=^$'THEN'
	'BEGIN'
	NEXT;
	'WHILE'HEX'DO'
		'BEGIN'
		'IF'CHAR<^A'THEN'ADD:=CHAR-^0
		'ELSE'ADD:=CHAR-^A+10;
		I:=I*16+ADD;
		NEXT;
		'END';
	'END'
'ELSE'
	'WHILE'NUMERIC'DO'[I:=I*10+CHAR-^0;NEXT];

'RETURN'I;
'END';


'PROCEDURE'HEXBYT(I);
'INTEGER'I,J;



'PROCEDURE'HEXDIG(I);
'INTEGER'I;
'IF'I>9'THEN'CHOUT(0,^A+I-10)
'ELSE'CHOUT(0,^0+I);


'BEGIN'
I:=I&$FF;
I:=I/16;
J:=REM(0);
HEXDIG(I);
HEXDIG(J);
'END';





'PROCEDURE'HEXOUT(I);
'INTEGER'I;
'BEGIN'
CHOUT(0,^$);
HEXBYT(SWAP(I));
HEXBYT(I);
'END';








	'PROCEDURE'ERROR(N);
	'ADDRESS'N;

'BEGIN'
TEXT(0,"NOPE-");TEXT(0,N);
CRLF(0);
ABORT;
'END';




	'PROCEDURE'DOTAB;
CHOUT(0,TAB);





	'PROCEDURE'SHOW(TXT,FLAG);
	'ADDRESS'TXT;
	'INTEGER'FLAG;

'BEGIN'
TEXT(0,TXT);DOTAB;
'IF'FLAG'THEN'CHOUT(0,^T)'ELSE'CHOUT(0,^F);
CHOUT(0,^ );
'END';






'BEGIN'\MAIN PROC\
DIRBLK:=9;
DIRSIZ:=4;
MAXFL:=47;	\SELECT SO THAT DIRSIZ IS RIGHT

\SETUP ABSOLUTE ADDRES
PARM:=$BF00;	\RESIDENT HANDER COMM AREA

\RESERVE THE ARRAYS
I:=(MAXFL+1)*2;
\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(I);
LBLK:=RESERVE(I);
\BLOCK 3
UNUSED:=RESERVE(74);
PRDEV:=RESERVE(1);
PMAXB:=RESERVE(2);
RNAM:=RESERVE(11);
TITLE:=RESERVE(60);
VOLUME:=RESERVE(2);
DIRDAT:=RESERVE(2);
FDATE:=RESERVE(I);
FLAGS:=RESERVE(8);
\NON DIR ARRAYS
LOCNAM:=RESERVE(11);
STAB:=RESERVE(48);

CRLF(0);
TEXT(0,"SET FOR APEX V1.0");
CRLF(0);


DEVICE:=PARM(INDEV);
FREAD(DEVICE,9,FNAME,4);

FILE:=PARM(INNO); 		\FILE NUMBER INPUT

'IF'PARM(INFLG)#SETUP'THEN'
	ERROR("SET WHAT FILE?");


FIRBLK:=FBLK(FILE);		\ITS FIRST BLOCK

CRLF(0);




BLOCK:=RESERVE(256);
FREAD(DEVICE,FIRBLK,BLOCK,1);


'REPEAT''BEGIN'

CRLF(0);


TEXT(0,"RESTART:");
DOTAB;
HEXOUT(SIX(START));
TEXT(0," ");
INITI(0);
NEXT;
'IF'CHAR#CR'THEN'
	PUT(START,NUMBER);


TEXT(0,"START:  ");
DOTAB;
HEXOUT(SIX(RESTART));
TEXT(0," ");
INITI(0);
NEXT;
'IF'CHAR#CR'THEN'
	PUT(RESTART,NUMBER);


TEXT(0,"EXIT:   ");
DOTAB;
HEXOUT(SIX(VEXIT));
TEXT(0," ");
INITI(0);
NEXT;
'IF'CHAR#CR'THEN'
	PUT(VEXIT,NUMBER);


TEXT(0,"ERROR EXIT: ");
DOTAB;
HEXOUT(SIX(VERROR));
TEXT(0," ");
INITI(0);
NEXT;
'IF'CHAR#CR'THEN'
	PUT(VERROR,NUMBER);


TEXT(0,"ABORT EXIT: ");
DOTAB;
HEXOUT(SIX(VABORT));
TEXT(0," ");
INITI(0);
NEXT;
'IF'CHAR#CR'THEN'
	PUT(VABORT,NUMBER);





TEXT(0,"USRTOP: ");
DOTAB;
CHOUT(0,^$);
HEXBYT(BLOCK(USRTOP));
TEXT(0,"   ");
INITI(0);
NEXT;
'IF'CHAR#CR'THEN'
	BLOCK(USRTOP):=NUMBER;

CRLF(0);



TEXT(0,"DEFAULT OUTPUT EXTENTION: ");
'FOR'I:=0,2'DO'CHOUT(0,BLOCK(DFOOFF+I));

INITI(0);
TEXT(0," ");
NEXT;
'IF'CHAR#CR'THEN'

'FOR'I:=0,2'DO'[BLOCK(DFOOFF+I):=CHAR;NEXT];

TEXT(0,"DEFAULT INPUT EXTENTION:  ");
'FOR'I:=0,2'DO'CHOUT(0,BLOCK(DFIOFF+I));
INITI(0);
TEXT(0," ");
NEXT;
'IF'CHAR#CR'THEN'
'FOR'I:=0,2'DO'[BLOCK(DFIOFF+I):=CHAR;NEXT];

CRLF(0);



SHOW("SYSBOMB:",BLOCK(SYBOMB));
INITI(0);
NEXT;
BLOCK(SYBOMB):=
	('IF'CHAR=^F'THEN'0
	'ELSE'('IF'CHAR=^T'THEN'$FF'ELSE'(BLOCK(SYBOMB))));



SPECIAL:=BLOCK(DFSOFF);

SHOW("BACKUP:  ",SPECIAL&1);

INITI(0);
NEXT;
NEWSPEC:=
	('IF'CHAR=^F'THEN'0
	'ELSE'('IF'CHAR=^T'THEN'1'ELSE'(SPECIAL&1)));

SHOW("SIZE LIMIT:",SPECIAL&2);
INITI(0);
NEXT;
NEWSPEC:=NEWSPEC ! 
	('IF'CHAR=^F'THEN'0
	'ELSE'('IF'CHAR=^T'THEN'2'ELSE'(SPECIAL&2)));

SHOW("KEEP DATE:",SPECIAL&4);
INITI(0);
NEXT;
NEWSPEC:=NEWSPEC ! 
	('IF'CHAR=^F'THEN'0
	'ELSE'('IF'CHAR=^T'THEN'4'ELSE'(SPECIAL&4)));

CRLF(0);
BLOCK(DFSOFF):=NEWSPEC;


TEXT(0,"OUTPUT BUFFER: ");
HEXOUT(SIX(OTBUFD));
CHOUT(0,^-);
HEXOUT(SIX(OTBUFE));
TEXT(0," ");
INITI(0);
NEXT;
'IF'CHAR#CR'THEN'
	'BEGIN'
	I:=NUMBER;
	PUT(OTBUFD,I);
	I:=NUMBER;
	PUT(OTBUFE,I);
	'END';

TEXT(0,"INPUT BUFFER:  ");
HEXOUT(SIX(INBUFD));
CHOUT(0,^-);
HEXOUT(SIX(INBUFE));

TEXT(0," ");
INITI(0);
NEXT;
'IF'CHAR#CR'THEN'
	'BEGIN'
	I:=NUMBER;
	PUT(INBUFD,I);
	I:=NUMBER;
	PUT(INBUFE,I);
	BLOCK(INBUFE+1):=SWAP(I);
	'END';


CRLF(0);
TEXT(0,"SATISFIED?");
INITI(0);
NEXT;

'END''UNTIL'CHAR=^Y;

FWRITE(DEVICE,FIRBLK,BLOCK,1);
CRLF(0);

'END';\OF ALL
