\SHADES.XPL	JUL-05-2001
\Display the shades in the standard color palette for graphic mode $13.
\This program does direct screen writes, which makes it about 100 times faster
\ than using the Point plot intrinsic.

inc	C:\CXPL\CODESI;

int	JJ;
seg char SCREEN;	\Array for video screen in mode $13



proc	DRAWBOX(X, Y, C);	\Draw a color swatch (C) at X, Y
int	X, Y, C;
int	I, J;
def	H=200/9, W=320/24;
begin
for J:= Y, Y+H-1 do
    for I:= X, X+W-1 do
	SCREEN(J, I):= C;
end;	\DRAWBOX



proc	DRAWSWATCHES;		\Draw the color swatches
int	I, J, C;
begin
C:= $20;			\skip the first 32 colors
for J:= 0, 9-1 do		\display an array of 24 x 9 swatches
    for I:= 0, 23 do
	begin
	DRAWBOX(I*(320/24), J*(200/9), C);
	C:= C + 1;
	end;
end;	\DRAWSWATCHES



begin	\MAIN
SCREEN:= RESERVE(200*2);	\Set up video screen array
for JJ:= 0, 199 do
	SCREEN(JJ):= $A000 + 320/16 *JJ;

SETVID($13);

DRAWSWATCHES;
JJ:= CHIN(1);

OPENI(0);
SETVID($03);
end;	\MAIN
