\SHAPE.XPL		-- USE XPL0 AND I2LBIG
\A TRIVIAL LOGO-LIKE PROGRAM BY LOREN BLANEY
\MODIFIED TO MAKE SHAPES FOR CAPELLA'S LOGO SEARCH, JAN. 1987

\	if FILL then
\		[RTMP:=DIRECTION;
\		PENUP;
\		RTMP1:=if ANGLE(KND)>90. then
\				(180.0-ANGLE(KND))/2.0
\		       else ANGLE(KND)/2.0;
\		RIGHT(RTMP1);
\		FORWARD(A/B);
\		DIRECTION:=RTMP;
\		PENDOWN]
\	else ;

\loop	begin
\	ASK("5-SQUARE");
\	INIT; CLEAR;
\	for I:=1,J do
\		begin
\		FORWARD(B);
\		RIGHT(C);
\		SQUARE(D);
\		end;
\	OPENI(0); J:=CHIN(0);
\	if J=^Q then quit;
\	end;

code	\COMPLETE SET, STANDARD XPLV5D INTRINSICS
ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
SCAN=24,	SETRUN=25,	CHAIN=28,	OPENF=29,

WRITE=30,	READ=31,	SETTXT=33,	SETHI=34,
SETMIX=35,	SETLO=36,	BUTTON=37,	PADDLE=38,
SOUND=39,	CLEAR=40,	POINT=41,	LINE=42,
MOVE=43,	SCREEN=44,	BLOCK=45,	FIX=50;

code real	RLRES=46,	RLIN=47,	RLOUT=48,
FLOAT=49,	RLABS=51,	FORMAT=52,	SQRT=53,
LN=54,		EXP=55,		SIN=56,		ATAN2=57,
MOD=58,		LOG=59,		COS=60,		TAN=61,
ASIN=62,	ACOS=63;

def	UP=1.570796327;		\DIRECTION IN RADIANS
def	ON=$80, OFF=0, COM=$40;		\COLOR
def	FF=$0C, BS=$8, PR=2, TV=0, ESC=$1B, DD=3, CR=$D, EOF=$1A ;

real	DIRECTION,SIZE,RTMP,RTMP1;
int	COLOR,STR;
int	Z,I,K,KND,CNT,
\	FILL,
	JETON,
	SHACNT,
	LAST,
	SAVE,NAME,SIDES,FILE;

real	A,X,Y, B,C,D,   HOLD;
int	J,  HOLD1;

real	R,ANGLE;
addr	PORT;
address KEYBRD,KEYSTRB;

external DUMPHI=$EE08;	\installed routine to dump hi-res screen to printer
def	PRNTPARM=$EE00;

\----------------------------------------

function KEYIN;	\check for a keystroke from apple keyboard
integer CHAR,NUL;
begin
if KEYBRD(0)<=127 then return 0;
CHAR:=KEYBRD(0)&$7F;
NUL:=KEYSTRB(0);
return CHAR;
end;

proc	FORWARD(DIST);
real	DIST,NEWX,NEWY;
begin
\CALCULATE THE END POINT OF THE LINE.
\GIVEN POLAR COORDINATES, DETERMINE RECTANGULAR COORDINATES
NEWX:=X + SIZE*DIST*COS(DIRECTION);
NEWY:=Y - SIZE*DIST*SIN(DIRECTION);
LINE(FIX(NEWX), FIX(NEWY), COLOR);
X:=NEWX; Y:=NEWY;
end;	\FORWARD

proc	RIGHT(DEG);
real	DEG;
begin
DIRECTION:=DIRECTON - DEG/57.2957795;
end;	\RIGHT

proc	LEFT(DEG);
real	DEG;
begin
DIRECTION:=DIRECTON + DEG/57.2957795;
end;	\LEFT

proc	PENUP;		COLOR:=OFF;
proc	PENDOWN;	COLOR:=ON;
proc	PENCOM;		COLOR:=COM;

proc	INIT;	\INITIALIZATION
begin
SIZE:=1.0;
DIRECTION:=UP;
PENDOWN;
MOVE(FIX(X), FIX(Y));
SETHI;
end;	\INIT

proc NOISE(N); int N;
int I;
begin
SOUND(1,200,300*N);
\for I:=0,500 do;
end;	\NOISE


proc GETSTR(SS,MAX); address SS; int MAX;	\get a string from the user
int I,J,CH;
begin
I:=0;
CH:=CHIN(0);
loop	begin
	if CH=CR then quit;
	SS(I):=CH;
	I:=I+1;
	if I>=MAX then quit;
	CH:=CHIN(0);
	end;
for J:=I,MAX-1 do SS(J):=^ ;
SS(MAX-1):=SS(MAX-1)!$80;
\if I>0 then SS(I-1):=SS(I-1)!$80;
end;	\GETSTR


proc CURPOS(HPOS,VPOS);		\position LASERJET cursor
int HPOS,VPOS;
begin
CHOUT(PR,ESC);TEXT(PR,"&a");INTOUT(PR,VPOS);CHOUT(PR,^R);
\CRLF(PR);
CHOUT(PR,ESC);TEXT(PR,"&a");INTOUT(PR,HPOS);CHOUT(PR,^C);
end ;

proc COPIES;
int N;
begin
TEXT(TV,"NUMBER OF COPIES: "); N:=INTIN(TV);
CHOUT(PR,ESC);TEXT(PR,"&l");INTOUT(PR,N);CHOUT(PR,^X);
end;


proc BYE;
begin
SETTXT;
CLOSE(DD);
if JETON=1 then
	[CURPOS(0,0);
	CHOUT(PR,CR);
	TEXT(PR,"&l0O(8U(s1p10v0s0b5T")];	\reset to normal
exit;
end;

proc HIRESC;
begin
CRLF(0);
TEXT(0,"commands in the hi-res screen: "); CRLF(0);
TEXT(0,"C --> CONTINUE (DO A NEW SHAPE)"); CRLF(0);
\TEXT(0,"F --> FILL (STARS ONLY)"); CRLF(0);
TEXT(0,"K --> KEEP PARAMETERS IN OUTFILE"); CRLF(0);
\TEXT(0,"L --> USE LAST PARAMETERS, NOT FIRST"); CRLF(0);
TEXT(0,"S --> SAVE (DON'T ERASE) SCREEN"); CRLF(0);
TEXT(0,"P --> PRINT ON LASERJET"); CRLF(0);
TEXT(0,"Q --> QUIT"); CRLF(0);
\TEXT(0,"*** LAST DOESN'T WORK ***"); CRLF(0);
CRLF(0);
end;	\HIRESC


proc KEEP;	\keep this set of params in outfile
addr NM;
begin
OPENI(TV);
NM:=RESERVE(34);
NM(0):=$A0;
TEXT(TV,"NAME OF SHAPE: ");
GETSTR(NM,29);
if SHACNT<10 then CHOUT(DD,^ );
INTOUT(DD,SHACNT); TEXT(DD,". ");
SHACNT:=SHACNT+1;
TEXT(DD,NM); TEXT(DD,NAME(KND));
TEXT(DD,"	");
RLOUT(DD,HOLD(0)); CHOUT(DD,^,);
RLOUT(DD,HOLD(1)); CHOUT(DD,^,);
RLOUT(DD,HOLD(2));
TEXT(DD," | ");
RLOUT(DD,HOLD(3)); CHOUT(DD,^,);
RLOUT(DD,HOLD(4)); CHOUT(DD,^,);
RLOUT(DD,HOLD(5)); CHOUT(DD,^,);
CHOUT(DD,^ );
INTOUT(DD,HOLD1(0));
CRLF(DD);
TEXT(TV,"-- DONE --");CRLF(TV);
for I:=0,6000 do ;
end;	\KEEP

proc PRINT;
int N,M,PARM; addr ADR;
begin
if JETON=2 then [TEXT(TV,"NO PRINTER"); for I:=0,6000 do ; return];
JETON:=1;
ADR:=$B610;
if ADR(0)#1 then
	[TEXT(TV,"I DON'T THINK THE HANDLER IS CORRECT. / ");
	INTOUT(TV,ADR(0));
	CRLF(TV); CHOUT(TV,07);
	TEXT(TV,"EXIT (Y/N)? Y");
	CHOUT(TV,08); OPENI(TV);
	if CHIN(TV)#^N then exit];

\TEXT(TV, "RESET LASERJET? N"); CHOUT(TV,BS);
\N:=CHIN(0)=^Y;
\if N then [CHOUT(PR,ESC);TEXT(PR,"E")];
TEXT(PR,"&l0O(8U(s1p10v0s0b5T");	\reset LASERJET to normal

CRLF(0);
TEXT(0,"CURSOR POSITION FOR LASERJET: ");
CRLF(0);
TEXT(0,"HORIZONTAL: "); N:=INTIN(0);
TEXT(0,"VERTICAL: "); M:=INTIN(0);
CURPOS(N,M);

TEXT(0,"RESOLUTION: ");
CRLF(0);
TEXT(0,"(1=300, 2=150, 3=100, 4=75 DPI):  ");
N:=INTIN(0);
PARM:=PRNTPARM;
PARM(2):=N;

TEXT(0,"1) NORMAL or 2) NEGATIVE IMAGE: 1"); CHOUT(TV,BS);
N:=CHIN(0)#^2;
if not N then [TEXT(TV,"negative image"); CRLF(TV)];
PARM(1):=not N;
OPENI(TV);

TEXT(0,"1) NORMAL or 2) MIRROR IMAGE : 1"); CHOUT(TV,BS);
N:=CHIN(0)#^2;
PARM(3):=not N;
if not N then [TEXT(TV,"mirror image"); CRLF(TV)];

DUMPHI;
Z:=KEYSTRB(0);
OPENI(TV);
TEXT(0,"EJECT PAGE? N"); CHOUT(TV,BS);
N:=CHIN(0)=^Y;
if N then [COPIES; CHOUT(PR,FF)];
end;	\PRINT


func SHOWNAMS;
int I;
begin
SETTXT;
for I:=0,CNT-1 do
	begin
	TEXT(0,NAME(I)); CRLF(0);
	end;
CRLF(0);
\if FILL then TEXT(0,"F ");
if LAST then TEXT(0,"L ");
if SAVE then TEXT(0,"S ");
TEXT(0,"   WHICH ONE?  "); I:=INTIN(0);
if I<0!I>CNT-1 then I:=0;
return I;
end;	\SHOWNAMS

\----------------------------------------

proc SHAPE(SZ);
real	SZ;
int	I;
begin
case KND of
6:	for I:=1,SIDES(KND) do
		begin
		FORWARD(SZ/R);
		PENUP;
		FORWARD(SZ/R);
		PENDOWN;
		FORWARD(SZ/R);
		RIGHT(ANGLE(KND));
		end;	\STAR1
100:	[]
else	for I:=1,SIDES(KND) do
		begin
		FORWARD(SZ);
		RIGHT(ANGLE(KND));
		end;
end;	\SHAPE

\----------------------------------------

proc SHOWPO;	\show positions
begin
RLOUT(TV,HOLD(0)); CHOUT(TV,^,);
RLOUT(TV,HOLD(1)); CHOUT(TV,^,);
RLOUT(TV,HOLD(2));
CRLF(TV);
end;

proc SHOWPM;	\show parameters
begin
RLOUT(TV,HOLD(3)); CHOUT(TV,^,);
RLOUT(TV,HOLD(4)); CHOUT(TV,^,);
RLOUT(TV,HOLD(5)); CHOUT(TV,^,);
CHOUT(TV,"  "); INTOUT(TV,HOLD1(0));
CRLF(TV);
end;

proc STORE1;	\store positions for later use
begin
HOLD(0):=A;
HOLD(1):=X;
HOLD(2):=Y;
end;

proc STORE2;	\store parameters for later use
begin
HOLD(3):=B;
HOLD(4):=C;
HOLD(5):=D;
HOLD1(0):=J;
end;

proc RESTO1;	\restore positions
begin
A:=HOLD(0);
X:=HOLD(1);
Y:=HOLD(2);
end;

proc RESTO2;	\restore parameters
begin
B:=HOLD(3);
C:=HOLD(4);
D:=HOLD(5);
J:=HOLD1(0);
end;

proc ASK;
int I;
begin
if KND=99 then return;
SETTXT;
TEXT(0,NAME(KND)); CRLF(0);
SHOWPO;
TEXT(0,"SAME STARTING POSITIONS? N"); CHOUT(TV,BS);
I:=CHIN(0);
I:=I=^Y ! I=^y ! I=^+;
OPENI(TV);

if I then RESTO1 else
	begin
	TEXT(0,"STARTING LENGTH OF LINE: ");
	A:=RLIN(0);
	TEXT(0,"X STARTING POSITION: ");
	X:=RLIN(0);
	TEXT(0,"Y STARTING POSITION: ");
	Y:=RLIN(0);
	end;
\-----------------------------------

CRLF(0);
SHOWPM;
TEXT(0,"SAME parameters? N"); CHOUT(TV,BS);
I:=CHIN(0);
I:=I=^Y ! I=^y ! I=^+;

if I then RESTO2 else
	begin
	if KND=2!KND=3 then TEXT(0,"INVERSE SIZE VALUE: ")
	else TEXT(0,"* INVERSE FORWARD MOVEMENT: ");
	B:=RLIN(0);

	TEXT(0,"ROTATION, IN DEGREES: ");
	C:=RLIN(0);

	TEXT(0,"* INVERSE DECREMENT VALUE: ");
	D:=RLIN(0);

	TEXT(0,"HOWMANY: ");
	J:=INTIN(0);
	end;

STORE1; STORE2;
end;	\ASK

\----------------------------------------

proc MULTI;
int I;
begin
Z:=KEYSTRB(0);
loop	begin
	HIRESC;
	KND:=SHOWNAMS;
	ASK;
	INIT;
	if SAVE then else if KND#99 then CLEAR;

	case KND of

	2,3:	[for I:=1,J do
			begin
			SHAPE(A/B);
			LEFT(C);
			A:=A-A/D;
			end];
	0:	[]
	else	begin
		if not LAST then RIGHT(30.);
		for I:=1,J do
			begin
			SHAPE(A);
			FORWARD(A/B);
			RIGHT(C);
			A:=A-A/D;
			end;
		end;

\	FILL:=false;
	LAST:=false;
	SAVE:=false;
	NOISE(1);
	loop	begin
		Z:=KEYIN;
		if Z=^K then [SETTXT; KEEP; SETHI];
		if Z=^S then [SAVE:=true; NOISE(2)];
		if Z=^L then [LAST:=true; STORE1; NOISE(3)];
		if Z=^P then [SETTXT; PRINT; SETHI];
\		if Z=^F then [FILL:=true; CHOUT(0,07); CHOUT(0,07)];
		if Z=^C then quit;
		if Z=^Q then quit;
		end;
	if Z=^Q then quit;
	end;
end;	\MULTI

proc DUMPFIL;	\dump input file into outfile
int CH;
begin
SHACNT:=1;
TEXT(TV,"MOVING INPUT FILE");
loop	begin
	CH:=CHIN(DD);
	if GETERR then quit;
	if CH=EOF then quit;
	CHOUT(DD,CH);
	if CH=CR then [CHOUT(TV,^.);SHACNT:=SHACNT+1];
	end;
end;	\DUMPFIL

\----------------------------------------

begin	\MAIN
TRAP(false); I:=GETERR;
KEYBRD:=$C000;
KEYSTRB:=$C010;
Z:=KEYSTRB(0);
FORMAT(4,1);
HOLD:=RLRES(10);
HOLD1:=RESERVE(4*2);
RTMP:=[135.,120.,115.,-15.,5.,14.];
for I:=0,5 do HOLD(I):=RTMP(I);
HOLD1(0):=50;

CNT:=10;
NAME:=[	" 0. GO TO GRAPHICS SCREEN",
	" 1. CLOSE STAR",
	" 2. SQUARE  ",
	" 3. HORSESHOE",
	" 4. ANGLE   ",
	" 5. TRIANGLE",
	" 6. OPEN STAR",
	" 7. PENTAGON",
	" 8. HEXAGON  ",
	" 9. OCTAGON  "];
ANGLE:=[0.0,144.,90.,90.,120.,120.,144.,72.,60.,45.];
SIDES:=[0,5,4,3,2,3,5,5,6,8];
R:=3.0;
\FILL:=false;
SAVE:=false;
JETON:=0;
LAST:=false;
FILE:=false;

CRLF(0);
TEXT(0,"<<<SHAPE MAKER>>>"); CRLF(0);CRLF(0);

OPENI(DD);
Z:=not GETERR;
OPENO(DD);
SHACNT:=1;
if GETERR then [CHOUT(0,7); TEXT(TV,"NO OUTFILE"); CRLF(TV)]
else [FILE:=true; if Z then DUMPFIL];

OPENO(PR);
if GETERR then [CHOUT(0,7); TEXT(TV,"NO PRINTER"); JETON:=2; CRLF(TV)];

MULTI;
BYE;
end;	\MAIN
