\SIEVE.XPL	MAY-19-95
\Eratosthenes Sieve Prime Number Program

code	CRLF=9, INTOUT=11, TEXT=12;
define	SIZE = 8190;
integer	PRIME, COUNT, ITER, I, K;
addr	FLAGS(SIZE+1);

begin
TEXT(0, "10 iterations
");
for ITER:= 1, 10 do				\do program 10 times
	begin
	COUNT:= 0;				\prime counter
	for I:= 0, SIZE do
		FLAGS(I):= true;		\set flags all true
	for I:= 0, SIZE do
	    if FLAGS(I) then			\found a prime
		begin
		PRIME:= I +I +3;		\twice the index + 3
		K:= I + PRIME;			\first multiple to kill
		while K <= SIZE do
			begin
			FLAGS(K):= false;	\zero a non-prime
			K:= K +PRIME;		\next multiple
			end;
		COUNT:= COUNT +1;		\primes found
		end;
	end;
INTOUT(0, COUNT);   TEXT(0, " primes
");						\primes found in 10th pass
end;
