\----------------------------------------------------------------------

func	GETFILESIZE(FILENAME);	\Return the size of a file
char	FILENAME;
int	PSPSEG,		\Program Segment Prefix segment, holds command line
	CPUREG,		\Address of CPU registers from GETREG
	DATASEG,	\Data segment address for this program
	;
char	DTA;		\Disk Transfer Access area for DOS calls
begin
CPUREG:= GETREG;			\Get address of CPU registers
PSPSEG:= CPUREG(11);
DATASEG:= CPUREG(12);

DTA:= RESERVE($80);			\Set up disk transfer access (DTA) area
CPUREG(AX):= $1A00;			\Use 128 bytes even though 34 is enough
CPUREG(DX):= DTA;
CPUREG(DS):= DATASEG;
SOFTINT($21);

CPUREG(AX):= $4E00;		\Look up first file name
CPUREG(CX):= $0037;		\Everything except volume label
CPUREG(DS):= DATASEG;
CPUREG(DX):= FILENAME;
SOFTINT($21);
return if (CPUREG(AX) & $FF) # 0 then 0
	else DTA($1A) + SWAP(DTA($1B));
end;	\GETFILESIZE



FILENAME:= "DI.EXE ";   FILENAME(6):= 0;
GETFILESIZE(FILENAME);
