\SPIRO2.XPL

'CODE'	\COMPLETE SET, STANDARD XPLV5D INTRINSICS

ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENIN=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;

'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;


'DEFINE'
	XCENTER=140,
	YCENTER=96,
	RAD=57.29578,
	PI=3.1415927;

'INTEGER'
	PX,
	PY,
	XOR,
	YOR,
	EDGES,
	PPTR,
	CHAR;


'REAL'
	RSTART,
	SIZE,
	ROTATE;



'PROCEDURE' WAIT;
'INTEGER' CHAR;
'BEGIN'
OPENIN(0);
CHAR:=CHIN(0);
'END';



'PROCEDURE' PNTVAL;
'BEGIN'
SETTXT;
TEXT(0,"CHANGE DEFAULTS? ");
OPENIN(0);
'IF' CHIN(0)=^Y 'THEN'
	'BEGIN'
	TEXT(0,"HORIZONAL OFFSET? ");
	XOR:=XCENTER+INTIN(0);
	TEXT(0,"VERTICAL OFFSET? ");
	YOR:=YCENTER+INTIN(0);
	TEXT(0,"SIZE? ");
	SIZE:=RLIN(0);
	TEXT(0,"ROTATION? ");
	RSTART:=RLIN(0)/RAD;
	'END';
TEXT(0,"EDGES? ");
EDGES:=INTIN(0);
TEXT(0,"CLEAR ARRAY? ");
OPENIN(0);
'IF' CHIN(0)=^Y 'THEN' PPTR:=0;
'END';



'PROCEDURE' DOPOINT;
'REAL' STEP;
'INTEGER' X,TEMP;
'BEGIN'
STEP:=(PI*2.)/FLOAT(EDGES);
ROTATE:=RSTART;
TEMP:=PPTR;

'FOR' PPTR:=PPTR,PPTR+EDGES-1 'DO'
	'BEGIN'
	PX(PPTR):=FIX(COS(ROTATE)*SIZE)+XOR;
	PY(PPTR):=FIX(SIN(ROTATE)*SIZE)+YOR;
	ROTATE:=ROTATE+STEP;
	'END';

'FOR' X:=TEMP,PPTR-1 'DO' DOT(PX(X),PY(X),$80);
'END';



'PROCEDURE' POINTS;
'BEGIN'
PNTVAL;
SETHI;
DOPOINT;
'END';



'PROCEDURE' SPIRAL;
'INTEGER' X,SSIZE,ESIZE,SSTEP;
'REAL' SKEW;
'BEGIN'
SETTXT;
TEXT(0,"START SIZE? ");
SSIZE:=INTIN(0);
TEXT(0,"END SIZE? ");
ESIZE:=INTIN(0);
TEXT(0,"SIZE STEP? ");
SSTEP:=INTIN(0);
TEXT(0,"SKEW? ");
SKEW:=RLIN(0)/RAD;
TEXT(0,"EDGES? ");
EDGES:=INTIN(0);
TEXT(0,"CLEAR ARRAY? ");
OPENIN(0);
'IF' CHIN(0)=^Y 'THEN' PPTR:=0;
RSTART:=0.;
SETHI;
X:=SSIZE;
'REPEAT'
	'BEGIN'
	SIZE:=FLOAT(X);
	DOPOINTS;
	RSTART:=RSTART+SKEW;
	X:=X+SSTEP;
	'END'
'UNTIL' X>ESIZE;
'END';



'PROCEDURE' STAR;
'INTEGER' X;
'BEGIN'
'FOR' X:=0,PPTR-1 'DO'
	'BEGIN'
	MOVE(XOR,YOR);
	LINE(PX(X),PY(X),$80);
	'END';
'END';



'PROCEDURE' CONNECT;
'INTEGER' START,END;
'BEGIN'
'FOR' START:=0,PPTR-1 'DO'
'FOR' END:=0,PPTR-1 'DO'
	'BEGIN'
	MOVE(PX(START),PY(START));
	LINE(PX(END),PY(END),$80);
	'END';
'END';



'PROCEDURE' SLANTS;
'INTEGER' X,Y;
'BEGIN'
Y:=PPTR-1;
'FOR' X:=0,PPTR-1 'DO'
	'BEGIN'
	MOVE(PX(X),PY(X));
	LINE(PX(Y),PY(Y),$80);
	Y:=Y-1;
	'END';
'END';



'PROCEDURE' CORONA;
'INTEGER' X,Y,SKIP;
'BEGIN'
SETTXT;
TEXT(0,"ENTER SKIP FACTOR ");
SKIP:=INTIN(0);
SETHI;
TEXT(0,"PPTR= ");INTOUT(0,PPTR);CRLF(0);
'FOR' X:=0,PPTR-1 'DO'
	'BEGIN'
	MOVE(PX(X),PY(X));
	Y:=X+SKIP;
	'IF' Y>=PPTR 'THEN' Y:=Y-PPTR;
	LINE(PX(Y),PY(Y),$80);
	'END';
'END';



'PROCEDURE' SETOR;
'DEFINE' XSIZE=10;
'INTEGER' XPAD,YPAD,X;
'BEGIN'
MOVE(XCENTER-XSIZE,YCENTER);
LINE(XCENTER+XSIZE,YCENTER,$80);
MOVE(XCENTER,YCENTER-XSIZE);
LINE(XCENTER,YCENTER+XSIZE,$80);
'REPEAT'
	'BEGIN'
	YPAD:=PADDLE(1);
	'FOR' X:=0,20 'DO';
	'IF' YPAD>191 'THEN' YPAD:=191;
	XPAD:=PADDLE(0);
	MOVE(XPAD,0);
	LINE(XPAD,191,$40);
	LINE(XPAD,0,$40);
	MOVE(0,YPAD);
	LINE(279,YPAD,$40);
	LINE(0,YPAD,$40);
	'END'
'UNTIL' BUTTON(0);
YOR:=YPAD;
XOR:=XPAD;
SETTXT;
TEXT(0,"NEW SIZE? ");
SIZE:=RLIN(0);
'END';



'PROCEDURE' ELIPSE;
'INTEGER' X,TEMP,PNTS;
'REAL' A,B,YA,XA,INC,ASQR,BSQR;
'BEGIN'
SETTXT;
TEXT(0,"WIDTH? ");
A:=RLIN(0);
ASQR:=A*A;
TEXT(0,"HEIGHT ");
B:=RLIN(0);
BSQR:=B*B;
TEXT(0,"NUMBER OF POINTS? ");
PNTS:=INTIN(0);
TEXT(0,"CLEAR ARRAY? ");
OPENIN(0);
'IF' CHIN(0)=^Y 'THEN' PPTR:=0;
SETHI;

TEMP:=PPTR;
YA:=B*-1.;
INC:=(2.*B)/(FLOAT(PNTS)/2.);
'FOR' PPTR:=PPTR,PPTR+(PNTS/2) 'DO'
	'BEGIN'
	RLOUT(0,YA);TEXT(0,"  ");INTOUT(0,PPTR);CRLF(0);
	PX(PPTR):=FIX(SQRT((1.-(YA*YA/BSQR))*ASQR))+XOR;
	PY(PPTR):=FIX(YA)+YOR;
	YA:=YA+INC;
	'END';

YA:=B;
'FOR' PPTR:=PPTR,PPTR+(PNTS/2) 'DO'
	'BEGIN'
	INTOUT(0,PPTR);CRLF(0);
	PX(PPTR):=-1*FIX(SQRT((1.-(YA*YA/BSQR))*ASQR))+XOR;
	PY(PPTR):=FIX(YA)+YOR;
	YA:=YA-INC;
	'END';

'FOR' X:=TEMP,PPTR-1 'DO' DOT(PX(X),PY(X),$80);
'END';



'PROCEDURE' SPIRO;
'REAL' ANGLE,A,B,G,H,INC,MAX;
'INTEGER' X;

'PROCEDURE' EPICYCLOID;
'BEGIN'
G:=(A+B)/B;
DOT(FIX((A+B)*COS(ANGLE) - B*COS(G*ANGLE))+XOR,
FIX((A+B)*SIN(ANGLE) - B*SIN(G*ANGLE))+YOR,
$80);
'REPEAT'
	'BEGIN'
	G:=(A+B)/B;
	LINE(FIX((A+B)*COS(ANGLE) - B*COS(G*ANGLE))+XOR,
	FIX((A+B)*SIN(ANGLE) - B*SIN(G*ANGLE))+YOR,
	$80);
	ANGLE:=ANGLE+INC;
	'END'
'UNTIL' ANGLE>MAX;
'END';



'PROCEDURE' HYPOCYCLOID;
'BEGIN'
H:=(A-B)/B;
DOT(FIX((A-B)*COS(ANGLE) + B*COS(H*ANGLE))+XOR,
FIX((A-B)*SIN(ANGLE) - B*SIN(H*ANGLE))+YOR,
$80);
'REPEAT'
	'BEGIN'
	G:=(A+B)/B;
	LINE(FIX((A-B)*COS(ANGLE) + B*COS(H*ANGLE))+XOR,
	FIX((A-B)*SIN(ANGLE) - B*SIN(H*ANGLE))+YOR,
	$80);
	ANGLE:=ANGLE+INC;
	'END'
'UNTIL' ANGLE>MAX;
'END';




'BEGIN'
SETTXT;
TEXT(0,"ENTER FIXED RADIUS ");
A:=RLIN(0);
TEXT(0,"ENTER ROLLING RADIUS ");
B:=RLIN(0);
TEXT(0,"ENTER TOTAL DEGREES ROTATION ");
MAX:=RLIN(0);
TEXT(0,"INCREMENT IN DEGREES ");
X:=INTIN(0);
INC:=.017*FLOAT(X);

TEXT(0,"1) EPICYCLOID");CRLF(0);
TEXT(0,"2) HYPOCYCLOID");CRLF(0);
X:=INTIN(0);
SETHI;
ANGLE:=0.;
'IF' X=1 'THEN' EPICYCLOID 'ELSE' HYPOCYCLOID;
'END';



'PROCEDURE' MENU;
'INTEGER' COMMAND;
'BEGIN'
SETTXT;
CHOUT(0,$0C);
TEXT(0," ****MENU*****");CRLF(0);
CRLF(0);
TEXT(0,"PPTR= ");INTOUT(0,PPTR);CRLF(0);
CRLF(0);
TEXT(0,"1) CIRCLE OF POINTS");CRLF(0);
TEXT(0,"2) STAR ");CRLF(0);
TEXT(0,"3) CONNECT DOTS ");CRLF(0);
TEXT(0,"4) CLEAR SCREEN ");CRLF(0);
TEXT(0,"5) DISPLAY ");CRLF(0);
TEXT(0,"6) SLANTS ");CRLF(0);
TEXT(0,"7) CORONA ");CRLF(0);
TEXT(0,"8) SPIRAL ");CRLF(0);
TEXT(0,"9) SET ORIGIN ");CRLF(0);
TEXT(0,"10) ELIPSE ");CRLF(0);
TEXT(0,"11) SPIRO ");CRLF(0);
CRLF(0);
TEXT(0,"SELECT ONE ");
COMMAND:=INTIN(0);
SETHI;
'CASE' COMMAND 'OF'
	1: [POINTS;WAIT];
	2: [STAR;WAIT];
	3: [CONNECT;WAIT];
	4: [CLEAR;SETTXT;];
	5: [SETHI;WAIT];
	6: [SLANTS;WAIT];
	7: [CORONA;WAIT];
	8: [SPIRAL;WAIT];
	9: SETOR;
	10: [ELIPSE;WAIT];
	11: [SPIRO;WAIT]
'ELSE';
'END';


'BEGIN'	\MAIN
PX:=RESERVE(2000);
PY:=RESERVE(2000);
XOR:=XCENTER;
YOR:=YCENTER;
SIZE:=60.;
PPTR:=0;
RSTART:=0.;

'LOOP'
	'BEGIN'
	MENU;
	'END';
SETTXT;
'END';
