\SQUASH20.XPL
\SQUASH V2.0 FOR FFS V2.0

'CODE'
ABS=0,		REM=2,		RESERVE=3,	SWAP=4,
CHIN=7,		CHOUT=8,	CRLF=9,		INTIN=10,
INTOUT=11,	TEXT=12,	INITI=13,	INITO=14,
CLOSE=15,	FRUN=28,	FSAVE=29,	FWRITE=30,
FREAD=31,	FASAVE=27,	FGET=26,	RESTORE=32,
ABORT=16,	SPACE=18;


\THE DIRECTORY
'ADDRESS'
	TITLE,	\TITLE OF THE VOLUME
	RNAM,	\THE REMEMBERED FILE
	FNAME,	\THE FILE NAMES
	FSTAT,	\THE FILE STATUS
	BLKUSE,	\BLOCK BIT MAP
	UNUSED;	\FREE DIRECTORY SPACE
\INTEGER ARRAYS IN THE DIRECTORY
'INTEGER'
	DIRDAT,	\DIRECTORY DATE
	FDATE,	\DATE OF FILES
	FBLK,	\THE FIRST BLOCK
	LBLK;	\THE LAST BLOCK


\THE SYSTEM GLOBALS:
'ADDRESS'
	STAB;	\FOR SORT

'INTEGER'
	DIRSIZ,	\DIR SIZE
	SWAPSIZ,\SWAPPING SIZE
	DIRBLK,	\WHERE DIRECT IS
	SWAPBLK,\SWAPPING AREA
	SYSBLK,	\WHERE SYSTEM IS
	USERBLK,\FIRST USER BLOCK
	BACKBLK,\BLOCK TO PU BACKUP DIR IN
	FIRBLK,	\FIRST BLOCK OF FILE
	LASBLK,	\LAST BLOCK OF FILE
	FLNO,	\NUMBER OF FILE
	MAXBLK,	\HIGHEST BLOCK
	MAXFL,	\HIGHEST FILE NO
	CHAR,	\INPUT CHARACTER
	SWAPFLG,\=0 IF SWAPPING AREA IS INVALID
	SWITCH,	\USER FILE SWITCH
	ARG1,	\USER ARGUMENT
	ARG2,	\USER ARGUMENT
	SPECIAL,\SPECIAL BITS IN PROGRAM FILE REQUEST
	SYSDAT,	\SYSTEM DATE
	INSIZE,	\SIZE OF LAST OPENED INFILE
	INDATE,	\DATE OF LAST INFILE
	MAXSTB,	\SIZE OF STAB
	FILENO;	\RUN FILE NUMBER

\FOR MAIN
'INTEGER'I,UBL;

\CONSTANTS

\FILE STATUS IN THE DIRECTORY
'DEFINE' NULL=0,TENTATIVE=255,REPLACE=254,VALID=1;


	'PROCEDURE'ERROR(N);
	'INTEGER'N;

'BEGIN'
TEXT(0,"SQUASH ERROR #");INTOUT(0,N);
CRLF(0);
ABORT;
'END';


	'PROCEDURE'PRDAT(DAT);
	'INTEGER'DAT,DAY,MO;

'BEGIN'
'IF'DAT<=0'THEN'[TEXT(0,"NO DATE");'EXIT'];
DAT:=DAT/32;DAY:=REM(0);
DAT:=DAT/16;MO:=REM(0);
INTOUT(0,MO);CHOUT(0,^/);
INTOUT(0,DAY);CHOUT(0,^/);
INTOUT(0,DAT+76);
'END';


	'PROCEDURE'WRTDIR;

'BEGIN'
FWRITE(DIRBLK,FNAME,DIRSIZ);
'END';



	'PROCEDURE'PRINT(FILE);
	'INTEGER'FILE,MIN,MAX,K,SIZE;

'BEGIN'
'FOR'K:=0,7'DO'CHOUT(0,FNAME(FILE*11+K));
CHOUT(0,^.);
'FOR'K:=8,10'DO'CHOUT(0,FNAME(FILE*11+K));
MIN:=FBLK(FILE);
MAX:=LBLK(FILE);
SIZE:=MAX-MIN+1;
TEXT(0,"  ");INTOUT(0,SIZE);
'IF'SIZE<10'THEN'CHOUT(0,^ );
'IF'SIZE<100'THEN'CHOUT(0,^ );
CHOUT(0,^ );
INTOUT(0,MIN);
CHOUT(0,^-);INTOUT(0,MAX);
'END';

	'PROCEDURE'RDDIR;

'BEGIN'
FREAD(DIRBLK,FNAME,DIRSIZ);
'END';


	'PROCEDURE'SORT;
	'INTEGER'I,J,T;

'BEGIN'\BUBBLE SORT THE FILES INTO ACENDING FBLK
J:=0;
'FOR'I:=0,MAXFL'DO'
	'IF' FSTAT(I)=VALID'THEN'
		[STAB(J):=I;J:=J+1];
MAXSTB:=J-1;
'FOR'I:=0,MAXSTB-1'DO'
'IF'FBLK(STAB(I+1))<FBLK(STAB(I))'THEN'
	\WE ARE OUT OF ORDER SO...
	'BEGIN'
	J:=I;
	'REPEAT''BEGIN'
		T:=STAB(J);
		STAB(J):=STAB(J+1);
		STAB(J+1):=T;
		J:=J-1;
		'END'
	'UNTIL'(FBLK(STAB(J))<FBLK(STAB(J+1)))!(J<0);
	'END';
'END';

	'PROC'COPY(FROM,TO,SIZE);
	'INT'FROM,TO,SIZE,BUFSIZ;
	'ADR'BUFFER;

'BEGIN'
BUFSIZ:=SPACE/256-4;
'IF'BUFSIZ<=0'THEN'ERROR(8);
BUFFER:=RESERVE(BUFSIZ*256);
'WHILE'SIZE>BUFSIZ'DO'
	'BEGIN'
	FREAD(FROM,BUFFER,BUFSIZ);
	FWRITE(TO,BUFFER,BUFSIZ);
	FROM:=FROM+BUFSIZ;
	TO:=TO+BUFSIZ;
	SIZE:=SIZE-BUFSIZ;
	'END';
FREAD(FROM,BUFFER,SIZE);
FWRITE(TO,BUFFER,SIZE);
'END';


	'PROCEDURE'MOVE(I);
	'INTEGER'I,FBL,LBL,SIZ,FL;

'BEGIN'
FL:=STAB(I);
FBL:=FBLK(FL);
LBL:=LBLK(FL);
SIZ:=LBL-FBL+1;
'IF'UBL<FBL'THEN'
	'BEGIN'
	TEXT(0,"MOVING: ");PRINT(FL);
	TEXT(0,"  TO  ");INTOUT(0,UBL);
	CRLF(0);
	COPY(FBL,UBL,SIZ);
	FBLK(FL):=UBL;
	LBLK(FL):=UBL+SIZ-1;
	'END';
UBL:=LBLK(FL)+1;
'END';




'BEGIN'\MAIN PROC\

MAXBLK:=1000;
SWAPSIZ:=56;
DIRBLK:=0;
DIRSIZ:=5;
SWAPBLK:=13;
USERBLK:=130;
SYSBLK:=SWAPBLK+SWAPSIZ;
BACKBLK:=125;

MAXFL:=47;	\SELECT SO THAT DIRSIZ IS RIGHT


\RESERVE THE ARRAYS
I:=(MAXFL+1)*2;
\BLOCKS 0-2
FNAME:=RESERVE((MAXFL+1)*11);
FSTAT:=RESERVE(MAXFL+1);
FBLK:=RESERVE(I);
LBLK:=RESERVE(I);
\BLOCK 3
BLKUSE:=RESERVE(181);
RNAM:=RESERVE(11);
TITLE:=RESERVE(62);
DIRDAT:=RESERVE(2);
\BLOCK 4
FDATE:=RESERVE(I);
UNUSED:=RESERVE(256-I);
\NON DIR ARRAYS
STAB:=RESERVE(48);

CRLF(0);TEXT(0,"SQUASH V2.0");CRLF(0);
TEXT(0,"VERIFY?");INITI(0);
'IF'CHIN(0)#^Y'THEN'ABORT;
RDDIR;
SORT;
UBL:=USERBLK;
'FOR'I:=0,MAXSTB'DO'MOVE(I);
WRTDIR;
TEXT(0,"SQUASH DONE");CRLF(0);
'END';\OF ALL
