\THERMIS.XPL
\CALCULATE THERMISTOR VALUES


'CODE'	\COMPLETE SET, STANDARD XPLV5D INTRINSICS
ABS=0		RAN=1		REM=2		RESERVE=3
SWAP=4		EXTEND=5	RESTART=6	CHIN=7
CHOUT=8		CRLF=9		INTIN=10	INTOUT=11
TEXT=12		OPENIN=13	OPENO=14	CLOSE=15
ABORT=16	TRAP=17		SPACE=18	RERUN=19
GETHP=20	SETHP=21	GETERR=22	CURSOR=23
SCAN=24		SETRUN=25	CHAIN=28	OPENF=29
WRITE=30	READ=31		RESTORE=32	SETTXT=33
SETHI=34	SETMIX=35	SETLO=36	BUTTON=37
PADDLE=38	SOUND=39	CLEAR=40	DOT=41
LINE=42		MOVE=43		SCREEN=44	BLOCK=45
FIX=50;

'CODE''REAL'	RLRES=46	RLIN=47		RLOUT=48
FLOAT=49	RLABS=51	FORMAT=52	SQRT=53
LN=54		EXP=55		SIN=56		ATAN2=57
MOD=58		LOG=59		COS=60		TAN=61
ASIN=62		ACOS=63;



'INTEGER' ODEV;


'REAL'
	RES0,
	RES25,
	RES50,
	RATIO,
	TEMP,
	BETA,
	FACT,
	RES;

'PROCEDURE' VALUES;
'BEGIN'
TEXT(0,"ENTER RESISTANCE AT 0 C ");
RES0:=RLIN(0);
TEXT(0,"ENTER RESISTANCE AT 50 C ");
RES50:=RLIN(0);
RATIO:=RES0/RES50;
BETA:=1765.2685*LN(RATIO);
TEXT(ODEV,"RATIO= ");
RLOUT(ODEV,RATIO);
CRLF(ODEV);
TEXT(ODEV,"BETA= ");
RLOUT(ODEV,BETA);
CRLF(ODEV);CRLF(ODEV);
TEXT(0,"RESISTANCE AT 25 C ");
RES25:=RLIN(0);
'END';


'FUNCTION' 'REAL' FINDRES(TEMP);
'REAL' TEMP;
'BEGIN'
'RETURN'
RES25/EXP((BETA+FACT)*(1./298.15-1./TEMP));
'END';



'PROCEDURE' VOLTAGE;
'REAL' DIVRES,VLTOUT,VLTIN,VLTOLD,DELTA;
'INTEGER' X;
'BEGIN'
TEXT(0,"VOLTAGE IN? ");
VLTIN:=RLIN(0);
TEXT(0,"DIVIDER RESISTOR? ");
DIVRES:=RLIN(0);
TEXT(0,"FUDGE FACTOR?");
FACT:=RLIN(0);
'FOR' X:=-40,100 'DO'
	'BEGIN'
	VLTOLD:=VLTOUT;
	RES:=FINDRES(FLOAT(X)+273.5);
	VLTOUT:=VLTIN-((RES/(RES+DIVRES))*VLTIN);
	INTOUT(ODEV,X);
	FORMAT(4,0);
	RLOUT(ODEV,FLOAT(X)*1.8+32.);
	FORMAT(7,0);
	RLOUT(ODEV,RES);
	FORMAT(4,3);
	RLOUT(ODEV,VLTOUT);
	FORMAT(3,4);
	DELTA:=VLTOUT-VLTOLD;
	RLOUT(ODEV,DELTA);
	FORMAT(3,2);
	RLOUT(ODEV,(5./256.)/(DELTA/1.8));
	CRLF(ODEV);
	'END';
'END';


'BEGIN'	\MAIN
TEXT(0,"OUTPUT DEVICE");
ODEV:=INTIN(0);
OPENO(ODEV);
VALUES;
'REPEAT'
	'BEGIN'
	VOLTAGE;
	TEXT(0,"MORE? ");
	OPENIN(0);
	'END'
'UNTIL' CHIN(0)=^N;
CHOUT(ODEV,$1A);
CLOSE(ODEV);
'END';
