\TILT.XPL	NOV-27-95
ext	ShowImage;

seg char ImageData(1);	\Segment array holding copy of PCX image
char	Palette(256*3);	\256 color registers. Each color is 3 bytes (RGB).
int	DataSeg,	\Our data segment address
	VidMode,	\Initial video mode to be restored upon exit
	II,		\Scratch for Main
	;

inc	\CXPL\STDLIB;
inc	LOADPCX;	\Routines to load a .PCX file

\-------------------------------------------------------------------------------

proc	DoIt;
int	Ang, K;
real	CosAng;
begin
Openi(1);
Ang:= 0;
loop	begin
	CosAng:= Cos(Rad(Float(Ang)));
	K:= Fix(4096.0/CosAng);
	ShowImage(ImageData(0), K);
	Ang:= Ang +10;
	if Chkkey then quit;
	end;
end;	\DoIt

\-------------------------------------------------------------------------------

proc	DosOpen; \Open input file (with extension) specified on command line
int	Handle;				\File handle
char	CmdTail($80);			\Copy of command tail
begin
Blit(CpuReg(11), $81, DataSeg, CmdTail, $7F);	\Get copy of command tail

Handle:= Fopen(CmdTail, 0);		\Open file name for input
Fset(Handle, ^I);
Openi(3);
end;	\DosOpen

\-------------------------------------------------------------------------------

begin	\Main
CpuReg:= Getreg;
DataSeg:= Cpureg(12);

ImageData(0):= Malloc(320/16*200);		\(320*200+15)/16;

DosOpen;				\Open .PCX file specified on command line
LoadPCX(ImageData(0));
LoadPcxPal(Palette);

II:= Equip;
if (II(2)&$08) = 0 then
	[Text(0, "

This program requires a VGA display.
");   exit];

Trap(false);
Trapc(true);				\Ignore Ctrl+C if struck on keyboard
VidMode:= GetVid;
Setvid($13);				\320x200x256

\Set block of 256 color registers starting with register 0
CallInt($10, $1012, 0, 256, Palette, 0, 0, DataSeg);

DoIt;

WaitKey;
SetVid(VidMode);	\Restore original video mode (clears screen)
end;	\Main
