\TRANS.XPL
\TRANSMITT FILE AT RATE DIFFERENT
\BAUD RATES

'CODE'RESERVE=3,CHIN=7,CHOUT=8,
REM=2,CRLF=9,NUMIN=10,
NUMOUT=11,TEXT=12,OPENIN=13,
OPENOUT=14,CLOSE=15,ABORT=16;

'ADDRESS'
	BCONL,	\LOW BYTE OF BAUD RATE CONSTANT
	BCONH,	\HIGH BYTE OF BAUD RATE CONSTANT
	TLOC;	\HOLDS BAUD RATE CONSTANT


'INTEGER'
	RATE,
	ODEV;

'PROC' NEWBAUD(R);
'INTEGER' R;
'BEGIN'
TLOC(0):=BCONL(R);
TLOC(1):=BCONH(R);
OPENIN(0);
'END';

'PROCEDURE' SETCONST;
'BEGIN'
\300 BAUD
BCONL(0):=$07;BCONH(0):=$73;
\600 BAUD
BCONL(1):=$3;BCONH(1):=$BC;
\1200 BAUD
BCONL(2):=$02;BCONH(2):=$6A;
\2400 BAUD
BCONL(3):=$00;BCONH(3):=$EF;
\4800 BAUD
BCONL(4):=$00;BCONH(4):=$77;
\9600 BAUD
BCONL(5):=$00;BCONH(5):=$3B;
\19,200 BAUD
BCONL(6):=$00;BCONH(6):=$1E;
'END';



'PROCEDURE' MENU;
'BEGIN'
NEWBAUD(1);
TEXT(0,"***** SELECT BAUD RATE ****");
CRLF(0);
TEXT(0," 0=300 BAUD");CRLF(0);
TEXT(0," 1=600 BAUD");CRLF(0);
TEXT(0," 2=1200 BAUD");CRLF(0);
TEXT(0," 3=2400 BAUD");CRLF(0);
TEXT(0," 4=4800 BAUD");CRLF(0);
TEXT(0," 5=9600 BAUD");CRLF(0);
TEXT(0," 6=19,200 BAUD");CRLF(0);
CRLF(0);
RATE:=NUMIN(0);
NEWBAUD(RATE);
'END';



'PROCEDURE' TRANSMIT;
'INTEGER' X;
'BEGIN'
'FOR' X:=0,65 'DO'
	'BEGIN'
	TEXT(0,"UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU");
	CRLF(0);
	TEXT(0,"UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU");
	CRLF(0);
	'END';
'END';

'PROCEDURE' TESTRATE;
'INTEGER' LOW,HIGH;
'BEGIN'
NEWBAUD(1);
TEXT(0,"ENTER LOW VALUE ");
LOW:=NUMIN(0);
TEXT(0,"ENTER HIGH VALUE ");
HIGH:=NUMIN(0);
TLOC(0):=LOW;
TLOC(1):=HIGH;
'END';



'BEGIN'	\MAIN
BCONL:=RESERVE(10);
BCONH:=RESERVE(10);
TLOC:=$00EA;
SETCONST;
'LOOP'
	'BEGIN'
	TESTRATE;
	TRANSMIT;
	'END';
'END';
