\TREE.XPL
\TESTS TREE BALANCING


'CODE'RESERVE=3,CHIN=7,CHOUT=8,
REM=2,CRLF=9,NUMIN=10,
NUMOUT=11,TEXT=12,OPENIN=13,
OPENOUT=14,CLOSE=15,ABORT=16;



'INTEGER' K,T,X,LINK,BAL,NEXT,S,R,P,Q,HEAD,
SIZE;

'ADDRESS' KEY;

'DEF' LEFT=0,RIGHT=1,GND=-1;


'PROCEDURE' INITIAL;
'BEGIN'
T:=HEAD;
P:=LINK(HEAD,RIGHT);S:=P;
'END';


'PROCEDURE' INSERT;
'BEGIN'
KEY(Q):=K;
LINK(Q,LEFT):=GND;LINK(Q,RIGHT):=GND;BAL(Q):=0;
NEXT:=NEXT+1;
'END';



'PROCEDURE' SEARCH(K);
'INTEGER' K;

'BEGIN'	\START OF SEARCH
'LOOP'
	'BEGIN'
	'IF' K<KEY(P) 'THEN'
		'BEGIN'	\MOVE LEFT
		Q:=LINK(P,LEFT);
		'IF' Q=GND 'THEN'
			'BEGIN'
			Q:=NEXT;
			LINK(P,LEFT):=NEXT;
			INSERT;
			'QUIT';
			'END';
		'END'
	'ELSE' 'IF' K>KEY(P) 'THEN'
		'BEGIN'	\MOVE RIGHT
		Q:=LINK(P,RIGHT);
		'IF' Q=GND 'THEN'
			'BEGIN'
			Q:=NEXT;
			LINK(P,RIGHT):=NEXT;
			INSERT;
			'QUIT';
			'END';
		'END'
	'ELSE' 'EXIT' P;
	'IF' BAL(Q)#0 'THEN'[T:=P;S:=Q;];
	P:=Q;
	'END';
'END';


'PROCEDURE' SETBAL;
'BEGIN'
'IF' K<KEY(S) 'THEN' [R:=LINK(S,LEFT);P:=R;]
	'ELSE' [R:=LINK(S,RIGHT);P:=R;];
'WHILE' P#Q 'DO'
	'BEGIN'
	'IF' K<KEY(P) 'THEN'
		'BEGIN'
		BAL(P):=-1;
		P:=LINK(P,LEFT);
		'END'
	'ELSE'
		'BEGIN'
		BAL(P):=1;
		P:=LINK(P,RIGHT);
		'END';
	'END';
'END';



'PROCEDURE' ROTRIGHT;

'PROCEDURE' RIGHTSINGLE;
'BEGIN'
P:=R;
LINK(S,RIGHT):=LINK(R,LEFT);
LINK(R,LEFT):=S;
BAL(S):=0;
BAL(R):=0;
'END';


'PROCEDURE' RIGHTDOUBLE;
'BEGIN'
P:=LINK(R,LEFT);
LINK(R,LEFT):=LINK(P,RIGHT);
LINK(P,RIGHT):=R;
LINK(S,RIGHT):=LINK(P,LEFT);
LINK(P,LEFT):=S;
'IF' BAL(P)= 1 'THEN' [BAL(S):=-1;BAL(R):=0;]
'ELSE' 'IF' BAL(P)=0 'THEN' [BAL(S):=0;BAL(R):=0;]
'ELSE' [BAL(S):=0;BAL(R):=1;];
BAL(P):=0;
'END';

'BEGIN'	\START ROTRIGHT
'IF' BAL(R)=1 'THEN' RIGHTSINGLE 'ELSE' RIGHTDOUBLE;
'END';



'PROCEDURE' ROTLEFT;

'PROCEDURE' LEFTSINGLE;
'BEGIN'
P:=R;
LINK(S,LEFT):=LINK(R,RIGHT);
LINK(R,RIGHT):=S;
BAL(S):=0;
BAL(R):=0;
'END';


'PROCEDURE' LEFTDOUBLE;
'BEGIN'
P:=LINK(R,RIGHT);
LINK(R,RIGHT):=LINK(P,LEFT);
LINK(P,LEFT):=R;
LINK(S,LEFT):=LINK(P,RIGHT);
LINK(P,RIGHT):=S;
'IF' BAL(P)=-1 'THEN' [BAL(S):=1;BAL(R):=0;]
'ELSE' 'IF' BAL(P)=0 'THEN' [BAL(S):=0;BAL(R):=0;]
'ELSE' [BAL(S):=0;BAL(R):=-1;];
BAL(P):=0;
'END';

'BEGIN'	\START ROTLEFT
'IF' BAL(R)=-1 'THEN' LEFTSINGLE 'ELSE' LEFTDOUBLE;
'END';


'PROCEDURE' BALANCE;
'INTEGER' LDIR;
'BEGIN'
LDIR:='IF' K<KEY(S) 'THEN' -1 'ELSE' 1;
'IF' BAL(S)=0 'THEN'
	'BEGIN'
	BAL(S):=LDIR;
	LINK(HEAD,LEFT):=LINK(HEAD,LEFT)+1;
	'EXIT';
	'END';
'IF' BAL(S)#LDIR 'THEN'
	'BEGIN'
	BAL(S):=0;'EXIT';
	'END'
'ELSE' 'IF' LDIR=-1 'THEN' ROTLEFT 'ELSE' ROTRIGHT;
'IF' S=LINK(T,RIGHT) 'THEN' LINK(T,RIGHT):=P 'ELSE' LINK(T,LEFT):=P;
'END';



'PROCEDURE' PRINT;
'INTEGER' X;
'BEGIN'
'FOR' X:=0,NEXT-1 'DO'
	'BEGIN'
	NUMOUT(0,X);
	TEXT(0,"  ");
	CHOUT(0,KEY(X));
	TEXT(0,"  ");
	NUMOUT(0,LINK(X,LEFT));
	TEXT(0,"  ");
	NUMOUT(0,LINK(X,RIGHT));
	TEXT(0,"  ");
	NUMOUT(0,BAL(X));
	CRLF(0);
	'END';
'END';



'BEGIN'	\MAIN
SIZE:=50;
KEY:=RESERVE(SIZE);
LINK:=RESERVE(SIZE*2);
'FOR' X:=0,SIZE-1 'DO' LINK(X):=RESERVE(4);
BAL:=RESERVE(SIZE*2);
HEAD:=0;
LINK(HEAD,RIGHT):=1;
LINK(HEAD,LEFT):=GND;
BAL(HEAD):=0;
NEXT:=1;
Q:=1;
'LOOP'
	'BEGIN'
	TEXT(0,"ENTER ");
	OPENIN(0);
	K:=CHIN(0);
	INITIAL;
	'IF' NEXT=1 'THEN' INSERT 'ELSE'
		'BEGIN'
		SEARCH(K);
		SETBAL;
		BALANCE;
		'END';
	PRINT;
	'END';
'END';
