\VIDCON.XPL

include C:\CXPL\CODESI;

\These codes indicate the type of video adapter used
def	MDPA=$01, 	\Monochrome Display Adapter		(MDPA)
	CGA=$02, 	\Color Graphics Adapter			(CGA)
	EGA=$04, 	\Enhanced Graphics Adapter		(EGA)
	VGA=$08, 	\Video Graphics Array			(VGA)
	MCGA=$10, 	\MultiColor Graphics Array		(MCGA)
	HGC=$20, 	\Hercules Graphics Card			(HGC)

\These codes indicate the type of monitor used
	MONO=$01, 	\Monochrome
	COLOR=$02, 	\Color (or Enhanced emulating color)
	ENHCOLOR=$04, 	\Enhanced Color
	ANALOGMONO=$08, \Analog Monochrome only
	ANALOGCOLOR=$10,\Analog Color only
	ANALOG=$18;	\Analog Monochrome and Color modes


int	X;



proc	VCONFIG;
\Routine to return the video configuration
\The Adapter code is in the low byte, monitor code in the high byte
int	MONOFLAG, ADAPTER, MONITOR, DSEG, CPUREG;
char	BBUF1;
int	IBUF1;


	proc	MONOTEST;
	if MONOFLAG then
	begin
	MONITOR:= MONITOR-1;
	ADAPTER:= ADAPTER-1;
	end;	\MONOTEST


	proc	VGATEST;
	int	SEG, OFF;
	int	SWITCH;
	begin
	OFF:= IBUF1(0);   SEG:= IBUF1(1);

	\Assume MCGA and Analog Color
	ADAPTER:= $10;   MONITOR:= $10;

	\Test Mode 12 supported = VGA
	if (PEEK(SEG, OFF+2) & 4) # 0 then
		begin
		\Select BW and Color Analog
		MONITOR:= $18;

		\Check VGA data switch
		if (PEEK(0, $489) & 1)#0 then [ADAPTER:= $08;   return];

		SWITCH:= PEEK(0, $488) & $0A;

		if MONOFLAG then
			begin
			case SWITCH of
			0, $A: [MONITOR:= 8;   ADAPTER:= 8];
			2, 8:  [MONITOR:= 1;   ADAPTER:= 1]
			other;
			end
		else
			begin
			case SWITCH of
			0, $A: [MONITOR:= 2;   ADAPTER:= 2];
			2, 8:  [MONITOR:= 10;   ADAPTER:= 8]
			other;
			end;
		end;
	end;	\VGATEST



	proc	EGATEST;
	int	MFLAG, CL;
	begin
	\Get configuration information
	CPUREG(1):= $0010;   CPUREG(0):= $1200;
	SOFTINT($10);

	\CGA card?
	if (CPUREG(1) & $FC)#0 then MONOTEST
	else	
		begin
		MFLAG:= (CPUREG(1) & $0100) # 0;
		if MONOFLAG # MFLAG then MONOTEST
		else
			begin
			\Select EGA
			ADAPTER:= $04;

			\Examine VGA switch settings
			CL:= CPUREG(2) & $0F;
			if CL>9 then MONITOR:= 1
			else case CL of
				3, 9: MONITOR:= 4;
				4, 5: MONITOR:= 1
			     other;
			end;
		end;
	end;	\EGATEST

begin	\VCONFIG
\Get DOS information
CPUREG:= GETREG;
DSEG:= CPUREG(12);

MONOFLAG:= (PEEK(0, $410) &$30) = $30;

\Reserve functionality/state tables
BBUF1:= RESERVE(40);
IBUF1:= BBUF1;

\Start with CGA and Color Monitor
ADAPTER:= 2;   MONITOR:= 2;

\Read Functionality/State Information
CPUREG(11):= DSEG;   CPUREG(4):= BBUF1;
CPUREG(1):= 0;   CPUREG(0):= $1B00;
SOFTINT($10);

\Test BIOS VGA support and Active Display
if ((CPUREG(0) & $FF)=$1B) & (BBUF1($25) >= 6) then VGATEST else EGATEST;

CPUREG(3):= $FFFF;
CPUREG(0):= $EF00;
SOFTINT($10);

if (CPUREG(3)&$FF)#$FF &  (ADAPTER&$01)#0 then ADAPTER:= $20;

return SWAP(MONITOR) ! ADAPTER;
end;	\VCONFIG



begin	\MAIN
X:= VCONFIG;
TEXT(0, "ADAPTER= ");   HEXOUT(0, X & $FF);
TEXT(0, " MONITOR= ");   HEXOUT(0, SWAP(X & $FF00));
CRLF(0);
end;	\MAIN
