\IBM PC XPL CODE SET FOR XPL V5.6I

code

ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15,
ABORT=16,	TRAP=17,	FREE=18,	RERUN=19,
GETHP=20,	SETHP=21,	GETERR=22,	CURSOR=23,
FSET=24,	SETRUN=25,	HEXIN=26,	HEXOUT=27,
CHAIN=28,	FOPEN=29,	WRITE=30,	READ=31,
FCLOSE=32,	CHKKEY=33,	SOFTINT=34,	GETREG=35,
BLIT=36,	PEEK=37,	POKE=38,	SOUND=39,
CLEAR=40,	POINT=41,	LINE=42,	MOVE=43,
READPIX=44,	SETVID=45	FIX=50,		POUT=64,
PIN=65,		INTRET=66,	EXTJMP=67,	EXTCAL=68;

code real

RLRES=46,	RLIN=47,	RLOUT=48,	FLOAT=49,
RLABS=51,	FORMAT=52,

SQRT=53,	LN=54,		EXP=55,		SIN=56,
ATAN2=57,	MOD=58,		LOG=59,		COS=60,
TAN=61,		ASIN=62,	ACOS=63;


real PX1,PY1,PX2,PY2,DX1,DY1,DX2,DY2,

OX1,OY1,OX2,OY2;


integer X, MODE,OLDMODE,CPUREG,COLOR,CCOLOR,COM,MAXX,MAXY;

define DEPTH=100;

procedure BOARDER;
begin
MOVE(0,0);
LINE(MAXX-1,0,1);
LINE(MAXX-1,MAXY-1,1);
LINE(0,MAXY-1,1);
LINE(0,0,1);
end;



procedure LINES;
integer I,C,P,CC;
begin
OPENI(0);
SETVID(MODE);
BOARDER;
CCOLOR:=1;
C:=0;
loop
	begin
	PX1:=PX1+DX1;PY1:=PY1+DY1;
	PX2:=PX2+DX2;PY2:=PY2+DY2;
	C:=C+1;
	if C>10 then
		begin
		C:=0;
		MOVE(FIX(OX1(0)),FIX(OY1(0)));
		LINE(FIX(OX2(0)),FIX(OY2(0)),0);
		for P:=0,DEPTH-2 do
			begin
			OX1(P):=OX1(P+1);OY1(P):=OY1(P+1);
			OX2(P):=OX2(P+1);OY2(P):=OY2(P+1);
			end;
		OX1(P):=PX1;OY1(P):=PY1;OX2(P):=PX2;OY2(P):=PY2;
		MOVE(FIX(PX1),FIX(PY1));
		LINE(FIX(PX2),FIX(PY2),CCOLOR);
		CCOLOR:=CCOLOR+1;
		if CCOLOR>=COLOR then CCOLOR:=1;
		end;

	if FIX(PX1)>=MAXX-2 ! FIX(PX1)<=1 then DX1:=-DX1;
	if FIX(PY1)<=1 ! FIX(PY1)>=MAXY-2 then DY1:=-DY1; 

	if FIX(PX2)>=MAXX-2 ! FIX(PX2)<=1 then DX2:=-DX2;
	if FIX(PY2)<=1 ! FIX(PY2)>=MAXY-2 then DY2:=-DY2; 
	for I:=0,100 do;

	if CHKKEY then quit;
	end;
end;


begin

CPUREG:=GETREG;
CPUREG(0):=$0F00;
SOFTINT($10);
OLDMODE:=CPUREG(0) & $FF;

OX1:=RLRES(DEPTH);
OY1:=RLRES(DEPTH);
OX2:=RLRES(DEPTH);
OY2:=RLRES(DEPTH);



MAXX:=640;	\800;
MAXY:=480;	\600;
COLOR:=16;	\256;
MODE:=$12;	\$30;	$63;

PX1:=310.0;PY1:=110.0;
PX2:=.90;PY2:=.80;
DX1:=.6;DY1:=.70;
DX2:=1.0;DY2:=1.0;

for X:=0,DEPTH-1 do
	begin
	OX1(X):=2.0;OY1(X):=2.0;
	OX2(X):=2.0;OY2(X):=2.0;
	end;

LINES;
SETVID(OLDMODE);
end;
