\XGET.XPL	JUN-30-86
\Program to receive a file using the XMODEM device.
\This strips out any existing LF's and inserts LF's after CR's.
\Note that the 68000 Apex system is not contaminated with linefeeds, so
\ when receiving a file from the 68000 the linefeeds must be inserted.

code
ABS=0,		RAN=1,		REM=2,		RESERVE=3,
SWAP=4,		EXTEND=5,	RESTART=6,	CHIN=7,
CHOUT=8,	CRLF=9,		INTIN=10,	INTOUT=11,
TEXT=12,	OPENI=13,	OPENO=14,	CLOSE=15;

int	CH;
def	LF=$0A, CR=$0D, EOF=$1A;


begin	\MAIN
TEXT(0, "
-- FILE GETTER, V1.1 --
(INSERTS LINEFEEDS)");

OPENI(5);
OPENO(3);
loop	begin
	repeat CH:= CHIN(5) until CH # LF;
	if CH = EOF then quit;
	CHOUT(3, CH);
	CHOUT(0, CH);
	if CH = CR then
		begin
		CHOUT(3, LF);
		CHOUT(0, LF);
		end;
	end;
OPENI(5);		\send ACK to tell sender we're all done
CLOSE(3);
end;	\MAIN
