\XPLColor.XPL	Jul-28-93
\Display 256 colors.
\(This version by-passes BIOS and goes ten times faster.)

code	Reserve=3,	ChIn=7,		SetVid=45;

seg char Screen;		\Array for video screen in mode $13
int	I, J;
def	TVW=320, TVH=200;	\Screen dimensions in pixels


proc	DrawSwatch(X, Y, C);	\Draw a color swatch (C) at X, Y
int	X, Y, C;
int	I, J;
[
    for J:= Y, Y+TVH/16-3 do
	for I:= X, X+TVW/16-3 do
	    Screen(J, I):= C;
];


[
    Screen:= Reserve(TVH*2);	\Set up Screen array in video memory
    for J:= 0, TVH-1 do
	Screen(J):= $a000 + TVW/16 *J;

    SetVid($13);		\Set 320x200x256 mode

    for J:= 0, 15 do		\Draw 16x16 array of swatches
	for I:= 0, 15 do
	    DrawSwatch(TVW/16*I, TVH/16*J, J*16+I);

    if ChIn(1) then;		\Wait for keystroke
    SetVid($03);		\Return to text mode
];
