\XPLT.XPL		VER 5.6-T		6-29-85

\REDUCED TO OUTPUT THE I2L IN TEXT FORM

\XPL0 COMPILER
\COPYRIGHT 1984 P.J.R. BOYLE
\FLOATING POINT VERSION BY LOREN BLANEY

\WARNING: THIS VERSION PRODUCES I2L CODE WHICH IS INCOMPATABLE WITH
\ VERSIONS 5F AND 4D (BECAUSE OF GLOBAL LOAD OPCODE AND INTRINSIC DISPATCH).

\CONTENTS:
\ MAIN--DISPLAY TITLE AND INITIALIZE
\	ERROR--DISPLAY ERROR MESSAGE AND OPTIONALLY CONTINUE
\	GETCH--GET A CHARACTER FROM THE SOURCE DEVICE
\	RATOM--READ AN ATOM FROM SOURCE DEVICE
\	SKIPIT--SKIP STATEMENT FOR ERRORS
\	HEXB--OUTPUT A HEX BYTE (IN ASCII) TO BINARY DEVICE
\	GEN--OUTPUT I2L CODE TO BINARY DEVICE
\	FIX--CHANGE A SPECIFIC I2L LOCATION TO THE CURRENT PC
\	LOOKUP--LOOK UP AN IDENTIFIER NAME IN THE SYMBOL TABLE
\	INSERT--INSERT AN IDENTIFIER INTO THE SYMBOL TABLE
\	GETCON--GET A CONSTANT (EITHER VALUE OR NAME)
\	PROCAL--PROCEDURE CALLS
\	BOOLEXP--GENERATE I2L CODE FOR A BOOLEAN EXPRESSION
\		FACTOR--GENERATE CODE FOR A FACTOR
\			STRCON--TEXT STRING CONSTANT
\			ARRAYCON--CONSTANT ARRAY
\			SPECFAC--SPECIAL FACTORS (addr,STRING)
\			IDFAC--IDENTIFIER FACTORS
\				FUNCTION--PROCEDURE AS A FACTOR
\		TERM--GENERATE CODE FOR A TERM (E.G. A*B)
\			TERMX--
\		ALGEXP--ALGEBRAIC EXPRESSION (E.G. A+B)
\			ALGX--
\		LOGEXP--LOGICAL EXPRESSION (E.G. A=B)
\			LOGX--
\		BOOLTERM--BOOLEAN TERM (E.G. A&B)
\	SSTATEMENT--(FOR 'QUIT'S IN 'CASE' STATEMENTS)
\		STATEMENT--PARSE AND GENERATE CODE
\			ASSIGN--ASSIGNMENT STATEMENTS
\				ASSX--
\			CASER--CASE STATEMENTS
\				CASER2--
\	PROCEDURE--PARSE AND GENERATE CODE
\		CODDEC--'CODE' DECLARATION
\		CONDEC--'DEFINE' DECLARATION
\		VARDEC--'INT','REAL', AND 'ADDR' DECLARATIONS
\		EXTDEC--'EXTERNAL' PROCEDURE DECLARATION
\		FPRDEC--FORWARD PROCEDURE DECLARATIONS
\		PROCDEC--'PROCEDURE' DECLARATIONS

code	\THE REQUIRED INTRINSICS:
ABS=0		REM=2		RESERVE=3	SWAP=4
CHIN=7		CHOUT=8		CRLF=9		INTIN=10
INTOUT=11	TEXT=12		OPENI=13	OPENO=14
CLOSE=15	HEXOUT=27;
code real
FLOAT=49,	RLRES=46;

def	TXMOD='TRUE';	\TRUE GIVES MNEMONICS FALSE GIVES CODES

def	TV=0, KB=0, NULDEV=7, EOF=$1A, BEL=$07, EOL=$0A; \I/O STUFF
def	SYMAX=254	\SIZE OF THE SYMBOL TABLE (MAX=254)
	RLMAX=25	\SIZE OF REAL-CONSTANT SYMBOL TABLE
	RLSIZE=5	\NO. OF BYTES IN A REAL NUMBER
	CODOFF=0	\OFFSET FOR INTRINSIC ROUTINES
	SIGCHAR=6	\NO. OF SIGNIFICANT CHARS IN AN IDENT
	QUITMAX=10;	\MAXIMUM NO. OF 'QUIT'S IN A 'LOOP'

int	ERRCNT	\ERROR COUNTER
	DEVICE	\DEFAULT DEVICE ARRAY.  WARNING!  NOT ROMMABLE
	LSTDEV	\LISTING OUTPUT DEVICE NUMBER
	SRCDEV	\SOURCE INPUT DEVICE NUMBER
	BINDEV	\BINARY OUTPUT DEVICE NUMBER
	CHAR	\CURRENT CHARACTER.  MOST OF THE TIME IT
		\ CONTAINS THE TERMINATOR OF THE CURRENT ATOM
	CASEIN	\BOOLEAN--UPPER/LOWER CASE FOR (') COMMANDS
	ATOM	\PRESENT ATOM DESCRIPTOR
		\CONTAINS RESERVED WORD HASH OR THE ASCII FOR
		\ A SPECIAL CHARACTER; 0 IF THE ATOM IS A
		\ CONSTANT OR AN IDENTIFIER
	ATYPE;	\PRESENT ATOM TYPE DESCRIPTOR
def	\ATYPE\ SPECIAL,IDENTIFIER,INTCON,REALCON;
char	IDENT;	\ARRAY--CURRENT IDENTIFIER NAME
int	HASH	\CURRENT IDENTIFIER HASH CODE
	LABCNT,
	IATOM;	\VALUE OF CURRENT INTEGER CONSTANT
real	RLATOM;	\REAL CONSTANT FROM PROC "RATOM"

int	IDTYPE;	\PRESENT IDENTIFIER TYPE DESCRIPTOR
def	UNDEF=0		\UNDEFINED ID (NO. ORDER IS CRITICAL)
	ADDRVAR=1	\ADDRESS VARIABLE ID (TYPE = INTEGER)
	INVAR=3		\INTEGER VARIABLE ID (ODD NOS.=INTEGER)
	RLVAR=4		\REAL VARIABLE ID
	INCON=5		\INTEGER CONSTANT ID
	RLCON=6		\REAL CONSTANT ID
	INPROC=7	\INTEGER PROCEDURE ID
	RLPROC=8	\REAL PROCEDURE ID
	INFPROC=9	\INTEGER FORWARD PROCEDURE ID
	RLFPROC=10	\REAL FORWARD PROCEDURE ID
	INOPT=11	\INTEGER OPTIMIZED PROCEDURE ID
	RLOPT=12	\REAL OPTIMIZED PROCEDURE ID
	ININT=13	\INTEGER INTRINSIC ID
	RLINT=14	\REAL INTRINSIC ID
	INEXT=15	\INTEGER EXTERNAL PROCEDURE ID
	RLEXT=16;	\REAL EXTERNAL PROCEDURE ID

int	LEV	\LEVEL OF CURRENT IDENTIFIER
	VAL	\VALUE OR ADDRESS OF CURRENT IDENTIFIER
	SYMNUM	\POSITION IN "SYMTBL" OF CURRENT IDENTIFER
	FACTYP;	\FACTOR (OR OPERAND) TYPE (REAL OR INTEGER)
def	\FACTYP\ REAL,INTEGER;
int	FIXES	\ARRAY--'QUIT' FIXES STILL OUTSTANDING
	LEVEL	\STATIC LEVEL OF CURRENT PROCEDURE
	NOLOC	\NUMBER OF BYTES OF LOCAL VARS CURRENTLY
	NOSYM	\CURRENT NUMBER OF SYMBOLS IN SYMBOL TABLE
	FIXCNT	\COUNT OF THE NUMBER OF OUTSTANDING 'QUIT'S
	STKLOD	\NO. OF INTEGERS LEFT ON STACK BY 'FOR' ! 'CASE'
	OPTPROC	\BOOLEAN--GENERATE AN OPTIMIZED PROCEDURE CALL
	NORLSY	\CURRENT NUMBER OF REAL CONSTANTS IN TABLE
	LASTOP	\PREVIOUS OPCODE
	HASLAB	\KEEPS TRACK OF LABEL GENERATION
	I;	\SCRATCH
char	HEXDIGIT; \ARRAY OF HEX DIGITS (0 - F)
	\ -- SYMBOL TABLE ARRAYS --
char	SYMBOL	\IDENTIFIER NAME (IDENT)
	SYMTYP;	\TYPE DESCRIPTORS (IDTYPE)
int	SYMVAL;	\VALUE OR ADDRESS (VAL)
char	SYMLEV	\LEVEL (LEV)
	SYMPNT;	\LIST LINKAGE POINTERS

char	BOX;	\HASH BOXES (SYMBOL LIST HEADERS)
real	RLTBL;	\REAL CONSTANT TABLE

def		\RESERVED WORD HASHES
ADRSYM=25797	BEGSYM=26057	CASEYM=25046	CODSYM=28615
DEFSYM=26058	DOSYM=28516	ELSEYM=27864	ENDSYM=28361
EXITYM=30926	EXTNYM=30937	FALSYM=25042	FFUNYM=26331
FORSYM=28632	FPRSYM=28888	FUNSYM=30164	GESYM=25959
GETSYM=26075	IFSYM=26217	INTSYM=28381	LESYM=25964
LOOPYM=28635	NOTSYM=28642	OFSYM=26223	PROCYM=29407
QUITYM=30170	REALYM=26067	REPSYM=26082	RETSYM=26086
THENYM=26841	TRUSYM=29417	UNTSYM=28393	WHILYM=26848
CHARYM=26820	EPRSYM=28887	EFUNYM=26330	LNKSYM=27098
OTHSYM=29911;



proc	ERROR; int N;	\SEND ERROR MESSAGE TO THE TV
int	ERR,CH,I;
char	STRING;
def	MAXERR=68;	\MAXIMUM ERROR NUMBER
begin
ERR:=RESERVE((MAXERR+1)*2);
for I:=0,MAXERR do ERR(I):="? ";	\UNUSED ERROR NOS. ="?"

ERR(1):="TOO MANY VARIABLES ";
ERR(2):="TOO MANY REAL CONSTANT NAMES ";
ERR(3):="TOO MANY NAMES ";
ERR(4):="TOO MANY 'QUITS' ";
ERR(5):="TOO MANY STATIC LEVELS ";
ERR(6):="NUMBER OUT OF RANGE ";
ERR(7):=ERR(6);		\FOR INTRINSIC DECLARATIONS
ERR(10):="UNDECLARED NAME ";
ERR(11):="NAME ALREADY DECLARED ";
ERR(20):="ILLEGAL START OF A STATEMENT ";	\IN "ASSIGN"
ERR(21):="^":=^"* ";
ERR(22):="'THEN'* ";
ERR(23):="'DO'* ";
ERR(24):="^",^"* ";
ERR(26):="ILLEGAL FACTOR ";	\UNRECOGNIZABLE SPECIAL FACTOR
ERR(27):="STATEMENT STARTING WITH A CONSTANT "; \IN "ASSIGN"
ERR(28):="'UNTIL'* ";
ERR(29):="'OTHER'* ";
ERR(30):="'ELSE'* ";
ERR(31):="DIGIT* ";
ERR(33):="INTEGER VARIABLE* ";	\IN A 'FOR' STATEMENT
ERR(40):="^"=^"* ";
ERR(41):="^";^"* ";
ERR(42):="CONSTANT* ";		\IN "GETCON"
ERR(43):="VARIABLE* ";		\FOR AN 'ADDR' OPERATOR
ERR(44):="^")^"* ";
ERR(45):="NAME* ";
ERR(46):="MIXED MODE ";
ERR(47):="INTEGER* ";
ERR(48):="'OF'* ";
ERR(49):="^":^"* ";
ERR(50):="^"]^"* ";
ERR(51):="NO ARGUMENTS DECLARED ";
ERR(52):="STATEMENT STARTING WITH 'ELSE' ";
ERR(53):="STATEMENT STARTING WITH 'OTHER' ";
ERR(60):="'QUIT' NOT IN A 'LOOP' ";
ERR(61):="EOF* ";
ERR(62):="EOF INSIDE A BLOCK ";
ERR(63):="EOF INSIDE A STRING ";
ERR(65):="'FPROC' & ITS 'PROC' NOT AT SAME LEVEL ";
ERR(66):="'FPROC' REFERENCE NOT FOUND ";
ERR(67):="'PROC' OR 'FUNC'* ";
ERR(68):="'EPROC'S AND 'LINK'S MUST BE GLOBAL ";

CHOUT(TV,BEL); CHOUT(TV,$0A);	\(DAMN LINEFEEDS!)
CRLF(TV);
TEXT(TV,"***** ERROR NO. "); INTOUT(TV,N); TEXT(TV," *****");
CRLF(TV);
STRING:=ERR(N);
I:=0;
loop	[CH:=STRING(I);		\OUTPUT MESSAGE
	if CH>=$80 then quit;
	if CH=^* then TEXT(TV," EXPECTED BUT NOT FOUND")
		else CHOUT(TV,CH);
	I:=I+1];
CRLF(TV);
TEXT(TV,"ATTEMPT TO CONTINUE? ");
OPENI(KB);
if CHIN(KB)=^N then [CLOSE(LSTDEV); exit];
BINDEV:=NULDEV;		\THERE SHALL BE NO OUTPUT FILE
ERRCNT:=ERRCNT+1;
end;	\ERROR



proc	GETCH;	\GET A CHARACTER FROM THE SOURCE DEVICE
\ FILTERS OUT COMMENTS AND DOES CASE SHIFT.
\(THIS PROCEDURE IS OPTIMIZED FOR SPEED.)
begin
CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
while CHAR=^\ do			\FILTER OUT COMMENTS
	begin
	loop	[CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
		case CHAR of
		EOL:	quit;
		^\:	quit;
		EOF:	quit
		else	];
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	end;
if CHAR=^' then [CASEIN:= not CASEIN; CHAR:=^ ]	\SHIFT CASE
else if CASEIN then	\SWITCH TO LOWER CASE IF CASEIN IS TRUE
	[if CHAR>=^A & CHAR<=^Z then CHAR:=CHAR+32];
end;	\GETCH



proc	RATOM;		\READ AN ATOM
\OUTPUTS:  ATOM, ATYPE, IDENT, HASH, IATOM, CHAR, RLATOM.
\ (THIS PROCEDURE IS OPTIMIZED FOR SPEED.)
int	LEN,NEG,EXP,I;
real	FRACT,DENOM;

	proc	RFRACT;	\READ THE FRACTIONAL PART OF A REAL NO.
	begin
	ATYPE:=REALCON; ATOM:=0;
	GETCH;
	FRACT:=FLOAT(0); DENOM:=FLOAT(10);	\(10.0 IS NOT SO PORTABLE)
	while CHAR>=^0 & CHAR<=^9 do
		[FRACT:=FRACT +FLOAT(CHAR-^0) /DENOM;
		DENOM:=DENOM*FLOAT(10);
		GETCH];
	RLATOM:=RLATOM +FRACT;
	end;	\RFRACT


	proc	REXP;	\READ AN EXPONENT IF ANY
	if CHAR=^E then
		begin
		ATYPE:=REALCON;
		GETCH;
		if CHAR=^- then [NEG:=true; GETCH]
			else NEG:=false;
		if CHAR=^+ then GETCH;
		EXP:=0;
		if CHAR<^0 ! CHAR>^9 then ERROR(31);
		while CHAR>=^0 & CHAR<=^9 do
			[EXP:=EXP *10 +CHAR-^0; GETCH];
		if NEG then EXP:= -EXP;
		while EXP>0 do
			[RLATOM:=RLATOM *FLOAT(10); EXP:=EXP-1];
		while EXP<0 do
			[RLATOM:=RLATOM /FLOAT(10); EXP:=EXP+1];
		end;	\REXP

begin	\RATOM
while CHAR<=$20\SPACE\ do
	begin	\SKIP SPACES, TABS, RETURNS, LF'S, & FF'S, ETC.
		\DON'T GO PAST EOF
	if CHAR=EOF then [ATYPE:=SPECIAL; ATOM:=EOF; return];
	GETCH;
	end;
if CHAR>=^a then if CHAR<=^z then		\RESERVED WORD
	[ATYPE:=SPECIAL;
	ATOM:=CHAR; GETCH;
	ATOM:=ATOM+SWAP(CHAR); GETCH;
	if CHAR>=^a & CHAR<=^z then [ATOM:=ATOM+CHAR; GETCH];
	while CHAR>=^a & CHAR<=^z do GETCH;
	if ATOM=TRUSYM then
		[ATYPE:=INTCON; ATOM:=0; IATOM:=true; return];
	if ATOM=FALSYM then
		[ATYPE:=INTCON; ATOM:=0; IATOM:=false];
	return];
if CHAR>=^A then if CHAR<=^Z then		\IDENTIFIER
	begin
	ATYPE:=IDENTIFIER; ATOM:=0;
	IDENT(0):=CHAR; HASH:=CHAR; GETCH;
	LEN:=1;
	loop case of
	CHAR>=^A & CHAR<=^Z,  CHAR>=^0 & CHAR<=^9,  CHAR=^_ :
		begin
		if LEN <SIGCHAR then
			[IDENT(LEN):=CHAR;
			HASH:=HASH+CHAR;
			LEN:=LEN+1];
		GETCH;
		end
	else quit;
	for LEN:=LEN,SIGCHAR-1 do
		[IDENT(LEN):=^ ; HASH:=HASH+^ ];
	HASH:=HASH & $3F;
	return;
	end;
if CHAR>=^0 then if CHAR<=^9 then	\UNSIGNED INTEGER
	begin
	ATYPE:=INTCON;		\ASSUME INTEGER UNTIL SHOWN OTHERWISE
	ATOM:=0;
	IATOM:=CHAR-^0; GETCH;
	loop	begin
		I:=IATOM;
		if CHAR<^0 ! CHAR>^9 then quit;
		I:=IATOM*10+CHAR-^0;
		if I<0\INTEGER OVERFLOW\ then quit;
		IATOM:=I;
		GETCH;
		end;
	RLATOM:=FLOAT(IATOM);
	IATOM:=I;		\(CAN'T FLOAT(32768))
	while CHAR>=^0 & CHAR<=^9 do	\MORE DIGITS MUST BE REAL
		[RLATOM:=RLATOM*FLOAT(10) + FLOAT(CHAR-^0);
		GETCH];
	if CHAR=^. then RFRACT;		\UNSIGNED REAL
	REXP;
	if ATYPE=INTCON & IATOM<0 & IATOM#$8000 then ERROR(6);
	return;
	end;
case CHAR of
^.:	[RLATOM:=FLOAT(0);			\UNSIGNED REAL
	RFRACT;
	REXP;
	return];
^$:	begin				\UNSIGNED HEX INTEGER
	ATYPE:=INTCON; ATOM:=0;
	GETCH;
	case of
	CHAR>=^0 & CHAR<=^9: IATOM:=CHAR-^0;
	CHAR>=^A & CHAR<=^F: IATOM:=CHAR-$37
	else [\DIGIT EXPECTED\ ERROR(31); return];
	loop	[GETCH;
		case of
		CHAR>=^0 & CHAR<=^9: I:=CHAR-^0;
		CHAR>=^A & CHAR<=^F: I:=CHAR-$37
		else return;
		if IATOM>$FFF then ERROR(6);
		IATOM:=IATOM*16+I];
	end;
^^:	[ATYPE:=INTCON;	\META CHARACTER = INTEGER CONSTANT
	ATOM:=0;
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	IATOM:=CHAR;
	GETCH;
	return];
^":	[ATYPE:=SPECIAL;		\SPECIAL CHARACTER
	ATOM:=CHAR;\(' AND BACKSLASH HAVE NO EFFECT IN STRINGS)
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	return]
else;
ATYPE:=SPECIAL;				\SPECIAL CHARACTER
ATOM:=CHAR;
GETCH;
if CHAR=^= then
	case ATOM of
	^::	[GETCH; ATOM:=GETSYM];
	^>:	[GETCH; ATOM:=GESYM];
	^<:	[GETCH; ATOM:=LESYM]
	else;
end;	\RATOM



proc	SKIPIT;
\SKIP THE REST OF A STATEMENT FOR ERROR RECOVERY
while ATOM#EOF & ATOM#^; & ATOM#ENDSYM & ATOM#^] &
	ATOM#BEGSYM & ATOM#^[ do RATOM;



proc	HEXB; int I;	\OUTPUT HEX BYTE (OPTIMIZED FOR SPEED)
begin
CHOUT(BINDEV,HEXDIGIT( (I&$FF)/16 ));
CHOUT(BINDEV,HEXDIGIT(REM(0)));
end;	\HEXB



proc	GEN(TYPE,OP,N1,N2);
int TYPE,OP,N1,N2;
addr A; int OPMN;
begin
OPMN:=
["EXIT","LOD","LDX","STO","STX","CAL","RET","JMP","JPC","HPI","ARG","IMM",
"CML","ADD","SUB","MUL","DIV","NEG","EQ","NE","GE","GT","LE","LT","FOR",
"INP","OR","AND","NOT","DUP","DBA","STI","DBI","ADR","LDI","LDA","IMS",
"CJP","JSR","RTS","DRP","CEXT","FLOD","FSTO","FIMM","FADD","FSUB","FMUL",
"FDIV","FNEG","FEQ","FNE","FGE","FGT","FLE","FLT","TRA","TRX","TRI","STT",
"MARK"];

if (OP=$06\RET\)&(LASTOP=$06) then return;	\AVOID DUPLICATE RETS
if (OP=$27\RTS\)&(LASTOP=$27) then return;	\AVOID DUPLICATE RTSS

CHOUT(BINDEV,$9);
if TXMOD then
	begin
	case OP of
	$FF:	TEXT(BINDEV,"NUL");
	$FE:	TEXT(BINDEV,"END");
	$FD:	TEXT(BINDEV,"INT");
	$FC:	TEXT(BINDEV,"FLT");
	$FB:	TEXT(BINDEV,"TXT")
	else	TEXT(BINDEV,OPMN(OP));
	end
else	begin
	CHOUT(BINDEV,^X);
	HEXB(OP);
	end;
if TYPE#0 then CHOUT(BINDEV,$9);

case TYPE of
0:	[];
1:	[INTOUT(BINDEV,N1);CHOUT(BINDEV,^,);INTOUT(BINDEV,N2)];
2:	INTOUT(BINDEV,N1);
3:	[CHOUT(BINDEV,^L);INTOUT(BINDEV,N1)];
5:	begin	\FLOAT IMM
	CHOUT(BINDEV,^$);
	A:=addr RLATOM;
	for I:=0,RLSIZE-1 do HEXB(A(I));
	end;
6:	begin
	CHOUT(BINDEV,^F);
	CHOUT(BINDEV,^L);INTOUT(BINDEV,N1);
	end
else ERROR(70);
if (OP<$FB)!(OP>$FD) then CRLF(BINDEV)
else CHOUT(BINDEV,$9);
LASTOP:=OP;
HASLAB:=false;
end;	\GEN


proc LABEL(N);
int N;
begin
if HASLAB then GEN(0,\NUL\$FF,0,0);
CHOUT(BINDEV,^L);
INTOUT(BINDEV,N);
LASTOP:=$FFFF;		\PREVENT OPTIMIZATION BASED ON LAST OP
HASLAB:=true;
end;


proc NEWLAB;
begin
LABCNT:=LABCNT+1;
return LABCNT;
end;

proc	LOOKUP;		\LOOKUP IDENTIFIER IN SYMBOL TABLE
\INPUTS: IDENT, HASH
\OUTPUTS: IDTYPE, VAL, LEV, SYMNUM.
\IF TWO IDENTIFIERS OF THE SAME NAME ARE IN THE SYMBOL TABLE
\ THEN THE MOST RECENT ENTRY IS USED.
int	I,K,PNTR;
begin
PNTR:=BOX(HASH);
loop	begin
	if PNTR=\EMPTY\$FF then [IDTYPE:=UNDEF; quit];
	I:=0; K:=PNTR;
	while IDENT(I)=SYMBOL(K) & I<SIGCHAR do
		[I:=I+1; K:=K+SYMAX];
	if I=SIGCHAR then	\FOUND
		[IDTYPE:=SYMTYP(PNTR);
		VAL:=SYMVAL(PNTR);
		LEV:=SYMLEV(PNTR);
		SYMNUM:=PNTR;		\(FOR FORWARD PROC)
		quit];
	PNTR:=SYMPNT(PNTR);
	end;
end;	\LOOKUP



proc	INSERT; int STYP,SLEV,SVAL;
\INSERT THE CURRENT IDENTIFIER INTO THE SYMBOL TABLE
\INPUTS:  STYP, SLEV, SVAL, IDENT, HASH, NOSYM, SYMBOL, & BOX.
int	I,K;
begin
LOOKUP;
if IDTYPE#UNDEF then if LEV=LEVEL then \COLLISION\ ERROR(11);
if NOSYM>=SYMAX then \TABLE FULL\ [ERROR(3); NOSYM:=SYMAX-1];
K:=NOSYM;
for I:=0,SIGCHAR-1 do [SYMBOL(K):=IDENT(I); K:=K+SYMAX];
SYMTYP(NOSYM):=STYP;
SYMLEV(NOSYM):=SLEV;
SYMVAL(NOSYM):=SVAL;
SYMPNT(NOSYM):=BOX(HASH);		\LINK BACK
BOX(HASH):=NOSYM;
NOSYM:=NOSYM+1;
end;	\INSERT



proc	GETCON;	\GET A CONSTANT--EITHER BY VALUE OR BY NAME
int	NEG;
begin
if ATOM=^+ then RATOM;
if ATOM=^- then [NEG:=true; RATOM] else NEG:=false;
case ATYPE of
INTCON:	[if NEG then IATOM:=-IATOM; FACTYP:=INTEGER];
REALCON:[if NEG then RLATOM:=-RLATOM; FACTYP:=REAL];
IDENTIFIER:
	begin
	LOOKUP;
	case IDTYPE of
	INCON:	[IATOM:=if NEG then -VAL else VAL;
		FACTYP:=INTEGER];
	RLCON:	[RLATOM:=if NEG then-RLTBL(VAL)else RLTBL(VAL);
		FACTYP:=REAL]
	else	ERROR(42);
	end
else	ERROR(42);
end;	\GETCON



fproc	BOOLEXP;


proc	PROCAL;
int	SVAL,SLEV,ARGCNT,SID;
begin
SVAL:=VAL; SLEV:=LEV; SID:=IDTYPE;
RATOM;
ARGCNT:=0;
if ATOM=^( then
	begin
	if SID>=INPROC & SID<=RLFPROC then	\NORMAL PROCEDURE CALL
		GEN(0,$3C\MARK\,0,0);		\WITH ARGS
	repeat	[RATOM; 
		BOOLEXP;
		ARGCNT:=ARGCNT +(if FACTYP=INTEGER then
			2 else RLSIZE)]
	until ATOM#^,;
	if ATOM#^) then ERROR(44) else RATOM;
	end;
case of
SID>=INPROC & SID<=RLFPROC:	\NORMAL PROCEDURE CALL
	[if ARGCNT>0 then GEN(2,\ARG\$0A,ARGCNT,0);
	GEN(3,\CAL\$05,SVAL,0)];
SID=ININT ! SID=RLINT:		\INTRINSIC PROCEDURE CALL
	GEN(2,\CML\$0C,SVAL,0);
SID=INOPT ! SID=RLOPT:		\OPTIMIZED PROCEDURE CALL
	[if ARGCNT>0 then \NO ARGS DECLARED\ ERROR(51);
	GEN(3,\JSR\$26,SVAL,0)]
else	GEN(3,\CEXT\$29,SVAL,0);  \EXTERNAL PROCEDURE CALL
end;	\PROCAL



proc	BOOLEXP;	\BOOLEAN EXPRESSION
\OUTPUTS FACTOR TYPE (FACTYP)
int	P1,P2,SFACTYP;



proc	FACTOR;


func	STRCON;		\STRING CONSTANT FUNCTION
int	SPC;
begin
SPC:=NEWLAB;
LABEL(SPC);
GEN(0,\TXT\$FB,0,0);
CHOUT(BINDEV,^");
while CHAR#^" do
	begin			\(GETCH--OPTIMIZED FOR SPEED)
	case CHAR of
	^^:	[CHOUT(BINDEV,CHAR);CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR)];
	EOF:	[ERROR(63); exit]
	else	[];
	CHOUT(BINDEV,CHAR);
	CHAR:=CHIN(SRCDEV); CHOUT(LSTDEV,CHAR);
	end;
CHOUT(BINDEV,CHAR);
CRLF(BINDEV);
GETCH;
FACTYP:=INTEGER;
return SPC;	\RETURN STARTING ADDRESS OF STRING
end;	\STRCON


func	ARRAYCON;	\CONSTANT ARRAYS
int	THISEL,NEXTEL,PNTR,SPC,I,INDIRECT,SFACTYP;
def	NULL=$FFFF;
char	ENTRY,R;

	proc ARRAYX;	\(THIS MUST BE AN OPTIMIZED PROCEDURE
	begin		\ FOR THE RESERVE TO WORK PROPERLY.)
	RATOM;
	INDIRECT:=true;
	case ATOM of
	^[:	ENTRY:=ARRAYCON;
	^":	ENTRY:=STRCON
	else	begin
		INDIRECT:=false;
		GETCON;
		if FACTYP=INTEGER then ENTRY:=IATOM
		else	[ENTRY:=RESERVE(RLSIZE);  \FACTYP=REAL
			R:=addr RLATOM;
			for I:=0,RLSIZE-1 do ENTRY(I):=R(I)];
		end;
	NEXTEL:=RESERVE(6);
	THISEL(1):=ENTRY;
	THISEL(2):=INDIRECT;
	THISEL(0):=NEXTEL;
	NEXTEL(0):=NULL;
	THISEL:=NEXTEL;
	RATOM;
	end;


begin	\ARRAYCON
PNTR:=RESERVE(6);
THISEL:=PNTR;
THISEL(0):=NULL;
ARRAYX;
while ATOM=^, do
	[SFACTYP:=FACTYP;
	ARRAYX;
	if FACTYP#SFACTYP then \MIXED MODE\ ERROR(46)];
if ATOM#^] then ERROR(50);

SPC:=NEWLAB;
LABEL(SPC);
while PNTR(0)#NULL do		\DUMP LIST
	begin
	if FACTYP=INTEGER then GEN(0,\INT\$FD,0,0)
	else GEN(0,\FLT\$FC,0,0);
	ENTRY:=PNTR(1);
	if FACTYP=INTEGER then
		begin
		if PNTR(2) \INDIRECT\ then CHOUT(BINDEV,^L);
		INTOUT(BINDEV,ENTRY);
		end
	else	begin	\(FACTYP=REAL)
		if PNTR(2) \INDIRECT\ then
			begin
			 TEXT(BINDEV,"FL");
			INTOUT(BINDEV,ENTRY);
			end
		else	begin
			CHOUT(BINDEV,^$);
			for I:=0,RLSIZE-1 do HEXB(ENTRY(I));
			end;
		end;
	PNTR:=PNTR(0);
	CRLF(BINDEV);
	end;
return SPC;	\RETURN STARTING ADDRESS OF ARRAY
end;	\ARRAYCON


proc	SPECFAC;	\SPECIAL CHARACTER FACTOR
int	SVAL,SPC,R;
begin
case ATOM of
^(:	[RATOM;			\PARENTHESIZED EXPRESSION
	BOOLEXP;	\(FACTOR TYPE IS UNCHANGED)
	if ATOM#^) then ERROR(44)];
^":	[SPC:=NEWLAB;		\STRING CONSTANT
	GEN(3,\JMP\$07,SPC,0);
	SVAL:=STRCON;
	LABEL(SPC);
	GEN(3,\IMM\$0B,SVAL,0)];
^[:	[SPC:=NEWLAB;		\CONSTANT ARRAY
	GEN(3,\JMP\$07,SPC,0);
	SVAL:=ARRAYCON;
	LABEL(SPC);
	if FACTYP=INTEGER then GEN(3,\IMM\$0B,SVAL,0)
	else	\FACTYP=REAL
		GEN(6,\FIMM\$2C,SVAL,0)];
ADRSYM:	begin			\GET ABSOLUTE HEAP ADDRESS
	RATOM;
	if ATYPE#IDENTIFIER then ERROR(45);
	LOOKUP;
	case IDTYPE of
		INVAR, ADDRVAR, RLVAR: GEN(1,\ADR\$21,LEV,VAL);
		UNDEF: ERROR(10)	\(UNDECLARED NAME)
	else ERROR(43);	\(VARIABLE EXPECTED)
	FACTYP:=INTEGER;
	end
else \ILLEGAL FACTOR\ ERROR(26);
RATOM;
end;	\SPECFAC



proc	IDFAC;		\IDENTIFIER FACTOR
int	SLEV,SVAL,SID;
begin	\IDFAC
LOOKUP;
SID:=IDTYPE;
case IDTYPE of
UNDEF:	ERROR(10);
INVAR, RLVAR:		\VARIABLE
	begin
	GEN(1,if SID=INVAR then \LOD\$01 else \FLOD\$2A,LEV,VAL);
	RATOM;
	if ATOM=^( then				\IT IS INDEXED
		begin
		repeat	[RATOM;
			BOOLEXP;
			if FACTYP#INTEGER then ERROR(47);
			GEN(0,if SID=INVAR then \DBI\$20
				else \TRI\$3A,0,0)]
		until ATOM#^, ;
		if ATOM#^) then ERROR(44) else RATOM;
		end;
	end;
ADDRVAR: begin		\ADDRESS VARIABLE
	RATOM;
	if ATOM#^( then GEN(1,\LOD\$01,LEV,VAL)
	else	begin		\ARRAY ELEMENT REFERENCE
		SLEV:=LEV; SVAL:=VAL;
		RATOM;
		BOOLEXP; 	\INDEX
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#^) then ERROR(44) else RATOM;
		GEN(1,\LDX\$02,SLEV,SVAL);
		end;
	end;
INCON:	begin	\INTEGER CONSTANT IDENTIFIER
	if ABS(VAL)<128 & VAL#$8000 then GEN(2,\IMS\$24,VAL,0)
		else GEN(2,\IMM\$0B,VAL,0);
	RATOM;
	end;
RLCON:	begin	\REAL CONSTANT IDENTIFIER
	RLATOM:=RLTBL(VAL); GEN(5,\FIMM\$2C,0,0);
	RATOM;
	end
else	begin	\PROCEDURES USED AS FUNCTIONS (BY DEFAULT)
	PROCAL;
	if SID<ININT then
		GEN(1,if SID&1 then \LOD\$01 else \FLOD\$2A,0,0);
	end;
FACTYP:=if SID & 1 then INTEGER else REAL; \ODD IDS ARE INTEGER
end;	\IDFAC


begin	\FACTOR
while ATOM=^+ do RATOM;			\IGNORE UNARY "+"
if ATOM=^- then				\UNARY "-"
	[RATOM;
	FACTOR;
	GEN(0,if FACTYP=INTEGER then \NEG\$11
		else \FNEG\$31,0,0)]
else	case ATYPE of
	SPECIAL:SPECFAC;
	INTCON:	[FACTYP:=INTEGER;	\INTEGER CONSTANT
		if ABS(IATOM)<128 & IATOM#$8000 then
			GEN(2,\IMS\$24,IATOM,0)
			else GEN(2,\IMM\$0B,IATOM,0);
		RATOM];
	REALCON:[FACTYP:=REAL;		\REAL CONSTANT
		GEN(5,\FIMM\$2C,0,0);
		RATOM]
	else	IDFAC;	\ATYPE = IDENTIFIER (BY DEFAULT)
end;	\FACTOR


proc	TERM;
int	SFACTYP;

	proc TERMX; int INOP,RLOP;
	[RATOM; FACTOR;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	GEN(0,if FACTYP=INTEGER then INOP else RLOP,0,0)];

begin	\TERM
FACTOR;
SFACTYP:=FACTYP;
loop	case ATOM of
	^*:	TERMX(\MUL\$0F,\MULF\$2F);
	^/:	TERMX(\DIV\$10,\DIVF\$30)
	else	quit;
end;	\TERM


proc	ALGEXP;		\ALGEBRIAC EXPRESSION
int	SFACTYP;

	proc ALGX; int INOP,RLOP;
	[RATOM; TERM;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	GEN(0,if FACTYP=INTEGER then INOP else RLOP,0,0)];

begin	\ALGEXP
TERM;
SFACTYP:=FACTYP;
loop	case ATOM of
	^+:	ALGX(\ADD\$0D,\ADDF\$2D);
	^-:	ALGX(\SUB\$0E,\SUBF\$2E)
	else	quit;
end;	\ALGEXP


proc	LOGEXP;		\LOGICAL EXPRESSION
int	SFACTYP;

	proc	LOGX; int INOP,RLOP;
	[RATOM; ALGEXP;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	GEN(0,if FACTYP=INTEGER then INOP else RLOP,0,0);
	FACTYP:=INTEGER];

begin	\LOGEXP
if ATOM=NOTSYM then		\UNARY 'NOT' OPERATOR
	[RATOM; LOGEXP;
	if FACTYP#INTEGER then ERROR(47);
	GEN(0,\NOT\$1C,0,0)]
else	[ALGEXP;
	SFACTYP:=FACTYP;
	case ATOM of
	^=:	LOGX(\EQ\$12,\EQF\$32);
	^#:	LOGX(\NE\$13,\NEF\$33);
	^>:	LOGX(\GT\$15,\GTF\$35);
	^<:	LOGX(\LT\$17,\LTF\$37);
	GESYM:	LOGX(\GE\$14,\GEF\$34);
	LESYM:	LOGX(\LE\$16,\LEF\$36)
	else];
end;	\LOGEXP


proc	BOOLTERM;	\BOOLEAN "&" EXPRESSIONS
begin
LOGEXP;
loop	[if ATOM=^& then [RATOM; LOGEXP; GEN(0,\AND\$1B,0,0)]
		else quit;
	if FACTYP#INTEGER then ERROR(47)];
end;


begin	\BOOLEXP
if ATOM=IFSYM then			\'IF' EXPRESSION
	[RATOM; BOOLEXP;
	P1:=NEWLAB;
	GEN(3,\JPC\$08,P1,0);
	if ATOM#THENYM then ERROR(22);
	RATOM; BOOLEXP; SFACTYP:=FACTYP;
	if ATOM#ELSEYM then ERROR(30);
	P2:=NEWLAB;
	GEN(3,\JMP\$07,P2,0);
	LABEL(P1);
	RATOM; BOOLEXP;
	if SFACTYP#FACTYP then \MIXED MODE\ ERROR(46);
	LABEL(P2)]
else	begin			\BOOLEAN "!" (OR) EXPRESSIONS
	BOOLTERM;
	loop	[if ATOM=^! then
			[RATOM; BOOLTERM; GEN(0,\OR\$1A,0,0)]
			else quit;
		if FACTYP#INTEGER then ERROR(47)];
	end;
end;	\BOOLEXP


proc	SSTATEMENT; int SSTK;	\(FOR 'QUIT'S IN 'CASE' STMNTS)


proc	STATEMENT;
int	P2,P3,SFIXS,SLEV,SVAL,SFACTYP,I;


proc	ASSIGN;		\ASSIGNMENT STATEMENT
\ (ALSO INCLUDES PROCEDURE CALLS)

	proc	ASSX;
	[if ATOM#GETSYM then ERROR(21);
	RATOM;
	BOOLEXP];	\RIGHT-HAND SIDE OF ASSIGNMENT

begin	\ASSIGN
if ATYPE#IDENTIFIER then
	\BAD START OF A STATEMENT\ [ERROR(20); SKIPIT; return];
LOOKUP; if IDTYPE=UNDEF then [ERROR(10); SKIPIT; return];
SLEV:=LEV; SVAL:=VAL;	\SAVE THESE FOR "GEN." AN INTERIM
			\ BOOLEXP MAY CHANGE LEV & VAL
if IDTYPE>=INPROC & IDTYPE<=RLEXT then PROCAL
else if IDTYPE=INVAR ! IDTYPE=RLVAR then
	begin
	SFACTYP:=if IDTYPE=INVAR then INTEGER else REAL;
	RATOM;
	if ATOM=^( then			\INDEXED
		begin
		GEN(1,\LOD\$01,SLEV,SVAL);
		RATOM;
		BOOLEXP;		\1ST INDEX
		if FACTYP#INTEGER then ERROR(47);
		while ATOM=^, do	\MULTIPLE INDEXING
			[GEN(0,if SFACTYP=INTEGER then \DBI\$20
				else \TRX\$39,0,0);
			RATOM;
			BOOLEXP;
			if FACTYP#INTEGER then ERROR(47)];
		GEN(0,if SFACTYP=INTEGER then \DBA\$1E
			else \TRA\$38,0,0);
		if ATOM#^) then ERROR(44) else RATOM;
		ASSX;	\TOS NOW POINTS TO ARRAY ELEMENT
		GEN(0,if SFACTYP=INTEGER then \STI\$1F
			else \STT\$3B,0,0);
		end
	else	[ASSX;
		GEN(1,if SFACTYP=INTEGER then \STO\$03
			else \FSTO\$2B,SLEV,SVAL)];
	if FACTYP#SFACTYP then \MIXED MODE\ ERROR(46);
	end
else if IDTYPE=ADDRVAR then		\ADDRESS VARIABLE
	begin
	RATOM;
	if ATOM=^( then				\INDEXED
		[RATOM;
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#^) then ERROR(44) else RATOM;
		ASSX;
		GEN(1,\STX\$04,SLEV,SVAL)]
	else	[ASSX;
		GEN(1,\STO\$03,SLEV,SVAL)];
	if FACTYP#INTEGER then \MIXED MODE\ ERROR(46);
	end
else \STATEMENT STARTING WITH A CONSTANT\ [ERROR(27); SKIPIT];
end;	\ASSIGN


proc	CASER; int TYPE;
int	SPC1,SPC2,SPC3;


proc	CASER2;
begin
RATOM;
BOOLEXP;
if FACTYP#INTEGER then ERROR(47);
SPC1:=NEWLAB;
GEN(3,TYPE,SPC1,0);
if ATOM=^, then				\MULTIPLE LABELS
	[SPC3:=NEWLAB;
	repeat	RATOM;	\FOR MORE THAN 2 LABELS
		GEN(3,\JMP\$07,SPC3,0);	\2 JUMPS TO STATEMENT
		LABEL(SPC1);
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		SPC1:=NEWLAB;
		GEN(3,TYPE,SPC1,0);
	until ATOM#^,;
	LABEL(SPC3)];
if ATOM#^: then [ERROR(49); SKIPIT; return];
RATOM;
STATEMENT;
end;	\CASER2


begin	\CASER
CASER2;
SPC2:=NEWLAB;
GEN(3,\JMP\$07,SPC2,0);		\JUMP OUT OF CASE STATEMENT
LABEL(SPC1);
while ATOM=^; do
	[CASER2;
	GEN(3,\JMP\$07,SPC2,0);	\2 JUMP EXIT (BACK THEN OUT)
	LABEL(SPC1)];
if ATOM#ELSEYM & ATOM#OTHSYM then ERROR(29);
RATOM;
STATEMENT;
LABEL(SPC2);
end;	\CASER


begin	\STATEMENT
case ATOM of
BEGSYM,^[:
	begin
	RATOM;
	loop	begin
		if ATOM=ELSEYM then [ERROR(52); RATOM];
		if ATOM=OTHSYM then [ERROR(53); RATOM];
		STATEMENT;
		case ATOM of
		^;:	RATOM;
		ENDSYM:	quit;
		^]:	quit;
		EOF:	[ERROR(62); exit]
		else	\SEMI EXPECTED\ ERROR(41);
		end;
	RATOM;		\READ PAST THE 'END'
	end;
CASEYM:	begin				\CASE STATEMENT
	RATOM;
	if ATOM=OFSYM then CASER(\JPC\$08)
	else	begin
		BOOLEXP;
		if FACTYP#INTEGER then ERROR(47);
		if ATOM#OFSYM then [ERROR(48); SKIPIT; return];
		STKLOD:=STKLOD+1;
		CASER(\CJP\$25);
		GEN(0,\DRP\$28,0,0);
		STKLOD:=STKLOD-1;
		end;
	end;
QUITYM:	begin
	for I:=SSTK,STKLOD-1 do GEN(0,\DRP\$28,0,0);
	if FIXCNT>QUITMAX then [ERROR(4); FIXCNT:=QUITMAX-1];
	FIXES(FIXCNT):=NEWLAB;		\QUIT STATEMENT
	GEN(3,\JMP\$07,FIXES(FIXCNT),0);   \(WILL BE "FIXED" AT END OF 'LOOP')
	FIXCNT:=FIXCNT+1;
	RATOM;
	end;
IFSYM:	begin				\IF STATEMENT
	RATOM;
	BOOLEXP;
	P3:=NEWLAB;
	GEN(3,\JPC\$08,P3,0);
	if ATOM#THENYM then [ERROR(22); SKIPIT; return];
	RATOM;
	STATEMENT;
	if ATOM=ELSEYM then
		[P2:=NEWLAB;
		GEN(3,\JMP\$07,P2,0);
		LABEL(P3);
		P3:=P2;
		RATOM;
		STATEMENT];
	LABEL(P3);
	end;
REPSYM:	[P2:=NEWLAB;			\REPEAT STATEMENT
	LABEL(P2);
	repeat RATOM; STATEMENT until ATOM#^;;
	if ATOM#UNTSYM then [ERROR(28); SKIPIT; return];
	RATOM;
	BOOLEXP;
	GEN(3,\JPC\$08,P2,0)];
WHILYM:	[RATOM;				\WHILE STATEMENT
	P2:=NEWLAB;
	LABEL(P2);
	BOOLEXP;
	P3:=NEWLAB;
	GEN(3,\JPC\$08,P3,0);
	if ATOM#DOSYM then [ERROR(23); SKIPIT; return];
	RATOM;
	STATEMENT;
	GEN(3,\JMP\$07,P2,0);
	LABEL(P3)];
RETSYM:	begin				\RETURN STATEMENT
	RATOM;
	for I:=0,STKLOD-1 do GEN(0,\DRP\$28,0,0);
	if ATOM#ELSEYM & ATOM#OTHSYM & ATOM#^; & ATOM#^] &
	    ATOM#ENDSYM & ATOM#UNTSYM then	\STORE THE RETURNED
		[BOOLEXP;		\ VALUE IN GLOBAL #0
		if FACTYP=INTEGER then GEN(1,\STO\$03,0,0)
			else GEN(1,\FSTO\$2B,0,0)];
	if OPTPROC then GEN(0,\RTS\$27,0,0)
	else GEN(1,\RET\$06,LEVEL,NOLOC);
	end;
LOOPYM:	begin				\LOOP STATEMENT
	SFIXS:=FIXCNT;
	RATOM;
	P2:=NEWLAB;
	LABEL(P2);
	SSTATEMENT(STKLOD);
	GEN(3,\JMP\$07,P2,0);
	while FIXCNT>SFIXS do	\FIX THE JUMPS FOR THE 'QUIT'S
		[FIXCNT:=FIXCNT-1; LABEL(FIXES(FIXCNT))];
	end;
FORSYM:	begin				\FOR STATEMENT
	RATOM;
	if ATYPE#IDENTIFIER then [ERROR(33); SKIPIT; return];
	LOOKUP;
	if IDTYPE=UNDEF then ERROR(10)
		else if IDTYPE#INVAR then ERROR(33);
	SLEV:=LEV; SVAL:=VAL;
	RATOM;
	if ATOM#GETSYM then [ERROR(21); SKIPIT; return];
	RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	GEN(1,\STO\$03,SLEV,SVAL);
	if ATOM#^, then [ERROR(24); SKIPIT; return];
	RATOM;
	BOOLEXP;
	if FACTYP#INTEGER then ERROR(47);
	if ATOM#DOSYM then [ERROR(23); SKIPIT; return];
	GEN(1,\LOD\$01,SLEV,SVAL);
	P2:=NEWLAB;
	LABEL(P2);
	P3:=NEWLAB;
	GEN(3,\FOR\$18,P3,0);
	RATOM;
	STKLOD:=STKLOD+1;
	STATEMENT;
	STKLOD:=STKLOD-1;
	GEN(1,\INP\$19,SLEV,SVAL);
	GEN(3,\JMP\$07,P2,0);
	LABEL(P3);
	\NOTE: THE INTERPRETER SPEEDS UP THINGS BY ASSUMING THAT "INC"
	\ WILL ALWAYS BE FOLLOWED BY A "JMP" GOING BACK TO THE "FOR"
	end;
EXITYM:	[RATOM; GEN(0,\EXIT\$00,0,0)];	\EXIT STATEMENT
ELSEYM,OTHSYM,^;,^],ENDSYM,UNTSYM:	[];
EOF:	[]		\(THIS IS MOSTLY AN ACADEMIC POINT)
else	ASSIGN;
end;	\STATEMENT


begin	\SSTATEMENT
\TRICK TO ADJUST STACK (WITH DRP'S) WHEN A 'QUIT' IS IN
\ A 'CASE' STATEMENT.
STATEMENT;
end;


proc	PROCEDURE(SPNT);
int SPNT;
int	K,I,J,P1,DX,		\HEAP SPACE REQUIREMENT COUNTER
	FPBASE,		\PC AT END OF DECLARATIONS
	FPROCNT;	\COUNT OF PENDING FORWARD PROCEDURES


proc	CODDEC;		\DECLARE INTRINSIC NAMES
int	SID;
begin
SID:=ININT;		\DEFAULT IS INTEGER INTRINSIC
RATOM;
if ATOM=REALYM then [SID:=RLINT; RATOM]
	else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	if ATOM#^= then ERROR(40);
	RATOM;
	GETCON; if FACTYP#INTEGER then ERROR(47);
	if IATOM<0 ! IATOM>127 then ERROR(7);
	INSERT(SID,LEVEL,IATOM+CODOFF);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\CODDEC


proc	CONDEC;		\DECLARE CONSTANT NAMES
int	CNTR,SSNO;
begin
RATOM;
CNTR:=0;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	begin
	RATOM;
	if ATOM#^= then [INSERT(INCON,LEVEL,CNTR); CNTR:=CNTR+1]
	else	begin
		SSNO:=NOSYM;
		INSERT(INCON,LEVEL,NORLSY);	\INSERT ID NOW
		RATOM;			\ FIX UP PARMS LATER
		GETCON;
		if FACTYP=INTEGER then SYMVAL(SSNO):=IATOM
		else		\FACTYP=REAL
			[SYMTYP(SSNO):=RLCON;
			if NORLSY>=RLMAX then
				[ERROR(2); NORLSY:=RLMAX-1];
			RLTBL(NORLSY):=RLATOM;
			NORLSY:=NORLSY+1];
		RATOM;
		end;
	if ATOM=^, then RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\CONDEC


proc	VARDEC; int TYPE;  \DECLARE VARIABLES--INT, REAL & ADDR
begin
RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[INSERT(TYPE,LEVEL,DX);
	DX:=DX +(if TYPE=RLVAR then RLSIZE else 2);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\VARDEC


proc	EXTDEC;		\DECLARE EXTERNAL PROCEDURES
int	SID;
begin
SID:=INEXT;		\DEFAULT IS INTEGER EXTERNAL PROCEDURE
RATOM;
if ATOM=REALYM then [SID:=RLEXT; RATOM]
	else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	[RATOM;
	if ATOM#^= then ERROR(40);
	RATOM;
	GETCON; if FACTYP#INTEGER then ERROR(47);
	INSERT(SID,LEVEL,IATOM);
	RATOM;
	if ATOM=^, then RATOM];
if ATOM#^; then ERROR(41) else RATOM;
end;	\EXTDEC


proc	FPRDEC; int OPTYPE;	\DECLARE FORWARD REFERENCED PROCEDURES
int	SID,I;
begin
SID:=INFPROC;			\DEFAULT TYPE
RATOM;
if ATOM=REALYM then [SID:=RLFPROC;RATOM]
else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45);
while ATYPE=IDENTIFIER do
	begin
	RATOM;
	I:=NEWLAB;
	INSERT(SID,LEVEL,I);
	LABEL(I);
	GEN(3,\JMP\$07,NEWLAB,0);
	FPROCNT:=FPROCNT+1;
	if ATOM=^, then RATOM;
	end;
if ATOM#^; then ERROR(41) else RATOM;
end;	\FPRDEC


proc	PROCDEC; int CANOPT;		\DECLARE PROCEDURE NAMES
int	SNOSYM,HASH,I,K,SID,SSNO,SNORL;
begin
SID:=INPROC;			\TYPED PROCEDURE (FOR FUNCTIONS)
RATOM;
if ATOM=REALYM then [SID:=RLPROC; RATOM]
	else if ATOM=INTSYM then RATOM;
if ATYPE#IDENTIFIER then ERROR(45) else LOOKUP;
if IDTYPE=INFPROC ! IDTYPE=RLFPROC then
	\PROCEDURE HAS BEEN PREVIOUSLY DECLARED BY A 'FPROC' OR 'FFUNCT'
	[if LEVEL#LEV then ERROR(65);
	LABEL(VAL+1);	\('FPROC' & 'PROC' MUST BE SAME SCOPE)
	SYMVAL(SYMNUM):=VAL+1;
	SYMTYP(SYMNUM):=if IDTYPE=INFPROC then INPROC else RLPROC;
	if SID#SYMTYP(SYMNUM) then \MIXED MODE\ ERROR(46);
	if VAL>=FPBASE then FPROCNT:=FPROCNT-1;
	OPTPROC:=false]
else 	begin
	SSNO:=NOSYM;
	I:=NEWLAB;
	INSERT(SID,LEVEL,I);
	LABEL(I);
	OPTPROC:=CANOPT;
	end;
LEVEL:=LEVEL+2; if LEVEL>14 then ERROR(5);
			\EAT THE ARGUMENT LIST AS A COMMENT
while CHAR#^; & CHAR#\CR\$0D do GETCH;	\SPECIAL COMMENT STOPS ON CR
if CHAR#^; then ERROR(41);
GETCH; RATOM;

SNOSYM:=NOSYM; SNORL:=NORLSY;
PROCEDURE(SNOSYM);
if ATOM#^; then ERROR(41) else RATOM;
if OPTPROC then SYMTYP(SSNO):= if SID=INPROC then INOPT
	else RLOPT;
while NOSYM>SNOSYM do	\RESTORE SYMBOL TABLE TO PREVIOUS LEVEL
\I.E. REMOVE THE IDENTIFIERS WHICH WERE LOCAL TO THIS PROCEDURE
	[NOSYM:=NOSYM-1;
	HASH:=0; K:=NOSYM;
	for I:=0,SIGCHAR-1 do
		[HASH:=HASH+SYMBOL(K); K:=K+SYMAX];
	BOX(HASH&$3F):=SYMPNT(NOSYM)];
NORLSY:=SNORL;
LEVEL:=LEVEL-2;
end;	\PROCDEC


begin	\PROCEDURE
DX:= if LEVEL=0 then RLSIZE else 0; \SAVE HEAP SPACE FOR RETURN
loop	case ATOM of
	INTSYM:	VARDEC(INVAR);
	ADRSYM:	VARDEC(ADDRVAR);
	CHARYM:	VARDEC(ADDRVAR);
	REALYM:	VARDEC(RLVAR);
	CODSYM:	CODDEC;
	EXTNYM:	EXTDEC;
	DEFSYM:	CONDEC;
	EPRSYM, EFUNYM:	if LEVEL=0 then FPRDEC(64)
			else [ERROR(68); SKIPIT]
	else	quit;
\FOR INVERTED STACK WE INVERT THE DEFINITIONS:
if LEVEL#0 then
for I:=SPNT,NOSYM-1 do
	begin
	K:=SYMTYP(I);
	J:=if K=RLVAR then 5 else 2;
	if (K=INVAR)!(K=ADDRVAR)!(K=RLVAR) then
		SYMVAL(I):=DX-SYMVAL(I)-J;
	end;

\PROCESS LOWER LEVEL PROCEDURES...
case ATOM of LNKSYM,PROCYM,FUNSYM,FPRSYM,FFUNYM:
	begin
	P1:=NEWLAB;
	GEN(3,\JMP\$07,P1,0);
	end
else P1:=0\NULL\;

FPROCNT:=0;
FPBASE:=LABCNT;
loop	case ATOM of
	LNKSYM: [if LEVEL#0 then ERROR(68);
		CHOUT(BINDEV,^%);
		RATOM;
		case ATOM of PROCYM,FUNSYM:PROCDEC(false)
		else ERROR(67)];
	PROCYM,FUNSYM:	PROCDEC(true);
	FPRSYM,FFUNYM:	FPRDEC(7)		\'FPROC' CANNOT PRECEDE A 'DEF'
	else	quit;
if P1#0 then LABEL(P1);

\RESERVE SPACE FOR LOCAL VARIABLES
if DX>0 then
	[OPTPROC:=false;
	if DX>255 then \TOO MANY VARIABLES\ ERROR(1)];
if not OPTPROC then
	GEN(1,\HPI\$09,LEVEL,DX);

\PROCESS THE BODY
NOLOC:=DX;
SSTATEMENT(STKLOD);	\(STKLOD WILL ALWAYS BE ZERO HERE)

\AND RETRUN
if OPTPROC then GEN(0,\RTS\$27,0,0)
else GEN(1,\RET\$06,LEVEL,NOLOC);

if FIXCNT#0 then \SOME 'QUIT'S NOT IN A 'LOOP'\ ERROR(60);
if FPROCNT#0 then \UNRESOLVED FWD REFERENCES\ ERROR(66);
end;	\PROCEDURE


begin	\MAIN--DISPLAY TITLE AND INITIALIZE
IDENT:=RESERVE(SIGCHAR);
FIXES:=RESERVE(2*QUITMAX);
SYMBOL:=RESERVE(SIGCHAR*SYMAX);	\SYMBOL TABLE
SYMTYP:=RESERVE(SYMAX);
SYMVAL:=RESERVE(SYMAX*2);
SYMLEV:=RESERVE(SYMAX);
SYMPNT:=RESERVE(SYMAX);
BOX:=RESERVE(64);		\HASH TABLE
RLTBL:=RLRES(RLMAX);
HEXDIGIT:="0123456789ABCDEF ";

DEVICE:=[3,0,3];	\DEFAULT DEVICE NOS.
CRLF(TV);
TEXT(TV,"-- XPL0 COMPILER, VER 5.6T --");
CRLF(TV);
TEXT(TV," COPYRIGHT 1984 P.J.R. BOYLE");
CRLF(0);CRLF(0);
TEXT(TV,"CHANGE DEFAULTS? ");
if CHIN(KB)=^Y then
	[TEXT(TV,"DEVICE NUMBERS (BINARY, LIST, SOURCE)?");
	CRLF(TV);
	DEVICE(0):=INTIN(KB); DEVICE(1):=INTIN(KB);
	DEVICE(2):=INTIN(KB)];
BINDEV:=DEVICE(0); LSTDEV:=DEVICE(1); SRCDEV:=DEVICE(2);
OPENO(BINDEV); OPENO(LSTDEV); OPENI(SRCDEV);
CRLF(TV);
CASEIN:=false; LABCNT:=0; LEVEL:=0;		\INITIALIZE SOME STUFF
STKLOD:=0; NOSYM:=0; NORLSY:=0; FIXCNT:=0;
for I:=0,63 do BOX(I):=\EMPTY\$FF;	\ZERO THE SYMBOL TABLE
ERRCNT:=0;
LASTOP:=$FFFF\NUL\;
HASLAB:=false;
GETCH; RATOM;
OPTPROC:=false;		\(FOR 2 REASONS)
PROCEDURE(0);		\COMPILE MAIN PROCEDURE, I.E. THE PROGRAM
while ATOM=^; do RATOM;
if ATOM#EOF then \MORE CODE AFTER END\ [ERROR(61); PROCEDURE(0)];
GEN(0,\END\$FE,0,0);CLOSE(BINDEV);
CRLF(LSTDEV);
TEXT(LSTDEV,"ERRORS DETECTED: "); INTOUT(LSTDEV,ERRCNT); CRLF(LSTDEV);
CLOSE(LSTDEV);
end;	\MAIN
